/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.compilation;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Generator</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.compilation.Generator#getKind <em>Kind</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.compilation.SmeCompPackage#getGenerator()
 * @model annotation="http://www.topcased.org/uuid uuid='_2640kMM9EduFJvhn52JvCw'"
 * @generated
 */
public interface Generator extends ScenarioItem {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String	copyright	= "Copyright : IRISA / INRIA Rennes - ESPRESSO team..\r\nThis plug-in is under the terms of the EPL License.\r\nhttp://www.eclipse.org/org/documents/epl-v10.html\r\n\r\n@author Christian Brunette\r\n";
	
	/**
	 * Returns the value of the '<em><b>Kind</b></em>' attribute. The default value is <code>"Signal"</code>. The
	 * literals are from the enumeration {@link fr.irisa.espresso.sme.compilation.GeneratorKind}. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Kind</em>' attribute isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Kind</em>' attribute.
	 * @see fr.irisa.espresso.sme.compilation.GeneratorKind
	 * @see #setKind(GeneratorKind)
	 * @see fr.irisa.espresso.sme.compilation.SmeCompPackage#getGenerator_Kind()
	 * @model default="Signal" id="true" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_TLwCJcM-EduFJvhn52JvCw'"
	 * @generated
	 */
	GeneratorKind getKind();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.compilation.Generator#getKind <em>Kind</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Kind</em>' attribute.
	 * @see fr.irisa.espresso.sme.compilation.GeneratorKind
	 * @see #getKind()
	 * @generated
	 */
	void setKind(GeneratorKind value);
	
} // Generator
