/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.compilation;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Scenario</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.compilation.Scenario#getElements <em>Elements</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.compilation.Scenario#getDescription <em>Description</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.compilation.Scenario#isDisplayWarnings <em>Display Warnings</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.compilation.SmeCompPackage#getScenario()
 * @model annotation="http://www.topcased.org/uuid uuid='_26vDkcM9EduFJvhn52JvCw'"
 * @generated
 */
public interface Scenario extends EObject {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String	copyright	= "Copyright : IRISA / INRIA Rennes - ESPRESSO team..\r\nThis plug-in is under the terms of the EPL License.\r\nhttp://www.eclipse.org/org/documents/epl-v10.html\r\n\r\n@author Christian Brunette\r\n";
	
	/**
	 * Returns the value of the '<em><b>Elements</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.compilation.ScenarioItem}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Elements</em>' containment reference list isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Elements</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.compilation.SmeCompPackage#getScenario_Elements()
	 * @model containment="true" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_Ao3VwsM-EduFJvhn52JvCw'"
	 * @generated
	 */
	EList<ScenarioItem> getElements();
	
	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see fr.irisa.espresso.sme.compilation.SmeCompPackage#getScenario_Description()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_IvY0gxj_Edy0-YMMPKJZWQ'"
	 * @generated
	 */
	String getDescription();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.compilation.Scenario#getDescription <em>Description</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);
	
	/**
	 * Returns the value of the '<em><b>Display Warnings</b></em>' attribute. The default value is <code>"false"</code>.
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This attribute will be true if we want to
	 * display all warning during compilation phase. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Display Warnings</em>' attribute.
	 * @see #setDisplayWarnings(boolean)
	 * @see fr.irisa.espresso.sme.compilation.SmeCompPackage#getScenario_DisplayWarnings()
	 * @model default="false"
	 * @generated
	 */
	boolean isDisplayWarnings();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.compilation.Scenario#isDisplayWarnings
	 * <em>Display Warnings</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Display Warnings</em>' attribute.
	 * @see #isDisplayWarnings()
	 * @generated
	 */
	void setDisplayWarnings(boolean value);
	
} // Scenario
