/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.compilation;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * 
 * @see fr.irisa.espresso.sme.compilation.SmeCompFactory
 * @model kind="package" annotation="http://www.topcased.org/uuid uuid='_26vDkMM9EduFJvhn52JvCw'"
 * @generated
 */
public interface SmeCompPackage extends EPackage {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String			copyright					= "Copyright : IRISA / INRIA Rennes - ESPRESSO team..\r\nThis plug-in is under the terms of the EPL License.\r\nhttp://www.eclipse.org/org/documents/epl-v10.html\r\n\r\n@author Christian Brunette\r\n";
	
	/**
	 * The package name. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String			eNAME						= "compilation";
	
	/**
	 * The package namespace URI. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String			eNS_URI						= "http://www.irisa.fr/espresso/SmeCompilation.ecore";
	
	/**
	 * The package namespace name. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String			eNS_PREFIX					= "compilation";
	
	/**
	 * The singleton instance of the package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	SmeCompPackage	eINSTANCE					= fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl.init();
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.compilation.impl.ScenarioImpl <em>Scenario</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.compilation.impl.ScenarioImpl
	 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getScenario()
	 * @generated
	 */
	int				SCENARIO					= 0;
	
	/**
	 * The feature id for the '<em><b>Elements</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SCENARIO__ELEMENTS			= 0;
	
	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SCENARIO__DESCRIPTION		= 1;
	
	/**
	 * The feature id for the '<em><b>Display Warnings</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SCENARIO__DISPLAY_WARNINGS	= 2;
	
	/**
	 * The number of structural features of the '<em>Scenario</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SCENARIO_FEATURE_COUNT		= 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.compilation.impl.ScenarioItemImpl
	 * <em>Scenario Item</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.compilation.impl.ScenarioItemImpl
	 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getScenarioItem()
	 * @generated
	 */
	int				SCENARIO_ITEM				= 3;
	
	/**
	 * The number of structural features of the '<em>Scenario Item</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				SCENARIO_ITEM_FEATURE_COUNT	= 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.compilation.impl.FunctionalityImpl
	 * <em>Functionality</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.compilation.impl.FunctionalityImpl
	 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getFunctionality()
	 * @generated
	 */
	int				FUNCTIONALITY				= 1;
	
	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FUNCTIONALITY__KIND			= SCENARIO_ITEM_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Functionality</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				FUNCTIONALITY_FEATURE_COUNT	= SCENARIO_ITEM_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.compilation.impl.GeneratorImpl <em>Generator</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.compilation.impl.GeneratorImpl
	 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getGenerator()
	 * @generated
	 */
	int				GENERATOR					= 2;
	
	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				GENERATOR__KIND				= SCENARIO_ITEM_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Generator</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int				GENERATOR_FEATURE_COUNT		= SCENARIO_ITEM_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.compilation.GeneratorKind <em>Generator Kind</em>}'
	 * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.compilation.GeneratorKind
	 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getGeneratorKind()
	 * @generated
	 */
	int				GENERATOR_KIND				= 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.compilation.FunctionalityKind
	 * <em>Functionality Kind</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.compilation.FunctionalityKind
	 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getFunctionalityKind()
	 * @generated
	 */
	int				FUNCTIONALITY_KIND			= 5;
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.compilation.Scenario <em>Scenario</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Scenario</em>'.
	 * @see fr.irisa.espresso.sme.compilation.Scenario
	 * @generated
	 */
	EClass getScenario();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.compilation.Scenario#getElements <em>Elements</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Elements</em>'.
	 * @see fr.irisa.espresso.sme.compilation.Scenario#getElements()
	 * @see #getScenario()
	 * @generated
	 */
	EReference getScenario_Elements();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.compilation.Scenario#getDescription
	 * <em>Description</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see fr.irisa.espresso.sme.compilation.Scenario#getDescription()
	 * @see #getScenario()
	 * @generated
	 */
	EAttribute getScenario_Description();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.compilation.Scenario#isDisplayWarnings
	 * <em>Display Warnings</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Display Warnings</em>'.
	 * @see fr.irisa.espresso.sme.compilation.Scenario#isDisplayWarnings()
	 * @see #getScenario()
	 * @generated
	 */
	EAttribute getScenario_DisplayWarnings();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.compilation.Functionality <em>Functionality</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Functionality</em>'.
	 * @see fr.irisa.espresso.sme.compilation.Functionality
	 * @generated
	 */
	EClass getFunctionality();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.compilation.Functionality#getKind
	 * <em>Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see fr.irisa.espresso.sme.compilation.Functionality#getKind()
	 * @see #getFunctionality()
	 * @generated
	 */
	EAttribute getFunctionality_Kind();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.compilation.Generator <em>Generator</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Generator</em>'.
	 * @see fr.irisa.espresso.sme.compilation.Generator
	 * @generated
	 */
	EClass getGenerator();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.compilation.Generator#getKind
	 * <em>Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see fr.irisa.espresso.sme.compilation.Generator#getKind()
	 * @see #getGenerator()
	 * @generated
	 */
	EAttribute getGenerator_Kind();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.compilation.ScenarioItem <em>Scenario Item</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Scenario Item</em>'.
	 * @see fr.irisa.espresso.sme.compilation.ScenarioItem
	 * @generated
	 */
	EClass getScenarioItem();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.compilation.GeneratorKind <em>Generator Kind</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Generator Kind</em>'.
	 * @see fr.irisa.espresso.sme.compilation.GeneratorKind
	 * @generated
	 */
	EEnum getGeneratorKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.compilation.FunctionalityKind
	 * <em>Functionality Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Functionality Kind</em>'.
	 * @see fr.irisa.espresso.sme.compilation.FunctionalityKind
	 * @generated
	 */
	EEnum getFunctionalityKind();
	
	/**
	 * Returns the factory that creates the instances of the model. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SmeCompFactory getSmeCompFactory();
	
	/**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.compilation.impl.ScenarioImpl
		 * <em>Scenario</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.compilation.impl.ScenarioImpl
		 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getScenario()
		 * @generated
		 */
		EClass		SCENARIO					= eINSTANCE.getScenario();
		
		/**
		 * The meta object literal for the '<em><b>Elements</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SCENARIO__ELEMENTS			= eINSTANCE.getScenario_Elements();
		
		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SCENARIO__DESCRIPTION		= eINSTANCE.getScenario_Description();
		
		/**
		 * The meta object literal for the '<em><b>Display Warnings</b></em>' attribute feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SCENARIO__DISPLAY_WARNINGS	= eINSTANCE.getScenario_DisplayWarnings();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.compilation.impl.FunctionalityImpl
		 * <em>Functionality</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.compilation.impl.FunctionalityImpl
		 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getFunctionality()
		 * @generated
		 */
		EClass		FUNCTIONALITY				= eINSTANCE.getFunctionality();
		
		/**
		 * The meta object literal for the '<em><b>Kind</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	FUNCTIONALITY__KIND			= eINSTANCE.getFunctionality_Kind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.compilation.impl.GeneratorImpl
		 * <em>Generator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.compilation.impl.GeneratorImpl
		 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getGenerator()
		 * @generated
		 */
		EClass		GENERATOR					= eINSTANCE.getGenerator();
		
		/**
		 * The meta object literal for the '<em><b>Kind</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	GENERATOR__KIND				= eINSTANCE.getGenerator_Kind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.compilation.impl.ScenarioItemImpl
		 * <em>Scenario Item</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.compilation.impl.ScenarioItemImpl
		 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getScenarioItem()
		 * @generated
		 */
		EClass		SCENARIO_ITEM				= eINSTANCE.getScenarioItem();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.compilation.GeneratorKind
		 * <em>Generator Kind</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.compilation.GeneratorKind
		 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getGeneratorKind()
		 * @generated
		 */
		EEnum		GENERATOR_KIND				= eINSTANCE.getGeneratorKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.compilation.FunctionalityKind
		 * <em>Functionality Kind</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.compilation.FunctionalityKind
		 * @see fr.irisa.espresso.sme.compilation.impl.SmeCompPackageImpl#getFunctionalityKind()
		 * @generated
		 */
		EEnum		FUNCTIONALITY_KIND			= eINSTANCE.getFunctionalityKind();
		
	}
	
} // SmeCompPackage
