/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.compilation.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.irisa.espresso.sme.compilation.Scenario;
import fr.irisa.espresso.sme.compilation.ScenarioItem;
import fr.irisa.espresso.sme.compilation.SmeCompPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Scenario</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.compilation.impl.ScenarioImpl#getElements <em>Elements</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.compilation.impl.ScenarioImpl#getDescription <em>Description</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.compilation.impl.ScenarioImpl#isDisplayWarnings <em>Display Warnings</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ScenarioImpl extends EObjectImpl implements Scenario {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final String		copyright					= "Copyright : IRISA / INRIA Rennes - ESPRESSO team..\r\nThis plug-in is under the terms of the EPL License.\r\nhttp://www.eclipse.org/org/documents/epl-v10.html\r\n\r\n@author Christian Brunette\r\n";
	
	/**
	 * The cached value of the '{@link #getElements() <em>Elements</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getElements()
	 * @generated
	 * @ordered
	 */
	protected EList<ScenarioItem>	elements;
	
	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String	DESCRIPTION_EDEFAULT		= null;
	
	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String				description					= DESCRIPTION_EDEFAULT;
	
	/**
	 * The default value of the '{@link #isDisplayWarnings() <em>Display Warnings</em>}' attribute. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #isDisplayWarnings()
	 * @generated
	 * @ordered
	 */
	protected static final boolean	DISPLAY_WARNINGS_EDEFAULT	= false;
	
	/**
	 * The cached value of the '{@link #isDisplayWarnings() <em>Display Warnings</em>}' attribute. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #isDisplayWarnings()
	 * @generated
	 * @ordered
	 */
	protected boolean				displayWarnings				= DISPLAY_WARNINGS_EDEFAULT;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ScenarioImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmeCompPackage.Literals.SCENARIO;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<ScenarioItem> getElements() {
		if (elements == null) {
			elements = new EObjectContainmentEList<ScenarioItem>(ScenarioItem.class, this,
				SmeCompPackage.SCENARIO__ELEMENTS);
		}
		return elements;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getDescription() {
		return description;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmeCompPackage.SCENARIO__DESCRIPTION, oldDescription,
				description));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isDisplayWarnings() {
		return displayWarnings;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDisplayWarnings(boolean newDisplayWarnings) {
		boolean oldDisplayWarnings = displayWarnings;
		displayWarnings = newDisplayWarnings;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmeCompPackage.SCENARIO__DISPLAY_WARNINGS,
				oldDisplayWarnings, displayWarnings));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmeCompPackage.SCENARIO__ELEMENTS:
				return ((InternalEList<?>) getElements()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmeCompPackage.SCENARIO__ELEMENTS:
				return getElements();
			case SmeCompPackage.SCENARIO__DESCRIPTION:
				return getDescription();
			case SmeCompPackage.SCENARIO__DISPLAY_WARNINGS:
				return isDisplayWarnings();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmeCompPackage.SCENARIO__ELEMENTS:
				getElements().clear();
				getElements().addAll((Collection<? extends ScenarioItem>) newValue);
				return;
			case SmeCompPackage.SCENARIO__DESCRIPTION:
				setDescription((String) newValue);
				return;
			case SmeCompPackage.SCENARIO__DISPLAY_WARNINGS:
				setDisplayWarnings((Boolean) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmeCompPackage.SCENARIO__ELEMENTS:
				getElements().clear();
				return;
			case SmeCompPackage.SCENARIO__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case SmeCompPackage.SCENARIO__DISPLAY_WARNINGS:
				setDisplayWarnings(DISPLAY_WARNINGS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmeCompPackage.SCENARIO__ELEMENTS:
				return elements != null && !elements.isEmpty();
			case SmeCompPackage.SCENARIO__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case SmeCompPackage.SCENARIO__DISPLAY_WARNINGS:
				return displayWarnings != DISPLAY_WARNINGS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (description: ");
		result.append(description);
		result.append(", displayWarnings: ");
		result.append(displayWarnings);
		result.append(')');
		return result.toString();
	}
	
} // ScenarioImpl
