/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.compilation.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import fr.irisa.espresso.sme.compilation.Functionality;
import fr.irisa.espresso.sme.compilation.Generator;
import fr.irisa.espresso.sme.compilation.Scenario;
import fr.irisa.espresso.sme.compilation.ScenarioItem;
import fr.irisa.espresso.sme.compilation.SmeCompPackage;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides an adapter <code>createXXX</code>
 * method for each class of the model. <!-- end-user-doc -->
 * 
 * @see fr.irisa.espresso.sme.compilation.SmeCompPackage
 * @generated
 */
public class SmeCompAdapterFactory extends AdapterFactoryImpl {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final String		copyright	= "Copyright : IRISA / INRIA Rennes - ESPRESSO team..\r\nThis plug-in is under the terms of the EPL License.\r\nhttp://www.eclipse.org/org/documents/epl-v10.html\r\n\r\n@author Christian Brunette\r\n";
	
	/**
	 * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static SmeCompPackage	modelPackage;
	
	/**
	 * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SmeCompAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = SmeCompPackage.eINSTANCE;
		}
	}
	
	/**
	 * Returns whether this factory is applicable for the type of the object. <!-- begin-user-doc --> This
	 * implementation returns <code>true</code> if the object is either the model's package or is an instance object of
	 * the model. <!-- end-user-doc -->
	 * 
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}
	
	/**
	 * The switch that delegates to the <code>createXXX</code> methods. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SmeCompSwitch<Adapter>	modelSwitch	= new SmeCompSwitch<Adapter>() {
														@Override
														public Adapter caseScenario(Scenario object) {
															return createScenarioAdapter();
														}
														@Override
														public Adapter caseFunctionality(Functionality object) {
															return createFunctionalityAdapter();
														}
														@Override
														public Adapter caseGenerator(Generator object) {
															return createGeneratorAdapter();
														}
														@Override
														public Adapter caseScenarioItem(ScenarioItem object) {
															return createScenarioItemAdapter();
														}
														@Override
														public Adapter defaultCase(EObject object) {
															return createEObjectAdapter();
														}
													};
	
	/**
	 * Creates an adapter for the <code>target</code>. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param target
	 *        the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject) target);
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.compilation.Scenario
	 * <em>Scenario</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can easily
	 * ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.compilation.Scenario
	 * @generated
	 */
	public Adapter createScenarioAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.compilation.Functionality
	 * <em>Functionality</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can easily
	 * ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.compilation.Functionality
	 * @generated
	 */
	public Adapter createFunctionalityAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.compilation.Generator
	 * <em>Generator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can easily
	 * ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.compilation.Generator
	 * @generated
	 */
	public Adapter createGeneratorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.compilation.ScenarioItem
	 * <em>Scenario Item</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can easily
	 * ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.compilation.ScenarioItem
	 * @generated
	 */
	public Adapter createScenarioItemAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for the default case. <!-- begin-user-doc --> This default implementation returns null.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}
	
} // SmeCompAdapterFactory
