/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.clockrelations;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ProjectScope;
import org.eclipse.core.runtime.Platform;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.preferences.ScopedPreferenceStore;
import org.osgi.service.prefs.BackingStoreException;
import org.osgi.service.prefs.Preferences;
import org.topcased.modeler.di.model.DiagramElement;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.utils.Utils;

import fr.irisa.espresso.sme.InputPort;
import fr.irisa.espresso.sme.MultipleInputsOperator;
import fr.irisa.espresso.sme.SignalOperator;
import fr.irisa.espresso.sme.diagram.clockrelations.preferences.CRD_DiagramPreferenceConstants;
import fr.irisa.espresso.sme.util.SmeSwitch;

/*
 * This utility class allows to create a GraphElement associated with a Model Object
 * 
 * @generated
 */
public class CRD_CreationUtils extends AbstractCreationUtils {
	
	/**
	 * Constructor
	 * 
	 * @param diagramConf
	 *        the Diagram Graphical Configuration
	 * @generated
	 */
	public CRD_CreationUtils(DiagramGraphConf diagramConf) {
		super(diagramConf);
	}
	
	/**
	 * @generated NOT
	 */
	private class GraphicSmeSwitch extends SmeSwitch<Object> {
		/**
		 * The presentation of the graphical element
		 * 
		 * @generated
		 */
		private String	presentation;
		
		/**
		 * Constructor
		 * 
		 * @param presentation
		 *        the presentation of the graphical element
		 * @generated
		 */
		public GraphicSmeSwitch(String presentation) {
			this.presentation = presentation;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseLocal(fr.irisa.espresso.sme.Local)
		 * @generated
		 */
		public Object caseLocal(fr.irisa.espresso.sme.Local object) {
			if ("default".equals(presentation)) {
				return createGraphElementLocal(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseSignalRef(fr.irisa.espresso.sme.SignalRef)
		 * @generated
		 */
		public Object caseSignalRef(fr.irisa.espresso.sme.SignalRef object) {
			if ("default".equals(presentation)) {
				return createGraphElementSignalRef(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseClockConstraintOperator(fr.irisa.espresso.sme.ClockConstraintOperator)
		 * @generated
		 */
		public Object caseClockConstraintOperator(fr.irisa.espresso.sme.ClockConstraintOperator object) {
			if ("default".equals(presentation)) {
				return createGraphElementClockConstraintOperator(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseClockRelationOperator(fr.irisa.espresso.sme.ClockRelationOperator)
		 * @generated
		 */
		public Object caseClockRelationOperator(fr.irisa.espresso.sme.ClockRelationOperator object) {
			if ("default".equals(presentation)) {
				return createGraphElementClockRelationOperator(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseClockSpeedOperator(fr.irisa.espresso.sme.ClockSpeedOperator)
		 * @generated
		 */
		public Object caseClockSpeedOperator(fr.irisa.espresso.sme.ClockSpeedOperator object) {
			if ("default".equals(presentation)) {
				return createGraphElementClockSpeedOperator(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseNullClock(fr.irisa.espresso.sme.NullClock)
		 * @generated
		 */
		public Object caseNullClock(fr.irisa.espresso.sme.NullClock object) {
			if ("default".equals(presentation)) {
				return createGraphElementNullClock(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseClockRelation(fr.irisa.espresso.sme.ClockRelation)
		 * @generated
		 */
		public Object caseClockRelation(fr.irisa.espresso.sme.ClockRelation object) {
			if ("default".equals(presentation)) {
				return createGraphElementClockRelation(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseAssertionClockConstraintOperator(fr.irisa.espresso.sme.AssertionClockConstraintOperator)
		 * @generated
		 */
		public Object caseAssertionClockConstraintOperator(fr.irisa.espresso.sme.AssertionClockConstraintOperator object) {
			if ("default".equals(presentation)) {
				return createGraphElementAssertionClockConstraintOperator(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseAssertionClockSpeedOperator(fr.irisa.espresso.sme.AssertionClockSpeedOperator)
		 * @generated
		 */
		public Object caseAssertionClockSpeedOperator(fr.irisa.espresso.sme.AssertionClockSpeedOperator object) {
			if ("default".equals(presentation)) {
				return createGraphElementAssertionClockSpeedOperator(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseDependenceOperator(fr.irisa.espresso.sme.DependenceOperator)
		 * @generated
		 */
		public Object caseDependenceOperator(fr.irisa.espresso.sme.DependenceOperator object) {
			if ("default".equals(presentation)) {
				return createGraphElementDependenceOperator(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseDependence(fr.irisa.espresso.sme.Dependence)
		 * @generated
		 */
		public Object caseDependence(fr.irisa.espresso.sme.Dependence object) {
			if ("default".equals(presentation)) {
				return createGraphElementDependence(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseCondition(fr.irisa.espresso.sme.Condition)
		 * @generated
		 */
		public Object caseCondition(fr.irisa.espresso.sme.Condition object) {
			if ("default".equals(presentation)) {
				return createGraphElementCondition(object, presentation);
			}
			return null;
		}
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseModelInstance(fr.irisa.espresso.sme.ModelInstance)
		 * @generated NOT
		 */
		public Object caseModelInstance(fr.irisa.espresso.sme.ModelInstance object) {
			if ("default".equals(presentation)) {
				return createGraphElementModelInstance(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseInput(fr.irisa.espresso.sme.Input)
		 * @generated NOT
		 */
		public Object caseInput(fr.irisa.espresso.sme.Input object) {
			if ("default".equals(presentation)) {
				return createGraphElementInput(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseOutput(fr.irisa.espresso.sme.Output)
		 * @generated NOT
		 */
		public Object caseOutput(fr.irisa.espresso.sme.Output object) {
			if ("default".equals(presentation)) {
				return createGraphElementOutput(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseInputInstance(fr.irisa.espresso.sme.InputInstance)
		 * @generated NOT
		 */
		public Object caseInputInstance(fr.irisa.espresso.sme.InputInstance object) {
			if ("default".equals(presentation)) {
				return createGraphElementInputInstance(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseOutputInstance(fr.irisa.espresso.sme.OutputInstance)
		 * @generated NOT
		 */
		public Object caseOutputInstance(fr.irisa.espresso.sme.OutputInstance object) {
			if ("default".equals(presentation)) {
				return createGraphElementOutputInstance(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseBasicIterate(fr.irisa.espresso.sme.BasicIterate)
		 * @generated NOT
		 */
		public Object caseBasicIterate(fr.irisa.espresso.sme.BasicIterate object) {
			if ("default".equals(presentation)) {
				return createGraphElementBasicIterate(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseIterate(fr.irisa.espresso.sme.Iterate)
		 * @generated NOT
		 */
		public Object caseIterate(fr.irisa.espresso.sme.Iterate object) {
			if ("default".equals(presentation)) {
				return createGraphElementIterate(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseSubProcess(fr.irisa.espresso.sme.SubProcess)
		 * @generated NOT
		 */
		public Object caseSubProcess(fr.irisa.espresso.sme.SubProcess object) {
			if ("default".equals(presentation)) {
				return createGraphElementSubProcess(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseAutomaton(fr.irisa.espresso.sme.Automaton)
		 * @generated NOT
		 */
		public Object caseAutomaton(fr.irisa.espresso.sme.Automaton object) {
			if ("default".equals(presentation)) {
				return createGraphElementAutomaton(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#caseInputPort(fr.irisa.espresso.sme.InputPort)
		 * @generated NOT
		 */
		public Object caseInputPort(fr.irisa.espresso.sme.InputPort object) {
			if ("default".equals(presentation)) {
				return createGraphElementInputPort(object, presentation);
			}
			return null;
		}
		
		/**
		 * @see fr.irisa.espresso.sme.util.SmeSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
		 * @generated
		 */
		public Object defaultCase(EObject object) {
			return null;
		}
	}
	
	/**
	 * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
	 *      java.lang.String)
	 * @generated
	 */
	public GraphElement createGraphElement(EObject obj, String presentation) {
		Object graphElt = null;
		
		if ("http://www.irisa.fr/espresso/sme.ecore".equals(obj.eClass().getEPackage().getNsURI())) {
			graphElt = new GraphicSmeSwitch(presentation).doSwitch(obj);
		}
		
		return (GraphElement) graphElt;
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementLocal(fr.irisa.espresso.sme.Local element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementSignalRef(fr.irisa.espresso.sme.SignalRef element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementClockConstraintOperator(
			fr.irisa.espresso.sme.ClockConstraintOperator element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementClockRelationOperator(fr.irisa.espresso.sme.ClockRelationOperator element,
			String presentation) {
		return createGraphElementSignalOperator(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementClockSpeedOperator(fr.irisa.espresso.sme.ClockSpeedOperator element,
			String presentation) {
		return createGraphElementSignalOperator(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementNullClock(fr.irisa.espresso.sme.NullClock element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementClockRelation(fr.irisa.espresso.sme.ClockRelation element,
			String presentation) {
		GraphEdge graphEdge = createGraphEdge(element, presentation);
		EdgeObjectUV srcfieldEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
		srcfieldEdgeObjectUV.setId(CRD_EdgeObjectConstants.SRCFIELD_EDGE_OBJECT_ID);
		srcfieldEdgeObjectUV.setUDistance(0);
		srcfieldEdgeObjectUV.setVDistance(0);
		srcfieldEdgeObjectUV.setVisible(getPreferenceStore().getBoolean(
			CRD_DiagramPreferenceConstants.CLOCKRELATION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY));
		graphEdge.getContained().add(srcfieldEdgeObjectUV);
		EdgeObjectUV dstfieldEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
		dstfieldEdgeObjectUV.setId(CRD_EdgeObjectConstants.DSTFIELD_EDGE_OBJECT_ID);
		dstfieldEdgeObjectUV.setUDistance(0);
		dstfieldEdgeObjectUV.setVDistance(0);
		dstfieldEdgeObjectUV.setVisible(getPreferenceStore().getBoolean(
			CRD_DiagramPreferenceConstants.CLOCKRELATION_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY));
		graphEdge.getContained().add(dstfieldEdgeObjectUV);
		return graphEdge;
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementAssertionClockConstraintOperator(
			fr.irisa.espresso.sme.AssertionClockConstraintOperator element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementAssertionClockSpeedOperator(
			fr.irisa.espresso.sme.AssertionClockSpeedOperator element, String presentation) {
		return createGraphElementSignalOperator(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementDependenceOperator(fr.irisa.espresso.sme.DependenceOperator element,
			String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementDependence(fr.irisa.espresso.sme.Dependence element, String presentation) {
		GraphEdge graphEdge = createGraphEdge(element, presentation);
		EdgeObjectUV srcfieldEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
		srcfieldEdgeObjectUV.setId(CRD_EdgeObjectConstants.SRCFIELD_EDGE_OBJECT_ID);
		srcfieldEdgeObjectUV.setUDistance(0);
		srcfieldEdgeObjectUV.setVDistance(0);
		srcfieldEdgeObjectUV.setVisible(getPreferenceStore().getBoolean(
			CRD_DiagramPreferenceConstants.DEPENDENCE_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY));
		graphEdge.getContained().add(srcfieldEdgeObjectUV);
		EdgeObjectUV dstfieldEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
		dstfieldEdgeObjectUV.setId(CRD_EdgeObjectConstants.DSTFIELD_EDGE_OBJECT_ID);
		dstfieldEdgeObjectUV.setUDistance(0);
		dstfieldEdgeObjectUV.setVDistance(0);
		dstfieldEdgeObjectUV.setVisible(getPreferenceStore().getBoolean(
			CRD_DiagramPreferenceConstants.DEPENDENCE_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY));
		graphEdge.getContained().add(dstfieldEdgeObjectUV);
		return graphEdge;
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementCondition(fr.irisa.espresso.sme.Condition element, String presentation) {
		GraphEdge graphEdge = createGraphEdge(element, presentation);
		EdgeObjectUV srcfieldEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
		srcfieldEdgeObjectUV.setId(CRD_EdgeObjectConstants.SRCFIELD_EDGE_OBJECT_ID);
		srcfieldEdgeObjectUV.setUDistance(0);
		srcfieldEdgeObjectUV.setVDistance(0);
		srcfieldEdgeObjectUV.setVisible(getPreferenceStore().getBoolean(
			CRD_DiagramPreferenceConstants.CONDITION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY));
		graphEdge.getContained().add(srcfieldEdgeObjectUV);
		EdgeObjectOffset conditionkindEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
		conditionkindEdgeObjectOffset.setId(CRD_EdgeObjectConstants.CONDITIONKIND_EDGE_OBJECT_ID);
		conditionkindEdgeObjectOffset.setOffset(new Dimension(0, 0));
		conditionkindEdgeObjectOffset.setVisible(getPreferenceStore().getBoolean(
			CRD_DiagramPreferenceConstants.CONDITION_CONDITIONKIND_EDGE_OBJECT_DEFAULT_VISIBILITY));
		graphEdge.getContained().add(conditionkindEdgeObjectOffset);
		return graphEdge;
	}
	
	/**
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementModelInstance(fr.irisa.espresso.sme.ModelInstance element,
			String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementInput(fr.irisa.espresso.sme.Input element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementOutput(fr.irisa.espresso.sme.Output element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementInputInstance(fr.irisa.espresso.sme.InputInstance element,
			String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementOutputInstance(fr.irisa.espresso.sme.OutputInstance element,
			String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementBasicIterate(fr.irisa.espresso.sme.BasicIterate element,
			String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementIterate(fr.irisa.espresso.sme.Iterate element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementSubProcess(fr.irisa.espresso.sme.SubProcess element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementAutomaton(fr.irisa.espresso.sme.Automaton element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param element
	 *        the model element
	 * @param presentation
	 *        the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementInputPort(fr.irisa.espresso.sme.InputPort element, String presentation) {
		return createGraphNode(element, presentation);
	}
	
	/**
	 * Create the ModelObject with its initial children
	 * 
	 * @param obj
	 *        the model object
	 * @return the model object with its children
	 * @generated
	 */
	public EObject createModelObject(EObject obj) {
		return obj;
	}
	
	/**
	 * Get the preference store associated with the current editor.
	 * 
	 * @return IPreferenceStore
	 * @generated
	 */
	private IPreferenceStore getPreferenceStore() {
		IEditorInput editorInput = CRD_Plugin.getActivePage().getActiveEditor().getEditorInput();
		if (editorInput instanceof IFileEditorInput) {
			IProject project = ((IFileEditorInput) editorInput).getFile().getProject();
			Preferences root = Platform.getPreferencesService().getRootNode();
			try {
				if (root.node(ProjectScope.SCOPE).node(project.getName()).nodeExists(CRD_Plugin.getId())) {
					return new ScopedPreferenceStore(new ProjectScope(project), CRD_Plugin.getId());
				}
			}
			catch (BackingStoreException e) {
				e.printStackTrace();
			}
		}
		return CRD_Plugin.getDefault().getPreferenceStore();
	}
	/**
	 * @param element
	 * @param presentation
	 * @return
	 * @generated NOT
	 */
	private GraphElement createGraphElementSignalOperator(SignalOperator element, String presentation) {
		GraphNode graphNode = createGraphNode(element, presentation);
		
		if (!(element instanceof MultipleInputsOperator && element.getInputPorts().size() != 0))
			fr.irisa.espresso.sme.util.Utils.createPorts(element);
		
		// Add InputPorts
		for (InputPort port : element.getInputPorts()) {
			if (getGraphicalRepresentation(graphNode, port) == null)
				graphNode.getContained().add(createGraphNode(port));
		}
		
		return graphNode;
	}
	
	/**
	 * Get the graphNode associated with the model object in the container
	 * 
	 * @param container
	 *        the graphNode in which the search of the graphNode is done
	 * @param modelObject
	 *        the model object to display
	 * @return the GraphNode or null if it does not exist
	 * @generated NOT
	 */
	private GraphNode getGraphicalRepresentation(GraphNode container, EObject modelObject) {
		for (DiagramElement iter : container.getContained()) {
			GraphElement elt = (GraphElement) iter;
			if (Utils.getElement(elt) == modelObject && elt instanceof GraphNode)
				return (GraphNode) elt;
		}
		return null;
	}
}
