/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.clockrelations;

/*
 * A collection of Roles. Each identifier is used to key the EditPolicy.
 * 
 * @generated
 */
public interface CRD_EditPolicyConstants {
	
	/**
	 * The key used to install an <i>ClockedExpr</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CLOCKEDEXPR_EDITPOLICY						= "ClockedExpr EditPolicy";
	
	/**
	 * The key used to install an <i>DependenceInOut</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	DEPENDENCEINOUT_EDITPOLICY					= "DependenceInOut EditPolicy";
	
	/**
	 * The key used to install an <i>SignalOrRef</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SIGNALORREF_EDITPOLICY						= "SignalOrRef EditPolicy";
	
	/**
	 * The key used to install an <i>SignalRef</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SIGNALREF_EDITPOLICY						= "SignalRef EditPolicy";
	
	/**
	 * The key used to install an <i>Input</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	INPUT_EDITPOLICY							= "Input EditPolicy";
	
	/**
	 * The key used to install an <i>Output</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	OUTPUT_EDITPOLICY							= "Output EditPolicy";
	
	/**
	 * The key used to install an <i>Local</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	LOCAL_EDITPOLICY							= "Local EditPolicy";
	
	/**
	 * The key used to install an <i>InputInstance</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	INPUTINSTANCE_EDITPOLICY					= "InputInstance EditPolicy";
	
	/**
	 * The key used to install an <i>OutputInstance</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	OUTPUTINSTANCE_EDITPOLICY					= "OutputInstance EditPolicy";
	
	/**
	 * The key used to install an <i>BasicIterate</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	BASICITERATE_EDITPOLICY						= "BasicIterate EditPolicy";
	
	/**
	 * The key used to install an <i>Iterate</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ITERATE_EDITPOLICY							= "Iterate EditPolicy";
	
	/**
	 * The key used to install an <i>SubProcess</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SUBPROCESS_EDITPOLICY						= "SubProcess EditPolicy";
	
	/**
	 * The key used to install an <i>Automaton</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	AUTOMATON_EDITPOLICY						= "Automaton EditPolicy";
	
	/**
	 * The key used to install an <i>ModelInstance</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	MODELINSTANCE_EDITPOLICY					= "ModelInstance EditPolicy";
	
	/**
	 * The key used to install an <i>ClockConstraintOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CLOCKCONSTRAINTOPERATOR_EDITPOLICY			= "ClockConstraintOperator EditPolicy";
	
	/**
	 * The key used to install an <i>AssertionClockConstraintOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ASSERTIONCLOCKCONSTRAINTOPERATOR_EDITPOLICY	= "AssertionClockConstraintOperator EditPolicy";
	
	/**
	 * The key used to install an <i>ClockRelationOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CLOCKRELATIONOPERATOR_EDITPOLICY			= "ClockRelationOperator EditPolicy";
	
	/**
	 * The key used to install an <i>ClockSpeedOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CLOCKSPEEDOPERATOR_EDITPOLICY				= "ClockSpeedOperator EditPolicy";
	
	/**
	 * The key used to install an <i>AssertionClockSpeedOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ASSERTIONCLOCKSPEEDOPERATOR_EDITPOLICY		= "AssertionClockSpeedOperator EditPolicy";
	
	/**
	 * The key used to install an <i>DependenceOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	DEPENDENCEOPERATOR_EDITPOLICY				= "DependenceOperator EditPolicy";
	
	/**
	 * The key used to install an <i>NullClock</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	NULLCLOCK_EDITPOLICY						= "NullClock EditPolicy";
	
	/**
	 * The key used to install an <i>InputPort</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	INPUTPORT_EDITPOLICY						= "InputPort EditPolicy";
	
	/**
	 * The key used to install an <i>ClockRelation</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CLOCKRELATION_EDITPOLICY					= "ClockRelation EditPolicy";
	
	/**
	 * The key used to install an <i>Condition</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CONDITION_EDITPOLICY						= "Condition EditPolicy";
	
	/**
	 * The key used to install an <i>Dependence</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	DEPENDENCE_EDITPOLICY						= "Dependence EditPolicy";
	
}
