/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.clockrelations.figures;

import org.eclipse.swt.graphics.Image;

import fr.irisa.espresso.sme.ClockConstraintOpKind;
import fr.irisa.espresso.sme.common.figures.ImageFigure;

/*
 * @generated NOT
 */
public class AssertionClockConstraintOperatorFigure extends ImageFigure {
	private final static String		ASSERTIONCLOCKSYNCHRONIZATION_IMG	= "ASSERTIONCLOCKSYNCHRONIZATION_LARGE";
	
	private final static String		ASSERTIONCLOCKEXCLUSION_IMG			= "ASSERTIONCLOCKEXCLUSION_LARGE";
	
	private final static String		ASSERTIONCLOCKIDENTITY_IMG			= "ASSERTIONCLOCKIDENTITY_LARGE";
	
	protected Image					img;
	
	private ClockConstraintOpKind	operator							= ClockConstraintOpKind.SYNCHRONIZED_LITERAL;
	
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public AssertionClockConstraintOperatorFigure() {
		super(ASSERTIONCLOCKSYNCHRONIZATION_IMG);
	}
	
	/**
	 * Get the kind of clock constraint operator
	 * 
	 * @return the current clock constraint operator
	 */
	public ClockConstraintOpKind getClockConstraintOperator() {
		return operator;
	}
	
	/**
	 * Set the kind of clock constraint operator
	 * 
	 * @param newValue
	 *        the new clock constraint operator
	 */
	public void setClockConstraintOperator(ClockConstraintOpKind newValue) {
		operator = newValue;
		switch (operator.getValue()) {
			case ClockConstraintOpKind.SYNCHRONIZED:
				this.setImage(ASSERTIONCLOCKSYNCHRONIZATION_IMG);
				break;
			case ClockConstraintOpKind.EXCLUDED:
				this.setImage(ASSERTIONCLOCKEXCLUSION_IMG);
				break;
			case ClockConstraintOpKind.IDENTITY:
				this.setImage(ASSERTIONCLOCKIDENTITY_IMG);
				break;
		}
	}
}
