/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.clockrelations.figures;

import org.eclipse.swt.graphics.Image;

import fr.irisa.espresso.sme.ClockSpeedOpKind;
import fr.irisa.espresso.sme.common.figures.SignalOperatorFigure;

/*
 * @generated NOT
 */
public class AssertionClockSpeedOperatorFigure extends SignalOperatorFigure {
	private final static String	ASSERTIONCLOCKSLOWER_IMG	= "ASSERTIONCLOCKSLOWER_LARGE";
	
	private final static String	ASSERTIONCLOCKFASTER_IMG	= "ASSERTIONCLOCKFASTER_LARGE";
	
	protected Image				img;
	
	private ClockSpeedOpKind	operator					= ClockSpeedOpKind.SLOWER_LITERAL;
	
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public AssertionClockSpeedOperatorFigure() {
		super(ASSERTIONCLOCKSLOWER_IMG);
	}
	
	/**
	 * Get the kind of clock speed operator
	 * 
	 * @return the current clock speed operator
	 */
	public ClockSpeedOpKind getClockSpeedOperator() {
		return operator;
	}
	
	/**
	 * Set the kind of clock speed operator
	 * 
	 * @param newValue
	 *        the new clock speed operator
	 */
	public void setClockSpeedOperator(ClockSpeedOpKind newValue) {
		operator = newValue;
		switch (operator.getValue()) {
			case ClockSpeedOpKind.SLOWER:
				this.setImage(ASSERTIONCLOCKSLOWER_IMG);
				break;
			case ClockSpeedOpKind.FASTER:
				this.setImage(ASSERTIONCLOCKFASTER_IMG);
				break;
		}
	}
}
