/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.clockrelations.figures;

import fr.irisa.espresso.sme.ClockRelationOpKind;
import fr.irisa.espresso.sme.common.figures.SignalOperatorFigure;

/*
 * @generated NOT
 */
public class ClockRelationOperatorFigure extends SignalOperatorFigure {
	private final static String	CLOCKUNION_IMG			= "CLOCKUNION_LARGE";
	
	private final static String	CLOCKINTERSECTION_IMG	= "CLOCKINTERSECTION_LARGE";
	
	private final static String	CLOCKCOMPLEMENTARY_IMG	= "CLOCKCOMPLEMENTARY_LARGE";
	
	private ClockRelationOpKind	operator				= ClockRelationOpKind.UNION_LITERAL;
	
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public ClockRelationOperatorFigure() {
		super(CLOCKUNION_IMG);
	}
	
	/**
	 * Get the kind of numeric operator
	 * 
	 * @return the current numeric operator
	 */
	public ClockRelationOpKind getClockRelationOperator() {
		return operator;
	}
	
	/**
	 * Set the kind of numeric operator
	 * 
	 * @param newValue
	 *        the new numeric operator
	 */
	public void setClockRelationOperator(ClockRelationOpKind newValue) {
		operator = newValue;
		switch (operator.getValue()) {
			case ClockRelationOpKind.UNION:
				this.setImage(CLOCKUNION_IMG);
				break;
			case ClockRelationOpKind.INTERSECTION:
				this.setImage(CLOCKINTERSECTION_IMG);
				break;
			case ClockRelationOpKind.COMPLEMENTARY:
				this.setImage(CLOCKCOMPLEMENTARY_IMG);
				break;
		}
	}
}
