/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.clockrelations.preferences;

/*
 * A set of constant that are used in the diagram graphical preferences
 * 
 * @generated
 */
public interface CRD_DiagramPreferenceConstants {
	/**
	 * The key used to install a <i>SignalRef Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SIGNALREF_DEFAULT_BACKGROUND_COLOR							= "SignalRef Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>SignalRef Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SIGNALREF_DEFAULT_FOREGROUND_COLOR							= "SignalRef Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>SignalRef Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SIGNALREF_DEFAULT_FONT										= "SignalRef Default Font (CRD)";
	
	/**
	 * The key used to install a <i>Input Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_BACKGROUND_COLOR								= "Input Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>Input Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_FOREGROUND_COLOR								= "Input Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>Input Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_FONT											= "Input Default Font (CRD)";
	
	/**
	 * The key used to install a <i>Output Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_BACKGROUND_COLOR								= "Output Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>Output Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_FOREGROUND_COLOR								= "Output Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>Output Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_FONT											= "Output Default Font (CRD)";
	
	/**
	 * The key used to install a <i>Local Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_BACKGROUND_COLOR								= "Local Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>Local Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_FOREGROUND_COLOR								= "Local Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>Local Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_FONT											= "Local Default Font (CRD)";
	
	/**
	 * The key used to install a <i>InputInstance Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTINSTANCE_DEFAULT_BACKGROUND_COLOR						= "InputInstance Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>InputInstance Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTINSTANCE_DEFAULT_FOREGROUND_COLOR						= "InputInstance Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>InputInstance Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTINSTANCE_DEFAULT_FONT									= "InputInstance Default Font (CRD)";
	
	/**
	 * The key used to install a <i>OutputInstance Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTINSTANCE_DEFAULT_BACKGROUND_COLOR						= "OutputInstance Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>OutputInstance Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTINSTANCE_DEFAULT_FOREGROUND_COLOR						= "OutputInstance Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>OutputInstance Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTINSTANCE_DEFAULT_FONT									= "OutputInstance Default Font (CRD)";
	
	/**
	 * The key used to install a <i>BasicIterate Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BASICITERATE_DEFAULT_BACKGROUND_COLOR						= "BasicIterate Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>BasicIterate Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BASICITERATE_DEFAULT_FOREGROUND_COLOR						= "BasicIterate Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>BasicIterate Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BASICITERATE_DEFAULT_FONT									= "BasicIterate Default Font (CRD)";
	
	/**
	 * The key used to install a <i>Iterate Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATE_DEFAULT_BACKGROUND_COLOR							= "Iterate Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>Iterate Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATE_DEFAULT_FOREGROUND_COLOR							= "Iterate Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>Iterate Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATE_DEFAULT_FONT										= "Iterate Default Font (CRD)";
	
	/**
	 * The key used to install a <i>SubProcess Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBPROCESS_DEFAULT_BACKGROUND_COLOR							= "SubProcess Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>SubProcess Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBPROCESS_DEFAULT_FOREGROUND_COLOR							= "SubProcess Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>SubProcess Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBPROCESS_DEFAULT_FONT										= "SubProcess Default Font (CRD)";
	
	/**
	 * The key used to install a <i>Automaton Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_BACKGROUND_COLOR							= "Automaton Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>Automaton Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_FOREGROUND_COLOR							= "Automaton Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>Automaton Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_FONT										= "Automaton Default Font (CRD)";
	
	/**
	 * The key used to install a <i>ModelInstance Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELINSTANCE_DEFAULT_BACKGROUND_COLOR						= "ModelInstance Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>ModelInstance Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELINSTANCE_DEFAULT_FOREGROUND_COLOR						= "ModelInstance Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>ModelInstance Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELINSTANCE_DEFAULT_FONT									= "ModelInstance Default Font (CRD)";
	
	/**
	 * The key used to install a <i>ClockConstraintOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKCONSTRAINTOPERATOR_DEFAULT_BACKGROUND_COLOR			= "ClockConstraintOperator Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>ClockConstraintOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKCONSTRAINTOPERATOR_DEFAULT_FOREGROUND_COLOR			= "ClockConstraintOperator Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>ClockConstraintOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKCONSTRAINTOPERATOR_DEFAULT_FONT						= "ClockConstraintOperator Default Font (CRD)";
	
	/**
	 * The key used to install a <i>AssertionClockConstraintOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_BACKGROUND_COLOR	= "AssertionClockConstraintOperator Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>AssertionClockConstraintOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_FOREGROUND_COLOR	= "AssertionClockConstraintOperator Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>AssertionClockConstraintOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_FONT				= "AssertionClockConstraintOperator Default Font (CRD)";
	
	/**
	 * The key used to install a <i>ClockRelationOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKRELATIONOPERATOR_DEFAULT_BACKGROUND_COLOR				= "ClockRelationOperator Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>ClockRelationOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKRELATIONOPERATOR_DEFAULT_FOREGROUND_COLOR				= "ClockRelationOperator Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>ClockRelationOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKRELATIONOPERATOR_DEFAULT_FONT							= "ClockRelationOperator Default Font (CRD)";
	
	/**
	 * The key used to install a <i>ClockSpeedOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKSPEEDOPERATOR_DEFAULT_BACKGROUND_COLOR					= "ClockSpeedOperator Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>ClockSpeedOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKSPEEDOPERATOR_DEFAULT_FOREGROUND_COLOR					= "ClockSpeedOperator Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>ClockSpeedOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKSPEEDOPERATOR_DEFAULT_FONT								= "ClockSpeedOperator Default Font (CRD)";
	
	/**
	 * The key used to install a <i>AssertionClockSpeedOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_BACKGROUND_COLOR		= "AssertionClockSpeedOperator Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>AssertionClockSpeedOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_FOREGROUND_COLOR		= "AssertionClockSpeedOperator Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>AssertionClockSpeedOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_FONT					= "AssertionClockSpeedOperator Default Font (CRD)";
	
	/**
	 * The key used to install a <i>DependenceOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DEPENDENCEOPERATOR_DEFAULT_BACKGROUND_COLOR					= "DependenceOperator Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>DependenceOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DEPENDENCEOPERATOR_DEFAULT_FOREGROUND_COLOR					= "DependenceOperator Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>DependenceOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DEPENDENCEOPERATOR_DEFAULT_FONT								= "DependenceOperator Default Font (CRD)";
	
	/**
	 * The key used to install a <i>NullClock Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NULLCLOCK_DEFAULT_BACKGROUND_COLOR							= "NullClock Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>NullClock Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NULLCLOCK_DEFAULT_FOREGROUND_COLOR							= "NullClock Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>NullClock Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NULLCLOCK_DEFAULT_FONT										= "NullClock Default Font (CRD)";
	
	/**
	 * The key used to install a <i>InputPort Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTPORT_DEFAULT_BACKGROUND_COLOR							= "InputPort Default Background Color (CRD)";
	
	/**
	 * The key used to install a <i>InputPort Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTPORT_DEFAULT_FOREGROUND_COLOR							= "InputPort Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>InputPort Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTPORT_DEFAULT_FONT										= "InputPort Default Font (CRD)";
	
	/**
	 * The key used to install a <i>ClockRelation Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKRELATION_EDGE_DEFAULT_FONT								= "ClockRelation Edge Default Font (CRD)";
	
	/**
	 * The key used to install a <i>ClockRelation Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKRELATION_EDGE_DEFAULT_FOREGROUND_COLOR					= "ClockRelation Edge Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>ClockRelation Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKRELATION_EDGE_DEFAULT_ROUTER							= "ClockRelation Edge Default Router (CRD)";
	
	/**
	 * The key used to install a <i>ClockRelation srcField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKRELATION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY		= "ClockRelation srcField Edge Object Default Visibility (CRD)";
	/**
	 * The key used to install a <i>ClockRelation dstField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CLOCKRELATION_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY		= "ClockRelation dstField Edge Object Default Visibility (CRD)";
	
	/**
	 * The key used to install a <i>Condition Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_EDGE_DEFAULT_FONT									= "Condition Edge Default Font (CRD)";
	
	/**
	 * The key used to install a <i>Condition Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_EDGE_DEFAULT_FOREGROUND_COLOR						= "Condition Edge Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>Condition Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_EDGE_DEFAULT_ROUTER								= "Condition Edge Default Router (CRD)";
	
	/**
	 * The key used to install a <i>Condition srcField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY			= "Condition srcField Edge Object Default Visibility (CRD)";
	/**
	 * The key used to install a <i>Condition conditionKind Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_CONDITIONKIND_EDGE_OBJECT_DEFAULT_VISIBILITY		= "Condition conditionKind Edge Object Default Visibility (CRD)";
	
	/**
	 * The key used to install a <i>Dependence Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DEPENDENCE_EDGE_DEFAULT_FONT								= "Dependence Edge Default Font (CRD)";
	
	/**
	 * The key used to install a <i>Dependence Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DEPENDENCE_EDGE_DEFAULT_FOREGROUND_COLOR					= "Dependence Edge Default Foreground Color (CRD)";
	
	/**
	 * The key used to install a <i>Dependence Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DEPENDENCE_EDGE_DEFAULT_ROUTER								= "Dependence Edge Default Router (CRD)";
	
	/**
	 * The key used to install a <i>Dependence srcField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DEPENDENCE_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY			= "Dependence srcField Edge Object Default Visibility (CRD)";
	/**
	 * The key used to install a <i>Dependence dstField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DEPENDENCE_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY			= "Dependence dstField Edge Object Default Visibility (CRD)";
	
}
