/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.clockrelations.preferences;

import java.util.HashMap;

import org.eclipse.jface.resource.StringConverter;
import org.topcased.modeler.preferences.ITopcasedPreferenceInitializer;

/*
 * Initialize the preferences of CRD_ diagram
 * 
 * @generated
 */
public class CRD_DiagramTopcasedPreferenceInitializer implements ITopcasedPreferenceInitializer {
	
	/**
	 * @see org.topcased.modeler.preferences.ITopcasedPreferenceInitializer#getDefaultPreference()
	 * @generated
	 */
	public HashMap<String, String> getDefaultPreference() {
		HashMap<String, String> defaultCRD_Preference = new HashMap<String, String>();
		// Initialize the default value of the SIGNALREF_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.SIGNALREF_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the SIGNALREF_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.SIGNALREF_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SIGNALREF_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.SIGNALREF_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the INPUT_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the INPUT_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the INPUT_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the OUTPUT_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.OUTPUT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the OUTPUT_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.OUTPUT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the OUTPUT_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.OUTPUT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the LOCAL_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.LOCAL_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the LOCAL_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.LOCAL_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the LOCAL_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.LOCAL_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the INPUTINSTANCE_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUTINSTANCE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the INPUTINSTANCE_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUTINSTANCE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the INPUTINSTANCE_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUTINSTANCE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the OUTPUTINSTANCE_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference
				.put(CRD_DiagramPreferenceConstants.OUTPUTINSTANCE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the OUTPUTINSTANCE_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.OUTPUTINSTANCE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the OUTPUTINSTANCE_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.OUTPUTINSTANCE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the BASICITERATE_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.BASICITERATE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the BASICITERATE_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.BASICITERATE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the BASICITERATE_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.BASICITERATE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ITERATE_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.ITERATE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ITERATE_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.ITERATE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ITERATE_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.ITERATE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the SUBPROCESS_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.SUBPROCESS_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the SUBPROCESS_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.SUBPROCESS_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SUBPROCESS_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.SUBPROCESS_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the AUTOMATON_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.AUTOMATON_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the AUTOMATON_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.AUTOMATON_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the AUTOMATON_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.AUTOMATON_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the MODELINSTANCE_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.MODELINSTANCE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the MODELINSTANCE_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.MODELINSTANCE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the MODELINSTANCE_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.MODELINSTANCE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CLOCKCONSTRAINTOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKCONSTRAINTOPERATOR_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the CLOCKCONSTRAINTOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKCONSTRAINTOPERATOR_DEFAULT_FOREGROUND_COLOR,
			"0,0,0");
		
		// Initialize the default value of the CLOCKCONSTRAINTOPERATOR_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKCONSTRAINTOPERATOR_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(
			CRD_DiagramPreferenceConstants.ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(
			CRD_DiagramPreferenceConstants.ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.ASSERTIONCLOCKCONSTRAINTOPERATOR_DEFAULT_FONT,
			StringConverter.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CLOCKRELATIONOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKRELATIONOPERATOR_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the CLOCKRELATIONOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKRELATIONOPERATOR_DEFAULT_FOREGROUND_COLOR,
			"0,0,0");
		
		// Initialize the default value of the CLOCKRELATIONOPERATOR_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKRELATIONOPERATOR_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CLOCKSPEEDOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKSPEEDOPERATOR_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the CLOCKSPEEDOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKSPEEDOPERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the CLOCKSPEEDOPERATOR_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKSPEEDOPERATOR_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_FOREGROUND_COLOR,
			"0,0,0");
		
		// Initialize the default value of the ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.ASSERTIONCLOCKSPEEDOPERATOR_DEFAULT_FONT,
			StringConverter.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the DEPENDENCEOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.DEPENDENCEOPERATOR_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the DEPENDENCEOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.DEPENDENCEOPERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the DEPENDENCEOPERATOR_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.DEPENDENCEOPERATOR_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the NULLCLOCK_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.NULLCLOCK_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the NULLCLOCK_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.NULLCLOCK_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the NULLCLOCK_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.NULLCLOCK_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the INPUTPORT_DEFAULT_BACKGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUTPORT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the INPUTPORT_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUTPORT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the INPUTPORT_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.INPUTPORT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the CLOCKRELATION_EDGE_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKRELATION_EDGE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CLOCKRELATION_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference
				.put(CRD_DiagramPreferenceConstants.CLOCKRELATION_EDGE_DEFAULT_FOREGROUND_COLOR, "0,0,255");
		
		// Initialize the default value of the CLOCKRELATION_EDGE_DEFAULT_ROUTER property
		defaultCRD_Preference
				.put(CRD_DiagramPreferenceConstants.CLOCKRELATION_EDGE_DEFAULT_ROUTER, "RectilinearRouter");
		
		// Initialize the default value of the CLOCKRELATION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKRELATION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		// Initialize the default value of the CLOCKRELATION_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CLOCKRELATION_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		
		// Initialize the default value of the CONDITION_EDGE_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CONDITION_EDGE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CONDITION_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CONDITION_EDGE_DEFAULT_FOREGROUND_COLOR, "0,128,0");
		
		// Initialize the default value of the CONDITION_EDGE_DEFAULT_ROUTER property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CONDITION_EDGE_DEFAULT_ROUTER, "RectilinearRouter");
		
		// Initialize the default value of the CONDITION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.CONDITION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		// Initialize the default value of the CONDITION_CONDITIONKIND_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultCRD_Preference.put(
			CRD_DiagramPreferenceConstants.CONDITION_CONDITIONKIND_EDGE_OBJECT_DEFAULT_VISIBILITY, "true");
		
		// Initialize the default value of the DEPENDENCE_EDGE_DEFAULT_FONT property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.DEPENDENCE_EDGE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the DEPENDENCE_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.DEPENDENCE_EDGE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the DEPENDENCE_EDGE_DEFAULT_ROUTER property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.DEPENDENCE_EDGE_DEFAULT_ROUTER, "ObliqueRouter");
		
		// Initialize the default value of the DEPENDENCE_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.DEPENDENCE_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		// Initialize the default value of the DEPENDENCE_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultCRD_Preference.put(CRD_DiagramPreferenceConstants.DEPENDENCE_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		
		return defaultCRD_Preference;
	}
}
