/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow;

/*
 * A collection of Roles. Each identifier is used to key the EditPolicy.
 * 
 * @generated
 */
public interface DF_EditPolicyConstants {
	
	/**
	 * The key used to install an <i>SubProcess</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SUBPROCESS_EDITPOLICY			= "SubProcess EditPolicy";
	
	/**
	 * The key used to install an <i>BasicIterate</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	BASICITERATE_EDITPOLICY			= "BasicIterate EditPolicy";
	
	/**
	 * The key used to install an <i>Iterate</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ITERATE_EDITPOLICY				= "Iterate EditPolicy";
	
	/**
	 * The key used to install an <i>IterationInit</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ITERATIONINIT_EDITPOLICY		= "IterationInit EditPolicy";
	
	/**
	 * The key used to install an <i>ModelDeclaration</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	MODELDECLARATION_EDITPOLICY		= "ModelDeclaration EditPolicy";
	
	/**
	 * The key used to install an <i>ModelRef</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	MODELREF_EDITPOLICY				= "ModelRef EditPolicy";
	
	/**
	 * The key used to install an <i>Automaton</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	AUTOMATON_EDITPOLICY			= "Automaton EditPolicy";
	
	/**
	 * The key used to install an <i>ModelInstance</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	MODELINSTANCE_EDITPOLICY		= "ModelInstance EditPolicy";
	
	/**
	 * The key used to install an <i>EnumerationType</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ENUMERATIONTYPE_EDITPOLICY		= "EnumerationType EditPolicy";
	
	/**
	 * The key used to install an <i>SubstitutionType</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SUBSTITUTIONTYPE_EDITPOLICY		= "SubstitutionType EditPolicy";
	
	/**
	 * The key used to install an <i>TupleType</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	TUPLETYPE_EDITPOLICY			= "TupleType EditPolicy";
	
	/**
	 * The key used to install an <i>ModelType</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	MODELTYPE_EDITPOLICY			= "ModelType EditPolicy";
	
	/**
	 * The key used to install an <i>UseModule</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	USEMODULE_EDITPOLICY			= "UseModule EditPolicy";
	
	/**
	 * The key used to install an <i>InputPort</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	INPUTPORT_EDITPOLICY			= "InputPort EditPolicy";
	
	/**
	 * The key used to install an <i>Assertion</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ASSERTION_EDITPOLICY			= "Assertion EditPolicy";
	
	/**
	 * The key used to install an <i>CartesianProduct</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CARTESIANPRODUCT_EDITPOLICY		= "CartesianProduct EditPolicy";
	
	/**
	 * The key used to install an <i>Switch</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SWITCH_EDITPOLICY				= "Switch EditPolicy";
	
	/**
	 * The key used to install an <i>SignalExpr</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SIGNALEXPR_EDITPOLICY			= "SignalExpr EditPolicy";
	
	/**
	 * The key used to install an <i>SignalOrRef</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SIGNALORREF_EDITPOLICY			= "SignalOrRef EditPolicy";
	
	/**
	 * The key used to install an <i>SignalRef</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SIGNALREF_EDITPOLICY			= "SignalRef EditPolicy";
	
	/**
	 * The key used to install an <i>Input</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	INPUT_EDITPOLICY				= "Input EditPolicy";
	
	/**
	 * The key used to install an <i>Output</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	OUTPUT_EDITPOLICY				= "Output EditPolicy";
	
	/**
	 * The key used to install an <i>Local</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	LOCAL_EDITPOLICY				= "Local EditPolicy";
	
	/**
	 * The key used to install an <i>InputInstance</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	INPUTINSTANCE_EDITPOLICY		= "InputInstance EditPolicy";
	
	/**
	 * The key used to install an <i>OutputInstance</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	OUTPUTINSTANCE_EDITPOLICY		= "OutputInstance EditPolicy";
	
	/**
	 * The key used to install an <i>Cell</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CELL_EDITPOLICY					= "Cell EditPolicy";
	
	/**
	 * The key used to install an <i>Counter</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	COUNTER_EDITPOLICY				= "Counter EditPolicy";
	
	/**
	 * The key used to install an <i>Delay</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	DELAY_EDITPOLICY				= "Delay EditPolicy";
	
	/**
	 * The key used to install an <i>Variable</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	VARIABLE_EDITPOLICY				= "Variable EditPolicy";
	
	/**
	 * The key used to install an <i>Window</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	WINDOW_EDITPOLICY				= "Window EditPolicy";
	
	/**
	 * The key used to install an <i>ConstantExpr</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CONSTANTEXPR_EDITPOLICY			= "ConstantExpr EditPolicy";
	
	/**
	 * The key used to install an <i>OutputPort</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	OUTPUTPORT_EDITPOLICY			= "OutputPort EditPolicy";
	
	/**
	 * The key used to install an <i>ConstantRef</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CONSTANTREF_EDITPOLICY			= "ConstantRef EditPolicy";
	
	/**
	 * The key used to install an <i>Parameter</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	PARAMETER_EDITPOLICY			= "Parameter EditPolicy";
	
	/**
	 * The key used to install an <i>ConstantValue</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CONSTANTVALUE_EDITPOLICY		= "ConstantValue EditPolicy";
	
	/**
	 * The key used to install an <i>Literal</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	LITERAL_EDITPOLICY				= "Literal EditPolicy";
	
	/**
	 * The key used to install an <i>EnumerationValue</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ENUMERATIONVALUE_EDITPOLICY		= "EnumerationValue EditPolicy";
	
	/**
	 * The key used to install an <i>ParameterInstance</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	PARAMETERINSTANCE_EDITPOLICY	= "ParameterInstance EditPolicy";
	
	/**
	 * The key used to install an <i>Index</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	INDEX_EDITPOLICY				= "Index EditPolicy";
	
	/**
	 * The key used to install an <i>Iterator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ITERATOR_EDITPOLICY				= "Iterator EditPolicy";
	
	/**
	 * The key used to install an <i>ArrayEnumeration</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ARRAYENUMERATION_EDITPOLICY		= "ArrayEnumeration EditPolicy";
	
	/**
	 * The key used to install an <i>ArrayRecovery</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ARRAYRECOVERY_EDITPOLICY		= "ArrayRecovery EditPolicy";
	
	/**
	 * The key used to install an <i>ArrayRestructuration</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ARRAYRESTRUCTURATION_EDITPOLICY	= "ArrayRestructuration EditPolicy";
	
	/**
	 * The key used to install an <i>Concatenation</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CONCATENATION_EDITPOLICY		= "Concatenation EditPolicy";
	
	/**
	 * The key used to install an <i>Extraction</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	EXTRACTION_EDITPOLICY			= "Extraction EditPolicy";
	
	/**
	 * The key used to install an <i>IfThenElse</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	IFTHENELSE_EDITPOLICY			= "IfThenElse EditPolicy";
	
	/**
	 * The key used to install an <i>Merge</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	MERGE_EDITPOLICY				= "Merge EditPolicy";
	
	/**
	 * The key used to install an <i>RepetitionOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	REPETITIONOPERATOR_EDITPOLICY	= "RepetitionOperator EditPolicy";
	
	/**
	 * The key used to install an <i>SequentialDefinition</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	SEQUENTIALDEFINITION_EDITPOLICY	= "SequentialDefinition EditPolicy";
	
	/**
	 * The key used to install an <i>Transposition</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	TRANSPOSITION_EDITPOLICY		= "Transposition EditPolicy";
	
	/**
	 * The key used to install an <i>TupleOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	TUPLEOPERATOR_EDITPOLICY		= "TupleOperator EditPolicy";
	
	/**
	 * The key used to install an <i>BooleanOperatorI</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	BOOLEANOPERATORI_EDITPOLICY		= "BooleanOperatorI EditPolicy";
	
	/**
	 * The key used to install an <i>BooleanExpression</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	BOOLEANEXPRESSION_EDITPOLICY	= "BooleanExpression EditPolicy";
	
	/**
	 * The key used to install an <i>And</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	AND_EDITPOLICY					= "And EditPolicy";
	
	/**
	 * The key used to install an <i>ComparisonOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	COMPARISONOPERATOR_EDITPOLICY	= "ComparisonOperator EditPolicy";
	
	/**
	 * The key used to install an <i>Not</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	NOT_EDITPOLICY					= "Not EditPolicy";
	
	/**
	 * The key used to install an <i>Or</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	OR_EDITPOLICY					= "Or EditPolicy";
	
	/**
	 * The key used to install an <i>Xor</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	XOR_EDITPOLICY					= "Xor EditPolicy";
	
	/**
	 * The key used to install an <i>ArithmeticOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ARITHMETICOPERATOR_EDITPOLICY	= "ArithmeticOperator EditPolicy";
	
	/**
	 * The key used to install an <i>ArrayProduct</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ARRAYPRODUCT_EDITPOLICY			= "ArrayProduct EditPolicy";
	
	/**
	 * The key used to install an <i>ComplexOperator</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	COMPLEXOPERATOR_EDITPOLICY		= "ComplexOperator EditPolicy";
	
	/**
	 * The key used to install an <i>NumericExpression</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	NUMERICEXPRESSION_EDITPOLICY	= "NumericExpression EditPolicy";
	
	/**
	 * The key used to install an <i>UnaryMinus</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	UNARYMINUS_EDITPOLICY			= "UnaryMinus EditPolicy";
	
	/**
	 * The key used to install an <i>CaseConnection</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CASECONNECTION_EDITPOLICY		= "CaseConnection EditPolicy";
	
	/**
	 * The key used to install an <i>Condition</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CONDITION_EDITPOLICY			= "Condition EditPolicy";
	
	/**
	 * The key used to install an <i>ConstantAffectation</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	CONSTANTAFFECTATION_EDITPOLICY	= "ConstantAffectation EditPolicy";
	
	/**
	 * The key used to install an <i>DataflowConnection</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	DATAFLOWCONNECTION_EDITPOLICY	= "DataflowConnection EditPolicy";
	
}
