/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.commands;

import org.eclipse.gef.EditDomain;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;

/*
 * CaseConnection edge creation command
 * 
 * @generated
 */
public class CaseConnectionEdgeCreationCommand extends CreateTypedEdgeCommand {
	
	/**
	 * @param domain
	 *        the edit domain
	 * @param newObj
	 *        the graph edge of the new connection
	 * @param src
	 *        the graph element of the source
	 * @generated
	 */
	public CaseConnectionEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src) {
		this(domain, newObj, src, true);
	}
	
	/**
	 * @param domain
	 *        the edit domain
	 * @param newObj
	 *        the graph edge of the new connection
	 * @param src
	 *        the graph element of the source
	 * @param needModelUpdate
	 *        set it to true if the model need to be updated
	 * @generated
	 */
	public CaseConnectionEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src,
			boolean needModelUpdate) {
		super(domain, newObj, src, needModelUpdate);
	}
	
}
