/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.commands;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.commands.AbstractRestoreConnectionCommand;
import org.topcased.modeler.requests.RestoreConnectionsRequest;

/*
 * ModelInstance restore connection command
 * 
 * @generated
 */
public class ModelInstanceRestoreConnectionCommand extends AbstractRestoreConnectionCommand {
	/**
	 * @param part
	 *        the EditPart that is restored
	 * @generated
	 */
	public ModelInstanceRestoreConnectionCommand(EditPart part) {
		super(part);
	}
	
	/**
	 * @see org.topcased.modeler.commands.AbstractRestoreConnectionCommand#initializeCommands()
	 * @generated NOT
	 */
	protected void initializeCommands() {
		// Add the restore connection commands of all inner objects
		// construct the RestoreConnectionRequest
		RestoreConnectionsRequest request = new RestoreConnectionsRequest();
		
		for (Object obj : getRestoredPart().getChildren()) {
			if (obj instanceof EditPart) {
				// get the Command
				Command command = ((EditPart) obj).getCommand(request);
				if (command != null && command.canExecute())
					add(command);
			}
		}
	}
	
}
