/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.figures;

import fr.irisa.espresso.sme.ArithmeticOpKind;
import fr.irisa.espresso.sme.common.figures.SignalOperatorFigure;

/*
 * @generated NOT
 */
public class ArithmeticOperatorFigure extends SignalOperatorFigure {
	private final static String	ADDITION_IMG		= "ADDITION_LARGE";
	
	private final static String	SUBSTRACTION_IMG	= "SUBSTRACTION_LARGE";
	
	private final static String	MULTIPLICATION_IMG	= "MULTIPLICATION_LARGE";
	
	private final static String	DIVISION_IMG		= "DIVISION_LARGE";
	
	private final static String	MODULO_IMG			= "MODULO_LARGE";
	
	private final static String	POWER_IMG			= "POWER_LARGE";
	
	private ArithmeticOpKind	operator			= ArithmeticOpKind.ADDITION_LITERAL;
	
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public ArithmeticOperatorFigure() {
		super(ADDITION_IMG);
	}
	
	/**
	 * Get the kind of numeric operator
	 * 
	 * @return the current numeric operator
	 * @generated NOT
	 */
	public ArithmeticOpKind getArithmeticOperator() {
		return operator;
	}
	
	/**
	 * Set the kind of numeric operator
	 * 
	 * @param newValue
	 *        the new numeric operator
	 * @generated NOT
	 */
	public void setArithmeticOperator(ArithmeticOpKind newValue) {
		operator = newValue;
		switch (operator.getValue()) {
			case ArithmeticOpKind.ADDITION:
				this.setImage(ADDITION_IMG);
				break;
			case ArithmeticOpKind.SUBSTRACTION:
				this.setImage(SUBSTRACTION_IMG);
				break;
			case ArithmeticOpKind.MULTIPLICATION:
				this.setImage(MULTIPLICATION_IMG);
				break;
			case ArithmeticOpKind.DIVISION:
				this.setImage(DIVISION_IMG);
				break;
			case ArithmeticOpKind.MODULO:
				this.setImage(MODULO_IMG);
				break;
			case ArithmeticOpKind.POWER:
				this.setImage(POWER_IMG);
				break;
		}
	}
}
