/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.figures;

import fr.irisa.espresso.sme.ComparisonOpKind;
import fr.irisa.espresso.sme.common.figures.SignalOperatorFigure;

/*
 * @generated NOT
 */
public class ComparisonOperatorFigure extends SignalOperatorFigure {
	private final static String	EQUAL_IMG					= "EQUAL_LARGE";
	
	private final static String	NOT_EQUAL_IMG				= "NOT_EQUAL_LARGE";
	
	private final static String	GREATER_IMG					= "GREATER_LARGE";
	
	private final static String	GREATER_OR_EQUAL_IMG		= "GREATER_OR_EQUAL_LARGE";
	
	private final static String	SMALLER_IMG					= "SMALLER_LARGE";
	
	private final static String	SMALLER_OR_EQUAL_IMG		= "SMALLER_OR_EQUAL_LARGE";
	
	private final static String	EQUAL_ANY_IMG				= "EQUAL_ANY_LARGE";
	
	private final static String	SMALLER_OR_EQUAL_ANY_IMG	= "SMALLER_OR_EQUAL_ANY_LARGE";
	
	private ComparisonOpKind	operator					= ComparisonOpKind.EQUAL_LITERAL;
	
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public ComparisonOperatorFigure() {
		super(EQUAL_IMG);
	}
	
	/**
	 * Get the kind of numeric operator
	 * 
	 * @return the current numeric operator
	 * @generated NOT
	 */
	public ComparisonOpKind getComparisonOperator() {
		return operator;
	}
	
	/**
	 * Set the kind of numeric operator
	 * 
	 * @param newValue
	 *        the new numeric operator
	 * @generated NOT
	 */
	public void setComparisonOperator(ComparisonOpKind newValue) {
		operator = newValue;
		switch (operator.getValue()) {
			case ComparisonOpKind.EQUAL:
				this.setImage(EQUAL_IMG);
				break;
			case ComparisonOpKind.NOT_EQUAL:
				this.setImage(NOT_EQUAL_IMG);
				break;
			case ComparisonOpKind.GREATER:
				this.setImage(GREATER_IMG);
				break;
			case ComparisonOpKind.GREATER_OR_EQUAL:
				this.setImage(GREATER_OR_EQUAL_IMG);
				break;
			case ComparisonOpKind.SMALLER:
				this.setImage(SMALLER_IMG);
				break;
			case ComparisonOpKind.SMALLER_OR_EQUAL:
				this.setImage(SMALLER_OR_EQUAL_IMG);
				break;
			case ComparisonOpKind.SMALLER_OR_EQUAL_ANY:
				this.setImage(SMALLER_OR_EQUAL_ANY_IMG);
				break;
			case ComparisonOpKind.EQUAL_ANY:
				this.setImage(EQUAL_ANY_IMG);
				break;
		}
	}
}
