/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.figures;

import fr.irisa.espresso.sme.CounterKind;
import fr.irisa.espresso.sme.common.figures.SignalOperatorFigure;

/*
 * @generated NOT
 */
public class CounterFigure extends SignalOperatorFigure {
	private final static String	COUNTER_AFTER_IMG	= "COUNTER_AFTER_LARGE";
	
	private final static String	COUNTER_COUNT_IMG	= "COUNTER_COUNT_LARGE";
	
	private final static String	COUNTER_FROM_IMG	= "COUNTER_FROM_LARGE";
	
	private CounterKind			operator			= CounterKind.FROM;
	
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public CounterFigure() {
		super(COUNTER_FROM_IMG);
	}
	
	/**
	 * Get the kind of counter operator
	 * 
	 * @return the current counter operator
	 * @generated NOT
	 */
	public CounterKind getCounterOperator() {
		return operator;
	}
	
	/**
	 * Set the kind of counter operator
	 * 
	 * @param newValue
	 *        the new counter operator
	 * @generated NOT
	 */
	public void setCounterOperator(CounterKind newValue) {
		operator = newValue;
		switch (operator.getValue()) {
			case CounterKind.FROM_VALUE:
				this.setImage(COUNTER_FROM_IMG);
				break;
			case CounterKind.AFTER_VALUE:
				this.setImage(COUNTER_AFTER_IMG);
				break;
			case CounterKind.COUNT_VALUE:
				this.setImage(COUNTER_COUNT_IMG);
				break;
		}
	}
}
