/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Dimension;

import fr.irisa.espresso.sme.common.figures.SignalOperatorFigure;

/*
 * @generated NOT
 */
public class IterateFigure extends SignalOperatorFigure {
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public IterateFigure() {
		super("ITERATE_LARGE");
	}
	
	/**
	 * @see fr.irisa.espresso.sme.common.figures.SignalOperatorFigure#drawLines(org.eclipse.draw2d.Graphics)
	 * @generated NOT
	 */
	protected void drawLines(Graphics graphics) {}
	
	/**
	 * Draw the image at the center of the figure
	 * 
	 * @param graphics
	 *        the graphics in which the image can be drawn
	 * @generated NOT
	 */
	protected void drawImage(Graphics graphics) {
		// Display the image at the center of the SignalOperator
		Dimension dim = new Dimension(img);
		graphics.drawImage(img, 0, 0, dim.width, dim.height, (bounds.x + PORT_SIZE.width),
			(bounds.y + (bounds.height - (dim.height * 2)) / 2), 2 * dim.width, 2 * dim.height);
	}
	
	/**
	 * @see IFigure#getPreferredSize(int, int)
	 * @generated NOT
	 */
	public Dimension getPreferredSize(int wHint, int hHint) {
		Dimension dim = super.getPreferredSize(wHint, hHint);
		Dimension imgDim = new Dimension(0, 0);
		if (img != null)
			imgDim = new Dimension(img);
		
		dim.width += imgDim.width;
		dim.height += Math.max(dim.height, imgDim.height * 2);
		return dim;
	}
}
