/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Dimension;

import fr.irisa.espresso.sme.common.figures.SignalOperatorFigure;

/*
 * @generated NOT
 */
public class MergeFigure extends SignalOperatorFigure {
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public MergeFigure() {
		super(null);
	}
	
	/**
	 * Draw the lines between InputPorts and between OutputPorts
	 * 
	 * @param graphics
	 *        the graphics in which the lines can be drawed
	 */
	protected void drawLines(Graphics graphics) {
		graphics.setLineWidth(2);
		
		int decX = 0;
		if (getNbInputPorts() > 1)
			decX = PORT_SIZE.width;
		
		// draw the triangle
		graphics.drawLine(bounds.getTopLeft().getTranslated(decX, 0), bounds.getBottomLeft().getTranslated(decX, 0));
		graphics.drawLine(bounds.getTopLeft().getTranslated(decX, 0), bounds.getRight());
		graphics.drawLine(bounds.getBottomLeft().getTranslated(decX, 0), bounds.getRight());
		
	}
	
	/**
	 * Draw the image at the center of the figure
	 * 
	 * @param graphics
	 *        the graphics in which the image can be drawed
	 */
	protected void drawImage(Graphics graphics) {

	}
	
	/**
	 * @see IFigure#getPreferredSize(int, int)
	 */
	public Dimension getPreferredSize(int wHint, int hHint) {
		int nbInputPorts = getNbInputPorts();
		Dimension dim = new Dimension();
		dim.width = ((nbInputPorts > 0) ? PORT_SIZE.width : 0) + 30;
		dim.height = (5 + PORT_SIZE.height) * nbInputPorts;
		return dim;
	}
}
