/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.preferences;

/*
 * A set of constant that are used in the diagram graphical preferences
 * 
 * @generated
 */
public interface DF_DiagramPreferenceConstants {
	/**
	 * The key used to install a <i>SubProcess Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBPROCESS_DEFAULT_BACKGROUND_COLOR							= "SubProcess Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>SubProcess Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBPROCESS_DEFAULT_FOREGROUND_COLOR							= "SubProcess Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>SubProcess Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBPROCESS_DEFAULT_FONT										= "SubProcess Default Font (DF)";
	
	/**
	 * The key used to install a <i>BasicIterate Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BASICITERATE_DEFAULT_BACKGROUND_COLOR						= "BasicIterate Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>BasicIterate Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BASICITERATE_DEFAULT_FOREGROUND_COLOR						= "BasicIterate Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>BasicIterate Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BASICITERATE_DEFAULT_FONT									= "BasicIterate Default Font (DF)";
	
	/**
	 * The key used to install a <i>Iterate Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATE_DEFAULT_BACKGROUND_COLOR							= "Iterate Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Iterate Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATE_DEFAULT_FOREGROUND_COLOR							= "Iterate Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Iterate Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATE_DEFAULT_FONT										= "Iterate Default Font (DF)";
	
	/**
	 * The key used to install a <i>ModelDeclaration Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELDECLARATION_DEFAULT_BACKGROUND_COLOR					= "ModelDeclaration Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ModelDeclaration Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELDECLARATION_DEFAULT_FOREGROUND_COLOR					= "ModelDeclaration Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ModelDeclaration Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELDECLARATION_DEFAULT_FONT								= "ModelDeclaration Default Font (DF)";
	
	/**
	 * The key used to install a <i>ModelRef Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELREF_DEFAULT_BACKGROUND_COLOR							= "ModelRef Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ModelRef Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELREF_DEFAULT_FOREGROUND_COLOR							= "ModelRef Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ModelRef Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELREF_DEFAULT_FONT										= "ModelRef Default Font (DF)";
	
	/**
	 * The key used to install a <i>Automaton Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_BACKGROUND_COLOR							= "Automaton Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Automaton Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_FOREGROUND_COLOR							= "Automaton Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Automaton Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_FONT										= "Automaton Default Font (DF)";
	
	/**
	 * The key used to install a <i>ModelInstance Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELINSTANCE_DEFAULT_BACKGROUND_COLOR						= "ModelInstance Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ModelInstance Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELINSTANCE_DEFAULT_FOREGROUND_COLOR						= "ModelInstance Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ModelInstance Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELINSTANCE_DEFAULT_FONT									= "ModelInstance Default Font (DF)";
	
	/**
	 * The key used to install a <i>EnumerationType Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONTYPE_DEFAULT_BACKGROUND_COLOR					= "EnumerationType Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>EnumerationType Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONTYPE_DEFAULT_FOREGROUND_COLOR					= "EnumerationType Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>EnumerationType Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONTYPE_DEFAULT_FONT								= "EnumerationType Default Font (DF)";
	
	/**
	 * The key used to install a <i>SubstitutionType Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBSTITUTIONTYPE_DEFAULT_BACKGROUND_COLOR					= "SubstitutionType Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>SubstitutionType Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBSTITUTIONTYPE_DEFAULT_FOREGROUND_COLOR					= "SubstitutionType Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>SubstitutionType Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBSTITUTIONTYPE_DEFAULT_FONT								= "SubstitutionType Default Font (DF)";
	
	/**
	 * The key used to install a <i>TupleType Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLETYPE_DEFAULT_BACKGROUND_COLOR							= "TupleType Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>TupleType Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLETYPE_DEFAULT_FOREGROUND_COLOR							= "TupleType Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>TupleType Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLETYPE_DEFAULT_FONT										= "TupleType Default Font (DF)";
	
	/**
	 * The key used to install a <i>ModelType Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELTYPE_DEFAULT_BACKGROUND_COLOR							= "ModelType Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ModelType Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELTYPE_DEFAULT_FOREGROUND_COLOR							= "ModelType Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ModelType Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELTYPE_DEFAULT_FONT										= "ModelType Default Font (DF)";
	
	/**
	 * The key used to install a <i>UseModule Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	USEMODULE_DEFAULT_BACKGROUND_COLOR							= "UseModule Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>UseModule Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	USEMODULE_DEFAULT_FOREGROUND_COLOR							= "UseModule Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>UseModule Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	USEMODULE_DEFAULT_FONT										= "UseModule Default Font (DF)";
	
	/**
	 * The key used to install a <i>InputPort Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTPORT_DEFAULT_BACKGROUND_COLOR							= "InputPort Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>InputPort Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTPORT_DEFAULT_FOREGROUND_COLOR							= "InputPort Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>InputPort Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTPORT_DEFAULT_FONT										= "InputPort Default Font (DF)";
	
	/**
	 * The key used to install a <i>Assertion Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTION_DEFAULT_BACKGROUND_COLOR							= "Assertion Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Assertion Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTION_DEFAULT_FOREGROUND_COLOR							= "Assertion Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Assertion Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ASSERTION_DEFAULT_FONT										= "Assertion Default Font (DF)";
	
	/**
	 * The key used to install a <i>CartesianProduct Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CARTESIANPRODUCT_DEFAULT_BACKGROUND_COLOR					= "CartesianProduct Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>CartesianProduct Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CARTESIANPRODUCT_DEFAULT_FOREGROUND_COLOR					= "CartesianProduct Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>CartesianProduct Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CARTESIANPRODUCT_DEFAULT_FONT								= "CartesianProduct Default Font (DF)";
	
	/**
	 * The key used to install a <i>Switch Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SWITCH_DEFAULT_BACKGROUND_COLOR								= "Switch Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Switch Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SWITCH_DEFAULT_FOREGROUND_COLOR								= "Switch Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Switch Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SWITCH_DEFAULT_FONT											= "Switch Default Font (DF)";
	
	/**
	 * The key used to install a <i>SignalRef Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SIGNALREF_DEFAULT_BACKGROUND_COLOR							= "SignalRef Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>SignalRef Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SIGNALREF_DEFAULT_FOREGROUND_COLOR							= "SignalRef Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>SignalRef Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SIGNALREF_DEFAULT_FONT										= "SignalRef Default Font (DF)";
	
	/**
	 * The key used to install a <i>Input Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_BACKGROUND_COLOR								= "Input Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Input Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_FOREGROUND_COLOR								= "Input Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Input Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_FONT											= "Input Default Font (DF)";
	
	/**
	 * The key used to install a <i>Output Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_BACKGROUND_COLOR								= "Output Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Output Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_FOREGROUND_COLOR								= "Output Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Output Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_FONT											= "Output Default Font (DF)";
	
	/**
	 * The key used to install a <i>Local Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_BACKGROUND_COLOR								= "Local Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Local Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_FOREGROUND_COLOR								= "Local Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Local Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_FONT											= "Local Default Font (DF)";
	
	/**
	 * The key used to install a <i>InputInstance Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTINSTANCE_DEFAULT_BACKGROUND_COLOR						= "InputInstance Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>InputInstance Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTINSTANCE_DEFAULT_FOREGROUND_COLOR						= "InputInstance Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>InputInstance Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUTINSTANCE_DEFAULT_FONT									= "InputInstance Default Font (DF)";
	
	/**
	 * The key used to install a <i>OutputInstance Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTINSTANCE_DEFAULT_BACKGROUND_COLOR						= "OutputInstance Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>OutputInstance Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTINSTANCE_DEFAULT_FOREGROUND_COLOR						= "OutputInstance Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>OutputInstance Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTINSTANCE_DEFAULT_FONT									= "OutputInstance Default Font (DF)";
	
	/**
	 * The key used to install a <i>Cell Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CELL_DEFAULT_BACKGROUND_COLOR								= "Cell Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Cell Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CELL_DEFAULT_FOREGROUND_COLOR								= "Cell Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Cell Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CELL_DEFAULT_FONT											= "Cell Default Font (DF)";
	
	/**
	 * The key used to install a <i>Counter Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COUNTER_DEFAULT_BACKGROUND_COLOR							= "Counter Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Counter Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COUNTER_DEFAULT_FOREGROUND_COLOR							= "Counter Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Counter Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COUNTER_DEFAULT_FONT										= "Counter Default Font (DF)";
	
	/**
	 * The key used to install a <i>Delay Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DELAY_DEFAULT_BACKGROUND_COLOR								= "Delay Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Delay Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DELAY_DEFAULT_FOREGROUND_COLOR								= "Delay Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Delay Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DELAY_DEFAULT_FONT											= "Delay Default Font (DF)";
	
	/**
	 * The key used to install a <i>Variable Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	VARIABLE_DEFAULT_BACKGROUND_COLOR							= "Variable Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Variable Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	VARIABLE_DEFAULT_FOREGROUND_COLOR							= "Variable Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Variable Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	VARIABLE_DEFAULT_FONT										= "Variable Default Font (DF)";
	
	/**
	 * The key used to install a <i>Window Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	WINDOW_DEFAULT_BACKGROUND_COLOR								= "Window Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Window Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	WINDOW_DEFAULT_FOREGROUND_COLOR								= "Window Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Window Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	WINDOW_DEFAULT_FONT											= "Window Default Font (DF)";
	
	/**
	 * The key used to install a <i>OutputPort Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTPORT_DEFAULT_BACKGROUND_COLOR							= "OutputPort Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>OutputPort Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTPORT_DEFAULT_FOREGROUND_COLOR							= "OutputPort Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>OutputPort Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUTPORT_DEFAULT_FONT										= "OutputPort Default Font (DF)";
	
	/**
	 * The key used to install a <i>ConstantRef Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTREF_DEFAULT_BACKGROUND_COLOR						= "ConstantRef Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ConstantRef Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTREF_DEFAULT_FOREGROUND_COLOR						= "ConstantRef Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ConstantRef Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTREF_DEFAULT_FONT									= "ConstantRef Default Font (DF)";
	
	/**
	 * The key used to install a <i>Parameter Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETER_DEFAULT_BACKGROUND_COLOR							= "Parameter Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Parameter Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETER_DEFAULT_FOREGROUND_COLOR							= "Parameter Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Parameter Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETER_DEFAULT_FONT										= "Parameter Default Font (DF)";
	
	/**
	 * The key used to install a <i>ConstantValue Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTVALUE_DEFAULT_BACKGROUND_COLOR						= "ConstantValue Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ConstantValue Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTVALUE_DEFAULT_FOREGROUND_COLOR						= "ConstantValue Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ConstantValue Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTVALUE_DEFAULT_FONT									= "ConstantValue Default Font (DF)";
	
	/**
	 * The key used to install a <i>Literal Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LITERAL_DEFAULT_BACKGROUND_COLOR							= "Literal Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Literal Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LITERAL_DEFAULT_FOREGROUND_COLOR							= "Literal Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Literal Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LITERAL_DEFAULT_FONT										= "Literal Default Font (DF)";
	
	/**
	 * The key used to install a <i>EnumerationValue Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONVALUE_DEFAULT_BACKGROUND_COLOR					= "EnumerationValue Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>EnumerationValue Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONVALUE_DEFAULT_FOREGROUND_COLOR					= "EnumerationValue Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>EnumerationValue Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONVALUE_DEFAULT_FONT								= "EnumerationValue Default Font (DF)";
	
	/**
	 * The key used to install a <i>ParameterInstance Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETERINSTANCE_DEFAULT_BACKGROUND_COLOR					= "ParameterInstance Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ParameterInstance Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETERINSTANCE_DEFAULT_FOREGROUND_COLOR					= "ParameterInstance Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ParameterInstance Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETERINSTANCE_DEFAULT_FONT								= "ParameterInstance Default Font (DF)";
	
	/**
	 * The key used to install a <i>Index Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INDEX_DEFAULT_BACKGROUND_COLOR								= "Index Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Index Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INDEX_DEFAULT_FOREGROUND_COLOR								= "Index Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Index Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INDEX_DEFAULT_FONT											= "Index Default Font (DF)";
	
	/**
	 * The key used to install a <i>Iterator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATOR_DEFAULT_BACKGROUND_COLOR							= "Iterator Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Iterator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATOR_DEFAULT_FOREGROUND_COLOR							= "Iterator Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Iterator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ITERATOR_DEFAULT_FONT										= "Iterator Default Font (DF)";
	
	/**
	 * The key used to install a <i>ArrayEnumeration Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYENUMERATION_DEFAULT_BACKGROUND_COLOR					= "ArrayEnumeration Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ArrayEnumeration Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYENUMERATION_DEFAULT_FOREGROUND_COLOR					= "ArrayEnumeration Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ArrayEnumeration Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYENUMERATION_DEFAULT_FONT								= "ArrayEnumeration Default Font (DF)";
	
	/**
	 * The key used to install a <i>ArrayRecovery Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYRECOVERY_DEFAULT_BACKGROUND_COLOR						= "ArrayRecovery Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ArrayRecovery Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYRECOVERY_DEFAULT_FOREGROUND_COLOR						= "ArrayRecovery Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ArrayRecovery Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYRECOVERY_DEFAULT_FONT									= "ArrayRecovery Default Font (DF)";
	
	/**
	 * The key used to install a <i>ArrayRestructuration Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYRESTRUCTURATION_DEFAULT_BACKGROUND_COLOR				= "ArrayRestructuration Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ArrayRestructuration Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYRESTRUCTURATION_DEFAULT_FOREGROUND_COLOR				= "ArrayRestructuration Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ArrayRestructuration Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYRESTRUCTURATION_DEFAULT_FONT							= "ArrayRestructuration Default Font (DF)";
	
	/**
	 * The key used to install a <i>Concatenation Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONCATENATION_DEFAULT_BACKGROUND_COLOR						= "Concatenation Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Concatenation Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONCATENATION_DEFAULT_FOREGROUND_COLOR						= "Concatenation Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Concatenation Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONCATENATION_DEFAULT_FONT									= "Concatenation Default Font (DF)";
	
	/**
	 * The key used to install a <i>Extraction Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	EXTRACTION_DEFAULT_BACKGROUND_COLOR							= "Extraction Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Extraction Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	EXTRACTION_DEFAULT_FOREGROUND_COLOR							= "Extraction Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Extraction Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	EXTRACTION_DEFAULT_FONT										= "Extraction Default Font (DF)";
	
	/**
	 * The key used to install a <i>IfThenElse Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	IFTHENELSE_DEFAULT_BACKGROUND_COLOR							= "IfThenElse Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>IfThenElse Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	IFTHENELSE_DEFAULT_FOREGROUND_COLOR							= "IfThenElse Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>IfThenElse Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	IFTHENELSE_DEFAULT_FONT										= "IfThenElse Default Font (DF)";
	
	/**
	 * The key used to install a <i>Merge Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MERGE_DEFAULT_BACKGROUND_COLOR								= "Merge Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Merge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MERGE_DEFAULT_FOREGROUND_COLOR								= "Merge Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Merge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MERGE_DEFAULT_FONT											= "Merge Default Font (DF)";
	
	/**
	 * The key used to install a <i>RepetitionOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	REPETITIONOPERATOR_DEFAULT_BACKGROUND_COLOR					= "RepetitionOperator Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>RepetitionOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	REPETITIONOPERATOR_DEFAULT_FOREGROUND_COLOR					= "RepetitionOperator Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>RepetitionOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	REPETITIONOPERATOR_DEFAULT_FONT								= "RepetitionOperator Default Font (DF)";
	
	/**
	 * The key used to install a <i>SequentialDefinition Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SEQUENTIALDEFINITION_DEFAULT_BACKGROUND_COLOR				= "SequentialDefinition Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>SequentialDefinition Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SEQUENTIALDEFINITION_DEFAULT_FOREGROUND_COLOR				= "SequentialDefinition Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>SequentialDefinition Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SEQUENTIALDEFINITION_DEFAULT_FONT							= "SequentialDefinition Default Font (DF)";
	
	/**
	 * The key used to install a <i>Transposition Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TRANSPOSITION_DEFAULT_BACKGROUND_COLOR						= "Transposition Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Transposition Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TRANSPOSITION_DEFAULT_FOREGROUND_COLOR						= "Transposition Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Transposition Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TRANSPOSITION_DEFAULT_FONT									= "Transposition Default Font (DF)";
	
	/**
	 * The key used to install a <i>TupleOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLEOPERATOR_DEFAULT_BACKGROUND_COLOR						= "TupleOperator Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>TupleOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLEOPERATOR_DEFAULT_FOREGROUND_COLOR						= "TupleOperator Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>TupleOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLEOPERATOR_DEFAULT_FONT									= "TupleOperator Default Font (DF)";
	
	/**
	 * The key used to install a <i>BooleanExpression Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BOOLEANEXPRESSION_DEFAULT_BACKGROUND_COLOR					= "BooleanExpression Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>BooleanExpression Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BOOLEANEXPRESSION_DEFAULT_FOREGROUND_COLOR					= "BooleanExpression Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>BooleanExpression Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	BOOLEANEXPRESSION_DEFAULT_FONT								= "BooleanExpression Default Font (DF)";
	
	/**
	 * The key used to install a <i>And Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AND_DEFAULT_BACKGROUND_COLOR								= "And Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>And Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AND_DEFAULT_FOREGROUND_COLOR								= "And Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>And Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AND_DEFAULT_FONT											= "And Default Font (DF)";
	
	/**
	 * The key used to install a <i>ComparisonOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COMPARISONOPERATOR_DEFAULT_BACKGROUND_COLOR					= "ComparisonOperator Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ComparisonOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COMPARISONOPERATOR_DEFAULT_FOREGROUND_COLOR					= "ComparisonOperator Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ComparisonOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COMPARISONOPERATOR_DEFAULT_FONT								= "ComparisonOperator Default Font (DF)";
	
	/**
	 * The key used to install a <i>Not Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NOT_DEFAULT_BACKGROUND_COLOR								= "Not Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Not Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NOT_DEFAULT_FOREGROUND_COLOR								= "Not Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Not Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NOT_DEFAULT_FONT											= "Not Default Font (DF)";
	
	/**
	 * The key used to install a <i>Or Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OR_DEFAULT_BACKGROUND_COLOR									= "Or Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Or Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OR_DEFAULT_FOREGROUND_COLOR									= "Or Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Or Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OR_DEFAULT_FONT												= "Or Default Font (DF)";
	
	/**
	 * The key used to install a <i>Xor Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	XOR_DEFAULT_BACKGROUND_COLOR								= "Xor Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>Xor Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	XOR_DEFAULT_FOREGROUND_COLOR								= "Xor Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Xor Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	XOR_DEFAULT_FONT											= "Xor Default Font (DF)";
	
	/**
	 * The key used to install a <i>ArithmeticOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARITHMETICOPERATOR_DEFAULT_BACKGROUND_COLOR					= "ArithmeticOperator Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ArithmeticOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARITHMETICOPERATOR_DEFAULT_FOREGROUND_COLOR					= "ArithmeticOperator Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ArithmeticOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARITHMETICOPERATOR_DEFAULT_FONT								= "ArithmeticOperator Default Font (DF)";
	
	/**
	 * The key used to install a <i>ArrayProduct Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYPRODUCT_DEFAULT_BACKGROUND_COLOR						= "ArrayProduct Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ArrayProduct Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYPRODUCT_DEFAULT_FOREGROUND_COLOR						= "ArrayProduct Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ArrayProduct Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ARRAYPRODUCT_DEFAULT_FONT									= "ArrayProduct Default Font (DF)";
	
	/**
	 * The key used to install a <i>ComplexOperator Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COMPLEXOPERATOR_DEFAULT_BACKGROUND_COLOR					= "ComplexOperator Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>ComplexOperator Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COMPLEXOPERATOR_DEFAULT_FOREGROUND_COLOR					= "ComplexOperator Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ComplexOperator Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	COMPLEXOPERATOR_DEFAULT_FONT								= "ComplexOperator Default Font (DF)";
	
	/**
	 * The key used to install a <i>NumericExpression Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NUMERICEXPRESSION_DEFAULT_BACKGROUND_COLOR					= "NumericExpression Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>NumericExpression Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NUMERICEXPRESSION_DEFAULT_FOREGROUND_COLOR					= "NumericExpression Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>NumericExpression Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	NUMERICEXPRESSION_DEFAULT_FONT								= "NumericExpression Default Font (DF)";
	
	/**
	 * The key used to install a <i>UnaryMinus Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	UNARYMINUS_DEFAULT_BACKGROUND_COLOR							= "UnaryMinus Default Background Color (DF)";
	
	/**
	 * The key used to install a <i>UnaryMinus Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	UNARYMINUS_DEFAULT_FOREGROUND_COLOR							= "UnaryMinus Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>UnaryMinus Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	UNARYMINUS_DEFAULT_FONT										= "UnaryMinus Default Font (DF)";
	
	/**
	 * The key used to install a <i>CaseConnection Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CASECONNECTION_EDGE_DEFAULT_FONT							= "CaseConnection Edge Default Font (DF)";
	
	/**
	 * The key used to install a <i>CaseConnection Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CASECONNECTION_EDGE_DEFAULT_FOREGROUND_COLOR				= "CaseConnection Edge Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>CaseConnection Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CASECONNECTION_EDGE_DEFAULT_ROUTER							= "CaseConnection Edge Default Router (DF)";
	
	/**
	 * The key used to install a <i>CaseConnection caseLabel Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CASECONNECTION_CASELABEL_EDGE_OBJECT_DEFAULT_VISIBILITY		= "CaseConnection caseLabel Edge Object Default Visibility (DF)";
	
	/**
	 * The key used to install a <i>Condition Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_EDGE_DEFAULT_FONT									= "Condition Edge Default Font (DF)";
	
	/**
	 * The key used to install a <i>Condition Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_EDGE_DEFAULT_FOREGROUND_COLOR						= "Condition Edge Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>Condition Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_EDGE_DEFAULT_ROUTER								= "Condition Edge Default Router (DF)";
	
	/**
	 * The key used to install a <i>Condition srcField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY			= "Condition srcField Edge Object Default Visibility (DF)";
	/**
	 * The key used to install a <i>Condition conditionKind Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONDITION_CONDITIONKIND_EDGE_OBJECT_DEFAULT_VISIBILITY		= "Condition conditionKind Edge Object Default Visibility (DF)";
	
	/**
	 * The key used to install a <i>ConstantAffectation Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTAFFECTATION_EDGE_DEFAULT_FONT						= "ConstantAffectation Edge Default Font (DF)";
	
	/**
	 * The key used to install a <i>ConstantAffectation Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTAFFECTATION_EDGE_DEFAULT_FOREGROUND_COLOR			= "ConstantAffectation Edge Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>ConstantAffectation Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTAFFECTATION_EDGE_DEFAULT_ROUTER						= "ConstantAffectation Edge Default Router (DF)";
	
	/**
	 * The key used to install a <i>ConstantAffectation srcField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTAFFECTATION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY	= "ConstantAffectation srcField Edge Object Default Visibility (DF)";
	
	/**
	 * The key used to install a <i>DataflowConnection Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DATAFLOWCONNECTION_EDGE_DEFAULT_FONT						= "DataflowConnection Edge Default Font (DF)";
	
	/**
	 * The key used to install a <i>DataflowConnection Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DATAFLOWCONNECTION_EDGE_DEFAULT_FOREGROUND_COLOR			= "DataflowConnection Edge Default Foreground Color (DF)";
	
	/**
	 * The key used to install a <i>DataflowConnection Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DATAFLOWCONNECTION_EDGE_DEFAULT_ROUTER						= "DataflowConnection Edge Default Router (DF)";
	
	/**
	 * The key used to install a <i>DataflowConnection srcField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DATAFLOWCONNECTION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY	= "DataflowConnection srcField Edge Object Default Visibility (DF)";
	/**
	 * The key used to install a <i>DataflowConnection dstField Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DATAFLOWCONNECTION_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY	= "DataflowConnection dstField Edge Object Default Visibility (DF)";
	/**
	 * The key used to install a <i>DataflowConnection castType Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	DATAFLOWCONNECTION_CASTTYPE_EDGE_OBJECT_DEFAULT_VISIBILITY	= "DataflowConnection castType Edge Object Default Visibility (DF)";
	
}
