/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.dataflow.preferences;

import java.util.HashMap;

import org.eclipse.jface.resource.StringConverter;
import org.topcased.modeler.preferences.ITopcasedPreferenceInitializer;

/*
 * Initialize the preferences of DF_ diagram
 * 
 * @generated
 */
public class DF_DiagramTopcasedPreferenceInitializer implements ITopcasedPreferenceInitializer {
	
	/**
	 * @see org.topcased.modeler.preferences.ITopcasedPreferenceInitializer#getDefaultPreference()
	 * @generated
	 */
	public HashMap<String, String> getDefaultPreference() {
		HashMap<String, String> defaultDF_Preference = new HashMap<String, String>();
		// Initialize the default value of the SUBPROCESS_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SUBPROCESS_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the SUBPROCESS_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SUBPROCESS_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SUBPROCESS_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SUBPROCESS_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the BASICITERATE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.BASICITERATE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the BASICITERATE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.BASICITERATE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the BASICITERATE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.BASICITERATE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ITERATE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ITERATE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ITERATE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ITERATE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ITERATE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ITERATE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the MODELDECLARATION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference
				.put(DF_DiagramPreferenceConstants.MODELDECLARATION_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the MODELDECLARATION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELDECLARATION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the MODELDECLARATION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELDECLARATION_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the MODELREF_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELREF_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the MODELREF_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELREF_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the MODELREF_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELREF_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the AUTOMATON_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.AUTOMATON_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the AUTOMATON_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.AUTOMATON_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the AUTOMATON_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.AUTOMATON_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the MODELINSTANCE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELINSTANCE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the MODELINSTANCE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELINSTANCE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the MODELINSTANCE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELINSTANCE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ENUMERATIONTYPE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ENUMERATIONTYPE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ENUMERATIONTYPE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ENUMERATIONTYPE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ENUMERATIONTYPE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ENUMERATIONTYPE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the SUBSTITUTIONTYPE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference
				.put(DF_DiagramPreferenceConstants.SUBSTITUTIONTYPE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the SUBSTITUTIONTYPE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SUBSTITUTIONTYPE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SUBSTITUTIONTYPE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SUBSTITUTIONTYPE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the TUPLETYPE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TUPLETYPE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the TUPLETYPE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TUPLETYPE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the TUPLETYPE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TUPLETYPE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the MODELTYPE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELTYPE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the MODELTYPE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELTYPE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the MODELTYPE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MODELTYPE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the USEMODULE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.USEMODULE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the USEMODULE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.USEMODULE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the USEMODULE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.USEMODULE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the INPUTPORT_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUTPORT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the INPUTPORT_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUTPORT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the INPUTPORT_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUTPORT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ASSERTION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ASSERTION_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ASSERTION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ASSERTION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ASSERTION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ASSERTION_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the CARTESIANPRODUCT_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference
				.put(DF_DiagramPreferenceConstants.CARTESIANPRODUCT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the CARTESIANPRODUCT_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CARTESIANPRODUCT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the CARTESIANPRODUCT_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CARTESIANPRODUCT_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the SWITCH_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SWITCH_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the SWITCH_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SWITCH_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SWITCH_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SWITCH_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the SIGNALREF_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SIGNALREF_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the SIGNALREF_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SIGNALREF_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SIGNALREF_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SIGNALREF_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the INPUT_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the INPUT_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the INPUT_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the OUTPUT_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the OUTPUT_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the OUTPUT_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the LOCAL_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.LOCAL_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the LOCAL_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.LOCAL_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the LOCAL_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.LOCAL_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the INPUTINSTANCE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUTINSTANCE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the INPUTINSTANCE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUTINSTANCE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the INPUTINSTANCE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INPUTINSTANCE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the OUTPUTINSTANCE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUTINSTANCE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the OUTPUTINSTANCE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUTINSTANCE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the OUTPUTINSTANCE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUTINSTANCE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the CELL_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CELL_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the CELL_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CELL_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the CELL_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CELL_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the COUNTER_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COUNTER_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the COUNTER_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COUNTER_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the COUNTER_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COUNTER_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the DELAY_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.DELAY_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the DELAY_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.DELAY_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the DELAY_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.DELAY_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the VARIABLE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.VARIABLE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the VARIABLE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.VARIABLE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the VARIABLE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.VARIABLE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the WINDOW_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.WINDOW_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the WINDOW_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.WINDOW_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the WINDOW_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.WINDOW_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the OUTPUTPORT_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUTPORT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the OUTPUTPORT_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUTPORT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the OUTPUTPORT_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OUTPUTPORT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the CONSTANTREF_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTREF_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the CONSTANTREF_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTREF_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the CONSTANTREF_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTREF_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the PARAMETER_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.PARAMETER_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the PARAMETER_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.PARAMETER_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the PARAMETER_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.PARAMETER_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the CONSTANTVALUE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTVALUE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the CONSTANTVALUE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTVALUE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the CONSTANTVALUE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTVALUE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the LITERAL_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.LITERAL_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the LITERAL_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.LITERAL_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the LITERAL_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.LITERAL_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ENUMERATIONVALUE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference
				.put(DF_DiagramPreferenceConstants.ENUMERATIONVALUE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ENUMERATIONVALUE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ENUMERATIONVALUE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ENUMERATIONVALUE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ENUMERATIONVALUE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the PARAMETERINSTANCE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.PARAMETERINSTANCE_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the PARAMETERINSTANCE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.PARAMETERINSTANCE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the PARAMETERINSTANCE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.PARAMETERINSTANCE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the INDEX_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INDEX_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the INDEX_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INDEX_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the INDEX_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.INDEX_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ITERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ITERATOR_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ITERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ITERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ITERATOR_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ITERATOR_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ARRAYENUMERATION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference
				.put(DF_DiagramPreferenceConstants.ARRAYENUMERATION_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ARRAYENUMERATION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYENUMERATION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ARRAYENUMERATION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYENUMERATION_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the ARRAYRECOVERY_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYRECOVERY_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ARRAYRECOVERY_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYRECOVERY_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ARRAYRECOVERY_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYRECOVERY_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ARRAYRESTRUCTURATION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYRESTRUCTURATION_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the ARRAYRESTRUCTURATION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYRESTRUCTURATION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ARRAYRESTRUCTURATION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYRESTRUCTURATION_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CONCATENATION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONCATENATION_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the CONCATENATION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONCATENATION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the CONCATENATION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONCATENATION_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the EXTRACTION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.EXTRACTION_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the EXTRACTION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.EXTRACTION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the EXTRACTION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.EXTRACTION_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the IFTHENELSE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.IFTHENELSE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the IFTHENELSE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.IFTHENELSE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the IFTHENELSE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.IFTHENELSE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the MERGE_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MERGE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the MERGE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MERGE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the MERGE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.MERGE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the REPETITIONOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.REPETITIONOPERATOR_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the REPETITIONOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.REPETITIONOPERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the REPETITIONOPERATOR_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.REPETITIONOPERATOR_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the SEQUENTIALDEFINITION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SEQUENTIALDEFINITION_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the SEQUENTIALDEFINITION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SEQUENTIALDEFINITION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SEQUENTIALDEFINITION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.SEQUENTIALDEFINITION_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the TRANSPOSITION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TRANSPOSITION_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the TRANSPOSITION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TRANSPOSITION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the TRANSPOSITION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TRANSPOSITION_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the TUPLEOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TUPLEOPERATOR_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the TUPLEOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TUPLEOPERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the TUPLEOPERATOR_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.TUPLEOPERATOR_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the BOOLEANEXPRESSION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.BOOLEANEXPRESSION_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the BOOLEANEXPRESSION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.BOOLEANEXPRESSION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the BOOLEANEXPRESSION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.BOOLEANEXPRESSION_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the AND_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.AND_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the AND_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.AND_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the AND_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.AND_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the COMPARISONOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COMPARISONOPERATOR_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the COMPARISONOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COMPARISONOPERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the COMPARISONOPERATOR_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COMPARISONOPERATOR_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the NOT_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.NOT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the NOT_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.NOT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the NOT_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.NOT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the OR_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OR_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the OR_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the OR_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.OR_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the XOR_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.XOR_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the XOR_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.XOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the XOR_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.XOR_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ARITHMETICOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARITHMETICOPERATOR_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the ARITHMETICOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARITHMETICOPERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ARITHMETICOPERATOR_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARITHMETICOPERATOR_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the ARRAYPRODUCT_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYPRODUCT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ARRAYPRODUCT_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYPRODUCT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ARRAYPRODUCT_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.ARRAYPRODUCT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the COMPLEXOPERATOR_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COMPLEXOPERATOR_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the COMPLEXOPERATOR_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COMPLEXOPERATOR_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the COMPLEXOPERATOR_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.COMPLEXOPERATOR_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the NUMERICEXPRESSION_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.NUMERICEXPRESSION_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the NUMERICEXPRESSION_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.NUMERICEXPRESSION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the NUMERICEXPRESSION_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.NUMERICEXPRESSION_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the UNARYMINUS_DEFAULT_BACKGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.UNARYMINUS_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the UNARYMINUS_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.UNARYMINUS_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the UNARYMINUS_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.UNARYMINUS_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the CASECONNECTION_EDGE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CASECONNECTION_EDGE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CASECONNECTION_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CASECONNECTION_EDGE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the CASECONNECTION_EDGE_DEFAULT_ROUTER property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CASECONNECTION_EDGE_DEFAULT_ROUTER, "RectilinearRouter");
		
		// Initialize the default value of the CASECONNECTION_CASELABEL_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CASECONNECTION_CASELABEL_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		
		// Initialize the default value of the CONDITION_EDGE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONDITION_EDGE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the CONDITION_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONDITION_EDGE_DEFAULT_FOREGROUND_COLOR, "0,128,0");
		
		// Initialize the default value of the CONDITION_EDGE_DEFAULT_ROUTER property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONDITION_EDGE_DEFAULT_ROUTER, "RectilinearRouter");
		
		// Initialize the default value of the CONDITION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONDITION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		// Initialize the default value of the CONDITION_CONDITIONKIND_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONDITION_CONDITIONKIND_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		
		// Initialize the default value of the CONSTANTAFFECTATION_EDGE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTAFFECTATION_EDGE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CONSTANTAFFECTATION_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTAFFECTATION_EDGE_DEFAULT_FOREGROUND_COLOR,
			"80,200,200");
		
		// Initialize the default value of the CONSTANTAFFECTATION_EDGE_DEFAULT_ROUTER property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.CONSTANTAFFECTATION_EDGE_DEFAULT_ROUTER,
			"RectilinearRouter");
		
		// Initialize the default value of the CONSTANTAFFECTATION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultDF_Preference.put(
			DF_DiagramPreferenceConstants.CONSTANTAFFECTATION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY, "true");
		
		// Initialize the default value of the DATAFLOWCONNECTION_EDGE_DEFAULT_FONT property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.DATAFLOWCONNECTION_EDGE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the DATAFLOWCONNECTION_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.DATAFLOWCONNECTION_EDGE_DEFAULT_FOREGROUND_COLOR,
			"0,0,0");
		
		// Initialize the default value of the DATAFLOWCONNECTION_EDGE_DEFAULT_ROUTER property
		defaultDF_Preference.put(DF_DiagramPreferenceConstants.DATAFLOWCONNECTION_EDGE_DEFAULT_ROUTER,
			"RectilinearRouter");
		
		// Initialize the default value of the DATAFLOWCONNECTION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultDF_Preference.put(
			DF_DiagramPreferenceConstants.DATAFLOWCONNECTION_SRCFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY, "true");
		// Initialize the default value of the DATAFLOWCONNECTION_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultDF_Preference.put(
			DF_DiagramPreferenceConstants.DATAFLOWCONNECTION_DSTFIELD_EDGE_OBJECT_DEFAULT_VISIBILITY, "true");
		// Initialize the default value of the DATAFLOWCONNECTION_CASTTYPE_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultDF_Preference.put(
			DF_DiagramPreferenceConstants.DATAFLOWCONNECTION_CASTTYPE_EDGE_OBJECT_DEFAULT_VISIBILITY, "true");
		
		return defaultDF_Preference;
	}
}
