/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.interface_.preferences;

/*
 * A set of constant that are used in the diagram graphical preferences
 * 
 * @generated
 */
public interface ID_DiagramPreferenceConstants {
	/**
	 * The key used to install a <i>Input Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_BACKGROUND_COLOR			= "Input Default Background Color (ID)";
	
	/**
	 * The key used to install a <i>Input Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_FOREGROUND_COLOR			= "Input Default Foreground Color (ID)";
	
	/**
	 * The key used to install a <i>Input Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	INPUT_DEFAULT_FONT						= "Input Default Font (ID)";
	
	/**
	 * The key used to install a <i>Output Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_BACKGROUND_COLOR			= "Output Default Background Color (ID)";
	
	/**
	 * The key used to install a <i>Output Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_FOREGROUND_COLOR			= "Output Default Foreground Color (ID)";
	
	/**
	 * The key used to install a <i>Output Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	OUTPUT_DEFAULT_FONT						= "Output Default Font (ID)";
	
	/**
	 * The key used to install a <i>Parameter Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETER_DEFAULT_BACKGROUND_COLOR		= "Parameter Default Background Color (ID)";
	
	/**
	 * The key used to install a <i>Parameter Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETER_DEFAULT_FOREGROUND_COLOR		= "Parameter Default Foreground Color (ID)";
	
	/**
	 * The key used to install a <i>Parameter Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PARAMETER_DEFAULT_FONT					= "Parameter Default Font (ID)";
	
	/**
	 * The key used to install a <i>Specifications Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SPECIFICATIONS_DEFAULT_BACKGROUND_COLOR	= "Specifications Default Background Color (ID)";
	
	/**
	 * The key used to install a <i>Specifications Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SPECIFICATIONS_DEFAULT_FOREGROUND_COLOR	= "Specifications Default Foreground Color (ID)";
	
	/**
	 * The key used to install a <i>Specifications Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SPECIFICATIONS_DEFAULT_FONT				= "Specifications Default Font (ID)";
	
	/**
	 * The key used to install a <i>Pragma Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PRAGMA_DEFAULT_BACKGROUND_COLOR			= "Pragma Default Background Color (ID)";
	
	/**
	 * The key used to install a <i>Pragma Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PRAGMA_DEFAULT_FOREGROUND_COLOR			= "Pragma Default Foreground Color (ID)";
	
	/**
	 * The key used to install a <i>Pragma Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PRAGMA_DEFAULT_FONT						= "Pragma Default Font (ID)";
	
}
