/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.interface_.preferences;

import java.util.HashMap;

import org.eclipse.jface.resource.StringConverter;
import org.topcased.modeler.preferences.ITopcasedPreferenceInitializer;

/*
 * Initialize the preferences of ID_ diagram
 * 
 * @generated
 */
public class ID_DiagramTopcasedPreferenceInitializer implements ITopcasedPreferenceInitializer {
	
	/**
	 * @see org.topcased.modeler.preferences.ITopcasedPreferenceInitializer#getDefaultPreference()
	 * @generated
	 */
	public HashMap<String, String> getDefaultPreference() {
		HashMap<String, String> defaultID_Preference = new HashMap<String, String>();
		// Initialize the default value of the INPUT_DEFAULT_BACKGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.INPUT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the INPUT_DEFAULT_FOREGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.INPUT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the INPUT_DEFAULT_FONT property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.INPUT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the OUTPUT_DEFAULT_BACKGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.OUTPUT_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the OUTPUT_DEFAULT_FOREGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.OUTPUT_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the OUTPUT_DEFAULT_FONT property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.OUTPUT_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the PARAMETER_DEFAULT_BACKGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.PARAMETER_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the PARAMETER_DEFAULT_FOREGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.PARAMETER_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the PARAMETER_DEFAULT_FONT property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.PARAMETER_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the SPECIFICATIONS_DEFAULT_BACKGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.SPECIFICATIONS_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the SPECIFICATIONS_DEFAULT_FOREGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.SPECIFICATIONS_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SPECIFICATIONS_DEFAULT_FONT property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.SPECIFICATIONS_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the PRAGMA_DEFAULT_BACKGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.PRAGMA_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the PRAGMA_DEFAULT_FOREGROUND_COLOR property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.PRAGMA_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the PRAGMA_DEFAULT_FONT property
		defaultID_Preference.put(ID_DiagramPreferenceConstants.PRAGMA_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		return defaultID_Preference;
	}
}
