/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.library.preferences;

/*
 * A set of constant that are used in the diagram graphical preferences
 * 
 * @generated
 */
public interface LIB_DiagramPreferenceConstants {
	/**
	 * The key used to install a <i>ModelDeclaration Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELDECLARATION_DEFAULT_BACKGROUND_COLOR	= "ModelDeclaration Default Background Color (LIB)";
	
	/**
	 * The key used to install a <i>ModelDeclaration Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELDECLARATION_DEFAULT_FOREGROUND_COLOR	= "ModelDeclaration Default Foreground Color (LIB)";
	
	/**
	 * The key used to install a <i>ModelDeclaration Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELDECLARATION_DEFAULT_FONT				= "ModelDeclaration Default Font (LIB)";
	
	/**
	 * The key used to install a <i>ConstantValue Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTVALUE_DEFAULT_BACKGROUND_COLOR		= "ConstantValue Default Background Color (LIB)";
	
	/**
	 * The key used to install a <i>ConstantValue Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTVALUE_DEFAULT_FOREGROUND_COLOR		= "ConstantValue Default Foreground Color (LIB)";
	
	/**
	 * The key used to install a <i>ConstantValue Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	CONSTANTVALUE_DEFAULT_FONT					= "ConstantValue Default Font (LIB)";
	
	/**
	 * The key used to install a <i>EnumerationType Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONTYPE_DEFAULT_BACKGROUND_COLOR	= "EnumerationType Default Background Color (LIB)";
	
	/**
	 * The key used to install a <i>EnumerationType Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONTYPE_DEFAULT_FOREGROUND_COLOR	= "EnumerationType Default Foreground Color (LIB)";
	
	/**
	 * The key used to install a <i>EnumerationType Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ENUMERATIONTYPE_DEFAULT_FONT				= "EnumerationType Default Font (LIB)";
	
	/**
	 * The key used to install a <i>ModelType Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELTYPE_DEFAULT_BACKGROUND_COLOR			= "ModelType Default Background Color (LIB)";
	
	/**
	 * The key used to install a <i>ModelType Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELTYPE_DEFAULT_FOREGROUND_COLOR			= "ModelType Default Foreground Color (LIB)";
	
	/**
	 * The key used to install a <i>ModelType Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	MODELTYPE_DEFAULT_FONT						= "ModelType Default Font (LIB)";
	
	/**
	 * The key used to install a <i>SubstitutionType Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBSTITUTIONTYPE_DEFAULT_BACKGROUND_COLOR	= "SubstitutionType Default Background Color (LIB)";
	
	/**
	 * The key used to install a <i>SubstitutionType Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBSTITUTIONTYPE_DEFAULT_FOREGROUND_COLOR	= "SubstitutionType Default Foreground Color (LIB)";
	
	/**
	 * The key used to install a <i>SubstitutionType Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	SUBSTITUTIONTYPE_DEFAULT_FONT				= "SubstitutionType Default Font (LIB)";
	
	/**
	 * The key used to install a <i>TupleType Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLETYPE_DEFAULT_BACKGROUND_COLOR			= "TupleType Default Background Color (LIB)";
	
	/**
	 * The key used to install a <i>TupleType Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLETYPE_DEFAULT_FOREGROUND_COLOR			= "TupleType Default Foreground Color (LIB)";
	
	/**
	 * The key used to install a <i>TupleType Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	TUPLETYPE_DEFAULT_FONT						= "TupleType Default Font (LIB)";
	
	/**
	 * The key used to install a <i>Pragma Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PRAGMA_DEFAULT_BACKGROUND_COLOR				= "Pragma Default Background Color (LIB)";
	
	/**
	 * The key used to install a <i>Pragma Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PRAGMA_DEFAULT_FOREGROUND_COLOR				= "Pragma Default Foreground Color (LIB)";
	
	/**
	 * The key used to install a <i>Pragma Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	PRAGMA_DEFAULT_FONT							= "Pragma Default Font (LIB)";
	
	/**
	 * The key used to install a <i>UseModule Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	USEMODULE_DEFAULT_BACKGROUND_COLOR			= "UseModule Default Background Color (LIB)";
	
	/**
	 * The key used to install a <i>UseModule Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	USEMODULE_DEFAULT_FOREGROUND_COLOR			= "UseModule Default Foreground Color (LIB)";
	
	/**
	 * The key used to install a <i>UseModule Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	USEMODULE_DEFAULT_FONT						= "UseModule Default Font (LIB)";
	
}
