/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.library.preferences;

import java.util.HashMap;

import org.eclipse.jface.resource.StringConverter;
import org.topcased.modeler.preferences.ITopcasedPreferenceInitializer;

/*
 * Initialize the preferences of LIB_ diagram
 * 
 * @generated
 */
public class LIB_DiagramTopcasedPreferenceInitializer implements ITopcasedPreferenceInitializer {
	
	/**
	 * @see org.topcased.modeler.preferences.ITopcasedPreferenceInitializer#getDefaultPreference()
	 * @generated
	 */
	public HashMap<String, String> getDefaultPreference() {
		HashMap<String, String> defaultLIB_Preference = new HashMap<String, String>();
		// Initialize the default value of the MODELDECLARATION_DEFAULT_BACKGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.MODELDECLARATION_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the MODELDECLARATION_DEFAULT_FOREGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.MODELDECLARATION_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the MODELDECLARATION_DEFAULT_FONT property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.MODELDECLARATION_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the CONSTANTVALUE_DEFAULT_BACKGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.CONSTANTVALUE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the CONSTANTVALUE_DEFAULT_FOREGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.CONSTANTVALUE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the CONSTANTVALUE_DEFAULT_FONT property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.CONSTANTVALUE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the ENUMERATIONTYPE_DEFAULT_BACKGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.ENUMERATIONTYPE_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the ENUMERATIONTYPE_DEFAULT_FOREGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.ENUMERATIONTYPE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ENUMERATIONTYPE_DEFAULT_FONT property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.ENUMERATIONTYPE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the MODELTYPE_DEFAULT_BACKGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.MODELTYPE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the MODELTYPE_DEFAULT_FOREGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.MODELTYPE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the MODELTYPE_DEFAULT_FONT property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.MODELTYPE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the SUBSTITUTIONTYPE_DEFAULT_BACKGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.SUBSTITUTIONTYPE_DEFAULT_BACKGROUND_COLOR,
			"255,255,255");
		
		// Initialize the default value of the SUBSTITUTIONTYPE_DEFAULT_FOREGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.SUBSTITUTIONTYPE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the SUBSTITUTIONTYPE_DEFAULT_FONT property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.SUBSTITUTIONTYPE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the TUPLETYPE_DEFAULT_BACKGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.TUPLETYPE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the TUPLETYPE_DEFAULT_FOREGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.TUPLETYPE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the TUPLETYPE_DEFAULT_FONT property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.TUPLETYPE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the PRAGMA_DEFAULT_BACKGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.PRAGMA_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the PRAGMA_DEFAULT_FOREGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.PRAGMA_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the PRAGMA_DEFAULT_FONT property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.PRAGMA_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the USEMODULE_DEFAULT_BACKGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.USEMODULE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the USEMODULE_DEFAULT_FOREGROUND_COLOR property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.USEMODULE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the USEMODULE_DEFAULT_FONT property
		defaultLIB_Preference.put(LIB_DiagramPreferenceConstants.USEMODULE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		return defaultLIB_Preference;
	}
}
