/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.modeautomaton;

/*
 * A collection of Roles. Each identifier is used to key the EditPolicy.
 * 
 * @generated
 */
public interface MA_EditPolicyConstants {
	
	/**
	 * The key used to install an <i>Local</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	LOCAL_EDITPOLICY			= "Local EditPolicy";
	
	/**
	 * The key used to install an <i>History</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	HISTORY_EDITPOLICY			= "History EditPolicy";
	
	/**
	 * The key used to install an <i>StateBase</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	STATEBASE_EDITPOLICY		= "StateBase EditPolicy";
	
	/**
	 * The key used to install an <i>Automaton</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	AUTOMATON_EDITPOLICY		= "Automaton EditPolicy";
	
	/**
	 * The key used to install an <i>AndState</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	ANDSTATE_EDITPOLICY			= "AndState EditPolicy";
	
	/**
	 * The key used to install an <i>State</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	STATE_EDITPOLICY			= "State EditPolicy";
	
	/**
	 * The key used to install an <i>WeakTransition</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	WEAKTRANSITION_EDITPOLICY	= "WeakTransition EditPolicy";
	
	/**
	 * The key used to install an <i>StrongTransition</i> EditPolicy.
	 * 
	 * @generated
	 */
	String	STRONGTRANSITION_EDITPOLICY	= "StrongTransition EditPolicy";
	
	/**
	 * The key used to install an <i>Initial State</i> EditPolicy.
	 * 
	 * @generated NOT
	 */
	String	INITIAL_STATE_EDITPOLICY	= "Initial State EditPolicy";
	
	/**
	 * The key used to install an <i>Transition</i> EditPolicy.
	 * 
	 * @generated NOT
	 */
	String	TRANSITION_EDITPOLICY		= "Transition EditPolicy";
	
}
