/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.modeautomaton.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPolicy;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.edit.DiagramEditPart;

import fr.irisa.espresso.sme.Automaton;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.common.figures.SmeDiagramFigure;
import fr.irisa.espresso.sme.common.policies.DiagramLayoutEditPolicy;

/*
 * @generated
 */
public class MA_DiagramEditPart extends DiagramEditPart {
	
	/**
	 * The Constructor
	 * 
	 * @param model
	 *        the root model element
	 * @generated
	 */
	public MA_DiagramEditPart(Diagram model) {
		super(model);
	}
	
	/**
	 * @see org.topcased.modeler.edit.DiagramEditPart#getLayoutEditPolicy()
	 * @generated NOT
	 */
	protected EditPolicy getLayoutEditPolicy() {
		return new DiagramLayoutEditPolicy();
	}
	
	/**
	 * @see org.topcased.modeler.edit.DiagramEditPart#createBodyFigure()
	 * @generated NOT
	 */
	protected IFigure createBodyFigure() {
		return new SmeDiagramFigure();
	}
	/**
	 * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#handleModelChanged(org.eclipse.emf.common.notify.Notification)
	 * @generated NOT
	 */
	protected void handleModelChanged(Notification msg) {
		Object obj = msg.getNotifier();
		if (obj.equals(this.getEObject())) {
			switch (msg.getFeatureID(Automaton.class)) {
				case SmePackage.AUTOMATON__INIT_STATE:
					for (Object part : getChildren()) {
						if (part instanceof StateBaseEditPart)
							((StateBaseEditPart) part).refresh();
					}
					break;
			}
		}
		super.handleModelChanged(msg);
	}
}
