/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.modeautomaton.figures;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.topcased.draw2d.figures.IContainerFigure;

import fr.irisa.espresso.sme.common.figures.StateFigure;

/*
 * @generated NOT
 */
public class AutomatonFigure extends StateFigure implements IContainerFigure {
	/** The pane in which the history will be put */
	private Figure	historyPane;
	
	/**
	 * Constructor
	 * 
	 * @generated NOT
	 */
	public AutomatonFigure() {
		super("AUTOMATON_LARGE");
		// We add the pane for the history element on the right of the label
		historyPane = new Figure();
		historyPane.setLayoutManager(new XYLayout());
		historyPane.setPreferredSize(new Dimension(30, 30));
		add(historyPane, BorderLayout.RIGHT);
	}
	
	/**
	 * @see org.topcased.draw2d.figures.IContainerFigure#getContentPane()
	 * @generated NOT
	 */
	public IFigure getContentPane() {
		return historyPane;
	}
}
