/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.modeautomaton.figures;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.Locator;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.eclipse.swt.SWT;
import org.topcased.modeler.edit.locators.EdgeObjectOffsetLocator;
import org.topcased.modeler.figures.EdgeObjectEditableLabel;
import org.topcased.modeler.figures.EdgeObjectOffsetEditableLabel;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.figures.IEdgeObjectOffsetFigure;
import org.topcased.modeler.figures.IGraphEdgeFigure;

/*
 * @generated
 */
public class WeakTransitionFigure extends PolylineConnectionEx implements IGraphEdgeFigure, HandleBounds {
	
	/**
	 * @generated
	 */
	private IEdgeObjectFigure	priorityEdgeObject;
	
	/**
	 * @generated
	 */
	private Locator				priorityLocator;
	/**
	 * @generated
	 */
	private IEdgeObjectFigure	guardEdgeObject;
	
	/**
	 * @generated
	 */
	private Locator				guardLocator;
	
	/**
	 * The constructor
	 * 
	 * @generated
	 */
	public WeakTransitionFigure() {
		super();
		
		priorityEdgeObject = new EdgeObjectEditableLabel(this);
		priorityLocator = new ConnectionEndpointLocator(this, false);
		add(priorityEdgeObject, priorityLocator);
		
		guardEdgeObject = new EdgeObjectOffsetEditableLabel(this);
		guardLocator = new EdgeObjectOffsetLocator((IEdgeObjectOffsetFigure) guardEdgeObject);
		add(guardEdgeObject, guardLocator);
		setLineStyle(SWT.LINE_SOLID);
	}
	
	/**
	 * @return the object figure
	 * @generated
	 */
	public IEdgeObjectFigure getPriorityEdgeObjectFigure() {
		return priorityEdgeObject;
	}
	/**
	 * @return the object figure
	 * @generated
	 */
	public IEdgeObjectFigure getGuardEdgeObjectFigure() {
		return guardEdgeObject;
	}
	
	/**
	 * @see org.topcased.modeler.figures.IGraphEdgeFigure#getLocator(org.topcased.modeler.figures.IEdgeObjectFigure)
	 * @generated
	 */
	public Locator getLocator(IEdgeObjectFigure edgeObjectfigure) {
		if (edgeObjectfigure == priorityEdgeObject) {
			return priorityLocator;
		}
		if (edgeObjectfigure == guardEdgeObject) {
			return guardLocator;
		}
		
		return null;
	}
	
	/**
	 * @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
	 * @generated
	 */
	public Rectangle getHandleBounds() {
		return getPoints().getBounds();
	}
}
