/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.modeautomaton.preferences;

/*
 * A set of constant that are used in the diagram graphical preferences
 * 
 * @generated
 */
public interface MA_DiagramPreferenceConstants {
	/**
	 * The key used to install a <i>Local Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_BACKGROUND_COLOR								= "Local Default Background Color (MA)";
	
	/**
	 * The key used to install a <i>Local Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_FOREGROUND_COLOR								= "Local Default Foreground Color (MA)";
	
	/**
	 * The key used to install a <i>Local Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	LOCAL_DEFAULT_FONT											= "Local Default Font (MA)";
	
	/**
	 * The key used to install a <i>History Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	HISTORY_DEFAULT_BACKGROUND_COLOR							= "History Default Background Color (MA)";
	
	/**
	 * The key used to install a <i>History Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	HISTORY_DEFAULT_FOREGROUND_COLOR							= "History Default Foreground Color (MA)";
	
	/**
	 * The key used to install a <i>History Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	HISTORY_DEFAULT_FONT										= "History Default Font (MA)";
	
	/**
	 * The key used to install a <i>Automaton Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_BACKGROUND_COLOR							= "Automaton Default Background Color (MA)";
	
	/**
	 * The key used to install a <i>Automaton Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_FOREGROUND_COLOR							= "Automaton Default Foreground Color (MA)";
	
	/**
	 * The key used to install a <i>Automaton Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	AUTOMATON_DEFAULT_FONT										= "Automaton Default Font (MA)";
	
	/**
	 * The key used to install a <i>AndState Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ANDSTATE_DEFAULT_BACKGROUND_COLOR							= "AndState Default Background Color (MA)";
	
	/**
	 * The key used to install a <i>AndState Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ANDSTATE_DEFAULT_FOREGROUND_COLOR							= "AndState Default Foreground Color (MA)";
	
	/**
	 * The key used to install a <i>AndState Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	ANDSTATE_DEFAULT_FONT										= "AndState Default Font (MA)";
	
	/**
	 * The key used to install a <i>State Default Background Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	STATE_DEFAULT_BACKGROUND_COLOR								= "State Default Background Color (MA)";
	
	/**
	 * The key used to install a <i>State Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	STATE_DEFAULT_FOREGROUND_COLOR								= "State Default Foreground Color (MA)";
	
	/**
	 * The key used to install a <i>State Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	STATE_DEFAULT_FONT											= "State Default Font (MA)";
	
	/**
	 * The key used to install a <i>WeakTransition Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	WEAKTRANSITION_EDGE_DEFAULT_FONT							= "WeakTransition Edge Default Font (MA)";
	
	/**
	 * The key used to install a <i>WeakTransition Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	WEAKTRANSITION_EDGE_DEFAULT_FOREGROUND_COLOR				= "WeakTransition Edge Default Foreground Color (MA)";
	
	/**
	 * The key used to install a <i>WeakTransition Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	WEAKTRANSITION_EDGE_DEFAULT_ROUTER							= "WeakTransition Edge Default Router (MA)";
	
	/**
	 * The key used to install a <i>WeakTransition priority Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	WEAKTRANSITION_PRIORITY_EDGE_OBJECT_DEFAULT_VISIBILITY		= "WeakTransition priority Edge Object Default Visibility (MA)";
	/**
	 * The key used to install a <i>WeakTransition guard Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	WEAKTRANSITION_GUARD_EDGE_OBJECT_DEFAULT_VISIBILITY			= "WeakTransition guard Edge Object Default Visibility (MA)";
	
	/**
	 * The key used to install a <i>StrongTransition Edge Default Font</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	STRONGTRANSITION_EDGE_DEFAULT_FONT							= "StrongTransition Edge Default Font (MA)";
	
	/**
	 * The key used to install a <i>StrongTransition Edge Default Foreground Color</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	STRONGTRANSITION_EDGE_DEFAULT_FOREGROUND_COLOR				= "StrongTransition Edge Default Foreground Color (MA)";
	
	/**
	 * The key used to install a <i>StrongTransition Edge Default Router</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	STRONGTRANSITION_EDGE_DEFAULT_ROUTER						= "StrongTransition Edge Default Router (MA)";
	
	/**
	 * The key used to install a <i>StrongTransition priority Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	STRONGTRANSITION_PRIORITY_EDGE_OBJECT_DEFAULT_VISIBILITY	= "StrongTransition priority Edge Object Default Visibility (MA)";
	/**
	 * The key used to install a <i>StrongTransition guard Edge Object Default Visibility</i> Preference.
	 * 
	 * @generated NOT
	 */
	String	STRONGTRANSITION_GUARD_EDGE_OBJECT_DEFAULT_VISIBILITY		= "StrongTransition guard Edge Object Default Visibility (MA)";
	
}
