/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.modeautomaton.preferences;

import java.util.HashMap;

import org.eclipse.jface.resource.StringConverter;
import org.topcased.modeler.preferences.ITopcasedPreferenceInitializer;

/*
 * Initialize the preferences of MA_ diagram
 * 
 * @generated
 */
public class MA_DiagramTopcasedPreferenceInitializer implements ITopcasedPreferenceInitializer {
	
	/**
	 * @see org.topcased.modeler.preferences.ITopcasedPreferenceInitializer#getDefaultPreference()
	 * @generated
	 */
	public HashMap<String, String> getDefaultPreference() {
		HashMap<String, String> defaultMA_Preference = new HashMap<String, String>();
		// Initialize the default value of the LOCAL_DEFAULT_BACKGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.LOCAL_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the LOCAL_DEFAULT_FOREGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.LOCAL_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the LOCAL_DEFAULT_FONT property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.LOCAL_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the HISTORY_DEFAULT_BACKGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.HISTORY_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the HISTORY_DEFAULT_FOREGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.HISTORY_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the HISTORY_DEFAULT_FONT property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.HISTORY_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the AUTOMATON_DEFAULT_BACKGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.AUTOMATON_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the AUTOMATON_DEFAULT_FOREGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.AUTOMATON_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the AUTOMATON_DEFAULT_FONT property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.AUTOMATON_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the ANDSTATE_DEFAULT_BACKGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.ANDSTATE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the ANDSTATE_DEFAULT_FOREGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.ANDSTATE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the ANDSTATE_DEFAULT_FONT property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.ANDSTATE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the STATE_DEFAULT_BACKGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.STATE_DEFAULT_BACKGROUND_COLOR, "255,255,255");
		
		// Initialize the default value of the STATE_DEFAULT_FOREGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.STATE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the STATE_DEFAULT_FONT property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.STATE_DEFAULT_FONT, StringConverter.asFontData(
			"Tahoma-regular-8").toString());
		
		// Initialize the default value of the WEAKTRANSITION_EDGE_DEFAULT_FONT property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.WEAKTRANSITION_EDGE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the WEAKTRANSITION_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.WEAKTRANSITION_EDGE_DEFAULT_FOREGROUND_COLOR, "0,0,0");
		
		// Initialize the default value of the WEAKTRANSITION_EDGE_DEFAULT_ROUTER property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.WEAKTRANSITION_EDGE_DEFAULT_ROUTER, "ObliqueRouter");
		
		// Initialize the default value of the WEAKTRANSITION_PRIORITY_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.WEAKTRANSITION_PRIORITY_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		// Initialize the default value of the WEAKTRANSITION_GUARD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.WEAKTRANSITION_GUARD_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		
		// Initialize the default value of the STRONGTRANSITION_EDGE_DEFAULT_FONT property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.STRONGTRANSITION_EDGE_DEFAULT_FONT, StringConverter
				.asFontData("Tahoma-regular-8").toString());
		
		// Initialize the default value of the STRONGTRANSITION_EDGE_DEFAULT_FOREGROUND_COLOR property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.STRONGTRANSITION_EDGE_DEFAULT_FOREGROUND_COLOR,
			"255,0,0");
		
		// Initialize the default value of the STRONGTRANSITION_EDGE_DEFAULT_ROUTER property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.STRONGTRANSITION_EDGE_DEFAULT_ROUTER, "ObliqueRouter");
		
		// Initialize the default value of the STRONGTRANSITION_PRIORITY_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultMA_Preference.put(
			MA_DiagramPreferenceConstants.STRONGTRANSITION_PRIORITY_EDGE_OBJECT_DEFAULT_VISIBILITY, "true");
		// Initialize the default value of the STRONGTRANSITION_GUARD_EDGE_OBJECT_DEFAULT_VISIBILITY property
		defaultMA_Preference.put(MA_DiagramPreferenceConstants.STRONGTRANSITION_GUARD_EDGE_OBJECT_DEFAULT_VISIBILITY,
			"true");
		
		return defaultMA_Preference;
	}
}
