/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.diagram.tupletype.policies;

import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy;
import org.topcased.modeler.utils.Utils;

import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.Local;
import fr.irisa.espresso.sme.Specifications;
import fr.irisa.espresso.sme.TupleType;
import fr.irisa.espresso.sme.TypeKind;
import fr.irisa.espresso.sme.common.SmeRequestConstants;
import fr.irisa.espresso.sme.common.commands.EditCommentCommand;

/*
 * @generated
 */
public class TT_DiagramLayoutEditPolicy extends ModelerLayoutEditPolicy {
	/**
	 * Default contructor.
	 * 
	 * @generated
	 */
	public TT_DiagramLayoutEditPolicy() {
		super();
	}
	
	/**
	 * @see org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy#isValid(org.eclipse.emf.ecore.EObject,
	 *      org.eclipse.emf.ecore.EObject)
	 * @generated NOT
	 */
	protected boolean isValid(EObject child, EObject parent) {
		return super.isValid(child, parent)
				&& ((((TupleType) parent).getKind().equals(TypeKind.BUNDLE_LITERAL) && ((child instanceof Local) || (child instanceof Specifications))) || (((TupleType) parent)
						.getKind().equals(TypeKind.STRUCT_LITERAL) && (child instanceof Local)));
	}
	
	/**
	 * @see org.eclipse.gef.editpolicies.AbstractEditPolicy#getCommand(org.eclipse.gef.Request)
	 * @generated NOT
	 */
	public Command getCommand(Request request) {
		if (SmeRequestConstants.REQ_EDIT_COMMENT.equals(request.getType())) {
			EObject obj = Utils.getElement((GraphElement) getHost().getModel());
			if (obj instanceof Identifier) {
				Map<String, String> params = request.getExtendedData();
				EditCommentCommand command = new EditCommentCommand((Identifier) obj, params);
				return command;
			}
			return null;
		}
		return super.getCommand(request);
	}
	
	/**
	 * @see org.eclipse.gef.editpolicies.AbstractEditPolicy#understandsRequest(org.eclipse.gef.Request)
	 * @generated NOT
	 */
	public boolean understandsRequest(Request req) {
		if (SmeRequestConstants.REQ_EDIT_COMMENT.equals(req.getType()))
			return (Utils.getElement((GraphElement) getHost().getModel()) instanceof Identifier);
		return super.understandsRequest(req);
	}
}
