/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.common;

/**
 * Identifies new Action constants
 * 
 * Creation : 25 mars 2006
 */
public interface SmeActionConstants {
	/**
	 * Add a new Port to MultipleInputsOperator
	 */
	String	ADD_NEW_PORT				= "AddNewPort";
	/**
	 * Go to the Interface Aspect
	 */
	String	GO_TO_INTERFACE_ASPECT		= "GoToInterfaceAspect";
	/**
	 * Go to the Dataflow Aspect
	 */
	String	GO_TO_DATAFLOW_ASPECT		= "GoToDataflowAspect";
	/**
	 * Go to the ClockRelation & Dependence Aspect
	 */
	String	GO_TO_CLOCKRELATION_ASPECT	= "GoToClockRelationAspect";
	/**
	 * Edit the comment of an identifier
	 */
	String	EDIT_COMMENT				= "EditComment";
	/**
	 * Edit the comment of a BooleanExpression or a NumericExpression
	 */
	String	EDIT_EXPRESSION				= "EditExpression";
	/**
	 * Edit the guard of a mode automaton transition
	 */
	String	EDIT_GUARD					= "EditGuard";
	/**
	 * Show the IterationInit behavior of the Iterate Block.
	 */
	String	SHOW_ITERATION_INIT			= "ShowIterationInit";
	/**
	 * Reload the interface of a ModelInstance
	 */
	String	RELOAD_MODELINSTANCE		= "ReloadModelInstance";
	/**
	 * Set the InitState of an Automaton
	 */
	String	SET_INIT_STATE				= "SetInitState";
}
