/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.common;

/**
 * created 13 september 2006
 * 
 */
public interface SmeRequestConstants {
	/** Indicates that an go to Interface Aspect request should be performed. */
	String	REQ_GO_TO_INTERFACE_ASPECT		= "interfaceAspect";
	
	/** Indicates that an go to Dataflow Aspect request should be performed. */
	String	REQ_GO_TO_DATAFLOW_ASPECT		= "dataflowAspect";
	
	/** Indicates that an go to ClockRelation&Dependence Aspect request should be performed. */
	String	REQ_GO_TO_CLOCKRELATION_ASPECT	= "clockRelationAspect";
	
	/** Indicates that an add new port request should be performed. */
	String	REQ_ADD_NEW_PORT				= "addNewPort";
	
	/** Indicates that an edit comment request should be performed. */
	String	REQ_EDIT_COMMENT				= "editComment";
	
	/** Indicates that an edit expression request should be performed. */
	String	REQ_EDIT_EXPRESSION				= "editExpression";
	
	/** Indicates that an edit guard request should be performed. */
	String	REQ_EDIT_GUARD					= "editGuard";
	
	/** Indicates that the IterationInit Show request should be performed. */
	String	REQ_SHOW_ITERATION_INIT			= "showIterationInit";
	
	/** Indicates that the Reload ModelInstance request should be performed. */
	String	REQ_RELOAD_MODELINSTANCE		= "reloadModelInstance";
	
	/** Indicates that the "Set InitState" request should be performed. */
	String	REQ_SET_INIT_STATE				= "setInitState";
}
