/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.common.figures;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.Locator;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.topcased.modeler.edit.locators.EdgeObjectOffsetLocator;
import org.topcased.modeler.figures.EdgeObjectEditableLabel;
import org.topcased.modeler.figures.EdgeObjectOffsetEditableLabel;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.figures.IEdgeObjectOffsetFigure;
import org.topcased.modeler.figures.IGraphEdgeFigure;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ConditionFigure extends PolylineConnectionEx implements IGraphEdgeFigure, HandleBounds {
	
	/**
	 * @generated
	 */
	private IEdgeObjectFigure	srcFieldEdgeObject;
	
	/**
	 * @generated
	 */
	private Locator				srcFieldLocator;
	
	/**
	 * @generated
	 */
	private IEdgeObjectFigure	conditionKindEdgeObject;
	
	/**
	 * @generated
	 */
	private Locator				conditionKindLocator;
	
	/**
	 * The constructor <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ConditionFigure() {
		super();
		
		srcFieldEdgeObject = new EdgeObjectEditableLabel(this);
		srcFieldLocator = new ConnectionEndpointLocator(this, false);
		add(srcFieldEdgeObject, srcFieldLocator);
		
		conditionKindEdgeObject = new EdgeObjectOffsetEditableLabel(this);
		conditionKindLocator = new EdgeObjectOffsetLocator((IEdgeObjectOffsetFigure) conditionKindEdgeObject);
		add(conditionKindEdgeObject, conditionKindLocator);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the object figure
	 * @generated
	 */
	public IEdgeObjectFigure getSrcFieldEdgeObjectFigure() {
		return srcFieldEdgeObject;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the object figure
	 * @generated
	 */
	public IEdgeObjectFigure getConditionKindEdgeObjectFigure() {
		return conditionKindEdgeObject;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.topcased.modeler.figures.IGraphEdgeFigure#getLocator(org.topcased.modeler.figures.IEdgeObjectFigure)
	 * @generated
	 */
	public Locator getLocator(IEdgeObjectFigure edgeObjectfigure) {
		if (edgeObjectfigure == srcFieldEdgeObject) {
			return srcFieldLocator;
		}
		if (edgeObjectfigure == conditionKindEdgeObject) {
			return conditionKindLocator;
		}
		
		return null;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
	 * @generated
	 */
	public Rectangle getHandleBounds() {
		return getPoints().getBounds();
	}
}
