/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.modeler.actions;

import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.ui.actions.RetargetAction;
import org.topcased.modeler.actions.ModelerActionBarContributor;

import fr.irisa.espresso.sme.common.SmeActionConstants;

/*
 * Generated Actions
 * 
 * @generated
 */
public class SmeEditorActionBarContributor extends ModelerActionBarContributor {
	/**
	 * @see org.eclipse.gef.ui.actions.ActionBarContributor#buildActions()
	 * @generated NOT
	 */
	protected void buildActions() {
		super.buildActions();
		
		RetargetAction action = new RetargetAction(SmeActionConstants.GO_TO_INTERFACE_ASPECT, "Interface");
		action.setToolTipText("Go to the interface Aspect (F9)");
		addRetargetAction(action);
		
		action = new RetargetAction(SmeActionConstants.GO_TO_DATAFLOW_ASPECT, "Dataflow");
		action.setToolTipText("Go to the computation Aspect (F10)");
		addRetargetAction(action);
		
		action = new RetargetAction(SmeActionConstants.GO_TO_CLOCKRELATION_ASPECT, "Clocks");
		action.setToolTipText("Go to the clock & dependence Aspect (F11)");
		addRetargetAction(action);
	}
	
	/**
	 * Add the actions to the ToolBar
	 * 
	 * @see org.eclipse.ui.part.EditorActionBarContributor#contributeToToolBar(org.eclipse.jface.action.IToolBarManager)
	 * @generated NOT
	 */
	public void contributeToToolBar(IToolBarManager toolBarManager) {
		super.contributeToToolBar(toolBarManager);
		
		// Change Aspect actions
		toolBarManager.add(new Separator());
		
		toolBarManager.add(getAction(SmeActionConstants.GO_TO_INTERFACE_ASPECT));
		toolBarManager.add(getAction(SmeActionConstants.GO_TO_DATAFLOW_ASPECT));
		toolBarManager.add(getAction(SmeActionConstants.GO_TO_CLOCKRELATION_ASPECT));
	}
}
