/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.modeler.providers;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAttribute;
import org.topcased.modeler.providers.ILabelFeatureProvider;

import fr.irisa.espresso.sme.InputPort;
import fr.irisa.espresso.sme.Iterate;
import fr.irisa.espresso.sme.ModelConnection;
import fr.irisa.espresso.sme.SmePackage;

/*
 * This is the item provider adpater for a {@link org.topcased.sme.Iterate} object. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */

public class IterateModelerProvider extends SubProcessModelerProvider implements ILabelFeatureProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param adapterFactory
	 *        the adapter factory
	 * 
	 * @generated
	 */
	public IterateModelerProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.topcased.modeler.providers.ILabelFeatureProvider#getLabelFeature(java.lang.Object)
	 * @generated
	 */
	public EAttribute getLabelFeature(Object object) {
		return SmePackage.eINSTANCE.getNamedElement_Name();
	}
	/**
	 * @see org.topcased.modeler.providers.IDeletePartnerProvider#getDeletePartners(java.lang.Object)
	 * @generated NOT
	 */
	public List getDeletePartners(Object object) {
		List deletelist = super.getDeletePartners(object);
		if (deletelist == null)
			deletelist = new ArrayList();
		
		Iterate expr = (Iterate) object;
		
		for (InputPort port : expr.getInputPorts()) {
			EList<? extends ModelConnection> list = port.getDst_DataflowConnections();
			if (!list.isEmpty())
				deletelist.addAll(list);
			
			list = port.getSrc_ClockRelations();
			if (!list.isEmpty())
				deletelist.addAll(list);
			
			list = port.getDst_ClockRelations();
			if (!list.isEmpty())
				deletelist.addAll(list);
		}
		
		return deletelist;
	}
}
