/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.modeler.providers;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.topcased.modeler.providers.IDeleteObjectProvider;
import org.topcased.modeler.providers.IDeletePartnerProvider;
import org.topcased.modeler.providers.ILabelFeatureProvider;

import fr.irisa.espresso.sme.util.SmeAdapterFactory;

/*
 * This is the factory that is used to provide the interfaces needed to support Viewers. The adapters generated by this
 * factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The adapters
 * also support Eclipse property sheets. Note that most of the adapters are shared among multiple instances.
 * 
 * @generated
 */
public class SmeModelerProviderAdapterFactory extends SmeAdapterFactory implements ComposeableAdapterFactory,
		IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * 
	 * @generated
	 */
	private ComposedAdapterFactory							parentAdapterFactory;
	
	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * 
	 * @generated
	 */
	private IChangeNotifier									changeNotifier	= new ChangeNotifier();
	
	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * 
	 * @generated
	 */
	private Collection										supportedTypes	= new ArrayList();
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.SignalExpr} instances.
	 * 
	 * @generated
	 */
	private SignalExprModelerProvider						signalexprModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ConstantExpr} instances.
	 * 
	 * @generated
	 */
	private ConstantExprModelerProvider						constantexprModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ClockedExpr} instances.
	 * 
	 * @generated
	 */
	private ClockedExprModelerProvider						clockedexprModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.BasicIterate} instances.
	 * 
	 * @generated
	 */
	private BasicIterateModelerProvider						basiciterateModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Iterate} instances.
	 * 
	 * @generated
	 */
	private IterateModelerProvider							iterateModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.IterationInit} instances.
	 * 
	 * @generated
	 */
	private IterationInitModelerProvider					iterationinitModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Specifications} instances.
	 * 
	 * @generated
	 */
	private SpecificationsModelerProvider					specificationsModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.SubProcess} instances.
	 * 
	 * @generated
	 */
	private SubProcessModelerProvider						subprocessModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.EnumerationType} instances.
	 * 
	 * @generated
	 */
	private EnumerationTypeModelerProvider					enumerationtypeModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ModelType} instances.
	 * 
	 * @generated
	 */
	private ModelTypeModelerProvider						modeltypeModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.SubstitutionType} instances.
	 * 
	 * @generated
	 */
	private SubstitutionTypeModelerProvider					substitutiontypeModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.TupleType} instances.
	 * 
	 * @generated
	 */
	private TupleTypeModelerProvider						tupletypeModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ModelDeclaration} instances.
	 * 
	 * @generated
	 */
	private ModelDeclarationModelerProvider					modeldeclarationModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ModelRef} instances.
	 * 
	 * @generated
	 */
	private ModelRefModelerProvider							modelrefModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ModelInstance} instances.
	 * 
	 * @generated
	 */
	private ModelInstanceModelerProvider					modelinstanceModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Module} instances.
	 * 
	 * @generated
	 */
	private ModuleModelerProvider							moduleModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.UseModule} instances.
	 * 
	 * @generated
	 */
	private UseModuleModelerProvider						usemoduleModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ConstantRef} instances.
	 * 
	 * @generated
	 */
	private ConstantRefModelerProvider						constantrefModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Constant} instances.
	 * 
	 * @generated
	 */
	private ConstantModelerProvider							constantModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ConstantValue} instances.
	 * 
	 * @generated
	 */
	private ConstantValueModelerProvider					constantvalueModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Literal} instances.
	 * 
	 * @generated
	 */
	private LiteralModelerProvider							literalModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.EnumerationValue} instances.
	 * 
	 * @generated
	 */
	private EnumerationValueModelerProvider					enumerationvalueModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Parameter} instances.
	 * 
	 * @generated
	 */
	private ParameterModelerProvider						parameterModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ParameterInstance} instances.
	 * 
	 * @generated
	 */
	private ParameterInstanceModelerProvider				parameterinstanceModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Iterator} instances.
	 * 
	 * @generated
	 */
	private IteratorModelerProvider							iteratorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Index} instances.
	 * 
	 * @generated
	 */
	private IndexModelerProvider							indexModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.SignalOrRef} instances.
	 * 
	 * @generated
	 */
	private SignalOrRefModelerProvider						signalorrefModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.SignalRef} instances.
	 * 
	 * @generated
	 */
	private SignalRefModelerProvider						signalrefModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Input} instances.
	 * 
	 * @generated
	 */
	private InputModelerProvider							inputModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.InputInstance} instances.
	 * 
	 * @generated
	 */
	private InputInstanceModelerProvider					inputinstanceModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Output} instances.
	 * 
	 * @generated
	 */
	private OutputModelerProvider							outputModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.OutputInstance} instances.
	 * 
	 * @generated
	 */
	private OutputInstanceModelerProvider					outputinstanceModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Local} instances.
	 * 
	 * @generated
	 */
	private LocalModelerProvider							localModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.CaseConnection} instances.
	 * 
	 * @generated
	 */
	private CaseConnectionModelerProvider					caseconnectionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ClockRelation} instances.
	 * 
	 * @generated
	 */
	private ClockRelationModelerProvider					clockrelationModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Condition} instances.
	 * 
	 * @generated
	 */
	private ConditionModelerProvider						conditionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ConstantAffectation} instances.
	 * 
	 * @generated
	 */
	private ConstantAffectationModelerProvider				constantaffectationModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Dependence} instances.
	 * 
	 * @generated
	 */
	private DependenceModelerProvider						dependenceModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.DataflowConnection} instances.
	 * 
	 * @generated
	 */
	private DataflowConnectionModelerProvider				dataflowconnectionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.InputPort} instances.
	 * 
	 * @generated
	 */
	private InputPortModelerProvider						inputportModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.OutputPort} instances.
	 * 
	 * @generated
	 */
	private OutputPortModelerProvider						outputportModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.BooleanOperatorI} instances.
	 * 
	 * @generated
	 */
	private BooleanOperatorIModelerProvider					booleanoperatoriModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.And} instances.
	 * 
	 * @generated
	 */
	private AndModelerProvider								andModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ArithmeticOperator} instances.
	 * 
	 * @generated
	 */
	private ArithmeticOperatorModelerProvider				arithmeticoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ArrayEnumeration} instances.
	 * 
	 * @generated
	 */
	private ArrayEnumerationModelerProvider					arrayenumerationModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ArrayProduct} instances.
	 * 
	 * @generated
	 */
	private ArrayProductModelerProvider						arrayproductModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ArrayRecovery} instances.
	 * 
	 * @generated
	 */
	private ArrayRecoveryModelerProvider					arrayrecoveryModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ArrayRestructuration} instances.
	 * 
	 * @generated
	 */
	private ArrayRestructurationModelerProvider				arrayrestructurationModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Assertion} instances.
	 * 
	 * @generated
	 */
	private AssertionModelerProvider						assertionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.AssertionClockConstraintOperator}
	 * instances.
	 * 
	 * @generated
	 */
	private AssertionClockConstraintOperatorModelerProvider	assertionclockconstraintoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.AssertionClockSpeedOperator}
	 * instances.
	 * 
	 * @generated
	 */
	private AssertionClockSpeedOperatorModelerProvider		assertionclockspeedoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.BooleanExpression} instances.
	 * 
	 * @generated
	 */
	private BooleanExpressionModelerProvider				booleanexpressionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.CartesianProduct} instances.
	 * 
	 * @generated
	 */
	private CartesianProductModelerProvider					cartesianproductModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Cell} instances.
	 * 
	 * @generated
	 */
	private CellModelerProvider								cellModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ClockConstraintOperator} instances.
	 * 
	 * @generated
	 */
	private ClockConstraintOperatorModelerProvider			clockconstraintoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ClockRelationOperator} instances.
	 * 
	 * @generated
	 */
	private ClockRelationOperatorModelerProvider			clockrelationoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ClockSpeedOperator} instances.
	 * 
	 * @generated
	 */
	private ClockSpeedOperatorModelerProvider				clockspeedoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ComparisonOperator} instances.
	 * 
	 * @generated
	 */
	private ComparisonOperatorModelerProvider				comparisonoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.ComplexOperator} instances.
	 * 
	 * @generated
	 */
	private ComplexOperatorModelerProvider					complexoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Concatenation} instances.
	 * 
	 * @generated
	 */
	private ConcatenationModelerProvider					concatenationModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Counter} instances.
	 * 
	 * @generated
	 */
	private CounterModelerProvider							counterModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Delay} instances.
	 * 
	 * @generated
	 */
	private DelayModelerProvider							delayModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.DependenceOperator} instances.
	 * 
	 * @generated
	 */
	private DependenceOperatorModelerProvider				dependenceoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Extraction} instances.
	 * 
	 * @generated
	 */
	private ExtractionModelerProvider						extractionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.IfThenElse} instances.
	 * 
	 * @generated
	 */
	private IfThenElseModelerProvider						ifthenelseModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Merge} instances.
	 * 
	 * @generated
	 */
	private MergeModelerProvider							mergeModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Not} instances.
	 * 
	 * @generated
	 */
	private NotModelerProvider								notModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.NullClock} instances.
	 * 
	 * @generated
	 */
	private NullClockModelerProvider						nullclockModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.NumericExpression} instances.
	 * 
	 * @generated
	 */
	private NumericExpressionModelerProvider				numericexpressionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Or} instances.
	 * 
	 * @generated
	 */
	private OrModelerProvider								orModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Pragma} instances.
	 * 
	 * @generated
	 */
	private PragmaModelerProvider							pragmaModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.RepetitionOperator} instances.
	 * 
	 * @generated
	 */
	private RepetitionOperatorModelerProvider				repetitionoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.SequentialDefinition} instances.
	 * 
	 * @generated
	 */
	private SequentialDefinitionModelerProvider				sequentialdefinitionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Switch} instances.
	 * 
	 * @generated
	 */
	private SwitchModelerProvider							switchModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Transposition} instances.
	 * 
	 * @generated
	 */
	private TranspositionModelerProvider					transpositionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.TupleOperator} instances.
	 * 
	 * @generated
	 */
	private TupleOperatorModelerProvider					tupleoperatorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.UnaryMinus} instances.
	 * 
	 * @generated
	 */
	private UnaryMinusModelerProvider						unaryminusModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Variable} instances.
	 * 
	 * @generated
	 */
	private VariableModelerProvider							variableModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Window} instances.
	 * 
	 * @generated
	 */
	private WindowModelerProvider							windowModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Xor} instances.
	 * 
	 * @generated
	 */
	private XorModelerProvider								xorModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.StateOrHistory} instances.
	 * 
	 * @generated
	 */
	private StateOrHistoryModelerProvider					stateorhistoryModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.History} instances.
	 * 
	 * @generated
	 */
	private HistoryModelerProvider							historyModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.StateBase} instances.
	 * 
	 * @generated
	 */
	private StateBaseModelerProvider						statebaseModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.State} instances.
	 * 
	 * @generated
	 */
	private StateModelerProvider							stateModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.Automaton} instances.
	 * 
	 * @generated
	 */
	private AutomatonModelerProvider						automatonModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.AndState} instances.
	 * 
	 * @generated
	 */
	private AndStateModelerProvider							andstateModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.WeakTransition} instances.
	 * 
	 * @generated
	 */
	private WeakTransitionModelerProvider					weaktransitionModelerProvider;
	
	/**
	 * This keeps track of the one adapter used for all {@link fr.irisa.espresso.sme.StrongTransition} instances.
	 * 
	 * @generated
	 */
	private StrongTransitionModelerProvider					strongtransitionModelerProvider;
	
	/**
	 * This constructs an instance.
	 * 
	 * @generated NOT
	 */
	public SmeModelerProviderAdapterFactory() {
		// default
		supportedTypes.add(ILabelFeatureProvider.class);
		// optional: Allows to delete all edges linked to a node that is deleted.
		supportedTypes.add(IDeletePartnerProvider.class);
		supportedTypes.add(IDeleteObjectProvider.class);
	}
	
	/**
	 * This returns the root adapter factory that contains this factory.
	 * 
	 * @return the root AdapterFactory
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}
	
	/**
	 * This sets the composed adapter factory that contains this factory.
	 * 
	 * @param parentAdapterFactory
	 *        the new parent adapter factory
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}
	
	/**
	 * @param type
	 *        the type to test
	 * @return true if supported
	 * 
	 * @generated
	 */
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}
	
	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * 
	 * @param notifier
	 *        the notifier
	 * @param type
	 *        the object to adapt
	 * @return the Adapter the created adatper
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}
	
	/**
	 * @param object
	 *        the object to adapt
	 * @param type
	 *        the type to adapt
	 * @return the adapted Object
	 * @generated
	 */
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class) type).isInstance(adapter))) {
				return adapter;
			}
		}
		
		return null;
	}
	
	/**
	 * This adds a listener.
	 * 
	 * @param notifyChangedListener
	 *        the listener to add
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}
	
	/**
	 * This removes a listener.
	 * 
	 * @param notifyChangedListener
	 *        the listener to remove
	 * 
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}
	
	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * 
	 * @param notification
	 *        the notification to fire
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);
		
		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.SignalExpr}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSignalExprAdapter() {
		if (signalexprModelerProvider == null) {
			signalexprModelerProvider = new SignalExprModelerProvider(this);
		}
		
		return signalexprModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ConstantExpr}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConstantExprAdapter() {
		if (constantexprModelerProvider == null) {
			constantexprModelerProvider = new ConstantExprModelerProvider(this);
		}
		
		return constantexprModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ClockedExpr}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createClockedExprAdapter() {
		if (clockedexprModelerProvider == null) {
			clockedexprModelerProvider = new ClockedExprModelerProvider(this);
		}
		
		return clockedexprModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.BasicIterate}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createBasicIterateAdapter() {
		if (basiciterateModelerProvider == null) {
			basiciterateModelerProvider = new BasicIterateModelerProvider(this);
		}
		
		return basiciterateModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Iterate}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createIterateAdapter() {
		if (iterateModelerProvider == null) {
			iterateModelerProvider = new IterateModelerProvider(this);
		}
		
		return iterateModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.IterationInit}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createIterationInitAdapter() {
		if (iterationinitModelerProvider == null) {
			iterationinitModelerProvider = new IterationInitModelerProvider(this);
		}
		
		return iterationinitModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Specifications}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSpecificationsAdapter() {
		if (specificationsModelerProvider == null) {
			specificationsModelerProvider = new SpecificationsModelerProvider(this);
		}
		
		return specificationsModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.SubProcess}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSubProcessAdapter() {
		if (subprocessModelerProvider == null) {
			subprocessModelerProvider = new SubProcessModelerProvider(this);
		}
		
		return subprocessModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.EnumerationType}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createEnumerationTypeAdapter() {
		if (enumerationtypeModelerProvider == null) {
			enumerationtypeModelerProvider = new EnumerationTypeModelerProvider(this);
		}
		
		return enumerationtypeModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ModelType}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createModelTypeAdapter() {
		if (modeltypeModelerProvider == null) {
			modeltypeModelerProvider = new ModelTypeModelerProvider(this);
		}
		
		return modeltypeModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.SubstitutionType}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSubstitutionTypeAdapter() {
		if (substitutiontypeModelerProvider == null) {
			substitutiontypeModelerProvider = new SubstitutionTypeModelerProvider(this);
		}
		
		return substitutiontypeModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.TupleType}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createTupleTypeAdapter() {
		if (tupletypeModelerProvider == null) {
			tupletypeModelerProvider = new TupleTypeModelerProvider(this);
		}
		
		return tupletypeModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ModelDeclaration}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createModelDeclarationAdapter() {
		if (modeldeclarationModelerProvider == null) {
			modeldeclarationModelerProvider = new ModelDeclarationModelerProvider(this);
		}
		
		return modeldeclarationModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ModelRef}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createModelRefAdapter() {
		if (modelrefModelerProvider == null) {
			modelrefModelerProvider = new ModelRefModelerProvider(this);
		}
		
		return modelrefModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ModelInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createModelInstanceAdapter() {
		if (modelinstanceModelerProvider == null) {
			modelinstanceModelerProvider = new ModelInstanceModelerProvider(this);
		}
		
		return modelinstanceModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Module}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createModuleAdapter() {
		if (moduleModelerProvider == null) {
			moduleModelerProvider = new ModuleModelerProvider(this);
		}
		
		return moduleModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.UseModule}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createUseModuleAdapter() {
		if (usemoduleModelerProvider == null) {
			usemoduleModelerProvider = new UseModuleModelerProvider(this);
		}
		
		return usemoduleModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ConstantRef}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConstantRefAdapter() {
		if (constantrefModelerProvider == null) {
			constantrefModelerProvider = new ConstantRefModelerProvider(this);
		}
		
		return constantrefModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Constant}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConstantAdapter() {
		if (constantModelerProvider == null) {
			constantModelerProvider = new ConstantModelerProvider(this);
		}
		
		return constantModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ConstantValue}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConstantValueAdapter() {
		if (constantvalueModelerProvider == null) {
			constantvalueModelerProvider = new ConstantValueModelerProvider(this);
		}
		
		return constantvalueModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Literal}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createLiteralAdapter() {
		if (literalModelerProvider == null) {
			literalModelerProvider = new LiteralModelerProvider(this);
		}
		
		return literalModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.EnumerationValue}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createEnumerationValueAdapter() {
		if (enumerationvalueModelerProvider == null) {
			enumerationvalueModelerProvider = new EnumerationValueModelerProvider(this);
		}
		
		return enumerationvalueModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Parameter}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createParameterAdapter() {
		if (parameterModelerProvider == null) {
			parameterModelerProvider = new ParameterModelerProvider(this);
		}
		
		return parameterModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ParameterInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createParameterInstanceAdapter() {
		if (parameterinstanceModelerProvider == null) {
			parameterinstanceModelerProvider = new ParameterInstanceModelerProvider(this);
		}
		
		return parameterinstanceModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Iterator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createIteratorAdapter() {
		if (iteratorModelerProvider == null) {
			iteratorModelerProvider = new IteratorModelerProvider(this);
		}
		
		return iteratorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Index}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createIndexAdapter() {
		if (indexModelerProvider == null) {
			indexModelerProvider = new IndexModelerProvider(this);
		}
		
		return indexModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.SignalOrRef}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSignalOrRefAdapter() {
		if (signalorrefModelerProvider == null) {
			signalorrefModelerProvider = new SignalOrRefModelerProvider(this);
		}
		
		return signalorrefModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.SignalRef}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSignalRefAdapter() {
		if (signalrefModelerProvider == null) {
			signalrefModelerProvider = new SignalRefModelerProvider(this);
		}
		
		return signalrefModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Input}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInputAdapter() {
		if (inputModelerProvider == null) {
			inputModelerProvider = new InputModelerProvider(this);
		}
		
		return inputModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.InputInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInputInstanceAdapter() {
		if (inputinstanceModelerProvider == null) {
			inputinstanceModelerProvider = new InputInstanceModelerProvider(this);
		}
		
		return inputinstanceModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Output}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createOutputAdapter() {
		if (outputModelerProvider == null) {
			outputModelerProvider = new OutputModelerProvider(this);
		}
		
		return outputModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.OutputInstance}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createOutputInstanceAdapter() {
		if (outputinstanceModelerProvider == null) {
			outputinstanceModelerProvider = new OutputInstanceModelerProvider(this);
		}
		
		return outputinstanceModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Local}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createLocalAdapter() {
		if (localModelerProvider == null) {
			localModelerProvider = new LocalModelerProvider(this);
		}
		
		return localModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.CaseConnection}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCaseConnectionAdapter() {
		if (caseconnectionModelerProvider == null) {
			caseconnectionModelerProvider = new CaseConnectionModelerProvider(this);
		}
		
		return caseconnectionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ClockRelation}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createClockRelationAdapter() {
		if (clockrelationModelerProvider == null) {
			clockrelationModelerProvider = new ClockRelationModelerProvider(this);
		}
		
		return clockrelationModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Condition}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConditionAdapter() {
		if (conditionModelerProvider == null) {
			conditionModelerProvider = new ConditionModelerProvider(this);
		}
		
		return conditionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ConstantAffectation}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConstantAffectationAdapter() {
		if (constantaffectationModelerProvider == null) {
			constantaffectationModelerProvider = new ConstantAffectationModelerProvider(this);
		}
		
		return constantaffectationModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Dependence}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDependenceAdapter() {
		if (dependenceModelerProvider == null) {
			dependenceModelerProvider = new DependenceModelerProvider(this);
		}
		
		return dependenceModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.DataflowConnection}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDataflowConnectionAdapter() {
		if (dataflowconnectionModelerProvider == null) {
			dataflowconnectionModelerProvider = new DataflowConnectionModelerProvider(this);
		}
		
		return dataflowconnectionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.InputPort}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createInputPortAdapter() {
		if (inputportModelerProvider == null) {
			inputportModelerProvider = new InputPortModelerProvider(this);
		}
		
		return inputportModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.OutputPort}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createOutputPortAdapter() {
		if (outputportModelerProvider == null) {
			outputportModelerProvider = new OutputPortModelerProvider(this);
		}
		
		return outputportModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.BooleanOperatorI}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createBooleanOperatorIAdapter() {
		if (booleanoperatoriModelerProvider == null) {
			booleanoperatoriModelerProvider = new BooleanOperatorIModelerProvider(this);
		}
		
		return booleanoperatoriModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.And}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAndAdapter() {
		if (andModelerProvider == null) {
			andModelerProvider = new AndModelerProvider(this);
		}
		
		return andModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ArithmeticOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createArithmeticOperatorAdapter() {
		if (arithmeticoperatorModelerProvider == null) {
			arithmeticoperatorModelerProvider = new ArithmeticOperatorModelerProvider(this);
		}
		
		return arithmeticoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ArrayEnumeration}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createArrayEnumerationAdapter() {
		if (arrayenumerationModelerProvider == null) {
			arrayenumerationModelerProvider = new ArrayEnumerationModelerProvider(this);
		}
		
		return arrayenumerationModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ArrayProduct}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createArrayProductAdapter() {
		if (arrayproductModelerProvider == null) {
			arrayproductModelerProvider = new ArrayProductModelerProvider(this);
		}
		
		return arrayproductModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ArrayRecovery}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createArrayRecoveryAdapter() {
		if (arrayrecoveryModelerProvider == null) {
			arrayrecoveryModelerProvider = new ArrayRecoveryModelerProvider(this);
		}
		
		return arrayrecoveryModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ArrayRestructuration}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createArrayRestructurationAdapter() {
		if (arrayrestructurationModelerProvider == null) {
			arrayrestructurationModelerProvider = new ArrayRestructurationModelerProvider(this);
		}
		
		return arrayrestructurationModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Assertion}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAssertionAdapter() {
		if (assertionModelerProvider == null) {
			assertionModelerProvider = new AssertionModelerProvider(this);
		}
		
		return assertionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.AssertionClockConstraintOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAssertionClockConstraintOperatorAdapter() {
		if (assertionclockconstraintoperatorModelerProvider == null) {
			assertionclockconstraintoperatorModelerProvider = new AssertionClockConstraintOperatorModelerProvider(this);
		}
		
		return assertionclockconstraintoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.AssertionClockSpeedOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAssertionClockSpeedOperatorAdapter() {
		if (assertionclockspeedoperatorModelerProvider == null) {
			assertionclockspeedoperatorModelerProvider = new AssertionClockSpeedOperatorModelerProvider(this);
		}
		
		return assertionclockspeedoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.BooleanExpression}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createBooleanExpressionAdapter() {
		if (booleanexpressionModelerProvider == null) {
			booleanexpressionModelerProvider = new BooleanExpressionModelerProvider(this);
		}
		
		return booleanexpressionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.CartesianProduct}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCartesianProductAdapter() {
		if (cartesianproductModelerProvider == null) {
			cartesianproductModelerProvider = new CartesianProductModelerProvider(this);
		}
		
		return cartesianproductModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Cell}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCellAdapter() {
		if (cellModelerProvider == null) {
			cellModelerProvider = new CellModelerProvider(this);
		}
		
		return cellModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ClockConstraintOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createClockConstraintOperatorAdapter() {
		if (clockconstraintoperatorModelerProvider == null) {
			clockconstraintoperatorModelerProvider = new ClockConstraintOperatorModelerProvider(this);
		}
		
		return clockconstraintoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ClockRelationOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createClockRelationOperatorAdapter() {
		if (clockrelationoperatorModelerProvider == null) {
			clockrelationoperatorModelerProvider = new ClockRelationOperatorModelerProvider(this);
		}
		
		return clockrelationoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ClockSpeedOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createClockSpeedOperatorAdapter() {
		if (clockspeedoperatorModelerProvider == null) {
			clockspeedoperatorModelerProvider = new ClockSpeedOperatorModelerProvider(this);
		}
		
		return clockspeedoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ComparisonOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createComparisonOperatorAdapter() {
		if (comparisonoperatorModelerProvider == null) {
			comparisonoperatorModelerProvider = new ComparisonOperatorModelerProvider(this);
		}
		
		return comparisonoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.ComplexOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createComplexOperatorAdapter() {
		if (complexoperatorModelerProvider == null) {
			complexoperatorModelerProvider = new ComplexOperatorModelerProvider(this);
		}
		
		return complexoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Concatenation}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createConcatenationAdapter() {
		if (concatenationModelerProvider == null) {
			concatenationModelerProvider = new ConcatenationModelerProvider(this);
		}
		
		return concatenationModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Counter}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCounterAdapter() {
		if (counterModelerProvider == null) {
			counterModelerProvider = new CounterModelerProvider(this);
		}
		
		return counterModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Delay}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDelayAdapter() {
		if (delayModelerProvider == null) {
			delayModelerProvider = new DelayModelerProvider(this);
		}
		
		return delayModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.DependenceOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDependenceOperatorAdapter() {
		if (dependenceoperatorModelerProvider == null) {
			dependenceoperatorModelerProvider = new DependenceOperatorModelerProvider(this);
		}
		
		return dependenceoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Extraction}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createExtractionAdapter() {
		if (extractionModelerProvider == null) {
			extractionModelerProvider = new ExtractionModelerProvider(this);
		}
		
		return extractionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.IfThenElse}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createIfThenElseAdapter() {
		if (ifthenelseModelerProvider == null) {
			ifthenelseModelerProvider = new IfThenElseModelerProvider(this);
		}
		
		return ifthenelseModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Merge}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createMergeAdapter() {
		if (mergeModelerProvider == null) {
			mergeModelerProvider = new MergeModelerProvider(this);
		}
		
		return mergeModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Not}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createNotAdapter() {
		if (notModelerProvider == null) {
			notModelerProvider = new NotModelerProvider(this);
		}
		
		return notModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.NullClock}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createNullClockAdapter() {
		if (nullclockModelerProvider == null) {
			nullclockModelerProvider = new NullClockModelerProvider(this);
		}
		
		return nullclockModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.NumericExpression}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createNumericExpressionAdapter() {
		if (numericexpressionModelerProvider == null) {
			numericexpressionModelerProvider = new NumericExpressionModelerProvider(this);
		}
		
		return numericexpressionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Or}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createOrAdapter() {
		if (orModelerProvider == null) {
			orModelerProvider = new OrModelerProvider(this);
		}
		
		return orModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Pragma}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createPragmaAdapter() {
		if (pragmaModelerProvider == null) {
			pragmaModelerProvider = new PragmaModelerProvider(this);
		}
		
		return pragmaModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.RepetitionOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createRepetitionOperatorAdapter() {
		if (repetitionoperatorModelerProvider == null) {
			repetitionoperatorModelerProvider = new RepetitionOperatorModelerProvider(this);
		}
		
		return repetitionoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.SequentialDefinition}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSequentialDefinitionAdapter() {
		if (sequentialdefinitionModelerProvider == null) {
			sequentialdefinitionModelerProvider = new SequentialDefinitionModelerProvider(this);
		}
		
		return sequentialdefinitionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Switch}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSwitchAdapter() {
		if (switchModelerProvider == null) {
			switchModelerProvider = new SwitchModelerProvider(this);
		}
		
		return switchModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Transposition}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createTranspositionAdapter() {
		if (transpositionModelerProvider == null) {
			transpositionModelerProvider = new TranspositionModelerProvider(this);
		}
		
		return transpositionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.TupleOperator}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createTupleOperatorAdapter() {
		if (tupleoperatorModelerProvider == null) {
			tupleoperatorModelerProvider = new TupleOperatorModelerProvider(this);
		}
		
		return tupleoperatorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.UnaryMinus}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createUnaryMinusAdapter() {
		if (unaryminusModelerProvider == null) {
			unaryminusModelerProvider = new UnaryMinusModelerProvider(this);
		}
		
		return unaryminusModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Variable}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createVariableAdapter() {
		if (variableModelerProvider == null) {
			variableModelerProvider = new VariableModelerProvider(this);
		}
		
		return variableModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Window}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createWindowAdapter() {
		if (windowModelerProvider == null) {
			windowModelerProvider = new WindowModelerProvider(this);
		}
		
		return windowModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Xor}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createXorAdapter() {
		if (xorModelerProvider == null) {
			xorModelerProvider = new XorModelerProvider(this);
		}
		
		return xorModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.StateOrHistory}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createStateOrHistoryAdapter() {
		if (stateorhistoryModelerProvider == null) {
			stateorhistoryModelerProvider = new StateOrHistoryModelerProvider(this);
		}
		
		return stateorhistoryModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.History}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createHistoryAdapter() {
		if (historyModelerProvider == null) {
			historyModelerProvider = new HistoryModelerProvider(this);
		}
		
		return historyModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.StateBase}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createStateBaseAdapter() {
		if (statebaseModelerProvider == null) {
			statebaseModelerProvider = new StateBaseModelerProvider(this);
		}
		
		return statebaseModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.State}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createStateAdapter() {
		if (stateModelerProvider == null) {
			stateModelerProvider = new StateModelerProvider(this);
		}
		
		return stateModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.Automaton}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAutomatonAdapter() {
		if (automatonModelerProvider == null) {
			automatonModelerProvider = new AutomatonModelerProvider(this);
		}
		
		return automatonModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.AndState}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAndStateAdapter() {
		if (andstateModelerProvider == null) {
			andstateModelerProvider = new AndStateModelerProvider(this);
		}
		
		return andstateModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.WeakTransition}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createWeakTransitionAdapter() {
		if (weaktransitionModelerProvider == null) {
			weaktransitionModelerProvider = new WeakTransitionModelerProvider(this);
		}
		
		return weaktransitionModelerProvider;
	}
	
	/**
	 * This creates an adapter for a {@link fr.irisa.espresso.sme.StrongTransition}.
	 * 
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createStrongTransitionAdapter() {
		if (strongtransitionModelerProvider == null) {
			strongtransitionModelerProvider = new StrongTransitionModelerProvider(this);
		}
		
		return strongtransitionModelerProvider;
	}
	
	/**
	 * This disposes all of the item providers created by this factory.
	 * 
	 * @generated
	 */
	public void dispose() {
		if (signalexprModelerProvider != null) {
			signalexprModelerProvider.dispose();
		}
		if (constantexprModelerProvider != null) {
			constantexprModelerProvider.dispose();
		}
		if (clockedexprModelerProvider != null) {
			clockedexprModelerProvider.dispose();
		}
		if (basiciterateModelerProvider != null) {
			basiciterateModelerProvider.dispose();
		}
		if (iterateModelerProvider != null) {
			iterateModelerProvider.dispose();
		}
		if (iterationinitModelerProvider != null) {
			iterationinitModelerProvider.dispose();
		}
		if (specificationsModelerProvider != null) {
			specificationsModelerProvider.dispose();
		}
		if (subprocessModelerProvider != null) {
			subprocessModelerProvider.dispose();
		}
		if (enumerationtypeModelerProvider != null) {
			enumerationtypeModelerProvider.dispose();
		}
		if (modeltypeModelerProvider != null) {
			modeltypeModelerProvider.dispose();
		}
		if (substitutiontypeModelerProvider != null) {
			substitutiontypeModelerProvider.dispose();
		}
		if (tupletypeModelerProvider != null) {
			tupletypeModelerProvider.dispose();
		}
		if (modeldeclarationModelerProvider != null) {
			modeldeclarationModelerProvider.dispose();
		}
		if (modelrefModelerProvider != null) {
			modelrefModelerProvider.dispose();
		}
		if (modelinstanceModelerProvider != null) {
			modelinstanceModelerProvider.dispose();
		}
		if (moduleModelerProvider != null) {
			moduleModelerProvider.dispose();
		}
		if (usemoduleModelerProvider != null) {
			usemoduleModelerProvider.dispose();
		}
		if (constantrefModelerProvider != null) {
			constantrefModelerProvider.dispose();
		}
		if (constantModelerProvider != null) {
			constantModelerProvider.dispose();
		}
		if (constantvalueModelerProvider != null) {
			constantvalueModelerProvider.dispose();
		}
		if (literalModelerProvider != null) {
			literalModelerProvider.dispose();
		}
		if (enumerationvalueModelerProvider != null) {
			enumerationvalueModelerProvider.dispose();
		}
		if (parameterModelerProvider != null) {
			parameterModelerProvider.dispose();
		}
		if (parameterinstanceModelerProvider != null) {
			parameterinstanceModelerProvider.dispose();
		}
		if (iteratorModelerProvider != null) {
			iteratorModelerProvider.dispose();
		}
		if (indexModelerProvider != null) {
			indexModelerProvider.dispose();
		}
		if (signalorrefModelerProvider != null) {
			signalorrefModelerProvider.dispose();
		}
		if (signalrefModelerProvider != null) {
			signalrefModelerProvider.dispose();
		}
		if (inputModelerProvider != null) {
			inputModelerProvider.dispose();
		}
		if (inputinstanceModelerProvider != null) {
			inputinstanceModelerProvider.dispose();
		}
		if (outputModelerProvider != null) {
			outputModelerProvider.dispose();
		}
		if (outputinstanceModelerProvider != null) {
			outputinstanceModelerProvider.dispose();
		}
		if (localModelerProvider != null) {
			localModelerProvider.dispose();
		}
		if (caseconnectionModelerProvider != null) {
			caseconnectionModelerProvider.dispose();
		}
		if (clockrelationModelerProvider != null) {
			clockrelationModelerProvider.dispose();
		}
		if (conditionModelerProvider != null) {
			conditionModelerProvider.dispose();
		}
		if (constantaffectationModelerProvider != null) {
			constantaffectationModelerProvider.dispose();
		}
		if (dependenceModelerProvider != null) {
			dependenceModelerProvider.dispose();
		}
		if (dataflowconnectionModelerProvider != null) {
			dataflowconnectionModelerProvider.dispose();
		}
		if (inputportModelerProvider != null) {
			inputportModelerProvider.dispose();
		}
		if (outputportModelerProvider != null) {
			outputportModelerProvider.dispose();
		}
		if (booleanoperatoriModelerProvider != null) {
			booleanoperatoriModelerProvider.dispose();
		}
		if (andModelerProvider != null) {
			andModelerProvider.dispose();
		}
		if (arithmeticoperatorModelerProvider != null) {
			arithmeticoperatorModelerProvider.dispose();
		}
		if (arrayenumerationModelerProvider != null) {
			arrayenumerationModelerProvider.dispose();
		}
		if (arrayproductModelerProvider != null) {
			arrayproductModelerProvider.dispose();
		}
		if (arrayrecoveryModelerProvider != null) {
			arrayrecoveryModelerProvider.dispose();
		}
		if (arrayrestructurationModelerProvider != null) {
			arrayrestructurationModelerProvider.dispose();
		}
		if (assertionModelerProvider != null) {
			assertionModelerProvider.dispose();
		}
		if (assertionclockconstraintoperatorModelerProvider != null) {
			assertionclockconstraintoperatorModelerProvider.dispose();
		}
		if (assertionclockspeedoperatorModelerProvider != null) {
			assertionclockspeedoperatorModelerProvider.dispose();
		}
		if (booleanexpressionModelerProvider != null) {
			booleanexpressionModelerProvider.dispose();
		}
		if (cartesianproductModelerProvider != null) {
			cartesianproductModelerProvider.dispose();
		}
		if (cellModelerProvider != null) {
			cellModelerProvider.dispose();
		}
		if (clockconstraintoperatorModelerProvider != null) {
			clockconstraintoperatorModelerProvider.dispose();
		}
		if (clockrelationoperatorModelerProvider != null) {
			clockrelationoperatorModelerProvider.dispose();
		}
		if (clockspeedoperatorModelerProvider != null) {
			clockspeedoperatorModelerProvider.dispose();
		}
		if (comparisonoperatorModelerProvider != null) {
			comparisonoperatorModelerProvider.dispose();
		}
		if (complexoperatorModelerProvider != null) {
			complexoperatorModelerProvider.dispose();
		}
		if (concatenationModelerProvider != null) {
			concatenationModelerProvider.dispose();
		}
		if (counterModelerProvider != null) {
			counterModelerProvider.dispose();
		}
		if (delayModelerProvider != null) {
			delayModelerProvider.dispose();
		}
		if (dependenceoperatorModelerProvider != null) {
			dependenceoperatorModelerProvider.dispose();
		}
		if (extractionModelerProvider != null) {
			extractionModelerProvider.dispose();
		}
		if (ifthenelseModelerProvider != null) {
			ifthenelseModelerProvider.dispose();
		}
		if (mergeModelerProvider != null) {
			mergeModelerProvider.dispose();
		}
		if (notModelerProvider != null) {
			notModelerProvider.dispose();
		}
		if (nullclockModelerProvider != null) {
			nullclockModelerProvider.dispose();
		}
		if (numericexpressionModelerProvider != null) {
			numericexpressionModelerProvider.dispose();
		}
		if (orModelerProvider != null) {
			orModelerProvider.dispose();
		}
		if (pragmaModelerProvider != null) {
			pragmaModelerProvider.dispose();
		}
		if (repetitionoperatorModelerProvider != null) {
			repetitionoperatorModelerProvider.dispose();
		}
		if (sequentialdefinitionModelerProvider != null) {
			sequentialdefinitionModelerProvider.dispose();
		}
		if (switchModelerProvider != null) {
			switchModelerProvider.dispose();
		}
		if (transpositionModelerProvider != null) {
			transpositionModelerProvider.dispose();
		}
		if (tupleoperatorModelerProvider != null) {
			tupleoperatorModelerProvider.dispose();
		}
		if (unaryminusModelerProvider != null) {
			unaryminusModelerProvider.dispose();
		}
		if (variableModelerProvider != null) {
			variableModelerProvider.dispose();
		}
		if (windowModelerProvider != null) {
			windowModelerProvider.dispose();
		}
		if (xorModelerProvider != null) {
			xorModelerProvider.dispose();
		}
		if (stateorhistoryModelerProvider != null) {
			stateorhistoryModelerProvider.dispose();
		}
		if (historyModelerProvider != null) {
			historyModelerProvider.dispose();
		}
		if (statebaseModelerProvider != null) {
			statebaseModelerProvider.dispose();
		}
		if (stateModelerProvider != null) {
			stateModelerProvider.dispose();
		}
		if (automatonModelerProvider != null) {
			automatonModelerProvider.dispose();
		}
		if (andstateModelerProvider != null) {
			andstateModelerProvider.dispose();
		}
		if (weaktransitionModelerProvider != null) {
			weaktransitionModelerProvider.dispose();
		}
		if (strongtransitionModelerProvider != null) {
			strongtransitionModelerProvider.dispose();
		}
	}
	
}
