/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.modeler.providers;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAttribute;
import org.topcased.modeler.providers.ILabelFeatureProvider;

import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.SubProcess;

/*
 * This is the item provider adpater for a {@link org.topcased.sme.SubProcess} object. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated NOT
 */
public class SubProcessModelerProvider extends ClockedExprModelerProvider implements ILabelFeatureProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param adapterFactory
	 *        the adapter factory
	 * 
	 * @generated
	 */
	public SubProcessModelerProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.topcased.modeler.providers.ILabelFeatureProvider#getLabelFeature(java.lang.Object)
	 * @generated
	 */
	public EAttribute getLabelFeature(Object object) {
		return SmePackage.eINSTANCE.getNamedElement_Name();
	}
	/**
	 * @see org.topcased.modeler.providers.IDeletePartnerProvider#getDeletePartners(java.lang.Object)
	 * @generated NOT
	 */
	public List getDeletePartners(Object object) {
		List deletelist = new ArrayList();
		
		SubProcess expr = (SubProcess) object;
		
		if (expr.getDst_CaseConnection() != null)
			deletelist.add(expr.getDst_CaseConnection());
		
		EList list = expr.getSrc_Dependences();
		if (!list.isEmpty())
			deletelist.addAll(list);
		
		list = expr.getDst_Dependences();
		if (!list.isEmpty())
			deletelist.addAll(list);
		
		return deletelist;
	}
}
