
package Signal.lib.Java;

public class pK_complex
{
    public float	re, im;

    public pK_complex()
    {
	this.re = 0;
	this.im = 0;
    }

    public pK_complex(float re, float im)
    {
	this.re = re;
	this.im = im;
    }

    public void affich()
    {
	System.out.print("real part: " + this.re);
	System.out.println("\timag part: " + this.im);
    }

    public static pK_complex pK_complexNew(float R1, float R2)
    {
	pK_complex apK_complex = new pK_complex();
	apK_complex.re = R1;
	apK_complex.im = R2;
	return apK_complex;
    }

    // Constructor : ( double @ double ) --> double complex
    public static pK_complexd pK_complexdNew(double R1, double R2)
    {
	return new pK_complexd(R1, R2);
    }

    public static pK_complex pK_complexPlus(pK_complex C1, pK_complex C2)
    {
	pK_complex apK_complex = new pK_complex();
	apK_complex.re = C1.re + C2.re;
	apK_complex.im = C1.im + C2.im;
	return apK_complex;
    }

    public static pK_complex pK_complexMinus(pK_complex C1, pK_complex C2)
    {
	pK_complex apK_complex = new pK_complex();
	apK_complex.re = C1.re - C2.re;
	apK_complex.im = C1.im - C2.im;
	return apK_complex;
    }

    public static pK_complex pK_complexUMinus(pK_complex C1)
    {
	pK_complex apK_complex = new pK_complex();
	apK_complex.re = -(C1.re);
	apK_complex.im = -(C1.im);
	return apK_complex;
    }

    public static pK_complex pK_complexMult(pK_complex C1, pK_complex C2)
    {
	pK_complex apK_complex = new pK_complex();
	apK_complex.re = (C1.re * C2.re) - (C1.im * C2.im);
	apK_complex.im = (C1.re * C2.im) + (C2.re * C1.im);
	return apK_complex;
    }

    public static pK_complex pK_complexDiv(pK_complex C1, pK_complex C2)
    {
	pK_complex apK_complex = new pK_complex();
	float iM2;
	iM2 = (float) 1.0 / ((C2.re * C2.re) + (C2.im * C2.im));
	apK_complex.re = iM2 * ((C1.re * C2.re) + (C1.im * C2.im));
	apK_complex.im = iM2 * ((C2.re * C1.im) - (C1.re * C2.im));
	return apK_complex;
    }

    public static pK_complex pK_complexPow(pK_complex C1, long ipow)
    {
	pK_complex apK_complex = new pK_complex();
	pK_complex vp = new pK_complex();
	apK_complex.re = (float) 1.0;
	apK_complex.im = (float) 0.0;
	if (ipow < 0)
	    {
		ipow = -ipow;
		vp = pK_complexDiv(apK_complex, C1);
	    }
	else
	    {
		vp.re = C1.re;
		vp.im = C1.im;
	    }
	while (ipow != 0)
	    {
		// if (ipow&1)
		apK_complex = pK_complexMult(apK_complex, vp);
		vp = pK_complexMult(vp, vp);
		ipow >>= 1;
	    }
	return apK_complex;
    }

    public static boolean pK_complexEq(pK_complex C1, pK_complex C2)
    {
	return ((C1.re == C2.re) && (C1.im == C2.im));
    }

    public static boolean pK_complexNeq(pK_complex C1, pK_complex C2)
    {
	return ((C1.re != C2.re) || (C1.im != C2.im));
    }

    public static pK_complex pK_complexConj(pK_complex E)
    {
	pK_complex apK_complex = new pK_complex();
	apK_complex.re = E.re;
	apK_complex.im = -E.im;
	return apK_complex;
    }

    public static float pK_complexmodule(pK_complex E)
    {
	return (float) java.lang.Math.sqrt(E.re * E.re + E.im * E.im);
    }

    public static float pK_complexarg(pK_complex E)
    {
	return (float) java.lang.Math.atan(E.im / E.re);
    }

    public static pK_complexd pK_complexdPlus(pK_complexd C1, pK_complexd C2)
    {
	pK_complexd apK_complexd = new pK_complexd();
	apK_complexd.re = C1.re + C2.re;
	apK_complexd.im = C1.im + C2.im;
	return apK_complexd;
    }

    public static pK_complexd pK_complexdMinus(pK_complexd C1, pK_complexd C2)
    {
	pK_complexd apK_complexd = new pK_complexd();
	apK_complexd.re = C1.re - C2.re;
	apK_complexd.im = C1.im - C2.im;
	return apK_complexd;
    }

    public static pK_complexd pK_complexdUMinus(pK_complexd C1)
    {
	pK_complexd apK_complexd = new pK_complexd();
	apK_complexd.re = -(C1.re);
	apK_complexd.im = -(C1.im);
	return apK_complexd;
    }

    public static pK_complexd pK_complexdMult(pK_complexd C1, pK_complexd C2)
    {
	pK_complexd apK_complexd = new pK_complexd();
	apK_complexd.re = (C1.re * C2.re) - (C1.im * C2.im);
	apK_complexd.im = (C1.re * C2.im) + (C2.re * C1.im);
	return apK_complexd;
    }

    public static pK_complexd pK_complexdDiv(pK_complexd C1, pK_complexd C2)
    {
	pK_complexd apK_complexd = new pK_complexd();
	double iM2;
	iM2 = (double) 1.0 / ((C2.re * C2.re) + (C2.im * C2.im));
	apK_complexd.re = iM2 * ((C1.re * C2.re) + (C1.im * C2.im));
	apK_complexd.im = iM2 * ((C2.re * C1.im) - (C1.re * C2.im));
	return apK_complexd;
    }

    public static pK_complexd pK_complexdPow(pK_complexd C1, long ipow)
    {
	pK_complexd apK_complexd = new pK_complexd();
	pK_complexd vp = new pK_complexd();
	apK_complexd.re = (float) 1.0;
	apK_complexd.im = (float) 0.0;
	if (ipow < 0)
	    {
		ipow = -ipow;
		vp = pK_complexdDiv(apK_complexd, C1);
	    }
	else
	    {
		vp.re = C1.re;
		vp.im = C1.im;
	    }
	while (ipow != 0)
	    {
		// if (ipow&1)
		apK_complexd = pK_complexdMult(apK_complexd, vp);
		vp = pK_complexdMult(vp, vp);
		ipow >>= 1;
	    }
	return apK_complexd;
    }

    public static boolean pK_complexdEq(pK_complexd C1, pK_complexd C2)
    {
	return ((C1.re == C2.re) && (C1.im == C2.im));
    }

    public static boolean pK_complexdNeq(pK_complexd C1, pK_complexd C2)
    {
	return ((C1.re != C2.re) || (C1.im != C2.im));
    }

    public static pK_complexd pK_complexdConj(pK_complexd E)
    {
	pK_complexd apK_complexd = new pK_complexd();
	apK_complexd.re = E.re;
	apK_complexd.im = -E.im;
	return apK_complexd;
    }

    public static float pK_complexdmodule(pK_complexd E)
    {
	return (float) java.lang.Math.sqrt(E.re * E.re + E.im * E.im);
    }

    public static float pK_complexdarg(pK_complexd E)
    {
	return (float) java.lang.Math.atan(E.im / E.re);
    }
}
