module SIGALI_VERIF = 

   pragmas 
      Comment " Sigali predefined library: Verif "
   end pragmas
   type setOfStates = boolean;

   process Always =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%       spec (| RESULT ^= PROP |) %
      pragmas 
         Sigali "&n(S,&i1);"
         Comment "invariant(SYSTEM, SET) -> BOOLEAN : invariant(syst, p) is True whenever"
         " the  set of  states,  solution of  the  polynomial p  is invariant  with."
         " It is apply on all the states (reachable or not). See also AG()."

      end pragmas

   %Always%; 
   process Reachable =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%       spec (| RESULT ^= PROP |) %
      pragmas 
         Sigali "&n(S, &i1);"
         Comment "Reachable(SYSTEM,  SET)  ->  BOOLEAN  :   Reachable(syst,  p)  is  True"
                 " whenever at least one of the state  of the set V(p) can be reached via a"
                 " trajectory of the system from one of the initial states."
      end pragmas

   %Reachable%; 
   %  process% function Never =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%          spec (| RESULT ^= PROP |) %
      pragmas 
         Sigali "&n(S,&i1);"
         Comment "Never(SYSTEM,  SET)  ->  BOOLEAN  :   Never(syst,  p)  is  True"
                 " whenever no state of V(p) can be reached from the initial states of the system"
      end pragmas

   %Never%; 
   process Attractivity =
        ( ? setOfStates PROP1, PROP2;
          ! boolean RESULT;
        )
%          spec (| RESULT ^= PROP1 ^= PROP2 |) %
      pragmas 
         Sigali "&n(S,&i1, &i2);"
         Comment " Attractivity(SYSTEM,SET,SET)  ->  BOOLEAN :   Attractivity(p1,p2) is  True"
                 " whenever  all the  trajectories initialized  in V(p1)  reach the  set of"
                 " states   V(p2).  "
      end pragmas

   %Attractivity%; 
   process Invariant =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%       spec (| RESULT ^= PROP |)    %
      pragmas 
         Sigali "&n(S,&i1);"
         Comment " Same as Always"
                 " under control with respect to the  system syst. ie there is always a way"
      end pragmas

   %Invariant%; 
   process C_Invariant =
        ( ? setOfStates PROP;
          ! boolean RESULT;
        )
%          spec (| RESULT ^= PROP |) %
      pragmas 
         Sigali "&n(S,&i1);"
         Comment " C_invariant(SYSTEM,  SET) ->  BOOLEAN  : c_invariant(syst,  p) is  True"
                 " whenever the set  of states, solutions of the  polynomial p is invariant"

                 " to stay inside V(p)."
                 " with respect to the system S.  The controlled system is the output of this"
      end pragmas

      
   %C_Invariant%; 

   process subset =
       ( ? setOfStates I,J;
         ! boolean RESULT;
           )
       pragmas 
         Sigali "&o1 :&n(&i1, &i2);"
         Comment "return true if I is included in J "
       end pragmas;
       
     end;
