/***Polychrony License******************************************
 *                                                             *
 * Copyright: IRISA/INRIA Rennes - ESPRESSO team.              *
 * This software is under the terms of the CeCILL-B License.   *
 * http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html *
 *                                                             *
 ***************************************************************/
#ifndef __PRIORITYRECEIVEQUEUE_H__
#define __PRIORITYRECEIVEQUEUE_H__



/***********************************************************************************/
/***************************   PRIORITY_RECEIVEQUEUE_NODE   ************************/
/***********************************************************************************/


typedef class PRIORITY_ReceiveQueueNode *ptPRIORITY_ReceiveQueueNode;
class PRIORITY_ReceiveQueueNode
{
 private:
  ProcessID_type contents;                                   /* Contents of a node */
  ptPRIORITY_ReceiveQueueNode next;                                   /* Next node */

 public:
  PRIORITY_ReceiveQueueNode(ProcessID_type Process_ID);
  ~PRIORITY_ReceiveQueueNode();
  void setContents(ProcessID_type Process_ID);
  void setNext(ptPRIORITY_ReceiveQueueNode nextNode);
  ProcessID_type getContents();
  ptPRIORITY_ReceiveQueueNode getNext();
};



/***********************************************************************************/
/*****************************   PRIORITY_RECEIVEQUEUE   ***************************/
/***********************************************************************************/


typedef class PRIORITY_ReceiveQueue *ptPRIORITY_ReceiveQueue;
class PRIORITY_ReceiveQueue
{
  private:
   ptPRIORITY_ReceiveQueueNode first;          /* First node of the PRIORITY_QUEUE */
   ptPRIORITY_ReceiveQueueNode last;            /* Last node of the PRIORITY_QUEUE */
   int max_size;                               /* Size limit of the PRIORITY_QUEUE */
   int current_size;              /* Current number of nodes in the PRIORITY_QUEUE */
  
   void setFirst(ptPRIORITY_ReceiveQueueNode node);
   void setLast(ptPRIORITY_ReceiveQueueNode node);
 
  public:
   PRIORITY_ReceiveQueue();
   PRIORITY_ReceiveQueue(int nbproc);
   ~PRIORITY_ReceiveQueue();
   ptPRIORITY_ReceiveQueueNode getFirst();
   ptPRIORITY_ReceiveQueueNode getLast();

   int getCurrentSize();

   void insert(ProcessID_type Process_ID);
   /* Insert Process_ID in the QUEUE */

   void remove(ProcessID_type& Process_ID);
   /* Remove the node with the highest value from the QUEUE and Process_ID is the
      value of this node */

   void clean();
   /* delete all nodes in the QUEUE */

   bool empty();
   /* The QUEUE is empty */

   bool full();
   /* The QUEUE size limit is reached */

   void printFile(char *result_file);
   /* prints the QUEUE in result_file */

};


#endif // __PRIORITYRECEIVEQUEUE_H__










