/***Polychrony License******************************************
 *                                                             *
 * Copyright: IRISA/INRIA Rennes - ESPRESSO team.              *
 * This software is under the terms of the CeCILL-B License.   *
 * http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html *
 *                                                             *
 ***************************************************************/

#include <semaphore.h>

// A Semaphore
// -----------

#define pK_sem_type \
  sem_t

#define pK_sem_dcl(s) \
  sem_t s;

#define pK_sem_ini(s, vini) \
  if (sem_init(&s, 0, (unsigned) vini) !=0) \
    printf("Sem_ini error: \n");

#define pK_sem_wait(s) \
  sem_wait(&s);

#define pK_sem_signal(s) \
  sem_post(&s);


// Array of Semaphores.
// -------------------

#define pK_sem_dcl_array(N) \
  sem_t semTable[N];

#define pK_Isem_ini(numSem, vini) \
  if (sem_init(&semTable[numSem], 0, (unsigned) vini) !=0) \
    printf("Sem_ini error: <%d>\n", numSem);

#define pK_Isem_wait(numSem) \
  sem_wait(&semTable[numSem]);

#define pK_Isem_signal(numSem) \
  sem_post(&semTable[numSem]);


