/***Polychrony License******************************************
 *                                                             *
 * Copyright: IRISA/INRIA Rennes - ESPRESSO team.              *
 * This software is under the terms of the CeCILL-B License.   *
 * http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html *
 *                                                             *
 ***************************************************************/

#include <pthread.h>

#define pK_type_task  \
  pthread_t
  
#define pK_tasks_dcl_array(N) \
  pthread_t threadsTable[N];

#define pK_io_tasks_dcl_array(N) \
  pthread_t io_threadsTable[N];

#define pK_io_Task_create(numTask, nameTask) \
  if ((pthread_create( &io_threadsTable[numTask], NULL, nameTask, NULL))) \
    printf("IO Thread creation failed: d%\n", numTask);


#define pK_Task_create(numTask, nameTask) \
  if ((pthread_create( &threadsTable[numTask], NULL, nameTask, NULL)))	\
    printf("Thread creation failed: d%\n", numTask);

#define pK_Task_exit(c) \
  pthread_exit(NULL);

#define pK_Task_cancel(numTask, nameTask) \
  pthread_cancel(threadsTable[numTask]);

  

#define pK_join(numTask) \
  if (pthread_join(threadsTable[numTask], NULL)) printf("pthread_join  failed: d%\n", numTask); 

#define pK_wait_end(numTask) pK_join(numTask)

#define pK_decl_Task(idTask) \
  static void* idTask(void* void_)

#define ___XXX_PK_XXX___ 0

#define pK_trace(idTask) \
  if (___XXX_PK_XXX___) printf("In thread : %s\n", idTask);


#define pK_Task_resume(numTask, nameTask) 

#define pK_Task_suspend(numTask, nameTask)
