/**
 * Copyright : IRISA / INRIA Rennes - ESPRESSO team This plug-in is under the terms of the CeCILL-B License.
 * http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 * 
 */
package Signal.lib.Java;

import java.io.IOException;
import Signal.lib.Java.pK_complex;
import Signal.lib.Java.pK_complexd;

// class to read inputs
public class KeyboardReader
{
    private boolean eof	= false;

    private void formatExceptionDetected()
    {
	eof = true;
    }

    public int[] readArrayint()
    {
	String s, va;
	int v, newind, lg, i = 0;
	int[] tab;
	int ind = 0;

	s = readLine();
	lg = s.length();
	tab = new int[lg];

	while (ind < lg)
	    {
		newind = s.indexOf(" ", ind);
		va = s.substring(ind, newind);
		ind = newind + 1;

		try
		    {
			v = Integer.parseInt(va);
		    }
		catch (NumberFormatException e)
		    {
			formatExceptionDetected();
			return null;
		    }
		catch (NullPointerException e)
		    {
			eof = true;
			return null;
		    }
		System.out.println(v);
		tab[i] = v;
		i++;
	    }
		
	return tab;
    }

    public void writeArrayInt(int[] s)
    {
	int i = 0;

	while (i < s.length)
	    {
		System.out.print(s[i]);
		System.out.print(" ");
		i++;
	    }
	System.out.println("\tnext:\n");
    }

    private String readLine()
    {
	String s = "";
	boolean b;
	char c;

	try
	    {
		b = true;
		while (b)
		    {
			c = (char) System.in.read();
			if (c == '\n')
			    b = false;
			else
			    s = s + c;
		    }
	    }
	catch (IOException e)
	    {
		eof = true;
	    }
	return s;
    }

    public int readint()
    {
	String s;
	int v;

	s = readLine();
	try
	    {
		v = Integer.parseInt(s);
	    }
	catch (NumberFormatException e)
	    {
		formatExceptionDetected();
		return 0;
	    }
	catch (NullPointerException e)
	    {
		eof = true;
		return 0;
	    }
	return v;
    }

    public short readshort()
    {
	String s;
	short v;
	s = readLine();
	try
	    {
		v = Short.parseShort(s);
	    }
	catch (NumberFormatException e)
	    {
		formatExceptionDetected();
		return (short) 0;
	    }
	catch (NullPointerException e)
	    {
		eof = true;
		return (short) 0;
	    }
	return v;
    }
    /*
     * public short[] readArrayshort () { String s,va; int v,newind,lg,i=0; int[] tab; int ind=0;
     * 
     * s = readLine (); lg=s.length(); tab=new int [lg];
     * 
     * while (ind<lg) { newind=s.indexOf(" ",ind); va =s.substring(ind,newind); ind=newind+1;
     * 
     * try { v = Integer.parseInt (va);} catch ( NumberFormatException e) { formatExceptionDetected(); return null;}
     * catch ( NullPointerException e) { eof = true; return null;} System.out.println(v); tab[i]=v; i++; }
     * 
     * return tab; }
     */

    public char readchar()
    {
	String s;
	char[] v;
	char vc = ' ';
	s = readLine();
	// v = s.toCharArray ();

	try
	    {
		v = s.toCharArray();
	    }
	catch (NumberFormatException e)
	    {
		formatExceptionDetected();
		return (char) 0;
	    }
	catch (NullPointerException e)
	    {
		eof = true;
		return (char) 0;
	    }
	try
	    {
		vc = v[0];
	    }
	catch (IndexOutOfBoundsException e)
	    {
		System.exit(0);
	    }
	return vc;
    }
    /*
     * public char[] readArraychar () { String s,va; int v,newind,lg,i=0; int[] tab; int ind=0;
     * 
     * s = readLine (); lg=s.length(); tab=new int [lg];
     * 
     * while (ind<lg) { newind=s.indexOf(" ",ind); va =s.substring(ind,newind); ind=newind+1;
     * 
     * try { v = Integer.parseInt (va);} catch ( NumberFormatException e) { formatExceptionDetected(); return null;}
     * catch ( NullPointerException e) { eof = true; return null;} System.out.println(v); tab[i]=v; i++; }
     * 
     * return tab; }
     */
    public long readlong()
    {
	String s;
	long v;

	s = readLine();
	try
	    {
		v = Long.parseLong(s);
	    }
	catch (NumberFormatException e)
	    {
		formatExceptionDetected();
		return (long) 0;
	    }
	catch (NullPointerException e)
	    {
		eof = true;
		return (long) 0;
	    }
	return v;
    }
    /*
     * public long[] readArraylong () { String s,va; int v,newind,lg,i=0; int[] tab; int ind=0;
     * 
     * s = readLine (); lg=s.length(); tab=new int [lg];
     * 
     * while (ind<lg) { newind=s.indexOf(" ",ind); va =s.substring(ind,newind); ind=newind+1;
     * 
     * try { v = Integer.parseInt (va);} catch ( NumberFormatException e) { formatExceptionDetected(); return null;}
     * catch ( NullPointerException e) { eof = true; return null;} System.out.println(v); tab[i]=v; i++; }
     * 
     * return tab; }
     */

    public float readfloat()
    {
	String s;
	float v;

	s = readLine();
	try
	    {
		v = Float.parseFloat(s);
	    }
	catch (NumberFormatException e)
	    {
		formatExceptionDetected();
		return (float) 0.;
	    }
	catch (NullPointerException e)
	    {
		eof = true;
		return (float) 0.;
	    }
	return v;
    }
    /*
     * public float[] readArrayfloat () { String s,va; int v,newind,lg,i=0; int[] tab; int ind=0;
     * 
     * s = readLine (); lg=s.length(); tab=new int [lg];
     * 
     * while (ind<lg) { newind=s.indexOf(" ",ind); va =s.substring(ind,newind); ind=newind+1;
     * 
     * try { v = Integer.parseInt (va);} catch ( NumberFormatException e) { formatExceptionDetected(); return null;}
     * catch ( NullPointerException e) { eof = true; return null;} System.out.println(v); tab[i]=v; i++; }
     * 
     * return tab; }
     */

    public double readdouble()
    {
	String s;
	double v;
	s = readLine();
	try
	    {
		v = Double.parseDouble(s);
	    }
	catch (NumberFormatException e)
	    {
		formatExceptionDetected();
		return (double) 0.;
	    }
	catch (NullPointerException e)
	    {
		eof = true;
		return (double) 0.;
	    }
	return v;
    }

    /*
     * public double[] readArraydouble () { String s,va; int v,newind,lg,i=0; int[] tab; int ind=0;
     * 
     * s = readLine (); lg=s.length(); tab=new int [lg];
     * 
     * while (ind<lg) { newind=s.indexOf(" ",ind); va =s.substring(ind,newind); ind=newind+1;
     * 
     * try { v = Integer.parseInt (va);} catch ( NumberFormatException e) { formatExceptionDetected(); return null;}
     * catch ( NullPointerException e) { eof = true; return null;} System.out.println(v); tab[i]=v; i++; }
     * 
     * return tab; }
     */

    public boolean readBool()
    {
	String s;
	boolean v = true;
	s = readLine();
	s = s.trim();
	try
	    {
		v = Boolean.getBoolean(s);
	    }
	catch (NumberFormatException e)
	    {
		formatExceptionDetected();
		return false;
	    }
	catch (NullPointerException e)
	    {
		eof = true;
		return false;
	    }
	return v;
    }

    /*
     * public boolean[] readArrayboolean () { String s,va; int v,newind,lg,i=0; int[] tab; int ind=0;
     * 
     * s = readLine (); lg=s.length(); tab=new int [lg];
     * 
     * while (ind<lg) { newind=s.indexOf(" ",ind); va =s.substring(ind,newind); ind=newind+1;
     * 
     * try { v = Integer.parseInt (va);} catch ( NumberFormatException e) { formatExceptionDetected(); return null;}
     * catch ( NullPointerException e) { eof = true; return null;} System.out.println(v); tab[i]=v; i++; }
     * 
     * return tab; }
     */
    public String readString()
    {
	return readLine();
    }

    public pK_complex readpK_complex()
    {
	String s = readLine();
	int ind = s.indexOf(" ", 0);
	String tmp = s.substring(0, ind);
	float re = Float.parseFloat(tmp);
	tmp = s.substring(ind + 1);
	float im = Float.parseFloat(tmp);
	return new pK_complex(re, im);
    }

    public pK_complexd readpK_complexd()
    {
	String s = readLine();
	int ind = s.indexOf(" ", 0);
	String tmp = s.substring(0, ind);
	double re = Double.parseDouble(tmp);
	tmp = s.substring(ind + 1);
	double im = Double.parseDouble(tmp);

	return new pK_complexd(re, im);
    }

    public boolean isEof()
    {
	return eof;
    }

}
