/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef pK_pK_STRING_H
#define pK_pK_STRING_H

#include "string.h"

#define pK_MAXSTRINGLENGTH_ 256
typedef char pK_String [pK_MAXSTRINGLENGTH_];

/* The strcmp() function  compares  two  strings  byte-by-byte,
   according  to  the ordering of your machine's character set.
   The function returns an integer greater than, equal  to,  or
   less  than  0,  if   the  string pointed to by s1 is greater
   than, equal to, or less than the string  pointed  to  by  s2
   respectively.  The sign of a non-zero return value is deter-
   mined  by the sign of the difference between the  values  of
   the  first  pair  of  bytes that differ in the strings being
   compared. */

#define pK_StringEQ(n,m) (strcmp(n,m) == 0)
#define pK_StringNEQ(n,m) (strcmp(n,m) != 0)
#define pK_StringLT(n,m) (strcmp(n,m) < 0)
#define pK_StringGT(n,m) (strcmp(n,m) > 0)
#define pK_StringLTE(n,m) (strcmp(n,m) <= 0)
#define pK_StringGTE(n,m) (strcmp(n,m) >= 0)


#endif
