module SIGNAL_INTRINSICS=

process _assert_ = (? boolean b; !)
  pragmas 
      Comment "specifies : b ^= when b "
      C_Code    "if (! (&i1)) fprintf(stderr, \"assertion not satisfied : &i1 \\n\") "
      CPP_Code  "if (! (&i1)) cerr << \"assertion not satisfied : &i1 \" << endl"
      Java_Code "if (! (&i1)) System.out.println(\"assertion not satisfied : &i1\") " 
end pragmas
;

process Nil_Process  = (? !)
pragmas 
  Comment "It represents an empty set of equations."
end pragmas
;

process left_tt= (? boolean y,z;! boolean x;)
     (| x := y default (false when ^z) |)
; 

process STATUS=(? INE ! OUT)
     pragmas 
     Comment " State variable specification : (| OUT := X $1 | X := INE when ^INE default OUT |)"
     end pragmas

     (| OUT := X $ 1
      | X := ( INE when ^INE ) default ( OUT $ 1) 
      |)
     where X ;
     end;

 function dim=(? x; !integer v;)
      pragmas 
      Comment " gives the dimension of an array."
     end pragmas  ;	

 function size=(? x; integer I; !integer v;)
      pragmas 
      Comment " gives the size of a dimension. size(x) is equivalent to size(x,1)."
     end pragmas ;	

 function bounds=(? E1,E2,E3; ! X;)
      pragmas 
      Comment "The values of E1 are compelled to evolve between that of E2 and E3."
      C_Code "&o1= (&i1 < &i2) ? &i2 : (&i1 > &i3) ? &i3 : &i1"
      CPP_Code "&o1= (&i1 < &i2) ? &i2 : (&i1 > &i3) ? &i3 : &i1"
     end pragmas 
     %(| X := if (E1 < E2) then E2 else if (E1 > E3) then E3 else E1 |)% 
	;

 function indices=(?integer x0, x1, x2,x3,x4, x5,x6, x7, x8, x9;  !o0, o1, o2,o3,o4, o5,o6, o7, o8,o9)
      pragmas 
      Comment " WARNING : input is list of integers. output is a list of indices with same cardinality of the inputs."
     end pragmas ;	
     

 use MATH_INTRINSICS;
 use IO_INTRINSICS;
 use CONV_INTRINSICS;
 use AFFINECLOCK_INTRINSICS;
 
end;

