module SCREEN_LIB =
   process WSET =
        { integer XN, FN, DY, TS; }
        ( ? integer SCREEN;
            boolean HE;
          ! integer V;
        )
      (| (| V := ACCU_MOD{TS,TS*XN,TS*(FN-1)}(HE)
          | WEFFACE(SCREEN when (^V),V,TS,DY)
          |)/ V
       | V := ACCU_MOD{TS,TS*XN,TS*(XN-1)}(HE)
       |)
      where 
      process ACCU_MOD =
           { integer V_INC, V_BOUND, V_INIT; }
           ( ? boolean HE;
             ! integer V;
           )
         (| V ^= HE
          | ZV := V$ init V_INIT
          | V1 := ZV+V_INC
          | V := (0 when (V1>=V_BOUND)) default V1
          |)
         where 
         integer V1, ZV;
         end
      ; 
      end
   ; 
   process WBOOL =
        { integer Y_POS, BOOL_HEIGHT, DELTA, BOOL_WIDTH; }
        ( ? integer SCREEN;
            boolean C;
            integer X;
        )
      (| H := ^C
       | ECRAN := SCREEN when H
       | (| X0 := X when H
          | X1 := X0+DELTA
          | WHLINE(ECRAN,X0,Y_POS,X1)
          |)
       | (| Y2 := Y_POS+((BOOL_HEIGHT when C) default ((-BOOL_HEIGHT) when (not C)))
          | WVLINE(ECRAN,X1,Y_POS,Y2)
          | X2 := X1+BOOL_WIDTH
          | WHLINE(ECRAN,X1,Y2,X2)
          | WVLINE(ECRAN,X2,Y_POS,Y2)
          |)
       | WHLINE(ECRAN,X2,Y_POS,X2+DELTA)
       |)
      where 
      integer X0, X1, Y2, X2;
      integer ECRAN;
      event H;
      end
   ; 
   process WVLINE =
        ( ? integer SCREEN;
            integer X1;
            integer Y1;
            integer Y2;
        )
        spec (| SCREEN ^= X1 ^= Y1 ^= Y2 |)
   
   ; 
   process WHLINE =
        ( ? integer SCREEN;
            integer X1;
            integer Y1;
            integer X2;
        )
        spec (| SCREEN ^= X1 ^= Y1 ^= X2 |)
   
   ; 
   process WBOTTOM =
        { integer Y_POS, DELTA; }
        ( ? integer SCREEN;
            event H;
            integer X;
        )
      (| H_COMPL := when ((not H) default (^X))
       | ECRAN := SCREEN when H_COMPL
       | X1 := X when H_COMPL
       | WHLINE(ECRAN,X1,Y_POS,X1+DELTA)
       |)
      where 
      integer X1;
      integer ECRAN;
      event H_COMPL;
      end
   ; 
   process WBOOLININTER =
        { integer Y_POS, BOOL_HEIGHT, DELTA, BOOL_WIDTH; }
        ( ? integer SCREEN;
            boolean C;
            boolean S;
            integer X;
        )
      (| WBOTTOM{Y_POS,DELTA+DELTA+BOOL_WIDTH}(SCREEN,^C,X)
       | WBOOL{Y_POS,BOOL_HEIGHT,DELTA,BOOL_WIDTH}(SCREEN,C,X)
       | WSTATE{Y_POS,BOOL_HEIGHT/2,DELTA+DELTA+BOOL_WIDTH}(SCREEN,S,X)
       |)
      where 
      process WSTATE =
           { integer Y_POS, BOOL_HEIGHT, DELTA; }
           ( ? integer SCREEN;
               boolean C;
               integer X;
           )
         (| H := ^C
          | ECRAN := SCREEN when H
          | X1 := X when H
          | X2 := X1+DELTA
          | (| Y11 := (-BOOL_HEIGHT) when C
             | Y12 := BOOL_HEIGHT when (not C)
             | Y1 := Y_POS+(Y11 default Y12)
             | WHLINE(ECRAN,X1,Y1,X2)
             |)
          | (| Y21 := Y11-1
             | Y22 := Y12+1
             | Y2 := Y_POS+(Y21 default Y22)
             | WHLINE(ECRAN,X1,Y2,X2)
             |)
          | (| Y31 := Y21-1
             | Y32 := Y22+1
             | Y3 := Y_POS+(Y31 default Y32)
             | WHLINE(ECRAN,X1,Y3,X2)
             |)
          |)
         where 
         integer X1, X2, Y11, Y12, Y1, Y21, Y22, Y2, Y31, Y32, Y3;
         integer ECRAN;
         event H;
         end
      ; 
      end
   ; 
   process WEFFACE =
        ( ? integer SCREEN;
            integer X1;
            integer DX;
            integer DY;
        )
        spec (| SCREEN ^= X1 ^= DX ^= DY |)
   
   ; 
   process INITSCREEN =
        ( ? event H_0;
            event HE;
          ! integer SCREEN;
        )
      (| ECRAN ^= H_0
       | ECRAN := GET_DISPLAY{}()
       | SCREEN := ECRAN cell HE
       |)
      where 
      integer ECRAN;
      process GET_DISPLAY =
           ( ! integer DESCR;
           )
      
      ; 
      end
   ; 
   process WINT =
        { integer Y_POS, HEIGHT, DELTA, WIDTH, C_min, C_max, STRING_HEIGHT; }
        ( ? integer SCREEN;
            integer C_ret;
            integer C;
            integer X;
        )
      (| H := ^C
       | ECRAN := SCREEN when H
       | X0 := X when H
       | diff := C_max-C_min
       | prop := inttoreal(diff/HEIGHT)
       | Y0 := 0
       | C_aff := (C when ((C<C_max) when (C>C_min))) default (C_max when (not (C<C_max))) default (C_min when (not (C>C_min)))
       | Y1_rel := real(C_aff-C_min)/prop
       | Y1 := realtoint(Y1_rel)
       | X1 := X0+WIDTH+DELTA
       | WRECT(ECRAN,X0,Y0-Y_POS,X1+DELTA,Y1-Y_POS)
       | WSTRING(ECRAN,C_aff,X0,(Y0-Y_POS)-STRING_HEIGHT)
       |)
      where 
      boolean chang;
      event H;
      integer ECRAN;
      integer X0, X1, Y0, Y1, diff, C_ret_aff, C_aff;
      real prop, Y0_rel, Y1_rel;
      function inttoreal =
           ( ? integer x;
             ! real y;
           )
           spec (| y ^= x |)
      
      ; 
      function realtoint =
           ( ? real x;
             ! integer y;
           )
           spec (| y ^= x |)
      
      ; 
      end
   ; 
   process WLINE =
        ( ? integer SCREEN;
            integer X1;
            integer Y1;
            integer X2;
            integer Y2;
        )
        spec (| SCREEN ^= X1 ^= Y1 ^= X2 ^= Y2 |)
   
   ; 
   process WRECT =
        ( ? integer SCREEN;
            integer X1;
            integer Y1;
            integer X2;
            integer Y2;
        )
        spec (| SCREEN ^= X1 ^= Y1 ^= X2 ^= Y2 |)
   
   ; 
   process WSTRING =
        ( ? integer SCREEN;
            integer CH;
            integer X;
            integer Y;
        )
        spec (| SCREEN ^= CH ^= Y ^= X |)
   
   ; 
end %SCREEN_LIB%; 
