#include "TYPES.h"
#include "PRIORITY_ReceiveQueue.h"



/***********************************************************************************/
/***************************   PRIORITY_RECEIVEQUEUE_NODE   ************************/
/***********************************************************************************/


PRIORITY_ReceiveQueueNode:: PRIORITY_ReceiveQueueNode(ProcessID_type Process_ID){
 contents = Process_ID;
 next = NULL;
}

PRIORITY_ReceiveQueueNode::~PRIORITY_ReceiveQueueNode(){}

void PRIORITY_ReceiveQueueNode::setContents(ProcessID_type Process_ID){
 contents = Process_ID;
}

void PRIORITY_ReceiveQueueNode::setNext(ptPRIORITY_ReceiveQueueNode nextNode){
 next = nextNode;
}


ProcessID_type PRIORITY_ReceiveQueueNode::getContents(){
 return contents;
}

ptPRIORITY_ReceiveQueueNode PRIORITY_ReceiveQueueNode::getNext(){
 return next;
}



/***********************************************************************************/
/*****************************   PRIORITY_RECEIVEQUEUE   ***************************/
/***********************************************************************************/



PRIORITY_ReceiveQueue::PRIORITY_ReceiveQueue():first(NULL),last(NULL),max_size(MAX_NUMBER_OF_PROCESSES),current_size(0){}

PRIORITY_ReceiveQueue::PRIORITY_ReceiveQueue(int nbproc):first(NULL),last(NULL),max_size(nbproc),current_size(0){}

PRIORITY_ReceiveQueue::~PRIORITY_ReceiveQueue(){}

int PRIORITY_ReceiveQueue::getCurrentSize(){
 return current_size;
}

void PRIORITY_ReceiveQueue::setFirst(ptPRIORITY_ReceiveQueueNode node){
 first = node;
}

void PRIORITY_ReceiveQueue::setLast(ptPRIORITY_ReceiveQueueNode node){
 last = node;
}

ptPRIORITY_ReceiveQueueNode PRIORITY_ReceiveQueue::getFirst(){
 return first;
}

ptPRIORITY_ReceiveQueueNode PRIORITY_ReceiveQueue::getLast(){
 return last;
}

void PRIORITY_ReceiveQueue::insert(ProcessID_type Process_ID){
 if (current_size < max_size)
   { ptPRIORITY_ReceiveQueueNode new_node = new PRIORITY_ReceiveQueueNode(Process_ID);
     ptPRIORITY_ReceiveQueueNode preview_node = NULL;
     ptPRIORITY_ReceiveQueueNode current_node = first;
  
     if (first == NULL) 
       { first = new_node; last = first;}
     else
       { ProcessID_type current_PID = current_node->getContents();  
         ptPRIORITY_ReceiveQueueNode next_node = current_node->getNext();
         while( (current_PID < Process_ID) && (next_node != NULL) )
           { preview_node = current_node;
             current_node = next_node;
             current_PID = current_node->getContents();
             next_node = current_node->getNext();
           };
  
         if ((next_node == NULL) && (current_PID < Process_ID))
           { current_node->setNext(new_node);
             last = new_node;}
         else
           { if (preview_node != NULL)
               { preview_node->setNext(new_node);
	         new_node->setNext(current_node);}
             else
               { new_node->setNext(current_node);
                 first = new_node;};

           };
       };
     current_size++;
  };
}

void PRIORITY_ReceiveQueue::remove(ProcessID_type& Process_ID){  
 if (!(this->empty()))
   { Process_ID = last->getContents();
     ptPRIORITY_ReceiveQueueNode preview_node = first;
     ptPRIORITY_ReceiveQueueNode current_node = first;
     ptPRIORITY_ReceiveQueueNode next_node = current_node->getNext();

     while(next_node != NULL)
       { preview_node = current_node;
         current_node = next_node;
         next_node = current_node->getNext();
       };
      
     if (current_node != first)
       { preview_node->setNext(NULL);}
     else
       { preview_node = NULL; first = NULL;};
     last = preview_node;
     current_size--;
   };
}

bool PRIORITY_ReceiveQueue::empty(){
 return(first == NULL);
}

bool PRIORITY_ReceiveQueue::full(){
 return( max_size == current_size);
}

void PRIORITY_ReceiveQueue::clean(){
 first = NULL;
 last = NULL;
 current_size =0;
} 

void PRIORITY_ReceiveQueue::printFile(char *result_file){
 FILE *file_out;
 ptPRIORITY_ReceiveQueueNode iter = first;
  
 file_out = fopen(result_file,"wt");
 if (!file_out)
   { fprintf(stderr,"Can not open file %s\n",result_file);
     exit(1);
   };
 while (iter != NULL)
   { fprintf(file_out, "%d\n", iter->getContents());
     iter = iter->getNext();};
 fclose(file_out);
}






