#include "TYPES.h"
#include "PRIORITY_SendQueue.h"



/***********************************************************************************/
/******************************  PRIORITY_SENDQUEUE_NODE  **************************/
/***********************************************************************************/

PRIORITY_SendQueueNode:: PRIORITY_SendQueueNode(ProcMess_type PM):next(NULL)
{
  contents.Proc = PM.Proc;
  contents.Mess = PM.Mess;
}

PRIORITY_SendQueueNode::~PRIORITY_SendQueueNode(){}

void PRIORITY_SendQueueNode::setContents(ProcMess_type PM)
{
  contents.Proc = PM.Proc;
  contents.Mess = PM.Mess;
}

void PRIORITY_SendQueueNode::setNext(ptPRIORITY_SendQueueNode nextNode)
{
 next = nextNode;
}

ProcMess_type PRIORITY_SendQueueNode::getContents()
{
  return contents;
}

ptPRIORITY_SendQueueNode PRIORITY_SendQueueNode:: getNext()
{
  return next;
}


/***********************************************************************************/
/********************************  PRIORITY_SENDQUEUE  *****************************/
/***********************************************************************************/


PRIORITY_SendQueue::PRIORITY_SendQueue():first(NULL),last(NULL),max_size(MAX_NUMBER_OF_PROCESSES),current_size(0){}

PRIORITY_SendQueue::PRIORITY_SendQueue(int nbproc):first(NULL),last(NULL),max_size(nbproc),current_size(0){}

PRIORITY_SendQueue::~PRIORITY_SendQueue() {}

int PRIORITY_SendQueue::getCurrentSize(){
 return current_size;
}

void PRIORITY_SendQueue::setFirst(ptPRIORITY_SendQueueNode node){
 first = node;
}

void PRIORITY_SendQueue::setLast(ptPRIORITY_SendQueueNode node){
 last = node;
}

ptPRIORITY_SendQueueNode PRIORITY_SendQueue::getFirst(){
 return first;
}

ptPRIORITY_SendQueueNode PRIORITY_SendQueue::getLast(){
 return last;
}

//************************************  A verifier ******************************


void PRIORITY_SendQueue::insert(ProcessID_type Process_ID, Message_type Message){ 
 if (current_size < max_size)
   { ProcMess_type PM;
     PM.Proc = Process_ID;
     PM.Mess = Message;
     ptPRIORITY_SendQueueNode new_node = new PRIORITY_SendQueueNode(PM);
     ptPRIORITY_SendQueueNode preview_node = NULL;
     ptPRIORITY_SendQueueNode current_node = first;
  
    if (first == NULL) 
      { first = new_node; last = first;}
    else
      { ProcMess_type current_PM = current_node->getContents();  
        ptPRIORITY_SendQueueNode next_node = current_node->getNext();

        while( (current_PM.Proc < Process_ID) && (next_node != NULL) )
          { preview_node = current_node;
            current_node = next_node;
            current_PM = current_node->getContents();
            next_node = current_node->getNext();
          }
  
        if ((next_node == NULL) && (current_PM.Proc < Process_ID))
          { current_node->setNext(new_node);
            last = new_node;}
        else
          { if (preview_node != NULL)
              { preview_node->setNext(new_node);
	        new_node->setNext(current_node);}
             else
              { new_node->setNext(current_node);
                first = new_node;}
          }
      }
    current_size++;
   }
}

ProcessID_type PRIORITY_SendQueue::remove(Message_type& Message)
{  
  if (!(this->empty()))
    {
      ProcMess_type PM;
      ptPRIORITY_SendQueueNode preview_node = first;
      ptPRIORITY_SendQueueNode current_node = first;
      ptPRIORITY_SendQueueNode next_node = current_node->getNext();
      
      while(next_node != NULL)
	{ 
	  preview_node = current_node;
	  current_node = next_node;
	  next_node = current_node->getNext();
	}
      
      if (current_node != first)
	preview_node->setNext(NULL);
      else
	{ 
	  preview_node = NULL;
	  first = NULL;
	}      
      PM = current_node->getContents();
      last = preview_node;
      current_size--;
      Message = PM.Mess;
      return PM.Proc;
    }
  else
    return UNDEFINED_ProcessID_type;
}

bool PRIORITY_SendQueue::empty(){
 return(first == NULL);
}

bool PRIORITY_SendQueue::full(){
 return( max_size == current_size);
}

void PRIORITY_SendQueue::clean()
{
  first = NULL;
  last = NULL;
  current_size =0;
} 


/*void PRIORITY_SendQueue::printFile(char *result_file){
 FILE *file_out;
 ptPRIORITY_SendQueueNode iter = first;
  
 file_out = fopen(result_file,"wt");
 if (!file_out)
   {
    fprintf(stderr,"Can not open file %s\n",result_file);
    exit(1);
   }
 while (iter != NULL)
   { fprintf(file_out, "%d\n", iter->getContents());
     iter = iter->getNext();}
 fclose(file_out);
}
*/





