#include "TYPES.h"
#include "EventManager.h"




/*********************************   EVENT OBJECT : BEGIN ******************************/

 Event::Event(APEX_Event_type e):event(e){}

/********************************** EVENT MANAGER_NODE  ********************************/

 EventManagerNode::EventManagerNode(EvtAssoc_type value):next(NULL){
   contents.EventID = value.EventID;
   contents.ptrEvent = value.ptrEvent;
 }

 EventManagerNode::EventManagerNode(){}

 EventManagerNode::~EventManagerNode(){}

 void EventManagerNode::setValue(EvtAssoc_type value){
   contents.EventID = value.EventID;
   contents.ptrEvent = value.ptrEvent;
 }

 void EventManagerNode::setNext(ptEventManagerNode ptvalue){ 
  next = ptvalue; }

 EvtAssoc_type EventManagerNode::getValue(){ 
  return contents; }

 ptEventManagerNode EventManagerNode::getNext(){ 
  return next; }


/***************************************  MANAGER  *************************************/


 EventManager::EventManager(int size):first(NULL),last(NULL),max_size(size),current_size(0){}
  
 EventManager::EventManager():first(NULL),last(NULL),max_size(MAX_NUMBER_OF_EVENTS),current_size(0){}

 EventManager::~EventManager(){}

 void EventManager::setFirst(ptEventManagerNode ptvalue){ 
  first = ptvalue; }

 void EventManager::setLast(ptEventManagerNode ptvalue){ 
  last = ptvalue; }

 ptEventManagerNode EventManager::getFirst(){ 
  return first; }

 ptEventManagerNode EventManager::getLast(){ 
  return last; }

 bool EventManager::EventRecord(Comm_ComponentName_type event_Name, Comm_ComponentID_type& eventID){
  if (current_size < max_size)
    { current_size++;
      EvtAssoc_type new_record;
      new_record.EventID = current_size;

      APEX_Event_type event;
      strcpy(event.Event_Name,event_Name);
      event.Event_State = DOWN;
      event.Waiting_Processes = 0;
      for (int i = 0; i < MAX_NUMBER_OF_PROCESSES; i++)
	{ event.Waiting_Queue[i] = false; };

      ptEvent ptsem = new Event(event);      
      new_record.ptrEvent = new Event(event);
      eventID = current_size;

      ptEventManagerNode new_node = new EventManagerNode(new_record);
      if (first == NULL)
        { first = new_node; last = new_node;}
      else
        { ptEventManagerNode iter = first;
          while ( iter != last ) 
               { iter = iter->getNext();};
          if (iter == last)
            { last->setNext(new_node); last = new_node; }

	};
      return true;
    }
  else 
    { return false; };
 }


 bool EventManager::EventCheckName(Comm_ComponentName_type eventName, Comm_ComponentID_type& eventID){
  bool retour;
  if (first == NULL)
    { eventID = NULL; retour = false; }
  else
    { ptEventManagerNode iter = first;
      while ( strcmp ( (((iter->getValue()).ptrEvent)->event).Event_Name, eventName) 
              && (iter != last) ) 
	{ iter = iter->getNext();};
      if (iter == last)
        { if ( strcmp ( (((iter->getValue()).ptrEvent)->event).Event_Name, eventName))
            { eventID = NULL; retour = false; }
          else
            { eventID = (iter->getValue()).EventID; retour = true; }
        }
      else
        { eventID = (iter->getValue()).EventID; retour = true;}
    };
  return retour;
 }


 bool EventManager::EventCheckID(Comm_ComponentID_type eventID, APEX_Event_type& event){
  bool retour;
  if (first == NULL)
    { retour = false; }
  else
    { ptEventManagerNode iter = first;
      while ( ((iter->getValue()).EventID != eventID) && (iter != last) ) 
	{ iter = iter->getNext();};
          if (iter == last)
            { if ( (iter->getValue()).EventID != eventID)
                { retour = false; }
              else
                { event = ((last->getValue()).ptrEvent)->event; retour = true; }
	    }
          else
            { event = ((iter->getValue()).ptrEvent)->event; retour = true;}
    };
  return retour;
 }



void EventManager::EventUpdate(APEX_Event_type event)
{
  bool b;
  APEX_Event_type *x;

  if (first != NULL)
    { ptEventManagerNode iter = first;
    Comm_ComponentName_type name;
    strcpy(name, event.Event_Name);
    while ( strcmp ((((iter->getValue()).ptrEvent)->event).Event_Name, name) && (iter != last) ) 
      { iter = iter->getNext();};
  
    if (iter != last) b= true; else b= !strcmp ((((iter->getValue()).ptrEvent)->event).Event_Name, name);
    if (b)
	{ 
	  x = &(((iter->getValue()).ptrEvent)->event);
	  x->Event_State = event.Event_State; 
	  x->Waiting_Processes = event.Waiting_Processes;
	  for (int i = 0; i < MAX_NUMBER_OF_PROCESSES; i++) x->Waiting_Queue[i] = event.Waiting_Queue[i];
	}
    }
}


bool EventManager::Full()
{ 
  return (max_size ==current_size);
}


 void EventManager::printFile(Comm_ComponentID_type eventID, char *result_file){ 
   FILE *file_out;
   APEX_Event_type evt;
   if (this->EventCheckID(eventID, evt))
     { file_out = fopen(result_file,"wt");
       if (!file_out)
         {
          fprintf(stderr,"Can not open file %s\n",result_file);
          exit(1);
         };    
       fprintf(file_out, "(Event_Identifier : %i, Name : %s, State : %i, Waiting_Processes : %i) \n" ,eventID, evt.Event_Name, evt.Event_State, evt.Waiting_Processes);
       fclose(file_out);
    }
}
