/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#ifndef pK_SIGNAL_PREDEF_H
#define pK_SIGNAL_PREDEF_H

/* Constants */
#undef TRUE
#define TRUE 1
#undef FALSE
#define FALSE 0

typedef int logical;

#include "pK_String.h"
#include "pK_Complex.h"
#include "pK_Conv.h"
#include "pK_stdio.h"

/* == and <== operators for predefined types except complex and string. 
   Complex is not allowed for <== operator. */
#define pK_eqeq_predef(X,Y) (X==Y)
#define pK_ltlteq_predef(X,Y) (X<=Y)


#define polychrony_exception(vstr) printf("%s\n", vstr)

#endif
