/* 
   Authors: Loc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
package SignalLibraries.Java;

public class pK_Obj
{
    /* ------------------result : boolean -------------- */
    public static boolean pK_pK_complex_2_boolean(pK_complex E)
    {
	return (boolean) (((E.re == 0.0) && (E.im == 0.0)) ? false : true);
    }

    public static boolean pK_pK_complexd_2_boolean(pK_complexd E)
    {
	return (boolean) (((E.re == 0.0) && (E.im == 0.0)) ? false : true);
    }

    public static boolean pK_long_2_boolean(long E)
    {
	return (boolean) (((E == 0)) ? false : true);
    }

    /* ------------------result : short -------------- */

    public static short pK_float_2_short(float x)
    {
	return (short) x;
    }

    public static short pK_double_2_short(double x)
    {
	return (short) x;
    }

    public static short pK_pK_complex_2_short(pK_complex E)
    {
	return pK_float_2_short(E.re);
    }

    public static short pK_pK_complexd_2_short(pK_complexd E)
    {
	return pK_double_2_short(E.re);
    }

    /* ------------------result : int -------------- */

    public static int pK_float_2_int(float x)
    {
	return (int) x;
    }

    public static double pK_float_2_double(float x)
    {
	return (double) x;
    }

    public static int pK_double_2_int(double x)
    {
	return (int) x;
    }

    public static float pK_double_2_float(double x)
    {
	return (float) x;
    }

    public static int pK_int_2_int(int x)
    {
	return x;
    }

    public static int pK_pK_complex_2_int(pK_complex E)
    {
	return pK_float_2_int(E.re);
    }

    /* ------------------result : long -------------- */
    public static long pK_double_2_long(double x)
    {
	return (long) x;
    }

    public static long pK_float_2_long(float x)
    {
	return (long) x;
    }

    public static long pK_pK_complex_2_long(pK_complex E)
    {
	return pK_float_2_long(E.re);
    }

    public static long pK_pK_complexd_2_long(pK_complexd E)
    {
	return pK_double_2_long(E.re);
    }

    /* ------------------result : float -------------- */

    public static float pK_pK_complex_2_float(pK_complex E)
    {
	return (float) (E.re);
    }

    public static float pK_pK_complexd_2_float(pK_complexd E)
    {
	return (float) (E.re);
    }

    /* ------------------result : double -------------- */
    public static double pK_pK_complex_2_double(pK_complex E)
    {
	return (double) (E.re);
    }

    public static double pK_pK_complexd_2_double(pK_complexd E)
    {
	return (double) (E.re);
    }

    /* ------------------result : complex -------------- */
    public static pK_complex pK_boolean_2_pK_complex(boolean E)
    {
	pK_complex S = new pK_complex();
	S.re = (E ? 1 : 0);
	S.im = 0;
	return S;
    }

    public static pK_complex pK_short_2_pK_complex(short E)
    {
	pK_complex S = new pK_complex();
	S.re = (float) E;
	S.im = 0;
	return S;
    }

    public static pK_complex pK_int_2_pK_complex(int E)
    {
	pK_complex S = new pK_complex();
	S.re = (float) E;
	S.im = 0;
	return S;
    }

    public static pK_complex pK_long_2_pK_complex(long E)
    {
	pK_complex S = new pK_complex();
	S.re = (float) E;
	S.im = 0;
	return S;
    }

    public static pK_complex pK_float_2_pK_complex(float E)
    {
	pK_complex S = new pK_complex();
	S.re = E;
	S.im = 0;
	return S;
    }

    public static pK_complex pK_double_2_pK_complex(double E)
    {
	pK_complex S = new pK_complex();
	S.re = (float) E;
	S.im = 0;
	return S;
    }

    public static pK_complex pK_pK_complexd_2_pK_complex(pK_complexd E)
    {
	pK_complex S = new pK_complex();
	S.re = (float) (E.re);
	S.im = (float) (E.im);
	return S;
    }

    /* ------------------result : double complex -------------- */
    public static pK_complexd pK_boolean_2_pK_complexd(boolean E)
    {
	pK_complexd S = new pK_complexd();
	S.re = (E ? 1.0 : 0.0);
	S.im = 0.0;
	return S;
    }

    public static pK_complexd pK_short_2_pK_complexd(short E)
    {
	pK_complexd S = new pK_complexd();
	S.re = (double) E;
	S.im = 0.0;
	return S;
    }

    public static pK_complexd pK_int_2_pK_complexd(int E)
    {
	pK_complexd S = new pK_complexd();
	S.re = (double) E;
	S.im = 0.0;
	return S;
    }

    public static double pK_int_2_double(int E)
    {
	return (double) E;
    }

    public static float pK_int_2_float(int E)
    {
	return (float) E;
    }

    public static pK_complexd pK_long_2_pK_complexd(long E)
    {
	pK_complexd S = new pK_complexd();
	S.re = (double) E;
	S.im = 0.0;
	return S;
    }

    public static pK_complexd pK_float_2_pK_complexd(float E)
    {
	pK_complexd S = new pK_complexd();
	S.re = (double) E;
	S.im = 0.0;
	return S;
    }

    public static pK_complexd pK_double_2_pK_complexd(double E)
    {
	pK_complexd S = new pK_complexd();
	S.re = E;
	S.im = 0.0;
	return S;
    }

    public static pK_complexd pK_pK_complex_2_pK_complexd(pK_complex E)
    {
	pK_complexd S = new pK_complexd();
	S.re = (double) (E.re);
	S.im = (double) (E.im);
	return S;
    }

    public static char pK_short_2_char(short x)
    {
	/*
	 * ISO-Latin9 coding, after the ISO-Latin1, allows to encode many characters such that glued "oe", euro symbol, sur 8 bits (like in ISO-Latin1) -
	 * The Ascii encoding is on 7 bits. It perhaps exists a norm on 16 bits allowing to ancode all the characters of the wold.
	 */
	return ((char) x);
    }

    public static int pK_int_2_int(pK_complexd E)
    {
	return pK_double_2_int(E.re);
    }

    public static short pK_char_2_short(char x)
    {
	return ((short) x);
    }

    public static pK_complex pK_char_2_pK_complex(char x)
    {
	short sh;
	sh = pK_char_2_short(x);
	return pK_short_2_pK_complex(sh);
    }

    public static int pK_enum_2_int(int a)
    {
	return a;
    }

}
