/*
   Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - EPL License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).

   Polychrony SME Platform is free software; you can redistribute it and/or modify it under
   the terms of the EPL as published by the Eclipse Foundation.

   Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the Eclipse Public License - v 1.0 for more details.

   You should have received a copy of the Eclipse Public License - v 1.0
   along with Polychrony SME Platform; see the file COPYING. If not, consult the url
   http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse Foundation, Inc.
   102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

#include "console.h"

/**
 * GUI Specific.
 * Does nothing.
 */
extern void sysgraph(int left, ptreg str)
{
}

/**
 * Writing a new line on the screen.
 */
extern void sysscreenln()
{
	printNewLineToConsole();
}

/**
 * Writing on the console left spaces following by the str string.
 */
extern void sysscreen(int left, ptreg str)
{
	char *text;
	int len, lg, i;

	len = strregsize(str);
	lg = len*(sizeof(char))+left+1;
	text = (char*) malloc(lg);
	if (left != 0)
		for (i = 1; i <= left; i++)
			text[i-1] = ' ';
	for (i=1; i<=len; i++)
		text[i+left-1] = strreggetchar(str, i);
	text[lg-1] = '\0'; // a NULL character is set

	printTextToConsole(text);
}

