/*
   Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - EPL License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).

   Polychrony SME Platform is free software; you can redistribute it and/or modify it under
   the terms of the EPL as published by the Eclipse Foundation.

   Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the Eclipse Public License - v 1.0 for more details.

   You should have received a copy of the Eclipse Public License - v 1.0
   along with Polychrony SME Platform; see the file COPYING. If not, consult the url
   http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse Foundation, Inc.
   102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

static ptOptionManager OM;
static ptBatchCompiler BC;

static char* copyString(const char *str, int size)
{
	char * c_name;
	int i;
	c_name = (char*)malloc (size+1);
	for (i =0; i < size; i++)
		c_name[i] = str[i];
	c_name[size] = '\0';
	return c_name;
}

static char* jstring2CString(jstring javaString, JNIEnv *env)
{
	const char *str = (env)->GetStringUTFChars(javaString, 0);
	int size = (env)->GetStringUTFLength(javaString);
	char* c_name= copyString(str, size);

	env->ReleaseStringUTFChars(javaString, str);
	env->DeleteLocalRef(javaString);
	return c_name;
}
