/*
   Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - EPL License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).

   Polychrony SME Platform is free software; you can redistribute it and/or modify it under
   the terms of the EPL as published by the Eclipse Foundation.

   Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the Eclipse Public License - v 1.0 for more details.

   You should have received a copy of the Eclipse Public License - v 1.0
   along with Polychrony SME Platform; see the file COPYING. If not, consult the url
   http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse Foundation, Inc.
   102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalParser
 * Method:    init
 * Signature: ()V
 */

#include <cstdlib>

JNIEXPORT void JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalParser_init(JNIEnv * env, jobject obj)
{
	setJNIEnv(env);
	parserFileName = sysGetnameTempfile();
}

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalParser
 * Method:    parseParamfile
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalParser_parseParamfile(JNIEnv * env, jobject obj, jstring filename)
{
	setJNIEnv(env);
	ntrees result;
	if(SIGNALParseParamfile( jstring2CString(filename, env), &result)) return (jlong) result;
	return (jlong) ERROR_NODE;
}

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalParser
 * Method:    parseSrcfile
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalParser_parseSrcfile(JNIEnv * env, jobject obj, jstring filename)
{
  ntrees result;
  boolean b;
  setJNIEnv(env);
  if(SIGNALParseSrcfile( jstring2CString(filename, env), &result, &b)) return (jlong) result;
  return (jlong) ERROR_NODE;
}

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalParser
 * Method:    sysParser
 * Signature: (ILjava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalParser_sysParser(JNIEnv * env, jobject obj, jint phylum, jstring filename)
{
	setJNIEnv(env);
	ntrees result;
	if(sysparser((integer)phylum, jstring2CString(filename, env), &result)) return (jlong) result;
	return (jlong) ERROR_NODE;
}

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalParser
 * Method:    parseString
 * Signature: (ILjava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalParser_parseString(JNIEnv * env, jobject obj, jint phylum, jstring expression)
{
	setJNIEnv(env);
	ntrees result;
	if (mkParserFile(env, expression) && sysparser((integer)phylum, parserFileName, &result)) return (jlong) result;
	return (jlong) ERROR_NODE;
}
