/*
   Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - EPL License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).

   Polychrony SME Platform is free software; you can redistribute it and/or modify it under
   the terms of the EPL as published by the Eclipse Foundation.

   Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the Eclipse Public License - v 1.0 for more details.

   You should have received a copy of the Eclipse Public License - v 1.0
   along with Polychrony SME Platform; see the file COPYING. If not, consult the url
   http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse Foundation, Inc.
   102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

#include <jni.h>
#include "SignalTreeComment.h"

/**
 * Copyright : IRISA / INRIA Rennes - ESPRESSO team. This plug-in is under the terms of the EPL License.
 * http://www.eclipse.org/org/documents/epl-v10.html
 * 
 * @author Christian Brunette
 */

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalTreeComment
 * Method:    addComment
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalTreeComment_addComment(JNIEnv *env, jobject obj, jlong node, jlong commentNode)
{
  STree_addComment((ntrees)node, (ntrees)commentNode, true);
}

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalTreeComment
 * Method:    addStrComment
 * Signature: (ILjava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalTreeComment_addStrComment(JNIEnv *env, jobject obj,jlong node, jstring comment)
{
  STree_addStrComment((ntrees) node, jstring2str(comment, env), true);
}

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalTreeComment
 * Method:    getComment
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalTreeComment_getComment(JNIEnv *env, jobject obj,jlong node)
{
   ntrees varb;
   if(STree_getComment((ntrees)node, true, &varb)) return (jlong)varb;
   return (jlong)ERROR_NODE;  
}

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalTreeComment
 * Method:    getAnnotations
 * Signature: (LL)L
 */
JNIEXPORT jlong JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalTreeComment_getAnnotations(JNIEnv *env, jobject obj, jlong t, jlong l)
{
  return (jlong)STree_getVMAnnotations((ntrees)t, (ntrees)l);
}

/*
 * Class:     fr_irisa_espresso_sme_polychrony_SignalTreeComment
 * Method:    getAnnotation
 * Signature: (L)L
 */
JNIEXPORT jlong JNICALL Java_fr_irisa_espresso_sme_polychrony_SignalTreeComment_getAnnotation (JNIEnv *env, jobject obj, jlong t)
{
  return (jlong)STree_getVMAnnotation((ntrees)t);
}
