/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.polychrony;

/**
 * Class for containing the return of tree2IGraph method declared in PKServices.
 */
public class GraphValue {
	/** The return code of the tree2IGraph operation */
	private int		returnCode;
	/** The generated graph */
	private long	graph;
	
	/**
	 * @param returnCode
	 *        the return code of the tree2IGraph operation
	 * @param graph
	 *        the generated graph
	 */
	public GraphValue(int returnCode, long graph) {
		this.setReturnCode(returnCode);
		this.setGraph(graph);
	}
	
	public void setGraph(long graph) {
		this.graph = graph;
	}
	
	public long getGraph() {
		return graph;
	}
	
	public void setReturnCode(int returnCode) {
		this.returnCode = returnCode;
	}
	
	public int getReturnCode() {
		return returnCode;
	}
}
