/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.polychrony;

public class PKOptionManager {
	public PKOptionManager() {
		setOptGenDot(false);
		setOptAlwaysCode(false);
		setOptDelayMultiplexing(false);
		setOptDelayOptimizing(false);
		setOptSubstitute(1);
		setOptExclusiveClock(false, 2);
		setOptTestFunctionality(false);
		setOptClustering(false);
		setOptUnification(false);
		setOptGenCBody(false);
		setOptGenCMain(false);
		setOptGenCIO(false);
		setOptGenCModules(false);
		setOptGenCPPBody(false);
		setOptGenCPPMain(false);
		setOptGenCPPIO(false);
		setOptGenCPPModules(false);
		setOptGenJava(false);
		setOptGenJavaBody(false);
		setOptGenJavaMain(false);
		setOptGenThreads(false);
		setOptGenJavaIO(false);
		setOptGenJavaModules(false);
		setOptGenList(false);
		setOptGenTrace(false);
		setOptGenFlatTrace(false);
		setOptGenz3z(false);
		setOptGenSyndex(false);
		setOptSeparateBooleansOthers(false);
		setOptSeparateStatesOthers(false);
		setOptUserPartitioning(false);
		setOptVerbose(false);
		setOptStat(false);
		setOptWarn(false);
		setOptDebug(false);
		setOptCrew(false);
		setOptSolvingDepth(5);
		setOptGenBF(false);
		setOptGenSBF(false);
		setOptGenFBF(false);
		setOptRetiming(false);
		setOptAbstraction(false);
		setOptKernel(false);
		setOptProfiling(false);
		setOptCheck(false);
		setOptGenLustre(false);
		setOptGenDistrib(false);
		setOptXMI(false);
		setOptSynoptic(false);
		setOptTraceabilityMode(false);
		setOptHeader(false);
	}
	
	public synchronized native void setOptGenDot(boolean b);
	
	public synchronized native void setOptAlwaysCode(boolean b);
	
	public synchronized native void setOptDelayMultiplexing(boolean b);
	
	public synchronized native void setOptDelayOptimizing(boolean b);
	
	public synchronized native void setOptSubstitute(int value);
	
	public synchronized native void setOptExclusiveClock(boolean b, int vlevel);
	
	public synchronized native void setOptTestFunctionality(boolean b);
	
	public synchronized native void setOptClustering(boolean b);
	
	public synchronized native void setOptUnification(boolean b);
	
	public synchronized native void setOptGenCBody(boolean b);
	
	public synchronized native void setOptGenCMain(boolean b);
	
	public synchronized native void setOptGenCIO(boolean b);
	
	public synchronized native void setOptGenCModules(boolean b);
	
	public synchronized native void setOptGenCPPBody(boolean b);
	
	public synchronized native void setOptGenCPPMain(boolean b);
	
	public synchronized native void setOptGenCPPIO(boolean b);
	
	public synchronized native void setOptGenCPPModules(boolean b);
	
	public synchronized native void setOptGenJava(boolean b);
	
	public synchronized native void setOptGenJavaBody(boolean b);
	
	public synchronized native void setOptGenJavaMain(boolean b);
	
	public synchronized native void setOptGenThreads(boolean b);
	
	public synchronized native void setOptGenJavaIO(boolean b);
	
	public synchronized native void setOptGenJavaModules(boolean b);
	
	public synchronized native void setOptGenList(boolean b);
	
	public synchronized native void setOptGenTrace(boolean b);
	
	public synchronized native void setOptGenFlatTrace(boolean b);
	
	public synchronized native void setOptGenz3z(boolean b);
	
	public synchronized native void setOptGenSyndex(boolean b);
	
	public synchronized native void setOptSeparateBooleansOthers(boolean b);
	
	public synchronized native void setOptSeparateStatesOthers(boolean b);
	
	public synchronized native void setOptUserPartitioning(boolean b);
	
	public synchronized native void setOptVerbose(boolean b);
	
	public synchronized native void setOptStat(boolean b);
	
	public synchronized native void setOptWarn(boolean b);
	
	public synchronized native void setOptDebug(boolean b);
	
	public synchronized native void setOptCrew(boolean b);
	
	public synchronized native void setOptSolvingDepth(int depth);
	
	public synchronized native void setOptGenBF(boolean b);
	
	public synchronized native void setOptGenSBF(boolean b);
	
	public synchronized native void setOptGenFBF(boolean b);
	
	public synchronized native void setOptRetiming(boolean b);
	
	public synchronized native void setOptAbstraction(boolean b);
	
	public synchronized native void setOptKernel(boolean b);
	
	public synchronized native void setOptProfiling(boolean b);
	
	public synchronized native void setOptCheck(boolean b);
	
	public synchronized native void setOptGenLustre(boolean b);
	
	public synchronized native void setOptGenDistrib(boolean b);
	
	public synchronized native void setOptXMI(boolean b);
	
	public synchronized native void setOptSynoptic(boolean b);
	
	public synchronized native void setOptTraceabilityMode(boolean b);
	
	public synchronized native void setOptHeader(boolean b);
	
	public synchronized native int compile(long graph, String outputFileName);
}
