/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.polychrony.traceability;

/**
 * This class contains all the warning messages displayable on the diagram that don't come directly from the compiler.
 */
public class WarningMessages {
	/*
	 * 3 general Messages used in at least 2 different classes
	 */
	public static final String	SOURCE_FIELD							= "The 'Src Field' attribute is useless when the source of the link is not a signal.";
	public static final String	DESTINATION_FIELD						= "The 'Dst Field' attribute is useless when the target of the link is not a signal.";
	public static final String	NO_SIGNAL_TYPE							= "No type defined for the signal : ";
	
	/*
	 * 18 specific messages used in one particular class
	 */
	public static final String	AND_STATE_SUB_STATES_NUMBER				= "An And State must have at least 2 sub-states.";
	public static final String	AUTOMATON_NO_SUB_STATE					= "The Automaton does not contain any sub-state : ";
	public static final String	AUTOMATON_INIT_STATE_NOT_SET			= "The initial state of the Automaton is not set. The first state inserted will be used as initial state : ";
	public static final String	CASE_CONNECTION_INTERVALS				= "Intervals for process choice are not fully implemented in the compiler yet.";
	public static final String	CONSTANT_AFFECTATION_SRC_FIELD			= "The 'Src Field' attribute is useless when the source of the link is not a constant.";
	public static final String	CONSTANT_VALUE_UNDEFINED_TYPE			= "No type defined for the Constant Value : ";
	public static final String	DATAFLOW_CONNECTION_IS_DEFAULT_VALUE	= "The 'Is Default Value' attribute is not used here. Use it only when the destination of the connection is a signal or a reference on a signal.";
	public static final String	ENUMERATION_TYPE_UNDEFINED_ENUM			= "The enumeration is not defined. The 'Enumerated Value' attribute is empty.";
	public static final String	IFTHENELSE_CLOCK_RELATION				= "The Input Ports of the If-Then-Else operator cannot be the source or the target of a Clock Relation link : ";
	public static final String	INPUT_PORT_SOURCE						= "The Input Port cannot be used as the source of a Clock Relation link.";
	public static final String	INPUT_PORT_TARGET						= "An Input Port of a dataflow operator or iteration block cannot be used as the target of a Clock Relation link.";
	public static final String	INPUT_PORT_DATAFLOW_TARGET				= "An Input Port of a clock operator cannot be used as the target of a Dataflow Connection link.";
	public static final String	MODEL_INSTANCE_PARAMETER_ATTRIBUTE		= "The referred parameter attribute is useless when the referred interface is not a model type.";
	public static final String	PARAMETER_NO_TYPE						= "No type defined for the parameter : ";
	public static final String	SIGNAL_REF_NOT_NEEDED					= "The Signal Reference is useless : ";
	public static final String	TRANSITION_GUARD						= "No 'Guard' is defined for the transition : ";
	public static final String	USE_MODULE_EMPTY_LIST					= "The list of used modules is empty.";
	public static final String	WINDOW_UNDEFINED_SIZE					= "There is no Window Size value defined. We use the default value : ";
}
