/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.provider;

import java.util.Collection;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import fr.irisa.espresso.sme.CartesianProduct;
import fr.irisa.espresso.sme.DataflowConnection;
import fr.irisa.espresso.sme.DataflowConnector;
import fr.irisa.espresso.sme.DataflowOperator;
import fr.irisa.espresso.sme.ModelInstance;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalExpr;
import fr.irisa.espresso.sme.SignalOperator;
import fr.irisa.espresso.sme.SmePackage;

/**
 * This is the item provider adapter for a {@link fr.irisa.espresso.sme.DataflowConnection} object. <!-- begin-user-doc
 * --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class DataflowConnectionItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public DataflowConnectionItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}
	
	/**
	 * This returns the property descriptors for the adapted class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);
			
			addNamePropertyDescriptor(object);
			addIsDefaultValuePropertyDescriptor(object);
			addCastTypePropertyDescriptor(object);
			addUseSrcClockPropertyDescriptor(object);
			addUseLastIterationValuePropertyDescriptor(object);
			addSrcPropertyDescriptor(object);
			addDstPropertyDescriptor(object);
			addSrcFieldPropertyDescriptor(object);
			addDstFieldPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}
	
	/**
	 * This adds a property descriptor for the Name feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_NamedElement_name_feature"),
			getString("_UI_NamedElement_name_description"), SmePackage.Literals.NAMED_ELEMENT__NAME, true, false,
			false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Is Default Value feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addIsDefaultValuePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DataflowConnection_isDefaultValue_feature"),
			getString("_UI_DataflowConnection_isDefaultValue_description"),
			SmePackage.Literals.DATAFLOW_CONNECTION__IS_DEFAULT_VALUE, true, false, false,
			ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE, getString("_UI_ExpertPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Cast Type feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addCastTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_DataflowConnection_castType_feature"),
			getString("_UI_DataflowConnection_castType_description"),
			SmePackage.Literals.DATAFLOW_CONNECTION__CAST_TYPE, true, false, false,
			ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_ExpertPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Use Src Clock feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addUseSrcClockPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DataflowConnection_useSrcClock_feature"),
			getString("_UI_DataflowConnection_useSrcClock_description"),
			SmePackage.Literals.DATAFLOW_CONNECTION__USE_SRC_CLOCK, true, false, false,
			ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE, getString("_UI_ExpertPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Use Last Iteration Value feature. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addUseLastIterationValuePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DataflowConnection_useLastIterationValue_feature"),
			getString("_UI_DataflowConnection_useLastIterationValue_description"),
			SmePackage.Literals.DATAFLOW_CONNECTION__USE_LAST_ITERATION_VALUE, true, false, false,
			ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE, getString("_UI_ExpertPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Src feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	protected void addSrcPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(new ItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_DataflowConnection_src_feature"),
			getString("_UI_DataflowConnection_src_description"), SmePackage.Literals.DATAFLOW_CONNECTION__SRC, true,
			false, true, null, getString("_UI_SourceTargetPropertyCategory"), null) {
			protected Collection<?> getComboBoxObjects(Object object) {
				SignalContainer parent = ((DataflowConnection) object).getParent();
				if (parent == null)
					return Collections.EMPTY_LIST;
				
				EList<SignalExpr> result = new BasicEList<SignalExpr>();
				for (EObject obj : parent.eContents()) {
					if (obj instanceof ModelInstance) {
						result.addAll(((ModelInstance) obj).getVisibleConstants());
						result.addAll(((ModelInstance) obj).getVisibleSignals());
					}
					else if (obj instanceof CartesianProduct)
						result.addAll(((CartesianProduct) obj).getOuts());
					else if (obj instanceof SignalExpr)
						result.add((SignalExpr) obj);
				}
				return result;
			}
		});
	}
	
	/**
	 * This adds a property descriptor for the Dst feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	protected void addDstPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(new ItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_DataflowConnection_dst_feature"),
			getString("_UI_DataflowConnection_dst_description"), SmePackage.Literals.DATAFLOW_CONNECTION__DST, true,
			false, true, null, getString("_UI_SourceTargetPropertyCategory"), null) {
			protected Collection<?> getComboBoxObjects(Object object) {
				SignalContainer parent = ((DataflowConnection) object).getParent();
				if (parent == null)
					return Collections.EMPTY_LIST;
				
				EList<DataflowConnector> result = new BasicEList<DataflowConnector>();
				for (EObject obj : parent.eContents()) {
					if (obj instanceof ModelInstance)
						result.addAll(((ModelInstance) obj).getInputs());
					else if (obj instanceof SignalOperator && obj instanceof DataflowOperator)
						result.addAll(((SignalOperator) obj).getInputPorts());
					else if (obj instanceof DataflowConnector)
						result.add((DataflowConnector) obj);
				}
				return result;
			}
		});
	}
	
	/**
	 * This adds a property descriptor for the Src Field feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addSrcFieldPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_DataflowConnection_srcField_feature"),
			getString("_UI_DataflowConnection_srcField_description"),
			SmePackage.Literals.DATAFLOW_CONNECTION__SRC_FIELD, true, false, false,
			ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_SourceTargetPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Field feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDstFieldPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_DataflowConnection_dstField_feature"),
			getString("_UI_DataflowConnection_dstField_description"),
			SmePackage.Literals.DATAFLOW_CONNECTION__DST_FIELD, true, false, false,
			ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_SourceTargetPropertyCategory"), null));
	}
	
	/**
	 * This returns DataflowConnection.gif. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/DataflowConnection"));
	}
	
	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((DataflowConnection) object).getName();
		return label == null || label.length() == 0 ? getString("_UI_DataflowConnection_type")
				: getString("_UI_DataflowConnection_type") + " " + label;
	}
	
	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached children and by creating
	 * a viewer notification, which it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		
		switch (notification.getFeatureID(DataflowConnection.class)) {
			case SmePackage.DATAFLOW_CONNECTION__NAME:
			case SmePackage.DATAFLOW_CONNECTION__IS_DEFAULT_VALUE:
			case SmePackage.DATAFLOW_CONNECTION__CAST_TYPE:
			case SmePackage.DATAFLOW_CONNECTION__USE_SRC_CLOCK:
			case SmePackage.DATAFLOW_CONNECTION__USE_LAST_ITERATION_VALUE:
			case SmePackage.DATAFLOW_CONNECTION__SRC:
			case SmePackage.DATAFLOW_CONNECTION__DST:
			case SmePackage.DATAFLOW_CONNECTION__SRC_FIELD:
			case SmePackage.DATAFLOW_CONNECTION__DST_FIELD:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}
	
	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children that can be created
	 * under this object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}
	
	/**
	 * Return the resource locator for this item provider's resources. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return SmeEditPlugin.INSTANCE;
	}
	
}
