/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.provider;

import java.util.Collection;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import fr.irisa.espresso.sme.ConstantOrRef;
import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.InterfaceDefinition;
import fr.irisa.espresso.sme.ModelInstance;
import fr.irisa.espresso.sme.ModelType;
import fr.irisa.espresso.sme.Parameter;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SmePackage;

/**
 * This is the item provider adapter for a {@link fr.irisa.espresso.sme.ModelInstance} object. <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * 
 * @generated
 */
public class ModelInstanceItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ModelInstanceItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}
	
	/**
	 * This returns the property descriptors for the adapted class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);
			
			addSrc_ClockRelationsPropertyDescriptor(object);
			addDst_ClockRelationsPropertyDescriptor(object);
			addNamePropertyDescriptor(object);
			addCommentPropertyDescriptor(object);
			addSrc_DependencesPropertyDescriptor(object);
			addDst_DependencesPropertyDescriptor(object);
			addReferredInterfacePropertyDescriptor(object);
			addReferredParameterPropertyDescriptor(object);
			addInputsPropertyDescriptor(object);
			addOutputsPropertyDescriptor(object);
			addParametersPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}
	
	/**
	 * This adds a property descriptor for the Src Clock Relations feature. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected void addSrc_ClockRelationsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_ClockedExpr_src_ClockRelations_feature"),
			getString("_UI_ClockedExpr_src_ClockRelations_description"),
			SmePackage.Literals.CLOCKED_EXPR__SRC_CLOCK_RELATIONS, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Clock Relations feature. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected void addDst_ClockRelationsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_ClockedExpr_dst_ClockRelations_feature"),
			getString("_UI_ClockedExpr_dst_ClockRelations_description"),
			SmePackage.Literals.CLOCKED_EXPR__DST_CLOCK_RELATIONS, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Name feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_NamedElement_name_feature"),
			getString("_UI_NamedElement_name_description"), SmePackage.Literals.NAMED_ELEMENT__NAME, true, false,
			false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Comment feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addCommentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_Identifier_comment_feature"), getString(
			"_UI_PropertyDescriptor_description", "_UI_Identifier_comment_feature", "_UI_Identifier_type"),
			SmePackage.Literals.IDENTIFIER__COMMENT, true, true, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
			getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Src Dependences feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addSrc_DependencesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DependenceInOut_src_Dependences_feature"),
			getString("_UI_DependenceInOut_src_Dependences_description"),
			SmePackage.Literals.DEPENDENCE_IN_OUT__SRC_DEPENDENCES, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Dependences feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDst_DependencesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DependenceInOut_dst_Dependences_feature"),
			getString("_UI_DependenceInOut_dst_Dependences_description"),
			SmePackage.Literals.DEPENDENCE_IN_OUT__DST_DEPENDENCES, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Referred Interface feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	protected void addReferredInterfacePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(new ItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_ModelInstance_referredInterface_feature"), getString("_UI_PropertyDescriptor_description",
				"_UI_ModelInstance_referredInterface_feature", "_UI_ModelInstance_type"),
			SmePackage.Literals.MODEL_INSTANCE__REFERRED_INTERFACE, true, false, false, null,
			getString("_UI_InstantiationPropertyCategory"), null) {
			protected Collection<?> getComboBoxObjects(Object object) {
				List<InterfaceDefinition> sortedList = new LinkedList<InterfaceDefinition>();
				
				// And we add all type declaration which are in the scope of the model type.
				SignalContainer parent = ((ModelInstance) object).getParent();
				if (parent != null) {
					EList<Identifier> vt = parent.getVisibleTypes();
					for (Identifier id : vt) {
						if (id instanceof ModelType)
							sortedList.add((ModelType) id);
					}
					sortedList.addAll(parent.getVisibleModelProcesses());
				}
				return sortedList;
			}
		});
	}
	
	/**
	 * This adds a property descriptor for the Referred Parameter feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	protected void addReferredParameterPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(new ItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_ModelInstance_referredParameter_feature"), getString("_UI_PropertyDescriptor_description",
				"_UI_ModelInstance_referredParameter_feature", "_UI_ModelInstance_type"),
			SmePackage.Literals.MODEL_INSTANCE__REFERRED_PARAMETER, true, false, false, null,
			getString("_UI_InstantiationPropertyCategory"), null) {
			protected Collection<?> getComboBoxObjects(Object object) {
				ModelInstance mi = (ModelInstance) object;
				InterfaceDefinition id = mi.getReferredInterface();
				
				if (id instanceof ModelType) {
					// The referred interface is a type of model, so we need a parameter to instantiate it
					List<String> sortedList = new LinkedList<String>();
					
					// We add the empty string to allow delete the field
					sortedList.add(0, "");
					
					// And we add all type declaration which are in the scope of the local signal.
					SignalContainer parent = mi.getParent();
					if (parent != null) {
						EList<ConstantOrRef> vt = parent.getVisibleConstants();
						String mTypeLit = ((ModelType) id).getModelType().getLiteral();
						for (ConstantOrRef cor : vt) {
							if (cor instanceof Parameter && ((Parameter) cor).getType() == mTypeLit)
								SmeUtils.addToList(sortedList, ((Parameter) cor).getName());
						}
					}
					return sortedList;
				}
				else
					// The referred interface is a model process so we need no parameter
					return Collections.EMPTY_LIST;
			}
		});
	}
	
	/**
	 * This adds a property descriptor for the Inputs feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addInputsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_ModelInstance_inputs_feature"),
			getString("_UI_ModelInstance_inputs_description"), SmePackage.Literals.MODEL_INSTANCE__INPUTS, false,
			false, false, null, getString("_UI_PortsPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Outputs feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addOutputsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_ModelInstance_outputs_feature"),
			getString("_UI_ModelInstance_outputs_description"), SmePackage.Literals.MODEL_INSTANCE__OUTPUTS, false,
			false, false, null, getString("_UI_PortsPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Parameters feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addParametersPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_ModelInstance_parameters_feature"),
			getString("_UI_ModelInstance_parameters_description"), SmePackage.Literals.MODEL_INSTANCE__PARAMETERS,
			false, false, false, null, getString("_UI_PortsPropertyCategory"), null));
	}
	
	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(SmePackage.Literals.MODEL_INSTANCE__INPUTS);
			childrenFeatures.add(SmePackage.Literals.MODEL_INSTANCE__OUTPUTS);
			childrenFeatures.add(SmePackage.Literals.MODEL_INSTANCE__PARAMETERS);
		}
		return childrenFeatures;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.
		
		return super.getChildFeature(object, child);
	}
	
	/**
	 * This returns ModelInstance.gif. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ModelInstance"));
	}
	
	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((ModelInstance) object).getName();
		return label == null || label.length() == 0 ? getString("_UI_ModelInstance_type")
				: getString("_UI_ModelInstance_type") + " " + label;
	}
	
	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached children and by creating
	 * a viewer notification, which it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		
		switch (notification.getFeatureID(ModelInstance.class)) {
			case SmePackage.MODEL_INSTANCE__NAME:
			case SmePackage.MODEL_INSTANCE__COMMENT:
			case SmePackage.MODEL_INSTANCE__REFERRED_INTERFACE:
			case SmePackage.MODEL_INSTANCE__REFERRED_PARAMETER:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case SmePackage.MODEL_INSTANCE__INPUTS:
			case SmePackage.MODEL_INSTANCE__OUTPUTS:
			case SmePackage.MODEL_INSTANCE__PARAMETERS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}
	
	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children that can be created
	 * under this object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}
	
	/**
	 * Return the resource locator for this item provider's resources. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return SmeEditPlugin.INSTANCE;
	}
	
}
