/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.provider;

import java.util.Collection;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.ModelType;
import fr.irisa.espresso.sme.Output;
import fr.irisa.espresso.sme.Parameter;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalIntrinsicType;
import fr.irisa.espresso.sme.SmePackage;

/**
 * This is the item provider adapter for a {@link fr.irisa.espresso.sme.Output} object. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class OutputItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public OutputItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}
	
	/**
	 * This returns the property descriptors for the adapted class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);
			
			addSrc_DataflowConnectionsPropertyDescriptor(object);
			addSrc_ClockRelationsPropertyDescriptor(object);
			addDst_ClockRelationsPropertyDescriptor(object);
			addSrc_DependencesPropertyDescriptor(object);
			addDst_DependencesPropertyDescriptor(object);
			addDst_DataflowConnectionsPropertyDescriptor(object);
			addSrc_ConditionsPropertyDescriptor(object);
			addNamePropertyDescriptor(object);
			addCommentPropertyDescriptor(object);
			addTypePropertyDescriptor(object);
			addArrayDimensionsPropertyDescriptor(object);
			addInitValuePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}
	
	/**
	 * This adds a property descriptor for the Src Dataflow Connections feature. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addSrc_DataflowConnectionsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_SignalExpr_src_DataflowConnections_feature"),
			getString("_UI_SignalExpr_src_DataflowConnections_description"),
			SmePackage.Literals.SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS, false, false, true, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Src Clock Relations feature. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected void addSrc_ClockRelationsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_ClockedExpr_src_ClockRelations_feature"),
			getString("_UI_ClockedExpr_src_ClockRelations_description"),
			SmePackage.Literals.CLOCKED_EXPR__SRC_CLOCK_RELATIONS, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Clock Relations feature. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected void addDst_ClockRelationsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_ClockedExpr_dst_ClockRelations_feature"),
			getString("_UI_ClockedExpr_dst_ClockRelations_description"),
			SmePackage.Literals.CLOCKED_EXPR__DST_CLOCK_RELATIONS, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Src Dependences feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addSrc_DependencesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DependenceInOut_src_Dependences_feature"),
			getString("_UI_DependenceInOut_src_Dependences_description"),
			SmePackage.Literals.DEPENDENCE_IN_OUT__SRC_DEPENDENCES, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Dependences feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDst_DependencesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DependenceInOut_dst_Dependences_feature"),
			getString("_UI_DependenceInOut_dst_Dependences_description"),
			SmePackage.Literals.DEPENDENCE_IN_OUT__DST_DEPENDENCES, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Dataflow Connections feature. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDst_DataflowConnectionsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DataflowConnector_dst_DataflowConnections_feature"),
			getString("_UI_DataflowConnector_dst_DataflowConnections_description"),
			SmePackage.Literals.DATAFLOW_CONNECTOR__DST_DATAFLOW_CONNECTIONS, false, false, true, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Src Conditions feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addSrc_ConditionsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_ConditionExpr_src_Conditions_feature"),
			getString("_UI_ConditionExpr_src_Conditions_description"),
			SmePackage.Literals.CONDITION_EXPR__SRC_CONDITIONS, false, false, true, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Name feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_NamedElement_name_feature"),
			getString("_UI_NamedElement_name_description"), SmePackage.Literals.NAMED_ELEMENT__NAME, true, false,
			false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Comment feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addCommentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_Identifier_comment_feature"), getString(
			"_UI_PropertyDescriptor_description", "_UI_Identifier_comment_feature", "_UI_Identifier_type"),
			SmePackage.Literals.IDENTIFIER__COMMENT, true, true, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
			getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Type feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	protected void addTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(new ItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_Signal_type_feature"),
			getString("_UI_Signal_type_description"), SmePackage.Literals.SIGNAL__TYPE, true, false, false,
			ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_BasicPropertyCategory"), null) {
			protected Collection<String> getComboBoxObjects(Object object) {
				// We put all intrinsic type in the list
				List<String> sortedList = new LinkedList<String>(SignalIntrinsicType.STRING_VALUES);
				
				// And we add all type declaration which are in the scope of the output signal.
				SignalContainer parent = ((Output) object).getParent();
				
				// The type of a output must be defined outside the model in which it is declared, except if the type is
				// carried by a parameter
				if (parent != null) {
					EList<Identifier> vt = parent.getVisibleTypes();
					int index;
					for (Identifier id : vt) {
						if ((id instanceof ModelType) == false) {
							// Search for the non-existent item
							index = Collections.binarySearch(sortedList, id.getName());
							// Add the non-existent item to the list
							if (index < 0 && (!parent.equals(id.getParent()) || id instanceof Parameter))
								sortedList.add(-index - 1, id.getName());
						}
					}
				}
				return sortedList;
			}
		});
	}
	
	/**
	 * This adds a property descriptor for the Array Dimensions feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addArrayDimensionsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_Signal_arrayDimensions_feature"),
			getString("_UI_Signal_arrayDimensions_description"), SmePackage.Literals.SIGNAL__ARRAY_DIMENSIONS, true,
			false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Init Value feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addInitValuePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_Signal_initValue_feature"),
			getString("_UI_Signal_initValue_description"), SmePackage.Literals.SIGNAL__INIT_VALUE, true, false, false,
			ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This returns Output.gif. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Output"));
	}
	
	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Output) object).getName();
		return label == null || label.length() == 0 ? getString("_UI_Output_type") : getString("_UI_Output_type") + " "
				+ label;
	}
	
	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached children and by creating
	 * a viewer notification, which it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		
		switch (notification.getFeatureID(Output.class)) {
			case SmePackage.OUTPUT__DST_DATAFLOW_CONNECTIONS:
			case SmePackage.OUTPUT__NAME:
			case SmePackage.OUTPUT__COMMENT:
			case SmePackage.OUTPUT__TYPE:
			case SmePackage.OUTPUT__ARRAY_DIMENSIONS:
			case SmePackage.OUTPUT__INIT_VALUE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}
	
	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children that can be created
	 * under this object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}
	
	/**
	 * Return the resource locator for this item provider's resources. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return SmeEditPlugin.INSTANCE;
	}
	
}
