/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import fr.irisa.espresso.sme.SmeFactory;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.SubProcess;
import fr.irisa.espresso.sme.util.Utils;

/**
 * This is the item provider adapter for a {@link fr.irisa.espresso.sme.SubProcess} object. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class SubProcessItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SubProcessItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}
	
	/**
	 * This returns the property descriptors for the adapted class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);
			
			addSrc_ClockRelationsPropertyDescriptor(object);
			addDst_ClockRelationsPropertyDescriptor(object);
			addNamePropertyDescriptor(object);
			addCommentPropertyDescriptor(object);
			addSrc_DependencesPropertyDescriptor(object);
			addDst_DependencesPropertyDescriptor(object);
			addDst_CaseConnectionPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}
	
	/**
	 * This adds a property descriptor for the Src Clock Relations feature. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected void addSrc_ClockRelationsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_ClockedExpr_src_ClockRelations_feature"),
			getString("_UI_ClockedExpr_src_ClockRelations_description"),
			SmePackage.Literals.CLOCKED_EXPR__SRC_CLOCK_RELATIONS, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Clock Relations feature. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected void addDst_ClockRelationsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_ClockedExpr_dst_ClockRelations_feature"),
			getString("_UI_ClockedExpr_dst_ClockRelations_description"),
			SmePackage.Literals.CLOCKED_EXPR__DST_CLOCK_RELATIONS, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Name feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_NamedElement_name_feature"),
			getString("_UI_NamedElement_name_description"), SmePackage.Literals.NAMED_ELEMENT__NAME, true, false,
			false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Comment feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addCommentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_Identifier_comment_feature"), getString(
			"_UI_PropertyDescriptor_description", "_UI_Identifier_comment_feature", "_UI_Identifier_type"),
			SmePackage.Literals.IDENTIFIER__COMMENT, true, true, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
			getString("_UI_BasicPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Src Dependences feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addSrc_DependencesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DependenceInOut_src_Dependences_feature"),
			getString("_UI_DependenceInOut_src_Dependences_description"),
			SmePackage.Literals.DEPENDENCE_IN_OUT__SRC_DEPENDENCES, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Dependences feature. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDst_DependencesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(),
			getString("_UI_DependenceInOut_dst_Dependences_feature"),
			getString("_UI_DependenceInOut_dst_Dependences_description"),
			SmePackage.Literals.DEPENDENCE_IN_OUT__DST_DEPENDENCES, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This adds a property descriptor for the Dst Case Connection feature. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected void addDst_CaseConnectionPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory)
				.getRootAdapterFactory(), getResourceLocator(), getString("_UI_SubProcess_dst_CaseConnection_feature"),
			getString("_UI_SubProcess_dst_CaseConnection_description"),
			SmePackage.Literals.SUB_PROCESS__DST_CASE_CONNECTION, false, false, false, null,
			getString("_UI_ConnectedlinksPropertyCategory"), null));
	}
	
	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(SmePackage.Literals.MODEL__ASSERTIONS);
			childrenFeatures.add(SmePackage.Literals.MODEL__AUTOMATA);
			childrenFeatures.add(SmePackage.Literals.MODEL__CONNECTIONS);
			childrenFeatures.add(SmePackage.Literals.MODEL__CONSTANT_REF);
			childrenFeatures.add(SmePackage.Literals.MODEL__CONSTANTS);
			childrenFeatures.add(SmePackage.Literals.MODEL__CONSTRAINTS);
			childrenFeatures.add(SmePackage.Literals.MODEL__INDEXES);
			childrenFeatures.add(SmePackage.Literals.MODEL__CONTAINED_INSTANCES);
			childrenFeatures.add(SmePackage.Literals.MODEL__LITERALS);
			childrenFeatures.add(SmePackage.Literals.MODEL__LOCALS);
			childrenFeatures.add(SmePackage.Literals.MODEL__OPERATORS);
			childrenFeatures.add(SmePackage.Literals.MODEL__SIGNAL_REF);
			childrenFeatures.add(SmePackage.Literals.MODEL__SUBPROCESSES);
			childrenFeatures.add(SmePackage.Literals.MODEL__TYPES);
			childrenFeatures.add(SmePackage.Literals.MODEL__USE_MODULE);
			childrenFeatures.add(SmePackage.Literals.MODEL__MODEL_REFS);
		}
		return childrenFeatures;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.
		
		return super.getChildFeature(object, child);
	}
	
	/**
	 * This returns SubProcess.gif. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/SubProcess"));
	}
	
	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((SubProcess) object).getName();
		return label == null || label.length() == 0 ? getString("_UI_SubProcess_type")
				: getString("_UI_SubProcess_type") + " " + label;
	}
	
	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached children and by creating
	 * a viewer notification, which it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		
		switch (notification.getFeatureID(SubProcess.class)) {
			case SmePackage.SUB_PROCESS__NAME:
			case SmePackage.SUB_PROCESS__COMMENT:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case SmePackage.SUB_PROCESS__ASSERTIONS:
			case SmePackage.SUB_PROCESS__AUTOMATA:
			case SmePackage.SUB_PROCESS__CONNECTIONS:
			case SmePackage.SUB_PROCESS__CONSTANT_REF:
			case SmePackage.SUB_PROCESS__CONSTANTS:
			case SmePackage.SUB_PROCESS__CONSTRAINTS:
			case SmePackage.SUB_PROCESS__INDEXES:
			case SmePackage.SUB_PROCESS__CONTAINED_INSTANCES:
			case SmePackage.SUB_PROCESS__LITERALS:
			case SmePackage.SUB_PROCESS__LOCALS:
			case SmePackage.SUB_PROCESS__OPERATORS:
			case SmePackage.SUB_PROCESS__SIGNAL_REF:
			case SmePackage.SUB_PROCESS__SUBPROCESSES:
			case SmePackage.SUB_PROCESS__TYPES:
			case SmePackage.SUB_PROCESS__USE_MODULE:
			case SmePackage.SUB_PROCESS__MODEL_REFS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}
	
	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children that can be created
	 * under this object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createAnd())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createArithmeticOperator())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createArrayEnumeration())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createArrayProduct())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createArrayRecovery())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createArrayRestructuration())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__ASSERTIONS, SmeFactory.eINSTANCE
				.createAssertion()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTRAINTS, SmeFactory.eINSTANCE
				.createAssertionClockConstraintOperator()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTRAINTS, Utils
				.createPorts(SmeFactory.eINSTANCE.createAssertionClockSpeedOperator())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__AUTOMATA, SmeFactory.eINSTANCE
				.createAutomaton()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__SUBPROCESSES, SmeFactory.eINSTANCE
				.createBasicIterate()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, SmeFactory.eINSTANCE
				.createBooleanExpression()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONNECTIONS, SmeFactory.eINSTANCE
				.createCaseConnection()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createCartesianProduct())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createCell())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTRAINTS, SmeFactory.eINSTANCE
				.createClockConstraintOperator()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONNECTIONS, SmeFactory.eINSTANCE
				.createClockRelation()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTRAINTS, Utils
				.createPorts(SmeFactory.eINSTANCE.createClockRelationOperator())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTRAINTS, Utils
				.createPorts(SmeFactory.eINSTANCE.createClockSpeedOperator())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createComparisonOperator())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createComplexOperator())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createConcatenation())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONNECTIONS, SmeFactory.eINSTANCE
				.createCondition()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONNECTIONS, SmeFactory.eINSTANCE
				.createConstantAffectation()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTANT_REF, SmeFactory.eINSTANCE
				.createConstantRef()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTANTS, SmeFactory.eINSTANCE
				.createConstantValue()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createCounter())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONNECTIONS, SmeFactory.eINSTANCE
				.createDataflowConnection()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createDelay())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONNECTIONS, SmeFactory.eINSTANCE
				.createDependence()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTRAINTS, SmeFactory.eINSTANCE
				.createDependenceOperator()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__TYPES, SmeFactory.eINSTANCE
				.createEnumerationType()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__LITERALS, SmeFactory.eINSTANCE
				.createEnumerationValue()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createExtraction())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createIfThenElse())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__INDEXES, SmeFactory.eINSTANCE
				.createIndex()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__SUBPROCESSES, Utils
				.createPorts(SmeFactory.eINSTANCE.createIterate())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__LITERALS, SmeFactory.eINSTANCE
				.createLiteral()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__LOCALS, SmeFactory.eINSTANCE
				.createLocal()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createMerge())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONTAINED_INSTANCES,
			SmeFactory.eINSTANCE.createModelInstance()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__MODEL_REFS, SmeFactory.eINSTANCE
				.createModelRef()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__TYPES, SmeFactory.eINSTANCE
				.createModelType()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__CONSTRAINTS, SmeFactory.eINSTANCE
				.createNullClock()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createNot())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, SmeFactory.eINSTANCE
				.createNumericExpression()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createOr())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createRepetitionOperator())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createSequentialDefinition())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__SIGNAL_REF, SmeFactory.eINSTANCE
				.createSignalRef()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__SUBPROCESSES, SmeFactory.eINSTANCE
				.createSubProcess()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__TYPES, SmeFactory.eINSTANCE
				.createSubstitutionType()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, SmeFactory.eINSTANCE
				.createSwitch()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createTransposition())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createTupleOperator())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__TYPES, SmeFactory.eINSTANCE
				.createTupleType()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createUnaryMinus())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__USE_MODULE, SmeFactory.eINSTANCE
				.createUseModule()));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createVariable())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createWindow())));
		
		newChildDescriptors.add(createChildParameter(SmePackage.Literals.MODEL__OPERATORS, Utils
				.createPorts(SmeFactory.eINSTANCE.createXor())));
	}
	
	/**
	 * Return the resource locator for this item provider's resources. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return SmeEditPlugin.INSTANCE;
	}
	
}
