/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.tests;

import junit.framework.TestCase;
import fr.irisa.espresso.sme.SignalOperator;

/**
 * <!-- begin-user-doc --> A test case for the model object '<em><b>Signal Operator</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following operations are tested:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.SignalOperator#getPortName(fr.irisa.espresso.sme.OperatorPort) <em>Get Port Name
 * </em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalOperator#getInputPorts() <em>Get Input Ports</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalOperator#getOutputPorts() <em>Get Output Ports</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalContainer#getVisibleConstants() <em>Get Visible Constants</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalContainer#getVisibleModelProcesses() <em>Get Visible Model Processes</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalContainer#getName() <em>Get Name</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalContainer#getVisibleSignals() <em>Get Visible Signals</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalContainer#getVisibleTypes() <em>Get Visible Types</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalElement#getParent() <em>Get Parent</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class SignalOperatorTest extends TestCase {
	
	/**
	 * The fixture for this Signal Operator test case. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SignalOperator	fixture	= null;
	
	/**
	 * Constructs a new Signal Operator test case with the given name. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SignalOperatorTest(String name) {
		super(name);
	}
	
	/**
	 * Sets the fixture for this Signal Operator test case. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void setFixture(SignalOperator fixture) {
		this.fixture = fixture;
	}
	
	/**
	 * Returns the fixture for this Signal Operator test case. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SignalOperator getFixture() {
		return fixture;
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalOperator#getPortName(fr.irisa.espresso.sme.OperatorPort)
	 * <em>Get Port Name</em>}' operation. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalOperator#getPortName(fr.irisa.espresso.sme.OperatorPort)
	 * @generated
	 */
	public void testGetPortName__OperatorPort() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalOperator#getInputPorts() <em>Get Input Ports</em>}' operation. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalOperator#getInputPorts()
	 * @generated
	 */
	public void testGetInputPorts() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalOperator#getOutputPorts() <em>Get Output Ports</em>}' operation.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalOperator#getOutputPorts()
	 * @generated
	 */
	public void testGetOutputPorts() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalContainer#getVisibleConstants() <em>Get Visible Constants</em>}'
	 * operation. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalContainer#getVisibleConstants()
	 * @generated
	 */
	public void testGetVisibleConstants() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalContainer#getVisibleModelProcesses()
	 * <em>Get Visible Model Processes</em>}' operation. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalContainer#getVisibleModelProcesses()
	 * @generated
	 */
	public void testGetVisibleModelProcesses() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalContainer#getName() <em>Get Name</em>}' operation. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalContainer#getName()
	 * @generated
	 */
	public void testGetName() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalContainer#getVisibleSignals() <em>Get Visible Signals</em>}'
	 * operation. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalContainer#getVisibleSignals()
	 * @generated
	 */
	public void testGetVisibleSignals() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalContainer#getVisibleTypes() <em>Get Visible Types</em>}' operation.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalContainer#getVisibleTypes()
	 * @generated
	 */
	public void testGetVisibleTypes() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
	/**
	 * Tests the '{@link fr.irisa.espresso.sme.SignalElement#getParent() <em>Get Parent</em>}' operation. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalElement#getParent()
	 * @generated
	 */
	public void testGetParent() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}
	
} // SignalOperatorTest
