/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.tests;

import junit.framework.Test;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

/**
 * <!-- begin-user-doc --> A test suite for the '<em><b>sme</b></em>' package. <!-- end-user-doc -->
 * 
 * @generated
 */
public class SmeTests extends TestSuite {
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static void main(String[] args) {
		TestRunner.run(suite());
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static Test suite() {
		TestSuite suite = new SmeTests("sme Tests");
		suite.addTestSuite(BasicIterateTest.class);
		suite.addTestSuite(IterateTest.class);
		suite.addTestSuite(IterationInitTest.class);
		suite.addTestSuite(SpecificationsTest.class);
		suite.addTestSuite(SubProcessTest.class);
		suite.addTestSuite(EnumerationTypeTest.class);
		suite.addTestSuite(ModelTypeTest.class);
		suite.addTestSuite(SubstitutionTypeTest.class);
		suite.addTestSuite(TupleTypeTest.class);
		suite.addTestSuite(ModelDeclarationTest.class);
		suite.addTestSuite(ModelRefTest.class);
		suite.addTestSuite(ModelInstanceTest.class);
		suite.addTestSuite(ModuleTest.class);
		suite.addTestSuite(UseModuleTest.class);
		suite.addTestSuite(ConstantRefTest.class);
		suite.addTestSuite(ConstantValueTest.class);
		suite.addTestSuite(LiteralTest.class);
		suite.addTestSuite(ParameterTest.class);
		suite.addTestSuite(ParameterInstanceTest.class);
		suite.addTestSuite(IteratorTest.class);
		suite.addTestSuite(IndexTest.class);
		suite.addTestSuite(SignalRefTest.class);
		suite.addTestSuite(InputTest.class);
		suite.addTestSuite(InputInstanceTest.class);
		suite.addTestSuite(OutputTest.class);
		suite.addTestSuite(OutputInstanceTest.class);
		suite.addTestSuite(LocalTest.class);
		suite.addTestSuite(CaseConnectionTest.class);
		suite.addTestSuite(ClockRelationTest.class);
		suite.addTestSuite(ConditionTest.class);
		suite.addTestSuite(ConstantAffectationTest.class);
		suite.addTestSuite(DependenceTest.class);
		suite.addTestSuite(DataflowConnectionTest.class);
		suite.addTestSuite(InputPortTest.class);
		suite.addTestSuite(OutputPortTest.class);
		suite.addTestSuite(AndTest.class);
		suite.addTestSuite(ArithmeticOperatorTest.class);
		suite.addTestSuite(ArrayEnumerationTest.class);
		suite.addTestSuite(ArrayProductTest.class);
		suite.addTestSuite(ArrayRecoveryTest.class);
		suite.addTestSuite(ArrayRestructurationTest.class);
		suite.addTestSuite(AssertionTest.class);
		suite.addTestSuite(BooleanExpressionTest.class);
		suite.addTestSuite(CartesianProductTest.class);
		suite.addTestSuite(CellTest.class);
		suite.addTestSuite(ClockConstraintOperatorTest.class);
		suite.addTestSuite(ClockRelationOperatorTest.class);
		suite.addTestSuite(ClockSpeedOperatorTest.class);
		suite.addTestSuite(ComparisonOperatorTest.class);
		suite.addTestSuite(ComplexOperatorTest.class);
		suite.addTestSuite(ConcatenationTest.class);
		suite.addTestSuite(CounterTest.class);
		suite.addTestSuite(DelayTest.class);
		suite.addTestSuite(DependenceOperatorTest.class);
		suite.addTestSuite(ExtractionTest.class);
		suite.addTestSuite(IfThenElseTest.class);
		suite.addTestSuite(MergeTest.class);
		suite.addTestSuite(NotTest.class);
		suite.addTestSuite(NullClockTest.class);
		suite.addTestSuite(NumericExpressionTest.class);
		suite.addTestSuite(OrTest.class);
		suite.addTestSuite(PragmaTest.class);
		suite.addTestSuite(RepetitionOperatorTest.class);
		suite.addTestSuite(SequentialDefinitionTest.class);
		suite.addTestSuite(SwitchTest.class);
		suite.addTestSuite(TranspositionTest.class);
		suite.addTestSuite(TupleOperatorTest.class);
		suite.addTestSuite(UnaryMinusTest.class);
		suite.addTestSuite(VariableTest.class);
		suite.addTestSuite(WindowTest.class);
		suite.addTestSuite(XorTest.class);
		suite.addTestSuite(HistoryTest.class);
		suite.addTestSuite(StateTest.class);
		suite.addTestSuite(AutomatonTest.class);
		suite.addTestSuite(AndStateTest.class);
		suite.addTestSuite(WeakTransitionTest.class);
		suite.addTestSuite(StrongTransitionTest.class);
		return suite;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SmeTests(String name) {
		super(name);
	}
	
} // SmeTests
