definition of Signal is
   chapter SYNTAXE
      rules
         <axiome_signal> ::= <decl_processus> ;
            <decl_processus>
         <axiome_signal> ::= <decl_processus> ";" ;
            <decl_processus>
         <axiome_signal> ::= <l_modules> ;
            <l_modules>
         <axiome_signal> ::= <l_modules> ";" ;
            <l_modules>

      chapter 'IDENTIFICATEURS'
         rules
            <l_identificateurs> ::= <identificateur> ;
               l_ident-list ((<identificateur>))
            <l_identificateurs> ::= <l_identificateurs> "," <identificateur> ;
               l_ident-post (<l_identificateurs>, <identificateur>)

         rules
            <identificateur> ::= %IDENT ;
               nom-atom(%IDENT)
      end chapter ;

      chapter 'MODULES'
         rules
            <l_modules> ::= <module> ;
               l_modu-list ((<module>))
            <l_modules> ::= <l_modules> ";" <module> ;
               l_modu-post (<l_modules>, <module>)
            <module> ::=
               "module" <identificateur> "=" <description_module> "end" ;
               modu (<identificateur>, <description_module>)
            <description_module> ::= <o_l_pragmas> <o_l_declarations> ;
               desc_modu (<o_l_pragmas>, <o_l_declarations>)
            <import> ::= "use" <l_objets_importes> ;
               <l_objets_importes>
            <l_objets_importes> ::= <objet_importe> ;
               l_impo-list ((<objet_importe>))
            <l_objets_importes> ::= <l_objets_importes> "," <objet_importe> ;
               l_impo-post (<l_objets_importes>, <objet_importe>)
            <objet_importe> ::= <identificateur> ;
               <identificateur>
            <indication_externe> ::= "external" ;
               exte (nil ())
            <indication_externe> ::= "external" <chaine> ;
               exte (<chaine>)
      end chapter ;

      chapter 'STRUCTURE DE PROCESSUS'
         -- Liste de declarations
         rules
            <o_l_declarations> ::= ;
               nil ()
            <o_l_declarations> ::= <l_declarations> ;
               <l_declarations>
            <o_l_declarations> ::= <l_declarations> ";" ;
               <l_declarations>
            <l_declarations> ::= <declaration> ;
               l_decl-list ((<declaration>))
            <l_declarations> ::= <l_declarations> ";" <declaration> ;
               l_decl-post (<l_declarations>, <declaration>)
            <declaration> ::= <decl_processus> ;
               <decl_processus>
            <declaration> ::= <decl_suites> ;
               <decl_suites>
            <declaration> ::= <decl_constantes> ;
               <decl_constantes>
            <declaration> ::= <decl_partages> ;
               <decl_partages>
            <declaration> ::= <decl_variables> ;
               <decl_variables>
            <declaration> ::= <decl_etiquettes> ;
               <decl_etiquettes>
            <declaration> ::= <import> ;
               <import>
            <declaration> ::= <references> ;
               <references>

         -- Processus
         rules
            <decl_processus> ::=
               "process" <identificateur> "=" <def_interface> <description> ;
               process (<identificateur>, <def_interface>, <description>)
            <decl_processus> ::=
               "private" "process" <identificateur> "=" <def_interface>
                  <description> ;
               process_p (<identificateur>, <def_interface>, <description>)
            <decl_processus> ::=
               "node" <identificateur> "=" <def_interface> <description> ;
               node (<identificateur>, <def_interface>, <description>)
            <decl_processus> ::=
               "private" "node" <identificateur> "=" <def_interface>
                  <description> ;
               node_p (<identificateur>, <def_interface>, <description>)
            <decl_processus> ::=
               "function" <identificateur> "=" <def_interface> <description> ;
               func (<identificateur>, <def_interface>, <description>)
            <decl_processus> ::=
               "private" "function" <identificateur> "=" <def_interface>
                  <description> ;
               func_p (<identificateur>, <def_interface>, <description>)
            <decl_processus> ::=
               "action" <identificateur> "=" <def_interface> <description> ;
               act (<identificateur>, <def_interface>, <description>)
            <decl_processus> ::=
               "private" "action" <identificateur> "=" <def_interface>
                  <description> ;
               act_p (<identificateur>, <def_interface>, <description>)
            <decl_processus> ::=
               "operator" <ident_operateur> "=" <def_interface> <description> ;
               oper (<ident_operateur>, <def_interface>, <description>)
            <description> ::= <o_l_pragmas> <o_corps> ;
               desc (<o_l_pragmas>, <o_corps>)
            <ident_operateur> ::= <identificateur> ;
               <identificateur>
            <ident_operateur> ::= <operateur> ;
               <operateur>
         

         -- Processus formels
         rules
            <decl_processus_formel> ::=
               "process" <identificateur> <identificateur> ;
               form_proc (<identificateur>.1, <identificateur>.2)
            <decl_processus_formel> ::= "node" <identificateur> <identificateur> ;
               form_node (<identificateur>.1, <identificateur>.2)
            <decl_processus_formel> ::=
               "function" <identificateur> <identificateur> ;
               form_func (<identificateur>.1, <identificateur>.2)
            <decl_processus_formel> ::=
               "action" <identificateur> <identificateur> ;
               form_act (<identificateur>.1, <identificateur>.2)

         -- Interface
         rules
            <def_interface> ::= <interface> ;
               <interface>
            <def_interface> ::= <identificateur> ;
               <identificateur>
            <interface> ::=
               <o_suite_parametres_formels> <entrees_sorties> <graphe_externe> ;
               inte
                  (<o_suite_parametres_formels>, <entrees_sorties>,
                      <graphe_externe>)
            <o_suite_parametres_formels> ::= ;
               nil ()
            <o_suite_parametres_formels> ::= "{" <o_l_decl_suites> "}" ;
               <o_l_decl_suites>
               
            <entrees_sorties> ::= "(" <o_entrees> <o_sorties> ")" ;
               ent_sor (<o_entrees>, <o_sorties>)
            <o_entrees> ::= ;
               nil ()
            <o_entrees> ::= "?" <o_l_decl_suites> ;
               <o_l_decl_suites>
               
            <o_sorties> ::= ;
               nil ()
            <o_sorties> ::= "!" <o_l_decl_suites> ;
               <o_l_decl_suites>
               

         -- Graphe externe
         rules
            <graphe_externe> ::= ;
               nil ()
            <graphe_externe> ::= <spec_proprietes> ;
               spec (nil (), <spec_proprietes>)
            <graphe_externe> ::= <l_attributs> ;
               spec (<l_attributs>, nil ())
            <graphe_externe> ::= <l_attributs> <spec_proprietes> ;
               spec (<l_attributs>, <spec_proprietes>)
            <l_attributs> ::= <attribut> ;
               l_attr-list ((<attribut>))
            <l_attributs> ::= <l_attributs> <attribut> ;
               l_attr-post (<l_attributs>, <attribut>)
            <attribut> ::= "safe" ;
               safe ()
            <attribut> ::= "deterministic" ;
               determ ()
            <attribut> ::= "unsafe" ;
               unsafe ()
            <spec_proprietes> ::= "spec" <primaire_processus> ;
               <primaire_processus>

         -- Corps
         rules
            <o_corps> ::= ;
               nil ()
            <o_corps> ::= <corps> ;
               <corps>
            <corps> ::= <corps_modele> ;
               <corps_modele>
            <corps_modele> ::= <term_processus> ;
               <term_processus>
            <corps_modele> ::= <indication_externe> ;
               <indication_externe>
            <corps_modele> ::= <indication_externe> <bloc_declarations> ;
               p_conf (<indication_externe>, <bloc_declarations>)

         -- Directives
         rules
            <o_l_pragmas> ::= ;
               nil ()
            <o_l_pragmas> ::= "pragmas" <l_pragmas> "end" "pragmas" ;
               <l_pragmas>
            <l_pragmas> ::= <pragma> ;
               l_prag-list ((<pragma>))
            <l_pragmas> ::= <l_pragmas> <pragma> ;
               l_prag-post (<l_pragmas>, <pragma>)
            <pragma> ::= <identificateur> <o_l_objets_pragma> <enonce_pragma> ;
               prag (<identificateur>, <o_l_objets_pragma>, <enonce_pragma>)
            <pragma> ::= <identificateur> <o_l_objets_pragma> ;
               prag (<identificateur>, <o_l_objets_pragma>, nil ())
            <o_l_objets_pragma> ::= ;
               nil ()
            <o_l_objets_pragma> ::= "{" <l_objets_pragma> "}" ;
               <l_objets_pragma>
            <l_objets_pragma> ::= <objet_pragma> ;
               l_opra-list ((<objet_pragma>))
            <l_objets_pragma> ::= <l_objets_pragma> "," <objet_pragma> ;
               l_opra-post (<l_objets_pragma>, <objet_pragma>)
            <enonce_pragma> ::= <chaine> ;
               <chaine>
            <objet_pragma> ::= <identificateur> ;
               <identificateur>
      end chapter ;

      chapter 'DECLARATIONS DE SUITES'
         -- Liste de declarations de suites
         rules
            <o_l_decl_suites> ::= ;
               nil ()
            <o_l_decl_suites> ::= <l_decl_suites> ;
               <l_decl_suites>
            <o_l_decl_suites> ::= <l_decl_suites> ";" ;
               <l_decl_suites>
            <l_decl_suites> ::= <decl_suites> ;
               l_dec_s-list ((<decl_suites>))
            <l_decl_suites> ::= <l_decl_suites> ";" <decl_suites> ;
               l_dec_s-post (<l_decl_suites>, <decl_suites>)
            <decl_suites> ::= <decl_types> ;
               <decl_types>
            <decl_suites> ::= <decl_signaux> ;
               <decl_signaux>
            <decl_suites> ::= <decl_processus_formel> ;
               <decl_processus_formel>

         chapter 'DECLARATIONS DE TYPES'
            rules
               <decl_types> ::= "type" <l_def_types> ;
                  <l_def_types>
               <decl_types> ::= "private" "type" <l_def_types> ;
                  l_type_p-list (<l_def_types>)     -- here, the list-operator is changed, it becomes opltypep
               <l_def_types> ::= <def_type> ;
                  l_type-list ((<def_type>))
               <l_def_types> ::= <l_def_types> "," <def_type> ;
                  l_type-post (<l_def_types>, <def_type>)
               <def_type> ::= <identificateur> ;
                  <identificateur>
               <def_type> ::= <identificateur> "=" <valeur_type> ;
                  type (<identificateur>, <valeur_type>, nil ())
               <def_type> ::=
                  <identificateur> "=" <valeur_type> "init" <expr_signal> ;
                  type (<identificateur>, <valeur_type>, <expr_signal>)
               <def_type> ::= "process" <identificateur> "=" <def_interface> <o_l_pragmas> ;
                  type_proc (<identificateur>, <def_interface>, <o_l_pragmas>)
               <def_type> ::= "node" <identificateur> "=" <def_interface> <o_l_pragmas> ;
                  type_node (<identificateur>, <def_interface>, <o_l_pragmas>)
               <def_type> ::= "function" <identificateur> "=" <def_interface> <o_l_pragmas> ;
                  type_func (<identificateur>, <def_interface>, <o_l_pragmas>)
               <def_type> ::= "action" <identificateur> "=" <def_interface> <o_l_pragmas> ;
                  type_act (<identificateur>, <def_interface>, <o_l_pragmas>)
               <def_type> ::= <type_decrit> "=" <valeur_type> ;
                  type (<type_decrit>, <valeur_type>, nil ())
               <valeur_type> ::= <type> ;
                  <type>
               <valeur_type> ::= <indication_externe> ;
                  <indication_externe>

            -- Types
            rules
               <type> ::= <type_decrit> ;
                  <type_decrit>
               <type> ::= <type_externe> ;
                  <type_externe>
               <type_decrit> ::= <type_predefini> ;
                  <type_predefini>
               <type_decrit> ::= <type_enumere> ;
                  <type_enumere>
               <type_decrit> ::= <type_tableau> ;
                  <type_tableau>
               <type_decrit> ::= <type_tuple> ;
                  <type_tuple>

            -- Types scalaires
            rules
               <type_predefini> ::= "event" ;
                  event ()
               <type_predefini> ::= "boolean" ;
                  logical ()
               <type_predefini> ::= "short" ;
                  short ()
               <type_predefini> ::= "integer" ;
                  integer ()
               <type_predefini> ::= "long" ;
                  long ()
               <type_predefini> ::= "real" ;
                  real ()
               <type_predefini> ::= "dreal" ;
                  dpreal ()
               <type_predefini> ::= "complex" ;
                  complex ()
               <type_predefini> ::= "dcomplex" ;
                  dcomplex ()
               <type_predefini> ::= "char" ;
                  char ()
               <type_predefini> ::= "string" ;
                  string ()

            -- Types externes
            rules
               <type_externe> ::= <identificateur> ;
                  <identificateur>

            -- Types enumeres
            rules
               <type_enumere> ::= "enum" "(" <l_identificateurs> ")" ;
                  t_enum-list (<l_identificateurs>)    -- here, the list-operator is changed, it becomes optenum

            -- Types tableaux
            rules
               <type_tableau> ::= <expr_dimension> <type> ;
                  t_vect (<expr_dimension>, <type>)
               <expr_dimension> ::= "[" <l_expr_signal> "]" ;
                  <l_expr_signal>
               <expr_dimension> ::= "[" "]" ;
                  nil ()
               <l_expr_signal> ::= <expr_signal> ;
                  l_e_sign-list ((<expr_signal>))
               <l_expr_signal> ::= <l_expr_signal> "," <expr_signal> ;
                  l_e_sign-post (<l_expr_signal>, <expr_signal>)
               <o_l_expr_signal> ::= ;
                  nil ()
               <o_l_expr_signal> ::= <l_expr_signal> ;
                  <l_expr_signal>

            -- Types tuples
            rules
               <type_tuple> ::= "struct" "(" <champs_nommes> ")" ;
                  stru (<champs_nommes>)
               <type_tuple> ::= "bundle" "(" <champs_nommes> ")" ;
                  bund (<champs_nommes>, nil ())
               <type_tuple> ::=
                  "bundle" "(" <champs_nommes> ")" <spec_proprietes> ;
                  bund (<champs_nommes>, <spec_proprietes>)
               <champs_nommes> ::= <o_l_decl_suites> ;
                  <o_l_decl_suites>
         end chapter ;

         chapter 'DECLARATIONS DE CONSTANTES'
            rules
               <decl_constantes> ::= "constant" <type> <l_def_constantes> ;
                  dec_con (<type>, <l_def_constantes>)
               <decl_constantes> ::= "constant" <l_def_constantes> ;
                  dec_con (implicit (), <l_def_constantes>)
               <decl_constantes> ::=
                  "private" "constant" <type> <l_def_constantes> ;
                  dec_con_p (<type>, <l_def_constantes>)
               <decl_constantes> ::= "private" "constant" <l_def_constantes> ;
                  dec_con_p (implicit (), <l_def_constantes>)
               <l_def_constantes> ::= <def_constante> ;
                  l_cons-list ((<def_constante>))
               <l_def_constantes> ::= <l_def_constantes> "," <def_constante> ;
                  l_cons-post (<l_def_constantes>, <def_constante>)
               <def_constante> ::= <identificateur> ;
                  <identificateur>
               <def_constante> ::= <identificateur> "=" <valeur_constante> ;
                  cons (<identificateur>, <valeur_constante>)
               <valeur_constante> ::= <expr_signal> ;
                  <expr_signal>
               <valeur_constante> ::= <indication_externe> ;
                  <indication_externe>
         end chapter ;

         chapter 'DECLARATIONS DE SIGNAUX'
            rules
               <decl_signaux> ::= <type> <l_signaux> ;
                  dec_sig (<type>, <l_signaux>)
               <decl_signaux> ::= <l_signaux> ;
                  dec_sig (implicit (), <l_signaux>)
               <l_signaux> ::= <signal> ;
                  l_sign-list ((<signal>))
               <l_signaux> ::= <l_signaux> "," <signal> ;
                  l_sign-post (<l_signaux>, <signal>)
            

            -- Elements d'une liste de declarations de signaux
            rules
               <signal> ::= <identificateur> ;
                  <identificateur>
               <signal> ::= <identificateur> "init" <expr_signal> ;
                  init (<identificateur>, <expr_signal>)
         end chapter ;

         chapter 'DECLARATIONS DE VARIABLES PARTAGEES'
            rules
               <decl_partages> ::= "shared" <type> <l_signaux> ;
                  dec_par (<type>, <l_signaux>)
               <decl_partages> ::= "shared" <l_signaux> ;
                  dec_par (implicit (), <l_signaux>)
            
         end chapter ;

         chapter 'DECLARATIONS DE VARIABLES D ETAT'
            rules
               <decl_variables> ::= "statevar" <type> <l_signaux> ;
                  dec_var (<type>, <l_signaux>)
               <decl_variables> ::= "statevar" <l_signaux> ;
                  dec_var (implicit (), <l_signaux>)
            
         end chapter ;

         chapter 'DECLARATIONS D ETIQUETTES'
            rules
               <decl_etiquettes> ::= "label" <l_identificateurs> ;
                  lab (<l_identificateurs>) 
            
         end chapter ;

         chapter 'REFERENCES'
            rules
               <references> ::= "ref" <l_identificateurs> ;
                  ref (<l_identificateurs>)
            
         end chapter ;
      end chapter ;

      chapter 'EXPRESSIONS DE PROCESSUS'
         rules
            <expr_processus> ::= <exemplaire_processus> ;
               <exemplaire_processus>
            <expr_processus> ::= <definition_signal> ;
               <definition_signal>
            <expr_processus> ::= <contrainte_signaux> ;
               <contrainte_signaux>
            <expr_processus> ::= <relation_horl> ;
               <relation_horl>
            <expr_processus> ::= <dependances> ;
               <dependances>
            <expr_processus> ::= <processus_etiquete> ;
               <processus_etiquete>
            <expr_processus> ::= <term_processus> ;
               <term_processus>
            <term_processus> ::= <expr_profil> ;
               <expr_profil>
            <term_processus> ::= <primaire_processus> ;
               <primaire_processus>
            <primaire_processus> ::= <processus_confine> ;
               <processus_confine>
            <primaire_processus> ::= <motif> ;
               <motif>
            <primaire_processus> ::= <expr_case> ;
               <expr_case>
            <primaire_processus> ::= <composition> ;
               <composition>
            <primaire_processus> ::= "assert" <composition> ;
               p_assert (<composition>)
            <primaire_processus> ::= "(" "|" "|" ")" ;
               null_proc ()
            <primaire_processus> ::= "(" <definition_signal> ")" ;
               <definition_signal>
            <primaire_processus> ::= "(" <contrainte_signaux> ")" ;
               <contrainte_signaux>

         chapter 'COMPOSITION DE PROCESSUS'
            rules
               <composition> ::= "(" "|" <l_composition> "|" ")" ;
                  <l_composition>
               <l_composition> ::= <expr_processus> ;
                  l_feed-list ((<expr_processus>))
               <l_composition> ::= <l_composition> "|" <expr_processus> ;
                  l_feed-post (<l_composition>, <expr_processus>)
         end chapter ;

         chapter 'PROCESSUS ETIQUETE'
            rules
               <processus_etiquete> ::= <etiquette> "::" <expr_processus> ;
                  p_etiq (<etiquette>, <expr_processus>)
               <etiquette> ::= <identificateur> ;
                  <identificateur>
         end chapter ;

         chapter 'PROCESSUS CONFINE'
            rules
               <processus_confine> ::= <primaire_processus> <bloc_declarations> ;
                  p_conf (<primaire_processus>, <bloc_declarations>)
               <bloc_declarations> ::= "where" <o_l_declarations> "end" ;
                  <o_l_declarations>
         end chapter ;

         chapter 'OPERATEURS SUR NOMS DE SIGNAUX'
            rules
               <expr_profil> ::= <term_processus> "/" <l_identificateurs> ;
                  obli (<term_processus>, <l_identificateurs>)
         end chapter ;

         chapter 'TABLEAUX DE PROCESSUS'
            rules
               <motif> ::=
                  "array" <indice_motif> "of" <expr_processus> <o_init_motif>
                     "end" ;
                  moti (<indice_motif>, <expr_processus>, <o_init_motif>)
               <motif> ::=
                  "iterate" <expr_signal> "of" <expr_processus> <o_init_motif>
                     "end" ;
                  iter (<expr_signal>, <expr_processus>, <o_init_motif>)
               <indice_motif> ::= <identificateur> <borne_superieure> ;
                  ind_mot (<identificateur>, <borne_superieure>)
               <borne_superieure> ::= "to" <expr_signal> ;
                  <expr_signal>
               <o_init_motif> ::= ;
                  nil ()
               <o_init_motif> ::= <init_motif> ;
                  <init_motif>
               <init_motif> ::= "with" <expr_processus> ;
                  <expr_processus>
         end chapter ;

         chapter 'CASE'
            rules
               <expr_case> ::=
                  "case" <identificateur> "in" <l_cas> <o_cas_sinon> "end" ;
                  p_cas (<identificateur>, <l_cas>, <o_cas_sinon>)
               <l_cas> ::= <cas> ;
                  l_cas-list ((<cas>))
               <l_cas> ::= <l_cas> <cas> ;
                  l_cas-post (<l_cas>, <cas>)
               <o_cas_sinon> ::= ;
                  nil ()
               <o_cas_sinon> ::= <cas_sinon> ;
                  <cas_sinon>
               <cas> ::= <enumeration_valeurs> ":" <term_processus> ;
                  cas (<enumeration_valeurs>, <term_processus>)
               <cas_sinon> ::= "else" <term_processus> ;
                  <term_processus>
               <enumeration_valeurs> ::= "{" <l_expr_signal> "}" ;
                  <l_expr_signal>
               <enumeration_valeurs> ::=
                  "[." <o_expr_signal> "," <o_expr_signal> ".]" ;
                  intv_ff (<o_expr_signal>.1, <o_expr_signal>.2)
               <enumeration_valeurs> ::=
                  "[." <o_expr_signal> "," <o_expr_signal> "[." ;
                  intv_fo (<o_expr_signal>.1, <o_expr_signal>.2)
               <enumeration_valeurs> ::=
                  ".]" <o_expr_signal> "," <o_expr_signal> ".]" ;
                  intv_of (<o_expr_signal>.1, <o_expr_signal>.2)
               <enumeration_valeurs> ::=
                  ".]" <o_expr_signal> "," <o_expr_signal> "[." ;
                  intv_oo (<o_expr_signal>.1, <o_expr_signal>.2)
               <o_expr_signal> ::= ;
                  nil ()
               <o_expr_signal> ::= <expr_signal> ;
                  <expr_signal>
         end chapter ;

         chapter 'INVOCATION DE PROCESSUS'
            rules
               <exemplaire_processus> ::= <production> ;
                  <production>
               <exemplaire_processus> ::= <appel> ;
                  <appel>
               <appel> ::= <reference_processus> "(" <o_l_expr_signal> ")" ;
                  appe (<reference_processus>, <o_l_expr_signal>)
               <appel> ::= "assert" "(" <expr_signal> ")" ;
                  appe_assert (<expr_signal>)
               <reference_processus> ::= <production> ;
                  <production>
               <reference_processus> ::= <identificateur> ;
                  <identificateur>
               <production> ::= <identificateur> "{" <o_l_expr_param> "}" ;
                  inst (<identificateur>, <o_l_expr_param>)
               <l_expr_param> ::= <expr_param> ;
                  l_e_para-list ((<expr_param>))
               <l_expr_param> ::= <l_expr_param> "," <expr_param> ;
                  l_e_para-post (<l_expr_param>, <expr_param>)
               <o_l_expr_param> ::= ;
                  nil ()
               <o_l_expr_param> ::= <l_expr_param> ;
                  <l_expr_param>
               <expr_param> ::= <expr_signal> ;
                  <expr_signal>
               <expr_param> ::= <type_decrit> ;
                  <type_decrit>
         end chapter ;

         chapter 'DEFINITION DE SIGNAUX'
            rules
               <definition_signal> ::= <expr_signal> ":=" <expr_signal> ;
                  def_sig (<expr_signal>.1, <expr_signal>.2)
               <definition_signal> ::= <expr_signal> "::=" <expr_signal> ;
                  def_part (<expr_signal>.1, <expr_signal>.2)
               <definition_signal> ::=
                  <expr_signal> "::=" "defaultvalue" <expr_signal> ;
                  def_part_def (<expr_signal>.1, <expr_signal>.2)
               <contrainte_signaux> ::= <expr_signal> ":=:" <expr_signal> ;
                  def_egal (<expr_signal>.1, <expr_signal>.2)
         end chapter ;

         chapter 'RELATIONS SUR HORLOGES'
            rules
               <relation_horl> ::= <expr_signal> "^=" <l_horl_egales> ;
                  l_equ_hor-pre (<expr_signal>, <l_horl_egales>)
               <relation_horl> ::= <expr_signal> "^<" <l_horl_croissantes> ;
                  l_cro_hor-pre (<expr_signal>, <l_horl_croissantes>)
               <relation_horl> ::= <expr_signal> "^>" <l_horl_decroissantes> ;
                  l_dec_hor-pre (<expr_signal>, <l_horl_decroissantes>)
               <relation_horl> ::= <expr_signal> "^#" <l_horl_exclusives> ;
                  l_exc_hor-pre (<expr_signal>, <l_horl_exclusives>)

            rules
               <l_horl_egales> ::= <expr_signal> ;
                  l_equ_hor-list ((<expr_signal>))
               <l_horl_egales> ::= <expr_signal> "^=" <l_horl_egales> ;
                  l_equ_hor-pre (<expr_signal>, <l_horl_egales>)
               <l_horl_croissantes> ::= <expr_signal> ;
                  l_cro_hor-list ((<expr_signal>))
               <l_horl_croissantes> ::= <expr_signal> "^<" <l_horl_croissantes> ;
                  l_cro_hor-pre (<expr_signal>, <l_horl_croissantes>)
               <l_horl_decroissantes> ::= <expr_signal> ;
                  l_dec_hor-list ((<expr_signal>))
               <l_horl_decroissantes> ::=
                  <expr_signal> "^>" <l_horl_decroissantes> ;
                  l_dec_hor-pre (<expr_signal>, <l_horl_decroissantes>)
               <l_horl_exclusives> ::= <expr_signal> ;
                  l_exc_hor-list ((<expr_signal>))
               <l_horl_exclusives> ::= <expr_signal> "^#" <l_horl_exclusives> ;
                  l_exc_hor-pre (<expr_signal>, <l_horl_exclusives>)
         end chapter ;

         chapter 'DEPENDANCES'
            rules
               <dependances> ::= <signaux> "-->" <l_dependances> ;
                  l_dep-pre (<signaux>, <l_dependances>)
               <dependances> ::=
                  "{" <signaux> "-->" <signaux> "}" "when" <expr_signal> ;
                  dep_d (<signaux>.1, <signaux>.2, <expr_signal>)
               <l_dependances> ::= <signaux> ;
                  l_dep-list ((<signaux>))
               <l_dependances> ::= <signaux> "-->" <l_dependances> ;
                  l_dep-pre (<signaux>, <l_dependances>)
               <signaux> ::= <expr_signal> ;
                  <expr_signal>
               <signaux> ::= "{" <l_expr_signal> "}" ;
                  <l_expr_signal>
         end chapter ;
      end chapter ;

      chapter 'EXPRESSIONS SUR SIGNAUX'
         rules
            <expr_signal> ::= <expr_sequence> ;
               <expr_sequence>
            <expr_signal> ::= "^0" ;
               hnull ()

         chapter 'SEQUENCE ET RESTRUCTURATION'
            rules
               <expr_sequence> ::= <expr_sequence> "next" <expr_restruct> ;
                  sequ (<expr_sequence>, <expr_restruct>)
               <expr_sequence> ::= <expr_restruct> ;
                  <expr_restruct>
               <expr_restruct> ::= <expr_temporel> ":" <expr_temporel> ;
                  rest (<expr_temporel>.1, <expr_temporel>.2)
               <expr_restruct> ::= <expr_temporel> ;
                  <expr_temporel>
         end chapter ;

         chapter 'EXPRESSIONS MULTI-HORLOGES'
            -- Expressions temporelles
            rules
               <expr_temporel> ::= <expr_temporel> "default" <term_temporel> ;
                  mele (<expr_temporel>, <term_temporel>)
               <expr_temporel> ::= <term_temporel> ;
                  <term_temporel>
               <term_temporel> ::= <term_temporel> "when" <prim_temporel> ;
                  extr (<term_temporel>, <prim_temporel>)
               <term_temporel> ::= <prim_temporel> ;
                  <prim_temporel>

            -- Compteurs
            rules
               <prim_temporel> ::= <expr_horloge> "after" <expr_horloge> ;
                  nomb_a (<expr_horloge>.1, <expr_horloge>.2)
               <prim_temporel> ::= <expr_horloge> "from" <expr_horloge> ;
                  nomb_d (<expr_horloge>.1, <expr_horloge>.2)
               <prim_temporel> ::= <expr_horloge> "count" <expr_horloge> ;
                  nomb_m (<expr_horloge>.1, <expr_horloge>.2)
               <prim_temporel> ::= <expr_horloge> ;
                  <expr_horloge>
                  

            -- Expressions sur horloges
            rules
               <expr_horloge> ::= <expr_horloge> "^+" <term_horloge> ;
                  bsup (<expr_horloge>, <term_horloge>)
               <expr_horloge> ::= <expr_horloge> "^-" <term_horloge> ;
                  comp (<expr_horloge>, <term_horloge>)
               <expr_horloge> ::= <term_horloge> ;
                  <term_horloge>
               <term_horloge> ::= <term_horloge> "^*" <fact_horloge> ;
                  binf (<term_horloge>, <fact_horloge>)
               <term_horloge> ::= <fact_horloge> ;
                  <fact_horloge>
               <fact_horloge> ::= "when" <fact_horloge> ;
                  when1 (<fact_horloge>)
               <fact_horloge> ::= <expr_condition> ;
                  <expr_condition>
         end chapter ;

         chapter 'CONDITION SYNCHRONE'
            rules
               <expr_condition> ::=
                  "if" <expr_signal> "then" <expr_signal> "else" <expr_condition> ;
                  cond (<expr_signal>.1, <expr_signal>.2, <expr_condition>)
               <expr_condition> ::= <expr_index> ;
                  <expr_index>
         end chapter ;

         chapter 'EXPRESSIONS D INDEX'
            rules
               <expr_index> ::=
                  <term_index> ".." <term_index> "step" <term_index> ;
                  enum (<term_index>.1, <term_index>.2, <term_index>.3)
               <expr_index> ::= <term_index> ".." <term_index> ;
                  enum (<term_index>.1, <term_index>.2, nil ())
               <expr_index> ::= <term_index> ;
                  <term_index>
               <term_index> ::= <expr_logique> ;
                  <expr_logique>
         end chapter ;

         chapter 'EXPRESSIONS A VALEUR LOGIQUE'
            -- Expressions synchrones booleennes
            rules
               <expr_logique> ::= <expr_logique> "xor" <term_logique> ;
                  ouex (<expr_logique>, <term_logique>)
               <expr_logique> ::= <term_logique> ;
                  <term_logique>
               <term_logique> ::= <term_logique> "or" <fact_logique> ;
                  ou (<term_logique>, <fact_logique>)
               <term_logique> ::= <fact_logique> ;
                  <fact_logique>
               <fact_logique> ::= <fact_logique> "and" <prim_logique> ;
                  et (<fact_logique>, <prim_logique>)
               <fact_logique> ::= <prim_logique> ;
                  <prim_logique>
               <prim_logique> ::= "not" <prim_logique> ;
                  non (<prim_logique>)
               <prim_logique> ::= <expr_relation> ;
                  <expr_relation>

            -- Expressions de relation
            rules
               <expr_relation> ::= <term_relation> "==" <term_relation> ;
                  egeg (<term_relation>.1, <term_relation>.2)
               <expr_relation> ::= <term_relation> "<<=" <term_relation> ;
                  iieg (<term_relation>.1, <term_relation>.2)
               <expr_relation> ::= <term_relation> ;
                  <term_relation>
               <term_relation> ::= <expr_arithmetique> "=" <expr_arithmetique> ;
                  egal (<expr_arithmetique>.1, <expr_arithmetique>.2)
               <term_relation> ::= <expr_arithmetique> "/=" <expr_arithmetique> ;
                  diff (<expr_arithmetique>.1, <expr_arithmetique>.2)
               <term_relation> ::= <expr_arithmetique> ">" <expr_arithmetique> ;
                  supe (<expr_arithmetique>.1, <expr_arithmetique>.2)
               <term_relation> ::= <expr_arithmetique> ">=" <expr_arithmetique> ;
                  s_egal (<expr_arithmetique>.1, <expr_arithmetique>.2)
               <term_relation> ::= <expr_arithmetique> "<" <expr_arithmetique> ;
                  infe (<expr_arithmetique>.1, <expr_arithmetique>.2)
               <term_relation> ::= <expr_arithmetique> "<=" <expr_arithmetique> ;
                  i_egal (<expr_arithmetique>.1, <expr_arithmetique>.2)
               <term_relation> ::= <expr_arithmetique> ;
                  <expr_arithmetique>
                  
         end chapter ;

         chapter 'EXPRESSIONS A VALEUR ARITHMETIQUE ET VECTORIELLES'
            rules
               <expr_arithmetique> ::=
                  <expr_arithmetique> "+" <term_arithmetique> ;
                  plus (<expr_arithmetique>, <term_arithmetique>)
               <expr_arithmetique> ::=
                  <expr_arithmetique> "-" <term_arithmetique> ;
                  moin (<expr_arithmetique>, <term_arithmetique>)
               <expr_arithmetique> ::=
                  <expr_arithmetique> "|+" <term_arithmetique> ;
                  conc (<expr_arithmetique>, <term_arithmetique>)
               <expr_arithmetique> ::= <term_arithmetique> ;
                  <term_arithmetique>

            rules
               <term_arithmetique> ::=
                  <term_arithmetique> "*" <fact_arithmetique> ;
                  mult (<term_arithmetique>, <fact_arithmetique>)
               <term_arithmetique> ::=
                  <term_arithmetique> "*." <fact_arithmetique> ;
                  mmul (<term_arithmetique>, <fact_arithmetique>)
               <term_arithmetique> ::=
                  <term_arithmetique> "/" <fact_arithmetique> ;
                  divi (<term_arithmetique>, <fact_arithmetique>)
               <term_arithmetique> ::=
                  <term_arithmetique> "modulo" <fact_arithmetique> ;
                  mod (<term_arithmetique>, <fact_arithmetique>)
               <term_arithmetique> ::=
                  <term_arithmetique> "|*" <fact_arithmetique> ;
                  repe (<term_arithmetique>, <fact_arithmetique>)
               <term_arithmetique> ::= <fact_arithmetique> ;
                  <fact_arithmetique>
               <fact_arithmetique> ::=
                  <unaire_arithmetique> "**" <unaire_arithmetique> ;
                  puis (<unaire_arithmetique>.1, <unaire_arithmetique>.2)
               <fact_arithmetique> ::=
                  <unaire_arithmetique> "@" <unaire_arithmetique> ;
                  cplx (<unaire_arithmetique>.1, <unaire_arithmetique>.2)
               <fact_arithmetique> ::= <unaire_arithmetique> ;
                  <unaire_arithmetique>
         end chapter ;

         chapter 'UNAIRES ARITHMETIQUES'
            rules
               <unaire_arithmetique> ::= "+" <expr_dynamique> ;
                  <expr_dynamique>
               <unaire_arithmetique> ::= "-" <expr_dynamique> ;
                  nega (<expr_dynamique>)
               <unaire_arithmetique> ::= <expr_dynamique> ;
                  <expr_dynamique>
         end chapter ;

         chapter 'VARIABLES'
            rules
               <expr_dynamique> ::=
                  <expr_dynamique> "cell" <expr_composite> <o_expr_init> ;
                  memo (<expr_dynamique>, <expr_composite>, <o_expr_init>)
               <expr_dynamique> ::= "var" <expr_composite> <o_expr_init> ;
                  var (<expr_composite>, <o_expr_init>)
         end chapter ;

         chapter 'EXPRESSIONS DE DECALAGE TEMPOREL'
            rules
               <expr_dynamique> ::= <expr_dynamique> <retard> <o_expr_init> ;
                  ret (<expr_dynamique>, <retard>, <o_expr_init>)
               <expr_dynamique> ::= <expr_dynamique> <fenetre> <o_expr_init> ;
                  fen (<expr_dynamique>, <fenetre>, <o_expr_init>)
               <retard> ::= "$" <expr_composite> ;
                  <expr_composite>
               <retard> ::= "$" ;
                  ret_un ()
               <fenetre> ::= "window" <expr_composite> ;
                  <expr_composite>
               <expr_dynamique> ::= <expr_composite> ;
                  <expr_composite>
         end chapter ;

         chapter 'EXPRESSIONS D INITIALISATION'
            rules
               <o_expr_init> ::= ;
                  nil ()
               <o_expr_init> ::= <expr_init> ;
                  <expr_init>
               <expr_init> ::= "init" <expr_composite> ;
                  <expr_composite>
         end chapter ;

         chapter 'EXPRESSIONS SUR SIGNAUX COMPOSITES'
            rules
               <expr_composite> ::= "tr" <expr_composite> ;
                  tran (<expr_composite>)
               <expr_composite> ::= <term_composite> ;
                  <term_composite>

            -- Recuperation
            rules
               <term_composite> ::= <expr_flot> "\\" <expr_flot> ;
                  recu (<expr_flot>.1, <expr_flot>.2)
               <term_composite> ::= <expr_flot> ;
                  <expr_flot>
         end chapter ;

         chapter 'VALEURS DE FLOTS'
            -- Horloge
            rules
               <expr_flot> ::= "^" <expr_flot> ;
                  evnt (<expr_flot>)
               <expr_flot> ::= <term_flot> ;
                  <term_flot>

            rules
               <term_flot> ::= <exemplaire_processus> ;
                  <exemplaire_processus>
               <term_flot> ::= <conversion> ;
                  <conversion>
               <term_flot> ::= <enumeration_vectoriel> ;
                  <enumeration_vectoriel>
               <term_flot> ::= <produit_index> ;
                  <produit_index>
               <term_flot> ::= <fact_flot> ;
                  <fact_flot>

            rules
               <fact_flot> ::= <fact_flot> "[" <l_expr_signal> "]" ;
                  elem (<fact_flot>, <l_expr_signal>)
               <fact_flot> ::= <fact_flot> "[" "?" "]" ;
                  sdec (<fact_flot>)
               <fact_flot> ::= <fact_flot> "." <identificateur> ;
                  cham (<fact_flot>, <identificateur>)
               <fact_flot> ::= "#" <identificateur> ;
                  v_enum (nil (), <identificateur>)
               <fact_flot> ::= <identificateur> "#" <identificateur> ;
                  v_enum (<identificateur>.1, <identificateur>.2)
               <fact_flot> ::= <identificateur> "?" ;
                  v_var_in (<identificateur>)
               <fact_flot> ::= <atom_flot> ;
                  <atom_flot>

            rules
               <atom_flot> ::= <constante> ;
                  <constante>
               <atom_flot> ::= <identificateur> ;
                  <identificateur>
               <atom_flot> ::= "(" <expr_signal> ")" ;
                  <expr_signal>
               <atom_flot> ::= <l_expr_flot> ;
                  l_e_flot-list (<l_expr_flot>)
               <l_expr_flot> ::= "(" <expr_signal> "," <l_expr_signal> ")" ;
                  l_e_sign-pre (<expr_signal>, <l_expr_signal>)
         end chapter ;

         chapter 'CONVERSION'
            rules
               <conversion> ::= <type_predefini> "(" <expr_signal> ")" ;
                  conv (<type_predefini>, <expr_signal>)
         end chapter ;

         chapter 'PRODUIT D INDEX'
            rules
               <produit_index> ::= "<<" <l_expr_signal> ">>" ;
                  pcar (<l_expr_signal>)
         end chapter ;

         chapter 'VECTEURS DEFINIS PAR ENUMERATION'
            -- A modifier
            rules
               <enumeration_vectoriel> ::= "[" <l_expr_signal> "]" ;
                  l_e_vect-list (<l_expr_signal>)     -- here, the list-operator is changed, it becomes oplevect
               <enumeration_vectoriel> ::= "[" "]" ;
                  tab_vide ()
               <enumeration_vectoriel> ::= "[" <element_multiple> "]" ;
                  l_ele_vec-list ((<element_multiple>))
               <enumeration_vectoriel> ::= "[" <element_multiple> "," <l_elements_vecteur> "]" ;
                  l_ele_vec-pre (<element_multiple>, <l_elements_vecteur>)
               <l_elements_vecteur> ::= <element_vecteur> ;
                  l_ele_vec-list ((<element_vecteur>))
               <l_elements_vecteur> ::=
                  <l_elements_vecteur> "," <element_vecteur> ;
                  l_ele_vec-post (<l_elements_vecteur>, <element_vecteur>)
               <element_vecteur> ::= <element_simple> ;
                  <element_simple>
               <element_vecteur> ::= <element_multiple> ;
                  <element_multiple>
               <element_simple> ::= <expr_dimension> ":" <expr_signal> ;
                  ele_vec (<expr_dimension>, <expr_signal>)
               <element_multiple> ::= <parcours_de_vecteur> ":" <def_element_multiple> ;
                  ens_vec (<parcours_de_vecteur>, <def_element_multiple>)
               <def_element_multiple> ::= <expr_signal> ;
                  <expr_signal>

            -- Parcours
            rules
               <parcours_de_vecteur> ::= "{" <l_parcours_de_parties> "}" ;
                  <l_parcours_de_parties>
               <l_parcours_de_parties> ::= <parcours_de_partie> ;
                  l_parc-list ((<parcours_de_partie>))
               <l_parcours_de_parties> ::=
                  <l_parcours_de_parties> "," <parcours_de_partie> ;
                  l_parc-post (<l_parcours_de_parties>, <parcours_de_partie>)
               <parcours_de_partie> ::= <o_index> <bornes> ;
                  parc (<o_index>, <bornes>)
               <o_index> ::= ;
                  nil ()
               <o_index> ::= <identificateur> ;
                  <identificateur>
               <bornes> ::= <o_borne_inf> <o_borne_sup> <o_pas> ;
                  born (<o_borne_inf>, <o_borne_sup>, <o_pas>)
               <o_borne_inf> ::= ;
                  nil ()
               <o_borne_inf> ::= <borne_inf> ;
                  <borne_inf>
               <o_borne_sup> ::= ;
                  nil ()
               <o_borne_sup> ::= <borne_sup> ;
                  <borne_sup>
               <borne_inf> ::= "in" <term_flot> ;
                  <term_flot>
               <borne_sup> ::= "to" <term_flot> ;
                  <term_flot>
               <pas> ::= "step" <term_flot> ;
                  <term_flot>
               <o_pas> ::= ;
                  nil ()
               <o_pas> ::= <pas> ;
                  <pas>
         end chapter ;

         chapter 'CONSTANTES'
            rules
               <constante> ::= <constante_logique> ;
                  <constante_logique>
               <constante> ::= <constante_entier> ;
                  <constante_entier>
               <constante> ::= <constante_reel> ;
                  <constante_reel>
               <constante> ::= <constante_double_precision> ;
                  <constante_double_precision>
               <constante> ::= <constante_caractere> ;
                  <constante_caractere>
               <constante> ::= <chaine> ;
                  <chaine>

            -- Constante logique
            rules
               <constante_logique> ::= "false" ;
                  false ()
               <constante_logique> ::= "true" ;
                  true ()
            

            -- Constante entiere
            rules
               <constante_entier> ::= %ENTIER ;
                  cst_ent-atom(%ENTIER)
            

            -- Constante reelle
            rules
               <constante_reel> ::= %REEL ;
                  cst_reel-atom(%REEL)

            -- Constante double precision
            rules
               <constante_double_precision> ::= %DREEL ;
                  cst_dp-atom(%DREEL)

            -- Constante caractere
            rules
               <constante_caractere> ::= %CAR ;
                  cst_car-atom(%CAR)

            -- Constante chaine
            rules
               <chaine> ::= <constante_chaine> ;
                  chai-list ((<constante_chaine>))
               <chaine> ::= <chaine> <constante_chaine> ;
                  chai-post (<chaine>, <constante_chaine>)
               <constante_chaine> ::= %CHAINE ;
                  cst_cha-atom(%CHAINE)
         end chapter ;
      end chapter ;

      chapter 'OPERATEURS'
         rules
            <operateur> ::= "^0" ;
               op-atom('^0')
            <operateur> ::= "next" ;
               op-atom('next')
            <operateur> ::= ":" ;
               op-atom(':')
            <operateur> ::= "default" ;
               op-atom('default')
            <operateur> ::= "when" ;
               op-atom('when')
            <operateur> ::= "after" ;
               op-atom('after')
            <operateur> ::= "from" ;
               op-atom('from')
            <operateur> ::= "count" ;
               op-atom('count')
            <operateur> ::= "^+" ;
               op-atom('^+')
            <operateur> ::= "^-" ;
               op-atom('^-')
            <operateur> ::= "^*" ;
               op-atom('^*')
            <operateur> ::= "if" ;
               op-atom('if')
            <operateur> ::= ".." ;
               op-atom('..')
            <operateur> ::= "xor" ;
               op-atom('xor')
            <operateur> ::= "or" ;
               op-atom('or')
            <operateur> ::= "and" ;
               op-atom('and')
            <operateur> ::= "not" ;
               op-atom('and')
            <operateur> ::= "==" ;
               op-atom('==')
            <operateur> ::= "<<=" ;
               op-atom('<<=')
            <operateur> ::= "=" ;
               op-atom('=')
            <operateur> ::= "/=" ;
               op-atom('/=')
            <operateur> ::= ">" ;
               op-atom('>')
            <operateur> ::= ">=" ;
               op-atom('>=')
            <operateur> ::= "<" ;
               op-atom('<')
            <operateur> ::= "<=" ;
               op-atom('<=')
            <operateur> ::= "+" ;
               op-atom('+')
            <operateur> ::= "-" ;
               op-atom('-')
            <operateur> ::= "|+" ;
               op-atom('|+')
            <operateur> ::= "*" ;
               op-atom('*')
            <operateur> ::= "*." ;
               op-atom('*.')
            <operateur> ::= "/" ;
               op-atom('/')
            <operateur> ::= "modulo" ;
               op-atom('modulo')
            <operateur> ::= "|*" ;
               op-atom('|*')
            <operateur> ::= "**" ;
               op-atom('**')
            <operateur> ::= "@" ;
               op-atom('@')
            <operateur> ::= "cell" ;
               op-atom('cell')
            <operateur> ::= "var" ;
               op-atom('var')
            <operateur> ::= "$" ;
               op-atom('$')
            <operateur> ::= "window" ;
               op-atom('window')
            <operateur> ::= "tr" ;
               op-atom('tr')
            <operateur> ::= "\\" ;
               op-atom('\\')
            <operateur> ::= "^" ;
               op-atom('^')
            <operateur> ::= "event" ;
               op-atom('event')
            <operateur> ::= "boolean" ;
               op-atom('boolean')
            <operateur> ::= "short" ;
               op-atom('short')
            <operateur> ::= "integer" ;
               op-atom('integer')
            <operateur> ::= "long" ;
               op-atom('long')
            <operateur> ::= "real" ;
               op-atom('real')
            <operateur> ::= "dreal" ;
               op-atom('dreal')
            <operateur> ::= "complex" ;
               op-atom('complex')
            <operateur> ::= "dcomplex" ;
               op-atom('dcomplex')
            <operateur> ::= "char" ;
               op-atom('char')
            <operateur> ::= "string" ;
               op-atom('string')
            <operateur> ::= "false" ;
               op-atom('false')
            <operateur> ::= "true" ;
               op-atom('true')
      end chapter ;
   end chapter ;

   chapter DOMAINES
      chapter OPERATORS
         chapter NULLARY
            abstract syntax
               nom  -> implemented as IDENTIFIER ;
               char  -> implemented as SINGLETON ;
               complex  -> implemented as SINGLETON ;
               cst_car  -> implemented as STRING ;
               cst_cha  -> implemented as STRING ;
               cst_dp  -> implemented as STRING ;
               cst_ent  -> implemented as STRING ;
               cst_reel  -> implemented as STRING ;
               dcomplex  -> implemented as SINGLETON ;
               determ  -> implemented as SINGLETON ;
               dpreal  -> implemented as SINGLETON ;
               event  -> implemented as SINGLETON ;
               false  -> implemented as SINGLETON ;
               hnull  -> implemented as SINGLETON ;
               implicit  -> implemented as SINGLETON ;
               integer  -> implemented as SINGLETON ;

            abstract syntax
               logical  -> implemented as SINGLETON ;
               long  -> implemented as SINGLETON ;
               nil  -> implemented as SINGLETON ;
               null_proc  -> implemented as SINGLETON ;
               op  -> implemented as STRING ;
               real  -> implemented as SINGLETON ;
               ret_un  -> implemented as SINGLETON ;
               safe  -> implemented as SINGLETON ;
               short  -> implemented as SINGLETON ;
               string  -> implemented as SINGLETON ;
               tab_vide  -> implemented as SINGLETON ;
               true  -> implemented as SINGLETON ;
               unsafe  -> implemented as SINGLETON ;
               meta  -> implemented as IDENTIFIER ;
               --                    %
               --                    %
               --                    1
               comment  -> implemented as STRING ;
         end chapter ;

         chapter UNARY
            abstract syntax
               appe_assert  -> E_SIGN ;
               evnt  -> E_SIGN ;
               exte  -> O_CHAI ;
               lab  -> L_IDENT ;
               nega  -> E_SIGN ;
               non  -> E_SIGN ;
               p_assert  -> E_PROC ;
               pcar  -> L_E_SIGN ;
               ref  -> L_IDENT ;
               sdec  -> E_SIGN ;
               stru  -> OL_DEC_S ;
               tran  -> E_SIGN ;
               v_var_in  -> IDENT ;
               when1  -> E_SIGN ;
         end chapter ;

         chapter BINARY
            abstract syntax
               appe  -> REF_PRO OL_E_SIGN ;
               binf  -> E_SIGN E_SIGN ;
               bsup  -> E_SIGN E_SIGN ;
               bund  -> OL_DEC_S O_E_PROC ;
               cas  -> ENU_VAL E_PROC ;
               cham  -> E_SIGN IDENT ;
               comp  -> E_SIGN E_SIGN ;
               conc  -> E_SIGN E_SIGN ;
               cons  -> IDENT D_CONS ;
               conv  -> I_TYPE E_SIGN ;
               cplx  -> E_SIGN E_SIGN ;
               dec_con  -> TYPE_S L_CONS ;
               dec_con_p  -> TYPE_S L_CONS ;
               dec_par  -> TYPE_S L_SIGN ;
               dec_sig  -> TYPE_S L_SIGN ;
               dec_var  -> TYPE_S L_SIGN ;
               def_egal  -> E_SIGN E_SIGN ;
               def_part  -> E_SIGN E_SIGN ;
               def_part_def  -> E_SIGN E_SIGN ;
               def_sig  -> E_SIGN E_SIGN ;
               desc  -> OL_PRAG O_CORP ;
               desc_modu  -> OL_PRAG OL_DECL ;
               diff  -> E_SIGN E_SIGN ;
               divi  -> E_SIGN E_SIGN ;
               egal  -> E_SIGN E_SIGN ;
               egeg  -> E_SIGN E_SIGN ;
               elem  -> E_SIGN OL_E_SIGN ;
               ele_vec  -> L_E_SIGN E_SIGN ;
               ens_vec  -> L_PARC E_SIGN ;
               ent_sor  -> OL_DEC_S OL_DEC_S ;
               et  -> E_SIGN E_SIGN ;
               extr  -> E_SIGN E_SIGN ;

            abstract syntax
               form_act  -> IDENT IDENT ;
               form_func  -> IDENT IDENT ;
               form_node  -> IDENT IDENT ;
               form_proc  -> IDENT IDENT ;
               i_egal  -> E_SIGN E_SIGN ;
               iieg  -> E_SIGN E_SIGN ;
               ind_mot  -> IDENT E_SIGN ;
               infe  -> E_SIGN E_SIGN ;
               init  -> IDENT E_SIGN ;
               inst  -> IDENT OL_E_PARA ;
               intv_ff  -> O_E_SIGN O_E_SIGN ;
               intv_fo  -> O_E_SIGN O_E_SIGN ;
               intv_of  -> O_E_SIGN O_E_SIGN ;
               intv_oo  -> O_E_SIGN O_E_SIGN ;
               mele  -> E_SIGN E_SIGN ;
               mmul  -> E_SIGN E_SIGN ;
               mod  -> E_SIGN E_SIGN ;
               modu  -> IDENT DESC_MODU ;
               moin  -> E_SIGN E_SIGN ;
               mult  -> E_SIGN E_SIGN ;
               nomb_a  -> E_SIGN E_SIGN ;
               nomb_d  -> E_SIGN E_SIGN ;
               nomb_m  -> E_SIGN E_SIGN ;

            abstract syntax
               obli  -> E_PROC L_IDENT ;
               ou  -> E_SIGN E_SIGN ;
               ouex  -> E_SIGN E_SIGN ;
               p_conf  -> E_PROC_EXTE OL_DECL ;
               p_etiq  -> IDENT E_PROC ;
               parc  -> O_IDENT BORN ;
               plus  -> E_SIGN E_SIGN ;
               puis  -> E_SIGN E_SIGN ;
               recu  -> E_SIGN E_SIGN ;
               repe  -> E_SIGN E_SIGN ;
               rest  -> E_SIGN E_SIGN ;
               s_egal  -> E_SIGN E_SIGN ;
               sequ  -> E_SIGN E_SIGN ;
               spec  -> OL_ATTR O_E_PROC ;
               supe  -> E_SIGN E_SIGN ;
               t_vect  -> OL_E_SIGN TYPE ;
               v_enum  -> O_IDENT IDENT ;
               var  -> E_SIGN O_E_SIGN ;
         end chapter ;

         chapter LISTS
            abstract syntax
               chai  -> CST_CHA + ... ;
               l_attr  -> ATTR + ... ;
               l_cas  -> CAS + ... ;
               l_cons  -> DEF_CONS + ... ;
               l_cro_hor  -> E_SIGN + ... ;
               l_dec_hor  -> E_SIGN + ... ;
               l_dec_s  -> DEC_S + ... ;
               l_decl  -> DECL + ... ;
               l_dep  -> LSIG + ... ;
               l_e_flot  -> E_SIGN + ... ;
               l_e_para  -> E_PARA + ... ;
               l_e_sign  -> E_SIGN + ... ;
               l_e_vect  -> E_SIGN + ... ;
               l_ele_vec  -> ELE_VEC + ... ;
               l_equ_hor  -> E_SIGN + ... ;
               l_exc_hor  -> E_SIGN + ... ;
               l_feed  -> E_PROC + ... ;
               l_ident  -> IDENT + ... ;
               l_impo  -> IDENT + ... ;
               l_modu  -> MODU + ... ;
               l_opra  -> IDENT + ... ;
               l_parc  -> PARC + ... ;
               l_prag  -> PRAG + ... ;
               l_sign  -> SIGN + ... ;
               l_type  -> DEF_TYPE + ... ;
               l_type_p  -> DEF_TYPE + ... ;
               t_enum  -> IDENT + ... ;
               comment_s  -> COMMENT * ... ;
         end chapter ;

         chapter TERNARY
            abstract syntax
               act  -> IDENT INTE DESC ;
               act_p  -> IDENT INTE DESC ;
               born  -> O_E_SIGN O_E_SIGN O_E_SIGN ;
               cond  -> E_SIGN E_SIGN E_SIGN ;
               dep_d  -> LSIG LSIG E_SIGN ;
               enum  -> E_SIGN E_SIGN O_E_SIGN ;
               fen  -> E_SIGN E_SIGN O_E_SIGN ;
               func  -> IDENT INTE DESC ;
               func_p  -> IDENT INTE DESC ;
               inte  -> OL_DEC_S ENT_SOR O_SPEC ;
               iter  -> E_SIGN E_PROC O_E_PROC ;
               memo  -> E_SIGN E_SIGN O_E_SIGN ;
               moti  -> IND_MOT E_PROC O_E_PROC ;
               node  -> IDENT INTE DESC ;
               node_p  -> IDENT INTE DESC ;
               oper  -> IDENT_OP INTE DESC ;
               p_cas  -> IDENT L_CAS E_PROC ;
               prag  -> IDENT OL_OPRA O_CHAI ;
               process  -> IDENT INTE DESC ;
               process_p  -> IDENT INTE DESC ;
               ret  -> E_SIGN D_E_SIGN O_E_SIGN ;
               type  -> TYPE D_TYPE O_E_SIGN ;
               type_act  -> IDENT INTE OL_PRAG;
               type_func  -> IDENT INTE OL_PRAG;
               type_node  -> IDENT INTE OL_PRAG;
               type_proc  -> IDENT INTE OL_PRAG;
         end chapter ;
      end chapter ;

      chapter PHYLA_TABLE
         abstract syntax
            ATTR  ::= determ safe unsafe ;
            BORN  ::= born ;
            CAS  ::= cas ;
            CHAI  ::= chai ;
            COMMENT  ::= comment ;
            CST_CHA  ::= cst_cha ;
            CST_ENT  ::= cst_ent ;
            DEC_S  ::=
               dec_sig form_act form_func form_node form_proc l_type l_type_p ;
            DESC  ::= desc ;
            DESC_MODU  ::= desc_modu ;
            E_PAR  ::= l_e_flot l_e_vect l_ele_vec pcar tab_vide ;
            ELE_VEC  ::= ele_vec ens_vec ;
            ENT_SOR  ::= ent_sor ;
            EXTE  ::= exte ;
            I_TYPE  ::=
               char complex dcomplex dpreal event integer logical long real
               short string ;
            IDENT  ::= nom ;
            IND_MOT  ::= ind_mot ;
            INST  ::= inst ;

         abstract syntax
            L_CAS  ::= l_cas ;
            L_CONS  ::= l_cons ;
            L_E_SIGN  ::= l_e_sign ;
            L_IDENT  ::= l_ident ;
            L_PARC  ::= l_parc ;
            L_SIGN  ::= l_sign ;
            MODU  ::= modu ;
            O_SPEC  ::= spec nil ;
            OL_ATTR  ::= l_attr nil ;
            OL_DECL  ::= l_decl nil ;
            OL_DEC_S  ::= l_dec_s nil ;
            OL_E_PARA  ::= l_e_para nil ;
            OL_OPRA  ::= l_opra nil ;
            OL_PRAG  ::= l_prag nil ;
            PARC  ::= parc ;
            PRAG  ::= prag ;

         abstract syntax
            DECL  ::=
               DEC_S act act_p dec_con dec_con_p dec_par dec_var func func_p l_impo lab
               node node_p oper process process_p ref ;
            DEF_CONS  ::= IDENT cons ;
            DEF_TYPE  ::= IDENT type type_act type_func type_node type_proc ;
            E_CST  ::= CHAI CST_ENT cst_car cst_dp cst_reel false true ;
            ENU_VAL  ::= L_E_SIGN intv_ff intv_fo intv_of intv_oo ;
            EXE_PRO  ::= INST appe appe_assert ;
            IDENT_OP  ::= IDENT op ;
            INTE  ::= IDENT inte ;
            O_CHAI  ::= CHAI nil ;
            O_IDENT  ::= IDENT nil ;
            OL_E_SIGN  ::= L_E_SIGN nil ;
            REF_PRO  ::= IDENT INST ;
            SIGN  ::= IDENT init ;
            TYP_DEC  ::= I_TYPE bund stru t_enum t_vect ;

         abstract syntax
            E_BASE  ::= E_CST IDENT ;
            E_PROC  ::=
               EXE_PRO def_egal def_part def_part_def def_sig dep_d iter
               l_cro_hor l_dec_hor l_dep l_equ_hor l_exc_hor l_feed moti
               null_proc obli p_assert p_cas p_conf p_etiq ;
            TYPE  ::= IDENT TYP_DEC ;

         abstract syntax
            E_NPAR  ::= E_BASE EXE_PRO conv ;
            O_E_PROC  ::= E_PROC nil ;
            TYPE_S  ::= TYPE implicit ;
            V_PROC  ::= E_PROC EXTE ;
            V_TYPE  ::= EXTE TYPE ;

         abstract syntax
            E_ATOM  ::= E_NPAR E_PAR ;
            O_CORP  ::= V_PROC nil ;

         abstract syntax
            E_FLOT  ::= E_ATOM cham elem evnt sdec v_enum v_var_in ;

         abstract syntax
            E_COMP  ::= E_FLOT recu tran ;

         abstract syntax
            E_DYNA  ::= E_COMP fen memo ret var ;

         abstract syntax
            E_ARIT1  ::= E_DYNA nega ;

         abstract syntax
            E_ARIT  ::=
               E_ARIT1 conc cplx divi mmul mod moin mult plus puis repe ;

         abstract syntax
            E_LOGI  ::=
               E_ARIT diff egal egeg et i_egal iieg infe non ou ouex s_egal supe ;

         abstract syntax
            E_INDE  ::= E_LOGI enum ;

         abstract syntax
            E_COND  ::= E_INDE cond ;

         abstract syntax
            E_HORL  ::= E_COND binf bsup comp when1 ;

         abstract syntax
            E_TEMP  ::= E_HORL extr mele nomb_a nomb_d nomb_m ;

         abstract syntax
            E_REST  ::= E_TEMP rest ;

         abstract syntax
            E_SEQU  ::= E_REST sequ ;

         abstract syntax
            E_SIGN  ::= E_SEQU hnull ;

         abstract syntax
            LSIG  ::= E_SIGN L_E_SIGN ;
            D_E_SIGN  ::= E_SIGN ret_un ;
            E_PARA  ::= E_SIGN TYP_DEC ;
            O_E_SIGN  ::= E_SIGN nil ;
            V_CONS  ::= E_SIGN EXTE ;
      end chapter ;
   end chapter ;

   chapter EDITEUR
      rules
         <axiome_signal> ::= <axiome_edition> ;
            <axiome_edition>

      chapter AXIOMES_EDITION
         rules
            <axiome_edition> ::= "[ATTR]" <attribut> ;
               <attribut>
            <axiome_edition> ::= "[BORN]" <bornes> ;
               <bornes>
            <axiome_edition> ::= "[CAS]" <cas> ;
               <cas>
            <axiome_edition> ::= "[CHAI]" <chaine> ;
               <chaine>
            <axiome_edition> ::= "[CST_CHA]" <constante_chaine> ;
               <constante_chaine>
            <axiome_edition> ::= "[DEC_S]" <decl_suites> ;
               <decl_suites>
            <axiome_edition> ::= "[DEC_S]" <decl_suites> ";" ;
               <decl_suites>
            <axiome_edition> ::= "[DESC]" <description> ;
               <description>
            <axiome_edition> ::= "[DESC_MODU]" <description_module> ;
               <description_module>
            <axiome_edition> ::= "[ELE_VEC]" <element_vecteur> ;
               <element_vecteur>
            <axiome_edition> ::= "[ENT_SOR]" <entrees_sorties> ;
               <entrees_sorties>
            <axiome_edition> ::= "[I_TYPE]" <type_predefini> ;
               <type_predefini>
            <axiome_edition> ::= "[IDENT]" <identificateur> ;
               <identificateur>
            <axiome_edition> ::= "[IND_MOT]" <indice_motif> ;
               <indice_motif>

         rules
            <axiome_edition> ::= "[L_CAS]" <l_cas> ;
               <l_cas>
            <axiome_edition> ::= "[L_CONS]" <l_def_constantes> ;
               <l_def_constantes>
            <axiome_edition> ::= "[L_E_SIGN]" <l_expr_signal> ;
               <l_expr_signal>
            <axiome_edition> ::= "[L_IDENT]" <l_identificateurs> ;
               <l_identificateurs>
            <axiome_edition> ::= "[L_PARC]" <l_parcours_de_parties> ;
               <l_parcours_de_parties>
            <axiome_edition> ::= "[L_SIGN]" <l_signaux> ;
               <l_signaux>
            <axiome_edition> ::= "[MODU]" <module> ;
               <module>
            <axiome_edition> ::= "[O_SPEC]" <graphe_externe> ;
               <graphe_externe>
            <axiome_edition> ::= "[O_SPEC]" <expr_processus> ;
               spec (nil (), <expr_processus>)
            <axiome_edition> ::= "[OL_ATTR]" <l_attributs> ;
               <l_attributs>
            <axiome_edition> ::= "[OL_ATTR]" ;
               nil ()
            <axiome_edition> ::= "[OL_DECL]" <o_l_declarations> ;
               <o_l_declarations>
            <axiome_edition> ::= "[OL_DEC_S]" <o_l_decl_suites> ;
               <o_l_decl_suites>
            <axiome_edition> ::= "[OL_E_PARA]" <o_l_expr_param> ;
               <o_l_expr_param>
            <axiome_edition> ::= "[OL_OPRA]" <o_l_objets_pragma> ;
               <o_l_objets_pragma>
            <axiome_edition> ::= "[OL_PRAG]" <o_l_pragmas> ;
               <o_l_pragmas>
            <axiome_edition> ::= "[OL_PRAG]" <l_pragmas> ;
               <l_pragmas>
            <axiome_edition> ::= "[PARC]" <parcours_de_partie> ;
               <parcours_de_partie>
            <axiome_edition> ::= "[PRAG]" <pragma> ;
               <pragma>

         rules
            <axiome_edition> ::= "[DECL]" <declaration> ;
               <declaration>
            <axiome_edition> ::= "[DECL]" <declaration> ";" ;
               <declaration>
            <axiome_edition> ::= "[DEF_CONS]" <def_constante> ;
               <def_constante>
            <axiome_edition> ::= "[DEF_TYPE]" <def_type> ;
               <def_type>
            <axiome_edition> ::= "[E_CST]" <constante> ;
               <constante>
            <axiome_edition> ::= "[ENU_VAL]" <enumeration_valeurs> ;
               <enumeration_valeurs>
            <axiome_edition> ::= "[IDENT_OP]" <ident_operateur> ;
               <ident_operateur>
            <axiome_edition> ::= "[INTE]" <def_interface> ;
               <def_interface>
            <axiome_edition> ::= "[O_CHAI]" <chaine> ;
               <chaine>
            <axiome_edition> ::= "[O_CHAI]" ;
               nil ()
            <axiome_edition> ::= "[O_IDENT]" <o_index> ;
               <o_index>
            <axiome_edition> ::= "[OL_E_SIGN]" <o_l_expr_signal> ;
               <o_l_expr_signal>
            <axiome_edition> ::= "[REF_PRO]" <reference_processus> ;
               <reference_processus>
            <axiome_edition> ::= "[SIGN]" <signal> ;
               <signal>

         rules
            <axiome_edition> ::= "[E_PROC]" <expr_processus> ;
               <expr_processus>
            <axiome_edition> ::= "[TYPE]" <type> ;
               <type>

         rules
            <axiome_edition> ::= "[O_E_PROC]" <expr_processus> ;
               <expr_processus>
            <axiome_edition> ::= "[O_E_PROC]" ;
               nil ()
            <axiome_edition> ::= "[TYPE_S]" <type> ;
               <type>
            <axiome_edition> ::= "[TYPE_S]" ;
               implicit ()
            <axiome_edition> ::= "[V_PROC]" <expr_processus> ;
               <expr_processus>
            <axiome_edition> ::= "[V_PROC]" <indication_externe> ;
               <indication_externe>
            <axiome_edition> ::= "[V_TYPE]" <valeur_type> ;
               <valeur_type>

         rules
            <axiome_edition> ::= "[O_CORP]" <o_corps> ;
               <o_corps>

         rules
            <axiome_edition> ::= "[E_SIGN]" <expr_signal> ;
               <expr_signal>

         rules
            <axiome_edition> ::= "[LSIG]" <signaux> ;
               <signaux>
            <axiome_edition> ::= "[D_E_SIGN]" <expr_signal> ;
               <expr_signal>
            <axiome_edition> ::= "[D_E_SIGN]" <retard> ;
               <retard>
            <axiome_edition> ::= "[E_PARA]" <expr_param> ;
               <expr_param>
            <axiome_edition> ::= "[O_E_SIGN]" <expr_signal> ;
               <expr_signal>
            <axiome_edition> ::= "[O_E_SIGN]" ;
               nil ()
            <axiome_edition> ::= "[V_CONS]" <valeur_constante> ;
               <valeur_constante>

      end chapter ;
   end chapter ;
end definition

