/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em><b>Arithmetic Op Kind</b></em>', and
 * utility methods for working with them. <!-- end-user-doc --> <!-- begin-model-doc --> This enumeration contains the
 * different kind of arithmetic operators of the Signal language. <!-- end-model-doc -->
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getArithmeticOpKind()
 * @model annotation="http://www.topcased.org/uuid uuid='_2JbvEe5WEduz9o2pAin6-g'"
 * @generated
 */
public enum ArithmeticOpKind implements Enumerator {
	/**
	 * The '<em><b>Addition</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #ADDITION
	 * @generated
	 * @ordered
	 */
	ADDITION_LITERAL(0, "Addition", "Addition"),

	/**
	 * The '<em><b>Substraction</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #SUBSTRACTION
	 * @generated
	 * @ordered
	 */
	SUBSTRACTION_LITERAL(1, "Substraction", "Substraction"),

	/**
	 * The '<em><b>Multiplication</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #MULTIPLICATION
	 * @generated
	 * @ordered
	 */
	MULTIPLICATION_LITERAL(2, "Multiplication", "Multiplication"),

	/**
	 * The '<em><b>Division</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #DIVISION
	 * @generated
	 * @ordered
	 */
	DIVISION_LITERAL(3, "Division", "Division"),

	/**
	 * The '<em><b>Modulo</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #MODULO
	 * @generated
	 * @ordered
	 */
	MODULO_LITERAL(4, "Modulo", "Modulo"),

	/**
	 * The '<em><b>Power</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #POWER
	 * @generated
	 * @ordered
	 */
	POWER_LITERAL(5, "Power", "Power");
	
	/**
	 * The '<em><b>Addition</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Addition</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #ADDITION_LITERAL
	 * @model name="Addition" annotation="http://www.topcased.org/uuid uuid='_2JlgEO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						ADDITION		= 0;
	
	/**
	 * The '<em><b>Substraction</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Substraction</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #SUBSTRACTION_LITERAL
	 * @model name="Substraction" annotation="http://www.topcased.org/uuid uuid='_2JlgEe5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						SUBSTRACTION	= 1;
	
	/**
	 * The '<em><b>Multiplication</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Multiplication</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #MULTIPLICATION_LITERAL
	 * @model name="Multiplication" annotation="http://www.topcased.org/uuid uuid='_2JlgEu5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						MULTIPLICATION	= 2;
	
	/**
	 * The '<em><b>Division</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Division</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #DIVISION_LITERAL
	 * @model name="Division" annotation="http://www.topcased.org/uuid uuid='_2JlgE-5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						DIVISION		= 3;
	
	/**
	 * The '<em><b>Modulo</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Modulo</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #MODULO_LITERAL
	 * @model name="Modulo" annotation="http://www.topcased.org/uuid uuid='_2JvREO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						MODULO			= 4;
	
	/**
	 * The '<em><b>Power</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Power</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #POWER_LITERAL
	 * @model name="Power" annotation="http://www.topcased.org/uuid uuid='_2JvREe5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						POWER			= 5;
	
	/**
	 * An array of all the '<em><b>Arithmetic Op Kind</b></em>' enumerators. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	private static final ArithmeticOpKind[]		VALUES_ARRAY	= new ArithmeticOpKind[] { ADDITION_LITERAL,
			SUBSTRACTION_LITERAL, MULTIPLICATION_LITERAL, DIVISION_LITERAL, MODULO_LITERAL, POWER_LITERAL, };
	
	/**
	 * A public read-only list of all the '<em><b>Arithmetic Op Kind</b></em>' enumerators. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static final List<ArithmeticOpKind>	VALUES			= Collections.unmodifiableList(Arrays
																		.asList(VALUES_ARRAY));
	
	/**
	 * Returns the '<em><b>Arithmetic Op Kind</b></em>' literal with the specified literal value. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ArithmeticOpKind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ArithmeticOpKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Arithmetic Op Kind</b></em>' literal with the specified name. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static ArithmeticOpKind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ArithmeticOpKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Arithmetic Op Kind</b></em>' literal with the specified integer value. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ArithmeticOpKind get(int value) {
		switch (value) {
			case ADDITION:
				return ADDITION_LITERAL;
			case SUBSTRACTION:
				return SUBSTRACTION_LITERAL;
			case MULTIPLICATION:
				return MULTIPLICATION_LITERAL;
			case DIVISION:
				return DIVISION_LITERAL;
			case MODULO:
				return MODULO_LITERAL;
			case POWER:
				return POWER_LITERAL;
		}
		return null;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final int		value;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	name;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	literal;
	
	/**
	 * Only this class can construct instances. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private ArithmeticOpKind(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int getValue() {
		return value;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getLiteral() {
		return literal;
	}
	
	/**
	 * Returns the literal value of the enumerator, which is its string representation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} // ArithmeticOpKind
