/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Automaton</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Automaton#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Automaton#getInitState <em>Init State</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Automaton#getTransitions <em>Transitions</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getAutomaton()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOgCO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Automaton extends CompoundState, ClockedExpr, DependenceInOut {
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getAutomata <em>Automata</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getAutomaton_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getAutomata
	 * @model opposite="automata" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOgCe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Automaton#getModelParent <em>Model Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * Returns the value of the '<em><b>Init State</b></em>' reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Init State</em>' reference isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Init State</em>' reference.
	 * @see #setInitState(StateBase)
	 * @see fr.irisa.espresso.sme.SmePackage#getAutomaton_InitState()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOgCu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	StateBase getInitState();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Automaton#getInitState <em>Init State</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Init State</em>' reference.
	 * @see #getInitState()
	 * @generated
	 */
	void setInitState(StateBase value);
	
	/**
	 * Returns the value of the '<em><b>Transitions</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.Transition}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.Transition#getAutomatonParent <em>Automaton Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Transitions</em>' containment reference list isn't clear, there really should be more
	 * of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Transitions</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getAutomaton_Transitions()
	 * @see fr.irisa.espresso.sme.Transition#getAutomatonParent
	 * @model opposite="automatonParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOgC-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<Transition> getTransitions();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This method returns the AST of the current
	 * state signal
	 * 
	 * @return a node representing the identifier of the current state signal
	 * 
	 *         <!-- end-model-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	long getCurrentStateNameAST();
	
	long getzNextStateNameAST(); // added by lbesnard, to be revisited (sme dependant).
	
} // Automaton
