/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Basic Iterate</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.BasicIterate#getIterationInit <em>Iteration Init</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.BasicIterate#getIterator <em>Iterator</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.BasicIterate#getUpperBound <em>Upper Bound</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.BasicIterate#getIteratorName <em>Iterator Name</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getBasicIterate()
 * @model
 * @generated
 */
public interface BasicIterate extends SubProcess {
	/**
	 * Returns the value of the '<em><b>Iteration Init</b></em>' containment reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.IterationInit#getArrayParent <em>Array Parent</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Iteration Init</em>' containment reference isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Iteration Init</em>' containment reference.
	 * @see #setIterationInit(IterationInit)
	 * @see fr.irisa.espresso.sme.SmePackage#getBasicIterate_IterationInit()
	 * @see fr.irisa.espresso.sme.IterationInit#getArrayParent
	 * @model opposite="arrayParent" containment="true" required="true"
	 * @generated
	 */
	IterationInit getIterationInit();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.BasicIterate#getIterationInit <em>Iteration Init</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Iteration Init</em>' containment reference.
	 * @see #getIterationInit()
	 * @generated
	 */
	void setIterationInit(IterationInit value);
	
	/**
	 * Returns the value of the '<em><b>Iterator</b></em>' containment reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Iterator#getArrayParent <em>Array Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Iterator</em>' containment reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Iterator</em>' containment reference.
	 * @see #setIterator(Iterator)
	 * @see fr.irisa.espresso.sme.SmePackage#getBasicIterate_Iterator()
	 * @see fr.irisa.espresso.sme.Iterator#getArrayParent
	 * @model opposite="arrayParent" containment="true" required="true"
	 * @generated
	 */
	Iterator getIterator();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.BasicIterate#getIterator <em>Iterator</em>}' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Iterator</em>' containment reference.
	 * @see #getIterator()
	 * @generated
	 */
	void setIterator(Iterator value);
	
	/**
	 * Returns the value of the '<em><b>Upper Bound</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Upper Bound</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Upper Bound</em>' attribute.
	 * @see #setUpperBound(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getBasicIterate_UpperBound()
	 * @model required="true"
	 * @generated
	 */
	String getUpperBound();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.BasicIterate#getUpperBound <em>Upper Bound</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Upper Bound</em>' attribute.
	 * @see #getUpperBound()
	 * @generated
	 */
	void setUpperBound(String value);
	
	/**
	 * Returns the value of the '<em><b>Iterator Name</b></em>' attribute. The default value is <code>""</code>. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Iterator Name</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Iterator Name</em>' attribute.
	 * @see #setIteratorName(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getBasicIterate_IteratorName()
	 * @model default="" required="true" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	String getIteratorName();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.BasicIterate#getIteratorName <em>Iterator Name</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Iterator Name</em>' attribute.
	 * @see #getIteratorName()
	 * @generated
	 */
	void setIteratorName(String value);
	
} // BasicIterate
