/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Boolean Expression</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.BooleanExpression#getExpression <em>Expression</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getBooleanExpression()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfx-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface BooleanExpression extends NamedElement, BooleanOperatorI {
	/**
	 * Returns the value of the '<em><b>Expression</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expression</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Expression</em>' attribute.
	 * @see #setExpression(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getBooleanExpression_Expression()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOfyO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getExpression();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.BooleanExpression#getExpression <em>Expression</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Expression</em>' attribute.
	 * @see #getExpression()
	 * @generated
	 */
	void setExpression(String value);
	
	/**
	 * If asCode is true, it returns the expression stored in the '<em>Expression</em>' attribute. Otherwise, it calls
	 * toString()
	 * 
	 * @param asCode
	 * @return
	 */
	public String toString(boolean asCode);
	
} // BooleanExpression
