/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Case Connection</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.CaseConnection#getCaseKind <em>Case Kind</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.CaseConnection#getEnumeration <em>Enumeration</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.CaseConnection#getLowerBound <em>Lower Bound</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.CaseConnection#getUpperBound <em>Upper Bound</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.CaseConnection#getCaseLabel <em>Case Label</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.CaseConnection#getSrc <em>Src</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.CaseConnection#getDst <em>Dst</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getCaseConnection()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfgO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface CaseConnection extends ModelConnection {
	/**
	 * Returns the value of the '<em><b>Case Kind</b></em>' attribute. The literals are from the enumeration
	 * {@link fr.irisa.espresso.sme.CaseKind}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Case Kind</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Case Kind</em>' attribute.
	 * @see fr.irisa.espresso.sme.CaseKind
	 * @see #setCaseKind(CaseKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getCaseConnection_CaseKind()
	 * @model unique="false" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfge5WEduz9o2pAin6-g'"
	 * @generated
	 */
	CaseKind getCaseKind();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.CaseConnection#getCaseKind <em>Case Kind</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Case Kind</em>' attribute.
	 * @see fr.irisa.espresso.sme.CaseKind
	 * @see #getCaseKind()
	 * @generated
	 */
	void setCaseKind(CaseKind value);
	
	/**
	 * Returns the value of the '<em><b>Enumeration</b></em>' attribute list. The list contents are of type
	 * {@link java.lang.String}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Enumeration</em>' attribute list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Enumeration</em>' attribute list.
	 * @see fr.irisa.espresso.sme.SmePackage#getCaseConnection_Enumeration()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfgu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<String> getEnumeration();
	
	/**
	 * Returns the value of the '<em><b>Lower Bound</b></em>' attribute. The default value is <code>""</code>. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lower Bound</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Lower Bound</em>' attribute.
	 * @see #setLowerBound(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getCaseConnection_LowerBound()
	 * @model default="" unique="false" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfg-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getLowerBound();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.CaseConnection#getLowerBound <em>Lower Bound</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Lower Bound</em>' attribute.
	 * @see #getLowerBound()
	 * @generated
	 */
	void setLowerBound(String value);
	
	/**
	 * Returns the value of the '<em><b>Upper Bound</b></em>' attribute. The default value is <code>""</code>. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Upper Bound</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Upper Bound</em>' attribute.
	 * @see #setUpperBound(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getCaseConnection_UpperBound()
	 * @model default="" unique="false" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfhO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getUpperBound();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.CaseConnection#getUpperBound <em>Upper Bound</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Upper Bound</em>' attribute.
	 * @see #getUpperBound()
	 * @generated
	 */
	void setUpperBound(String value);
	
	/**
	 * Returns the value of the '<em><b>Case Label</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Case Label</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Case Label</em>' attribute.
	 * @see fr.irisa.espresso.sme.SmePackage#getCaseConnection_CaseLabel()
	 * @model required="true" transient="true" changeable="false" volatile="true" derived="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfhe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getCaseLabel();
	
	/**
	 * Returns the value of the '<em><b>Src</b></em>' reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.Switch#getSrc_CaseConnections <em>Src Case Connections</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Src</em>' reference isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src</em>' reference.
	 * @see #setSrc(Switch)
	 * @see fr.irisa.espresso.sme.SmePackage#getCaseConnection_Src()
	 * @see fr.irisa.espresso.sme.Switch#getSrc_CaseConnections
	 * @model opposite="src_CaseConnections" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfhu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Switch getSrc();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.CaseConnection#getSrc <em>Src</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Src</em>' reference.
	 * @see #getSrc()
	 * @generated
	 */
	void setSrc(Switch value);
	
	/**
	 * Returns the value of the '<em><b>Dst</b></em>' reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.SubProcess#getDst_CaseConnection <em>Dst Case Connection</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Dst</em>' reference isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst</em>' reference.
	 * @see #setDst(SubProcess)
	 * @see fr.irisa.espresso.sme.SmePackage#getCaseConnection_Dst()
	 * @see fr.irisa.espresso.sme.SubProcess#getDst_CaseConnection
	 * @model opposite="dst_CaseConnection" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfh-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	SubProcess getDst();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.CaseConnection#getDst <em>Dst</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Dst</em>' reference.
	 * @see #getDst()
	 * @generated
	 */
	void setDst(SubProcess value);
	
} // CaseConnection
