/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Clocked Expr</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> ClockedExpr is an abstract meta-class that represents elements that can be used as the
 * source or target of a ClockRelation Connection. So it represents elements that can involve in clock relations or
 * clock constraints. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.ClockedExpr#getSrc_ClockRelations <em>Src Clock Relations</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ClockedExpr#getDst_ClockRelations <em>Dst Clock Relations</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getClockedExpr()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOe3e5WEduz9o2pAin6-g'"
 * @generated
 */
public interface ClockedExpr extends ConnectableElement {
	/**
	 * Returns the value of the '<em><b>Src Clock Relations</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.ClockRelation}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ClockRelation#getSrc <em>Src</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src Clock Relations</em>' reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc --> <!-- begin-model-doc --> This elements references all outgoing ClockRelation relations from
	 * the current element. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Src Clock Relations</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getClockedExpr_Src_ClockRelations()
	 * @see fr.irisa.espresso.sme.ClockRelation#getSrc
	 * @model opposite="src" annotation="http://www.topcased.org/uuid uuid='_2LOe3u5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ClockRelation> getSrc_ClockRelations();
	
	/**
	 * Returns the value of the '<em><b>Dst Clock Relations</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.ClockRelation}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ClockRelation#getDst <em>Dst</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst Clock Relations</em>' reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc --> <!-- begin-model-doc --> This elements references all incoming ClockRelation relations to
	 * the current element. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Dst Clock Relations</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getClockedExpr_Dst_ClockRelations()
	 * @see fr.irisa.espresso.sme.ClockRelation#getDst
	 * @model opposite="dst" annotation="http://www.topcased.org/uuid uuid='_2LOe3-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ClockRelation> getDst_ClockRelations();
	
} // ClockedExpr
