/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em><b>Comparison Op Kind</b></em>', and
 * utility methods for working with them. <!-- end-user-doc --> <!-- begin-model-doc --> This enumeration contains the
 * different kind of boolean comparison operators of the Signal language. <!-- end-model-doc -->
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getComparisonOpKind()
 * @model annotation="http://www.topcased.org/uuid uuid='_2JvREu5WEduz9o2pAin6-g'"
 * @generated
 */
public enum ComparisonOpKind implements Enumerator {
	/**
	 * The '<em><b>Equal</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #EQUAL
	 * @generated
	 * @ordered
	 */
	EQUAL_LITERAL(0, "Equal", "Equal"),

	/**
	 * The '<em><b>Not Equal</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #NOT_EQUAL
	 * @generated
	 * @ordered
	 */
	NOT_EQUAL_LITERAL(1, "NotEqual", "NotEqual"),

	/**
	 * The '<em><b>Greater</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #GREATER
	 * @generated
	 * @ordered
	 */
	GREATER_LITERAL(2, "Greater", "Greater"),

	/**
	 * The '<em><b>Greater Or Equal</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #GREATER_OR_EQUAL
	 * @generated
	 * @ordered
	 */
	GREATER_OR_EQUAL_LITERAL(3, "GreaterOrEqual", "GreaterOrEqual"),

	/**
	 * The '<em><b>Smaller</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #SMALLER
	 * @generated
	 * @ordered
	 */
	SMALLER_LITERAL(4, "Smaller", "Smaller"),

	/**
	 * The '<em><b>Smaller Or Equal</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #SMALLER_OR_EQUAL
	 * @generated
	 * @ordered
	 */
	SMALLER_OR_EQUAL_LITERAL(5, "SmallerOrEqual", "SmallerOrEqual"),

	/**
	 * The '<em><b>Equal Any</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #EQUAL_ANY
	 * @generated
	 * @ordered
	 */
	EQUAL_ANY_LITERAL(6, "EqualAny", "EqualAny"),

	/**
	 * The '<em><b>Smaller Or Equal Any</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #SMALLER_OR_EQUAL_ANY
	 * @generated
	 * @ordered
	 */
	SMALLER_OR_EQUAL_ANY_LITERAL(7, "SmallerOrEqualAny", "SmallerOrEqualAny");
	
	/**
	 * The '<em><b>Equal</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Equal</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #EQUAL_LITERAL
	 * @model name="Equal" annotation="http://www.topcased.org/uuid uuid='_2J4bAO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						EQUAL					= 0;
	
	/**
	 * The '<em><b>Not Equal</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Not Equal</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #NOT_EQUAL_LITERAL
	 * @model name="NotEqual" annotation="http://www.topcased.org/uuid uuid='_2J4bAe5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						NOT_EQUAL				= 1;
	
	/**
	 * The '<em><b>Greater</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Greater</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #GREATER_LITERAL
	 * @model name="Greater" annotation="http://www.topcased.org/uuid uuid='_2J4bAu5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						GREATER					= 2;
	
	/**
	 * The '<em><b>Greater Or Equal</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Greater Or Equal</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #GREATER_OR_EQUAL_LITERAL
	 * @model name="GreaterOrEqual" annotation="http://www.topcased.org/uuid uuid='_2KCMAO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						GREATER_OR_EQUAL		= 3;
	
	/**
	 * The '<em><b>Smaller</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Smaller</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #SMALLER_LITERAL
	 * @model name="Smaller" annotation="http://www.topcased.org/uuid uuid='_2KCMAe5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						SMALLER					= 4;
	
	/**
	 * The '<em><b>Smaller Or Equal</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Smaller Or Equal</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #SMALLER_OR_EQUAL_LITERAL
	 * @model name="SmallerOrEqual" annotation="http://www.topcased.org/uuid uuid='_2KLV8O5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						SMALLER_OR_EQUAL		= 5;
	
	/**
	 * The '<em><b>Equal Any</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Equal Any</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc --> <!-- begin-model-doc --> This operator corresponds to the Equal operator, but if two arrays
	 * are compared, it returns a boolean value and not an array of boolean value. <!-- end-model-doc -->
	 * 
	 * @see #EQUAL_ANY_LITERAL
	 * @model name="EqualAny" annotation="http://www.topcased.org/uuid uuid='_2KLV8e5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						EQUAL_ANY				= 6;
	
	/**
	 * The '<em><b>Smaller Or Equal Any</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Smaller Or Equal Any</b></em>' literal object isn't clear, there really should be more
	 * of a description here...
	 * </p>
	 * <!-- end-user-doc --> <!-- begin-model-doc --> This operator corresponds to the Smaller or Equal operator, but if
	 * two arrays are compared, it returns a boolean value and not an array of boolean value. <!-- end-model-doc -->
	 * 
	 * @see #SMALLER_OR_EQUAL_ANY_LITERAL
	 * @model name="SmallerOrEqualAny" annotation="http://www.topcased.org/uuid uuid='_2KLV8u5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						SMALLER_OR_EQUAL_ANY	= 7;
	
	/**
	 * An array of all the '<em><b>Comparison Op Kind</b></em>' enumerators. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	private static final ComparisonOpKind[]		VALUES_ARRAY			= new ComparisonOpKind[] { EQUAL_LITERAL,
			NOT_EQUAL_LITERAL, GREATER_LITERAL, GREATER_OR_EQUAL_LITERAL, SMALLER_LITERAL, SMALLER_OR_EQUAL_LITERAL,
			EQUAL_ANY_LITERAL, SMALLER_OR_EQUAL_ANY_LITERAL,			};
	
	/**
	 * A public read-only list of all the '<em><b>Comparison Op Kind</b></em>' enumerators. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static final List<ComparisonOpKind>	VALUES					= Collections.unmodifiableList(Arrays
																				.asList(VALUES_ARRAY));
	
	/**
	 * Returns the '<em><b>Comparison Op Kind</b></em>' literal with the specified literal value. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ComparisonOpKind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ComparisonOpKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Comparison Op Kind</b></em>' literal with the specified name. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static ComparisonOpKind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ComparisonOpKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Comparison Op Kind</b></em>' literal with the specified integer value. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ComparisonOpKind get(int value) {
		switch (value) {
			case EQUAL:
				return EQUAL_LITERAL;
			case NOT_EQUAL:
				return NOT_EQUAL_LITERAL;
			case GREATER:
				return GREATER_LITERAL;
			case GREATER_OR_EQUAL:
				return GREATER_OR_EQUAL_LITERAL;
			case SMALLER:
				return SMALLER_LITERAL;
			case SMALLER_OR_EQUAL:
				return SMALLER_OR_EQUAL_LITERAL;
			case EQUAL_ANY:
				return EQUAL_ANY_LITERAL;
			case SMALLER_OR_EQUAL_ANY:
				return SMALLER_OR_EQUAL_ANY_LITERAL;
		}
		return null;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final int		value;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	name;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	literal;
	
	/**
	 * Only this class can construct instances. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private ComparisonOpKind(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int getValue() {
		return value;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getLiteral() {
		return literal;
	}
	
	/**
	 * Returns the literal value of the enumerator, which is its string representation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} // ComparisonOpKind
