/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Compound State</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.CompoundState#getStates <em>States</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.CompoundState#getHistory <em>History</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.CompoundState#getLocals <em>Locals</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getCompoundState()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOgBO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface CompoundState extends StateBase, SignalContainer {
	/**
	 * Returns the value of the '<em><b>States</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.StateBase}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.StateBase#getStateParent <em>State Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>States</em>' containment reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>States</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getCompoundState_States()
	 * @see fr.irisa.espresso.sme.StateBase#getStateParent
	 * @model opposite="stateParent" containment="true" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOgBe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<StateBase> getStates();
	
	/**
	 * Returns the value of the '<em><b>History</b></em>' containment reference. It is bidirectional and its opposite is
	 * '{@link fr.irisa.espresso.sme.History#getParentState <em>Parent State</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>History</em>' containment reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>History</em>' containment reference.
	 * @see #setHistory(History)
	 * @see fr.irisa.espresso.sme.SmePackage#getCompoundState_History()
	 * @see fr.irisa.espresso.sme.History#getParentState
	 * @model opposite="parentState" containment="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOgBu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	History getHistory();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.CompoundState#getHistory <em>History</em>}' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>History</em>' containment reference.
	 * @see #getHistory()
	 * @generated
	 */
	void setHistory(History value);
	
	/**
	 * Returns the value of the '<em><b>Locals</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.Local}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.Local#getStateParent <em>State Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Locals</em>' containment reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Locals</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getCompoundState_Locals()
	 * @see fr.irisa.espresso.sme.Local#getStateParent
	 * @model opposite="stateParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOgB-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<Local> getLocals();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This method returns a string indicating
	 * the prefix of the compound state. This prefix is used to create intermediate signal. This string is assumed (not
	 * checked) to be unique. //REV create a real mechanisms to guarantee the uniqueness. <!-- end-model-doc -->
	 * 
	 * @model kind="operation" required="true"
	 * @generated
	 */
	String getPrefix();
	
} // CompoundState
