/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Condition</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Condition#getConditionKind <em>Condition Kind</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Condition#getSrc <em>Src</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Condition#getDst <em>Dst</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Condition#getSrcField <em>Src Field</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getCondition()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfj-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Condition extends ModelConnection {
	/**
	 * Returns the value of the '<em><b>Condition Kind</b></em>' attribute. The literals are from the enumeration
	 * {@link fr.irisa.espresso.sme.SignalStateKind}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Condition Kind</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Condition Kind</em>' attribute.
	 * @see fr.irisa.espresso.sme.SignalStateKind
	 * @see #setConditionKind(SignalStateKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getCondition_ConditionKind()
	 * @model unique="false" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfkO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	SignalStateKind getConditionKind();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Condition#getConditionKind <em>Condition Kind</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Condition Kind</em>' attribute.
	 * @see fr.irisa.espresso.sme.SignalStateKind
	 * @see #getConditionKind()
	 * @generated
	 */
	void setConditionKind(SignalStateKind value);
	
	/**
	 * Returns the value of the '<em><b>Src</b></em>' reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ConditionExpr#getSrc_Conditions <em>Src Conditions</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src</em>' reference isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src</em>' reference.
	 * @see #setSrc(ConditionExpr)
	 * @see fr.irisa.espresso.sme.SmePackage#getCondition_Src()
	 * @see fr.irisa.espresso.sme.ConditionExpr#getSrc_Conditions
	 * @model opposite="src_Conditions" required="true"
	 * @generated
	 */
	ConditionExpr getSrc();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Condition#getSrc <em>Src</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Src</em>' reference.
	 * @see #getSrc()
	 * @generated
	 */
	void setSrc(ConditionExpr value);
	
	/**
	 * Returns the value of the '<em><b>Dst</b></em>' reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ConditionnedExpr#getDst_Condition <em>Dst Condition</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst</em>' reference isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst</em>' reference.
	 * @see #setDst(ConditionnedExpr)
	 * @see fr.irisa.espresso.sme.SmePackage#getCondition_Dst()
	 * @see fr.irisa.espresso.sme.ConditionnedExpr#getDst_Condition
	 * @model opposite="dst_Condition" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfk-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	ConditionnedExpr getDst();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Condition#getDst <em>Dst</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Dst</em>' reference.
	 * @see #getDst()
	 * @generated
	 */
	void setDst(ConditionnedExpr value);
	
	/**
	 * Returns the value of the '<em><b>Src Field</b></em>' attribute. The default value is <code>""</code>. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src Field</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src Field</em>' attribute.
	 * @see #setSrcField(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getCondition_SrcField()
	 * @model default="" unique="false" ordered="false"
	 * @generated
	 */
	String getSrcField();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Condition#getSrcField <em>Src Field</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Src Field</em>' attribute.
	 * @see #getSrcField()
	 * @generated
	 */
	void setSrcField(String value);
	
} // Condition
