/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Condition Expr</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.ConditionExpr#getSrc_Conditions <em>Src Conditions</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getConditionExpr()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface ConditionExpr extends ConnectableElement {
	/**
	 * Returns the value of the '<em><b>Src Conditions</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.Condition}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.Condition#getSrc <em>Src</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src Conditions</em>' reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src Conditions</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getConditionExpr_Src_Conditions()
	 * @see fr.irisa.espresso.sme.Condition#getSrc
	 * @model opposite="src" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOfYu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<Condition> getSrc_Conditions();
	
} // ConditionExpr
