/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Constant</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Constant#getDst_ConstantAffectation <em>Dst Constant Affectation</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getConstant()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOfS-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Constant extends ConstantOrRef, Identifier {
	/**
	 * Returns the value of the '<em><b>Dst Constant Affectation</b></em>' reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.ConstantAffectation#getDst <em>Dst</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst Constant Affectation</em>' reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst Constant Affectation</em>' reference.
	 * @see #setDst_ConstantAffectation(ConstantAffectation)
	 * @see fr.irisa.espresso.sme.SmePackage#getConstant_Dst_ConstantAffectation()
	 * @see fr.irisa.espresso.sme.ConstantAffectation#getDst
	 * @model opposite="dst" annotation="http://www.topcased.org/uuid uuid='_2LOfTO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	ConstantAffectation getDst_ConstantAffectation();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Constant#getDst_ConstantAffectation
	 * <em>Dst Constant Affectation</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Dst Constant Affectation</em>' reference.
	 * @see #getDst_ConstantAffectation()
	 * @generated
	 */
	void setDst_ConstantAffectation(ConstantAffectation value);
	
} // Constant
