/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Constant Value</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.ConstantValue#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ConstantValue#getModuleParent <em>Module Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ConstantValue#getArrayDimensions <em>Array Dimensions</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ConstantValue#getType <em>Type</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ConstantValue#getValue <em>Value</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ConstantValue#getVisibility <em>Visibility</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getConstantValue()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfTu5WEduz9o2pAin6-g'"
 * @generated
 */
public interface ConstantValue extends Constant, ConditionExpr {
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getConstants <em>Constants</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getConstantValue_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getConstants
	 * @model opposite="constants" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfT-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ConstantValue#getModelParent <em>Model Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * Returns the value of the '<em><b>Module Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.Module#getConstants <em>Constants</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Module Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Module Parent</em>' container reference.
	 * @see #setModuleParent(Module)
	 * @see fr.irisa.espresso.sme.SmePackage#getConstantValue_ModuleParent()
	 * @see fr.irisa.espresso.sme.Module#getConstants
	 * @model opposite="constants" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfUO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Module getModuleParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ConstantValue#getModuleParent <em>Module Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Module Parent</em>' container reference.
	 * @see #getModuleParent()
	 * @generated
	 */
	void setModuleParent(Module value);
	
	/**
	 * Returns the value of the '<em><b>Array Dimensions</b></em>' attribute list. The list contents are of type
	 * {@link java.lang.String}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Array Dimensions</em>' attribute list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Array Dimensions</em>' attribute list.
	 * @see fr.irisa.espresso.sme.SmePackage#getConstantValue_ArrayDimensions()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfUe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<String> getArrayDimensions();
	
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> This type can be of one of the IntrinsicType or one of the SignalType declared <!--
	 * end-model-doc -->
	 * 
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getConstantValue_Type()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfUu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getType();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ConstantValue#getType <em>Type</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);
	
	/**
	 * Returns the value of the '<em><b>Value</b></em>' attribute list. The list contents are of type
	 * {@link java.lang.String}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Value</em>' attribute list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Value</em>' attribute list.
	 * @see fr.irisa.espresso.sme.SmePackage#getConstantValue_Value()
	 * @model unique="false" annotation="http://www.topcased.org/uuid uuid='_2LOfU-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<String> getValue();
	
	/**
	 * Returns the value of the '<em><b>Visibility</b></em>' attribute. The literals are from the enumeration
	 * {@link fr.irisa.espresso.sme.VisibilityKind}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Visibility</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Visibility</em>' attribute.
	 * @see fr.irisa.espresso.sme.VisibilityKind
	 * @see #setVisibility(VisibilityKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getConstantValue_Visibility()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOfVO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	VisibilityKind getVisibility();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ConstantValue#getVisibility <em>Visibility</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Visibility</em>' attribute.
	 * @see fr.irisa.espresso.sme.VisibilityKind
	 * @see #getVisibility()
	 * @generated
	 */
	void setVisibility(VisibilityKind value);
	
} // ConstantValue
