/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Dataflow Connection</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnection#isIsDefaultValue <em>Is Default Value</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnection#getCastType <em>Cast Type</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnection#isUseSrcClock <em>Use Src Clock</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnection#isUseLastIterationValue <em>Use Last Iteration Value</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnection#getSrc <em>Src</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnection#getDst <em>Dst</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnection#getSrcField <em>Src Field</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnection#getDstField <em>Dst Field</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfmu5WEduz9o2pAin6-g'"
 * @generated
 */
public interface DataflowConnection extends ModelConnection {
	/**
	 * Returns the value of the '<em><b>Is Default Value</b></em>' attribute. The default value is <code>"false"</code>.
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This attribute is only considered in the
	 * case of a partial definition (isPartialDefinition equals true). If this attribute is true, that means that the
	 * source expression is considered as the default expression for the destination Signal. For a Signal, only one of
	 * the partial definition connection can have its isDefaultValue set to true. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Is Default Value</em>' attribute.
	 * @see #setIsDefaultValue(boolean)
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection_IsDefaultValue()
	 * @model default="false" unique="false" ordered="false" annotation="http://www.topcased.org/uuid
	 *        uuid='_2LOfnO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	boolean isIsDefaultValue();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.DataflowConnection#isIsDefaultValue
	 * <em>Is Default Value</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Is Default Value</em>' attribute.
	 * @see #isIsDefaultValue()
	 * @generated
	 */
	void setIsDefaultValue(boolean value);
	
	/**
	 * Returns the value of the '<em><b>Cast Type</b></em>' attribute. The default value is <code>""</code>. The
	 * literals are from the enumeration {@link fr.irisa.espresso.sme.SignalIntrinsicType}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cast Type</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Cast Type</em>' attribute.
	 * @see fr.irisa.espresso.sme.SignalIntrinsicType
	 * @see #setCastType(SignalIntrinsicType)
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection_CastType()
	 * @model default="" unique="false" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfne5WEduz9o2pAin6-g'"
	 * @generated
	 */
	SignalIntrinsicType getCastType();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.DataflowConnection#getCastType <em>Cast Type</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Cast Type</em>' attribute.
	 * @see fr.irisa.espresso.sme.SignalIntrinsicType
	 * @see #getCastType()
	 * @generated
	 */
	void setCastType(SignalIntrinsicType value);
	
	/**
	 * Returns the value of the '<em><b>Use Src Clock</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Use Src Clock</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Use Src Clock</em>' attribute.
	 * @see #setUseSrcClock(boolean)
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection_UseSrcClock()
	 * @model unique="false" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfnu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	boolean isUseSrcClock();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.DataflowConnection#isUseSrcClock <em>Use Src Clock</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Use Src Clock</em>' attribute.
	 * @see #isUseSrcClock()
	 * @generated
	 */
	void setUseSrcClock(boolean value);
	
	/**
	 * Returns the value of the '<em><b>Use Last Iteration Value</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Use Last Iteration Value</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Use Last Iteration Value</em>' attribute.
	 * @see #setUseLastIterationValue(boolean)
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection_UseLastIterationValue()
	 * @model unique="false" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfn-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	boolean isUseLastIterationValue();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.DataflowConnection#isUseLastIterationValue
	 * <em>Use Last Iteration Value</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Use Last Iteration Value</em>' attribute.
	 * @see #isUseLastIterationValue()
	 * @generated
	 */
	void setUseLastIterationValue(boolean value);
	
	/**
	 * Returns the value of the '<em><b>Src</b></em>' reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.SignalExpr#getSrc_DataflowConnections <em>Src Dataflow Connections</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src</em>' reference isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src</em>' reference.
	 * @see #setSrc(SignalExpr)
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection_Src()
	 * @see fr.irisa.espresso.sme.SignalExpr#getSrc_DataflowConnections
	 * @model opposite="src_DataflowConnections" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfoO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	SignalExpr getSrc();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.DataflowConnection#getSrc <em>Src</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Src</em>' reference.
	 * @see #getSrc()
	 * @generated
	 */
	void setSrc(SignalExpr value);
	
	/**
	 * Returns the value of the '<em><b>Dst</b></em>' reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.DataflowConnector#getDst_DataflowConnections <em>Dst Dataflow Connections</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst</em>' reference isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst</em>' reference.
	 * @see #setDst(DataflowConnector)
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection_Dst()
	 * @see fr.irisa.espresso.sme.DataflowConnector#getDst_DataflowConnections
	 * @model opposite="dst_DataflowConnections" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfoe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	DataflowConnector getDst();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.DataflowConnection#getDst <em>Dst</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Dst</em>' reference.
	 * @see #getDst()
	 * @generated
	 */
	void setDst(DataflowConnector value);
	
	/**
	 * Returns the value of the '<em><b>Src Field</b></em>' attribute. The default value is <code>""</code>. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src Field</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src Field</em>' attribute.
	 * @see #setSrcField(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection_SrcField()
	 * @model default="" unique="false" ordered="false"
	 * @generated
	 */
	String getSrcField();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.DataflowConnection#getSrcField <em>Src Field</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Src Field</em>' attribute.
	 * @see #getSrcField()
	 * @generated
	 */
	void setSrcField(String value);
	
	/**
	 * Returns the value of the '<em><b>Dst Field</b></em>' attribute. The default value is <code>""</code>. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst Field</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst Field</em>' attribute.
	 * @see #setDstField(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnection_DstField()
	 * @model default="" unique="false" ordered="false"
	 * @generated
	 */
	String getDstField();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.DataflowConnection#getDstField <em>Dst Field</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Dst Field</em>' attribute.
	 * @see #getDstField()
	 * @generated
	 */
	void setDstField(String value);
	
} // DataflowConnection
