/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Dataflow Connector</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.DataflowConnector#getDst_DataflowConnections <em>Dst Dataflow Connections</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnector()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOfRO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface DataflowConnector extends ConnectableElement {
	/**
	 * Returns the value of the '<em><b>Dst Dataflow Connections</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.DataflowConnection}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.DataflowConnection#getDst <em>Dst</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * --> <!-- begin-model-doc --> For InputPort element, the cardinality of this field must be 0..1. We need the
	 * cardinality 0..*, for definition/partial definition.
	 * 
	 * <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Dst Dataflow Connections</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getDataflowConnector_Dst_DataflowConnections()
	 * @see fr.irisa.espresso.sme.DataflowConnection#getDst
	 * @model opposite="dst" annotation="http://www.topcased.org/uuid uuid='_2LOfRe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<DataflowConnection> getDst_DataflowConnections();
	
} // DataflowConnector
