/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Enumeration Value</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <!-- begin-model-doc --> This metaclass is used to represent the Enumerated Value in Signal. It is used as a literal
 * whose value is the value of the enumerated type, and typeValue contains the name of the Enumerated Type. <!--
 * end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.EnumerationValue#getTypeValue <em>Type Value</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getEnumerationValue()
 * @model
 * @generated
 */
public interface EnumerationValue extends Literal {
	/**
	 * Returns the value of the '<em><b>Type Value</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type Value</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Type Value</em>' attribute.
	 * @see #setTypeValue(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getEnumerationValue_TypeValue()
	 * @model
	 * @generated
	 */
	String getTypeValue();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.EnumerationValue#getTypeValue <em>Type Value</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Type Value</em>' attribute.
	 * @see #getTypeValue()
	 * @generated
	 */
	void setTypeValue(String value);
	
} // EnumerationValue
