/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Identifier</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Identifier is an abstract meta-class that represents an identifier in the Signal language.
 * Be sure to use unique names. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Identifier#getComment <em>Comment</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getIdentifier()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOe1-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Identifier extends NamedElement, ConnectableElement {
	/**
	 * Returns the value of the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> Any comments on the identifier. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Comment</em>' attribute.
	 * @see #setComment(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getIdentifier_Comment()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOe2O5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getComment();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Identifier#getComment <em>Comment</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Comment</em>' attribute.
	 * @see #getComment()
	 * @generated
	 */
	void setComment(String value);
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This method returns a string describing
	 * the identifier.
	 * 
	 * @param asCode
	 *        if it is true, the generated string will be formatted as in code generation otherwise, it calls the
	 *        classical toString method.
	 * @param withComments
	 *        if it is true, the comment will be added to the String. <!-- end-model-doc -->
	 * @model required="true" asCodeRequired="true" withCommentsRequired="true"
	 * @generated
	 */
	String toString(boolean asCode, boolean withComments);
	
} // Identifier
