/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Index</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Index#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Index#getFrom <em>From</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Index#getTo <em>To</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Index#getStep <em>Step</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getIndex()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfXO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Index extends Constant {
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getIndexes <em>Indexes</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getIndex_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getIndexes
	 * @model opposite="indexes" required="true" transient="false" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfXe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Index#getModelParent <em>Model Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * Returns the value of the '<em><b>From</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> The "from" attribute must contain a integer expression. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>From</em>' attribute.
	 * @see #setFrom(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getIndex_From()
	 * @model unique="false" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfXu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getFrom();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Index#getFrom <em>From</em>}' attribute. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>From</em>' attribute.
	 * @see #getFrom()
	 * @generated
	 */
	void setFrom(String value);
	
	/**
	 * Returns the value of the '<em><b>To</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> The "to" attribute must contain a integer expression. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>To</em>' attribute.
	 * @see #setTo(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getIndex_To()
	 * @model unique="false" required="true" ordered="false" annotation="http://www.topcased.org/uuid
	 *        uuid='_2LOfX-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getTo();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Index#getTo <em>To</em>}' attribute. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>To</em>' attribute.
	 * @see #getTo()
	 * @generated
	 */
	void setTo(String value);
	
	/**
	 * Returns the value of the '<em><b>Step</b></em>' attribute. The default value is <code>"1"</code>. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> The "step" attribute must contain a constant
	 * integer expression. If it is let empty, that means that "step" is equal to 1. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Step</em>' attribute.
	 * @see #setStep(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getIndex_Step()
	 * @model default="1" unique="false" ordered="false" annotation="http://www.topcased.org/uuid
	 *        uuid='_2LOfYO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getStep();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Index#getStep <em>Step</em>}' attribute. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Step</em>' attribute.
	 * @see #getStep()
	 * @generated
	 */
	void setStep(String value);
	
} // Index
