/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Iterate</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Iterate#getIterationInit <em>Iteration Init</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Iterate#getIns <em>Ins</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getIterate()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfAO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Iterate extends SubProcess, SignalOperator {
	/**
	 * Returns the value of the '<em><b>Iteration Init</b></em>' containment reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.IterationInit#getIterateParent <em>Iterate Parent</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Iteration Init</em>' containment reference isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Iteration Init</em>' containment reference.
	 * @see #setIterationInit(IterationInit)
	 * @see fr.irisa.espresso.sme.SmePackage#getIterate_IterationInit()
	 * @see fr.irisa.espresso.sme.IterationInit#getIterateParent
	 * @model opposite="iterateParent" containment="true" required="true" annotation="http://www.topcased.org/uuid
	 *        uuid='_2LOfAu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	IterationInit getIterationInit();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Iterate#getIterationInit <em>Iteration Init</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Iteration Init</em>' containment reference.
	 * @see #getIterationInit()
	 * @generated
	 */
	void setIterationInit(IterationInit value);
	
	/**
	 * Returns the value of the '<em><b>Ins</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.InputPort}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ins</em>' containment reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Ins</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getIterate_Ins()
	 * @model containment="true" required="true" changeable="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfA-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<InputPort> getIns();
	
} // Iterate
