/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Iteration Init</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.IterationInit#getArrayParent <em>Array Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.IterationInit#getIterateParent <em>Iterate Parent</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getIterationInit()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfBO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface IterationInit extends Model {
	/**
	 * Returns the value of the '<em><b>Array Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.BasicIterate#getIterationInit <em>Iteration Init</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Array Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Array Parent</em>' container reference.
	 * @see #setArrayParent(BasicIterate)
	 * @see fr.irisa.espresso.sme.SmePackage#getIterationInit_ArrayParent()
	 * @see fr.irisa.espresso.sme.BasicIterate#getIterationInit
	 * @model opposite="iterationInit" transient="false"
	 * @generated
	 */
	BasicIterate getArrayParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.IterationInit#getArrayParent <em>Array Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Array Parent</em>' container reference.
	 * @see #getArrayParent()
	 * @generated
	 */
	void setArrayParent(BasicIterate value);
	
	/**
	 * Returns the value of the '<em><b>Iterate Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.Iterate#getIterationInit <em>Iteration Init</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Iterate Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Iterate Parent</em>' container reference.
	 * @see #setIterateParent(Iterate)
	 * @see fr.irisa.espresso.sme.SmePackage#getIterationInit_IterateParent()
	 * @see fr.irisa.espresso.sme.Iterate#getIterationInit
	 * @model opposite="iterationInit" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfBe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Iterate getIterateParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.IterationInit#getIterateParent <em>Iterate Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Iterate Parent</em>' container reference.
	 * @see #getIterateParent()
	 * @generated
	 */
	void setIterateParent(Iterate value);
	
} // IterationInit
