/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Local</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Local#getStatus <em>Status</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Local#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Local#getStateParent <em>State Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Local#getTypeParent <em>Type Parent</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getLocal()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfdu5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Local extends Signal {
	/**
	 * Returns the value of the '<em><b>Status</b></em>' attribute. The literals are from the enumeration
	 * {@link fr.irisa.espresso.sme.StatusKind}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Status</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Status</em>' attribute.
	 * @see fr.irisa.espresso.sme.StatusKind
	 * @see #setStatus(StatusKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getLocal_Status()
	 * @model required="true"
	 * @generated
	 */
	StatusKind getStatus();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Local#getStatus <em>Status</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Status</em>' attribute.
	 * @see fr.irisa.espresso.sme.StatusKind
	 * @see #getStatus()
	 * @generated
	 */
	void setStatus(StatusKind value);
	
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getLocals <em>Locals</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getLocal_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getLocals
	 * @model opposite="locals" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfeO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Local#getModelParent <em>Model Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * Returns the value of the '<em><b>State Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.CompoundState#getLocals <em>Locals</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>State Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>State Parent</em>' container reference.
	 * @see #setStateParent(CompoundState)
	 * @see fr.irisa.espresso.sme.SmePackage#getLocal_StateParent()
	 * @see fr.irisa.espresso.sme.CompoundState#getLocals
	 * @model opposite="locals" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfee5WEduz9o2pAin6-g'"
	 * @generated
	 */
	CompoundState getStateParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Local#getStateParent <em>State Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>State Parent</em>' container reference.
	 * @see #getStateParent()
	 * @generated
	 */
	void setStateParent(CompoundState value);
	
	/**
	 * Returns the value of the '<em><b>Type Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.TupleType#getLocals <em>Locals</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Type Parent</em>' container reference.
	 * @see #setTypeParent(TupleType)
	 * @see fr.irisa.espresso.sme.SmePackage#getLocal_TypeParent()
	 * @see fr.irisa.espresso.sme.TupleType#getLocals
	 * @model opposite="locals" transient="false" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfeu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	TupleType getTypeParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Local#getTypeParent <em>Type Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Type Parent</em>' container reference.
	 * @see #getTypeParent()
	 * @generated
	 */
	void setTypeParent(TupleType value);
	
} // Local
