/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Model Declaration</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getModuleParent <em>Module Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getSpecParent <em>Spec Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getModelType <em>Model Type</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getVisibility <em>Visibility</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#isIsMain <em>Is Main</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#isIsSigaliProcess <em>Is Sigali Process</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getCompilationDirective <em>Compilation Directive</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getRunOn <em>Run On</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getC_CODE <em>CCODE</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getCpp_CODE <em>Cpp CODE</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getJava_CODE <em>Java CODE</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getProcessor_type <em>Processor type</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelDeclaration#getModelDeclarations <em>Model Declarations</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfIe5WEduz9o2pAin6-g'"
 * @generated
 */
public interface ModelDeclaration extends Model, InterfaceDefinition, Identifier, ConstantExpr, RootModel {
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.ModelDeclaration#getModelDeclarations <em>Model Declarations</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(ModelDeclaration)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_ModelParent()
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getModelDeclarations
	 * @model opposite="modelDeclarations" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfIu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	ModelDeclaration getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getModelParent <em>Model Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(ModelDeclaration value);
	
	/**
	 * Returns the value of the '<em><b>Module Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.Module#getModelDeclarations <em>Model Declarations</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Module Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Module Parent</em>' container reference.
	 * @see #setModuleParent(Module)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_ModuleParent()
	 * @see fr.irisa.espresso.sme.Module#getModelDeclarations
	 * @model opposite="modelDeclarations" transient="false" annotation="http://www.topcased.org/uuid
	 *        uuid='_2LOfI-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Module getModuleParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getModuleParent <em>Module Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Module Parent</em>' container reference.
	 * @see #getModuleParent()
	 * @generated
	 */
	void setModuleParent(Module value);
	
	/**
	 * Returns the value of the '<em><b>Spec Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Specifications#getModelDeclarations <em>Model Declarations</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Spec Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Spec Parent</em>' container reference.
	 * @see #setSpecParent(Specifications)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_SpecParent()
	 * @see fr.irisa.espresso.sme.Specifications#getModelDeclarations
	 * @model opposite="modelDeclarations" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfJO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Specifications getSpecParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getSpecParent <em>Spec Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Spec Parent</em>' container reference.
	 * @see #getSpecParent()
	 * @generated
	 */
	void setSpecParent(Specifications value);
	
	/**
	 * Returns the value of the '<em><b>Model Type</b></em>' attribute. The default value is <code>"process"</code>. The
	 * literals are from the enumeration {@link fr.irisa.espresso.sme.ModelKind}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Type</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Type</em>' attribute.
	 * @see fr.irisa.espresso.sme.ModelKind
	 * @see #setModelType(ModelKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_ModelType()
	 * @model default="process" annotation="http://www.topcased.org/uuid uuid='_2LOfJe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	ModelKind getModelType();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getModelType <em>Model Type</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Type</em>' attribute.
	 * @see fr.irisa.espresso.sme.ModelKind
	 * @see #getModelType()
	 * @generated
	 */
	void setModelType(ModelKind value);
	
	/**
	 * Returns the value of the '<em><b>Visibility</b></em>' attribute. The literals are from the enumeration
	 * {@link fr.irisa.espresso.sme.VisibilityKind}. <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc
	 * --> In a Module, a visibility set to private means that the ModelDeclaration is only visible in the Module. <!--
	 * end-model-doc -->
	 * 
	 * @return the value of the '<em>Visibility</em>' attribute.
	 * @see fr.irisa.espresso.sme.VisibilityKind
	 * @see #setVisibility(VisibilityKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_Visibility()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfJu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	VisibilityKind getVisibility();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getVisibility <em>Visibility</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Visibility</em>' attribute.
	 * @see fr.irisa.espresso.sme.VisibilityKind
	 * @see #getVisibility()
	 * @generated
	 */
	void setVisibility(VisibilityKind value);
	
	/**
	 * Returns the value of the '<em><b>Is Main</b></em>' attribute. The default value is <code>"false"</code>. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> When the ModelDeclaration is in a Module,
	 * setting the isMain attribute to true means that the ModelDeclaration is an �entry point� of this Module: it
	 * constitutes a compilation unit. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Is Main</em>' attribute.
	 * @see #setIsMain(boolean)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_IsMain()
	 * @model default="false" unique="false" ordered="false" annotation="http://www.topcased.org/uuid
	 *        uuid='_2LOfJ-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	boolean isIsMain();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#isIsMain <em>Is Main</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Is Main</em>' attribute.
	 * @see #isIsMain()
	 * @generated
	 */
	void setIsMain(boolean value);
	
	/**
	 * Returns the value of the '<em><b>Is Sigali Process</b></em>' attribute. The default value is <code>"false"</code>
	 * . <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This attribute is set to true for models
	 * contained in a specific library dedicated to the SIGALI prover. The calls of these models are external calls that
	 * are interpreted when translated into the SIGALI representation. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Is Sigali Process</em>' attribute.
	 * @see #setIsSigaliProcess(boolean)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_IsSigaliProcess()
	 * @model default="false" unique="false" ordered="false" annotation="http://www.topcased.org/uuid
	 *        uuid='_2LOfKO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	boolean isIsSigaliProcess();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#isIsSigaliProcess
	 * <em>Is Sigali Process</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Is Sigali Process</em>' attribute.
	 * @see #isIsSigaliProcess()
	 * @generated
	 */
	void setIsSigaliProcess(boolean value);
	
	/**
	 * Returns the value of the '<em><b>Compilation Directive</b></em>' attribute. The default value is
	 * <code>"NONE"</code>. The literals are from the enumeration {@link fr.irisa.espresso.sme.CompilationDirectiveKind}
	 * . <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Compilation Directive</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Compilation Directive</em>' attribute.
	 * @see fr.irisa.espresso.sme.CompilationDirectiveKind
	 * @see #setCompilationDirective(CompilationDirectiveKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_CompilationDirective()
	 * @model default="NONE" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOfKe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	CompilationDirectiveKind getCompilationDirective();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getCompilationDirective
	 * <em>Compilation Directive</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Compilation Directive</em>' attribute.
	 * @see fr.irisa.espresso.sme.CompilationDirectiveKind
	 * @see #getCompilationDirective()
	 * @generated
	 */
	void setCompilationDirective(CompilationDirectiveKind value);
	
	/**
	 * Returns the value of the '<em><b>Run On</b></em>' attribute. The default value is <code>"-1"</code>. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> When a partitioning based on the use of the
	 * pragma RunOn is applied on an application, the global graph of the application is partitioned according to the n
	 * different values of the pragma so as to obtain n sub-graphs, corresponding to n sub-models. The tree of clocks
	 * and the interface of these sub-models may be completed in such a way that they represent endochronous processes.
	 * <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Run On</em>' attribute.
	 * @see #setRunOn(int)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_RunOn()
	 * @model default="-1" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOfKu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	int getRunOn();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getRunOn <em>Run On</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Run On</em>' attribute.
	 * @see #getRunOn()
	 * @generated
	 */
	void setRunOn(int value);
	
	/**
	 * Returns the value of the '<em><b>CCODE</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> This string represents a piece of C code. Each call of the model is translated by this string
	 * in the generated code, after substitution of the encoded parameters by the corresponding signals in the
	 * considered call. The following encoded parameters may be used in the string: &pj (where j is a constant integer
	 * value) represents the jth parameter of the call; &ij (where j is a constant integer value) represents the jth
	 * input signal of the call; &oj (where j is a constant integer value) represents the jth output signal of the call;
	 * &n represents the name of the model. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>CCODE</em>' attribute.
	 * @see #setC_CODE(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_C_CODE()
	 * @model unique="false" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOfK-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getC_CODE();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getC_CODE <em>CCODE</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>CCODE</em>' attribute.
	 * @see #getC_CODE()
	 * @generated
	 */
	void setC_CODE(String value);
	
	/**
	 * Returns the value of the '<em><b>Cpp CODE</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> This string represents a piece of C++ code. Each call of the model is translated by this
	 * string in the generated code, after substitution of the encoded parameters by the corresponding signals in the
	 * considered call. The following encoded parameters may be used in the string: &pj (where j is a constant integer
	 * value) represents the jth parameter of the call; &ij (where j is a constant integer value) represents the jth
	 * input signal of the call; &oj (where j is a constant integer value) represents the jth output signal of the call;
	 * &n represents the name of the model. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Cpp CODE</em>' attribute.
	 * @see #setCpp_CODE(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_Cpp_CODE()
	 * @model unique="false" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOfLO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getCpp_CODE();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getCpp_CODE <em>Cpp CODE</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Cpp CODE</em>' attribute.
	 * @see #getCpp_CODE()
	 * @generated
	 */
	void setCpp_CODE(String value);
	
	/**
	 * Returns the value of the '<em><b>Java CODE</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * <!-- begin-model-doc --> This string represents a piece of JAVA code. Each call of the model is translated by
	 * this string in the generated code, after substitution of the encoded parameters by the corresponding signals in
	 * the considered call. The following encoded parameters may be used in the string: &pj (where j is a constant
	 * integer value) represents the jth parameter of the call; &ij (where j is a constant integer value) represents the
	 * jth input signal of the call; &oj (where j is a constant integer value) represents the jth output signal of the
	 * call; &n represents the name of the model. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Java CODE</em>' attribute.
	 * @see #setJava_CODE(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_Java_CODE()
	 * @model unique="false" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOfLe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getJava_CODE();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getJava_CODE <em>Java CODE</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Java CODE</em>' attribute.
	 * @see #getJava_CODE()
	 * @generated
	 */
	void setJava_CODE(String value);
	
	/**
	 * Returns the value of the '<em><b>Processor type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * --> <!-- begin-model-doc --> This attribute is a string representing a name, for example, "DSP", that should be
	 * the name of a file DSP.LIB containing a module that defines the cost of each operator by particular models. When
	 * profiling (performance evaluation) is required on a given program implemented on some processor represented as a
	 * model with the PROCESSOR_TYPEpragma, a morphism of this program is applied, that defines a new program
	 * representing cost evaluation of the original program. The image of the original program by this morphism uses the
	 * library designated by the pragma to interpret the cost evaluation operators. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Processor type</em>' attribute.
	 * @see #setProcessor_type(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_Processor_type()
	 * @model unique="false" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOfLu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getProcessor_type();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelDeclaration#getProcessor_type <em>Processor type</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Processor type</em>' attribute.
	 * @see #getProcessor_type()
	 * @generated
	 */
	void setProcessor_type(String value);
	
	/**
	 * Returns the value of the '<em><b>Model Declarations</b></em>' containment reference list. The list contents are
	 * of type {@link fr.irisa.espresso.sme.ModelDeclaration}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ModelDeclaration#getModelParent <em>Model Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Declarations</em>' containment reference list isn't clear, there really should
	 * be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Declarations</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getModelDeclaration_ModelDeclarations()
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getModelParent
	 * @model opposite="modelParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfL-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ModelDeclaration> getModelDeclarations();
	
} // ModelDeclaration
