/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Model Instance</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.ModelInstance#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelInstance#getReferredInterface <em>Referred Interface</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelInstance#getReferredParameter <em>Referred Parameter</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelInstance#getInputs <em>Inputs</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelInstance#getOutputs <em>Outputs</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.ModelInstance#getParameters <em>Parameters</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getModelInstance()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfMO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface ModelInstance extends ClockedExpr, Identifier, DependenceInOut, SignalContainer {
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getContainedInstances <em>Contained Instances</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelInstance_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getContainedInstances
	 * @model opposite="containedInstances" required="true" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfMe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelInstance#getModelParent <em>Model Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * Returns the value of the '<em><b>Referred Interface</b></em>' reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Referred Interface</em>' reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Referred Interface</em>' reference.
	 * @see #setReferredInterface(InterfaceDefinition)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelInstance_ReferredInterface()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOfMu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	InterfaceDefinition getReferredInterface();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelInstance#getReferredInterface
	 * <em>Referred Interface</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Referred Interface</em>' reference.
	 * @see #getReferredInterface()
	 * @generated
	 */
	void setReferredInterface(InterfaceDefinition value);
	
	/**
	 * Returns the value of the '<em><b>Referred Parameter</b></em>' reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Referred Parameter</em>' reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Referred Parameter</em>' reference.
	 * @see #setReferredParameter(Parameter)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelInstance_ReferredParameter()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfM-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Parameter getReferredParameter();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelInstance#getReferredParameter
	 * <em>Referred Parameter</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Referred Parameter</em>' reference.
	 * @see #getReferredParameter()
	 * @generated
	 */
	void setReferredParameter(Parameter value);
	
	/**
	 * Returns the value of the '<em><b>Inputs</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.InputInstance}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.InputInstance#getInstanceParent <em>Instance Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Inputs</em>' containment reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Inputs</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getModelInstance_Inputs()
	 * @see fr.irisa.espresso.sme.InputInstance#getInstanceParent
	 * @model opposite="instanceParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfNO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<InputInstance> getInputs();
	
	/**
	 * Returns the value of the '<em><b>Outputs</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.OutputInstance}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.OutputInstance#getInstanceParent <em>Instance Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outputs</em>' containment reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Outputs</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getModelInstance_Outputs()
	 * @see fr.irisa.espresso.sme.OutputInstance#getInstanceParent
	 * @model opposite="instanceParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfNe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<OutputInstance> getOutputs();
	
	/**
	 * Returns the value of the '<em><b>Parameters</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.ParameterInstance}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ParameterInstance#getInstanceParent <em>Instance Parent</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Parameters</em>' containment reference list isn't clear, there really should be more
	 * of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Parameters</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getModelInstance_Parameters()
	 * @see fr.irisa.espresso.sme.ParameterInstance#getInstanceParent
	 * @model opposite="instanceParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfNu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ParameterInstance> getParameters();
	
} // ModelInstance
