/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Model Type</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.ModelType#getModelType <em>Model Type</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getModelType()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfFu5WEduz9o2pAin6-g'"
 * @generated
 */
public interface ModelType extends InterfaceDefinition, TypeDeclaration, ParameterType {
	/**
	 * Returns the value of the '<em><b>Model Type</b></em>' attribute. The default value is <code>"process"</code>. The
	 * literals are from the enumeration {@link fr.irisa.espresso.sme.ModelKind}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Type</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Type</em>' attribute.
	 * @see fr.irisa.espresso.sme.ModelKind
	 * @see #setModelType(ModelKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getModelType_ModelType()
	 * @model default="process" annotation="http://www.topcased.org/uuid uuid='_2LOfF-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	ModelKind getModelType();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.ModelType#getModelType <em>Model Type</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Type</em>' attribute.
	 * @see fr.irisa.espresso.sme.ModelKind
	 * @see #getModelType()
	 * @generated
	 */
	void setModelType(ModelKind value);
	
} // ModelType
