/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Module</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Module#getConstants <em>Constants</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Module#getModelDeclarations <em>Model Declarations</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Module#getTypes <em>Types</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Module#getUseModule <em>Use Module</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Module#getPragmas <em>Pragmas</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getModule()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfN-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Module extends Identifier, RootModel, SignalContainer {
	/**
	 * Returns the value of the '<em><b>Constants</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.ConstantValue}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ConstantValue#getModuleParent <em>Module Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Constants</em>' containment reference list isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Constants</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getModule_Constants()
	 * @see fr.irisa.espresso.sme.ConstantValue#getModuleParent
	 * @model opposite="moduleParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfO-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ConstantValue> getConstants();
	
	/**
	 * Returns the value of the '<em><b>Model Declarations</b></em>' containment reference list. The list contents are
	 * of type {@link fr.irisa.espresso.sme.ModelDeclaration}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ModelDeclaration#getModuleParent <em>Module Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Declarations</em>' containment reference list isn't clear, there really should
	 * be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Declarations</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getModule_ModelDeclarations()
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getModuleParent
	 * @model opposite="moduleParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfPO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ModelDeclaration> getModelDeclarations();
	
	/**
	 * Returns the value of the '<em><b>Types</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.TypeDeclaration}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.TypeDeclaration#getModuleParent <em>Module Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Types</em>' containment reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Types</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getModule_Types()
	 * @see fr.irisa.espresso.sme.TypeDeclaration#getModuleParent
	 * @model opposite="moduleParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfPe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<TypeDeclaration> getTypes();
	
	/**
	 * Returns the value of the '<em><b>Use Module</b></em>' containment reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.UseModule#getModuleParent <em>Module Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Use Module</em>' containment reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Use Module</em>' containment reference.
	 * @see #setUseModule(UseModule)
	 * @see fr.irisa.espresso.sme.SmePackage#getModule_UseModule()
	 * @see fr.irisa.espresso.sme.UseModule#getModuleParent
	 * @model opposite="moduleParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfPu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	UseModule getUseModule();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Module#getUseModule <em>Use Module</em>}' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Use Module</em>' containment reference.
	 * @see #getUseModule()
	 * @generated
	 */
	void setUseModule(UseModule value);
	
	/**
	 * Returns the value of the '<em><b>Pragmas</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.Pragma}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.Pragma#getModuleParent <em>Module Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pragmas</em>' containment reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Pragmas</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getModule_Pragmas()
	 * @see fr.irisa.espresso.sme.Pragma#getModuleParent
	 * @model opposite="moduleParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfP-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<Pragma> getPragmas();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @model kind="operation" annotation="http://www.topcased.org/uuid uuid='_2LOfOO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ConstantValue> getExportedConstants();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @model kind="operation" annotation="http://www.topcased.org/uuid uuid='_2LOfOe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ModelDeclaration> getExportedModels();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @model kind="operation" annotation="http://www.topcased.org/uuid uuid='_2LOfOu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<TypeDeclaration> getExportedTypes();
	
} // Module
