/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Parameter</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Parameter#getInterfaceParent <em>Interface Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Parameter#getArrayDimensions <em>Array Dimensions</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Parameter#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getParameter()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfVe5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Parameter extends Constant, ConditionExpr {
	/**
	 * Returns the value of the '<em><b>Interface Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.InterfaceDefinition#getParameters <em>Parameters</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Parent</em>' container reference isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Interface Parent</em>' container reference.
	 * @see #setInterfaceParent(InterfaceDefinition)
	 * @see fr.irisa.espresso.sme.SmePackage#getParameter_InterfaceParent()
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getParameters
	 * @model opposite="parameters" required="true" transient="false" annotation="http://www.topcased.org/uuid
	 *        uuid='_2LOfVu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	InterfaceDefinition getInterfaceParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Parameter#getInterfaceParent <em>Interface Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Interface Parent</em>' container reference.
	 * @see #getInterfaceParent()
	 * @generated
	 */
	void setInterfaceParent(InterfaceDefinition value);
	
	/**
	 * Returns the value of the '<em><b>Array Dimensions</b></em>' attribute list. The list contents are of type
	 * {@link java.lang.String}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Array Dimensions</em>' attribute list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Array Dimensions</em>' attribute list.
	 * @see fr.irisa.espresso.sme.SmePackage#getParameter_ArrayDimensions()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfV-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<String> getArrayDimensions();
	
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> This type can be of one of the IntrinsicType or one of the ParameterType declared <!--
	 * end-model-doc -->
	 * 
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getParameter_Type()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfWO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getType();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Parameter#getType <em>Type</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);
	
} // Parameter
