/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Pragma</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Pragma#getInterfaceParent <em>Interface Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Pragma#getModuleParent <em>Module Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Pragma#getPragma <em>Pragma</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Pragma#getExpression <em>Expression</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Pragma#getTargets <em>Targets</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getPragma()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOf5e5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Pragma extends SignalElement {
	/**
	 * Returns the value of the '<em><b>Interface Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.InterfaceDefinition#getPragmas <em>Pragmas</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Interface Parent</em>' container reference isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Interface Parent</em>' container reference.
	 * @see #setInterfaceParent(InterfaceDefinition)
	 * @see fr.irisa.espresso.sme.SmePackage#getPragma_InterfaceParent()
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getPragmas
	 * @model opposite="pragmas" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOf5u5WEduz9o2pAin6-g'"
	 * @generated
	 */
	InterfaceDefinition getInterfaceParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Pragma#getInterfaceParent <em>Interface Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Interface Parent</em>' container reference.
	 * @see #getInterfaceParent()
	 * @generated
	 */
	void setInterfaceParent(InterfaceDefinition value);
	
	/**
	 * Returns the value of the '<em><b>Module Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.Module#getPragmas <em>Pragmas</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Module Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Module Parent</em>' container reference.
	 * @see #setModuleParent(Module)
	 * @see fr.irisa.espresso.sme.SmePackage#getPragma_ModuleParent()
	 * @see fr.irisa.espresso.sme.Module#getPragmas
	 * @model opposite="pragmas" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOf5-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Module getModuleParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Pragma#getModuleParent <em>Module Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Module Parent</em>' container reference.
	 * @see #getModuleParent()
	 * @generated
	 */
	void setModuleParent(Module value);
	
	/**
	 * Returns the value of the '<em><b>Pragma</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pragma</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Pragma</em>' attribute.
	 * @see #setPragma(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getPragma_Pragma()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOf6O5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getPragma();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Pragma#getPragma <em>Pragma</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Pragma</em>' attribute.
	 * @see #getPragma()
	 * @generated
	 */
	void setPragma(String value);
	
	/**
	 * Returns the value of the '<em><b>Expression</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expression</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Expression</em>' attribute.
	 * @see #setExpression(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getPragma_Expression()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOf6e5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getExpression();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Pragma#getExpression <em>Expression</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Expression</em>' attribute.
	 * @see #getExpression()
	 * @generated
	 */
	void setExpression(String value);
	
	/**
	 * Returns the value of the '<em><b>Targets</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.Identifier}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Targets</em>' reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Targets</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getPragma_Targets()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOf6u5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<Identifier> getTargets();
	
} // Pragma
