/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em><b>Process Attribute Kind</b></em>',
 * and utility methods for working with them. <!-- end-user-doc --> <!-- begin-model-doc --> A process model is said
 * either <b>safe</b> if it makes no side effects, either <b>deterministic</b> if its only possible side effects are
 * changes to its private memory, or <b>unsafe</b> otherwise. <!-- end-model-doc -->
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getProcessAttributeKind()
 * @model annotation="http://www.topcased.org/uuid uuid='_2D688O5WEduz9o2pAin6-g'"
 * @generated
 */
public enum ProcessAttributeKind implements Enumerator {
	/**
	 * The '<em><b>Safe</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #SAFE
	 * @generated
	 * @ordered
	 */
	SAFE_LITERAL(0, "safe", "safe"),

	/**
	 * The '<em><b>Deterministic</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #DETERMINISTIC
	 * @generated
	 * @ordered
	 */
	DETERMINISTIC_LITERAL(1, "deterministic", "deterministic"),

	/**
	 * The '<em><b>Unsafe</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #UNSAFE
	 * @generated
	 * @ordered
	 */
	UNSAFE_LITERAL(2, "unsafe", "unsafe");
	
	/**
	 * The '<em><b>Safe</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Safe</b></em>' literal object isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #SAFE_LITERAL
	 * @model name="safe" annotation="http://www.topcased.org/uuid uuid='_2EN34O5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							SAFE			= 0;
	
	/**
	 * The '<em><b>Deterministic</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Deterministic</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #DETERMINISTIC_LITERAL
	 * @model name="deterministic" annotation="http://www.topcased.org/uuid uuid='_2EN34e5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							DETERMINISTIC	= 1;
	
	/**
	 * The '<em><b>Unsafe</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Unsafe</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #UNSAFE_LITERAL
	 * @model name="unsafe" annotation="http://www.topcased.org/uuid uuid='_2EN34u5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							UNSAFE			= 2;
	
	/**
	 * An array of all the '<em><b>Process Attribute Kind</b></em>' enumerators. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	private static final ProcessAttributeKind[]		VALUES_ARRAY	= new ProcessAttributeKind[] { SAFE_LITERAL,
			DETERMINISTIC_LITERAL, UNSAFE_LITERAL,					};
	
	/**
	 * A public read-only list of all the '<em><b>Process Attribute Kind</b></em>' enumerators. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final List<ProcessAttributeKind>	VALUES			= Collections.unmodifiableList(Arrays
																			.asList(VALUES_ARRAY));
	
	/**
	 * Returns the '<em><b>Process Attribute Kind</b></em>' literal with the specified literal value. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ProcessAttributeKind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ProcessAttributeKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Process Attribute Kind</b></em>' literal with the specified name. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ProcessAttributeKind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ProcessAttributeKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Process Attribute Kind</b></em>' literal with the specified integer value. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static ProcessAttributeKind get(int value) {
		switch (value) {
			case SAFE:
				return SAFE_LITERAL;
			case DETERMINISTIC:
				return DETERMINISTIC_LITERAL;
			case UNSAFE:
				return UNSAFE_LITERAL;
		}
		return null;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final int		value;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	name;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	literal;
	
	/**
	 * Only this class can construct instances. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private ProcessAttributeKind(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int getValue() {
		return value;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getLiteral() {
		return literal;
	}
	
	/**
	 * Returns the literal value of the enumerator, which is its string representation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} // ProcessAttributeKind
