/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Signal</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Signal#getType <em>Type</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Signal#getArrayDimensions <em>Array Dimensions</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Signal#getInitValue <em>Init Value</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSignal()
 * @model abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOfZ-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Signal extends SignalOrRef, Identifier {
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> This type can be of one of the IntrinsicType or one of the SignalType declared <!--
	 * end-model-doc -->
	 * 
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getSignal_Type()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfaO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getType();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Signal#getType <em>Type</em>}' attribute. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);
	
	/**
	 * Returns the value of the '<em><b>Array Dimensions</b></em>' attribute list. The list contents are of type
	 * {@link java.lang.String}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Array Dimensions</em>' attribute list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Array Dimensions</em>' attribute list.
	 * @see fr.irisa.espresso.sme.SmePackage#getSignal_ArrayDimensions()
	 * @model unique="false" annotation="http://www.topcased.org/uuid uuid='_2LOfae5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<String> getArrayDimensions();
	
	/**
	 * Returns the value of the '<em><b>Init Value</b></em>' attribute list. The list contents are of type
	 * {@link java.lang.String}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Init Value</em>' attribute list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Init Value</em>' attribute list.
	 * @see fr.irisa.espresso.sme.SmePackage#getSignal_InitValue()
	 * @model unique="false" annotation="http://www.topcased.org/uuid uuid='_2LOfau5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<String> getInitValue();
	
} // Signal
