/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Signal Container</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <!-- begin-model-doc --> SignalContainer is an abstract meta-class that represents elements that creates hierarchie
 * in the model (all SME meta-classes with containment relations). Several operations was defined on these meta-classes
 * which allows to return identifiers according to their visibility to other hierarchical level. <!-- end-model-doc -->
 * 
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSignalContainer()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOe4-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface SignalContainer extends SignalElement {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This methods returns a list of all
	 * constants (ConstantValue or Parameter) that are visible in the scope of this container. <!-- end-model-doc -->
	 * 
	 * @model kind="operation" annotation="http://www.topcased.org/uuid uuid='_2LOe5O5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ConstantOrRef> getVisibleConstants();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This methods returns a list of all
	 * processes (Model Declaration or Parameter of type model) that are visible in the scope of this container. <!--
	 * end-model-doc -->
	 * 
	 * @model kind="operation" annotation="http://www.topcased.org/uuid uuid='_2LOe6O5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<InterfaceDefinition> getVisibleModelProcesses();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This methods returns the name of the
	 * container. <!-- end-model-doc -->
	 * 
	 * @model kind="operation" required="true" annotation="http://www.topcased.org/uuid uuid='_2LOe5-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getName();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This methods returns a list of all signals
	 * (Input, Output, Local, Input Instance or Output Instance) that are visible in the scope of this container. <!--
	 * end-model-doc -->
	 * 
	 * @model kind="operation" annotation="http://www.topcased.org/uuid uuid='_2LOe5e5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<SignalOrRef> getVisibleSignals();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This methods returns a list of all types
	 * (Type Declaration elements) that are visible in the scope of this container. <!-- end-model-doc -->
	 * 
	 * @model kind="operation" annotation="http://www.topcased.org/uuid uuid='_2LOe5u5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<Identifier> getVisibleTypes();
	
} // SignalContainer
