/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import java.util.Set;

import org.eclipse.emf.ecore.EObject;

import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Signal Element</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> SignalElement is the root meta-class for all elements that can be transformed into the
 * Signal native AST. <!-- end-model-doc -->
 * 
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSignalElement()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOe0u5WEduz9o2pAin6-g'"
 * @generated
 */
public interface SignalElement extends EObject {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This methods returns the container of the
	 * Signal element. <!-- end-model-doc -->
	 * 
	 * @model kind="operation" required="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOe0-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	SignalContainer getParent();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This method builds the abstract syntax
	 * tree representing the signal element. The returned integer corresponds to the adress of the node element in the
	 * native compiler.
	 * 
	 * <!-- end-model-doc -->
	 * 
	 * @model required="true" exceptions="fr.irisa.espresso.sme.CyclicDefinitionException"
	 *        pathDataType="fr.irisa.espresso.sme.Set<fr.irisa.espresso.sme.SignalElement>" pathRequired="true"
	 * @generated
	 */
	long getAST(Set<SignalElement> path) throws CyclicDefinitionException;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This method returns the
	 * <code>declTree</code> declaration list to which is added the declaration of the signal element (if any).
	 * 
	 * @param errorNode
	 *        the address of the node corresponding to the current list of declarations <!-- end-model-doc -->
	 * @model required="true" declTreeRequired="true"
	 * @generated
	 */
	long getDeclarationAST(long errorNode);
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> This method returns the
	 * <code>bodyTree</code> declaration list to which is added the equation built from the signal element (if any).
	 * 
	 * @param body
	 *        the address of the node corresponding to the current equation list. <!-- end-model-doc -->
	 * @model required="true" bodyTreeRequired="true"
	 * @generated
	 */
	long buildEquationsAST(long body);
	
} // SignalElement
