/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em><b>Signal Intrinsic Type</b></em>',
 * and utility methods for working with them. <!-- end-user-doc --> <!-- begin-model-doc --> This enumeration contains
 * all intrinsic signal types of the SIGNAL language. <!-- end-model-doc -->
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSignalIntrinsicType()
 * @model annotation="http://www.topcased.org/uuid uuid='_1_Anwe5WEduz9o2pAin6-g'"
 * @generated
 */
public enum SignalIntrinsicType implements Enumerator {
	/**
	 * The '<em><b>Undefined</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #UNDEFINED
	 * @generated
	 * @ordered
	 */
	UNDEFINED_LITERAL(0, "undefined", ""),

	/**
	 * The '<em><b>Boolean</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #BOOLEAN
	 * @generated
	 * @ordered
	 */
	BOOLEAN_LITERAL(1, "boolean", "boolean"),

	/**
	 * The '<em><b>Char</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #CHAR
	 * @generated
	 * @ordered
	 */
	CHAR_LITERAL(2, "char", "char"),

	/**
	 * The '<em><b>Complex</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #COMPLEX
	 * @generated
	 * @ordered
	 */
	COMPLEX_LITERAL(3, "complex", "complex"),

	/**
	 * The '<em><b>Dcomplex</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #DCOMPLEX
	 * @generated
	 * @ordered
	 */
	DCOMPLEX_LITERAL(4, "dcomplex", "dcomplex"),

	/**
	 * The '<em><b>Dreal</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #DREAL
	 * @generated
	 * @ordered
	 */
	DREAL_LITERAL(5, "dreal", "dreal"),

	/**
	 * The '<em><b>Event</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #EVENT
	 * @generated
	 * @ordered
	 */
	EVENT_LITERAL(6, "event", "event"),

	/**
	 * The '<em><b>Integer</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #INTEGER
	 * @generated
	 * @ordered
	 */
	INTEGER_LITERAL(7, "integer", "integer"),

	/**
	 * The '<em><b>Long</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #LONG
	 * @generated
	 * @ordered
	 */
	LONG_LITERAL(8, "long", "long"),

	/**
	 * The '<em><b>Real</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #REAL
	 * @generated
	 * @ordered
	 */
	REAL_LITERAL(9, "real", "real"),

	/**
	 * The '<em><b>Short</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #SHORT
	 * @generated
	 * @ordered
	 */
	SHORT_LITERAL(10, "short", "short"),

	/**
	 * The '<em><b>String</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #STRING
	 * @generated
	 * @ordered
	 */
	STRING_LITERAL(11, "string", "string");
	
	/**
	 * The '<em><b>Undefined</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Undefined</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #UNDEFINED_LITERAL
	 * @model name="undefined" literal=""
	 * @generated
	 * @ordered
	 */
	public static final int							UNDEFINED			= 0;
	
	/**
	 * The '<em><b>Boolean</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Boolean</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #BOOLEAN_LITERAL
	 * @model name="boolean" annotation="http://www.topcased.org/uuid uuid='_1_JxsO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							BOOLEAN				= 1;
	
	/**
	 * The '<em><b>Char</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Char</b></em>' literal object isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #CHAR_LITERAL
	 * @model name="char" annotation="http://www.topcased.org/uuid uuid='_1_csoO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							CHAR				= 2;
	
	/**
	 * The '<em><b>Complex</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Complex</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #COMPLEX_LITERAL
	 * @model name="complex" annotation="http://www.topcased.org/uuid uuid='_1_wOoO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							COMPLEX				= 3;
	
	/**
	 * The '<em><b>Dcomplex</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Dcomplex</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #DCOMPLEX_LITERAL
	 * @model name="dcomplex" annotation="http://www.topcased.org/uuid uuid='_2ADJkO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							DCOMPLEX			= 4;
	
	/**
	 * The '<em><b>Dreal</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Dreal</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #DREAL_LITERAL
	 * @model name="dreal" annotation="http://www.topcased.org/uuid uuid='_2AWEgO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							DREAL				= 5;
	
	/**
	 * The '<em><b>Event</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Event</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #EVENT_LITERAL
	 * @model name="event" annotation="http://www.topcased.org/uuid uuid='_2Ao_cO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							EVENT				= 6;
	
	/**
	 * The '<em><b>Integer</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Integer</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #INTEGER_LITERAL
	 * @model name="integer" annotation="http://www.topcased.org/uuid uuid='_2AywcO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							INTEGER				= 7;
	
	/**
	 * The '<em><b>Long</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Long</b></em>' literal object isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #LONG_LITERAL
	 * @model name="long" annotation="http://www.topcased.org/uuid uuid='_2BFrYO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							LONG				= 8;
	
	/**
	 * The '<em><b>Real</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Real</b></em>' literal object isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #REAL_LITERAL
	 * @model name="real" annotation="http://www.topcased.org/uuid uuid='_2BZNYO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							REAL				= 9;
	
	/**
	 * The '<em><b>Short</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Short</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #SHORT_LITERAL
	 * @model name="short" annotation="http://www.topcased.org/uuid uuid='_2BsIUO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							SHORT				= 10;
	
	/**
	 * The '<em><b>String</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #STRING_LITERAL
	 * @model name="string" annotation="http://www.topcased.org/uuid uuid='_2B1SQO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int							STRING				= 11;
	
	/**
	 * An array of all the '<em><b>Signal Intrinsic Type</b></em>' enumerators. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	private static final SignalIntrinsicType[]		VALUES_ARRAY		= new SignalIntrinsicType[] {
			UNDEFINED_LITERAL, BOOLEAN_LITERAL, CHAR_LITERAL, COMPLEX_LITERAL, DCOMPLEX_LITERAL, DREAL_LITERAL,
			EVENT_LITERAL, INTEGER_LITERAL, LONG_LITERAL, REAL_LITERAL, SHORT_LITERAL, STRING_LITERAL, };
	
	/**
	 * A public read-only list of all the '<em><b>Signal Intrinsic Type</b></em>' enumerators. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final List<SignalIntrinsicType>	VALUES				= Collections.unmodifiableList(Arrays
																				.asList(VALUES_ARRAY));
	
	/**
	 * An array of all the '<em><b>Signal Intrinsic Type</b></em>' as Strings. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated NOT
	 */
	private static final String[]					STRING_VALUES_ARRAY	= new String[] { "", "boolean", "char",
			"complex", "dcomplex", "dreal", "event", "integer", "long", "real", "short", "string" };
	
	/**
	 * A public read-only list of all the '<em><b>Signal Intrinsic Type</b></em>' as strings. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public static final List<String>				STRING_VALUES		= Arrays.asList(STRING_VALUES_ARRAY);
	
	/**
	 * Returns the '<em><b>Signal Intrinsic Type</b></em>' literal with the specified literal value. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static SignalIntrinsicType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SignalIntrinsicType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Signal Intrinsic Type</b></em>' literal with the specified name. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static SignalIntrinsicType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SignalIntrinsicType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Signal Intrinsic Type</b></em>' literal with the specified integer value. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static SignalIntrinsicType get(int value) {
		switch (value) {
			case UNDEFINED:
				return UNDEFINED_LITERAL;
			case BOOLEAN:
				return BOOLEAN_LITERAL;
			case CHAR:
				return CHAR_LITERAL;
			case COMPLEX:
				return COMPLEX_LITERAL;
			case DCOMPLEX:
				return DCOMPLEX_LITERAL;
			case DREAL:
				return DREAL_LITERAL;
			case EVENT:
				return EVENT_LITERAL;
			case INTEGER:
				return INTEGER_LITERAL;
			case LONG:
				return LONG_LITERAL;
			case REAL:
				return REAL_LITERAL;
			case SHORT:
				return SHORT_LITERAL;
			case STRING:
				return STRING_LITERAL;
		}
		return null;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final int		value;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	name;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	literal;
	
	/**
	 * Only this class can construct instances. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private SignalIntrinsicType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int getValue() {
		return value;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getLiteral() {
		return literal;
	}
	
	/**
	 * Returns the literal value of the enumerator, which is its string representation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} // SignalIntrinsicType
