/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Signal Operator</b></em>'. <!-- end-user-doc -->
 * 
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSignalOperator()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOfqO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface SignalOperator extends SignalContainer {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @model unique="false" required="true" ordered="false" portUnique="false" portRequired="true" portOrdered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfq-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getPortName(OperatorPort port);
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @model kind="operation" required="true" annotation="http://www.topcased.org/uuid uuid='_2LOfqe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<InputPort> getInputPorts();
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @model kind="operation" required="true" annotation="http://www.topcased.org/uuid uuid='_2LOfqu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<OutputPort> getOutputPorts();
	
} // SignalOperator
