/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Signal Ref</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.SignalRef#getSignal <em>Signal</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalRef#getSigName <em>Sig Name</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SignalRef#getModelParent <em>Model Parent</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSignalRef()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfY-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface SignalRef extends SignalOrRef, SignalElement {
	/**
	 * Returns the value of the '<em><b>Signal</b></em>' reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Signal</em>' reference isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Signal</em>' reference.
	 * @see #setSignal(Signal)
	 * @see fr.irisa.espresso.sme.SmePackage#getSignalRef_Signal()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOfZO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Signal getSignal();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.SignalRef#getSignal <em>Signal</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Signal</em>' reference.
	 * @see #getSignal()
	 * @generated
	 */
	void setSignal(Signal value);
	
	/**
	 * Returns the value of the '<em><b>Sig Name</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sig Name</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Sig Name</em>' attribute.
	 * @see #setSigName(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getSignalRef_SigName()
	 * @model unique="false" required="true" transient="true" volatile="true" derived="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfZe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getSigName();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.SignalRef#getSigName <em>Sig Name</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Sig Name</em>' attribute.
	 * @see #getSigName()
	 * @generated
	 */
	void setSigName(String value);
	
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getSignalRef <em>Signal Ref</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getSignalRef_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getSignalRef
	 * @model opposite="signalRef" required="true" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfZu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.SignalRef#getModelParent <em>Model Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * 
	 * @param asCode
	 *        if it is true, the generated string will be formatted as in code generation otherwise, it calls the
	 *        classical toString method.
	 * @return a string describing the identifier
	 */
	String toString(boolean asCode);
	
} // SignalRef
