/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em><b>Signal State Kind</b></em>', and
 * utility methods for working with them. <!-- end-user-doc --> <!-- begin-model-doc --> This enumeration is used to
 * qualify the test applied to a signal: checking its presence or, if it is a boolean signal its value. <!--
 * end-model-doc -->
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSignalStateKind()
 * @model annotation="http://www.topcased.org/uuid uuid='_2Ii-Qe5WEduz9o2pAin6-g'"
 * @generated
 */
public enum SignalStateKind implements Enumerator {
	/**
	 * The '<em><b>Present</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #PRESENT
	 * @generated
	 * @ordered
	 */
	PRESENT_LITERAL(0, "Present", "Present"),

	/**
	 * The '<em><b>True</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #TRUE
	 * @generated
	 * @ordered
	 */
	TRUE_LITERAL(1, "True", "True"),

	/**
	 * The '<em><b>False</b></em>' literal object. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #FALSE
	 * @generated
	 * @ordered
	 */
	FALSE_LITERAL(2, "False", "False");
	
	/**
	 * The '<em><b>Present</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Present</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #PRESENT_LITERAL
	 * @model name="Present" annotation="http://www.topcased.org/uuid uuid='_2IsIMO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						PRESENT			= 0;
	
	/**
	 * The '<em><b>True</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>True</b></em>' literal object isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #TRUE_LITERAL
	 * @model name="True" annotation="http://www.topcased.org/uuid uuid='_2IsIMe5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						TRUE			= 1;
	
	/**
	 * The '<em><b>False</b></em>' literal value. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>False</b></em>' literal object isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @see #FALSE_LITERAL
	 * @model name="False" annotation="http://www.topcased.org/uuid uuid='_2I15MO5WEduz9o2pAin6-g'"
	 * @generated
	 * @ordered
	 */
	public static final int						FALSE			= 2;
	
	/**
	 * An array of all the '<em><b>Signal State Kind</b></em>' enumerators. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	private static final SignalStateKind[]		VALUES_ARRAY	= new SignalStateKind[] { PRESENT_LITERAL,
			TRUE_LITERAL, FALSE_LITERAL,						};
	
	/**
	 * A public read-only list of all the '<em><b>Signal State Kind</b></em>' enumerators. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static final List<SignalStateKind>	VALUES			= Collections.unmodifiableList(Arrays
																		.asList(VALUES_ARRAY));
	
	/**
	 * Returns the '<em><b>Signal State Kind</b></em>' literal with the specified literal value. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static SignalStateKind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SignalStateKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Signal State Kind</b></em>' literal with the specified name. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static SignalStateKind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SignalStateKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}
	
	/**
	 * Returns the '<em><b>Signal State Kind</b></em>' literal with the specified integer value. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static SignalStateKind get(int value) {
		switch (value) {
			case PRESENT:
				return PRESENT_LITERAL;
			case TRUE:
				return TRUE_LITERAL;
			case FALSE:
				return FALSE_LITERAL;
		}
		return null;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final int		value;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	name;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private final String	literal;
	
	/**
	 * Only this class can construct instances. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private SignalStateKind(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int getValue() {
		return value;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getLiteral() {
		return literal;
	}
	
	/**
	 * Returns the literal value of the enumerator, which is its string representation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} // SignalStateKind
