/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc --> The <b>Factory</b> for the model. It provides a create method for each non-abstract class of
 * the model. <!-- end-user-doc -->
 * 
 * @see fr.irisa.espresso.sme.SmePackage
 * @generated
 */
public interface SmeFactory extends EFactory {
	/**
	 * The singleton instance of the factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	SmeFactory	eINSTANCE	= fr.irisa.espresso.sme.impl.SmeFactoryImpl.init();
	
	/**
	 * Returns a new object of class '<em>Basic Iterate</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Basic Iterate</em>'.
	 * @generated
	 */
	BasicIterate createBasicIterate();
	
	/**
	 * Returns a new object of class '<em>Iterate</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Iterate</em>'.
	 * @generated
	 */
	Iterate createIterate();
	
	/**
	 * Returns a new object of class '<em>Iteration Init</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Iteration Init</em>'.
	 * @generated
	 */
	IterationInit createIterationInit();
	
	/**
	 * Returns a new object of class '<em>Specifications</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Specifications</em>'.
	 * @generated
	 */
	Specifications createSpecifications();
	
	/**
	 * Returns a new object of class '<em>Sub Process</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Sub Process</em>'.
	 * @generated
	 */
	SubProcess createSubProcess();
	
	/**
	 * Returns a new object of class '<em>Enumeration Type</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Enumeration Type</em>'.
	 * @generated
	 */
	EnumerationType createEnumerationType();
	
	/**
	 * Returns a new object of class '<em>Model Type</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Model Type</em>'.
	 * @generated
	 */
	ModelType createModelType();
	
	/**
	 * Returns a new object of class '<em>Substitution Type</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Substitution Type</em>'.
	 * @generated
	 */
	SubstitutionType createSubstitutionType();
	
	/**
	 * Returns a new object of class '<em>Tuple Type</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Tuple Type</em>'.
	 * @generated
	 */
	TupleType createTupleType();
	
	/**
	 * Returns a new object of class '<em>Model Declaration</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Model Declaration</em>'.
	 * @generated
	 */
	ModelDeclaration createModelDeclaration();
	
	/**
	 * Returns a new object of class '<em>Model Ref</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Model Ref</em>'.
	 * @generated
	 */
	ModelRef createModelRef();
	
	/**
	 * Returns a new object of class '<em>Model Instance</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Model Instance</em>'.
	 * @generated
	 */
	ModelInstance createModelInstance();
	
	/**
	 * Returns a new object of class '<em>Module</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Module</em>'.
	 * @generated
	 */
	Module createModule();
	
	/**
	 * Returns a new object of class '<em>Use Module</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Use Module</em>'.
	 * @generated
	 */
	UseModule createUseModule();
	
	/**
	 * Returns a new object of class '<em>Constant Ref</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Constant Ref</em>'.
	 * @generated
	 */
	ConstantRef createConstantRef();
	
	/**
	 * Returns a new object of class '<em>Constant Value</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Constant Value</em>'.
	 * @generated
	 */
	ConstantValue createConstantValue();
	
	/**
	 * Returns a new object of class '<em>Literal</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Literal</em>'.
	 * @generated
	 */
	Literal createLiteral();
	
	/**
	 * Returns a new object of class '<em>Enumeration Value</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Enumeration Value</em>'.
	 * @generated
	 */
	EnumerationValue createEnumerationValue();
	
	/**
	 * Returns a new object of class '<em>Parameter</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Parameter</em>'.
	 * @generated
	 */
	Parameter createParameter();
	
	/**
	 * Returns a new object of class '<em>Parameter Instance</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Parameter Instance</em>'.
	 * @generated
	 */
	ParameterInstance createParameterInstance();
	
	/**
	 * Returns a new object of class '<em>Iterator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Iterator</em>'.
	 * @generated
	 */
	Iterator createIterator();
	
	/**
	 * Returns a new object of class '<em>Index</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Index</em>'.
	 * @generated
	 */
	Index createIndex();
	
	/**
	 * Returns a new object of class '<em>Signal Ref</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Signal Ref</em>'.
	 * @generated
	 */
	SignalRef createSignalRef();
	
	/**
	 * Returns a new object of class '<em>Input</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Input</em>'.
	 * @generated
	 */
	Input createInput();
	
	/**
	 * Returns a new object of class '<em>Input Instance</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Input Instance</em>'.
	 * @generated
	 */
	InputInstance createInputInstance();
	
	/**
	 * Returns a new object of class '<em>Output</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Output</em>'.
	 * @generated
	 */
	Output createOutput();
	
	/**
	 * Returns a new object of class '<em>Output Instance</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Output Instance</em>'.
	 * @generated
	 */
	OutputInstance createOutputInstance();
	
	/**
	 * Returns a new object of class '<em>Local</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Local</em>'.
	 * @generated
	 */
	Local createLocal();
	
	/**
	 * Returns a new object of class '<em>Case Connection</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Case Connection</em>'.
	 * @generated
	 */
	CaseConnection createCaseConnection();
	
	/**
	 * Returns a new object of class '<em>Clock Relation</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Clock Relation</em>'.
	 * @generated
	 */
	ClockRelation createClockRelation();
	
	/**
	 * Returns a new object of class '<em>Condition</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Condition</em>'.
	 * @generated
	 */
	Condition createCondition();
	
	/**
	 * Returns a new object of class '<em>Constant Affectation</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Constant Affectation</em>'.
	 * @generated
	 */
	ConstantAffectation createConstantAffectation();
	
	/**
	 * Returns a new object of class '<em>Dependence</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Dependence</em>'.
	 * @generated
	 */
	Dependence createDependence();
	
	/**
	 * Returns a new object of class '<em>Dataflow Connection</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Dataflow Connection</em>'.
	 * @generated
	 */
	DataflowConnection createDataflowConnection();
	
	/**
	 * Returns a new object of class '<em>Input Port</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Input Port</em>'.
	 * @generated
	 */
	InputPort createInputPort();
	
	/**
	 * Returns a new object of class '<em>Output Port</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Output Port</em>'.
	 * @generated
	 */
	OutputPort createOutputPort();
	
	/**
	 * Returns a new object of class '<em>And</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>And</em>'.
	 * @generated
	 */
	And createAnd();
	
	/**
	 * Returns a new object of class '<em>Arithmetic Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Arithmetic Operator</em>'.
	 * @generated
	 */
	ArithmeticOperator createArithmeticOperator();
	
	/**
	 * Returns a new object of class '<em>Array Enumeration</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Array Enumeration</em>'.
	 * @generated
	 */
	ArrayEnumeration createArrayEnumeration();
	
	/**
	 * Returns a new object of class '<em>Array Product</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Array Product</em>'.
	 * @generated
	 */
	ArrayProduct createArrayProduct();
	
	/**
	 * Returns a new object of class '<em>Array Recovery</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Array Recovery</em>'.
	 * @generated
	 */
	ArrayRecovery createArrayRecovery();
	
	/**
	 * Returns a new object of class '<em>Array Restructuration</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Array Restructuration</em>'.
	 * @generated
	 */
	ArrayRestructuration createArrayRestructuration();
	
	/**
	 * Returns a new object of class '<em>Assertion</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Assertion</em>'.
	 * @generated
	 */
	Assertion createAssertion();
	
	/**
	 * Returns a new object of class '<em>Assertion Clock Constraint Operator</em>'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return a new object of class '<em>Assertion Clock Constraint Operator</em>'.
	 * @generated
	 */
	AssertionClockConstraintOperator createAssertionClockConstraintOperator();
	
	/**
	 * Returns a new object of class '<em>Assertion Clock Speed Operator</em>'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return a new object of class '<em>Assertion Clock Speed Operator</em>'.
	 * @generated
	 */
	AssertionClockSpeedOperator createAssertionClockSpeedOperator();
	
	/**
	 * Returns a new object of class '<em>Boolean Expression</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Boolean Expression</em>'.
	 * @generated
	 */
	BooleanExpression createBooleanExpression();
	
	/**
	 * Returns a new object of class '<em>Cartesian Product</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Cartesian Product</em>'.
	 * @generated
	 */
	CartesianProduct createCartesianProduct();
	
	/**
	 * Returns a new object of class '<em>Cell</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Cell</em>'.
	 * @generated
	 */
	Cell createCell();
	
	/**
	 * Returns a new object of class '<em>Clock Constraint Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Clock Constraint Operator</em>'.
	 * @generated
	 */
	ClockConstraintOperator createClockConstraintOperator();
	
	/**
	 * Returns a new object of class '<em>Clock Relation Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Clock Relation Operator</em>'.
	 * @generated
	 */
	ClockRelationOperator createClockRelationOperator();
	
	/**
	 * Returns a new object of class '<em>Clock Speed Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Clock Speed Operator</em>'.
	 * @generated
	 */
	ClockSpeedOperator createClockSpeedOperator();
	
	/**
	 * Returns a new object of class '<em>Comparison Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Comparison Operator</em>'.
	 * @generated
	 */
	ComparisonOperator createComparisonOperator();
	
	/**
	 * Returns a new object of class '<em>Complex Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Complex Operator</em>'.
	 * @generated
	 */
	ComplexOperator createComplexOperator();
	
	/**
	 * Returns a new object of class '<em>Concatenation</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Concatenation</em>'.
	 * @generated
	 */
	Concatenation createConcatenation();
	
	/**
	 * Returns a new object of class '<em>Counter</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Counter</em>'.
	 * @generated
	 */
	Counter createCounter();
	
	/**
	 * Returns a new object of class '<em>Delay</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Delay</em>'.
	 * @generated
	 */
	Delay createDelay();
	
	/**
	 * Returns a new object of class '<em>Dependence Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Dependence Operator</em>'.
	 * @generated
	 */
	DependenceOperator createDependenceOperator();
	
	/**
	 * Returns a new object of class '<em>Extraction</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Extraction</em>'.
	 * @generated
	 */
	Extraction createExtraction();
	
	/**
	 * Returns a new object of class '<em>If Then Else</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>If Then Else</em>'.
	 * @generated
	 */
	IfThenElse createIfThenElse();
	
	/**
	 * Returns a new object of class '<em>Merge</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Merge</em>'.
	 * @generated
	 */
	Merge createMerge();
	
	/**
	 * Returns a new object of class '<em>Not</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Not</em>'.
	 * @generated
	 */
	Not createNot();
	
	/**
	 * Returns a new object of class '<em>Null Clock</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Null Clock</em>'.
	 * @generated
	 */
	NullClock createNullClock();
	
	/**
	 * Returns a new object of class '<em>Numeric Expression</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Numeric Expression</em>'.
	 * @generated
	 */
	NumericExpression createNumericExpression();
	
	/**
	 * Returns a new object of class '<em>Or</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Or</em>'.
	 * @generated
	 */
	Or createOr();
	
	/**
	 * Returns a new object of class '<em>Pragma</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Pragma</em>'.
	 * @generated
	 */
	Pragma createPragma();
	
	/**
	 * Returns a new object of class '<em>Repetition Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Repetition Operator</em>'.
	 * @generated
	 */
	RepetitionOperator createRepetitionOperator();
	
	/**
	 * Returns a new object of class '<em>Sequential Definition</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Sequential Definition</em>'.
	 * @generated
	 */
	SequentialDefinition createSequentialDefinition();
	
	/**
	 * Returns a new object of class '<em>Switch</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Switch</em>'.
	 * @generated
	 */
	Switch createSwitch();
	
	/**
	 * Returns a new object of class '<em>Transposition</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Transposition</em>'.
	 * @generated
	 */
	Transposition createTransposition();
	
	/**
	 * Returns a new object of class '<em>Tuple Operator</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Tuple Operator</em>'.
	 * @generated
	 */
	TupleOperator createTupleOperator();
	
	/**
	 * Returns a new object of class '<em>Unary Minus</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Unary Minus</em>'.
	 * @generated
	 */
	UnaryMinus createUnaryMinus();
	
	/**
	 * Returns a new object of class '<em>Variable</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Variable</em>'.
	 * @generated
	 */
	Variable createVariable();
	
	/**
	 * Returns a new object of class '<em>Window</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Window</em>'.
	 * @generated
	 */
	Window createWindow();
	
	/**
	 * Returns a new object of class '<em>Xor</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Xor</em>'.
	 * @generated
	 */
	Xor createXor();
	
	/**
	 * Returns a new object of class '<em>History</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>History</em>'.
	 * @generated
	 */
	History createHistory();
	
	/**
	 * Returns a new object of class '<em>State</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>State</em>'.
	 * @generated
	 */
	State createState();
	
	/**
	 * Returns a new object of class '<em>Automaton</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Automaton</em>'.
	 * @generated
	 */
	Automaton createAutomaton();
	
	/**
	 * Returns a new object of class '<em>And State</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>And State</em>'.
	 * @generated
	 */
	AndState createAndState();
	
	/**
	 * Returns a new object of class '<em>Weak Transition</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Weak Transition</em>'.
	 * @generated
	 */
	WeakTransition createWeakTransition();
	
	/**
	 * Returns a new object of class '<em>Strong Transition</em>'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Strong Transition</em>'.
	 * @generated
	 */
	StrongTransition createStrongTransition();
	
	/**
	 * Returns the package supported by this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the package supported by this factory.
	 * @generated
	 */
	SmePackage getSmePackage();
	
} // SmeFactory
