/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Specifications</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Specifications#getInterfaceParent <em>Interface Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Specifications#getTypeParent <em>Type Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Specifications#getModelDeclarations <em>Model Declarations</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSpecifications()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfBu5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Specifications extends Model {
	/**
	 * Returns the value of the '<em><b>Interface Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.InterfaceDefinition#getSpec <em>Spec</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Parent</em>' container reference isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Interface Parent</em>' container reference.
	 * @see #setInterfaceParent(InterfaceDefinition)
	 * @see fr.irisa.espresso.sme.SmePackage#getSpecifications_InterfaceParent()
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getSpec
	 * @model opposite="spec" transient="false" annotation="http://www.topcased.org/uuid uuid='_2LOfB-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	InterfaceDefinition getInterfaceParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Specifications#getInterfaceParent <em>Interface Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Interface Parent</em>' container reference.
	 * @see #getInterfaceParent()
	 * @generated
	 */
	void setInterfaceParent(InterfaceDefinition value);
	
	/**
	 * Returns the value of the '<em><b>Type Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.TupleType#getSpec <em>Spec</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Type Parent</em>' container reference.
	 * @see #setTypeParent(TupleType)
	 * @see fr.irisa.espresso.sme.SmePackage#getSpecifications_TypeParent()
	 * @see fr.irisa.espresso.sme.TupleType#getSpec
	 * @model opposite="spec" transient="false" annotation="http://www.topcased.org/uuid uuid='_2LOfCO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	TupleType getTypeParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Specifications#getTypeParent <em>Type Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Type Parent</em>' container reference.
	 * @see #getTypeParent()
	 * @generated
	 */
	void setTypeParent(TupleType value);
	
	/**
	 * Returns the value of the '<em><b>Model Declarations</b></em>' containment reference list. The list contents are
	 * of type {@link fr.irisa.espresso.sme.ModelDeclaration}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.ModelDeclaration#getSpecParent <em>Spec Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Declarations</em>' containment reference list isn't clear, there really should
	 * be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Declarations</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getSpecifications_ModelDeclarations()
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getSpecParent
	 * @model opposite="specParent" containment="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfCe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<ModelDeclaration> getModelDeclarations();
	
} // Specifications
