/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>State Or History</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.StateOrHistory#getDst_StrongTransitions <em>Dst Strong Transitions</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.StateOrHistory#getDst_WeakTransitions <em>Dst Weak Transitions</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getStateOrHistory()
 * @model interface="true" abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOf-u5WEduz9o2pAin6-g'"
 * @generated
 */
public interface StateOrHistory extends ConnectableElement {
	/**
	 * Returns the value of the '<em><b>Dst Strong Transitions</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.StrongTransition}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.StrongTransition#getDst <em>Dst</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst Strong Transitions</em>' reference list isn't clear, there really should be more
	 * of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst Strong Transitions</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getStateOrHistory_Dst_StrongTransitions()
	 * @see fr.irisa.espresso.sme.StrongTransition#getDst
	 * @model opposite="dst" annotation="http://www.topcased.org/uuid uuid='_2LOf--5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<StrongTransition> getDst_StrongTransitions();
	
	/**
	 * Returns the value of the '<em><b>Dst Weak Transitions</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.WeakTransition}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.WeakTransition#getDst <em>Dst</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst Weak Transitions</em>' reference list isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst Weak Transitions</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getStateOrHistory_Dst_WeakTransitions()
	 * @see fr.irisa.espresso.sme.WeakTransition#getDst
	 * @model opposite="dst" annotation="http://www.topcased.org/uuid uuid='_2LOf_O5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<WeakTransition> getDst_WeakTransitions();
	
} // StateOrHistory
