/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Sub Process</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.SubProcess#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SubProcess#getDst_CaseConnection <em>Dst Case Connection</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSubProcess()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfCu5WEduz9o2pAin6-g'"
 * @generated
 */
public interface SubProcess extends Model, ClockedExpr, Identifier, DependenceInOut {
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getSubprocesses <em>Subprocesses</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getSubProcess_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getSubprocesses
	 * @model opposite="subprocesses" required="true" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfC-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.SubProcess#getModelParent <em>Model Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * Returns the value of the '<em><b>Dst Case Connection</b></em>' reference. It is bidirectional and its opposite is
	 * '{@link fr.irisa.espresso.sme.CaseConnection#getDst <em>Dst</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst Case Connection</em>' reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst Case Connection</em>' reference.
	 * @see #setDst_CaseConnection(CaseConnection)
	 * @see fr.irisa.espresso.sme.SmePackage#getSubProcess_Dst_CaseConnection()
	 * @see fr.irisa.espresso.sme.CaseConnection#getDst
	 * @model opposite="dst" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOfDO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	CaseConnection getDst_CaseConnection();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.SubProcess#getDst_CaseConnection
	 * <em>Dst Case Connection</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Dst Case Connection</em>' reference.
	 * @see #getDst_CaseConnection()
	 * @generated
	 */
	void setDst_CaseConnection(CaseConnection value);
	
} // SubProcess
