/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Substitution Type</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.SubstitutionType#getType <em>Type</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SubstitutionType#isIsExternal <em>Is External</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.SubstitutionType#getArrayDimensions <em>Array Dimensions</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSubstitutionType()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfGO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface SubstitutionType extends TypeDeclaration, SignalType {
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> This type can be of one of the IntrinsicType or one of the SignalType declared <!--
	 * end-model-doc -->
	 * 
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getSubstitutionType_Type()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfGe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getType();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.SubstitutionType#getType <em>Type</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);
	
	/**
	 * Returns the value of the '<em><b>Is External</b></em>' attribute. The default value is <code>"false"</code>. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> The initial value for this type will be
	 * generated automatically through a constant whose type is this external type. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Is External</em>' attribute.
	 * @see #setIsExternal(boolean)
	 * @see fr.irisa.espresso.sme.SmePackage#getSubstitutionType_IsExternal()
	 * @model default="false" annotation="http://www.topcased.org/uuid uuid='_2LOfGu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	boolean isIsExternal();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.SubstitutionType#isIsExternal <em>Is External</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Is External</em>' attribute.
	 * @see #isIsExternal()
	 * @generated
	 */
	void setIsExternal(boolean value);
	
} // SubstitutionType
