/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Switch</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Switch#getSignal <em>Signal</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Switch#getSrc_CaseConnections <em>Src Case Connections</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Switch#getSrcField <em>Src Field</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getSwitch()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOf7u5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Switch extends NamedElement, DataflowOperator, ConnectableElement {
	/**
	 * Returns the value of the '<em><b>Signal</b></em>' reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Signal</em>' reference isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Signal</em>' reference.
	 * @see #setSignal(Signal)
	 * @see fr.irisa.espresso.sme.SmePackage#getSwitch_Signal()
	 * @model required="true" ordered="false" annotation="http://www.topcased.org/uuid uuid='_2LOf7-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Signal getSignal();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Switch#getSignal <em>Signal</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Signal</em>' reference.
	 * @see #getSignal()
	 * @generated
	 */
	void setSignal(Signal value);
	
	/**
	 * Returns the value of the '<em><b>Src Case Connections</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.CaseConnection}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.CaseConnection#getSrc <em>Src</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src Case Connections</em>' reference list isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src Case Connections</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getSwitch_Src_CaseConnections()
	 * @see fr.irisa.espresso.sme.CaseConnection#getSrc
	 * @model opposite="src" required="true" annotation="http://www.topcased.org/uuid uuid='_2LOf8O5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<CaseConnection> getSrc_CaseConnections();
	
	/**
	 * Returns the value of the '<em><b>Src Field</b></em>' attribute. The default value is <code>""</code>. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src Field</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src Field</em>' attribute.
	 * @see #setSrcField(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getSwitch_SrcField()
	 * @model default="" unique="false" ordered="false"
	 * @generated
	 */
	String getSrcField();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Switch#getSrcField <em>Src Field</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Src Field</em>' attribute.
	 * @see #getSrcField()
	 * @generated
	 */
	void setSrcField(String value);
	
} // Switch
