/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Transition</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.Transition#getGuard <em>Guard</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Transition#getPriority <em>Priority</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.Transition#getAutomatonParent <em>Automaton Parent</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getTransition()
 * @model abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOgD-5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Transition extends Connection {
	/**
	 * Returns the value of the '<em><b>Guard</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Guard</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Guard</em>' attribute.
	 * @see #setGuard(String)
	 * @see fr.irisa.espresso.sme.SmePackage#getTransition_Guard()
	 * @model annotation="http://www.topcased.org/uuid uuid='_2LOgEO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	String getGuard();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Transition#getGuard <em>Guard</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Guard</em>' attribute.
	 * @see #getGuard()
	 * @generated
	 */
	void setGuard(String value);
	
	/**
	 * Returns the value of the '<em><b>Priority</b></em>' attribute. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Priority</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Priority</em>' attribute.
	 * @see #setPriority(int)
	 * @see fr.irisa.espresso.sme.SmePackage#getTransition_Priority()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOgEe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	int getPriority();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Transition#getPriority <em>Priority</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Priority</em>' attribute.
	 * @see #getPriority()
	 * @generated
	 */
	void setPriority(int value);
	
	/**
	 * Returns the value of the '<em><b>Automaton Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.Automaton#getTransitions <em>Transitions</em>}'. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Automaton Parent</em>' container reference isn't clear, there really should be more of
	 * a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Automaton Parent</em>' container reference.
	 * @see #setAutomatonParent(Automaton)
	 * @see fr.irisa.espresso.sme.SmePackage#getTransition_AutomatonParent()
	 * @see fr.irisa.espresso.sme.Automaton#getTransitions
	 * @model opposite="transitions" required="true" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_3h6dhBXJEdyEE5SD-YnmUA'"
	 * @generated
	 */
	Automaton getAutomatonParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.Transition#getAutomatonParent <em>Automaton Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Automaton Parent</em>' container reference.
	 * @see #getAutomatonParent()
	 * @generated
	 */
	void setAutomatonParent(Automaton value);
	
} // Transition
