/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Tuple Type</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.TupleType#getKind <em>Kind</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.TupleType#getLocals <em>Locals</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.TupleType#getSpec <em>Spec</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getTupleType()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfHO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface TupleType extends TypeDeclaration, SignalContainer, SignalType {
	/**
	 * Returns the value of the '<em><b>Kind</b></em>' attribute. The default value is <code>"struct"</code>. The
	 * literals are from the enumeration {@link fr.irisa.espresso.sme.TypeKind}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Kind</em>' attribute isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Kind</em>' attribute.
	 * @see fr.irisa.espresso.sme.TypeKind
	 * @see #setKind(TypeKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getTupleType_Kind()
	 * @model default="struct" unique="false" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfHe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	TypeKind getKind();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.TupleType#getKind <em>Kind</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Kind</em>' attribute.
	 * @see fr.irisa.espresso.sme.TypeKind
	 * @see #getKind()
	 * @generated
	 */
	void setKind(TypeKind value);
	
	/**
	 * Returns the value of the '<em><b>Locals</b></em>' containment reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.Local}. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.Local#getTypeParent <em>Type Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Locals</em>' containment reference list isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Locals</em>' containment reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getTupleType_Locals()
	 * @see fr.irisa.espresso.sme.Local#getTypeParent
	 * @model opposite="typeParent" containment="true" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfH-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<Local> getLocals();
	
	/**
	 * Returns the value of the '<em><b>Spec</b></em>' containment reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.Specifications#getTypeParent <em>Type Parent</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Spec</em>' containment reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Spec</em>' containment reference.
	 * @see #setSpec(Specifications)
	 * @see fr.irisa.espresso.sme.SmePackage#getTupleType_Spec()
	 * @see fr.irisa.espresso.sme.Specifications#getTypeParent
	 * @model opposite="typeParent" containment="true" ordered="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfIO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Specifications getSpec();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.TupleType#getSpec <em>Spec</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Spec</em>' containment reference.
	 * @see #getSpec()
	 * @generated
	 */
	void setSpec(Specifications value);
	
} // TupleType
