/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Type Declaration</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.TypeDeclaration#getModuleParent <em>Module Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.TypeDeclaration#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.TypeDeclaration#getVisibility <em>Visibility</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getTypeDeclaration()
 * @model abstract="true" annotation="http://www.topcased.org/uuid uuid='_2LOfDe5WEduz9o2pAin6-g'"
 * @generated
 */
public interface TypeDeclaration extends Identifier {
	/**
	 * Returns the value of the '<em><b>Module Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.Module#getTypes <em>Types</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Module Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Module Parent</em>' container reference.
	 * @see #setModuleParent(Module)
	 * @see fr.irisa.espresso.sme.SmePackage#getTypeDeclaration_ModuleParent()
	 * @see fr.irisa.espresso.sme.Module#getTypes
	 * @model opposite="types" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfDu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Module getModuleParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.TypeDeclaration#getModuleParent <em>Module Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Module Parent</em>' container reference.
	 * @see #getModuleParent()
	 * @generated
	 */
	void setModuleParent(Module value);
	
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getTypes <em>Types</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getTypeDeclaration_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getTypes
	 * @model opposite="types" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfD-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.TypeDeclaration#getModelParent <em>Model Parent</em>}'
	 * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * Returns the value of the '<em><b>Visibility</b></em>' attribute. The literals are from the enumeration
	 * {@link fr.irisa.espresso.sme.VisibilityKind}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Visibility</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Visibility</em>' attribute.
	 * @see fr.irisa.espresso.sme.VisibilityKind
	 * @see #setVisibility(VisibilityKind)
	 * @see fr.irisa.espresso.sme.SmePackage#getTypeDeclaration_Visibility()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOfEO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	VisibilityKind getVisibility();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.TypeDeclaration#getVisibility <em>Visibility</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Visibility</em>' attribute.
	 * @see fr.irisa.espresso.sme.VisibilityKind
	 * @see #getVisibility()
	 * @generated
	 */
	void setVisibility(VisibilityKind value);
	
} // TypeDeclaration
