/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Use Module</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.UseModule#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.UseModule#getModuleParent <em>Module Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.UseModule#getModules <em>Modules</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getUseModule()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfQO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface UseModule extends SignalElement {
	/**
	 * Returns the value of the '<em><b>Model Parent</b></em>' container reference. It is bidirectional and its opposite
	 * is '{@link fr.irisa.espresso.sme.Model#getUseModule <em>Use Module</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Model Parent</em>' container reference.
	 * @see #setModelParent(Model)
	 * @see fr.irisa.espresso.sme.SmePackage#getUseModule_ModelParent()
	 * @see fr.irisa.espresso.sme.Model#getUseModule
	 * @model opposite="useModule" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfQe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Model getModelParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.UseModule#getModelParent <em>Model Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Model Parent</em>' container reference.
	 * @see #getModelParent()
	 * @generated
	 */
	void setModelParent(Model value);
	
	/**
	 * Returns the value of the '<em><b>Module Parent</b></em>' container reference. It is bidirectional and its
	 * opposite is '{@link fr.irisa.espresso.sme.Module#getUseModule <em>Use Module</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Module Parent</em>' container reference isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Module Parent</em>' container reference.
	 * @see #setModuleParent(Module)
	 * @see fr.irisa.espresso.sme.SmePackage#getUseModule_ModuleParent()
	 * @see fr.irisa.espresso.sme.Module#getUseModule
	 * @model opposite="useModule" transient="false"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOfQu5WEduz9o2pAin6-g'"
	 * @generated
	 */
	Module getModuleParent();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.UseModule#getModuleParent <em>Module Parent</em>}' container
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Module Parent</em>' container reference.
	 * @see #getModuleParent()
	 * @generated
	 */
	void setModuleParent(Module value);
	
	/**
	 * Returns the value of the '<em><b>Modules</b></em>' reference list. The list contents are of type
	 * {@link fr.irisa.espresso.sme.Module}. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Modules</em>' reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Modules</em>' reference list.
	 * @see fr.irisa.espresso.sme.SmePackage#getUseModule_Modules()
	 * @model required="true" annotation="http://www.topcased.org/uuid uuid='_2LOfQ-5WEduz9o2pAin6-g'"
	 * @generated
	 */
	EList<Module> getModules();
	
} // UseModule
