/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Weak Transition</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.WeakTransition#getSrc <em>Src</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.WeakTransition#getDst <em>Dst</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.irisa.espresso.sme.SmePackage#getWeakTransition()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOgEu5WEduz9o2pAin6-g'"
 * @generated
 */
public interface WeakTransition extends Transition {
	/**
	 * Returns the value of the '<em><b>Src</b></em>' reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.StateBase#getSrc_WeakTransitions <em>Src Weak Transitions</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Src</em>' reference isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Src</em>' reference.
	 * @see #setSrc(StateBase)
	 * @see fr.irisa.espresso.sme.SmePackage#getWeakTransition_Src()
	 * @see fr.irisa.espresso.sme.StateBase#getSrc_WeakTransitions
	 * @model opposite="src_WeakTransitions" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOgFO5WEduz9o2pAin6-g'"
	 * @generated
	 */
	StateBase getSrc();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.WeakTransition#getSrc <em>Src</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Src</em>' reference.
	 * @see #getSrc()
	 * @generated
	 */
	void setSrc(StateBase value);
	
	/**
	 * Returns the value of the '<em><b>Dst</b></em>' reference. It is bidirectional and its opposite is '
	 * {@link fr.irisa.espresso.sme.StateOrHistory#getDst_WeakTransitions <em>Dst Weak Transitions</em>}'. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dst</em>' reference isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dst</em>' reference.
	 * @see #setDst(StateOrHistory)
	 * @see fr.irisa.espresso.sme.SmePackage#getWeakTransition_Dst()
	 * @see fr.irisa.espresso.sme.StateOrHistory#getDst_WeakTransitions
	 * @model opposite="dst_WeakTransitions" required="true"
	 *        annotation="http://www.topcased.org/uuid uuid='_2LOgFe5WEduz9o2pAin6-g'"
	 * @generated
	 */
	StateOrHistory getDst();
	
	/**
	 * Sets the value of the '{@link fr.irisa.espresso.sme.WeakTransition#getDst <em>Dst</em>}' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *        the new value of the '<em>Dst</em>' reference.
	 * @see #getDst()
	 * @generated
	 */
	void setDst(StateOrHistory value);
	
} // WeakTransition
