/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.irisa.espresso.sme.BasicIterate;
import fr.irisa.espresso.sme.ClockRelation;
import fr.irisa.espresso.sme.ConstantOrRef;
import fr.irisa.espresso.sme.Dependence;
import fr.irisa.espresso.sme.IterationInit;
import fr.irisa.espresso.sme.Iterator;
import fr.irisa.espresso.sme.SmeFactory;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.Phyla;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Basic Iterate</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.BasicIterateImpl#getIterationInit <em>Iteration Init</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.BasicIterateImpl#getIterator <em>Iterator</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.BasicIterateImpl#getUpperBound <em>Upper Bound</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.BasicIterateImpl#getIteratorName <em>Iterator Name</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class BasicIterateImpl extends SubProcessImpl implements BasicIterate {
	/**
	 * The cached value of the '{@link #getIterationInit() <em>Iteration Init</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getIterationInit()
	 * @generated
	 * @ordered
	 */
	protected IterationInit			iterationInit;
	
	/**
	 * The cached value of the '{@link #getIterator() <em>Iterator</em>}' containment reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getIterator()
	 * @generated
	 * @ordered
	 */
	protected Iterator				iterator;
	
	/**
	 * The default value of the '{@link #getUpperBound() <em>Upper Bound</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getUpperBound()
	 * @generated
	 * @ordered
	 */
	protected static final String	UPPER_BOUND_EDEFAULT	= null;
	
	/**
	 * The cached value of the '{@link #getUpperBound() <em>Upper Bound</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getUpperBound()
	 * @generated
	 * @ordered
	 */
	protected String				upperBound				= UPPER_BOUND_EDEFAULT;
	
	/**
	 * The default value of the '{@link #getIteratorName() <em>Iterator Name</em>}' attribute. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getIteratorName()
	 * @generated
	 * @ordered
	 */
	protected static final String	ITERATOR_NAME_EDEFAULT	= "";
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected BasicIterateImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.BASIC_ITERATE;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public IterationInit getIterationInit() {
		if (iterationInit == null) {
			iterationInit = SmeFactory.eINSTANCE.createIterationInit();
			iterationInit.setArrayParent(this);
		}
		return iterationInit;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetIterationInit(IterationInit newIterationInit, NotificationChain msgs) {
		IterationInit oldIterationInit = iterationInit;
		iterationInit = newIterationInit;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
				SmePackage.BASIC_ITERATE__ITERATION_INIT, oldIterationInit, newIterationInit);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIterationInit(IterationInit newIterationInit) {
		if (newIterationInit != iterationInit) {
			NotificationChain msgs = null;
			if (iterationInit != null)
				msgs = ((InternalEObject) iterationInit).eInverseRemove(this, SmePackage.ITERATION_INIT__ARRAY_PARENT,
					IterationInit.class, msgs);
			if (newIterationInit != null)
				msgs = ((InternalEObject) newIterationInit).eInverseAdd(this, SmePackage.ITERATION_INIT__ARRAY_PARENT,
					IterationInit.class, msgs);
			msgs = basicSetIterationInit(newIterationInit, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.BASIC_ITERATE__ITERATION_INIT,
				newIterationInit, newIterationInit));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Iterator getIterator() {
		// If no iterator exists, we create one automatically
		if (iterator == null) {
			iterator = SmeFactory.eINSTANCE.createIterator();
			iterator.setArrayParent(this);
		}
		return iterator;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetIterator(Iterator newIterator, NotificationChain msgs) {
		Iterator oldIterator = iterator;
		iterator = newIterator;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
				SmePackage.BASIC_ITERATE__ITERATOR, oldIterator, newIterator);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIterator(Iterator newIterator) {
		if (newIterator != iterator) {
			NotificationChain msgs = null;
			if (iterator != null)
				msgs = ((InternalEObject) iterator).eInverseRemove(this, SmePackage.ITERATOR__ARRAY_PARENT,
					Iterator.class, msgs);
			if (newIterator != null)
				msgs = ((InternalEObject) newIterator).eInverseAdd(this, SmePackage.ITERATOR__ARRAY_PARENT,
					Iterator.class, msgs);
			msgs = basicSetIterator(newIterator, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.BASIC_ITERATE__ITERATOR, newIterator,
				newIterator));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getUpperBound() {
		return upperBound;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setUpperBound(String newUpperBound) {
		String oldUpperBound = upperBound;
		upperBound = newUpperBound;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.BASIC_ITERATE__UPPER_BOUND, oldUpperBound,
				upperBound));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public String getIteratorName() {
		return getIterator().getName();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void setIteratorName(String newIteratorName) {
		getIterator().setName(newIteratorName);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.BASIC_ITERATE__ITERATION_INIT:
				if (iterationInit != null)
					msgs = ((InternalEObject) iterationInit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE
							- SmePackage.BASIC_ITERATE__ITERATION_INIT, null, msgs);
				return basicSetIterationInit((IterationInit) otherEnd, msgs);
			case SmePackage.BASIC_ITERATE__ITERATOR:
				if (iterator != null)
					msgs = ((InternalEObject) iterator).eInverseRemove(this, EOPPOSITE_FEATURE_BASE
							- SmePackage.BASIC_ITERATE__ITERATOR, null, msgs);
				return basicSetIterator((Iterator) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.BASIC_ITERATE__ITERATION_INIT:
				return basicSetIterationInit(null, msgs);
			case SmePackage.BASIC_ITERATE__ITERATOR:
				return basicSetIterator(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.BASIC_ITERATE__ITERATION_INIT:
				return getIterationInit();
			case SmePackage.BASIC_ITERATE__ITERATOR:
				return getIterator();
			case SmePackage.BASIC_ITERATE__UPPER_BOUND:
				return getUpperBound();
			case SmePackage.BASIC_ITERATE__ITERATOR_NAME:
				return getIteratorName();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.BASIC_ITERATE__ITERATION_INIT:
				setIterationInit((IterationInit) newValue);
				return;
			case SmePackage.BASIC_ITERATE__ITERATOR:
				setIterator((Iterator) newValue);
				return;
			case SmePackage.BASIC_ITERATE__UPPER_BOUND:
				setUpperBound((String) newValue);
				return;
			case SmePackage.BASIC_ITERATE__ITERATOR_NAME:
				setIteratorName((String) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.BASIC_ITERATE__ITERATION_INIT:
				setIterationInit((IterationInit) null);
				return;
			case SmePackage.BASIC_ITERATE__ITERATOR:
				setIterator((Iterator) null);
				return;
			case SmePackage.BASIC_ITERATE__UPPER_BOUND:
				setUpperBound(UPPER_BOUND_EDEFAULT);
				return;
			case SmePackage.BASIC_ITERATE__ITERATOR_NAME:
				setIteratorName(ITERATOR_NAME_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.BASIC_ITERATE__ITERATION_INIT:
				return iterationInit != null;
			case SmePackage.BASIC_ITERATE__ITERATOR:
				return iterator != null;
			case SmePackage.BASIC_ITERATE__UPPER_BOUND:
				return UPPER_BOUND_EDEFAULT == null ? upperBound != null : !UPPER_BOUND_EDEFAULT.equals(upperBound);
			case SmePackage.BASIC_ITERATE__ITERATOR_NAME:
				return ITERATOR_NAME_EDEFAULT == null ? getIteratorName() != null : !ITERATOR_NAME_EDEFAULT
						.equals(getIteratorName());
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (upperBound: ");
		result.append(upperBound);
		result.append(')');
		return result.toString();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.Identifier#toString(boolean, boolean)
	 * @generated NOT
	 */
	public String toString(boolean asCode, boolean withComment) {
		if (asCode) {
			StringBuffer result = new StringBuffer();
			if (withComment && comment != null && ("".equals(comment) == false))
				result.append(comment + "\n\n");
			result.append(name);
			result.append("::array " + getIteratorName() + " to (" + upperBound + ")\n");
			result.append("\t\t(| ... |)\n");
			result.append("\t\t with (| ... |)\n");
			return result.toString();
		}
		else
			return toString();
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.irisa.espresso.sme.impl.SubProcessImpl#getVisibleConstants()
	 * 
	 * @generated NOT
	 */
	@Override
	public EList<ConstantOrRef> getVisibleConstants() {
		EList<ConstantOrRef> list = super.getVisibleConstants();
		list.add(getIterator());
		return list;
	}
	
	/**
	 * @see org.topcased.sme.SignalElement#buildEquationsAST(int)
	 * @generated NOT
	 */
	public long buildEquationsAST(long bodyTree) {
		if (this.getDst_CaseConnection() == null && bodyTree != PKTrees.ERROR_NODE) {
			// It is used as a labeled part in the specification of the process
			bodyTree = PkPlugin.getTreeAPI().post(bodyTree, getCommonPart());
			
			for (ClockRelation cr : getDst_ClockRelations())
				bodyTree = cr.buildEquationsAST(bodyTree);
			for (Dependence dep : getDst_Dependences())
				bodyTree = dep.buildEquationsAST(bodyTree);
			
		}
		else if (this.getDst_CaseConnection() != null && bodyTree == PKTrees.ERROR_NODE) {
			// The Basic Iterate Block is used as a case in a switch case constructs
			bodyTree = PkPlugin.getTreeAPI().makeList(SignalOperators.oplfeed, getCommonPart());
			
			for (ClockRelation cr : getDst_ClockRelations())
				bodyTree = cr.buildEquationsAST(bodyTree);
			for (Dependence dep : getDst_Dependences())
				bodyTree = dep.buildEquationsAST(bodyTree);
		}
		return bodyTree;
	}
	
	private long getCommonPart() {
		PKTrees API = PkPlugin.getTreeAPI();
		
		// We build the structure of a Model (cut and paste of the Model method, because cannot use those of SubProcess)
		long result = makeEquations(API.makeEmptyList(SignalOperators.oplfeed));
		if (API.isEmpty(result))
			result = API.makeNullary(SignalOperators.opnullproc);
		
		long declTree = makeDeclarations(API.makeEmptyList(SignalOperators.opldecl));
		if (!API.isEmpty(declTree)) // If there are declarations, we create a confined processus
			result = API.makeBinary(SignalOperators.oppconf, result, declTree);
		
		long initNode = getIterationInit().buildEquationsAST(PKTrees.ERROR_NODE);
		
		if (upperBound != null && "".equals(upperBound) == false) {
			long upperNode = PkPlugin.getParser().parseString(Phyla.ph_e_sign, upperBound);
			if (upperNode != PKTrees.ERROR_NODE) {
				long idNode;
				try {
					idNode = getIterator().getAST(null);
				}
				catch (CyclicDefinitionException cde) {
					idNode = PKTrees.ERROR_NODE;
				}
				
				if (idNode != PKTrees.ERROR_NODE) {
					long indiceNode = API.makeBinary(SignalOperators.opindmot, idNode, upperNode);
					result = API.makeTernary(SignalOperators.opmoti, indiceNode, result, initNode);
				}
				else {
					PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.BASIC_ITERATE_INCORRECT_ITERATOR_NAME
							+ name, this);
				}
			}
			else {
				PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.BASIC_ITERATE_UPPER_BOUND_ANALYSIS + name,
					this);
			}
		}
		else {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.BASIC_ITERATE_UPPER_BOUND_NO_NAME + name, this);
		}
		
		// we add the label to it.
		long idNode = getAST(null);
		if (idNode != PKTrees.ERROR_NODE)
			result = API.makeBinary(SignalOperators.oppetiq, idNode, result);
		
		return result;
	}
	
} // BasicIterateImpl
