/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.irisa.espresso.sme.CartesianProduct;
import fr.irisa.espresso.sme.DataflowOperator;
import fr.irisa.espresso.sme.InputPort;
import fr.irisa.espresso.sme.Model;
import fr.irisa.espresso.sme.OutputPort;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalElement;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Cartesian Product</b></em>'. <!-- end-user-doc
 * -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.CartesianProductImpl#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.CartesianProductImpl#getOuts <em>Outs</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CartesianProductImpl extends MultipleInputsOperatorImpl implements CartesianProduct {
	/**
	 * The cached value of the '{@link #getOuts() <em>Outs</em>}' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getOuts()
	 * @generated
	 * @ordered
	 */
	protected EList<OutputPort>	outs;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CartesianProductImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.CARTESIAN_PRODUCT;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Model getModelParent() {
		if (eContainerFeatureID != SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT)
			return null;
		return (Model) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetModelParent(Model newModelParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newModelParent, SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setModelParent(Model newModelParent) {
		if (newModelParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT && newModelParent != null)) {
			if (EcoreUtil.isAncestor(this, newModelParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newModelParent != null)
				msgs = ((InternalEObject) newModelParent).eInverseAdd(this, SmePackage.MODEL__OPERATORS, Model.class,
					msgs);
			msgs = basicSetModelParent(newModelParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT,
				newModelParent, newModelParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<OutputPort> getOuts() {
		if (outs == null) {
			outs = new EObjectContainmentEList<OutputPort>(OutputPort.class, this, SmePackage.CARTESIAN_PRODUCT__OUTS);
		}
		return outs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public SignalContainer getParent() {
		return getModelParent();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<OutputPort> getOutputPorts() {
		return ECollections.unmodifiableEList(getOuts());
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetModelParent((Model) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT:
				return basicSetModelParent(null, msgs);
			case SmePackage.CARTESIAN_PRODUCT__OUTS:
				return ((InternalEList<?>) getOuts()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.MODEL__OPERATORS, Model.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT:
				return getModelParent();
			case SmePackage.CARTESIAN_PRODUCT__OUTS:
				return getOuts();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT:
				setModelParent((Model) newValue);
				return;
			case SmePackage.CARTESIAN_PRODUCT__OUTS:
				getOuts().clear();
				getOuts().addAll((Collection<? extends OutputPort>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT:
				setModelParent((Model) null);
				return;
			case SmePackage.CARTESIAN_PRODUCT__OUTS:
				getOuts().clear();
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT:
				return getModelParent() != null;
			case SmePackage.CARTESIAN_PRODUCT__OUTS:
				return outs != null && !outs.isEmpty();
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == DataflowOperator.class) {
			switch (derivedFeatureID) {
				case SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT:
					return SmePackage.DATAFLOW_OPERATOR__MODEL_PARENT;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == DataflowOperator.class) {
			switch (baseFeatureID) {
				case SmePackage.DATAFLOW_OPERATOR__MODEL_PARENT:
					return SmePackage.CARTESIAN_PRODUCT__MODEL_PARENT;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.MultipleInputsOperatorImpl#buildEquationsAST(int)
	 * @generated NOT
	 */
	@Override
	public long buildEquationsAST(long bodyTree) {
		int size = getIns().size();
		if (size != getOuts().size() && size < 2) {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.CARTESIAN_PRODUCT_NUMBER_OF_PORTS + name, this);
			return bodyTree;
		}
		
		PKTrees API = PkPlugin.getTreeAPI();
		
		long result = API.makeEmptyList(SignalOperators.oplesign);
		Set<SignalElement> path = new HashSet<SignalElement>();
		boolean allOK = true;
		
		for (InputPort ip : ins) {
			try {
				long node = ip.getAST(path);
				if (node == PKTrees.ERROR_NODE)
					allOK = false;
				else
					result = API.post(result, node);
			}
			catch (CyclicDefinitionException cde) {
				PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.CYCLE_DETECTION + cde.getElement(), cde
						.getElement());
				allOK = false;
			}
		}
		
		result = API.makeUnary(SignalOperators.oppcar, result);
		
		long outList = API.makeEmptyList(SignalOperators.opleflot);
		boolean outEmpty = true;
		for (OutputPort op : getOuts()) {
			try {
				// Put null for the Set of SignalElement because we only get its name
				long node = op.getAST(null);
				
				if (node == PKTrees.ERROR_NODE)
					allOK = false;
				else {
					outList = API.post(outList, node);
					outEmpty = false;
				}
			}
			catch (CyclicDefinitionException cde) {
				PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.CYCLE_DETECTION + cde.getElement(), cde
						.getElement());
				allOK = false;
			}
		}
		if (!outEmpty)
			result = API.makeBinary(SignalOperators.opdefsig, outList, result);
		
		if (allOK)
			bodyTree = API.post(bodyTree, result);
		
		return bodyTree;
	}
	
	/**
	 * This method is not supported: returns an UnsupportedOperationException
	 * 
	 * @see fr.irisa.espresso.sme.impl.MultipleInputsOperatorImpl#getAST(java.util.Set)
	 * @generated NOT
	 */
	public long getAST(Set<SignalElement> path) {
		throw new UnsupportedOperationException();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.MultipleInputsOperatorImpl#getDeclarationAST(int)
	 * @generated NOT
	 */
	@Override
	public long getDeclarationAST(long declTree) {
		for (OutputPort op : getOuts())
			declTree = op.getDeclarationAST(declTree);
		return declTree;
	}
	
} // CartesianProductImpl
