/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.irisa.espresso.sme.ClockRelation;
import fr.irisa.espresso.sme.ClockedExpr;
import fr.irisa.espresso.sme.ConnectableElement;
import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.InputPort;
import fr.irisa.espresso.sme.SignalElement;
import fr.irisa.espresso.sme.SignalOrRef;
import fr.irisa.espresso.sme.SignalRef;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.Phyla;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.traceability.WarningMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;
import fr.irisa.espresso.sme.util.Utils;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Clock Relation</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.ClockRelationImpl#getSrc <em>Src</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ClockRelationImpl#getDst <em>Dst</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ClockRelationImpl#getSrcField <em>Src Field</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ClockRelationImpl#getDstField <em>Dst Field</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ClockRelationImpl extends ModelConnectionImpl implements ClockRelation {
	/**
	 * The cached value of the '{@link #getSrc() <em>Src</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSrc()
	 * @generated
	 * @ordered
	 */
	protected ClockedExpr			src;
	
	/**
	 * The cached value of the '{@link #getDst() <em>Dst</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDst()
	 * @generated
	 * @ordered
	 */
	protected ClockedExpr			dst;
	
	/**
	 * The default value of the '{@link #getSrcField() <em>Src Field</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getSrcField()
	 * @generated
	 * @ordered
	 */
	protected static final String	SRC_FIELD_EDEFAULT	= "";
	
	/**
	 * The cached value of the '{@link #getSrcField() <em>Src Field</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getSrcField()
	 * @generated
	 * @ordered
	 */
	protected String				srcField			= SRC_FIELD_EDEFAULT;
	
	/**
	 * The default value of the '{@link #getDstField() <em>Dst Field</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getDstField()
	 * @generated
	 * @ordered
	 */
	protected static final String	DST_FIELD_EDEFAULT	= "";
	
	/**
	 * The cached value of the '{@link #getDstField() <em>Dst Field</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getDstField()
	 * @generated
	 * @ordered
	 */
	protected String				dstField			= DST_FIELD_EDEFAULT;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ClockRelationImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.CLOCK_RELATION;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ClockedExpr getSrc() {
		if (src != null && src.eIsProxy()) {
			InternalEObject oldSrc = (InternalEObject) src;
			src = (ClockedExpr) eResolveProxy(oldSrc);
			if (src != oldSrc) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SmePackage.CLOCK_RELATION__SRC, oldSrc,
						src));
			}
		}
		return src;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ClockedExpr basicGetSrc() {
		return src;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetSrc(ClockedExpr newSrc, NotificationChain msgs) {
		ClockedExpr oldSrc = src;
		src = newSrc;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
				SmePackage.CLOCK_RELATION__SRC, oldSrc, newSrc);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSrc(ClockedExpr newSrc) {
		if (newSrc != src) {
			NotificationChain msgs = null;
			if (src != null)
				msgs = ((InternalEObject) src).eInverseRemove(this, SmePackage.CLOCKED_EXPR__SRC_CLOCK_RELATIONS,
					ClockedExpr.class, msgs);
			if (newSrc != null)
				msgs = ((InternalEObject) newSrc).eInverseAdd(this, SmePackage.CLOCKED_EXPR__SRC_CLOCK_RELATIONS,
					ClockedExpr.class, msgs);
			msgs = basicSetSrc(newSrc, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.CLOCK_RELATION__SRC, newSrc, newSrc));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ClockedExpr getDst() {
		if (dst != null && dst.eIsProxy()) {
			InternalEObject oldDst = (InternalEObject) dst;
			dst = (ClockedExpr) eResolveProxy(oldDst);
			if (dst != oldDst) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SmePackage.CLOCK_RELATION__DST, oldDst,
						dst));
			}
		}
		return dst;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ClockedExpr basicGetDst() {
		return dst;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetDst(ClockedExpr newDst, NotificationChain msgs) {
		ClockedExpr oldDst = dst;
		dst = newDst;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
				SmePackage.CLOCK_RELATION__DST, oldDst, newDst);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDst(ClockedExpr newDst) {
		if (newDst != dst) {
			NotificationChain msgs = null;
			if (dst != null)
				msgs = ((InternalEObject) dst).eInverseRemove(this, SmePackage.CLOCKED_EXPR__DST_CLOCK_RELATIONS,
					ClockedExpr.class, msgs);
			if (newDst != null)
				msgs = ((InternalEObject) newDst).eInverseAdd(this, SmePackage.CLOCKED_EXPR__DST_CLOCK_RELATIONS,
					ClockedExpr.class, msgs);
			msgs = basicSetDst(newDst, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.CLOCK_RELATION__DST, newDst, newDst));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getSrcField() {
		return srcField;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSrcField(String newSrcField) {
		String oldSrcField = srcField;
		srcField = newSrcField;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.CLOCK_RELATION__SRC_FIELD, oldSrcField,
				srcField));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getDstField() {
		return dstField;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDstField(String newDstField) {
		String oldDstField = dstField;
		dstField = newDstField;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.CLOCK_RELATION__DST_FIELD, oldDstField,
				dstField));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.CLOCK_RELATION__SRC:
				if (src != null)
					msgs = ((InternalEObject) src).eInverseRemove(this, SmePackage.CLOCKED_EXPR__SRC_CLOCK_RELATIONS,
						ClockedExpr.class, msgs);
				return basicSetSrc((ClockedExpr) otherEnd, msgs);
			case SmePackage.CLOCK_RELATION__DST:
				if (dst != null)
					msgs = ((InternalEObject) dst).eInverseRemove(this, SmePackage.CLOCKED_EXPR__DST_CLOCK_RELATIONS,
						ClockedExpr.class, msgs);
				return basicSetDst((ClockedExpr) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.CLOCK_RELATION__SRC:
				return basicSetSrc(null, msgs);
			case SmePackage.CLOCK_RELATION__DST:
				return basicSetDst(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.CLOCK_RELATION__SRC:
				if (resolve)
					return getSrc();
				return basicGetSrc();
			case SmePackage.CLOCK_RELATION__DST:
				if (resolve)
					return getDst();
				return basicGetDst();
			case SmePackage.CLOCK_RELATION__SRC_FIELD:
				return getSrcField();
			case SmePackage.CLOCK_RELATION__DST_FIELD:
				return getDstField();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.CLOCK_RELATION__SRC:
				setSrc((ClockedExpr) newValue);
				return;
			case SmePackage.CLOCK_RELATION__DST:
				setDst((ClockedExpr) newValue);
				return;
			case SmePackage.CLOCK_RELATION__SRC_FIELD:
				setSrcField((String) newValue);
				return;
			case SmePackage.CLOCK_RELATION__DST_FIELD:
				setDstField((String) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.CLOCK_RELATION__SRC:
				setSrc((ClockedExpr) null);
				return;
			case SmePackage.CLOCK_RELATION__DST:
				setDst((ClockedExpr) null);
				return;
			case SmePackage.CLOCK_RELATION__SRC_FIELD:
				setSrcField(SRC_FIELD_EDEFAULT);
				return;
			case SmePackage.CLOCK_RELATION__DST_FIELD:
				setDstField(DST_FIELD_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.CLOCK_RELATION__SRC:
				return src != null;
			case SmePackage.CLOCK_RELATION__DST:
				return dst != null;
			case SmePackage.CLOCK_RELATION__SRC_FIELD:
				return SRC_FIELD_EDEFAULT == null ? srcField != null : !SRC_FIELD_EDEFAULT.equals(srcField);
			case SmePackage.CLOCK_RELATION__DST_FIELD:
				return DST_FIELD_EDEFAULT == null ? dstField != null : !DST_FIELD_EDEFAULT.equals(dstField);
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (srcField: ");
		result.append(srcField);
		result.append(", dstField: ");
		result.append(dstField);
		result.append(')');
		return result.toString();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ConnectionImpl#getDestination()
	 * @generated NOT
	 */
	public ConnectableElement getDestination() {
		return getDst();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ConnectionImpl#getSource()
	 * @generated NOT
	 */
	public ConnectableElement getSource() {
		return getSrc();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ConnectionImpl#buildEquationsAST(int)
	 * @generated NOT
	 */
	@Override
	public long buildEquationsAST(long bodyTree) {
		long dstNode;
		Set<SignalElement> path = new HashSet<SignalElement>();
		ClockedExpr dst = getDst();
		
		// If the destination is an InputPort, the getAst method must be called.
		if (dst instanceof InputPort)
			return bodyTree;
		
		try {
			// If the destination corresponds to a Signal or a SignalRef, we have to check the srcField and dstField
			if (dst instanceof SignalOrRef && dstField != null && "".equals(dstField) == false) {
				String tmp;
				// Check on Identifier and not on Signal because it can be an InputInstance or OutputInstance
				if (dst instanceof Identifier)
					tmp = ((Identifier) dst).getName();
				else
					tmp = ((SignalRef) dst).getSigName();
				
				if (tmp == null || "".equals(tmp))
					return PKTrees.ERROR_NODE;
				
				tmp = Utils.getSignalString(tmp, dstField);
				
				dstNode = PkPlugin.getParser().parseString(Phyla.ph_e_sign, tmp);
				if (dstNode == PKTrees.ERROR_NODE) {
					PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.DESTINATION_FIELD, this);
					return bodyTree;
				}
			}
			else {
				// DstField is useless
				if (dstField != null && "".equals(dstField) == false)
					PolychronyDiagnostic.add(Diagnostic.WARNING, WarningMessages.DESTINATION_FIELD, this);
				dstNode = dst.getAST(path);
				if (dstNode == PKTrees.ERROR_NODE)
					return bodyTree;
			}
			long srcNode = getAST(path);
			if (srcNode != PKTrees.ERROR_NODE) {
				long result = PkPlugin.getTreeAPI().makeList(SignalOperators.oplequhor, srcNode);
				result = PkPlugin.getTreeAPI().pre(result, dstNode);
				bodyTree = PkPlugin.getTreeAPI().post(bodyTree, result);
			}
		}
		catch (CyclicDefinitionException cde) {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.CYCLE_DETECTION + cde.getElement(), cde
					.getElement());
		}
		
		return bodyTree;
	}
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#getAST(java.util.Set)
	 * @generated NOT
	 */
	public long getAST(Set<SignalElement> path) throws CyclicDefinitionException {
		long srcNode;
		
		// Add source field information for tuple type identifiers
		if (src instanceof SignalOrRef && srcField != null && "".equals(srcField) == false) {
			String tmp;
			// Check on Identifier and not on Signal because it can be an InputInstance or OutputInstance
			if (src instanceof Identifier)
				tmp = ((Identifier) src).getName();
			else
				tmp = ((SignalRef) src).getSigName();
			
			if (tmp == null || "".equals(tmp)) {
				return PKTrees.ERROR_NODE;
			}
			
			tmp = Utils.getSignalString(tmp, srcField);
			
			srcNode = PkPlugin.getParser().parseString(Phyla.ph_e_sign, tmp);
			if (srcNode == PKTrees.ERROR_NODE)
				PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.SOURCE_FIELD, this);
		}
		else {
			// SrcField is useless
			if (srcField != null && "".equals(srcField) == false)
				PolychronyDiagnostic.add(Diagnostic.WARNING, WarningMessages.SOURCE_FIELD, this);
			srcNode = src.getAST(path);
		}
		return srcNode;
	}
	
} // ClockRelationImpl
