/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.Set;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.irisa.espresso.sme.ConnectableElement;
import fr.irisa.espresso.sme.Constant;
import fr.irisa.espresso.sme.ConstantAffectation;
import fr.irisa.espresso.sme.ConstantExpr;
import fr.irisa.espresso.sme.ConstantOrRef;
import fr.irisa.espresso.sme.ConstantRef;
import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.SignalElement;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.Phyla;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.traceability.WarningMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;
import fr.irisa.espresso.sme.util.Utils;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Constant Affectation</b></em>'. <!--
 * end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.ConstantAffectationImpl#getSrc <em>Src</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ConstantAffectationImpl#getDst <em>Dst</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ConstantAffectationImpl#getSrcField <em>Src Field</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ConstantAffectationImpl extends ModelConnectionImpl implements ConstantAffectation {
	/**
	 * The cached value of the '{@link #getSrc() <em>Src</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSrc()
	 * @generated
	 * @ordered
	 */
	protected ConstantExpr			src;
	
	/**
	 * The cached value of the '{@link #getDst() <em>Dst</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDst()
	 * @generated
	 * @ordered
	 */
	protected Constant				dst;
	
	/**
	 * The default value of the '{@link #getSrcField() <em>Src Field</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getSrcField()
	 * @generated
	 * @ordered
	 */
	protected static final String	SRC_FIELD_EDEFAULT	= "";
	
	/**
	 * The cached value of the '{@link #getSrcField() <em>Src Field</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getSrcField()
	 * @generated
	 * @ordered
	 */
	protected String				srcField			= SRC_FIELD_EDEFAULT;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ConstantAffectationImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.CONSTANT_AFFECTATION;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ConstantExpr getSrc() {
		if (src != null && src.eIsProxy()) {
			InternalEObject oldSrc = (InternalEObject) src;
			src = (ConstantExpr) eResolveProxy(oldSrc);
			if (src != oldSrc) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SmePackage.CONSTANT_AFFECTATION__SRC,
						oldSrc, src));
			}
		}
		return src;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ConstantExpr basicGetSrc() {
		return src;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetSrc(ConstantExpr newSrc, NotificationChain msgs) {
		ConstantExpr oldSrc = src;
		src = newSrc;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
				SmePackage.CONSTANT_AFFECTATION__SRC, oldSrc, newSrc);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSrc(ConstantExpr newSrc) {
		if (newSrc != src) {
			NotificationChain msgs = null;
			if (src != null)
				msgs = ((InternalEObject) src).eInverseRemove(this,
					SmePackage.CONSTANT_EXPR__SRC_CONSTANT_AFFECTATIONS, ConstantExpr.class, msgs);
			if (newSrc != null)
				msgs = ((InternalEObject) newSrc).eInverseAdd(this,
					SmePackage.CONSTANT_EXPR__SRC_CONSTANT_AFFECTATIONS, ConstantExpr.class, msgs);
			msgs = basicSetSrc(newSrc, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.CONSTANT_AFFECTATION__SRC, newSrc, newSrc));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Constant getDst() {
		if (dst != null && dst.eIsProxy()) {
			InternalEObject oldDst = (InternalEObject) dst;
			dst = (Constant) eResolveProxy(oldDst);
			if (dst != oldDst) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SmePackage.CONSTANT_AFFECTATION__DST,
						oldDst, dst));
			}
		}
		return dst;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Constant basicGetDst() {
		return dst;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetDst(Constant newDst, NotificationChain msgs) {
		Constant oldDst = dst;
		dst = newDst;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
				SmePackage.CONSTANT_AFFECTATION__DST, oldDst, newDst);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDst(Constant newDst) {
		if (newDst != dst) {
			NotificationChain msgs = null;
			if (dst != null)
				msgs = ((InternalEObject) dst).eInverseRemove(this, SmePackage.CONSTANT__DST_CONSTANT_AFFECTATION,
					Constant.class, msgs);
			if (newDst != null)
				msgs = ((InternalEObject) newDst).eInverseAdd(this, SmePackage.CONSTANT__DST_CONSTANT_AFFECTATION,
					Constant.class, msgs);
			msgs = basicSetDst(newDst, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.CONSTANT_AFFECTATION__DST, newDst, newDst));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getSrcField() {
		return srcField;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSrcField(String newSrcField) {
		String oldSrcField = srcField;
		srcField = newSrcField;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.CONSTANT_AFFECTATION__SRC_FIELD,
				oldSrcField, srcField));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.CONSTANT_AFFECTATION__SRC:
				if (src != null)
					msgs = ((InternalEObject) src).eInverseRemove(this,
						SmePackage.CONSTANT_EXPR__SRC_CONSTANT_AFFECTATIONS, ConstantExpr.class, msgs);
				return basicSetSrc((ConstantExpr) otherEnd, msgs);
			case SmePackage.CONSTANT_AFFECTATION__DST:
				if (dst != null)
					msgs = ((InternalEObject) dst).eInverseRemove(this, SmePackage.CONSTANT__DST_CONSTANT_AFFECTATION,
						Constant.class, msgs);
				return basicSetDst((Constant) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.CONSTANT_AFFECTATION__SRC:
				return basicSetSrc(null, msgs);
			case SmePackage.CONSTANT_AFFECTATION__DST:
				return basicSetDst(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.CONSTANT_AFFECTATION__SRC:
				if (resolve)
					return getSrc();
				return basicGetSrc();
			case SmePackage.CONSTANT_AFFECTATION__DST:
				if (resolve)
					return getDst();
				return basicGetDst();
			case SmePackage.CONSTANT_AFFECTATION__SRC_FIELD:
				return getSrcField();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.CONSTANT_AFFECTATION__SRC:
				setSrc((ConstantExpr) newValue);
				return;
			case SmePackage.CONSTANT_AFFECTATION__DST:
				setDst((Constant) newValue);
				return;
			case SmePackage.CONSTANT_AFFECTATION__SRC_FIELD:
				setSrcField((String) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.CONSTANT_AFFECTATION__SRC:
				setSrc((ConstantExpr) null);
				return;
			case SmePackage.CONSTANT_AFFECTATION__DST:
				setDst((Constant) null);
				return;
			case SmePackage.CONSTANT_AFFECTATION__SRC_FIELD:
				setSrcField(SRC_FIELD_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.CONSTANT_AFFECTATION__SRC:
				return src != null;
			case SmePackage.CONSTANT_AFFECTATION__DST:
				return dst != null;
			case SmePackage.CONSTANT_AFFECTATION__SRC_FIELD:
				return SRC_FIELD_EDEFAULT == null ? srcField != null : !SRC_FIELD_EDEFAULT.equals(srcField);
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (srcField: ");
		result.append(srcField);
		result.append(')');
		return result.toString();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ConnectionImpl#getDestination()
	 * @generated NOT
	 */
	public ConnectableElement getDestination() {
		return getDst();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ConnectionImpl#getSource()
	 * @generated NOT
	 */
	public ConnectableElement getSource() {
		return getSrc();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#getAST(java.util.Set)
	 * @generated NOT
	 */
	public long getAST(Set<SignalElement> path) throws CyclicDefinitionException {
		long srcNode;
		
		if (getSrc() instanceof ConstantOrRef && srcField != null && "".equals(srcField) == false) {
			String tmp;
			// Check on Identifier and not on Constant because it can be an ParameterInstance
			if (src instanceof Identifier)
				tmp = ((Identifier) src).getName();
			else
				tmp = ((ConstantRef) src).getCstName();
			
			if (tmp == null || "".equals(tmp)) {
				return PKTrees.ERROR_NODE;
			}
			
			tmp = Utils.getSignalString(tmp, srcField);
			
			srcNode = PkPlugin.getParser().parseString(Phyla.ph_e_sign, tmp);
			if (srcNode == PKTrees.ERROR_NODE)
				PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.SOURCE_FIELD, this);
		}
		else {
			if (srcField != null && "".equals(srcField) == false)
				PolychronyDiagnostic.add(Diagnostic.WARNING, WarningMessages.CONSTANT_AFFECTATION_SRC_FIELD, this);
			srcNode = src.getAST(path);
		}
		return srcNode;
	}
	
} // ConstantAffectationImpl
