/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.Collection;
import java.util.Set;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.irisa.espresso.sme.CompoundState;
import fr.irisa.espresso.sme.History;
import fr.irisa.espresso.sme.OperatorPort;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalElement;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.StrongTransition;
import fr.irisa.espresso.sme.WeakTransition;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.PkPlugin;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>History</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.HistoryImpl#getDst_StrongTransitions <em>Dst Strong Transitions</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.HistoryImpl#getDst_WeakTransitions <em>Dst Weak Transitions</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.HistoryImpl#getName <em>Name</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.HistoryImpl#getParentState <em>Parent State</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class HistoryImpl extends EObjectImpl implements History {
	/**
	 * The cached value of the '{@link #getDst_StrongTransitions() <em>Dst Strong Transitions</em>}' reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDst_StrongTransitions()
	 * @generated
	 * @ordered
	 */
	protected EList<StrongTransition>	dst_StrongTransitions;
	
	/**
	 * The cached value of the '{@link #getDst_WeakTransitions() <em>Dst Weak Transitions</em>}' reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDst_WeakTransitions()
	 * @generated
	 * @ordered
	 */
	protected EList<WeakTransition>		dst_WeakTransitions;
	
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String		NAME_EDEFAULT	= "";
	
	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String					name			= NAME_EDEFAULT;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected HistoryImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.HISTORY;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<StrongTransition> getDst_StrongTransitions() {
		if (dst_StrongTransitions == null) {
			dst_StrongTransitions = new EObjectWithInverseResolvingEList<StrongTransition>(StrongTransition.class,
				this, SmePackage.HISTORY__DST_STRONG_TRANSITIONS, SmePackage.STRONG_TRANSITION__DST);
		}
		return dst_StrongTransitions;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<WeakTransition> getDst_WeakTransitions() {
		if (dst_WeakTransitions == null) {
			dst_WeakTransitions = new EObjectWithInverseResolvingEList<WeakTransition>(WeakTransition.class, this,
				SmePackage.HISTORY__DST_WEAK_TRANSITIONS, SmePackage.WEAK_TRANSITION__DST);
		}
		return dst_WeakTransitions;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public String getName() {
		CompoundState state = this.getParentState();
		name = "of " + state.getName();
		return name;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void setName(String newName) {}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CompoundState getParentState() {
		if (eContainerFeatureID != SmePackage.HISTORY__PARENT_STATE)
			return null;
		return (CompoundState) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetParentState(CompoundState newParentState, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newParentState, SmePackage.HISTORY__PARENT_STATE, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setParentState(CompoundState newParentState) {
		if (newParentState != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.HISTORY__PARENT_STATE && newParentState != null)) {
			if (EcoreUtil.isAncestor(this, newParentState))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newParentState != null)
				msgs = ((InternalEObject) newParentState).eInverseAdd(this, SmePackage.COMPOUND_STATE__HISTORY,
					CompoundState.class, msgs);
			msgs = basicSetParentState(newParentState, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.HISTORY__PARENT_STATE, newParentState,
				newParentState));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public SignalContainer getParent() {
		return getParentState();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.HISTORY__DST_STRONG_TRANSITIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getDst_StrongTransitions()).basicAdd(
					otherEnd, msgs);
			case SmePackage.HISTORY__DST_WEAK_TRANSITIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getDst_WeakTransitions()).basicAdd(
					otherEnd, msgs);
			case SmePackage.HISTORY__PARENT_STATE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetParentState((CompoundState) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.HISTORY__DST_STRONG_TRANSITIONS:
				return ((InternalEList<?>) getDst_StrongTransitions()).basicRemove(otherEnd, msgs);
			case SmePackage.HISTORY__DST_WEAK_TRANSITIONS:
				return ((InternalEList<?>) getDst_WeakTransitions()).basicRemove(otherEnd, msgs);
			case SmePackage.HISTORY__PARENT_STATE:
				return basicSetParentState(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case SmePackage.HISTORY__PARENT_STATE:
				return eInternalContainer().eInverseRemove(this, SmePackage.COMPOUND_STATE__HISTORY,
					CompoundState.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.HISTORY__DST_STRONG_TRANSITIONS:
				return getDst_StrongTransitions();
			case SmePackage.HISTORY__DST_WEAK_TRANSITIONS:
				return getDst_WeakTransitions();
			case SmePackage.HISTORY__NAME:
				return getName();
			case SmePackage.HISTORY__PARENT_STATE:
				return getParentState();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.HISTORY__DST_STRONG_TRANSITIONS:
				getDst_StrongTransitions().clear();
				getDst_StrongTransitions().addAll((Collection<? extends StrongTransition>) newValue);
				return;
			case SmePackage.HISTORY__DST_WEAK_TRANSITIONS:
				getDst_WeakTransitions().clear();
				getDst_WeakTransitions().addAll((Collection<? extends WeakTransition>) newValue);
				return;
			case SmePackage.HISTORY__NAME:
				setName((String) newValue);
				return;
			case SmePackage.HISTORY__PARENT_STATE:
				setParentState((CompoundState) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.HISTORY__DST_STRONG_TRANSITIONS:
				getDst_StrongTransitions().clear();
				return;
			case SmePackage.HISTORY__DST_WEAK_TRANSITIONS:
				getDst_WeakTransitions().clear();
				return;
			case SmePackage.HISTORY__NAME:
				setName(NAME_EDEFAULT);
				return;
			case SmePackage.HISTORY__PARENT_STATE:
				setParentState((CompoundState) null);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.HISTORY__DST_STRONG_TRANSITIONS:
				return dst_StrongTransitions != null && !dst_StrongTransitions.isEmpty();
			case SmePackage.HISTORY__DST_WEAK_TRANSITIONS:
				return dst_WeakTransitions != null && !dst_WeakTransitions.isEmpty();
			case SmePackage.HISTORY__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case SmePackage.HISTORY__PARENT_STATE:
				return getParentState() != null;
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == OperatorPort.class) {
			switch (derivedFeatureID) {
				case SmePackage.HISTORY__NAME:
					return SmePackage.OPERATOR_PORT__NAME;
				default:
					return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == OperatorPort.class) {
			switch (baseFeatureID) {
				case SmePackage.OPERATOR_PORT__NAME:
					return SmePackage.HISTORY__NAME;
				default:
					return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#buildEquationsAST(int)
	 * @generated NOT
	 */
	public long buildEquationsAST(long bodyTree) {
		return bodyTree;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#getAST(java.util.Set)
	 * @generated NOT
	 */
	public long getAST(Set<SignalElement> path) throws CyclicDefinitionException {
		long result = PKTrees.ERROR_NODE;
		if (getParentState() == null) {
			result = PKTrees.ERROR_NODE;
		}
		else {
			result = getParentState().getAST(path);
		}
		PkPlugin.getTraceabilityAPI().getInterfaceMapSMESignal().put(this, result);
		return result;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#getDeclarationAST(int)
	 * @generated NOT
	 */
	public long getDeclarationAST(long declTree) {
		return declTree;
	}
	
} // HistoryImpl
