/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.HashSet;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.irisa.espresso.sme.ClockRelation;
import fr.irisa.espresso.sme.Dependence;
import fr.irisa.espresso.sme.InputPort;
import fr.irisa.espresso.sme.Iterate;
import fr.irisa.espresso.sme.IterationInit;
import fr.irisa.espresso.sme.OperatorPort;
import fr.irisa.espresso.sme.OutputPort;
import fr.irisa.espresso.sme.SignalElement;
import fr.irisa.espresso.sme.SmeFactory;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Iterate</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.IterateImpl#getIterationInit <em>Iteration Init</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.IterateImpl#getIns <em>Ins</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class IterateImpl extends SubProcessImpl implements Iterate {
	/**
	 * The cached value of the '{@link #getIterationInit() <em>Iteration Init</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getIterationInit()
	 * @generated
	 * @ordered
	 */
	protected IterationInit		iterationInit;
	
	/**
	 * The cached value of the '{@link #getIns() <em>Ins</em>}' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getIns()
	 * @generated
	 * @ordered
	 */
	protected EList<InputPort>	ins;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected IterateImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.ITERATE;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public IterationInit getIterationInit() {
		if (iterationInit == null) {
			iterationInit = SmeFactory.eINSTANCE.createIterationInit();
			iterationInit.setIterateParent(this);
		}
		return iterationInit;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetIterationInit(IterationInit newIterationInit, NotificationChain msgs) {
		IterationInit oldIterationInit = iterationInit;
		iterationInit = newIterationInit;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
				SmePackage.ITERATE__ITERATION_INIT, oldIterationInit, newIterationInit);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIterationInit(IterationInit newIterationInit) {
		if (newIterationInit != iterationInit) {
			NotificationChain msgs = null;
			if (iterationInit != null)
				msgs = ((InternalEObject) iterationInit).eInverseRemove(this,
					SmePackage.ITERATION_INIT__ITERATE_PARENT, IterationInit.class, msgs);
			if (newIterationInit != null)
				msgs = ((InternalEObject) newIterationInit).eInverseAdd(this,
					SmePackage.ITERATION_INIT__ITERATE_PARENT, IterationInit.class, msgs);
			msgs = basicSetIterationInit(newIterationInit, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.ITERATE__ITERATION_INIT, newIterationInit,
				newIterationInit));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<InputPort> getIns() {
		if (ins == null) {
			ins = new EObjectContainmentEList<InputPort>(InputPort.class, this, SmePackage.ITERATE__INS);
		}
		return ins;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public String getPortName(OperatorPort port) {
		String tmp = "";
		if (name != null)
			tmp = name;
		if (port instanceof InputPort) {
			tmp += "_in";
			int ind = ins.indexOf(port);
			if (ind != PKTrees.ERROR_NODE)
				return (tmp + ind);
		}
		return null;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<InputPort> getInputPorts() {
		return ECollections.unmodifiableEList(getIns());
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<OutputPort> getOutputPorts() {
		return ECollections.emptyEList();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.ITERATE__ITERATION_INIT:
				if (iterationInit != null)
					msgs = ((InternalEObject) iterationInit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE
							- SmePackage.ITERATE__ITERATION_INIT, null, msgs);
				return basicSetIterationInit((IterationInit) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.ITERATE__ITERATION_INIT:
				return basicSetIterationInit(null, msgs);
			case SmePackage.ITERATE__INS:
				return ((InternalEList<?>) getIns()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.ITERATE__ITERATION_INIT:
				return getIterationInit();
			case SmePackage.ITERATE__INS:
				return getIns();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.ITERATE__ITERATION_INIT:
				setIterationInit((IterationInit) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.ITERATE__ITERATION_INIT:
				setIterationInit((IterationInit) null);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.ITERATE__ITERATION_INIT:
				return iterationInit != null;
			case SmePackage.ITERATE__INS:
				return ins != null && !ins.isEmpty();
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * @see org.topcased.sme.SignalElement#buildEquationsAST(int)
	 * @generated NOT
	 */
	public long buildEquationsAST(long bodyTree) {
		if (this.getDst_CaseConnection() == null && bodyTree != PKTrees.ERROR_NODE) {
			// It is used as a labeled part in the specification of the process
			bodyTree = PkPlugin.getTreeAPI().post(bodyTree, getCommonPart());
			
			for (ClockRelation cr : getDst_ClockRelations())
				bodyTree = cr.buildEquationsAST(bodyTree);
			for (Dependence dep : getDst_Dependences())
				bodyTree = dep.buildEquationsAST(bodyTree);
		}
		else if (this.getDst_CaseConnection() != null && bodyTree == PKTrees.ERROR_NODE) {
			// The Iterate is used as a case in a switch case constructs
			bodyTree = PkPlugin.getTreeAPI().makeList(SignalOperators.oplfeed, getCommonPart());
			
			for (ClockRelation cr : getDst_ClockRelations())
				bodyTree = cr.buildEquationsAST(bodyTree);
			for (Dependence dep : getDst_Dependences())
				bodyTree = dep.buildEquationsAST(bodyTree);
		}
		return bodyTree;
	}
	
	private long getCommonPart() {
		PKTrees API = PkPlugin.getTreeAPI();
		
		// We build the structure of a Model (cut and paste of the Model method, because cannot use those of SubProcess)
		long result = makeEquations(API.makeEmptyList(SignalOperators.oplfeed));
		if (API.isEmpty(result))
			result = API.makeNullary(SignalOperators.opnullproc);
		
		long declTree = makeDeclarations(API.makeEmptyList(SignalOperators.opldecl));
		if (!API.isEmpty(declTree)) // If there are declarations, we create a confined processus
			result = API.makeBinary(SignalOperators.oppconf, result, declTree);
		
		if (getIns().size() > 0) {
			long initNode = getIterationInit().buildEquationsAST(PKTrees.ERROR_NODE);
			boolean allOk = true;
			long indexNode = API.makeEmptyList(SignalOperators.opleflot);
			for (InputPort in : getIns()) {
				try {
					long tmp = in.getAST(new HashSet<SignalElement>());
					if (tmp == PKTrees.ERROR_NODE)
						allOk = false;
					else
						indexNode = API.post(indexNode, tmp);
				}
				catch (CyclicDefinitionException cde) {
					PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.CYCLE_DETECTION + cde.getElement(), cde
							.getElement());
					allOk = false;
				}
			}
			if (allOk)
				result = API.makeTernary(SignalOperators.opiter, indexNode, result, initNode);
		}
		else {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.ITERATE_INPUT_PORT + name, this);
		}
		
		// we add the label to it.
		long idNode = getAST(null);
		if (idNode != PKTrees.ERROR_NODE)
			result = API.makeBinary(SignalOperators.oppetiq, idNode, result);
		
		return result;
	}
	
} // IterateImpl
