/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import fr.irisa.espresso.sme.BasicIterate;
import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.Iterate;
import fr.irisa.espresso.sme.IterationInit;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalOrRef;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Iteration Init</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.IterationInitImpl#getArrayParent <em>Array Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.IterationInitImpl#getIterateParent <em>Iterate Parent</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class IterationInitImpl extends ModelImpl implements IterationInit {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected IterationInitImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.ITERATION_INIT;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public BasicIterate getArrayParent() {
		if (eContainerFeatureID != SmePackage.ITERATION_INIT__ARRAY_PARENT)
			return null;
		return (BasicIterate) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetArrayParent(BasicIterate newArrayParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newArrayParent, SmePackage.ITERATION_INIT__ARRAY_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setArrayParent(BasicIterate newArrayParent) {
		if (newArrayParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.ITERATION_INIT__ARRAY_PARENT && newArrayParent != null)) {
			if (EcoreUtil.isAncestor(this, newArrayParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newArrayParent != null)
				msgs = ((InternalEObject) newArrayParent).eInverseAdd(this, SmePackage.BASIC_ITERATE__ITERATION_INIT,
					BasicIterate.class, msgs);
			msgs = basicSetArrayParent(newArrayParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.ITERATION_INIT__ARRAY_PARENT,
				newArrayParent, newArrayParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Iterate getIterateParent() {
		if (eContainerFeatureID != SmePackage.ITERATION_INIT__ITERATE_PARENT)
			return null;
		return (Iterate) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetIterateParent(Iterate newIterateParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newIterateParent, SmePackage.ITERATION_INIT__ITERATE_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIterateParent(Iterate newIterateParent) {
		if (newIterateParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.ITERATION_INIT__ITERATE_PARENT && newIterateParent != null)) {
			if (EcoreUtil.isAncestor(this, newIterateParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newIterateParent != null)
				msgs = ((InternalEObject) newIterateParent).eInverseAdd(this, SmePackage.ITERATE__ITERATION_INIT,
					Iterate.class, msgs);
			msgs = basicSetIterateParent(newIterateParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.ITERATION_INIT__ITERATE_PARENT,
				newIterateParent, newIterateParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.ITERATION_INIT__ARRAY_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetArrayParent((BasicIterate) otherEnd, msgs);
			case SmePackage.ITERATION_INIT__ITERATE_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetIterateParent((Iterate) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.ITERATION_INIT__ARRAY_PARENT:
				return basicSetArrayParent(null, msgs);
			case SmePackage.ITERATION_INIT__ITERATE_PARENT:
				return basicSetIterateParent(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case SmePackage.ITERATION_INIT__ARRAY_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.BASIC_ITERATE__ITERATION_INIT,
					BasicIterate.class, msgs);
			case SmePackage.ITERATION_INIT__ITERATE_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.ITERATE__ITERATION_INIT, Iterate.class,
					msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.ITERATION_INIT__ARRAY_PARENT:
				return getArrayParent();
			case SmePackage.ITERATION_INIT__ITERATE_PARENT:
				return getIterateParent();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.ITERATION_INIT__ARRAY_PARENT:
				setArrayParent((BasicIterate) newValue);
				return;
			case SmePackage.ITERATION_INIT__ITERATE_PARENT:
				setIterateParent((Iterate) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.ITERATION_INIT__ARRAY_PARENT:
				setArrayParent((BasicIterate) null);
				return;
			case SmePackage.ITERATION_INIT__ITERATE_PARENT:
				setIterateParent((Iterate) null);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.ITERATION_INIT__ARRAY_PARENT:
				return getArrayParent() != null;
			case SmePackage.ITERATION_INIT__ITERATE_PARENT:
				return getIterateParent() != null;
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public SignalContainer getParent() {
		Iterate it = getIterateParent();
		if (it != null)
			return it;
		else
			return getArrayParent();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ModelImpl#getVisibleSignals()
	 * @generated NOT
	 */
	@Override
	public EList<SignalOrRef> getVisibleSignals() {
		EList<SignalOrRef> list = super.getVisibleSignals();
		
		if (getParent() != null)
			list.addAll(getParent().getVisibleSignals());
		
		return list;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ModelImpl#getVisibleTypes()
	 * @generated NOT
	 */
	@Override
	public EList<Identifier> getVisibleTypes() {
		EList<Identifier> list = super.getVisibleTypes();
		
		if (getParent() != null)
			list.addAll(getParent().getVisibleTypes());
		
		return list;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ModelImpl#getName()
	 * @generated NOT
	 */
	@Override
	public String getName() {
		return "Init of " + getParent().getName();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#buildEquationsAST(int)
	 * @generated NOT
	 */
	public long buildEquationsAST(long bodyTree) {
		assert (bodyTree == PKTrees.ERROR_NODE);
		
		PKTrees API = PkPlugin.getTreeAPI();
		
		long declTree = makeDeclarations(API.makeEmptyList(SignalOperators.opldecl));
		if (API.isEmpty(declTree)) {
			bodyTree = makeEquations(API.makeEmptyList(SignalOperators.oplfeed));
			if (API.isEmpty(bodyTree))
				bodyTree = API.makeNullary(SignalOperators.opnil);
		}
		else {
			bodyTree = makeEquations(API.makeEmptyList(SignalOperators.oplfeed));
			if (API.isEmpty(bodyTree))
				bodyTree = API.makeNullary(SignalOperators.opnullproc);
			bodyTree = API.makeBinary(SignalOperators.oppconf, bodyTree, declTree);
		}
		return bodyTree;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ModelImpl#getDeclarationAST(int)
	 * @generated NOT
	 */
	public long getDeclarationAST(long declTree) {
		return declTree;
	}
	
} // IterationInitImpl
