/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.Iterator;
import java.util.Set;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import fr.irisa.espresso.sme.ClockRelation;
import fr.irisa.espresso.sme.CompoundState;
import fr.irisa.espresso.sme.DataflowConnection;
import fr.irisa.espresso.sme.Dependence;
import fr.irisa.espresso.sme.Local;
import fr.irisa.espresso.sme.Model;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalElement;
import fr.irisa.espresso.sme.SignalIntrinsicType;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.StatusKind;
import fr.irisa.espresso.sme.TupleType;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.Phyla;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.traceability.WarningMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Local</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.LocalImpl#getStatus <em>Status</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.LocalImpl#getModelParent <em>Model Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.LocalImpl#getStateParent <em>State Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.LocalImpl#getTypeParent <em>Type Parent</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class LocalImpl extends SignalImpl implements Local {
	/**
	 * The default value of the '{@link #getStatus() <em>Status</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getStatus()
	 * @generated
	 * @ordered
	 */
	protected static final StatusKind	STATUS_EDEFAULT	= StatusKind.NORMAL;
	
	/**
	 * The cached value of the '{@link #getStatus() <em>Status</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getStatus()
	 * @generated
	 * @ordered
	 */
	protected StatusKind				status			= STATUS_EDEFAULT;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected LocalImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.LOCAL;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StatusKind getStatus() {
		return status;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setStatus(StatusKind newStatus) {
		StatusKind oldStatus = status;
		status = newStatus == null ? STATUS_EDEFAULT : newStatus;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.LOCAL__STATUS, oldStatus, status));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Model getModelParent() {
		if (eContainerFeatureID != SmePackage.LOCAL__MODEL_PARENT)
			return null;
		return (Model) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetModelParent(Model newModelParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newModelParent, SmePackage.LOCAL__MODEL_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setModelParent(Model newModelParent) {
		if (newModelParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.LOCAL__MODEL_PARENT && newModelParent != null)) {
			if (EcoreUtil.isAncestor(this, newModelParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newModelParent != null)
				msgs = ((InternalEObject) newModelParent)
						.eInverseAdd(this, SmePackage.MODEL__LOCALS, Model.class, msgs);
			msgs = basicSetModelParent(newModelParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.LOCAL__MODEL_PARENT, newModelParent,
				newModelParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CompoundState getStateParent() {
		if (eContainerFeatureID != SmePackage.LOCAL__STATE_PARENT)
			return null;
		return (CompoundState) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetStateParent(CompoundState newStateParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newStateParent, SmePackage.LOCAL__STATE_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setStateParent(CompoundState newStateParent) {
		if (newStateParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.LOCAL__STATE_PARENT && newStateParent != null)) {
			if (EcoreUtil.isAncestor(this, newStateParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStateParent != null)
				msgs = ((InternalEObject) newStateParent).eInverseAdd(this, SmePackage.COMPOUND_STATE__LOCALS,
					CompoundState.class, msgs);
			msgs = basicSetStateParent(newStateParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.LOCAL__STATE_PARENT, newStateParent,
				newStateParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TupleType getTypeParent() {
		if (eContainerFeatureID != SmePackage.LOCAL__TYPE_PARENT)
			return null;
		return (TupleType) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetTypeParent(TupleType newTypeParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newTypeParent, SmePackage.LOCAL__TYPE_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setTypeParent(TupleType newTypeParent) {
		if (newTypeParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.LOCAL__TYPE_PARENT && newTypeParent != null)) {
			if (EcoreUtil.isAncestor(this, newTypeParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newTypeParent != null)
				msgs = ((InternalEObject) newTypeParent).eInverseAdd(this, SmePackage.TUPLE_TYPE__LOCALS,
					TupleType.class, msgs);
			msgs = basicSetTypeParent(newTypeParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.LOCAL__TYPE_PARENT, newTypeParent,
				newTypeParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.LOCAL__MODEL_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetModelParent((Model) otherEnd, msgs);
			case SmePackage.LOCAL__STATE_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetStateParent((CompoundState) otherEnd, msgs);
			case SmePackage.LOCAL__TYPE_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetTypeParent((TupleType) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.LOCAL__MODEL_PARENT:
				return basicSetModelParent(null, msgs);
			case SmePackage.LOCAL__STATE_PARENT:
				return basicSetStateParent(null, msgs);
			case SmePackage.LOCAL__TYPE_PARENT:
				return basicSetTypeParent(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case SmePackage.LOCAL__MODEL_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.MODEL__LOCALS, Model.class, msgs);
			case SmePackage.LOCAL__STATE_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.COMPOUND_STATE__LOCALS,
					CompoundState.class, msgs);
			case SmePackage.LOCAL__TYPE_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.TUPLE_TYPE__LOCALS, TupleType.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.LOCAL__STATUS:
				return getStatus();
			case SmePackage.LOCAL__MODEL_PARENT:
				return getModelParent();
			case SmePackage.LOCAL__STATE_PARENT:
				return getStateParent();
			case SmePackage.LOCAL__TYPE_PARENT:
				return getTypeParent();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.LOCAL__STATUS:
				setStatus((StatusKind) newValue);
				return;
			case SmePackage.LOCAL__MODEL_PARENT:
				setModelParent((Model) newValue);
				return;
			case SmePackage.LOCAL__STATE_PARENT:
				setStateParent((CompoundState) newValue);
				return;
			case SmePackage.LOCAL__TYPE_PARENT:
				setTypeParent((TupleType) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.LOCAL__STATUS:
				setStatus(STATUS_EDEFAULT);
				return;
			case SmePackage.LOCAL__MODEL_PARENT:
				setModelParent((Model) null);
				return;
			case SmePackage.LOCAL__STATE_PARENT:
				setStateParent((CompoundState) null);
				return;
			case SmePackage.LOCAL__TYPE_PARENT:
				setTypeParent((TupleType) null);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.LOCAL__STATUS:
				return status != STATUS_EDEFAULT;
			case SmePackage.LOCAL__MODEL_PARENT:
				return getModelParent() != null;
			case SmePackage.LOCAL__STATE_PARENT:
				return getStateParent() != null;
			case SmePackage.LOCAL__TYPE_PARENT:
				return getTypeParent() != null;
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (status: ");
		result.append(status);
		result.append(')');
		return result.toString();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.Identifier#toString(boolean, boolean)
	 * @generated NOT
	 */
	public String toString(boolean asCode, boolean withComment) {
		if (asCode) {
			StringBuffer result = new StringBuffer();
			if (withComment && comment != null && ("".equals(comment) == false))
				result.append(comment + "\n\n");
			result.append(status.getLiteral());
			if (type != null) {
				result.append(type);
				if (getArrayDimensions().size() > 0) {
					result.append("[");
					Iterator<String> it = arrayDimensions.iterator();
					result.append(it.next());
					while (it.hasNext()) {
						result.append(", ");
						result.append(it.next());
					}
					result.append("]");
				}
			}
			result.append(" " + name);
			return result.toString();
		}
		else
			return toString();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public SignalContainer getParent() {
		SignalContainer parent = getModelParent();
		if (parent != null)
			return parent;
		parent = getTypeParent();
		if (parent != null)
			return parent;
		return getStateParent();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.SignalImpl#getAST(java.util.Set)
	 * @generated NOT
	 */
	@Override
	public long getAST(Set<SignalElement> path) {
		long idNode = super.getAST(path);
		if (idNode != PKTrees.ERROR_NODE && status.equals(StatusKind.STATEVAR))
			idNode = PkPlugin.getTreeAPI().makeUnary(SignalOperators.opvvarin, idNode);
		PkPlugin.getTraceabilityAPI().getInterfaceMapSMESignal().put(this, idNode);
		return idNode;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#buildEquationsAST(int)
	 * @generated NOT
	 */
	public long buildEquationsAST(long bodyTree) {
		for (DataflowConnection dc : getDst_DataflowConnections())
			bodyTree = dc.buildEquationsAST(bodyTree);
		for (ClockRelation cr : getDst_ClockRelations())
			bodyTree = cr.buildEquationsAST(bodyTree);
		for (Dependence dep : getDst_Dependences())
			bodyTree = dep.buildEquationsAST(bodyTree);
		return bodyTree;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.SignalImpl#getDeclarationAST(int)
	 * @generated NOT
	 */
	@Override
	public long getDeclarationAST(long declTree) {
		long idNode = super.getAST(null);
		if (idNode != PKTrees.ERROR_NODE) {
			PKTrees API = PkPlugin.getTreeAPI();
			long typeNode;
			if (TYPE_EDEFAULT == type || type.equals(SignalIntrinsicType.UNDEFINED_LITERAL.getLiteral())) {
				// Implicit type ==> we do not use arrayDimensions
				typeNode = API.makeNullary(SignalOperators.opimplicit);
				PolychronyDiagnostic.add(Diagnostic.WARNING, WarningMessages.NO_SIGNAL_TYPE + name, this);
			}
			else {
				if (type.equals(SignalIntrinsicType.BOOLEAN_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.oplogical);
				else if (type.equals(SignalIntrinsicType.CHAR_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opchar);
				else if (type.equals(SignalIntrinsicType.COMPLEX_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opcomplex);
				else if (type.equals(SignalIntrinsicType.DCOMPLEX_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opdcomplex);
				else if (type.equals(SignalIntrinsicType.DREAL_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opdpreal);
				else if (type.equals(SignalIntrinsicType.EVENT_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opevent);
				else if (type.equals(SignalIntrinsicType.INTEGER_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opinteger);
				else if (type.equals(SignalIntrinsicType.LONG_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.oplong);
				else if (type.equals(SignalIntrinsicType.REAL_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opreal);
				else if (type.equals(SignalIntrinsicType.SHORT_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opshort);
				else if (type.equals(SignalIntrinsicType.STRING_LITERAL.getLiteral()))
					typeNode = API.makeNullary(SignalOperators.opstring);
				else
					typeNode = API.atomString(SignalOperators.opnom, type);
				
				// Add the specification of arrayDimensions. Parse the textual expression
				if (!getArrayDimensions().isEmpty()) {
					long arrayNode = API.makeEmptyList(SignalOperators.oplesign);
					boolean allOk = true;
					for (String st : arrayDimensions) {
						long exprNode = PkPlugin.getParser().parseString(Phyla.ph_e_sign, st);
						if (exprNode == PKTrees.ERROR_NODE) {
							PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.ARRAY_DIMENSION_VALUE + st, this);
							allOk = false;
						}
						else
							arrayNode = API.post(arrayNode, exprNode);
					}
					if (allOk)
						typeNode = API.makeBinary(SignalOperators.optvect, arrayNode, typeNode);
				}
			}
			
			int size = getInitValue().size();
			if (size > 0) {
				long valueNode;
				if (size > 1) {
					valueNode = API.makeEmptyList(SignalOperators.oplevect);
					boolean allOk = true;
					// Value represents an array
					for (String st : initValue) {
						long exprNode = PkPlugin.getParser().parseString(Phyla.ph_e_sign, st);
						if (exprNode == PKTrees.ERROR_NODE) {
							PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.SIGNAL_INITIAL_VALUE + st, this);
							allOk = false;
						}
						else
							valueNode = API.post(valueNode, exprNode);
					}
					if (allOk)
						idNode = API.makeBinary(SignalOperators.opinit, idNode, valueNode);
				}
				else {
					// Value is a simple value
					valueNode = PkPlugin.getParser().parseString(Phyla.ph_e_sign, initValue.get(0));
					if (valueNode == PKTrees.ERROR_NODE)
						PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.SIGNAL_INITIAL_VALUE + name, this);
					else {
						// Create the <signal> node with initial value
						idNode = API.makeBinary(SignalOperators.opinit, idNode, valueNode);
					}
				}
				
			}
			switch (status.getValue()) {
				case StatusKind.STATEVAR_VALUE:
					declTree = API.post(declTree, API.makeBinary(SignalOperators.opdecvar, typeNode, API.makeList(
						SignalOperators.oplsign, idNode)));
					break;
				case StatusKind.SHARED_VALUE:
					declTree = API.post(declTree, API.makeBinary(SignalOperators.opdecpar, typeNode, API.makeList(
						SignalOperators.oplsign, idNode)));
					break;
				default:
					declTree = API.post(declTree, API.makeBinary(SignalOperators.opdecsig, typeNode, API.makeList(
						SignalOperators.oplsign, idNode)));
			}
		}
		return declTree;
	}
	
	/**
	 * This method returns true if the current signal uses only partial definition
	 * 
	 * @generated NOT
	 */
	public boolean isPartiallyDefined() {
		// Only local signal with status equal to shared or statevar can be partially defined
		return !(status.equals(StatusKind.NORMAL));
	}
	
} // LocalImpl
