/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.Collection;
import java.util.Set;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.irisa.espresso.sme.ConstantOrRef;
import fr.irisa.espresso.sme.ConstantValue;
import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.InterfaceDefinition;
import fr.irisa.espresso.sme.ModelDeclaration;
import fr.irisa.espresso.sme.ModelType;
import fr.irisa.espresso.sme.Module;
import fr.irisa.espresso.sme.Pragma;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalElement;
import fr.irisa.espresso.sme.SignalOrRef;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.TypeDeclaration;
import fr.irisa.espresso.sme.UseModule;
import fr.irisa.espresso.sme.VisibilityKind;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.Phyla;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;
import fr.irisa.espresso.sme.util.Utils;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Module</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.ModuleImpl#getName <em>Name</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ModuleImpl#getComment <em>Comment</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ModuleImpl#getConstants <em>Constants</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ModuleImpl#getModelDeclarations <em>Model Declarations</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ModuleImpl#getTypes <em>Types</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ModuleImpl#getUseModule <em>Use Module</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.ModuleImpl#getPragmas <em>Pragmas</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ModuleImpl extends EObjectImpl implements Module {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String		NAME_EDEFAULT		= null;
	
	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String					name				= NAME_EDEFAULT;
	
	/**
	 * The default value of the '{@link #getComment() <em>Comment</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getComment()
	 * @generated
	 * @ordered
	 */
	protected static final String		COMMENT_EDEFAULT	= null;
	
	/**
	 * The cached value of the '{@link #getComment() <em>Comment</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getComment()
	 * @generated
	 * @ordered
	 */
	protected String					comment				= COMMENT_EDEFAULT;
	
	/**
	 * The cached value of the '{@link #getConstants() <em>Constants</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getConstants()
	 * @generated
	 * @ordered
	 */
	protected EList<ConstantValue>		constants;
	
	/**
	 * The cached value of the '{@link #getModelDeclarations() <em>Model Declarations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getModelDeclarations()
	 * @generated
	 * @ordered
	 */
	protected EList<ModelDeclaration>	modelDeclarations;
	
	/**
	 * The cached value of the '{@link #getTypes() <em>Types</em>}' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getTypes()
	 * @generated
	 * @ordered
	 */
	protected EList<TypeDeclaration>	types;
	
	/**
	 * The cached value of the '{@link #getUseModule() <em>Use Module</em>}' containment reference. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getUseModule()
	 * @generated
	 * @ordered
	 */
	protected UseModule					useModule;
	
	/**
	 * The cached value of the '{@link #getPragmas() <em>Pragmas</em>}' containment reference list. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getPragmas()
	 * @generated
	 * @ordered
	 */
	protected EList<Pragma>				pragmas;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ModuleImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.MODULE;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.MODULE__NAME, oldName, name));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getComment() {
		return comment;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setComment(String newComment) {
		String oldComment = comment;
		comment = newComment;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.MODULE__COMMENT, oldComment, comment));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<ConstantValue> getConstants() {
		if (constants == null) {
			constants = new EObjectContainmentWithInverseEList<ConstantValue>(ConstantValue.class, this,
				SmePackage.MODULE__CONSTANTS, SmePackage.CONSTANT_VALUE__MODULE_PARENT);
		}
		return constants;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<ModelDeclaration> getModelDeclarations() {
		if (modelDeclarations == null) {
			modelDeclarations = new EObjectContainmentWithInverseEList<ModelDeclaration>(ModelDeclaration.class, this,
				SmePackage.MODULE__MODEL_DECLARATIONS, SmePackage.MODEL_DECLARATION__MODULE_PARENT);
		}
		return modelDeclarations;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<TypeDeclaration> getTypes() {
		if (types == null) {
			types = new EObjectContainmentWithInverseEList<TypeDeclaration>(TypeDeclaration.class, this,
				SmePackage.MODULE__TYPES, SmePackage.TYPE_DECLARATION__MODULE_PARENT);
		}
		return types;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public UseModule getUseModule() {
		return useModule;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetUseModule(UseModule newUseModule, NotificationChain msgs) {
		UseModule oldUseModule = useModule;
		useModule = newUseModule;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
				SmePackage.MODULE__USE_MODULE, oldUseModule, newUseModule);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setUseModule(UseModule newUseModule) {
		if (newUseModule != useModule) {
			NotificationChain msgs = null;
			if (useModule != null)
				msgs = ((InternalEObject) useModule).eInverseRemove(this, SmePackage.USE_MODULE__MODULE_PARENT,
					UseModule.class, msgs);
			if (newUseModule != null)
				msgs = ((InternalEObject) newUseModule).eInverseAdd(this, SmePackage.USE_MODULE__MODULE_PARENT,
					UseModule.class, msgs);
			msgs = basicSetUseModule(newUseModule, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.MODULE__USE_MODULE, newUseModule,
				newUseModule));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<Pragma> getPragmas() {
		if (pragmas == null) {
			pragmas = new EObjectContainmentWithInverseEList<Pragma>(Pragma.class, this, SmePackage.MODULE__PRAGMAS,
				SmePackage.PRAGMA__MODULE_PARENT);
		}
		return pragmas;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<ConstantValue> getExportedConstants() {
		EList<ConstantValue> list = new BasicEList<ConstantValue>();
		
		for (ConstantValue cst : getConstants()) {
			if (cst.getVisibility().equals(VisibilityKind.PUBLIC_LITERAL))
				list.add(cst);
		}
		
		return list;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<ModelDeclaration> getExportedModels() {
		EList<ModelDeclaration> list = new BasicEList<ModelDeclaration>();
		
		for (ModelDeclaration model : getModelDeclarations()) {
			if (model.getVisibility().equals(VisibilityKind.PUBLIC_LITERAL))
				list.add(model);
		}
		
		return list;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<TypeDeclaration> getExportedTypes() {
		// REV add useModule treatment for all Model with a useModule.
		// maybe it is necessary to add a hash table or a map to eliminate all types with the same name.
		EList<TypeDeclaration> list = new BasicEList<TypeDeclaration>();
		
		for (TypeDeclaration type : getTypes()) {
			if (type.getVisibility().equals(VisibilityKind.PUBLIC_LITERAL))
				list.add(type);
		}
		
		return list;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<ConstantOrRef> getVisibleConstants() {
		EList<ConstantOrRef> list = new BasicEList<ConstantOrRef>(this.getConstants());
		
		if (useModule != null) {
			for (Module mod : useModule.getModules())
				list.addAll(mod.getExportedConstants());
		}
		return list;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<InterfaceDefinition> getVisibleModelProcesses() {
		EList<InterfaceDefinition> list = new BasicEList<InterfaceDefinition>(this.getModelDeclarations());
		for (TypeDeclaration type : getTypes()) {
			if (type instanceof ModelType)
				list.add((ModelType) type);
		}
		
		if (useModule != null) {
			for (Module mod : useModule.getModules()) {
				list.addAll(mod.getExportedModels());
				for (TypeDeclaration type : mod.getExportedTypes()) {
					if (type instanceof ModelType)
						list.add((ModelType) type);
				}
			}
		}
		
		return list;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<SignalOrRef> getVisibleSignals() {
		// No Signals can be declared in a module and also in imported modules
		return ECollections.emptyEList();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public EList<Identifier> getVisibleTypes() {
		EList<Identifier> list = new BasicEList<Identifier>(this.getTypes());
		
		if (useModule != null) {
			for (Module mod : useModule.getModules())
				list.addAll(mod.getExportedTypes());
		}
		
		return list;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public SignalContainer getParent() {
		return null;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.MODULE__CONSTANTS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getConstants()).basicAdd(otherEnd, msgs);
			case SmePackage.MODULE__MODEL_DECLARATIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getModelDeclarations()).basicAdd(otherEnd,
					msgs);
			case SmePackage.MODULE__TYPES:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getTypes()).basicAdd(otherEnd, msgs);
			case SmePackage.MODULE__USE_MODULE:
				if (useModule != null)
					msgs = ((InternalEObject) useModule).eInverseRemove(this, EOPPOSITE_FEATURE_BASE
							- SmePackage.MODULE__USE_MODULE, null, msgs);
				return basicSetUseModule((UseModule) otherEnd, msgs);
			case SmePackage.MODULE__PRAGMAS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getPragmas()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.MODULE__CONSTANTS:
				return ((InternalEList<?>) getConstants()).basicRemove(otherEnd, msgs);
			case SmePackage.MODULE__MODEL_DECLARATIONS:
				return ((InternalEList<?>) getModelDeclarations()).basicRemove(otherEnd, msgs);
			case SmePackage.MODULE__TYPES:
				return ((InternalEList<?>) getTypes()).basicRemove(otherEnd, msgs);
			case SmePackage.MODULE__USE_MODULE:
				return basicSetUseModule(null, msgs);
			case SmePackage.MODULE__PRAGMAS:
				return ((InternalEList<?>) getPragmas()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.MODULE__NAME:
				return getName();
			case SmePackage.MODULE__COMMENT:
				return getComment();
			case SmePackage.MODULE__CONSTANTS:
				return getConstants();
			case SmePackage.MODULE__MODEL_DECLARATIONS:
				return getModelDeclarations();
			case SmePackage.MODULE__TYPES:
				return getTypes();
			case SmePackage.MODULE__USE_MODULE:
				return getUseModule();
			case SmePackage.MODULE__PRAGMAS:
				return getPragmas();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.MODULE__NAME:
				setName((String) newValue);
				return;
			case SmePackage.MODULE__COMMENT:
				setComment((String) newValue);
				return;
			case SmePackage.MODULE__CONSTANTS:
				getConstants().clear();
				getConstants().addAll((Collection<? extends ConstantValue>) newValue);
				return;
			case SmePackage.MODULE__MODEL_DECLARATIONS:
				getModelDeclarations().clear();
				getModelDeclarations().addAll((Collection<? extends ModelDeclaration>) newValue);
				return;
			case SmePackage.MODULE__TYPES:
				getTypes().clear();
				getTypes().addAll((Collection<? extends TypeDeclaration>) newValue);
				return;
			case SmePackage.MODULE__USE_MODULE:
				setUseModule((UseModule) newValue);
				return;
			case SmePackage.MODULE__PRAGMAS:
				getPragmas().clear();
				getPragmas().addAll((Collection<? extends Pragma>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.MODULE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case SmePackage.MODULE__COMMENT:
				setComment(COMMENT_EDEFAULT);
				return;
			case SmePackage.MODULE__CONSTANTS:
				getConstants().clear();
				return;
			case SmePackage.MODULE__MODEL_DECLARATIONS:
				getModelDeclarations().clear();
				return;
			case SmePackage.MODULE__TYPES:
				getTypes().clear();
				return;
			case SmePackage.MODULE__USE_MODULE:
				setUseModule((UseModule) null);
				return;
			case SmePackage.MODULE__PRAGMAS:
				getPragmas().clear();
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.MODULE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case SmePackage.MODULE__COMMENT:
				return COMMENT_EDEFAULT == null ? comment != null : !COMMENT_EDEFAULT.equals(comment);
			case SmePackage.MODULE__CONSTANTS:
				return constants != null && !constants.isEmpty();
			case SmePackage.MODULE__MODEL_DECLARATIONS:
				return modelDeclarations != null && !modelDeclarations.isEmpty();
			case SmePackage.MODULE__TYPES:
				return types != null && !types.isEmpty();
			case SmePackage.MODULE__USE_MODULE:
				return useModule != null;
			case SmePackage.MODULE__PRAGMAS:
				return pragmas != null && !pragmas.isEmpty();
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", comment: ");
		result.append(comment);
		result.append(')');
		return result.toString();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.Identifier#toString(boolean, boolean)
	 * @generated NOT
	 */
	public String toString(boolean asCode, boolean withComment) {
		if (asCode) {
			StringBuffer result = new StringBuffer();
			if (withComment && comment != null && ("".equals(comment) == false))
				result.append(comment + "\n\n");
			result.append("module ");
			result.append(name);
			result.append(" = \n ... \nend module");
			return result.toString();
		}
		else
			return toString();
	}
	
	/**
	 * A Module cannot be declared in a parent object, so bodyTree is not modified.
	 * 
	 * @see fr.irisa.espresso.sme.SignalElement#buildEquationsAST(int)
	 * @generated NOT
	 */
	public long buildEquationsAST(long bodyTree) {
		return bodyTree;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#getAST(java.util.Set)
	 * @generated NOT
	 */
	public long getAST(Set<SignalElement> path) {
		long result = PKTrees.ERROR_NODE;
		if (name != null) {
			long idNode = PkPlugin.getParser().parseString(Phyla.ph_ident, name);
			if (idNode == PKTrees.ERROR_NODE) {
				PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.INCORRECT_NAME + name, this);
				result = PKTrees.ERROR_NODE;
			}
			else {
				result = idNode;
			}
		}
		else {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.NO_NAME, this);
			result = PKTrees.ERROR_NODE;
		}
		PkPlugin.getTraceabilityAPI().getInterfaceMapSMESignal().put(this, result);
		return result;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#getDeclarationAST(int)
	 * @generated NOT
	 */
	public long getDeclarationAST(long declTree) {
		PKTrees API = PkPlugin.getTreeAPI();
		declTree = API.makeEmptyList(SignalOperators.oplmodu);
		
		long declList = makeDeclarations(API.makeEmptyList(SignalOperators.opldecl));
		if (API.isEmpty(declList))
			declList = API.makeNullary(SignalOperators.opnil);
		
		long idNode = getAST(null);
		if (idNode != PKTrees.ERROR_NODE) {
			declTree = API.post(declTree, API.makeBinary(SignalOperators.opmodu, API.atomString(SignalOperators.opnom,
				getName()), API.makeBinary(SignalOperators.opdescmodu, makePragmasSignalTree(), declList)));
		}
		
		return declTree;
	}
	
	/**
	 * @return
	 */
	protected long makeDeclarations(long l) {
		l = Utils.makeDeclarationList(getTypes(), l);
		l = Utils.makeDeclarationList(getConstants(), l);
		l = Utils.makeDeclarationList(getModelDeclarations(), l);
		if (useModule != null)
			l = useModule.getDeclarationAST(l);
		return l;
	}
	
	/**
	 * @return
	 * @generated NOT
	 */
	private long makePragmasSignalTree() {
		PKTrees API = PkPlugin.getTreeAPI();
		// Add all comment pragmas: first the Model Declaration one and then all identifiers contain directly (first
		// level) by the Module
		long result = Utils.getCommentAST(this, API.makeEmptyList(SignalOperators.oplprag));
		for (ConstantValue cst : getConstants())
			result = Utils.getCommentAST(cst, result);
		for (TypeDeclaration td : getTypes())
			result = Utils.getCommentAST(td, result);
		
		for (Pragma p : getPragmas())
			result = p.buildEquationsAST(result);
		
		if (API.isEmpty(result))
			result = API.makeNullary(SignalOperators.opnil);
		
		return result;
	}
	
} // ModuleImpl
