/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.Collection;
import java.util.Set;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;

import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.InterfaceDefinition;
import fr.irisa.espresso.sme.Module;
import fr.irisa.espresso.sme.Pragma;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalElement;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.Phyla;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Pragma</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.PragmaImpl#getInterfaceParent <em>Interface Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.PragmaImpl#getModuleParent <em>Module Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.PragmaImpl#getPragma <em>Pragma</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.PragmaImpl#getExpression <em>Expression</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.PragmaImpl#getTargets <em>Targets</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class PragmaImpl extends EObjectImpl implements Pragma {
	/**
	 * The default value of the '{@link #getPragma() <em>Pragma</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getPragma()
	 * @generated
	 * @ordered
	 */
	protected static final String	PRAGMA_EDEFAULT		= null;
	
	/**
	 * The cached value of the '{@link #getPragma() <em>Pragma</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getPragma()
	 * @generated
	 * @ordered
	 */
	protected String				pragma				= PRAGMA_EDEFAULT;
	
	/**
	 * The default value of the '{@link #getExpression() <em>Expression</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getExpression()
	 * @generated
	 * @ordered
	 */
	protected static final String	EXPRESSION_EDEFAULT	= null;
	
	/**
	 * The cached value of the '{@link #getExpression() <em>Expression</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getExpression()
	 * @generated
	 * @ordered
	 */
	protected String				expression			= EXPRESSION_EDEFAULT;
	
	/**
	 * The cached value of the '{@link #getTargets() <em>Targets</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getTargets()
	 * @generated
	 * @ordered
	 */
	protected EList<Identifier>		targets;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected PragmaImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.PRAGMA;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public InterfaceDefinition getInterfaceParent() {
		if (eContainerFeatureID != SmePackage.PRAGMA__INTERFACE_PARENT)
			return null;
		return (InterfaceDefinition) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetInterfaceParent(InterfaceDefinition newInterfaceParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newInterfaceParent, SmePackage.PRAGMA__INTERFACE_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setInterfaceParent(InterfaceDefinition newInterfaceParent) {
		if (newInterfaceParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.PRAGMA__INTERFACE_PARENT && newInterfaceParent != null)) {
			if (EcoreUtil.isAncestor(this, newInterfaceParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInterfaceParent != null)
				msgs = ((InternalEObject) newInterfaceParent).eInverseAdd(this,
					SmePackage.INTERFACE_DEFINITION__PRAGMAS, InterfaceDefinition.class, msgs);
			msgs = basicSetInterfaceParent(newInterfaceParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.PRAGMA__INTERFACE_PARENT,
				newInterfaceParent, newInterfaceParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Module getModuleParent() {
		if (eContainerFeatureID != SmePackage.PRAGMA__MODULE_PARENT)
			return null;
		return (Module) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetModuleParent(Module newModuleParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newModuleParent, SmePackage.PRAGMA__MODULE_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setModuleParent(Module newModuleParent) {
		if (newModuleParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.PRAGMA__MODULE_PARENT && newModuleParent != null)) {
			if (EcoreUtil.isAncestor(this, newModuleParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newModuleParent != null)
				msgs = ((InternalEObject) newModuleParent).eInverseAdd(this, SmePackage.MODULE__PRAGMAS, Module.class,
					msgs);
			msgs = basicSetModuleParent(newModuleParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.PRAGMA__MODULE_PARENT, newModuleParent,
				newModuleParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getPragma() {
		return pragma;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setPragma(String newPragma) {
		String oldPragma = pragma;
		pragma = newPragma;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.PRAGMA__PRAGMA, oldPragma, pragma));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getExpression() {
		return expression;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setExpression(String newExpression) {
		String oldExpression = expression;
		expression = newExpression;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.PRAGMA__EXPRESSION, oldExpression,
				expression));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<Identifier> getTargets() {
		if (targets == null) {
			targets = new EObjectResolvingEList<Identifier>(Identifier.class, this, SmePackage.PRAGMA__TARGETS);
		}
		return targets;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public SignalContainer getParent() {
		SignalContainer parent = getInterfaceParent();
		if (parent != null)
			return parent;
		return getModuleParent();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.PRAGMA__INTERFACE_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetInterfaceParent((InterfaceDefinition) otherEnd, msgs);
			case SmePackage.PRAGMA__MODULE_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetModuleParent((Module) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.PRAGMA__INTERFACE_PARENT:
				return basicSetInterfaceParent(null, msgs);
			case SmePackage.PRAGMA__MODULE_PARENT:
				return basicSetModuleParent(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case SmePackage.PRAGMA__INTERFACE_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.INTERFACE_DEFINITION__PRAGMAS,
					InterfaceDefinition.class, msgs);
			case SmePackage.PRAGMA__MODULE_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.MODULE__PRAGMAS, Module.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.PRAGMA__INTERFACE_PARENT:
				return getInterfaceParent();
			case SmePackage.PRAGMA__MODULE_PARENT:
				return getModuleParent();
			case SmePackage.PRAGMA__PRAGMA:
				return getPragma();
			case SmePackage.PRAGMA__EXPRESSION:
				return getExpression();
			case SmePackage.PRAGMA__TARGETS:
				return getTargets();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.PRAGMA__INTERFACE_PARENT:
				setInterfaceParent((InterfaceDefinition) newValue);
				return;
			case SmePackage.PRAGMA__MODULE_PARENT:
				setModuleParent((Module) newValue);
				return;
			case SmePackage.PRAGMA__PRAGMA:
				setPragma((String) newValue);
				return;
			case SmePackage.PRAGMA__EXPRESSION:
				setExpression((String) newValue);
				return;
			case SmePackage.PRAGMA__TARGETS:
				getTargets().clear();
				getTargets().addAll((Collection<? extends Identifier>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.PRAGMA__INTERFACE_PARENT:
				setInterfaceParent((InterfaceDefinition) null);
				return;
			case SmePackage.PRAGMA__MODULE_PARENT:
				setModuleParent((Module) null);
				return;
			case SmePackage.PRAGMA__PRAGMA:
				setPragma(PRAGMA_EDEFAULT);
				return;
			case SmePackage.PRAGMA__EXPRESSION:
				setExpression(EXPRESSION_EDEFAULT);
				return;
			case SmePackage.PRAGMA__TARGETS:
				getTargets().clear();
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.PRAGMA__INTERFACE_PARENT:
				return getInterfaceParent() != null;
			case SmePackage.PRAGMA__MODULE_PARENT:
				return getModuleParent() != null;
			case SmePackage.PRAGMA__PRAGMA:
				return PRAGMA_EDEFAULT == null ? pragma != null : !PRAGMA_EDEFAULT.equals(pragma);
			case SmePackage.PRAGMA__EXPRESSION:
				return EXPRESSION_EDEFAULT == null ? expression != null : !EXPRESSION_EDEFAULT.equals(expression);
			case SmePackage.PRAGMA__TARGETS:
				return targets != null && !targets.isEmpty();
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (pragma: ");
		result.append(pragma);
		result.append(", expression: ");
		result.append(expression);
		result.append(')');
		return result.toString();
	}
	
	/**
	 * Return the bodyTree (which is a list of type lprag) to which is added the current pragma.
	 * 
	 * @see fr.irisa.espresso.sme.SignalElement#buildEquationsAST(int)
	 * @generated NOT
	 */
	public long buildEquationsAST(long bodyTree) {
		PKTrees API = PkPlugin.getTreeAPI();
		assert (API.oper(bodyTree) != SignalOperators.oplprag);
		
		if (pragma == null || "".equals(pragma)) {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.PRAGMA_NO_ATTRIBUTE, this);
			return PKTrees.ERROR_NODE;
		}
		long idNode = PkPlugin.getParser().parseString(Phyla.ph_ident, pragma);
		if (idNode == PKTrees.ERROR_NODE) {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.PRAGMA_INCORRECT_ATTRIBUTE, this);
			return bodyTree;
		}
		
		long targetNode;
		if (getTargets().size() == 0) {
			// The target is the container
			targetNode = API.makeNullary(SignalOperators.opnil);
		}
		else {
			targetNode = API.makeEmptyList(SignalOperators.oplopra);
			for (Identifier id : targets) {
				try {
					long node = id.getAST(null);
					if (node != PKTrees.ERROR_NODE)
						targetNode = API.post(targetNode, node);
				}
				catch (CyclicDefinitionException cde) {
					PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.CYCLE_DETECTION + cde.getElement(), cde
							.getElement());
				}
			}
			if (API.isEmpty(targetNode))
				targetNode = API.makeNullary(SignalOperators.opnil);
		}
		
		bodyTree = API.post(bodyTree, API.makeTernary(SignalOperators.opprag, idNode, targetNode, API
				.makePragmaEnonce(expression)));
		
		return bodyTree;
	}
	
	/**
	 * This operation is not supported by the Pragma model object. Call the buildEquationAST method.
	 * 
	 * @see fr.irisa.espresso.sme.SignalElement#getAST(java.util.Set)
	 * @generated NOT
	 */
	public long getAST(Set<SignalElement> path) throws CyclicDefinitionException {
		throw new UnsupportedOperationException();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#getDeclarationAST(int)
	 * @generated NOT
	 */
	public long getDeclarationAST(long declTree) {
		return declTree;
	}
	
} // PragmaImpl
