/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.irisa.espresso.sme.ConstantOrRef;
import fr.irisa.espresso.sme.Identifier;
import fr.irisa.espresso.sme.InterfaceDefinition;
import fr.irisa.espresso.sme.ModelDeclaration;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SignalOrRef;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.Specifications;
import fr.irisa.espresso.sme.TupleType;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Specifications</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.SpecificationsImpl#getInterfaceParent <em>Interface Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.SpecificationsImpl#getTypeParent <em>Type Parent</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.SpecificationsImpl#getModelDeclarations <em>Model Declarations</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class SpecificationsImpl extends ModelImpl implements Specifications {
	/**
	 * The cached value of the '{@link #getModelDeclarations() <em>Model Declarations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getModelDeclarations()
	 * @generated
	 * @ordered
	 */
	protected EList<ModelDeclaration>	modelDeclarations;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SpecificationsImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.SPECIFICATIONS;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public InterfaceDefinition getInterfaceParent() {
		if (eContainerFeatureID != SmePackage.SPECIFICATIONS__INTERFACE_PARENT)
			return null;
		return (InterfaceDefinition) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetInterfaceParent(InterfaceDefinition newInterfaceParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newInterfaceParent, SmePackage.SPECIFICATIONS__INTERFACE_PARENT,
			msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setInterfaceParent(InterfaceDefinition newInterfaceParent) {
		if (newInterfaceParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.SPECIFICATIONS__INTERFACE_PARENT && newInterfaceParent != null)) {
			if (EcoreUtil.isAncestor(this, newInterfaceParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInterfaceParent != null)
				msgs = ((InternalEObject) newInterfaceParent).eInverseAdd(this, SmePackage.INTERFACE_DEFINITION__SPEC,
					InterfaceDefinition.class, msgs);
			msgs = basicSetInterfaceParent(newInterfaceParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.SPECIFICATIONS__INTERFACE_PARENT,
				newInterfaceParent, newInterfaceParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TupleType getTypeParent() {
		if (eContainerFeatureID != SmePackage.SPECIFICATIONS__TYPE_PARENT)
			return null;
		return (TupleType) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetTypeParent(TupleType newTypeParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newTypeParent, SmePackage.SPECIFICATIONS__TYPE_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setTypeParent(TupleType newTypeParent) {
		if (newTypeParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.SPECIFICATIONS__TYPE_PARENT && newTypeParent != null)) {
			if (EcoreUtil.isAncestor(this, newTypeParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newTypeParent != null)
				msgs = ((InternalEObject) newTypeParent).eInverseAdd(this, SmePackage.TUPLE_TYPE__SPEC,
					TupleType.class, msgs);
			msgs = basicSetTypeParent(newTypeParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.SPECIFICATIONS__TYPE_PARENT,
				newTypeParent, newTypeParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList<ModelDeclaration> getModelDeclarations() {
		if (modelDeclarations == null) {
			modelDeclarations = new EObjectContainmentWithInverseEList<ModelDeclaration>(ModelDeclaration.class, this,
				SmePackage.SPECIFICATIONS__MODEL_DECLARATIONS, SmePackage.MODEL_DECLARATION__SPEC_PARENT);
		}
		return modelDeclarations;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.SPECIFICATIONS__INTERFACE_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetInterfaceParent((InterfaceDefinition) otherEnd, msgs);
			case SmePackage.SPECIFICATIONS__TYPE_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetTypeParent((TupleType) otherEnd, msgs);
			case SmePackage.SPECIFICATIONS__MODEL_DECLARATIONS:
				return ((InternalEList<InternalEObject>) (InternalEList<?>) getModelDeclarations()).basicAdd(otherEnd,
					msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.SPECIFICATIONS__INTERFACE_PARENT:
				return basicSetInterfaceParent(null, msgs);
			case SmePackage.SPECIFICATIONS__TYPE_PARENT:
				return basicSetTypeParent(null, msgs);
			case SmePackage.SPECIFICATIONS__MODEL_DECLARATIONS:
				return ((InternalEList<?>) getModelDeclarations()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case SmePackage.SPECIFICATIONS__INTERFACE_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.INTERFACE_DEFINITION__SPEC,
					InterfaceDefinition.class, msgs);
			case SmePackage.SPECIFICATIONS__TYPE_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.TUPLE_TYPE__SPEC, TupleType.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.SPECIFICATIONS__INTERFACE_PARENT:
				return getInterfaceParent();
			case SmePackage.SPECIFICATIONS__TYPE_PARENT:
				return getTypeParent();
			case SmePackage.SPECIFICATIONS__MODEL_DECLARATIONS:
				return getModelDeclarations();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.SPECIFICATIONS__INTERFACE_PARENT:
				setInterfaceParent((InterfaceDefinition) newValue);
				return;
			case SmePackage.SPECIFICATIONS__TYPE_PARENT:
				setTypeParent((TupleType) newValue);
				return;
			case SmePackage.SPECIFICATIONS__MODEL_DECLARATIONS:
				getModelDeclarations().clear();
				getModelDeclarations().addAll((Collection<? extends ModelDeclaration>) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.SPECIFICATIONS__INTERFACE_PARENT:
				setInterfaceParent((InterfaceDefinition) null);
				return;
			case SmePackage.SPECIFICATIONS__TYPE_PARENT:
				setTypeParent((TupleType) null);
				return;
			case SmePackage.SPECIFICATIONS__MODEL_DECLARATIONS:
				getModelDeclarations().clear();
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.SPECIFICATIONS__INTERFACE_PARENT:
				return getInterfaceParent() != null;
			case SmePackage.SPECIFICATIONS__TYPE_PARENT:
				return getTypeParent() != null;
			case SmePackage.SPECIFICATIONS__MODEL_DECLARATIONS:
				return modelDeclarations != null && !modelDeclarations.isEmpty();
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public SignalContainer getParent() {
		SignalContainer parent = getTypeParent();
		if (parent != null)
			return parent;
		else
			return getInterfaceParent();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ModelImpl#getVisibleConstants()
	 * @generated NOT
	 */
	public EList<ConstantOrRef> getVisibleConstants() {
		EList<ConstantOrRef> list = super.getVisibleConstants();
		
		SignalContainer parent = getParent();
		if (parent != null)
			list.addAll(parent.getVisibleConstants());
		
		return list;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ModelImpl#getVisibleModelProcesses()
	 * @generated NOT
	 */
	public EList<InterfaceDefinition> getVisibleModelProcesses() {
		EList<InterfaceDefinition> list = super.getVisibleModelProcesses();
		
		SignalContainer parent = getParent();
		if (parent != null)
			list.addAll(parent.getVisibleModelProcesses());
		
		return list;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ModelImpl#getVisibleSignals()
	 * @generated NOT
	 */
	@Override
	public EList<SignalOrRef> getVisibleSignals() {
		EList<SignalOrRef> list = super.getVisibleSignals();
		
		SignalContainer parent = getParent();
		if (parent != null)
			list.addAll(parent.getVisibleSignals());
		
		return list;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ModelImpl#getVisibleTypes()
	 * @generated NOT
	 */
	@Override
	public EList<Identifier> getVisibleTypes() {
		EList<Identifier> list = super.getVisibleTypes();
		
		SignalContainer parent = getParent();
		if (parent != null)
			list.addAll(parent.getVisibleTypes());
		
		return list;
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalContainer#getName()
	 * @generated NOT
	 */
	public String getName() {
		return "Specifications of " + getParent().getName();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.SignalElement#buildEquationsAST(int)
	 * @generated NOT
	 */
	public long buildEquationsAST(long bodyTree) {
		// the value of the parameter bodyTree is normally PKTrees.ERROR_NODE, we do not need to keep it
		assert (bodyTree == PKTrees.ERROR_NODE);
		PKTrees API = PkPlugin.getTreeAPI();
		
		long declTree = makeDeclarations(API.makeEmptyList(SignalOperators.opldecl));
		if (API.isEmpty(declTree)) {
			bodyTree = makeEquations(API.makeEmptyList(SignalOperators.oplfeed));
			if (API.isEmpty(bodyTree))
				bodyTree = API.makeNullary(SignalOperators.opnil);
		}
		else {
			bodyTree = makeEquations(API.makeEmptyList(SignalOperators.oplfeed));
			if (API.isEmpty(bodyTree))
				bodyTree = API.makeNullary(SignalOperators.opnullproc);
			bodyTree = API.makeBinary(SignalOperators.oppconf, bodyTree, declTree);
		}
		return bodyTree;
		
	}
	
	/**
	 * A Specification has no declaration, so declTree is not modified.
	 * 
	 * @see fr.irisa.espresso.sme.SignalElement#getDeclarationAST(int)
	 * @generated NOT
	 */
	public long getDeclarationAST(long declTree) {
		return declTree;
	}
	
} // SpecificationsImpl
