/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import fr.irisa.espresso.sme.Automaton;
import fr.irisa.espresso.sme.SignalContainer;
import fr.irisa.espresso.sme.SmePackage;
import fr.irisa.espresso.sme.Transition;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;
import fr.irisa.espresso.sme.polychrony.PKTrees;
import fr.irisa.espresso.sme.polychrony.Phyla;
import fr.irisa.espresso.sme.polychrony.PkPlugin;
import fr.irisa.espresso.sme.polychrony.SignalOperators;
import fr.irisa.espresso.sme.polychrony.traceability.ErrorMessages;
import fr.irisa.espresso.sme.polychrony.traceability.WarningMessages;
import fr.irisa.espresso.sme.polychrony.utils.PolychronyDiagnostic;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Transition</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.irisa.espresso.sme.impl.TransitionImpl#getGuard <em>Guard</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.TransitionImpl#getPriority <em>Priority</em>}</li>
 * <li>{@link fr.irisa.espresso.sme.impl.TransitionImpl#getAutomatonParent <em>Automaton Parent</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class TransitionImpl extends ConnectionImpl implements Transition {
	/**
	 * The default value of the '{@link #getGuard() <em>Guard</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getGuard()
	 * @generated
	 * @ordered
	 */
	protected static final String	GUARD_EDEFAULT		= null;
	
	/**
	 * The cached value of the '{@link #getGuard() <em>Guard</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see #getGuard()
	 * @generated
	 * @ordered
	 */
	protected String				guard				= GUARD_EDEFAULT;
	
	/**
	 * The default value of the '{@link #getPriority() <em>Priority</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected static final int		PRIORITY_EDEFAULT	= 0;
	
	/**
	 * The cached value of the '{@link #getPriority() <em>Priority</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected int					priority			= PRIORITY_EDEFAULT;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected TransitionImpl() {
		super();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SmePackage.Literals.TRANSITION;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getGuard() {
		return guard;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setGuard(String newGuard) {
		String oldGuard = guard;
		guard = newGuard;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.TRANSITION__GUARD, oldGuard, guard));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int getPriority() {
		return priority;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setPriority(int newPriority) {
		int oldPriority = priority;
		priority = newPriority;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.TRANSITION__PRIORITY, oldPriority,
				priority));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Automaton getAutomatonParent() {
		if (eContainerFeatureID != SmePackage.TRANSITION__AUTOMATON_PARENT)
			return null;
		return (Automaton) eContainer();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetAutomatonParent(Automaton newAutomatonParent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newAutomatonParent, SmePackage.TRANSITION__AUTOMATON_PARENT, msgs);
		return msgs;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAutomatonParent(Automaton newAutomatonParent) {
		if (newAutomatonParent != eInternalContainer()
				|| (eContainerFeatureID != SmePackage.TRANSITION__AUTOMATON_PARENT && newAutomatonParent != null)) {
			if (EcoreUtil.isAncestor(this, newAutomatonParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newAutomatonParent != null)
				msgs = ((InternalEObject) newAutomatonParent).eInverseAdd(this, SmePackage.AUTOMATON__TRANSITIONS,
					Automaton.class, msgs);
			msgs = basicSetAutomatonParent(newAutomatonParent, msgs);
			if (msgs != null)
				msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SmePackage.TRANSITION__AUTOMATON_PARENT,
				newAutomatonParent, newAutomatonParent));
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.TRANSITION__AUTOMATON_PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetAutomatonParent((Automaton) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SmePackage.TRANSITION__AUTOMATON_PARENT:
				return basicSetAutomatonParent(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case SmePackage.TRANSITION__AUTOMATON_PARENT:
				return eInternalContainer().eInverseRemove(this, SmePackage.AUTOMATON__TRANSITIONS, Automaton.class,
					msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SmePackage.TRANSITION__GUARD:
				return getGuard();
			case SmePackage.TRANSITION__PRIORITY:
				return new Integer(getPriority());
			case SmePackage.TRANSITION__AUTOMATON_PARENT:
				return getAutomatonParent();
		}
		return super.eGet(featureID, resolve, coreType);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SmePackage.TRANSITION__GUARD:
				setGuard((String) newValue);
				return;
			case SmePackage.TRANSITION__PRIORITY:
				setPriority(((Integer) newValue).intValue());
				return;
			case SmePackage.TRANSITION__AUTOMATON_PARENT:
				setAutomatonParent((Automaton) newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SmePackage.TRANSITION__GUARD:
				setGuard(GUARD_EDEFAULT);
				return;
			case SmePackage.TRANSITION__PRIORITY:
				setPriority(PRIORITY_EDEFAULT);
				return;
			case SmePackage.TRANSITION__AUTOMATON_PARENT:
				setAutomatonParent((Automaton) null);
				return;
		}
		super.eUnset(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SmePackage.TRANSITION__GUARD:
				return GUARD_EDEFAULT == null ? guard != null : !GUARD_EDEFAULT.equals(guard);
			case SmePackage.TRANSITION__PRIORITY:
				return priority != PRIORITY_EDEFAULT;
			case SmePackage.TRANSITION__AUTOMATON_PARENT:
				return getAutomatonParent() != null;
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();
		
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (guard: ");
		result.append(guard);
		result.append(", priority: ");
		result.append(priority);
		result.append(')');
		return result.toString();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public SignalContainer getParent() {
		return getAutomatonParent();
	}
	
	/**
	 * @see fr.irisa.espresso.sme.impl.ConnectionImpl#buildEquationsAST(int)
	 * @generated NOT
	 */
	// @Override
	public long buildEquationsAST1(long bodyTree, boolean bstrong) {
		if (getSource() == null || getDestination() == null) {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.TRANSITION_SOURCE_DESTINATION + name, this);
			return bodyTree;
		}
		
		PKTrees API = PkPlugin.getTreeAPI();
		
		try {
			long result = getAST(null);
			if (result != PKTrees.ERROR_NODE) {
				boolean allOk = true;
				long guardNode;
				if (guard != GUARD_EDEFAULT && "".equals(guard) == false)
					guardNode = PkPlugin.getParser().parseString(Phyla.ph_e_sign, guard);
				else {
					PolychronyDiagnostic.add(Diagnostic.WARNING, WarningMessages.TRANSITION_GUARD + name, this);
					guardNode = API.makeNullary(SignalOperators.optrue);
				}
				
				if (guardNode == PKTrees.ERROR_NODE) {
					PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.TRANSITION_INCORRECT_GUARD + name, this);
					return bodyTree;
				}
				// We use the unary when operator onto the guard to obtain an event
				guardNode = API.makeUnary(SignalOperators.opwhen1, guardNode);
				
				// The current state of the Automaton must be the source state of this transition
				long condNode = getSource().getAST(null);
				if (condNode == PKTrees.ERROR_NODE)
					return bodyTree;
				
				// Use the Name of the state as the enumerated value of the
				condNode = API.makeBinary(SignalOperators.opvenum, API.makeNullary(SignalOperators.opnil), condNode);
				
				// (LBesnard) Error : csname must be different for a weak/strong transition.
				// For a weak it is <foo>_currentState, for a strong it is <foo>_zNextState
				// fixed by adding a parameter.
				long csName;
				if (bstrong)
					csName = getAutomatonParent().getzNextStateNameAST();
				else
					csName = getAutomatonParent().getCurrentStateNameAST();
				if (csName == PKTrees.ERROR_NODE)
					return bodyTree;
				
				// Check the equality with the currentState of the parent Automaton
				condNode = API.makeBinary(SignalOperators.opegal, csName, condNode);
				guardNode = API.makeBinary(SignalOperators.opextr, guardNode, condNode);
				
				// Create the equation to define the event of the transition
				result = API.makeBinary(SignalOperators.opdefsig, result, guardNode);
				
				// otherwise ?
				if (allOk)
					bodyTree = API.post(bodyTree, result);
				
			}
		}
		catch (CyclicDefinitionException cde) {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.CYCLE_DETECTION + cde.getElement(), cde
					.getElement());
			// Normally it will not be thrown
		}
		return bodyTree;
	}
	/**
	 * @see fr.irisa.espresso.sme.impl.ConnectionImpl#getDeclarationAST(int)
	 * @generated NOT
	 */
	@Override
	public long getDeclarationAST(long declTree) {
		try {
			long idNode = getAST(null);
			if (idNode != PKTrees.ERROR_NODE) {
				PKTrees API = PkPlugin.getTreeAPI();
				// We declare an event whose name are the transition name
				declTree = API.post(declTree, API.makeBinary(SignalOperators.opdecsig, API
						.makeNullary(SignalOperators.opevent), API.makeList(SignalOperators.oplsign, idNode)));
			}
		}
		catch (CyclicDefinitionException cde) {
			PolychronyDiagnostic.add(Diagnostic.ERROR, ErrorMessages.CYCLE_DETECTION + cde.getElement(), cde
					.getElement());
			// Normally it will not be thrown
		}
		return declTree;
	}
	
} // TransitionImpl
