/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import fr.irisa.espresso.sme.*;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides an adapter <code>createXXX</code>
 * method for each class of the model. <!-- end-user-doc -->
 * 
 * @see fr.irisa.espresso.sme.SmePackage
 * @generated
 */
public class SmeAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static SmePackage	modelPackage;
	
	/**
	 * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SmeAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = SmePackage.eINSTANCE;
		}
	}
	
	/**
	 * Returns whether this factory is applicable for the type of the object. <!-- begin-user-doc --> This
	 * implementation returns <code>true</code> if the object is either the model's package or is an instance object of
	 * the model. <!-- end-user-doc -->
	 * 
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}
	
	/**
	 * The switch that delegates to the <code>createXXX</code> methods. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SmeSwitch<Adapter>	modelSwitch	= new SmeSwitch<Adapter>() {
													@Override
													public Adapter caseSignalElement(SignalElement object) {
														return createSignalElementAdapter();
													}
													@Override
													public Adapter caseRootModel(RootModel object) {
														return createRootModelAdapter();
													}
													@Override
													public Adapter caseConnectableElement(ConnectableElement object) {
														return createConnectableElementAdapter();
													}
													@Override
													public Adapter caseNamedElement(NamedElement object) {
														return createNamedElementAdapter();
													}
													@Override
													public Adapter caseIdentifier(Identifier object) {
														return createIdentifierAdapter();
													}
													@Override
													public Adapter caseSignalExpr(SignalExpr object) {
														return createSignalExprAdapter();
													}
													@Override
													public Adapter caseConstantExpr(ConstantExpr object) {
														return createConstantExprAdapter();
													}
													@Override
													public Adapter caseClockedExpr(ClockedExpr object) {
														return createClockedExprAdapter();
													}
													@Override
													public Adapter caseDependenceInOut(DependenceInOut object) {
														return createDependenceInOutAdapter();
													}
													@Override
													public Adapter caseSignalContainer(SignalContainer object) {
														return createSignalContainerAdapter();
													}
													@Override
													public Adapter caseInterfaceDefinition(InterfaceDefinition object) {
														return createInterfaceDefinitionAdapter();
													}
													@Override
													public Adapter caseModel(Model object) {
														return createModelAdapter();
													}
													@Override
													public Adapter caseBasicIterate(BasicIterate object) {
														return createBasicIterateAdapter();
													}
													@Override
													public Adapter caseIterate(Iterate object) {
														return createIterateAdapter();
													}
													@Override
													public Adapter caseIterationInit(IterationInit object) {
														return createIterationInitAdapter();
													}
													@Override
													public Adapter caseSpecifications(Specifications object) {
														return createSpecificationsAdapter();
													}
													@Override
													public Adapter caseSubProcess(SubProcess object) {
														return createSubProcessAdapter();
													}
													@Override
													public Adapter caseTypeDeclaration(TypeDeclaration object) {
														return createTypeDeclarationAdapter();
													}
													@Override
													public Adapter caseParameterType(ParameterType object) {
														return createParameterTypeAdapter();
													}
													@Override
													public Adapter caseSignalType(SignalType object) {
														return createSignalTypeAdapter();
													}
													@Override
													public Adapter caseEnumerationType(EnumerationType object) {
														return createEnumerationTypeAdapter();
													}
													@Override
													public Adapter caseModelType(ModelType object) {
														return createModelTypeAdapter();
													}
													@Override
													public Adapter caseSubstitutionType(SubstitutionType object) {
														return createSubstitutionTypeAdapter();
													}
													@Override
													public Adapter caseTupleType(TupleType object) {
														return createTupleTypeAdapter();
													}
													@Override
													public Adapter caseModelDeclaration(ModelDeclaration object) {
														return createModelDeclarationAdapter();
													}
													@Override
													public Adapter caseModelRef(ModelRef object) {
														return createModelRefAdapter();
													}
													@Override
													public Adapter caseModelInstance(ModelInstance object) {
														return createModelInstanceAdapter();
													}
													@Override
													public Adapter caseModule(Module object) {
														return createModuleAdapter();
													}
													@Override
													public Adapter caseUseModule(UseModule object) {
														return createUseModuleAdapter();
													}
													@Override
													public Adapter caseDataflowConnector(DataflowConnector object) {
														return createDataflowConnectorAdapter();
													}
													@Override
													public Adapter caseConstantOrRef(ConstantOrRef object) {
														return createConstantOrRefAdapter();
													}
													@Override
													public Adapter caseConstantRef(ConstantRef object) {
														return createConstantRefAdapter();
													}
													@Override
													public Adapter caseConstant(Constant object) {
														return createConstantAdapter();
													}
													@Override
													public Adapter caseConstantValue(ConstantValue object) {
														return createConstantValueAdapter();
													}
													@Override
													public Adapter caseLiteral(Literal object) {
														return createLiteralAdapter();
													}
													@Override
													public Adapter caseEnumerationValue(EnumerationValue object) {
														return createEnumerationValueAdapter();
													}
													@Override
													public Adapter caseParameter(Parameter object) {
														return createParameterAdapter();
													}
													@Override
													public Adapter caseParameterInstance(ParameterInstance object) {
														return createParameterInstanceAdapter();
													}
													@Override
													public Adapter caseIterator(Iterator object) {
														return createIteratorAdapter();
													}
													@Override
													public Adapter caseIndex(Index object) {
														return createIndexAdapter();
													}
													@Override
													public Adapter caseSignalOrRef(SignalOrRef object) {
														return createSignalOrRefAdapter();
													}
													@Override
													public Adapter caseSignalRef(SignalRef object) {
														return createSignalRefAdapter();
													}
													@Override
													public Adapter caseSignal(Signal object) {
														return createSignalAdapter();
													}
													@Override
													public Adapter caseInput(Input object) {
														return createInputAdapter();
													}
													@Override
													public Adapter caseInputInstance(InputInstance object) {
														return createInputInstanceAdapter();
													}
													@Override
													public Adapter caseOutput(Output object) {
														return createOutputAdapter();
													}
													@Override
													public Adapter caseOutputInstance(OutputInstance object) {
														return createOutputInstanceAdapter();
													}
													@Override
													public Adapter caseLocal(Local object) {
														return createLocalAdapter();
													}
													@Override
													public Adapter caseConnection(Connection object) {
														return createConnectionAdapter();
													}
													@Override
													public Adapter caseModelConnection(ModelConnection object) {
														return createModelConnectionAdapter();
													}
													@Override
													public Adapter caseCaseConnection(CaseConnection object) {
														return createCaseConnectionAdapter();
													}
													@Override
													public Adapter caseClockRelation(ClockRelation object) {
														return createClockRelationAdapter();
													}
													@Override
													public Adapter caseCondition(Condition object) {
														return createConditionAdapter();
													}
													@Override
													public Adapter caseConstantAffectation(ConstantAffectation object) {
														return createConstantAffectationAdapter();
													}
													@Override
													public Adapter caseDataflowConnection(DataflowConnection object) {
														return createDataflowConnectionAdapter();
													}
													@Override
													public Adapter caseDependence(Dependence object) {
														return createDependenceAdapter();
													}
													@Override
													public Adapter caseOperatorPort(OperatorPort object) {
														return createOperatorPortAdapter();
													}
													@Override
													public Adapter caseInputPort(InputPort object) {
														return createInputPortAdapter();
													}
													@Override
													public Adapter caseOutputPort(OutputPort object) {
														return createOutputPortAdapter();
													}
													@Override
													public Adapter caseSignalOperator(SignalOperator object) {
														return createSignalOperatorAdapter();
													}
													@Override
													public Adapter caseConditionExpr(ConditionExpr object) {
														return createConditionExprAdapter();
													}
													@Override
													public Adapter caseConditionnedExpr(ConditionnedExpr object) {
														return createConditionnedExprAdapter();
													}
													@Override
													public Adapter caseControlflowOperator(ControlflowOperator object) {
														return createControlflowOperatorAdapter();
													}
													@Override
													public Adapter caseDataflowOperator(DataflowOperator object) {
														return createDataflowOperatorAdapter();
													}
													@Override
													public Adapter caseBooleanOperatorI(BooleanOperatorI object) {
														return createBooleanOperatorIAdapter();
													}
													@Override
													public Adapter caseNumericOperatorI(NumericOperatorI object) {
														return createNumericOperatorIAdapter();
													}
													@Override
													public Adapter caseSingleInputOperator(SingleInputOperator object) {
														return createSingleInputOperatorAdapter();
													}
													@Override
													public Adapter caseTwoInputsOperator(TwoInputsOperator object) {
														return createTwoInputsOperatorAdapter();
													}
													@Override
													public Adapter caseMultipleInputsOperator(
															MultipleInputsOperator object) {
														return createMultipleInputsOperatorAdapter();
													}
													@Override
													public Adapter caseAnd(And object) {
														return createAndAdapter();
													}
													@Override
													public Adapter caseArithmeticOperator(ArithmeticOperator object) {
														return createArithmeticOperatorAdapter();
													}
													@Override
													public Adapter caseArrayEnumeration(ArrayEnumeration object) {
														return createArrayEnumerationAdapter();
													}
													@Override
													public Adapter caseArrayProduct(ArrayProduct object) {
														return createArrayProductAdapter();
													}
													@Override
													public Adapter caseArrayRecovery(ArrayRecovery object) {
														return createArrayRecoveryAdapter();
													}
													@Override
													public Adapter caseArrayRestructuration(ArrayRestructuration object) {
														return createArrayRestructurationAdapter();
													}
													@Override
													public Adapter caseAssertion(Assertion object) {
														return createAssertionAdapter();
													}
													@Override
													public Adapter caseAssertionClockConstraintOperator(
															AssertionClockConstraintOperator object) {
														return createAssertionClockConstraintOperatorAdapter();
													}
													@Override
													public Adapter caseAssertionClockSpeedOperator(
															AssertionClockSpeedOperator object) {
														return createAssertionClockSpeedOperatorAdapter();
													}
													@Override
													public Adapter caseBooleanExpression(BooleanExpression object) {
														return createBooleanExpressionAdapter();
													}
													@Override
													public Adapter caseCartesianProduct(CartesianProduct object) {
														return createCartesianProductAdapter();
													}
													@Override
													public Adapter caseCell(Cell object) {
														return createCellAdapter();
													}
													@Override
													public Adapter caseClockConstraintOperator(
															ClockConstraintOperator object) {
														return createClockConstraintOperatorAdapter();
													}
													@Override
													public Adapter caseClockRelationOperator(
															ClockRelationOperator object) {
														return createClockRelationOperatorAdapter();
													}
													@Override
													public Adapter caseClockSpeedOperator(ClockSpeedOperator object) {
														return createClockSpeedOperatorAdapter();
													}
													@Override
													public Adapter caseComparisonOperator(ComparisonOperator object) {
														return createComparisonOperatorAdapter();
													}
													@Override
													public Adapter caseComplexOperator(ComplexOperator object) {
														return createComplexOperatorAdapter();
													}
													@Override
													public Adapter caseConcatenation(Concatenation object) {
														return createConcatenationAdapter();
													}
													@Override
													public Adapter caseCounter(Counter object) {
														return createCounterAdapter();
													}
													@Override
													public Adapter caseDelay(Delay object) {
														return createDelayAdapter();
													}
													@Override
													public Adapter caseDependenceOperator(DependenceOperator object) {
														return createDependenceOperatorAdapter();
													}
													@Override
													public Adapter caseExtraction(Extraction object) {
														return createExtractionAdapter();
													}
													@Override
													public Adapter caseIfThenElse(IfThenElse object) {
														return createIfThenElseAdapter();
													}
													@Override
													public Adapter caseMerge(Merge object) {
														return createMergeAdapter();
													}
													@Override
													public Adapter caseNot(Not object) {
														return createNotAdapter();
													}
													@Override
													public Adapter caseNullClock(NullClock object) {
														return createNullClockAdapter();
													}
													@Override
													public Adapter caseNumericExpression(NumericExpression object) {
														return createNumericExpressionAdapter();
													}
													@Override
													public Adapter caseOr(Or object) {
														return createOrAdapter();
													}
													@Override
													public Adapter casePragma(Pragma object) {
														return createPragmaAdapter();
													}
													@Override
													public Adapter caseRepetitionOperator(RepetitionOperator object) {
														return createRepetitionOperatorAdapter();
													}
													@Override
													public Adapter caseSequentialDefinition(SequentialDefinition object) {
														return createSequentialDefinitionAdapter();
													}
													@Override
													public Adapter caseSwitch(Switch object) {
														return createSwitchAdapter();
													}
													@Override
													public Adapter caseTransposition(Transposition object) {
														return createTranspositionAdapter();
													}
													@Override
													public Adapter caseTupleOperator(TupleOperator object) {
														return createTupleOperatorAdapter();
													}
													@Override
													public Adapter caseUnaryMinus(UnaryMinus object) {
														return createUnaryMinusAdapter();
													}
													@Override
													public Adapter caseVariable(Variable object) {
														return createVariableAdapter();
													}
													@Override
													public Adapter caseWindow(Window object) {
														return createWindowAdapter();
													}
													@Override
													public Adapter caseXor(Xor object) {
														return createXorAdapter();
													}
													@Override
													public Adapter caseStateOrHistory(StateOrHistory object) {
														return createStateOrHistoryAdapter();
													}
													@Override
													public Adapter caseHistory(History object) {
														return createHistoryAdapter();
													}
													@Override
													public Adapter caseStateBase(StateBase object) {
														return createStateBaseAdapter();
													}
													@Override
													public Adapter caseState(State object) {
														return createStateAdapter();
													}
													@Override
													public Adapter caseCompoundState(CompoundState object) {
														return createCompoundStateAdapter();
													}
													@Override
													public Adapter caseAutomaton(Automaton object) {
														return createAutomatonAdapter();
													}
													@Override
													public Adapter caseAndState(AndState object) {
														return createAndStateAdapter();
													}
													@Override
													public Adapter caseTransition(Transition object) {
														return createTransitionAdapter();
													}
													@Override
													public Adapter caseWeakTransition(WeakTransition object) {
														return createWeakTransitionAdapter();
													}
													@Override
													public Adapter caseStrongTransition(StrongTransition object) {
														return createStrongTransitionAdapter();
													}
													@Override
													public Adapter defaultCase(EObject object) {
														return createEObjectAdapter();
													}
												};
	
	/**
	 * Creates an adapter for the <code>target</code>. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param target
	 *        the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject) target);
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.RootModel <em>Root Model</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.RootModel
	 * @generated
	 */
	public Adapter createRootModelAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SignalElement <em>Signal Element</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SignalElement
	 * @generated
	 */
	public Adapter createSignalElementAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ConnectableElement
	 * <em>Connectable Element</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ConnectableElement
	 * @generated
	 */
	public Adapter createConnectableElementAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.NamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.NamedElement
	 * @generated
	 */
	public Adapter createNamedElementAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Identifier <em>Identifier</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Identifier
	 * @generated
	 */
	public Adapter createIdentifierAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SignalExpr <em>Signal Expr</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SignalExpr
	 * @generated
	 */
	public Adapter createSignalExprAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ConstantExpr <em>Constant Expr</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ConstantExpr
	 * @generated
	 */
	public Adapter createConstantExprAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ClockedExpr <em>Clocked Expr</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ClockedExpr
	 * @generated
	 */
	public Adapter createClockedExprAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.DependenceInOut
	 * <em>Dependence In Out</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.DependenceInOut
	 * @generated
	 */
	public Adapter createDependenceInOutAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SignalContainer
	 * <em>Signal Container</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SignalContainer
	 * @generated
	 */
	public Adapter createSignalContainerAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.InterfaceDefinition
	 * <em>Interface Definition</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition
	 * @generated
	 */
	public Adapter createInterfaceDefinitionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Model <em>Model</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Model
	 * @generated
	 */
	public Adapter createModelAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.BasicIterate <em>Basic Iterate</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.BasicIterate
	 * @generated
	 */
	public Adapter createBasicIterateAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Iterate <em>Iterate</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Iterate
	 * @generated
	 */
	public Adapter createIterateAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.IterationInit <em>Iteration Init</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.IterationInit
	 * @generated
	 */
	public Adapter createIterationInitAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Specifications
	 * <em>Specifications</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can easily
	 * ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Specifications
	 * @generated
	 */
	public Adapter createSpecificationsAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SubProcess <em>Sub Process</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SubProcess
	 * @generated
	 */
	public Adapter createSubProcessAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.TypeDeclaration
	 * <em>Type Declaration</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.TypeDeclaration
	 * @generated
	 */
	public Adapter createTypeDeclarationAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ParameterType <em>Parameter Type</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ParameterType
	 * @generated
	 */
	public Adapter createParameterTypeAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SignalType <em>Signal Type</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SignalType
	 * @generated
	 */
	public Adapter createSignalTypeAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.EnumerationType
	 * <em>Enumeration Type</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.EnumerationType
	 * @generated
	 */
	public Adapter createEnumerationTypeAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ModelType <em>Model Type</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ModelType
	 * @generated
	 */
	public Adapter createModelTypeAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SubstitutionType
	 * <em>Substitution Type</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SubstitutionType
	 * @generated
	 */
	public Adapter createSubstitutionTypeAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.TupleType <em>Tuple Type</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.TupleType
	 * @generated
	 */
	public Adapter createTupleTypeAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ModelDeclaration
	 * <em>Model Declaration</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ModelDeclaration
	 * @generated
	 */
	public Adapter createModelDeclarationAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ModelRef <em>Model Ref</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ModelRef
	 * @generated
	 */
	public Adapter createModelRefAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ModelInstance <em>Model Instance</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ModelInstance
	 * @generated
	 */
	public Adapter createModelInstanceAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Module <em>Module</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Module
	 * @generated
	 */
	public Adapter createModuleAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.UseModule <em>Use Module</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.UseModule
	 * @generated
	 */
	public Adapter createUseModuleAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.DataflowConnector
	 * <em>Dataflow Connector</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.DataflowConnector
	 * @generated
	 */
	public Adapter createDataflowConnectorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ConstantOrRef
	 * <em>Constant Or Ref</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ConstantOrRef
	 * @generated
	 */
	public Adapter createConstantOrRefAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ConstantRef <em>Constant Ref</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ConstantRef
	 * @generated
	 */
	public Adapter createConstantRefAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Constant <em>Constant</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Constant
	 * @generated
	 */
	public Adapter createConstantAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ConstantValue <em>Constant Value</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ConstantValue
	 * @generated
	 */
	public Adapter createConstantValueAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Literal <em>Literal</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Literal
	 * @generated
	 */
	public Adapter createLiteralAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.EnumerationValue
	 * <em>Enumeration Value</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.EnumerationValue
	 * @generated
	 */
	public Adapter createEnumerationValueAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Parameter <em>Parameter</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Parameter
	 * @generated
	 */
	public Adapter createParameterAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ParameterInstance
	 * <em>Parameter Instance</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ParameterInstance
	 * @generated
	 */
	public Adapter createParameterInstanceAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Iterator <em>Iterator</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Iterator
	 * @generated
	 */
	public Adapter createIteratorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Index <em>Index</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Index
	 * @generated
	 */
	public Adapter createIndexAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SignalOrRef <em>Signal Or Ref</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SignalOrRef
	 * @generated
	 */
	public Adapter createSignalOrRefAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SignalRef <em>Signal Ref</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SignalRef
	 * @generated
	 */
	public Adapter createSignalRefAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Signal <em>Signal</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Signal
	 * @generated
	 */
	public Adapter createSignalAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Input <em>Input</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Input
	 * @generated
	 */
	public Adapter createInputAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.InputInstance <em>Input Instance</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.InputInstance
	 * @generated
	 */
	public Adapter createInputInstanceAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Output <em>Output</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Output
	 * @generated
	 */
	public Adapter createOutputAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.OutputInstance
	 * <em>Output Instance</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.OutputInstance
	 * @generated
	 */
	public Adapter createOutputInstanceAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Local <em>Local</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Local
	 * @generated
	 */
	public Adapter createLocalAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Connection <em>Connection</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Connection
	 * @generated
	 */
	public Adapter createConnectionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ModelConnection
	 * <em>Model Connection</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ModelConnection
	 * @generated
	 */
	public Adapter createModelConnectionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.CaseConnection
	 * <em>Case Connection</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.CaseConnection
	 * @generated
	 */
	public Adapter createCaseConnectionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ClockRelation <em>Clock Relation</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ClockRelation
	 * @generated
	 */
	public Adapter createClockRelationAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Condition <em>Condition</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Condition
	 * @generated
	 */
	public Adapter createConditionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ConstantAffectation
	 * <em>Constant Affectation</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ConstantAffectation
	 * @generated
	 */
	public Adapter createConstantAffectationAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Dependence <em>Dependence</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Dependence
	 * @generated
	 */
	public Adapter createDependenceAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.DataflowConnection
	 * <em>Dataflow Connection</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.DataflowConnection
	 * @generated
	 */
	public Adapter createDataflowConnectionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.OperatorPort <em>Operator Port</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.OperatorPort
	 * @generated
	 */
	public Adapter createOperatorPortAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.InputPort <em>Input Port</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.InputPort
	 * @generated
	 */
	public Adapter createInputPortAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.OutputPort <em>Output Port</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.OutputPort
	 * @generated
	 */
	public Adapter createOutputPortAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SignalOperator
	 * <em>Signal Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SignalOperator
	 * @generated
	 */
	public Adapter createSignalOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ConditionExpr <em>Condition Expr</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ConditionExpr
	 * @generated
	 */
	public Adapter createConditionExprAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ConditionnedExpr
	 * <em>Conditionned Expr</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ConditionnedExpr
	 * @generated
	 */
	public Adapter createConditionnedExprAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ControlflowOperator
	 * <em>Controlflow Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ControlflowOperator
	 * @generated
	 */
	public Adapter createControlflowOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.DataflowOperator
	 * <em>Dataflow Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.DataflowOperator
	 * @generated
	 */
	public Adapter createDataflowOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.BooleanOperatorI
	 * <em>Boolean Operator I</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.BooleanOperatorI
	 * @generated
	 */
	public Adapter createBooleanOperatorIAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.NumericOperatorI
	 * <em>Numeric Operator I</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.NumericOperatorI
	 * @generated
	 */
	public Adapter createNumericOperatorIAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SingleInputOperator
	 * <em>Single Input Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SingleInputOperator
	 * @generated
	 */
	public Adapter createSingleInputOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.TwoInputsOperator
	 * <em>Two Inputs Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.TwoInputsOperator
	 * @generated
	 */
	public Adapter createTwoInputsOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.MultipleInputsOperator
	 * <em>Multiple Inputs Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.MultipleInputsOperator
	 * @generated
	 */
	public Adapter createMultipleInputsOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.And <em>And</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.And
	 * @generated
	 */
	public Adapter createAndAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ArithmeticOperator
	 * <em>Arithmetic Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ArithmeticOperator
	 * @generated
	 */
	public Adapter createArithmeticOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ArrayEnumeration
	 * <em>Array Enumeration</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ArrayEnumeration
	 * @generated
	 */
	public Adapter createArrayEnumerationAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ArrayProduct <em>Array Product</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ArrayProduct
	 * @generated
	 */
	public Adapter createArrayProductAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ArrayRecovery <em>Array Recovery</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ArrayRecovery
	 * @generated
	 */
	public Adapter createArrayRecoveryAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ArrayRestructuration
	 * <em>Array Restructuration</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ArrayRestructuration
	 * @generated
	 */
	public Adapter createArrayRestructurationAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Assertion <em>Assertion</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Assertion
	 * @generated
	 */
	public Adapter createAssertionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.AssertionClockConstraintOperator
	 * <em>Assertion Clock Constraint Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null
	 * so that we can easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases
	 * anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.AssertionClockConstraintOperator
	 * @generated
	 */
	public Adapter createAssertionClockConstraintOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.AssertionClockSpeedOperator
	 * <em>Assertion Clock Speed Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so
	 * that we can easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.AssertionClockSpeedOperator
	 * @generated
	 */
	public Adapter createAssertionClockSpeedOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.BooleanExpression
	 * <em>Boolean Expression</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.BooleanExpression
	 * @generated
	 */
	public Adapter createBooleanExpressionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.CartesianProduct
	 * <em>Cartesian Product</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.CartesianProduct
	 * @generated
	 */
	public Adapter createCartesianProductAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Cell <em>Cell</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Cell
	 * @generated
	 */
	public Adapter createCellAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ClockConstraintOperator
	 * <em>Clock Constraint Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ClockConstraintOperator
	 * @generated
	 */
	public Adapter createClockConstraintOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ClockRelationOperator
	 * <em>Clock Relation Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ClockRelationOperator
	 * @generated
	 */
	public Adapter createClockRelationOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ClockSpeedOperator
	 * <em>Clock Speed Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ClockSpeedOperator
	 * @generated
	 */
	public Adapter createClockSpeedOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ComparisonOperator
	 * <em>Comparison Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ComparisonOperator
	 * @generated
	 */
	public Adapter createComparisonOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.ComplexOperator
	 * <em>Complex Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.ComplexOperator
	 * @generated
	 */
	public Adapter createComplexOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Concatenation <em>Concatenation</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Concatenation
	 * @generated
	 */
	public Adapter createConcatenationAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Counter <em>Counter</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Counter
	 * @generated
	 */
	public Adapter createCounterAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Delay <em>Delay</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Delay
	 * @generated
	 */
	public Adapter createDelayAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.DependenceOperator
	 * <em>Dependence Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.DependenceOperator
	 * @generated
	 */
	public Adapter createDependenceOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Extraction <em>Extraction</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Extraction
	 * @generated
	 */
	public Adapter createExtractionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.IfThenElse <em>If Then Else</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.IfThenElse
	 * @generated
	 */
	public Adapter createIfThenElseAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Merge <em>Merge</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Merge
	 * @generated
	 */
	public Adapter createMergeAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Not <em>Not</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Not
	 * @generated
	 */
	public Adapter createNotAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.NullClock <em>Null Clock</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.NullClock
	 * @generated
	 */
	public Adapter createNullClockAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.NumericExpression
	 * <em>Numeric Expression</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.NumericExpression
	 * @generated
	 */
	public Adapter createNumericExpressionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Or <em>Or</em>}'. <!-- begin-user-doc
	 * --> This default implementation returns null so that we can easily ignore cases; it's useful to ignore a case
	 * when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Or
	 * @generated
	 */
	public Adapter createOrAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Pragma <em>Pragma</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Pragma
	 * @generated
	 */
	public Adapter createPragmaAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.RepetitionOperator
	 * <em>Repetition Operator</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.RepetitionOperator
	 * @generated
	 */
	public Adapter createRepetitionOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.SequentialDefinition
	 * <em>Sequential Definition</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.SequentialDefinition
	 * @generated
	 */
	public Adapter createSequentialDefinitionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Switch <em>Switch</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Switch
	 * @generated
	 */
	public Adapter createSwitchAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Transposition <em>Transposition</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Transposition
	 * @generated
	 */
	public Adapter createTranspositionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.TupleOperator <em>Tuple Operator</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.TupleOperator
	 * @generated
	 */
	public Adapter createTupleOperatorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.UnaryMinus <em>Unary Minus</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
	 * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.UnaryMinus
	 * @generated
	 */
	public Adapter createUnaryMinusAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Variable <em>Variable</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Variable
	 * @generated
	 */
	public Adapter createVariableAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Window <em>Window</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Window
	 * @generated
	 */
	public Adapter createWindowAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Xor <em>Xor</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Xor
	 * @generated
	 */
	public Adapter createXorAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.StateOrHistory
	 * <em>State Or History</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.StateOrHistory
	 * @generated
	 */
	public Adapter createStateOrHistoryAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.History <em>History</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.History
	 * @generated
	 */
	public Adapter createHistoryAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.StateBase <em>State Base</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.StateBase
	 * @generated
	 */
	public Adapter createStateBaseAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.State <em>State</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.State
	 * @generated
	 */
	public Adapter createStateAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.CompoundState <em>Compound State</em>}
	 * '. <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.CompoundState
	 * @generated
	 */
	public Adapter createCompoundStateAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Automaton <em>Automaton</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Automaton
	 * @generated
	 */
	public Adapter createAutomatonAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.AndState <em>And State</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.AndState
	 * @generated
	 */
	public Adapter createAndStateAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.Transition <em>Transition</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
	 * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.Transition
	 * @generated
	 */
	public Adapter createTransitionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.WeakTransition
	 * <em>Weak Transition</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.WeakTransition
	 * @generated
	 */
	public Adapter createWeakTransitionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for an object of class '{@link fr.irisa.espresso.sme.StrongTransition
	 * <em>Strong Transition</em>}'. <!-- begin-user-doc --> This default implementation returns null so that we can
	 * easily ignore cases; it's useful to ignore a case when inheritance will catch all the cases anyway. <!--
	 * end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.irisa.espresso.sme.StrongTransition
	 * @generated
	 */
	public Adapter createStrongTransitionAdapter() {
		return null;
	}
	
	/**
	 * Creates a new adapter for the default case. <!-- begin-user-doc --> This default implementation returns null.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}
	
} // SmeAdapterFactory
