/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * 
 * @see fr.irisa.espresso.sme.SmeFactory
 * @model kind="package" annotation="http://www.topcased.org/uuid uuid='_1_AnwO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface SmePackage extends EPackage {
	/**
	 * The package name. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String		eNAME														= "sme";
	
	/**
	 * The package namespace URI. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String		eNS_URI														= "http://www.irisa.fr/espresso/sme.ecore";
	
	/**
	 * The package namespace name. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String		eNS_PREFIX													= "sme";
	
	/**
	 * The singleton instance of the package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	SmePackage	eINSTANCE													= fr.irisa.espresso.sme.impl.SmePackageImpl
																					.init();
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.RootModel <em>Root Model</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.RootModel
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getRootModel()
	 * @generated
	 */
	int			ROOT_MODEL													= 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.SignalElement <em>Signal Element</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalElement
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalElement()
	 * @generated
	 */
	int			SIGNAL_ELEMENT												= 0;
	
	/**
	 * The number of structural features of the '<em>Signal Element</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_ELEMENT_FEATURE_COUNT								= 0;
	
	/**
	 * The number of structural features of the '<em>Root Model</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ROOT_MODEL_FEATURE_COUNT									= SIGNAL_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ConnectableElement <em>Connectable Element</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ConnectableElement
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConnectableElement()
	 * @generated
	 */
	int			CONNECTABLE_ELEMENT											= 2;
	
	/**
	 * The number of structural features of the '<em>Connectable Element</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONNECTABLE_ELEMENT_FEATURE_COUNT							= SIGNAL_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.NamedElement <em>Named Element</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.NamedElement
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNamedElement()
	 * @generated
	 */
	int			NAMED_ELEMENT												= 3;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NAMED_ELEMENT__NAME											= SIGNAL_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Named Element</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NAMED_ELEMENT_FEATURE_COUNT									= SIGNAL_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.IdentifierImpl <em>Identifier</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.IdentifierImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIdentifier()
	 * @generated
	 */
	int			IDENTIFIER													= 4;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IDENTIFIER__NAME											= NAMED_ELEMENT__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IDENTIFIER__COMMENT											= NAMED_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Identifier</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IDENTIFIER_FEATURE_COUNT									= NAMED_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.SignalExpr <em>Signal Expr</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalExpr
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalExpr()
	 * @generated
	 */
	int			SIGNAL_EXPR													= 5;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS						= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Signal Expr</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_EXPR_FEATURE_COUNT									= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ConstantExpr <em>Constant Expr</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ConstantExpr
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantExpr()
	 * @generated
	 */
	int			CONSTANT_EXPR												= 6;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_EXPR__SRC_CONSTANT_AFFECTATIONS					= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Constant Expr</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_EXPR_FEATURE_COUNT									= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ClockedExpr <em>Clocked Expr</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ClockedExpr
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockedExpr()
	 * @generated
	 */
	int			CLOCKED_EXPR												= 7;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCKED_EXPR__SRC_CLOCK_RELATIONS							= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCKED_EXPR__DST_CLOCK_RELATIONS							= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Clocked Expr</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCKED_EXPR_FEATURE_COUNT									= CONNECTABLE_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.DependenceInOut <em>Dependence In Out</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.DependenceInOut
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDependenceInOut()
	 * @generated
	 */
	int			DEPENDENCE_IN_OUT											= 8;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_IN_OUT__SRC_DEPENDENCES							= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_IN_OUT__DST_DEPENDENCES							= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Dependence In Out</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_IN_OUT_FEATURE_COUNT								= CONNECTABLE_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.SignalContainer <em>Signal Container</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalContainer
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalContainer()
	 * @generated
	 */
	int			SIGNAL_CONTAINER											= 9;
	
	/**
	 * The number of structural features of the '<em>Signal Container</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_CONTAINER_FEATURE_COUNT								= SIGNAL_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.InterfaceDefinition <em>Interface Definition</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.InterfaceDefinition
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getInterfaceDefinition()
	 * @generated
	 */
	int			INTERFACE_DEFINITION										= 10;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INTERFACE_DEFINITION__TYPE									= SIGNAL_CONTAINER_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Inputs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INTERFACE_DEFINITION__INPUTS								= SIGNAL_CONTAINER_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Outputs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INTERFACE_DEFINITION__OUTPUTS								= SIGNAL_CONTAINER_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INTERFACE_DEFINITION__PARAMETERS							= SIGNAL_CONTAINER_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Spec</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INTERFACE_DEFINITION__SPEC									= SIGNAL_CONTAINER_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Pragmas</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INTERFACE_DEFINITION__PRAGMAS								= SIGNAL_CONTAINER_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Process Class</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INTERFACE_DEFINITION__PROCESS_CLASS							= SIGNAL_CONTAINER_FEATURE_COUNT + 6;
	
	/**
	 * The number of structural features of the '<em>Interface Definition</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INTERFACE_DEFINITION_FEATURE_COUNT							= SIGNAL_CONTAINER_FEATURE_COUNT + 7;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ModelImpl <em>Model</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ModelImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModel()
	 * @generated
	 */
	int			MODEL														= 11;
	
	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__ASSERTIONS											= SIGNAL_CONTAINER_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Automata</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__AUTOMATA												= SIGNAL_CONTAINER_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__CONNECTIONS											= SIGNAL_CONTAINER_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Constant Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__CONSTANT_REF											= SIGNAL_CONTAINER_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__CONSTANTS											= SIGNAL_CONTAINER_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__CONSTRAINTS											= SIGNAL_CONTAINER_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Indexes</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__INDEXES												= SIGNAL_CONTAINER_FEATURE_COUNT + 6;
	
	/**
	 * The feature id for the '<em><b>Contained Instances</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__CONTAINED_INSTANCES									= SIGNAL_CONTAINER_FEATURE_COUNT + 7;
	
	/**
	 * The feature id for the '<em><b>Literals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__LITERALS												= SIGNAL_CONTAINER_FEATURE_COUNT + 8;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__LOCALS												= SIGNAL_CONTAINER_FEATURE_COUNT + 9;
	
	/**
	 * The feature id for the '<em><b>Operators</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__OPERATORS											= SIGNAL_CONTAINER_FEATURE_COUNT + 10;
	
	/**
	 * The feature id for the '<em><b>Signal Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__SIGNAL_REF											= SIGNAL_CONTAINER_FEATURE_COUNT + 11;
	
	/**
	 * The feature id for the '<em><b>Subprocesses</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__SUBPROCESSES											= SIGNAL_CONTAINER_FEATURE_COUNT + 12;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__TYPES												= SIGNAL_CONTAINER_FEATURE_COUNT + 13;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__USE_MODULE											= SIGNAL_CONTAINER_FEATURE_COUNT + 14;
	
	/**
	 * The feature id for the '<em><b>Model Refs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL__MODEL_REFS											= SIGNAL_CONTAINER_FEATURE_COUNT + 15;
	
	/**
	 * The number of structural features of the '<em>Model</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_FEATURE_COUNT											= SIGNAL_CONTAINER_FEATURE_COUNT + 16;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.SubProcessImpl <em>Sub Process</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.SubProcessImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSubProcess()
	 * @generated
	 */
	int			SUB_PROCESS													= 16;
	
	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__ASSERTIONS										= MODEL__ASSERTIONS;
	
	/**
	 * The feature id for the '<em><b>Automata</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__AUTOMATA										= MODEL__AUTOMATA;
	
	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__CONNECTIONS									= MODEL__CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Constant Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__CONSTANT_REF									= MODEL__CONSTANT_REF;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__CONSTANTS										= MODEL__CONSTANTS;
	
	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__CONSTRAINTS									= MODEL__CONSTRAINTS;
	
	/**
	 * The feature id for the '<em><b>Indexes</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__INDEXES										= MODEL__INDEXES;
	
	/**
	 * The feature id for the '<em><b>Contained Instances</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__CONTAINED_INSTANCES							= MODEL__CONTAINED_INSTANCES;
	
	/**
	 * The feature id for the '<em><b>Literals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__LITERALS										= MODEL__LITERALS;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__LOCALS											= MODEL__LOCALS;
	
	/**
	 * The feature id for the '<em><b>Operators</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__OPERATORS										= MODEL__OPERATORS;
	
	/**
	 * The feature id for the '<em><b>Signal Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__SIGNAL_REF										= MODEL__SIGNAL_REF;
	
	/**
	 * The feature id for the '<em><b>Subprocesses</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__SUBPROCESSES									= MODEL__SUBPROCESSES;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__TYPES											= MODEL__TYPES;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__USE_MODULE										= MODEL__USE_MODULE;
	
	/**
	 * The feature id for the '<em><b>Model Refs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__MODEL_REFS										= MODEL__MODEL_REFS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__SRC_CLOCK_RELATIONS							= MODEL_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__DST_CLOCK_RELATIONS							= MODEL_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__NAME											= MODEL_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__COMMENT										= MODEL_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__SRC_DEPENDENCES								= MODEL_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__DST_DEPENDENCES								= MODEL_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__MODEL_PARENT									= MODEL_FEATURE_COUNT + 6;
	
	/**
	 * The feature id for the '<em><b>Dst Case Connection</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS__DST_CASE_CONNECTION							= MODEL_FEATURE_COUNT + 7;
	
	/**
	 * The number of structural features of the '<em>Sub Process</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUB_PROCESS_FEATURE_COUNT									= MODEL_FEATURE_COUNT + 8;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.BasicIterateImpl <em>Basic Iterate</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.BasicIterateImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getBasicIterate()
	 * @generated
	 */
	int			BASIC_ITERATE												= 12;
	
	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__ASSERTIONS									= SUB_PROCESS__ASSERTIONS;
	
	/**
	 * The feature id for the '<em><b>Automata</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__AUTOMATA										= SUB_PROCESS__AUTOMATA;
	
	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__CONNECTIONS									= SUB_PROCESS__CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Constant Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__CONSTANT_REF									= SUB_PROCESS__CONSTANT_REF;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__CONSTANTS									= SUB_PROCESS__CONSTANTS;
	
	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__CONSTRAINTS									= SUB_PROCESS__CONSTRAINTS;
	
	/**
	 * The feature id for the '<em><b>Indexes</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__INDEXES										= SUB_PROCESS__INDEXES;
	
	/**
	 * The feature id for the '<em><b>Contained Instances</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__CONTAINED_INSTANCES							= SUB_PROCESS__CONTAINED_INSTANCES;
	
	/**
	 * The feature id for the '<em><b>Literals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__LITERALS										= SUB_PROCESS__LITERALS;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__LOCALS										= SUB_PROCESS__LOCALS;
	
	/**
	 * The feature id for the '<em><b>Operators</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__OPERATORS									= SUB_PROCESS__OPERATORS;
	
	/**
	 * The feature id for the '<em><b>Signal Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__SIGNAL_REF									= SUB_PROCESS__SIGNAL_REF;
	
	/**
	 * The feature id for the '<em><b>Subprocesses</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__SUBPROCESSES									= SUB_PROCESS__SUBPROCESSES;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__TYPES										= SUB_PROCESS__TYPES;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__USE_MODULE									= SUB_PROCESS__USE_MODULE;
	
	/**
	 * The feature id for the '<em><b>Model Refs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__MODEL_REFS									= SUB_PROCESS__MODEL_REFS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__SRC_CLOCK_RELATIONS							= SUB_PROCESS__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__DST_CLOCK_RELATIONS							= SUB_PROCESS__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__NAME											= SUB_PROCESS__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__COMMENT										= SUB_PROCESS__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__SRC_DEPENDENCES								= SUB_PROCESS__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__DST_DEPENDENCES								= SUB_PROCESS__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__MODEL_PARENT									= SUB_PROCESS__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Dst Case Connection</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__DST_CASE_CONNECTION							= SUB_PROCESS__DST_CASE_CONNECTION;
	
	/**
	 * The feature id for the '<em><b>Iteration Init</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__ITERATION_INIT								= SUB_PROCESS_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Iterator</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__ITERATOR										= SUB_PROCESS_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Upper Bound</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__UPPER_BOUND									= SUB_PROCESS_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Iterator Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE__ITERATOR_NAME								= SUB_PROCESS_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Basic Iterate</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BASIC_ITERATE_FEATURE_COUNT									= SUB_PROCESS_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.IterateImpl <em>Iterate</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.IterateImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIterate()
	 * @generated
	 */
	int			ITERATE														= 13;
	
	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__ASSERTIONS											= SUB_PROCESS__ASSERTIONS;
	
	/**
	 * The feature id for the '<em><b>Automata</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__AUTOMATA											= SUB_PROCESS__AUTOMATA;
	
	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__CONNECTIONS										= SUB_PROCESS__CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Constant Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__CONSTANT_REF										= SUB_PROCESS__CONSTANT_REF;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__CONSTANTS											= SUB_PROCESS__CONSTANTS;
	
	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__CONSTRAINTS										= SUB_PROCESS__CONSTRAINTS;
	
	/**
	 * The feature id for the '<em><b>Indexes</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__INDEXES											= SUB_PROCESS__INDEXES;
	
	/**
	 * The feature id for the '<em><b>Contained Instances</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__CONTAINED_INSTANCES								= SUB_PROCESS__CONTAINED_INSTANCES;
	
	/**
	 * The feature id for the '<em><b>Literals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__LITERALS											= SUB_PROCESS__LITERALS;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__LOCALS												= SUB_PROCESS__LOCALS;
	
	/**
	 * The feature id for the '<em><b>Operators</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__OPERATORS											= SUB_PROCESS__OPERATORS;
	
	/**
	 * The feature id for the '<em><b>Signal Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__SIGNAL_REF											= SUB_PROCESS__SIGNAL_REF;
	
	/**
	 * The feature id for the '<em><b>Subprocesses</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__SUBPROCESSES										= SUB_PROCESS__SUBPROCESSES;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__TYPES												= SUB_PROCESS__TYPES;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__USE_MODULE											= SUB_PROCESS__USE_MODULE;
	
	/**
	 * The feature id for the '<em><b>Model Refs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__MODEL_REFS											= SUB_PROCESS__MODEL_REFS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__SRC_CLOCK_RELATIONS								= SUB_PROCESS__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__DST_CLOCK_RELATIONS								= SUB_PROCESS__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__NAME												= SUB_PROCESS__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__COMMENT											= SUB_PROCESS__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__SRC_DEPENDENCES									= SUB_PROCESS__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__DST_DEPENDENCES									= SUB_PROCESS__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__MODEL_PARENT										= SUB_PROCESS__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Dst Case Connection</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__DST_CASE_CONNECTION								= SUB_PROCESS__DST_CASE_CONNECTION;
	
	/**
	 * The feature id for the '<em><b>Iteration Init</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__ITERATION_INIT										= SUB_PROCESS_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE__INS												= SUB_PROCESS_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Iterate</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATE_FEATURE_COUNT										= SUB_PROCESS_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.IterationInitImpl <em>Iteration Init</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.IterationInitImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIterationInit()
	 * @generated
	 */
	int			ITERATION_INIT												= 14;
	
	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__ASSERTIONS									= MODEL__ASSERTIONS;
	
	/**
	 * The feature id for the '<em><b>Automata</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__AUTOMATA									= MODEL__AUTOMATA;
	
	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__CONNECTIONS									= MODEL__CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Constant Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__CONSTANT_REF								= MODEL__CONSTANT_REF;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__CONSTANTS									= MODEL__CONSTANTS;
	
	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__CONSTRAINTS									= MODEL__CONSTRAINTS;
	
	/**
	 * The feature id for the '<em><b>Indexes</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__INDEXES										= MODEL__INDEXES;
	
	/**
	 * The feature id for the '<em><b>Contained Instances</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__CONTAINED_INSTANCES							= MODEL__CONTAINED_INSTANCES;
	
	/**
	 * The feature id for the '<em><b>Literals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__LITERALS									= MODEL__LITERALS;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__LOCALS										= MODEL__LOCALS;
	
	/**
	 * The feature id for the '<em><b>Operators</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__OPERATORS									= MODEL__OPERATORS;
	
	/**
	 * The feature id for the '<em><b>Signal Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__SIGNAL_REF									= MODEL__SIGNAL_REF;
	
	/**
	 * The feature id for the '<em><b>Subprocesses</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__SUBPROCESSES								= MODEL__SUBPROCESSES;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__TYPES										= MODEL__TYPES;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__USE_MODULE									= MODEL__USE_MODULE;
	
	/**
	 * The feature id for the '<em><b>Model Refs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__MODEL_REFS									= MODEL__MODEL_REFS;
	
	/**
	 * The feature id for the '<em><b>Array Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__ARRAY_PARENT								= MODEL_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Iterate Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT__ITERATE_PARENT								= MODEL_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Iteration Init</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATION_INIT_FEATURE_COUNT								= MODEL_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.SpecificationsImpl <em>Specifications</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.SpecificationsImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSpecifications()
	 * @generated
	 */
	int			SPECIFICATIONS												= 15;
	
	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__ASSERTIONS									= MODEL__ASSERTIONS;
	
	/**
	 * The feature id for the '<em><b>Automata</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__AUTOMATA									= MODEL__AUTOMATA;
	
	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__CONNECTIONS									= MODEL__CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Constant Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__CONSTANT_REF								= MODEL__CONSTANT_REF;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__CONSTANTS									= MODEL__CONSTANTS;
	
	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__CONSTRAINTS									= MODEL__CONSTRAINTS;
	
	/**
	 * The feature id for the '<em><b>Indexes</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__INDEXES										= MODEL__INDEXES;
	
	/**
	 * The feature id for the '<em><b>Contained Instances</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__CONTAINED_INSTANCES							= MODEL__CONTAINED_INSTANCES;
	
	/**
	 * The feature id for the '<em><b>Literals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__LITERALS									= MODEL__LITERALS;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__LOCALS										= MODEL__LOCALS;
	
	/**
	 * The feature id for the '<em><b>Operators</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__OPERATORS									= MODEL__OPERATORS;
	
	/**
	 * The feature id for the '<em><b>Signal Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__SIGNAL_REF									= MODEL__SIGNAL_REF;
	
	/**
	 * The feature id for the '<em><b>Subprocesses</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__SUBPROCESSES								= MODEL__SUBPROCESSES;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__TYPES										= MODEL__TYPES;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__USE_MODULE									= MODEL__USE_MODULE;
	
	/**
	 * The feature id for the '<em><b>Model Refs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__MODEL_REFS									= MODEL__MODEL_REFS;
	
	/**
	 * The feature id for the '<em><b>Interface Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__INTERFACE_PARENT							= MODEL_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Type Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__TYPE_PARENT									= MODEL_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Declarations</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS__MODEL_DECLARATIONS							= MODEL_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Specifications</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SPECIFICATIONS_FEATURE_COUNT								= MODEL_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.TypeDeclarationImpl <em>Type Declaration</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.TypeDeclarationImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTypeDeclaration()
	 * @generated
	 */
	int			TYPE_DECLARATION											= 17;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TYPE_DECLARATION__NAME										= IDENTIFIER__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TYPE_DECLARATION__COMMENT									= IDENTIFIER__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TYPE_DECLARATION__MODULE_PARENT								= IDENTIFIER_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TYPE_DECLARATION__MODEL_PARENT								= IDENTIFIER_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TYPE_DECLARATION__VISIBILITY								= IDENTIFIER_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Type Declaration</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TYPE_DECLARATION_FEATURE_COUNT								= IDENTIFIER_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ParameterType <em>Parameter Type</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ParameterType
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getParameterType()
	 * @generated
	 */
	int			PARAMETER_TYPE												= 18;
	
	/**
	 * The number of structural features of the '<em>Parameter Type</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_TYPE_FEATURE_COUNT								= 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.SignalType <em>Signal Type</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalType
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalType()
	 * @generated
	 */
	int			SIGNAL_TYPE													= 19;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_TYPE__SRC_CONSTANT_AFFECTATIONS						= PARAMETER_TYPE_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_TYPE__ARRAY_DIMENSIONS								= PARAMETER_TYPE_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Signal Type</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_TYPE_FEATURE_COUNT									= PARAMETER_TYPE_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.EnumerationTypeImpl <em>Enumeration Type</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.EnumerationTypeImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getEnumerationType()
	 * @generated
	 */
	int			ENUMERATION_TYPE											= 20;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE__NAME										= TYPE_DECLARATION__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE__COMMENT									= TYPE_DECLARATION__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE__MODULE_PARENT								= TYPE_DECLARATION__MODULE_PARENT;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE__MODEL_PARENT								= TYPE_DECLARATION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE__VISIBILITY								= TYPE_DECLARATION__VISIBILITY;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE__SRC_CONSTANT_AFFECTATIONS					= TYPE_DECLARATION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE__ARRAY_DIMENSIONS							= TYPE_DECLARATION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Enum Values</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE__ENUM_VALUES								= TYPE_DECLARATION_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Enumeration Type</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_TYPE_FEATURE_COUNT								= TYPE_DECLARATION_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ModelTypeImpl <em>Model Type</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ModelTypeImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelType()
	 * @generated
	 */
	int			MODEL_TYPE													= 21;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__TYPE											= INTERFACE_DEFINITION__TYPE;
	
	/**
	 * The feature id for the '<em><b>Inputs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__INPUTS											= INTERFACE_DEFINITION__INPUTS;
	
	/**
	 * The feature id for the '<em><b>Outputs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__OUTPUTS											= INTERFACE_DEFINITION__OUTPUTS;
	
	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__PARAMETERS										= INTERFACE_DEFINITION__PARAMETERS;
	
	/**
	 * The feature id for the '<em><b>Spec</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__SPEC											= INTERFACE_DEFINITION__SPEC;
	
	/**
	 * The feature id for the '<em><b>Pragmas</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__PRAGMAS											= INTERFACE_DEFINITION__PRAGMAS;
	
	/**
	 * The feature id for the '<em><b>Process Class</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__PROCESS_CLASS									= INTERFACE_DEFINITION__PROCESS_CLASS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__NAME											= INTERFACE_DEFINITION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__COMMENT											= INTERFACE_DEFINITION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__MODULE_PARENT									= INTERFACE_DEFINITION_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__MODEL_PARENT									= INTERFACE_DEFINITION_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__VISIBILITY										= INTERFACE_DEFINITION_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Model Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE__MODEL_TYPE										= INTERFACE_DEFINITION_FEATURE_COUNT + 5;
	
	/**
	 * The number of structural features of the '<em>Model Type</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_TYPE_FEATURE_COUNT									= INTERFACE_DEFINITION_FEATURE_COUNT + 6;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.SubstitutionTypeImpl <em>Substitution Type</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.SubstitutionTypeImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSubstitutionType()
	 * @generated
	 */
	int			SUBSTITUTION_TYPE											= 22;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__NAME										= TYPE_DECLARATION__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__COMMENT									= TYPE_DECLARATION__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__MODULE_PARENT							= TYPE_DECLARATION__MODULE_PARENT;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__MODEL_PARENT								= TYPE_DECLARATION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__VISIBILITY								= TYPE_DECLARATION__VISIBILITY;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__SRC_CONSTANT_AFFECTATIONS				= TYPE_DECLARATION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__ARRAY_DIMENSIONS							= TYPE_DECLARATION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__TYPE										= TYPE_DECLARATION_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Is External</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE__IS_EXTERNAL								= TYPE_DECLARATION_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Substitution Type</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SUBSTITUTION_TYPE_FEATURE_COUNT								= TYPE_DECLARATION_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.TupleTypeImpl <em>Tuple Type</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.TupleTypeImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTupleType()
	 * @generated
	 */
	int			TUPLE_TYPE													= 23;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__NAME											= TYPE_DECLARATION__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__COMMENT											= TYPE_DECLARATION__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__MODULE_PARENT									= TYPE_DECLARATION__MODULE_PARENT;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__MODEL_PARENT									= TYPE_DECLARATION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__VISIBILITY										= TYPE_DECLARATION__VISIBILITY;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__SRC_CONSTANT_AFFECTATIONS						= TYPE_DECLARATION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__ARRAY_DIMENSIONS								= TYPE_DECLARATION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Kind</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__KIND											= TYPE_DECLARATION_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__LOCALS											= TYPE_DECLARATION_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Spec</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE__SPEC											= TYPE_DECLARATION_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Tuple Type</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_TYPE_FEATURE_COUNT									= TYPE_DECLARATION_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ModelDeclarationImpl <em>Model Declaration</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ModelDeclarationImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelDeclaration()
	 * @generated
	 */
	int			MODEL_DECLARATION											= 24;
	
	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__ASSERTIONS								= MODEL__ASSERTIONS;
	
	/**
	 * The feature id for the '<em><b>Automata</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__AUTOMATA									= MODEL__AUTOMATA;
	
	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__CONNECTIONS								= MODEL__CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Constant Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__CONSTANT_REF								= MODEL__CONSTANT_REF;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__CONSTANTS								= MODEL__CONSTANTS;
	
	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__CONSTRAINTS								= MODEL__CONSTRAINTS;
	
	/**
	 * The feature id for the '<em><b>Indexes</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__INDEXES									= MODEL__INDEXES;
	
	/**
	 * The feature id for the '<em><b>Contained Instances</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__CONTAINED_INSTANCES						= MODEL__CONTAINED_INSTANCES;
	
	/**
	 * The feature id for the '<em><b>Literals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__LITERALS									= MODEL__LITERALS;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__LOCALS									= MODEL__LOCALS;
	
	/**
	 * The feature id for the '<em><b>Operators</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__OPERATORS								= MODEL__OPERATORS;
	
	/**
	 * The feature id for the '<em><b>Signal Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__SIGNAL_REF								= MODEL__SIGNAL_REF;
	
	/**
	 * The feature id for the '<em><b>Subprocesses</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__SUBPROCESSES								= MODEL__SUBPROCESSES;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__TYPES									= MODEL__TYPES;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__USE_MODULE								= MODEL__USE_MODULE;
	
	/**
	 * The feature id for the '<em><b>Model Refs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__MODEL_REFS								= MODEL__MODEL_REFS;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__TYPE										= MODEL_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Inputs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__INPUTS									= MODEL_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Outputs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__OUTPUTS									= MODEL_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__PARAMETERS								= MODEL_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Spec</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__SPEC										= MODEL_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Pragmas</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__PRAGMAS									= MODEL_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Process Class</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__PROCESS_CLASS							= MODEL_FEATURE_COUNT + 6;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__NAME										= MODEL_FEATURE_COUNT + 7;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__COMMENT									= MODEL_FEATURE_COUNT + 8;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__SRC_CONSTANT_AFFECTATIONS				= MODEL_FEATURE_COUNT + 9;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__MODEL_PARENT								= MODEL_FEATURE_COUNT + 10;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__MODULE_PARENT							= MODEL_FEATURE_COUNT + 11;
	
	/**
	 * The feature id for the '<em><b>Spec Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__SPEC_PARENT								= MODEL_FEATURE_COUNT + 12;
	
	/**
	 * The feature id for the '<em><b>Model Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__MODEL_TYPE								= MODEL_FEATURE_COUNT + 13;
	
	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__VISIBILITY								= MODEL_FEATURE_COUNT + 14;
	
	/**
	 * The feature id for the '<em><b>Is Main</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__IS_MAIN									= MODEL_FEATURE_COUNT + 15;
	
	/**
	 * The feature id for the '<em><b>Is Sigali Process</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__IS_SIGALI_PROCESS						= MODEL_FEATURE_COUNT + 16;
	
	/**
	 * The feature id for the '<em><b>Compilation Directive</b></em>' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__COMPILATION_DIRECTIVE					= MODEL_FEATURE_COUNT + 17;
	
	/**
	 * The feature id for the '<em><b>Run On</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__RUN_ON									= MODEL_FEATURE_COUNT + 18;
	
	/**
	 * The feature id for the '<em><b>CCODE</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__CCODE									= MODEL_FEATURE_COUNT + 19;
	
	/**
	 * The feature id for the '<em><b>Cpp CODE</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__CPP_CODE									= MODEL_FEATURE_COUNT + 20;
	
	/**
	 * The feature id for the '<em><b>Java CODE</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__JAVA_CODE								= MODEL_FEATURE_COUNT + 21;
	
	/**
	 * The feature id for the '<em><b>Processor type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__PROCESSOR_TYPE							= MODEL_FEATURE_COUNT + 22;
	
	/**
	 * The feature id for the '<em><b>Model Declarations</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION__MODEL_DECLARATIONS						= MODEL_FEATURE_COUNT + 23;
	
	/**
	 * The number of structural features of the '<em>Model Declaration</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_DECLARATION_FEATURE_COUNT								= MODEL_FEATURE_COUNT + 24;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ModelRefImpl <em>Model Ref</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ModelRefImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelRef()
	 * @generated
	 */
	int			MODEL_REF													= 25;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_REF__SRC_CONSTANT_AFFECTATIONS						= CONSTANT_EXPR__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Model</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_REF__MODEL											= CONSTANT_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_REF__MODEL_NAME										= CONSTANT_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_REF__MODEL_PARENT										= CONSTANT_EXPR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Model Ref</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_REF_FEATURE_COUNT										= CONSTANT_EXPR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ModelInstanceImpl <em>Model Instance</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ModelInstanceImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelInstance()
	 * @generated
	 */
	int			MODEL_INSTANCE												= 26;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__SRC_CLOCK_RELATIONS							= CLOCKED_EXPR__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__DST_CLOCK_RELATIONS							= CLOCKED_EXPR__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__NAME										= CLOCKED_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__COMMENT										= CLOCKED_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__SRC_DEPENDENCES								= CLOCKED_EXPR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__DST_DEPENDENCES								= CLOCKED_EXPR_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__MODEL_PARENT								= CLOCKED_EXPR_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Referred Interface</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__REFERRED_INTERFACE							= CLOCKED_EXPR_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Referred Parameter</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__REFERRED_PARAMETER							= CLOCKED_EXPR_FEATURE_COUNT + 6;
	
	/**
	 * The feature id for the '<em><b>Inputs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__INPUTS										= CLOCKED_EXPR_FEATURE_COUNT + 7;
	
	/**
	 * The feature id for the '<em><b>Outputs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__OUTPUTS										= CLOCKED_EXPR_FEATURE_COUNT + 8;
	
	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE__PARAMETERS									= CLOCKED_EXPR_FEATURE_COUNT + 9;
	
	/**
	 * The number of structural features of the '<em>Model Instance</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_INSTANCE_FEATURE_COUNT								= CLOCKED_EXPR_FEATURE_COUNT + 10;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ModuleImpl <em>Module</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ModuleImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModule()
	 * @generated
	 */
	int			MODULE														= 27;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODULE__NAME												= IDENTIFIER__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODULE__COMMENT												= IDENTIFIER__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODULE__CONSTANTS											= IDENTIFIER_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Declarations</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODULE__MODEL_DECLARATIONS									= IDENTIFIER_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODULE__TYPES												= IDENTIFIER_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODULE__USE_MODULE											= IDENTIFIER_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Pragmas</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODULE__PRAGMAS												= IDENTIFIER_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Module</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODULE_FEATURE_COUNT										= IDENTIFIER_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.UseModuleImpl <em>Use Module</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.UseModuleImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getUseModule()
	 * @generated
	 */
	int			USE_MODULE													= 28;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			USE_MODULE__MODEL_PARENT									= SIGNAL_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			USE_MODULE__MODULE_PARENT									= SIGNAL_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Modules</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			USE_MODULE__MODULES											= SIGNAL_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Use Module</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			USE_MODULE_FEATURE_COUNT									= SIGNAL_ELEMENT_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.DataflowConnector <em>Dataflow Connector</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.DataflowConnector
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDataflowConnector()
	 * @generated
	 */
	int			DATAFLOW_CONNECTOR											= 29;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTOR__DST_DATAFLOW_CONNECTIONS				= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Dataflow Connector</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTOR_FEATURE_COUNT							= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ConstantOrRef <em>Constant Or Ref</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ConstantOrRef
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantOrRef()
	 * @generated
	 */
	int			CONSTANT_OR_REF												= 30;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_OR_REF__SRC_DATAFLOW_CONNECTIONS					= SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_OR_REF__SRC_CONSTANT_AFFECTATIONS					= SIGNAL_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Constant Or Ref</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_OR_REF_FEATURE_COUNT								= SIGNAL_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ConstantRefImpl <em>Constant Ref</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ConstantRefImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantRef()
	 * @generated
	 */
	int			CONSTANT_REF												= 31;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_REF__SRC_DATAFLOW_CONNECTIONS						= CONSTANT_OR_REF__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_REF__SRC_CONSTANT_AFFECTATIONS						= CONSTANT_OR_REF__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_REF__SRC_CONDITIONS								= CONSTANT_OR_REF_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Constant</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_REF__CONSTANT										= CONSTANT_OR_REF_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Cst Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_REF__CST_NAME										= CONSTANT_OR_REF_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_REF__MODEL_PARENT									= CONSTANT_OR_REF_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Constant Ref</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_REF_FEATURE_COUNT									= CONSTANT_OR_REF_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ConstantImpl <em>Constant</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ConstantImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstant()
	 * @generated
	 */
	int			CONSTANT													= 32;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT__SRC_DATAFLOW_CONNECTIONS							= CONSTANT_OR_REF__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT__SRC_CONSTANT_AFFECTATIONS							= CONSTANT_OR_REF__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT__NAME												= CONSTANT_OR_REF_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT__COMMENT											= CONSTANT_OR_REF_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Dst Constant Affectation</b></em>' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT__DST_CONSTANT_AFFECTATION							= CONSTANT_OR_REF_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Constant</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_FEATURE_COUNT										= CONSTANT_OR_REF_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ConstantValueImpl <em>Constant Value</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ConstantValueImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantValue()
	 * @generated
	 */
	int			CONSTANT_VALUE												= 33;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__SRC_DATAFLOW_CONNECTIONS					= CONSTANT__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__SRC_CONSTANT_AFFECTATIONS					= CONSTANT__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__NAME										= CONSTANT__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__COMMENT										= CONSTANT__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Dst Constant Affectation</b></em>' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__DST_CONSTANT_AFFECTATION					= CONSTANT__DST_CONSTANT_AFFECTATION;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__SRC_CONDITIONS								= CONSTANT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__MODEL_PARENT								= CONSTANT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__MODULE_PARENT								= CONSTANT_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__ARRAY_DIMENSIONS							= CONSTANT_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__TYPE										= CONSTANT_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__VALUE										= CONSTANT_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE__VISIBILITY									= CONSTANT_FEATURE_COUNT + 6;
	
	/**
	 * The number of structural features of the '<em>Constant Value</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_VALUE_FEATURE_COUNT								= CONSTANT_FEATURE_COUNT + 7;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.LiteralImpl <em>Literal</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.LiteralImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getLiteral()
	 * @generated
	 */
	int			LITERAL														= 34;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LITERAL__SRC_DATAFLOW_CONNECTIONS							= SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LITERAL__SRC_CONSTANT_AFFECTATIONS							= SIGNAL_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LITERAL__SRC_CONDITIONS										= SIGNAL_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LITERAL__MODEL_PARENT										= SIGNAL_EXPR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LITERAL__VALUE												= SIGNAL_EXPR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Literal</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LITERAL_FEATURE_COUNT										= SIGNAL_EXPR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.EnumerationValueImpl <em>Enumeration Value</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.EnumerationValueImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getEnumerationValue()
	 * @generated
	 */
	int			ENUMERATION_VALUE											= 35;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_VALUE__SRC_DATAFLOW_CONNECTIONS					= LITERAL__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_VALUE__SRC_CONSTANT_AFFECTATIONS				= LITERAL__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_VALUE__SRC_CONDITIONS							= LITERAL__SRC_CONDITIONS;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_VALUE__MODEL_PARENT								= LITERAL__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_VALUE__VALUE									= LITERAL__VALUE;
	
	/**
	 * The feature id for the '<em><b>Type Value</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_VALUE__TYPE_VALUE								= LITERAL_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Enumeration Value</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ENUMERATION_VALUE_FEATURE_COUNT								= LITERAL_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ParameterImpl <em>Parameter</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ParameterImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getParameter()
	 * @generated
	 */
	int			PARAMETER													= 36;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__SRC_DATAFLOW_CONNECTIONS							= CONSTANT__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__SRC_CONSTANT_AFFECTATIONS						= CONSTANT__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__NAME												= CONSTANT__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__COMMENT											= CONSTANT__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Dst Constant Affectation</b></em>' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__DST_CONSTANT_AFFECTATION							= CONSTANT__DST_CONSTANT_AFFECTATION;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__SRC_CONDITIONS									= CONSTANT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Interface Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__INTERFACE_PARENT									= CONSTANT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__ARRAY_DIMENSIONS									= CONSTANT_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER__TYPE												= CONSTANT_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Parameter</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_FEATURE_COUNT										= CONSTANT_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ParameterInstanceImpl <em>Parameter Instance</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ParameterInstanceImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getParameterInstance()
	 * @generated
	 */
	int			PARAMETER_INSTANCE											= 37;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE__SRC_DATAFLOW_CONNECTIONS				= CONSTANT__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE__SRC_CONSTANT_AFFECTATIONS				= CONSTANT__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE__NAME									= CONSTANT__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE__COMMENT									= CONSTANT__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Dst Constant Affectation</b></em>' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE__DST_CONSTANT_AFFECTATION				= CONSTANT__DST_CONSTANT_AFFECTATION;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE__SRC_CONDITIONS							= CONSTANT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE__PARAMETER								= CONSTANT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Instance Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE__INSTANCE_PARENT							= CONSTANT_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Parameter Instance</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PARAMETER_INSTANCE_FEATURE_COUNT							= CONSTANT_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.IteratorImpl <em>Iterator</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.IteratorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIterator()
	 * @generated
	 */
	int			ITERATOR													= 38;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATOR__SRC_DATAFLOW_CONNECTIONS							= CONSTANT__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATOR__SRC_CONSTANT_AFFECTATIONS							= CONSTANT__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATOR__NAME												= CONSTANT__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATOR__COMMENT											= CONSTANT__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Dst Constant Affectation</b></em>' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATOR__DST_CONSTANT_AFFECTATION							= CONSTANT__DST_CONSTANT_AFFECTATION;
	
	/**
	 * The feature id for the '<em><b>Array Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATOR__ARRAY_PARENT										= CONSTANT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Iterator</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ITERATOR_FEATURE_COUNT										= CONSTANT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.IndexImpl <em>Index</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.IndexImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIndex()
	 * @generated
	 */
	int			INDEX														= 39;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__SRC_DATAFLOW_CONNECTIONS								= CONSTANT__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__SRC_CONSTANT_AFFECTATIONS							= CONSTANT__SRC_CONSTANT_AFFECTATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__NAME													= CONSTANT__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__COMMENT												= CONSTANT__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Dst Constant Affectation</b></em>' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__DST_CONSTANT_AFFECTATION								= CONSTANT__DST_CONSTANT_AFFECTATION;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__MODEL_PARENT											= CONSTANT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>From</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__FROM													= CONSTANT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>To</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__TO													= CONSTANT_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Step</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX__STEP													= CONSTANT_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Index</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INDEX_FEATURE_COUNT											= CONSTANT_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.SignalOrRef <em>Signal Or Ref</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalOrRef
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalOrRef()
	 * @generated
	 */
	int			SIGNAL_OR_REF												= 40;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OR_REF__SRC_DATAFLOW_CONNECTIONS						= SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OR_REF__SRC_CLOCK_RELATIONS							= SIGNAL_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OR_REF__DST_CLOCK_RELATIONS							= SIGNAL_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OR_REF__SRC_DEPENDENCES								= SIGNAL_EXPR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OR_REF__DST_DEPENDENCES								= SIGNAL_EXPR_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OR_REF__DST_DATAFLOW_CONNECTIONS						= SIGNAL_EXPR_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OR_REF__SRC_CONDITIONS								= SIGNAL_EXPR_FEATURE_COUNT + 5;
	
	/**
	 * The number of structural features of the '<em>Signal Or Ref</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OR_REF_FEATURE_COUNT									= SIGNAL_EXPR_FEATURE_COUNT + 6;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.SignalRefImpl <em>Signal Ref</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.SignalRefImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalRef()
	 * @generated
	 */
	int			SIGNAL_REF													= 41;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__SRC_DATAFLOW_CONNECTIONS						= SIGNAL_OR_REF__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__SRC_CLOCK_RELATIONS								= SIGNAL_OR_REF__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__DST_CLOCK_RELATIONS								= SIGNAL_OR_REF__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__SRC_DEPENDENCES									= SIGNAL_OR_REF__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__DST_DEPENDENCES									= SIGNAL_OR_REF__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__DST_DATAFLOW_CONNECTIONS						= SIGNAL_OR_REF__DST_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__SRC_CONDITIONS									= SIGNAL_OR_REF__SRC_CONDITIONS;
	
	/**
	 * The feature id for the '<em><b>Signal</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__SIGNAL											= SIGNAL_OR_REF_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Sig Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__SIG_NAME										= SIGNAL_OR_REF_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF__MODEL_PARENT									= SIGNAL_OR_REF_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Signal Ref</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_REF_FEATURE_COUNT									= SIGNAL_OR_REF_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.SignalImpl <em>Signal</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.SignalImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignal()
	 * @generated
	 */
	int			SIGNAL														= 42;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__SRC_DATAFLOW_CONNECTIONS							= SIGNAL_OR_REF__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__SRC_CLOCK_RELATIONS									= SIGNAL_OR_REF__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__DST_CLOCK_RELATIONS									= SIGNAL_OR_REF__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__SRC_DEPENDENCES										= SIGNAL_OR_REF__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__DST_DEPENDENCES										= SIGNAL_OR_REF__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__DST_DATAFLOW_CONNECTIONS							= SIGNAL_OR_REF__DST_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__SRC_CONDITIONS										= SIGNAL_OR_REF__SRC_CONDITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__NAME												= SIGNAL_OR_REF_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__COMMENT												= SIGNAL_OR_REF_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__TYPE												= SIGNAL_OR_REF_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__ARRAY_DIMENSIONS									= SIGNAL_OR_REF_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Init Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL__INIT_VALUE											= SIGNAL_OR_REF_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Signal</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_FEATURE_COUNT										= SIGNAL_OR_REF_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.InputImpl <em>Input</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.InputImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getInput()
	 * @generated
	 */
	int			INPUT														= 43;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__SRC_DATAFLOW_CONNECTIONS								= SIGNAL__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__SRC_CLOCK_RELATIONS									= SIGNAL__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__DST_CLOCK_RELATIONS									= SIGNAL__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__SRC_DEPENDENCES										= SIGNAL__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__DST_DEPENDENCES										= SIGNAL__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__DST_DATAFLOW_CONNECTIONS								= SIGNAL__DST_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__SRC_CONDITIONS										= SIGNAL__SRC_CONDITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__NAME													= SIGNAL__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__COMMENT												= SIGNAL__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__TYPE													= SIGNAL__TYPE;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__ARRAY_DIMENSIONS										= SIGNAL__ARRAY_DIMENSIONS;
	
	/**
	 * The feature id for the '<em><b>Init Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__INIT_VALUE											= SIGNAL__INIT_VALUE;
	
	/**
	 * The feature id for the '<em><b>Interface Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT__INTERFACE_PARENT										= SIGNAL_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Input</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_FEATURE_COUNT											= SIGNAL_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.InputInstanceImpl <em>Input Instance</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.InputInstanceImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getInputInstance()
	 * @generated
	 */
	int			INPUT_INSTANCE												= 44;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__SRC_DATAFLOW_CONNECTIONS					= SIGNAL_OR_REF__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__SRC_CLOCK_RELATIONS							= SIGNAL_OR_REF__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__DST_CLOCK_RELATIONS							= SIGNAL_OR_REF__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__SRC_DEPENDENCES								= SIGNAL_OR_REF__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__DST_DEPENDENCES								= SIGNAL_OR_REF__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__DST_DATAFLOW_CONNECTIONS					= SIGNAL_OR_REF__DST_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__SRC_CONDITIONS								= SIGNAL_OR_REF__SRC_CONDITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__NAME										= SIGNAL_OR_REF_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__COMMENT										= SIGNAL_OR_REF_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Input</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__INPUT										= SIGNAL_OR_REF_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Instance Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE__INSTANCE_PARENT								= SIGNAL_OR_REF_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Input Instance</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_INSTANCE_FEATURE_COUNT								= SIGNAL_OR_REF_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.OutputImpl <em>Output</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.OutputImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOutput()
	 * @generated
	 */
	int			OUTPUT														= 45;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__SRC_DATAFLOW_CONNECTIONS							= SIGNAL__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__SRC_CLOCK_RELATIONS									= SIGNAL__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__DST_CLOCK_RELATIONS									= SIGNAL__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__SRC_DEPENDENCES										= SIGNAL__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__DST_DEPENDENCES										= SIGNAL__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__DST_DATAFLOW_CONNECTIONS							= SIGNAL__DST_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__SRC_CONDITIONS										= SIGNAL__SRC_CONDITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__NAME												= SIGNAL__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__COMMENT												= SIGNAL__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__TYPE												= SIGNAL__TYPE;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__ARRAY_DIMENSIONS									= SIGNAL__ARRAY_DIMENSIONS;
	
	/**
	 * The feature id for the '<em><b>Init Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__INIT_VALUE											= SIGNAL__INIT_VALUE;
	
	/**
	 * The feature id for the '<em><b>Interface Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT__INTERFACE_PARENT									= SIGNAL_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Output</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_FEATURE_COUNT										= SIGNAL_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.OutputInstanceImpl <em>Output Instance</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.OutputInstanceImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOutputInstance()
	 * @generated
	 */
	int			OUTPUT_INSTANCE												= 46;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__SRC_DATAFLOW_CONNECTIONS					= SIGNAL_OR_REF__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__SRC_CLOCK_RELATIONS						= SIGNAL_OR_REF__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__DST_CLOCK_RELATIONS						= SIGNAL_OR_REF__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__SRC_DEPENDENCES							= SIGNAL_OR_REF__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__DST_DEPENDENCES							= SIGNAL_OR_REF__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__DST_DATAFLOW_CONNECTIONS					= SIGNAL_OR_REF__DST_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__SRC_CONDITIONS								= SIGNAL_OR_REF__SRC_CONDITIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__SRC_CONSTANT_AFFECTATIONS					= SIGNAL_OR_REF_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__NAME										= SIGNAL_OR_REF_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__COMMENT									= SIGNAL_OR_REF_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Output</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__OUTPUT										= SIGNAL_OR_REF_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Instance Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE__INSTANCE_PARENT							= SIGNAL_OR_REF_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Output Instance</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_INSTANCE_FEATURE_COUNT								= SIGNAL_OR_REF_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.LocalImpl <em>Local</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.LocalImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getLocal()
	 * @generated
	 */
	int			LOCAL														= 47;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__SRC_DATAFLOW_CONNECTIONS								= SIGNAL__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__SRC_CLOCK_RELATIONS									= SIGNAL__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__DST_CLOCK_RELATIONS									= SIGNAL__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__SRC_DEPENDENCES										= SIGNAL__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__DST_DEPENDENCES										= SIGNAL__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__DST_DATAFLOW_CONNECTIONS								= SIGNAL__DST_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__SRC_CONDITIONS										= SIGNAL__SRC_CONDITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__NAME													= SIGNAL__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__COMMENT												= SIGNAL__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__TYPE													= SIGNAL__TYPE;
	
	/**
	 * The feature id for the '<em><b>Array Dimensions</b></em>' attribute list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__ARRAY_DIMENSIONS										= SIGNAL__ARRAY_DIMENSIONS;
	
	/**
	 * The feature id for the '<em><b>Init Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__INIT_VALUE											= SIGNAL__INIT_VALUE;
	
	/**
	 * The feature id for the '<em><b>Status</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__STATUS												= SIGNAL_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__MODEL_PARENT											= SIGNAL_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>State Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__STATE_PARENT											= SIGNAL_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Type Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL__TYPE_PARENT											= SIGNAL_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Local</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			LOCAL_FEATURE_COUNT											= SIGNAL_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ConnectionImpl <em>Connection</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ConnectionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConnection()
	 * @generated
	 */
	int			CONNECTION													= 48;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONNECTION__NAME											= NAMED_ELEMENT__NAME;
	
	/**
	 * The number of structural features of the '<em>Connection</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONNECTION_FEATURE_COUNT									= NAMED_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ModelConnectionImpl <em>Model Connection</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ModelConnectionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelConnection()
	 * @generated
	 */
	int			MODEL_CONNECTION											= 49;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_CONNECTION__NAME										= CONNECTION__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_CONNECTION__MODEL_PARENT								= CONNECTION_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Model Connection</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MODEL_CONNECTION_FEATURE_COUNT								= CONNECTION_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.CaseConnectionImpl <em>Case Connection</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.CaseConnectionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCaseConnection()
	 * @generated
	 */
	int			CASE_CONNECTION												= 50;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__NAME										= MODEL_CONNECTION__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__MODEL_PARENT								= MODEL_CONNECTION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Case Kind</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__CASE_KIND									= MODEL_CONNECTION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Enumeration</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__ENUMERATION								= MODEL_CONNECTION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Lower Bound</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__LOWER_BOUND								= MODEL_CONNECTION_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Upper Bound</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__UPPER_BOUND								= MODEL_CONNECTION_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Case Label</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__CASE_LABEL									= MODEL_CONNECTION_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Src</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__SRC										= MODEL_CONNECTION_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION__DST										= MODEL_CONNECTION_FEATURE_COUNT + 6;
	
	/**
	 * The number of structural features of the '<em>Case Connection</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CASE_CONNECTION_FEATURE_COUNT								= MODEL_CONNECTION_FEATURE_COUNT + 7;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ClockRelationImpl <em>Clock Relation</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ClockRelationImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockRelation()
	 * @generated
	 */
	int			CLOCK_RELATION												= 51;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION__NAME										= MODEL_CONNECTION__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION__MODEL_PARENT								= MODEL_CONNECTION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Src</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION__SRC											= MODEL_CONNECTION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION__DST											= MODEL_CONNECTION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION__SRC_FIELD									= MODEL_CONNECTION_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Dst Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION__DST_FIELD									= MODEL_CONNECTION_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Clock Relation</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION_FEATURE_COUNT								= MODEL_CONNECTION_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ConditionImpl <em>Condition</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ConditionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCondition()
	 * @generated
	 */
	int			CONDITION													= 52;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION__NAME												= MODEL_CONNECTION__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION__MODEL_PARENT										= MODEL_CONNECTION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Condition Kind</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION__CONDITION_KIND									= MODEL_CONNECTION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION__SRC												= MODEL_CONNECTION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION__DST												= MODEL_CONNECTION_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION__SRC_FIELD										= MODEL_CONNECTION_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Condition</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION_FEATURE_COUNT										= MODEL_CONNECTION_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ConstantAffectationImpl
	 * <em>Constant Affectation</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ConstantAffectationImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantAffectation()
	 * @generated
	 */
	int			CONSTANT_AFFECTATION										= 53;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_AFFECTATION__NAME									= MODEL_CONNECTION__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_AFFECTATION__MODEL_PARENT							= MODEL_CONNECTION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Src</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_AFFECTATION__SRC									= MODEL_CONNECTION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_AFFECTATION__DST									= MODEL_CONNECTION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_AFFECTATION__SRC_FIELD								= MODEL_CONNECTION_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Constant Affectation</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONSTANT_AFFECTATION_FEATURE_COUNT							= MODEL_CONNECTION_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.DependenceImpl <em>Dependence</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.DependenceImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDependence()
	 * @generated
	 */
	int			DEPENDENCE													= 55;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.DataflowConnectionImpl
	 * <em>Dataflow Connection</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.DataflowConnectionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDataflowConnection()
	 * @generated
	 */
	int			DATAFLOW_CONNECTION											= 54;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__NAME									= MODEL_CONNECTION__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__MODEL_PARENT							= MODEL_CONNECTION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Is Default Value</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__IS_DEFAULT_VALUE						= MODEL_CONNECTION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Cast Type</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__CAST_TYPE								= MODEL_CONNECTION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Use Src Clock</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__USE_SRC_CLOCK							= MODEL_CONNECTION_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Use Last Iteration Value</b></em>' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__USE_LAST_ITERATION_VALUE				= MODEL_CONNECTION_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Src</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__SRC									= MODEL_CONNECTION_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__DST									= MODEL_CONNECTION_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Src Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__SRC_FIELD								= MODEL_CONNECTION_FEATURE_COUNT + 6;
	
	/**
	 * The feature id for the '<em><b>Dst Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION__DST_FIELD								= MODEL_CONNECTION_FEATURE_COUNT + 7;
	
	/**
	 * The number of structural features of the '<em>Dataflow Connection</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_CONNECTION_FEATURE_COUNT							= MODEL_CONNECTION_FEATURE_COUNT + 8;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE__NAME											= MODEL_CONNECTION__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE__MODEL_PARENT									= MODEL_CONNECTION__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Src</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE__SRC												= MODEL_CONNECTION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE__DST												= MODEL_CONNECTION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE__SRC_FIELD										= MODEL_CONNECTION_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Dst Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE__DST_FIELD										= MODEL_CONNECTION_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Dependence</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_FEATURE_COUNT									= MODEL_CONNECTION_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.OperatorPort <em>Operator Port</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.OperatorPort
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOperatorPort()
	 * @generated
	 */
	int			OPERATOR_PORT												= 56;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OPERATOR_PORT__NAME											= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Operator Port</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OPERATOR_PORT_FEATURE_COUNT									= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.InputPortImpl <em>Input Port</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.InputPortImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getInputPort()
	 * @generated
	 */
	int			INPUT_PORT													= 57;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_PORT__SRC_CLOCK_RELATIONS								= CLOCKED_EXPR__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_PORT__DST_CLOCK_RELATIONS								= CLOCKED_EXPR__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_PORT__NAME											= CLOCKED_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_PORT__DST_DATAFLOW_CONNECTIONS						= CLOCKED_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Operator Parent</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_PORT__OPERATOR_PARENT									= CLOCKED_EXPR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Input Port</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			INPUT_PORT_FEATURE_COUNT									= CLOCKED_EXPR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.OutputPortImpl <em>Output Port</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.OutputPortImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOutputPort()
	 * @generated
	 */
	int			OUTPUT_PORT													= 58;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_PORT__NAME											= IDENTIFIER__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_PORT__COMMENT										= IDENTIFIER__COMMENT;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_PORT__SRC_DATAFLOW_CONNECTIONS						= IDENTIFIER_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_PORT__SRC_CONSTANT_AFFECTATIONS						= IDENTIFIER_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Operator Parent</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_PORT__OPERATOR_PARENT								= IDENTIFIER_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Output Port</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OUTPUT_PORT_FEATURE_COUNT									= IDENTIFIER_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.SignalOperator <em>Signal Operator</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalOperator
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalOperator()
	 * @generated
	 */
	int			SIGNAL_OPERATOR												= 59;
	
	/**
	 * The number of structural features of the '<em>Signal Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SIGNAL_OPERATOR_FEATURE_COUNT								= SIGNAL_CONTAINER_FEATURE_COUNT + 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ConditionExpr <em>Condition Expr</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ConditionExpr
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConditionExpr()
	 * @generated
	 */
	int			CONDITION_EXPR												= 60;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION_EXPR__SRC_CONDITIONS								= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Condition Expr</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITION_EXPR_FEATURE_COUNT								= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ConditionnedExpr <em>Conditionned Expr</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ConditionnedExpr
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConditionnedExpr()
	 * @generated
	 */
	int			CONDITIONNED_EXPR											= 61;
	
	/**
	 * The feature id for the '<em><b>Dst Condition</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITIONNED_EXPR__DST_CONDITION							= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Conditionned Expr</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONDITIONNED_EXPR_FEATURE_COUNT								= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ControlflowOperator <em>Controlflow Operator</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ControlflowOperator
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getControlflowOperator()
	 * @generated
	 */
	int			CONTROLFLOW_OPERATOR										= 62;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONTROLFLOW_OPERATOR__MODEL_PARENT							= 0;
	
	/**
	 * The number of structural features of the '<em>Controlflow Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONTROLFLOW_OPERATOR_FEATURE_COUNT							= 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.DataflowOperator <em>Dataflow Operator</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.DataflowOperator
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDataflowOperator()
	 * @generated
	 */
	int			DATAFLOW_OPERATOR											= 63;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_OPERATOR__MODEL_PARENT								= 0;
	
	/**
	 * The number of structural features of the '<em>Dataflow Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DATAFLOW_OPERATOR_FEATURE_COUNT								= 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.BooleanOperatorI <em>Boolean Operator I</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.BooleanOperatorI
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getBooleanOperatorI()
	 * @generated
	 */
	int			BOOLEAN_OPERATOR_I											= 64;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_OPERATOR_I__SRC_DATAFLOW_CONNECTIONS				= SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_OPERATOR_I__SRC_CONSTANT_AFFECTATIONS				= SIGNAL_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_OPERATOR_I__MODEL_PARENT							= SIGNAL_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_OPERATOR_I__SRC_CONDITIONS							= SIGNAL_EXPR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Boolean Operator I</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_OPERATOR_I_FEATURE_COUNT							= SIGNAL_EXPR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.NumericOperatorI <em>Numeric Operator I</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.NumericOperatorI
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNumericOperatorI()
	 * @generated
	 */
	int			NUMERIC_OPERATOR_I											= 65;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_OPERATOR_I__SRC_DATAFLOW_CONNECTIONS				= SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_OPERATOR_I__SRC_CONSTANT_AFFECTATIONS				= SIGNAL_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_OPERATOR_I__MODEL_PARENT							= SIGNAL_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Numeric Operator I</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_OPERATOR_I_FEATURE_COUNT							= SIGNAL_EXPR_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.SingleInputOperatorImpl
	 * <em>Single Input Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.SingleInputOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSingleInputOperator()
	 * @generated
	 */
	int			SINGLE_INPUT_OPERATOR										= 66;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SINGLE_INPUT_OPERATOR__NAME									= SIGNAL_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SINGLE_INPUT_OPERATOR__IN									= SIGNAL_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Single Input Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SINGLE_INPUT_OPERATOR_FEATURE_COUNT							= SIGNAL_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.TwoInputsOperatorImpl <em>Two Inputs Operator</em>}
	 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.TwoInputsOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTwoInputsOperator()
	 * @generated
	 */
	int			TWO_INPUTS_OPERATOR											= 67;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TWO_INPUTS_OPERATOR__NAME									= SIGNAL_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>First Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TWO_INPUTS_OPERATOR__FIRST_OPERAND							= SIGNAL_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TWO_INPUTS_OPERATOR__SECOND_OPERAND							= SIGNAL_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Two Inputs Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TWO_INPUTS_OPERATOR_FEATURE_COUNT							= SIGNAL_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.MultipleInputsOperatorImpl
	 * <em>Multiple Inputs Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.MultipleInputsOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getMultipleInputsOperator()
	 * @generated
	 */
	int			MULTIPLE_INPUTS_OPERATOR									= 68;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MULTIPLE_INPUTS_OPERATOR__NAME								= SIGNAL_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MULTIPLE_INPUTS_OPERATOR__INS								= SIGNAL_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Multiple Inputs Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT						= SIGNAL_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.AndImpl <em>And</em>}' class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.AndImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAnd()
	 * @generated
	 */
	int			AND															= 69;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND__NAME													= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND__INS													= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND__SRC_DATAFLOW_CONNECTIONS								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND__SRC_CONSTANT_AFFECTATIONS								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND__MODEL_PARENT											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND__SRC_CONDITIONS											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>And</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_FEATURE_COUNT											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ArithmeticOperatorImpl
	 * <em>Arithmetic Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ArithmeticOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArithmeticOperator()
	 * @generated
	 */
	int			ARITHMETIC_OPERATOR											= 70;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARITHMETIC_OPERATOR__NAME									= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARITHMETIC_OPERATOR__INS									= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARITHMETIC_OPERATOR__SRC_DATAFLOW_CONNECTIONS				= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARITHMETIC_OPERATOR__SRC_CONSTANT_AFFECTATIONS				= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARITHMETIC_OPERATOR__MODEL_PARENT							= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARITHMETIC_OPERATOR__OPERATOR								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Arithmetic Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARITHMETIC_OPERATOR_FEATURE_COUNT							= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ArrayEnumerationImpl <em>Array Enumeration</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ArrayEnumerationImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArrayEnumeration()
	 * @generated
	 */
	int			ARRAY_ENUMERATION											= 71;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_ENUMERATION__NAME										= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_ENUMERATION__INS										= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_ENUMERATION__SRC_DATAFLOW_CONNECTIONS					= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_ENUMERATION__SRC_CONSTANT_AFFECTATIONS				= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_ENUMERATION__MODEL_PARENT								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Array Enumeration</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_ENUMERATION_FEATURE_COUNT								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ArrayProductImpl <em>Array Product</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ArrayProductImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArrayProduct()
	 * @generated
	 */
	int			ARRAY_PRODUCT												= 72;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_PRODUCT__NAME											= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_PRODUCT__INS											= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_PRODUCT__SRC_DATAFLOW_CONNECTIONS						= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_PRODUCT__SRC_CONSTANT_AFFECTATIONS					= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_PRODUCT__MODEL_PARENT									= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Array Product</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_PRODUCT_FEATURE_COUNT									= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ArrayRecoveryImpl <em>Array Recovery</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ArrayRecoveryImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArrayRecovery()
	 * @generated
	 */
	int			ARRAY_RECOVERY												= 73;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RECOVERY__NAME										= TWO_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>First Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RECOVERY__FIRST_OPERAND								= TWO_INPUTS_OPERATOR__FIRST_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RECOVERY__SECOND_OPERAND								= TWO_INPUTS_OPERATOR__SECOND_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RECOVERY__SRC_DATAFLOW_CONNECTIONS					= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RECOVERY__SRC_CONSTANT_AFFECTATIONS					= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RECOVERY__SRC_CONDITIONS								= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RECOVERY__MODEL_PARENT								= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Array Recovery</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RECOVERY_FEATURE_COUNT								= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ArrayRestructurationImpl
	 * <em>Array Restructuration</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ArrayRestructurationImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArrayRestructuration()
	 * @generated
	 */
	int			ARRAY_RESTRUCTURATION										= 74;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RESTRUCTURATION__NAME									= TWO_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>First Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RESTRUCTURATION__FIRST_OPERAND						= TWO_INPUTS_OPERATOR__FIRST_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RESTRUCTURATION__SECOND_OPERAND						= TWO_INPUTS_OPERATOR__SECOND_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RESTRUCTURATION__SRC_DATAFLOW_CONNECTIONS				= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RESTRUCTURATION__SRC_CONSTANT_AFFECTATIONS			= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RESTRUCTURATION__MODEL_PARENT							= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Array Restructuration</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ARRAY_RESTRUCTURATION_FEATURE_COUNT							= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.AssertionImpl <em>Assertion</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.AssertionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAssertion()
	 * @generated
	 */
	int			ASSERTION													= 75;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION__NAME												= NAMED_ELEMENT__NAME;
	
	/**
	 * The feature id for the '<em><b>Dst Condition</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION__DST_CONDITION									= NAMED_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Expression</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION__EXPRESSION										= NAMED_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION__MODEL_PARENT										= NAMED_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Assertion</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_FEATURE_COUNT										= NAMED_ELEMENT_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.BooleanExpressionImpl <em>Boolean Expression</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.BooleanExpressionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getBooleanExpression()
	 * @generated
	 */
	int			BOOLEAN_EXPRESSION											= 78;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.CartesianProductImpl <em>Cartesian Product</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.CartesianProductImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCartesianProduct()
	 * @generated
	 */
	int			CARTESIAN_PRODUCT											= 79;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.CellImpl <em>Cell</em>}' class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.CellImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCell()
	 * @generated
	 */
	int			CELL														= 80;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ClockConstraintOperatorImpl
	 * <em>Clock Constraint Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ClockConstraintOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockConstraintOperator()
	 * @generated
	 */
	int			CLOCK_CONSTRAINT_OPERATOR									= 81;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_CONSTRAINT_OPERATOR__SRC_CLOCK_RELATIONS				= CLOCKED_EXPR__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_CONSTRAINT_OPERATOR__DST_CLOCK_RELATIONS				= CLOCKED_EXPR__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_CONSTRAINT_OPERATOR__NAME								= CLOCKED_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_CONSTRAINT_OPERATOR__MODEL_PARENT						= CLOCKED_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_CONSTRAINT_OPERATOR__OPERATOR							= CLOCKED_EXPR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Clock Constraint Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_CONSTRAINT_OPERATOR_FEATURE_COUNT						= CLOCKED_EXPR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.AssertionClockConstraintOperatorImpl
	 * <em>Assertion Clock Constraint Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.AssertionClockConstraintOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAssertionClockConstraintOperator()
	 * @generated
	 */
	int			ASSERTION_CLOCK_CONSTRAINT_OPERATOR							= 76;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_CONSTRAINT_OPERATOR__SRC_CLOCK_RELATIONS	= CLOCK_CONSTRAINT_OPERATOR__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_CONSTRAINT_OPERATOR__DST_CLOCK_RELATIONS	= CLOCK_CONSTRAINT_OPERATOR__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_CONSTRAINT_OPERATOR__NAME					= CLOCK_CONSTRAINT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_CONSTRAINT_OPERATOR__MODEL_PARENT			= CLOCK_CONSTRAINT_OPERATOR__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_CONSTRAINT_OPERATOR__OPERATOR				= CLOCK_CONSTRAINT_OPERATOR__OPERATOR;
	
	/**
	 * The number of structural features of the '<em>Assertion Clock Constraint Operator</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_CONSTRAINT_OPERATOR_FEATURE_COUNT			= CLOCK_CONSTRAINT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ClockRelationOperatorImpl
	 * <em>Clock Relation Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ClockRelationOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockRelationOperator()
	 * @generated
	 */
	int			CLOCK_RELATION_OPERATOR										= 82;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ClockSpeedOperatorImpl
	 * <em>Clock Speed Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ClockSpeedOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockSpeedOperator()
	 * @generated
	 */
	int			CLOCK_SPEED_OPERATOR										= 83;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_SPEED_OPERATOR__NAME									= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_SPEED_OPERATOR__INS									= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_SPEED_OPERATOR__MODEL_PARENT							= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_SPEED_OPERATOR__OPERATOR								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Clock Speed Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_SPEED_OPERATOR_FEATURE_COUNT							= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.AssertionClockSpeedOperatorImpl
	 * <em>Assertion Clock Speed Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.AssertionClockSpeedOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAssertionClockSpeedOperator()
	 * @generated
	 */
	int			ASSERTION_CLOCK_SPEED_OPERATOR								= 77;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_SPEED_OPERATOR__NAME						= CLOCK_SPEED_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_SPEED_OPERATOR__INS							= CLOCK_SPEED_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_SPEED_OPERATOR__MODEL_PARENT				= CLOCK_SPEED_OPERATOR__MODEL_PARENT;
	
	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_SPEED_OPERATOR__OPERATOR					= CLOCK_SPEED_OPERATOR__OPERATOR;
	
	/**
	 * The number of structural features of the '<em>Assertion Clock Speed Operator</em>' class. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			ASSERTION_CLOCK_SPEED_OPERATOR_FEATURE_COUNT				= CLOCK_SPEED_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_EXPRESSION__NAME									= NAMED_ELEMENT__NAME;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_EXPRESSION__SRC_DATAFLOW_CONNECTIONS				= NAMED_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_EXPRESSION__SRC_CONSTANT_AFFECTATIONS				= NAMED_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_EXPRESSION__MODEL_PARENT							= NAMED_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_EXPRESSION__SRC_CONDITIONS							= NAMED_ELEMENT_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Expression</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_EXPRESSION__EXPRESSION								= NAMED_ELEMENT_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Boolean Expression</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			BOOLEAN_EXPRESSION_FEATURE_COUNT							= NAMED_ELEMENT_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CARTESIAN_PRODUCT__NAME										= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CARTESIAN_PRODUCT__INS										= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CARTESIAN_PRODUCT__MODEL_PARENT								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Outs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CARTESIAN_PRODUCT__OUTS										= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Cartesian Product</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CARTESIAN_PRODUCT_FEATURE_COUNT								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CELL__NAME													= SINGLE_INPUT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CELL__IN													= SINGLE_INPUT_OPERATOR__IN;
	
	/**
	 * The feature id for the '<em><b>Dst Condition</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CELL__DST_CONDITION											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CELL__SRC_DATAFLOW_CONNECTIONS								= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CELL__SRC_CONDITIONS										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CELL__MODEL_PARENT											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Initial Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CELL__INITIAL_VALUE											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Cell</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CELL_FEATURE_COUNT											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION_OPERATOR__NAME								= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION_OPERATOR__INS								= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION_OPERATOR__SRC_CLOCK_RELATIONS				= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION_OPERATOR__DST_CLOCK_RELATIONS				= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION_OPERATOR__MODEL_PARENT						= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION_OPERATOR__OPERATOR							= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Clock Relation Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CLOCK_RELATION_OPERATOR_FEATURE_COUNT						= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ComparisonOperatorImpl
	 * <em>Comparison Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ComparisonOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getComparisonOperator()
	 * @generated
	 */
	int			COMPARISON_OPERATOR											= 84;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR__NAME									= TWO_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>First Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR__FIRST_OPERAND							= TWO_INPUTS_OPERATOR__FIRST_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR__SECOND_OPERAND							= TWO_INPUTS_OPERATOR__SECOND_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR__SRC_DATAFLOW_CONNECTIONS				= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR__SRC_CONSTANT_AFFECTATIONS				= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR__MODEL_PARENT							= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR__SRC_CONDITIONS							= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR__OPERATOR								= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Comparison Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPARISON_OPERATOR_FEATURE_COUNT							= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ComplexOperatorImpl <em>Complex Operator</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ComplexOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getComplexOperator()
	 * @generated
	 */
	int			COMPLEX_OPERATOR											= 85;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPLEX_OPERATOR__NAME										= TWO_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>First Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPLEX_OPERATOR__FIRST_OPERAND								= TWO_INPUTS_OPERATOR__FIRST_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPLEX_OPERATOR__SECOND_OPERAND							= TWO_INPUTS_OPERATOR__SECOND_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPLEX_OPERATOR__SRC_DATAFLOW_CONNECTIONS					= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPLEX_OPERATOR__SRC_CONSTANT_AFFECTATIONS					= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPLEX_OPERATOR__MODEL_PARENT								= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Complex Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPLEX_OPERATOR_FEATURE_COUNT								= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ConcatenationImpl <em>Concatenation</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ConcatenationImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConcatenation()
	 * @generated
	 */
	int			CONCATENATION												= 86;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONCATENATION__NAME											= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONCATENATION__INS											= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONCATENATION__SRC_DATAFLOW_CONNECTIONS						= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONCATENATION__SRC_CONSTANT_AFFECTATIONS					= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONCATENATION__MODEL_PARENT									= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Concatenation</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			CONCATENATION_FEATURE_COUNT									= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.CounterImpl <em>Counter</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.CounterImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCounter()
	 * @generated
	 */
	int			COUNTER														= 87;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COUNTER__NAME												= TWO_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>First Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COUNTER__FIRST_OPERAND										= TWO_INPUTS_OPERATOR__FIRST_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COUNTER__SECOND_OPERAND										= TWO_INPUTS_OPERATOR__SECOND_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COUNTER__SRC_DATAFLOW_CONNECTIONS							= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COUNTER__MODEL_PARENT										= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Counter Kind</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COUNTER__COUNTER_KIND										= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Counter</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COUNTER_FEATURE_COUNT										= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.DelayImpl <em>Delay</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.DelayImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDelay()
	 * @generated
	 */
	int			DELAY														= 88;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DELAY__NAME													= SINGLE_INPUT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DELAY__IN													= SINGLE_INPUT_OPERATOR__IN;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DELAY__SRC_DATAFLOW_CONNECTIONS								= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DELAY__SRC_CONDITIONS										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DELAY__MODEL_PARENT											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Nb Instants</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DELAY__NB_INSTANTS											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Initial Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DELAY__INITIAL_VALUE										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Delay</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DELAY_FEATURE_COUNT											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.DependenceOperatorImpl
	 * <em>Dependence Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.DependenceOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDependenceOperator()
	 * @generated
	 */
	int			DEPENDENCE_OPERATOR											= 89;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_OPERATOR__SRC_DEPENDENCES						= DEPENDENCE_IN_OUT__SRC_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_OPERATOR__DST_DEPENDENCES						= DEPENDENCE_IN_OUT__DST_DEPENDENCES;
	
	/**
	 * The feature id for the '<em><b>Dst Condition</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_OPERATOR__DST_CONDITION							= DEPENDENCE_IN_OUT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_OPERATOR__NAME									= DEPENDENCE_IN_OUT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_OPERATOR__MODEL_PARENT							= DEPENDENCE_IN_OUT_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Dependence Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			DEPENDENCE_OPERATOR_FEATURE_COUNT							= DEPENDENCE_IN_OUT_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.ExtractionImpl <em>Extraction</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.ExtractionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getExtraction()
	 * @generated
	 */
	int			EXTRACTION													= 90;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			EXTRACTION__NAME											= SINGLE_INPUT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			EXTRACTION__IN												= SINGLE_INPUT_OPERATOR__IN;
	
	/**
	 * The feature id for the '<em><b>Dst Condition</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			EXTRACTION__DST_CONDITION									= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			EXTRACTION__SRC_DATAFLOW_CONNECTIONS						= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			EXTRACTION__SRC_CONSTANT_AFFECTATIONS						= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			EXTRACTION__SRC_CONDITIONS									= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			EXTRACTION__MODEL_PARENT									= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Extraction</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			EXTRACTION_FEATURE_COUNT									= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.IfThenElseImpl <em>If Then Else</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.IfThenElseImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIfThenElse()
	 * @generated
	 */
	int			IF_THEN_ELSE												= 91;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE__NAME											= TWO_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>First Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE__FIRST_OPERAND									= TWO_INPUTS_OPERATOR__FIRST_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE__SECOND_OPERAND								= TWO_INPUTS_OPERATOR__SECOND_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Dst Condition</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE__DST_CONDITION									= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE__SRC_DATAFLOW_CONNECTIONS						= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE__SRC_CONSTANT_AFFECTATIONS						= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE__SRC_CONDITIONS								= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE__MODEL_PARENT									= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>If Then Else</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			IF_THEN_ELSE_FEATURE_COUNT									= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.MergeImpl <em>Merge</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.MergeImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getMerge()
	 * @generated
	 */
	int			MERGE														= 92;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MERGE__NAME													= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MERGE__INS													= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MERGE__SRC_DATAFLOW_CONNECTIONS								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MERGE__SRC_CONSTANT_AFFECTATIONS							= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MERGE__SRC_CONDITIONS										= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MERGE__MODEL_PARENT											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Merge</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			MERGE_FEATURE_COUNT											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.NotImpl <em>Not</em>}' class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.NotImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNot()
	 * @generated
	 */
	int			NOT															= 93;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NOT__NAME													= SINGLE_INPUT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NOT__IN														= SINGLE_INPUT_OPERATOR__IN;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NOT__SRC_DATAFLOW_CONNECTIONS								= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NOT__SRC_CONSTANT_AFFECTATIONS								= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NOT__MODEL_PARENT											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NOT__SRC_CONDITIONS											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Not</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NOT_FEATURE_COUNT											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.NullClockImpl <em>Null Clock</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.NullClockImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNullClock()
	 * @generated
	 */
	int			NULL_CLOCK													= 94;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NULL_CLOCK__SRC_CLOCK_RELATIONS								= CLOCKED_EXPR__SRC_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NULL_CLOCK__DST_CLOCK_RELATIONS								= CLOCKED_EXPR__DST_CLOCK_RELATIONS;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NULL_CLOCK__MODEL_PARENT									= CLOCKED_EXPR_FEATURE_COUNT + 0;
	
	/**
	 * The number of structural features of the '<em>Null Clock</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NULL_CLOCK_FEATURE_COUNT									= CLOCKED_EXPR_FEATURE_COUNT + 1;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.NumericExpressionImpl <em>Numeric Expression</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.NumericExpressionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNumericExpression()
	 * @generated
	 */
	int			NUMERIC_EXPRESSION											= 95;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_EXPRESSION__NAME									= NAMED_ELEMENT__NAME;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_EXPRESSION__SRC_DATAFLOW_CONNECTIONS				= NAMED_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_EXPRESSION__SRC_CONSTANT_AFFECTATIONS				= NAMED_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_EXPRESSION__MODEL_PARENT							= NAMED_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Expression</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_EXPRESSION__EXPRESSION								= NAMED_ELEMENT_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Numeric Expression</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			NUMERIC_EXPRESSION_FEATURE_COUNT							= NAMED_ELEMENT_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.OrImpl <em>Or</em>}' class. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.OrImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOr()
	 * @generated
	 */
	int			OR															= 96;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OR__NAME													= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OR__INS														= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OR__SRC_DATAFLOW_CONNECTIONS								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OR__SRC_CONSTANT_AFFECTATIONS								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OR__MODEL_PARENT											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OR__SRC_CONDITIONS											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Or</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			OR_FEATURE_COUNT											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.PragmaImpl <em>Pragma</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.PragmaImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getPragma()
	 * @generated
	 */
	int			PRAGMA														= 97;
	
	/**
	 * The feature id for the '<em><b>Interface Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PRAGMA__INTERFACE_PARENT									= SIGNAL_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Module Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PRAGMA__MODULE_PARENT										= SIGNAL_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Pragma</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PRAGMA__PRAGMA												= SIGNAL_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Expression</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PRAGMA__EXPRESSION											= SIGNAL_ELEMENT_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Targets</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PRAGMA__TARGETS												= SIGNAL_ELEMENT_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>Pragma</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			PRAGMA_FEATURE_COUNT										= SIGNAL_ELEMENT_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.RepetitionOperatorImpl
	 * <em>Repetition Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.RepetitionOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getRepetitionOperator()
	 * @generated
	 */
	int			REPETITION_OPERATOR											= 98;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			REPETITION_OPERATOR__NAME									= TWO_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>First Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			REPETITION_OPERATOR__FIRST_OPERAND							= TWO_INPUTS_OPERATOR__FIRST_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			REPETITION_OPERATOR__SECOND_OPERAND							= TWO_INPUTS_OPERATOR__SECOND_OPERAND;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			REPETITION_OPERATOR__SRC_DATAFLOW_CONNECTIONS				= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			REPETITION_OPERATOR__SRC_CONSTANT_AFFECTATIONS				= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			REPETITION_OPERATOR__MODEL_PARENT							= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Repetition Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			REPETITION_OPERATOR_FEATURE_COUNT							= TWO_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.SequentialDefinitionImpl
	 * <em>Sequential Definition</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.SequentialDefinitionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSequentialDefinition()
	 * @generated
	 */
	int			SEQUENTIAL_DEFINITION										= 99;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SEQUENTIAL_DEFINITION__NAME									= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SEQUENTIAL_DEFINITION__INS									= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SEQUENTIAL_DEFINITION__SRC_DATAFLOW_CONNECTIONS				= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SEQUENTIAL_DEFINITION__SRC_CONSTANT_AFFECTATIONS			= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SEQUENTIAL_DEFINITION__MODEL_PARENT							= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Sequential Definition</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SEQUENTIAL_DEFINITION_FEATURE_COUNT							= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.SwitchImpl <em>Switch</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.SwitchImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSwitch()
	 * @generated
	 */
	int			SWITCH														= 100;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SWITCH__NAME												= NAMED_ELEMENT__NAME;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SWITCH__MODEL_PARENT										= NAMED_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Signal</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SWITCH__SIGNAL												= NAMED_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Case Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SWITCH__SRC_CASE_CONNECTIONS								= NAMED_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Field</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SWITCH__SRC_FIELD											= NAMED_ELEMENT_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Switch</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			SWITCH_FEATURE_COUNT										= NAMED_ELEMENT_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.TranspositionImpl <em>Transposition</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.TranspositionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTransposition()
	 * @generated
	 */
	int			TRANSPOSITION												= 101;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSPOSITION__NAME											= SINGLE_INPUT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSPOSITION__IN											= SINGLE_INPUT_OPERATOR__IN;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSPOSITION__SRC_DATAFLOW_CONNECTIONS						= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSPOSITION__SRC_CONSTANT_AFFECTATIONS					= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSPOSITION__MODEL_PARENT									= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Transposition</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSPOSITION_FEATURE_COUNT									= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.TupleOperatorImpl <em>Tuple Operator</em>}' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.TupleOperatorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTupleOperator()
	 * @generated
	 */
	int			TUPLE_OPERATOR												= 102;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_OPERATOR__NAME										= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_OPERATOR__INS											= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_OPERATOR__SRC_DATAFLOW_CONNECTIONS					= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_OPERATOR__SRC_CONSTANT_AFFECTATIONS					= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_OPERATOR__MODEL_PARENT								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Tuple Operator</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TUPLE_OPERATOR_FEATURE_COUNT								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.UnaryMinusImpl <em>Unary Minus</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.UnaryMinusImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getUnaryMinus()
	 * @generated
	 */
	int			UNARY_MINUS													= 103;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			UNARY_MINUS__NAME											= SINGLE_INPUT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			UNARY_MINUS__IN												= SINGLE_INPUT_OPERATOR__IN;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			UNARY_MINUS__SRC_DATAFLOW_CONNECTIONS						= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			UNARY_MINUS__SRC_CONSTANT_AFFECTATIONS						= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			UNARY_MINUS__MODEL_PARENT									= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Unary Minus</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			UNARY_MINUS_FEATURE_COUNT									= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.VariableImpl <em>Variable</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.VariableImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getVariable()
	 * @generated
	 */
	int			VARIABLE													= 104;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			VARIABLE__NAME												= SINGLE_INPUT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			VARIABLE__IN												= SINGLE_INPUT_OPERATOR__IN;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			VARIABLE__SRC_DATAFLOW_CONNECTIONS							= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			VARIABLE__MODEL_PARENT										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Initial Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			VARIABLE__INITIAL_VALUE										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Variable</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			VARIABLE_FEATURE_COUNT										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.WindowImpl <em>Window</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.WindowImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getWindow()
	 * @generated
	 */
	int			WINDOW														= 105;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WINDOW__NAME												= SINGLE_INPUT_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>In</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WINDOW__IN													= SINGLE_INPUT_OPERATOR__IN;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WINDOW__SRC_DATAFLOW_CONNECTIONS							= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WINDOW__MODEL_PARENT										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Window Size</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WINDOW__WINDOW_SIZE											= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Initial Value</b></em>' attribute list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WINDOW__INITIAL_VALUE										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Window</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WINDOW_FEATURE_COUNT										= SINGLE_INPUT_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.XorImpl <em>Xor</em>}' class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.XorImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getXor()
	 * @generated
	 */
	int			XOR															= 106;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			XOR__NAME													= MULTIPLE_INPUTS_OPERATOR__NAME;
	
	/**
	 * The feature id for the '<em><b>Ins</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			XOR__INS													= MULTIPLE_INPUTS_OPERATOR__INS;
	
	/**
	 * The feature id for the '<em><b>Src Dataflow Connections</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			XOR__SRC_DATAFLOW_CONNECTIONS								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Src Constant Affectations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			XOR__SRC_CONSTANT_AFFECTATIONS								= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			XOR__MODEL_PARENT											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Conditions</b></em>' reference list. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			XOR__SRC_CONDITIONS											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 3;
	
	/**
	 * The number of structural features of the '<em>Xor</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			XOR_FEATURE_COUNT											= MULTIPLE_INPUTS_OPERATOR_FEATURE_COUNT + 4;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.StateOrHistory <em>State Or History</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.StateOrHistory
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getStateOrHistory()
	 * @generated
	 */
	int			STATE_OR_HISTORY											= 107;
	
	/**
	 * The feature id for the '<em><b>Dst Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_OR_HISTORY__DST_STRONG_TRANSITIONS					= CONNECTABLE_ELEMENT_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_OR_HISTORY__DST_WEAK_TRANSITIONS						= CONNECTABLE_ELEMENT_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>State Or History</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_OR_HISTORY_FEATURE_COUNT								= CONNECTABLE_ELEMENT_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.HistoryImpl <em>History</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.HistoryImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getHistory()
	 * @generated
	 */
	int			HISTORY														= 108;
	
	/**
	 * The feature id for the '<em><b>Dst Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			HISTORY__DST_STRONG_TRANSITIONS								= STATE_OR_HISTORY__DST_STRONG_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			HISTORY__DST_WEAK_TRANSITIONS								= STATE_OR_HISTORY__DST_WEAK_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			HISTORY__NAME												= STATE_OR_HISTORY_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Parent State</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			HISTORY__PARENT_STATE										= STATE_OR_HISTORY_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>History</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			HISTORY_FEATURE_COUNT										= STATE_OR_HISTORY_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.StateBase <em>State Base</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.StateBase
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getStateBase()
	 * @generated
	 */
	int			STATE_BASE													= 109;
	
	/**
	 * The feature id for the '<em><b>Dst Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_BASE__DST_STRONG_TRANSITIONS							= STATE_OR_HISTORY__DST_STRONG_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_BASE__DST_WEAK_TRANSITIONS							= STATE_OR_HISTORY__DST_WEAK_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_BASE__NAME											= STATE_OR_HISTORY_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_BASE__COMMENT											= STATE_OR_HISTORY_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>State Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_BASE__STATE_PARENT									= STATE_OR_HISTORY_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Src Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_BASE__SRC_WEAK_TRANSITIONS							= STATE_OR_HISTORY_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Src Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_BASE__SRC_STRONG_TRANSITIONS							= STATE_OR_HISTORY_FEATURE_COUNT + 4;
	
	/**
	 * The number of structural features of the '<em>State Base</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_BASE_FEATURE_COUNT									= STATE_OR_HISTORY_FEATURE_COUNT + 5;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.StateImpl <em>State</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.StateImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getState()
	 * @generated
	 */
	int			STATE														= 110;
	
	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__ASSERTIONS											= MODEL__ASSERTIONS;
	
	/**
	 * The feature id for the '<em><b>Automata</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__AUTOMATA												= MODEL__AUTOMATA;
	
	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__CONNECTIONS											= MODEL__CONNECTIONS;
	
	/**
	 * The feature id for the '<em><b>Constant Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__CONSTANT_REF											= MODEL__CONSTANT_REF;
	
	/**
	 * The feature id for the '<em><b>Constants</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__CONSTANTS											= MODEL__CONSTANTS;
	
	/**
	 * The feature id for the '<em><b>Constraints</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__CONSTRAINTS											= MODEL__CONSTRAINTS;
	
	/**
	 * The feature id for the '<em><b>Indexes</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__INDEXES												= MODEL__INDEXES;
	
	/**
	 * The feature id for the '<em><b>Contained Instances</b></em>' containment reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__CONTAINED_INSTANCES									= MODEL__CONTAINED_INSTANCES;
	
	/**
	 * The feature id for the '<em><b>Literals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__LITERALS												= MODEL__LITERALS;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__LOCALS												= MODEL__LOCALS;
	
	/**
	 * The feature id for the '<em><b>Operators</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__OPERATORS											= MODEL__OPERATORS;
	
	/**
	 * The feature id for the '<em><b>Signal Ref</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__SIGNAL_REF											= MODEL__SIGNAL_REF;
	
	/**
	 * The feature id for the '<em><b>Subprocesses</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__SUBPROCESSES											= MODEL__SUBPROCESSES;
	
	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__TYPES												= MODEL__TYPES;
	
	/**
	 * The feature id for the '<em><b>Use Module</b></em>' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__USE_MODULE											= MODEL__USE_MODULE;
	
	/**
	 * The feature id for the '<em><b>Model Refs</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__MODEL_REFS											= MODEL__MODEL_REFS;
	
	/**
	 * The feature id for the '<em><b>Dst Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__DST_STRONG_TRANSITIONS								= MODEL_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__DST_WEAK_TRANSITIONS									= MODEL_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__NAME													= MODEL_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__COMMENT												= MODEL_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>State Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__STATE_PARENT											= MODEL_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Src Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__SRC_WEAK_TRANSITIONS									= MODEL_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Src Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE__SRC_STRONG_TRANSITIONS								= MODEL_FEATURE_COUNT + 6;
	
	/**
	 * The number of structural features of the '<em>State</em>' class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STATE_FEATURE_COUNT											= MODEL_FEATURE_COUNT + 7;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.CompoundState <em>Compound State</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.CompoundState
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCompoundState()
	 * @generated
	 */
	int			COMPOUND_STATE												= 111;
	
	/**
	 * The feature id for the '<em><b>Dst Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__DST_STRONG_TRANSITIONS						= STATE_BASE__DST_STRONG_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__DST_WEAK_TRANSITIONS						= STATE_BASE__DST_WEAK_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__NAME										= STATE_BASE__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__COMMENT										= STATE_BASE__COMMENT;
	
	/**
	 * The feature id for the '<em><b>State Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__STATE_PARENT								= STATE_BASE__STATE_PARENT;
	
	/**
	 * The feature id for the '<em><b>Src Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__SRC_WEAK_TRANSITIONS						= STATE_BASE__SRC_WEAK_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Src Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__SRC_STRONG_TRANSITIONS						= STATE_BASE__SRC_STRONG_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>States</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__STATES										= STATE_BASE_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>History</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__HISTORY										= STATE_BASE_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE__LOCALS										= STATE_BASE_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Compound State</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			COMPOUND_STATE_FEATURE_COUNT								= STATE_BASE_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.AutomatonImpl <em>Automaton</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.AutomatonImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAutomaton()
	 * @generated
	 */
	int			AUTOMATON													= 112;
	
	/**
	 * The feature id for the '<em><b>Dst Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__DST_STRONG_TRANSITIONS							= COMPOUND_STATE__DST_STRONG_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__DST_WEAK_TRANSITIONS								= COMPOUND_STATE__DST_WEAK_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__NAME												= COMPOUND_STATE__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__COMMENT											= COMPOUND_STATE__COMMENT;
	
	/**
	 * The feature id for the '<em><b>State Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__STATE_PARENT										= COMPOUND_STATE__STATE_PARENT;
	
	/**
	 * The feature id for the '<em><b>Src Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__SRC_WEAK_TRANSITIONS								= COMPOUND_STATE__SRC_WEAK_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Src Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__SRC_STRONG_TRANSITIONS							= COMPOUND_STATE__SRC_STRONG_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>States</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__STATES											= COMPOUND_STATE__STATES;
	
	/**
	 * The feature id for the '<em><b>History</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__HISTORY											= COMPOUND_STATE__HISTORY;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__LOCALS											= COMPOUND_STATE__LOCALS;
	
	/**
	 * The feature id for the '<em><b>Src Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__SRC_CLOCK_RELATIONS								= COMPOUND_STATE_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst Clock Relations</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__DST_CLOCK_RELATIONS								= COMPOUND_STATE_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Src Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__SRC_DEPENDENCES									= COMPOUND_STATE_FEATURE_COUNT + 2;
	
	/**
	 * The feature id for the '<em><b>Dst Dependences</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__DST_DEPENDENCES									= COMPOUND_STATE_FEATURE_COUNT + 3;
	
	/**
	 * The feature id for the '<em><b>Model Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__MODEL_PARENT										= COMPOUND_STATE_FEATURE_COUNT + 4;
	
	/**
	 * The feature id for the '<em><b>Init State</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__INIT_STATE										= COMPOUND_STATE_FEATURE_COUNT + 5;
	
	/**
	 * The feature id for the '<em><b>Transitions</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON__TRANSITIONS										= COMPOUND_STATE_FEATURE_COUNT + 6;
	
	/**
	 * The number of structural features of the '<em>Automaton</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AUTOMATON_FEATURE_COUNT										= COMPOUND_STATE_FEATURE_COUNT + 7;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.AndStateImpl <em>And State</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.AndStateImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAndState()
	 * @generated
	 */
	int			AND_STATE													= 113;
	
	/**
	 * The feature id for the '<em><b>Dst Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__DST_STRONG_TRANSITIONS							= COMPOUND_STATE__DST_STRONG_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Dst Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__DST_WEAK_TRANSITIONS								= COMPOUND_STATE__DST_WEAK_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__NAME												= COMPOUND_STATE__NAME;
	
	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__COMMENT											= COMPOUND_STATE__COMMENT;
	
	/**
	 * The feature id for the '<em><b>State Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__STATE_PARENT										= COMPOUND_STATE__STATE_PARENT;
	
	/**
	 * The feature id for the '<em><b>Src Weak Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__SRC_WEAK_TRANSITIONS								= COMPOUND_STATE__SRC_WEAK_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>Src Strong Transitions</b></em>' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__SRC_STRONG_TRANSITIONS							= COMPOUND_STATE__SRC_STRONG_TRANSITIONS;
	
	/**
	 * The feature id for the '<em><b>States</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__STATES											= COMPOUND_STATE__STATES;
	
	/**
	 * The feature id for the '<em><b>History</b></em>' containment reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__HISTORY											= COMPOUND_STATE__HISTORY;
	
	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE__LOCALS											= COMPOUND_STATE__LOCALS;
	
	/**
	 * The number of structural features of the '<em>And State</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			AND_STATE_FEATURE_COUNT										= COMPOUND_STATE_FEATURE_COUNT + 0;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.TransitionImpl <em>Transition</em>}' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.TransitionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTransition()
	 * @generated
	 */
	int			TRANSITION													= 114;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSITION__NAME											= CONNECTION__NAME;
	
	/**
	 * The feature id for the '<em><b>Guard</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSITION__GUARD											= CONNECTION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSITION__PRIORITY										= CONNECTION_FEATURE_COUNT + 1;
	
	/**
	 * The feature id for the '<em><b>Automaton Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSITION__AUTOMATON_PARENT								= CONNECTION_FEATURE_COUNT + 2;
	
	/**
	 * The number of structural features of the '<em>Transition</em>' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			TRANSITION_FEATURE_COUNT									= CONNECTION_FEATURE_COUNT + 3;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.WeakTransitionImpl <em>Weak Transition</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.WeakTransitionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getWeakTransition()
	 * @generated
	 */
	int			WEAK_TRANSITION												= 115;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WEAK_TRANSITION__NAME										= TRANSITION__NAME;
	
	/**
	 * The feature id for the '<em><b>Guard</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WEAK_TRANSITION__GUARD										= TRANSITION__GUARD;
	
	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WEAK_TRANSITION__PRIORITY									= TRANSITION__PRIORITY;
	
	/**
	 * The feature id for the '<em><b>Automaton Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WEAK_TRANSITION__AUTOMATON_PARENT							= TRANSITION__AUTOMATON_PARENT;
	
	/**
	 * The feature id for the '<em><b>Src</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WEAK_TRANSITION__SRC										= TRANSITION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WEAK_TRANSITION__DST										= TRANSITION_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Weak Transition</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			WEAK_TRANSITION_FEATURE_COUNT								= TRANSITION_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.impl.StrongTransitionImpl <em>Strong Transition</em>}'
	 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.impl.StrongTransitionImpl
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getStrongTransition()
	 * @generated
	 */
	int			STRONG_TRANSITION											= 116;
	
	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STRONG_TRANSITION__NAME										= TRANSITION__NAME;
	
	/**
	 * The feature id for the '<em><b>Guard</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STRONG_TRANSITION__GUARD									= TRANSITION__GUARD;
	
	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STRONG_TRANSITION__PRIORITY									= TRANSITION__PRIORITY;
	
	/**
	 * The feature id for the '<em><b>Automaton Parent</b></em>' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STRONG_TRANSITION__AUTOMATON_PARENT							= TRANSITION__AUTOMATON_PARENT;
	
	/**
	 * The feature id for the '<em><b>Src</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STRONG_TRANSITION__SRC										= TRANSITION_FEATURE_COUNT + 0;
	
	/**
	 * The feature id for the '<em><b>Dst</b></em>' reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STRONG_TRANSITION__DST										= TRANSITION_FEATURE_COUNT + 1;
	
	/**
	 * The number of structural features of the '<em>Strong Transition</em>' class. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int			STRONG_TRANSITION_FEATURE_COUNT								= TRANSITION_FEATURE_COUNT + 2;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.SignalIntrinsicType <em>Signal Intrinsic Type</em>}'
	 * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalIntrinsicType
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalIntrinsicType()
	 * @generated
	 */
	int			SIGNAL_INTRINSIC_TYPE										= 117;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ModelKind <em>Model Kind</em>}' enum. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ModelKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelKind()
	 * @generated
	 */
	int			MODEL_KIND													= 118;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ProcessAttributeKind <em>Process Attribute Kind</em>}'
	 * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ProcessAttributeKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getProcessAttributeKind()
	 * @generated
	 */
	int			PROCESS_ATTRIBUTE_KIND										= 119;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.CompilationDirectiveKind
	 * <em>Compilation Directive Kind</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.CompilationDirectiveKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCompilationDirectiveKind()
	 * @generated
	 */
	int			COMPILATION_DIRECTIVE_KIND									= 120;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.SignalStateKind <em>Signal State Kind</em>}' enum. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.SignalStateKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalStateKind()
	 * @generated
	 */
	int			SIGNAL_STATE_KIND											= 121;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.CaseKind <em>Case Kind</em>}' enum. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.CaseKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCaseKind()
	 * @generated
	 */
	int			CASE_KIND													= 122;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.TypeKind <em>Type Kind</em>}' enum. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.TypeKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTypeKind()
	 * @generated
	 */
	int			TYPE_KIND													= 123;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ArithmeticOpKind <em>Arithmetic Op Kind</em>}' enum.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ArithmeticOpKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArithmeticOpKind()
	 * @generated
	 */
	int			ARITHMETIC_OP_KIND											= 124;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ComparisonOpKind <em>Comparison Op Kind</em>}' enum.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ComparisonOpKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getComparisonOpKind()
	 * @generated
	 */
	int			COMPARISON_OP_KIND											= 125;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ClockConstraintOpKind <em>Clock Constraint Op Kind</em>}
	 * ' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ClockConstraintOpKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockConstraintOpKind()
	 * @generated
	 */
	int			CLOCK_CONSTRAINT_OP_KIND									= 126;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ClockRelationOpKind <em>Clock Relation Op Kind</em>}'
	 * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ClockRelationOpKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockRelationOpKind()
	 * @generated
	 */
	int			CLOCK_RELATION_OP_KIND										= 127;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.ClockSpeedOpKind <em>Clock Speed Op Kind</em>}' enum.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.ClockSpeedOpKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockSpeedOpKind()
	 * @generated
	 */
	int			CLOCK_SPEED_OP_KIND											= 128;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.VisibilityKind <em>Visibility Kind</em>}' enum. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.VisibilityKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getVisibilityKind()
	 * @generated
	 */
	int			VISIBILITY_KIND												= 129;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.CounterKind <em>Counter Kind</em>}' enum. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.CounterKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCounterKind()
	 * @generated
	 */
	int			COUNTER_KIND												= 130;
	
	/**
	 * The meta object id for the '{@link fr.irisa.espresso.sme.StatusKind <em>Status Kind</em>}' enum. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.StatusKind
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getStatusKind()
	 * @generated
	 */
	int			STATUS_KIND													= 131;
	
	/**
	 * The meta object id for the '<em>Cyclic Definition Exception</em>' data type. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see fr.irisa.espresso.sme.polychrony.CyclicDefinitionException
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCyclicDefinitionException()
	 * @generated
	 */
	int			CYCLIC_DEFINITION_EXCEPTION									= 132;
	
	/**
	 * The meta object id for the '<em>Set</em>' data type. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see java.util.Set
	 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSet()
	 * @generated
	 */
	int			SET															= 133;
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.RootModel <em>Root Model</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Root Model</em>'.
	 * @see fr.irisa.espresso.sme.RootModel
	 * @generated
	 */
	EClass getRootModel();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SignalElement <em>Signal Element</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal Element</em>'.
	 * @see fr.irisa.espresso.sme.SignalElement
	 * @generated
	 */
	EClass getSignalElement();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ConnectableElement <em>Connectable Element</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Connectable Element</em>'.
	 * @see fr.irisa.espresso.sme.ConnectableElement
	 * @generated
	 */
	EClass getConnectableElement();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.NamedElement <em>Named Element</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Named Element</em>'.
	 * @see fr.irisa.espresso.sme.NamedElement
	 * @generated
	 */
	EClass getNamedElement();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.NamedElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.irisa.espresso.sme.NamedElement#getName()
	 * @see #getNamedElement()
	 * @generated
	 */
	EAttribute getNamedElement_Name();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Identifier <em>Identifier</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Identifier</em>'.
	 * @see fr.irisa.espresso.sme.Identifier
	 * @generated
	 */
	EClass getIdentifier();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Identifier#getComment <em>Comment</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Comment</em>'.
	 * @see fr.irisa.espresso.sme.Identifier#getComment()
	 * @see #getIdentifier()
	 * @generated
	 */
	EAttribute getIdentifier_Comment();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SignalExpr <em>Signal Expr</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal Expr</em>'.
	 * @see fr.irisa.espresso.sme.SignalExpr
	 * @generated
	 */
	EClass getSignalExpr();
	
	/**
	 * Returns the meta object for the reference list '
	 * {@link fr.irisa.espresso.sme.SignalExpr#getSrc_DataflowConnections <em>Src Dataflow Connections</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Src Dataflow Connections</em>'.
	 * @see fr.irisa.espresso.sme.SignalExpr#getSrc_DataflowConnections()
	 * @see #getSignalExpr()
	 * @generated
	 */
	EReference getSignalExpr_Src_DataflowConnections();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ConstantExpr <em>Constant Expr</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Constant Expr</em>'.
	 * @see fr.irisa.espresso.sme.ConstantExpr
	 * @generated
	 */
	EClass getConstantExpr();
	
	/**
	 * Returns the meta object for the reference list '
	 * {@link fr.irisa.espresso.sme.ConstantExpr#getSrc_ConstantAffectations <em>Src Constant Affectations</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Src Constant Affectations</em>'.
	 * @see fr.irisa.espresso.sme.ConstantExpr#getSrc_ConstantAffectations()
	 * @see #getConstantExpr()
	 * @generated
	 */
	EReference getConstantExpr_Src_ConstantAffectations();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ClockedExpr <em>Clocked Expr</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Clocked Expr</em>'.
	 * @see fr.irisa.espresso.sme.ClockedExpr
	 * @generated
	 */
	EClass getClockedExpr();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.ClockedExpr#getSrc_ClockRelations
	 * <em>Src Clock Relations</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Src Clock Relations</em>'.
	 * @see fr.irisa.espresso.sme.ClockedExpr#getSrc_ClockRelations()
	 * @see #getClockedExpr()
	 * @generated
	 */
	EReference getClockedExpr_Src_ClockRelations();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.ClockedExpr#getDst_ClockRelations
	 * <em>Dst Clock Relations</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Dst Clock Relations</em>'.
	 * @see fr.irisa.espresso.sme.ClockedExpr#getDst_ClockRelations()
	 * @see #getClockedExpr()
	 * @generated
	 */
	EReference getClockedExpr_Dst_ClockRelations();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.DependenceInOut <em>Dependence In Out</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Dependence In Out</em>'.
	 * @see fr.irisa.espresso.sme.DependenceInOut
	 * @generated
	 */
	EClass getDependenceInOut();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.DependenceInOut#getSrc_Dependences
	 * <em>Src Dependences</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Src Dependences</em>'.
	 * @see fr.irisa.espresso.sme.DependenceInOut#getSrc_Dependences()
	 * @see #getDependenceInOut()
	 * @generated
	 */
	EReference getDependenceInOut_Src_Dependences();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.DependenceInOut#getDst_Dependences
	 * <em>Dst Dependences</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Dst Dependences</em>'.
	 * @see fr.irisa.espresso.sme.DependenceInOut#getDst_Dependences()
	 * @see #getDependenceInOut()
	 * @generated
	 */
	EReference getDependenceInOut_Dst_Dependences();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SignalContainer <em>Signal Container</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal Container</em>'.
	 * @see fr.irisa.espresso.sme.SignalContainer
	 * @generated
	 */
	EClass getSignalContainer();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.InterfaceDefinition
	 * <em>Interface Definition</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interface Definition</em>'.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition
	 * @generated
	 */
	EClass getInterfaceDefinition();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.InterfaceDefinition#getType
	 * <em>Type</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getType()
	 * @see #getInterfaceDefinition()
	 * @generated
	 */
	EReference getInterfaceDefinition_Type();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.InterfaceDefinition#getInputs <em>Inputs</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Inputs</em>'.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getInputs()
	 * @see #getInterfaceDefinition()
	 * @generated
	 */
	EReference getInterfaceDefinition_Inputs();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.InterfaceDefinition#getOutputs <em>Outputs</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Outputs</em>'.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getOutputs()
	 * @see #getInterfaceDefinition()
	 * @generated
	 */
	EReference getInterfaceDefinition_Outputs();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.InterfaceDefinition#getParameters <em>Parameters</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Parameters</em>'.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getParameters()
	 * @see #getInterfaceDefinition()
	 * @generated
	 */
	EReference getInterfaceDefinition_Parameters();
	
	/**
	 * Returns the meta object for the containment reference '{@link fr.irisa.espresso.sme.InterfaceDefinition#getSpec
	 * <em>Spec</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Spec</em>'.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getSpec()
	 * @see #getInterfaceDefinition()
	 * @generated
	 */
	EReference getInterfaceDefinition_Spec();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.InterfaceDefinition#getPragmas <em>Pragmas</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Pragmas</em>'.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getPragmas()
	 * @see #getInterfaceDefinition()
	 * @generated
	 */
	EReference getInterfaceDefinition_Pragmas();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.InterfaceDefinition#getProcessClass
	 * <em>Process Class</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Process Class</em>'.
	 * @see fr.irisa.espresso.sme.InterfaceDefinition#getProcessClass()
	 * @see #getInterfaceDefinition()
	 * @generated
	 */
	EAttribute getInterfaceDefinition_ProcessClass();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Model <em>Model</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Model</em>'.
	 * @see fr.irisa.espresso.sme.Model
	 * @generated
	 */
	EClass getModel();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getAssertions
	 * <em>Assertions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Assertions</em>'.
	 * @see fr.irisa.espresso.sme.Model#getAssertions()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Assertions();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getAutomata
	 * <em>Automata</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Automata</em>'.
	 * @see fr.irisa.espresso.sme.Model#getAutomata()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Automata();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getConnections
	 * <em>Connections</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Connections</em>'.
	 * @see fr.irisa.espresso.sme.Model#getConnections()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Connections();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getConstantRef
	 * <em>Constant Ref</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Constant Ref</em>'.
	 * @see fr.irisa.espresso.sme.Model#getConstantRef()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_ConstantRef();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getConstants
	 * <em>Constants</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Constants</em>'.
	 * @see fr.irisa.espresso.sme.Model#getConstants()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Constants();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getConstraints
	 * <em>Constraints</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Constraints</em>'.
	 * @see fr.irisa.espresso.sme.Model#getConstraints()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Constraints();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getIndexes
	 * <em>Indexes</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Indexes</em>'.
	 * @see fr.irisa.espresso.sme.Model#getIndexes()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Indexes();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.Model#getContainedInstances <em>Contained Instances</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Contained Instances</em>'.
	 * @see fr.irisa.espresso.sme.Model#getContainedInstances()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_ContainedInstances();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getLiterals
	 * <em>Literals</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Literals</em>'.
	 * @see fr.irisa.espresso.sme.Model#getLiterals()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Literals();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getLocals
	 * <em>Locals</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Locals</em>'.
	 * @see fr.irisa.espresso.sme.Model#getLocals()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Locals();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getOperators
	 * <em>Operators</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Operators</em>'.
	 * @see fr.irisa.espresso.sme.Model#getOperators()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Operators();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getSignalRef
	 * <em>Signal Ref</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Signal Ref</em>'.
	 * @see fr.irisa.espresso.sme.Model#getSignalRef()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_SignalRef();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getSubprocesses
	 * <em>Subprocesses</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Subprocesses</em>'.
	 * @see fr.irisa.espresso.sme.Model#getSubprocesses()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Subprocesses();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getTypes
	 * <em>Types</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Types</em>'.
	 * @see fr.irisa.espresso.sme.Model#getTypes()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Types();
	
	/**
	 * Returns the meta object for the containment reference '{@link fr.irisa.espresso.sme.Model#getUseModule
	 * <em>Use Module</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Use Module</em>'.
	 * @see fr.irisa.espresso.sme.Model#getUseModule()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_UseModule();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Model#getModelRefs
	 * <em>Model Refs</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Model Refs</em>'.
	 * @see fr.irisa.espresso.sme.Model#getModelRefs()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_ModelRefs();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.BasicIterate <em>Basic Iterate</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Basic Iterate</em>'.
	 * @see fr.irisa.espresso.sme.BasicIterate
	 * @generated
	 */
	EClass getBasicIterate();
	
	/**
	 * Returns the meta object for the containment reference '
	 * {@link fr.irisa.espresso.sme.BasicIterate#getIterationInit <em>Iteration Init</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Iteration Init</em>'.
	 * @see fr.irisa.espresso.sme.BasicIterate#getIterationInit()
	 * @see #getBasicIterate()
	 * @generated
	 */
	EReference getBasicIterate_IterationInit();
	
	/**
	 * Returns the meta object for the containment reference '{@link fr.irisa.espresso.sme.BasicIterate#getIterator
	 * <em>Iterator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Iterator</em>'.
	 * @see fr.irisa.espresso.sme.BasicIterate#getIterator()
	 * @see #getBasicIterate()
	 * @generated
	 */
	EReference getBasicIterate_Iterator();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.BasicIterate#getUpperBound
	 * <em>Upper Bound</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Upper Bound</em>'.
	 * @see fr.irisa.espresso.sme.BasicIterate#getUpperBound()
	 * @see #getBasicIterate()
	 * @generated
	 */
	EAttribute getBasicIterate_UpperBound();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.BasicIterate#getIteratorName
	 * <em>Iterator Name</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Iterator Name</em>'.
	 * @see fr.irisa.espresso.sme.BasicIterate#getIteratorName()
	 * @see #getBasicIterate()
	 * @generated
	 */
	EAttribute getBasicIterate_IteratorName();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Iterate <em>Iterate</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Iterate</em>'.
	 * @see fr.irisa.espresso.sme.Iterate
	 * @generated
	 */
	EClass getIterate();
	
	/**
	 * Returns the meta object for the containment reference '{@link fr.irisa.espresso.sme.Iterate#getIterationInit
	 * <em>Iteration Init</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Iteration Init</em>'.
	 * @see fr.irisa.espresso.sme.Iterate#getIterationInit()
	 * @see #getIterate()
	 * @generated
	 */
	EReference getIterate_IterationInit();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Iterate#getIns
	 * <em>Ins</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Ins</em>'.
	 * @see fr.irisa.espresso.sme.Iterate#getIns()
	 * @see #getIterate()
	 * @generated
	 */
	EReference getIterate_Ins();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.IterationInit <em>Iteration Init</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Iteration Init</em>'.
	 * @see fr.irisa.espresso.sme.IterationInit
	 * @generated
	 */
	EClass getIterationInit();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.IterationInit#getArrayParent
	 * <em>Array Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Array Parent</em>'.
	 * @see fr.irisa.espresso.sme.IterationInit#getArrayParent()
	 * @see #getIterationInit()
	 * @generated
	 */
	EReference getIterationInit_ArrayParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.IterationInit#getIterateParent
	 * <em>Iterate Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Iterate Parent</em>'.
	 * @see fr.irisa.espresso.sme.IterationInit#getIterateParent()
	 * @see #getIterationInit()
	 * @generated
	 */
	EReference getIterationInit_IterateParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Specifications <em>Specifications</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Specifications</em>'.
	 * @see fr.irisa.espresso.sme.Specifications
	 * @generated
	 */
	EClass getSpecifications();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.Specifications#getInterfaceParent <em>Interface Parent</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Interface Parent</em>'.
	 * @see fr.irisa.espresso.sme.Specifications#getInterfaceParent()
	 * @see #getSpecifications()
	 * @generated
	 */
	EReference getSpecifications_InterfaceParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Specifications#getTypeParent
	 * <em>Type Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Type Parent</em>'.
	 * @see fr.irisa.espresso.sme.Specifications#getTypeParent()
	 * @see #getSpecifications()
	 * @generated
	 */
	EReference getSpecifications_TypeParent();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.Specifications#getModelDeclarations <em>Model Declarations</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Model Declarations</em>'.
	 * @see fr.irisa.espresso.sme.Specifications#getModelDeclarations()
	 * @see #getSpecifications()
	 * @generated
	 */
	EReference getSpecifications_ModelDeclarations();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SubProcess <em>Sub Process</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Sub Process</em>'.
	 * @see fr.irisa.espresso.sme.SubProcess
	 * @generated
	 */
	EClass getSubProcess();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.SubProcess#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.SubProcess#getModelParent()
	 * @see #getSubProcess()
	 * @generated
	 */
	EReference getSubProcess_ModelParent();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.SubProcess#getDst_CaseConnection
	 * <em>Dst Case Connection</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst Case Connection</em>'.
	 * @see fr.irisa.espresso.sme.SubProcess#getDst_CaseConnection()
	 * @see #getSubProcess()
	 * @generated
	 */
	EReference getSubProcess_Dst_CaseConnection();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.TypeDeclaration <em>Type Declaration</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Type Declaration</em>'.
	 * @see fr.irisa.espresso.sme.TypeDeclaration
	 * @generated
	 */
	EClass getTypeDeclaration();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.TypeDeclaration#getModuleParent <em>Module Parent</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Module Parent</em>'.
	 * @see fr.irisa.espresso.sme.TypeDeclaration#getModuleParent()
	 * @see #getTypeDeclaration()
	 * @generated
	 */
	EReference getTypeDeclaration_ModuleParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.TypeDeclaration#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.TypeDeclaration#getModelParent()
	 * @see #getTypeDeclaration()
	 * @generated
	 */
	EReference getTypeDeclaration_ModelParent();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.TypeDeclaration#getVisibility
	 * <em>Visibility</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Visibility</em>'.
	 * @see fr.irisa.espresso.sme.TypeDeclaration#getVisibility()
	 * @see #getTypeDeclaration()
	 * @generated
	 */
	EAttribute getTypeDeclaration_Visibility();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ParameterType <em>Parameter Type</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Parameter Type</em>'.
	 * @see fr.irisa.espresso.sme.ParameterType
	 * @generated
	 */
	EClass getParameterType();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SignalType <em>Signal Type</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal Type</em>'.
	 * @see fr.irisa.espresso.sme.SignalType
	 * @generated
	 */
	EClass getSignalType();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.SignalType#getArrayDimensions
	 * <em>Array Dimensions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Array Dimensions</em>'.
	 * @see fr.irisa.espresso.sme.SignalType#getArrayDimensions()
	 * @see #getSignalType()
	 * @generated
	 */
	EAttribute getSignalType_ArrayDimensions();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.EnumerationType <em>Enumeration Type</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Enumeration Type</em>'.
	 * @see fr.irisa.espresso.sme.EnumerationType
	 * @generated
	 */
	EClass getEnumerationType();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.EnumerationType#getEnumValues
	 * <em>Enum Values</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Enum Values</em>'.
	 * @see fr.irisa.espresso.sme.EnumerationType#getEnumValues()
	 * @see #getEnumerationType()
	 * @generated
	 */
	EAttribute getEnumerationType_EnumValues();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ModelType <em>Model Type</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Model Type</em>'.
	 * @see fr.irisa.espresso.sme.ModelType
	 * @generated
	 */
	EClass getModelType();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelType#getModelType
	 * <em>Model Type</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Model Type</em>'.
	 * @see fr.irisa.espresso.sme.ModelType#getModelType()
	 * @see #getModelType()
	 * @generated
	 */
	EAttribute getModelType_ModelType();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SubstitutionType <em>Substitution Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Substitution Type</em>'.
	 * @see fr.irisa.espresso.sme.SubstitutionType
	 * @generated
	 */
	EClass getSubstitutionType();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.SubstitutionType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.irisa.espresso.sme.SubstitutionType#getType()
	 * @see #getSubstitutionType()
	 * @generated
	 */
	EAttribute getSubstitutionType_Type();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.SubstitutionType#isIsExternal
	 * <em>Is External</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Is External</em>'.
	 * @see fr.irisa.espresso.sme.SubstitutionType#isIsExternal()
	 * @see #getSubstitutionType()
	 * @generated
	 */
	EAttribute getSubstitutionType_IsExternal();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.TupleType <em>Tuple Type</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Tuple Type</em>'.
	 * @see fr.irisa.espresso.sme.TupleType
	 * @generated
	 */
	EClass getTupleType();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.TupleType#getKind <em>Kind</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Kind</em>'.
	 * @see fr.irisa.espresso.sme.TupleType#getKind()
	 * @see #getTupleType()
	 * @generated
	 */
	EAttribute getTupleType_Kind();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.TupleType#getLocals
	 * <em>Locals</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Locals</em>'.
	 * @see fr.irisa.espresso.sme.TupleType#getLocals()
	 * @see #getTupleType()
	 * @generated
	 */
	EReference getTupleType_Locals();
	
	/**
	 * Returns the meta object for the containment reference '{@link fr.irisa.espresso.sme.TupleType#getSpec
	 * <em>Spec</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Spec</em>'.
	 * @see fr.irisa.espresso.sme.TupleType#getSpec()
	 * @see #getTupleType()
	 * @generated
	 */
	EReference getTupleType_Spec();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ModelDeclaration <em>Model Declaration</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Model Declaration</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration
	 * @generated
	 */
	EClass getModelDeclaration();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.ModelDeclaration#getModelParent <em>Model Parent</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getModelParent()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EReference getModelDeclaration_ModelParent();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.ModelDeclaration#getModuleParent <em>Module Parent</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Module Parent</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getModuleParent()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EReference getModelDeclaration_ModuleParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.ModelDeclaration#getSpecParent
	 * <em>Spec Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Spec Parent</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getSpecParent()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EReference getModelDeclaration_SpecParent();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#getModelType
	 * <em>Model Type</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Model Type</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getModelType()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_ModelType();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#getVisibility
	 * <em>Visibility</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Visibility</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getVisibility()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_Visibility();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#isIsMain
	 * <em>Is Main</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Is Main</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#isIsMain()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_IsMain();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#isIsSigaliProcess
	 * <em>Is Sigali Process</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Is Sigali Process</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#isIsSigaliProcess()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_IsSigaliProcess();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#getCompilationDirective
	 * <em>Compilation Directive</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Compilation Directive</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getCompilationDirective()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_CompilationDirective();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#getRunOn
	 * <em>Run On</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Run On</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getRunOn()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_RunOn();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#getC_CODE
	 * <em>CCODE</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>CCODE</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getC_CODE()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_C_CODE();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#getCpp_CODE
	 * <em>Cpp CODE</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Cpp CODE</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getCpp_CODE()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_Cpp_CODE();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#getJava_CODE
	 * <em>Java CODE</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Java CODE</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getJava_CODE()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_Java_CODE();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelDeclaration#getProcessor_type
	 * <em>Processor type</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Processor type</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getProcessor_type()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EAttribute getModelDeclaration_Processor_type();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.ModelDeclaration#getModelDeclarations <em>Model Declarations</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Model Declarations</em>'.
	 * @see fr.irisa.espresso.sme.ModelDeclaration#getModelDeclarations()
	 * @see #getModelDeclaration()
	 * @generated
	 */
	EReference getModelDeclaration_ModelDeclarations();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ModelRef <em>Model Ref</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Model Ref</em>'.
	 * @see fr.irisa.espresso.sme.ModelRef
	 * @generated
	 */
	EClass getModelRef();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ModelRef#getModel <em>Model</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Model</em>'.
	 * @see fr.irisa.espresso.sme.ModelRef#getModel()
	 * @see #getModelRef()
	 * @generated
	 */
	EReference getModelRef_Model();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ModelRef#getModelName
	 * <em>Model Name</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Model Name</em>'.
	 * @see fr.irisa.espresso.sme.ModelRef#getModelName()
	 * @see #getModelRef()
	 * @generated
	 */
	EAttribute getModelRef_ModelName();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.ModelRef#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.ModelRef#getModelParent()
	 * @see #getModelRef()
	 * @generated
	 */
	EReference getModelRef_ModelParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ModelInstance <em>Model Instance</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Model Instance</em>'.
	 * @see fr.irisa.espresso.sme.ModelInstance
	 * @generated
	 */
	EClass getModelInstance();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.ModelInstance#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.ModelInstance#getModelParent()
	 * @see #getModelInstance()
	 * @generated
	 */
	EReference getModelInstance_ModelParent();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ModelInstance#getReferredInterface
	 * <em>Referred Interface</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Referred Interface</em>'.
	 * @see fr.irisa.espresso.sme.ModelInstance#getReferredInterface()
	 * @see #getModelInstance()
	 * @generated
	 */
	EReference getModelInstance_ReferredInterface();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ModelInstance#getReferredParameter
	 * <em>Referred Parameter</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Referred Parameter</em>'.
	 * @see fr.irisa.espresso.sme.ModelInstance#getReferredParameter()
	 * @see #getModelInstance()
	 * @generated
	 */
	EReference getModelInstance_ReferredParameter();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.ModelInstance#getInputs
	 * <em>Inputs</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Inputs</em>'.
	 * @see fr.irisa.espresso.sme.ModelInstance#getInputs()
	 * @see #getModelInstance()
	 * @generated
	 */
	EReference getModelInstance_Inputs();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.ModelInstance#getOutputs <em>Outputs</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Outputs</em>'.
	 * @see fr.irisa.espresso.sme.ModelInstance#getOutputs()
	 * @see #getModelInstance()
	 * @generated
	 */
	EReference getModelInstance_Outputs();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.ModelInstance#getParameters <em>Parameters</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Parameters</em>'.
	 * @see fr.irisa.espresso.sme.ModelInstance#getParameters()
	 * @see #getModelInstance()
	 * @generated
	 */
	EReference getModelInstance_Parameters();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Module <em>Module</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Module</em>'.
	 * @see fr.irisa.espresso.sme.Module
	 * @generated
	 */
	EClass getModule();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Module#getConstants
	 * <em>Constants</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Constants</em>'.
	 * @see fr.irisa.espresso.sme.Module#getConstants()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_Constants();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.Module#getModelDeclarations <em>Model Declarations</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Model Declarations</em>'.
	 * @see fr.irisa.espresso.sme.Module#getModelDeclarations()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_ModelDeclarations();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Module#getTypes
	 * <em>Types</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Types</em>'.
	 * @see fr.irisa.espresso.sme.Module#getTypes()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_Types();
	
	/**
	 * Returns the meta object for the containment reference '{@link fr.irisa.espresso.sme.Module#getUseModule
	 * <em>Use Module</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Use Module</em>'.
	 * @see fr.irisa.espresso.sme.Module#getUseModule()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_UseModule();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.Module#getPragmas
	 * <em>Pragmas</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Pragmas</em>'.
	 * @see fr.irisa.espresso.sme.Module#getPragmas()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_Pragmas();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.UseModule <em>Use Module</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Use Module</em>'.
	 * @see fr.irisa.espresso.sme.UseModule
	 * @generated
	 */
	EClass getUseModule();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.UseModule#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.UseModule#getModelParent()
	 * @see #getUseModule()
	 * @generated
	 */
	EReference getUseModule_ModelParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.UseModule#getModuleParent
	 * <em>Module Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Module Parent</em>'.
	 * @see fr.irisa.espresso.sme.UseModule#getModuleParent()
	 * @see #getUseModule()
	 * @generated
	 */
	EReference getUseModule_ModuleParent();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.UseModule#getModules
	 * <em>Modules</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Modules</em>'.
	 * @see fr.irisa.espresso.sme.UseModule#getModules()
	 * @see #getUseModule()
	 * @generated
	 */
	EReference getUseModule_Modules();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.DataflowConnector <em>Dataflow Connector</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Dataflow Connector</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnector
	 * @generated
	 */
	EClass getDataflowConnector();
	
	/**
	 * Returns the meta object for the reference list '
	 * {@link fr.irisa.espresso.sme.DataflowConnector#getDst_DataflowConnections <em>Dst Dataflow Connections</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Dst Dataflow Connections</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnector#getDst_DataflowConnections()
	 * @see #getDataflowConnector()
	 * @generated
	 */
	EReference getDataflowConnector_Dst_DataflowConnections();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ConstantOrRef <em>Constant Or Ref</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Constant Or Ref</em>'.
	 * @see fr.irisa.espresso.sme.ConstantOrRef
	 * @generated
	 */
	EClass getConstantOrRef();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ConstantRef <em>Constant Ref</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Constant Ref</em>'.
	 * @see fr.irisa.espresso.sme.ConstantRef
	 * @generated
	 */
	EClass getConstantRef();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ConstantRef#getConstant
	 * <em>Constant</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Constant</em>'.
	 * @see fr.irisa.espresso.sme.ConstantRef#getConstant()
	 * @see #getConstantRef()
	 * @generated
	 */
	EReference getConstantRef_Constant();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ConstantRef#getCstName <em>Cst Name</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Cst Name</em>'.
	 * @see fr.irisa.espresso.sme.ConstantRef#getCstName()
	 * @see #getConstantRef()
	 * @generated
	 */
	EAttribute getConstantRef_CstName();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.ConstantRef#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.ConstantRef#getModelParent()
	 * @see #getConstantRef()
	 * @generated
	 */
	EReference getConstantRef_ModelParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Constant <em>Constant</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Constant</em>'.
	 * @see fr.irisa.espresso.sme.Constant
	 * @generated
	 */
	EClass getConstant();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.Constant#getDst_ConstantAffectation
	 * <em>Dst Constant Affectation</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst Constant Affectation</em>'.
	 * @see fr.irisa.espresso.sme.Constant#getDst_ConstantAffectation()
	 * @see #getConstant()
	 * @generated
	 */
	EReference getConstant_Dst_ConstantAffectation();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ConstantValue <em>Constant Value</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Constant Value</em>'.
	 * @see fr.irisa.espresso.sme.ConstantValue
	 * @generated
	 */
	EClass getConstantValue();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.ConstantValue#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.ConstantValue#getModelParent()
	 * @see #getConstantValue()
	 * @generated
	 */
	EReference getConstantValue_ModelParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.ConstantValue#getModuleParent
	 * <em>Module Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Module Parent</em>'.
	 * @see fr.irisa.espresso.sme.ConstantValue#getModuleParent()
	 * @see #getConstantValue()
	 * @generated
	 */
	EReference getConstantValue_ModuleParent();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.ConstantValue#getArrayDimensions
	 * <em>Array Dimensions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Array Dimensions</em>'.
	 * @see fr.irisa.espresso.sme.ConstantValue#getArrayDimensions()
	 * @see #getConstantValue()
	 * @generated
	 */
	EAttribute getConstantValue_ArrayDimensions();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ConstantValue#getType <em>Type</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.irisa.espresso.sme.ConstantValue#getType()
	 * @see #getConstantValue()
	 * @generated
	 */
	EAttribute getConstantValue_Type();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.ConstantValue#getValue
	 * <em>Value</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Value</em>'.
	 * @see fr.irisa.espresso.sme.ConstantValue#getValue()
	 * @see #getConstantValue()
	 * @generated
	 */
	EAttribute getConstantValue_Value();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ConstantValue#getVisibility
	 * <em>Visibility</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Visibility</em>'.
	 * @see fr.irisa.espresso.sme.ConstantValue#getVisibility()
	 * @see #getConstantValue()
	 * @generated
	 */
	EAttribute getConstantValue_Visibility();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Literal <em>Literal</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Literal</em>'.
	 * @see fr.irisa.espresso.sme.Literal
	 * @generated
	 */
	EClass getLiteral();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Literal#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.Literal#getModelParent()
	 * @see #getLiteral()
	 * @generated
	 */
	EReference getLiteral_ModelParent();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Literal#getValue <em>Value</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.irisa.espresso.sme.Literal#getValue()
	 * @see #getLiteral()
	 * @generated
	 */
	EAttribute getLiteral_Value();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.EnumerationValue <em>Enumeration Value</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Enumeration Value</em>'.
	 * @see fr.irisa.espresso.sme.EnumerationValue
	 * @generated
	 */
	EClass getEnumerationValue();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.EnumerationValue#getTypeValue
	 * <em>Type Value</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Type Value</em>'.
	 * @see fr.irisa.espresso.sme.EnumerationValue#getTypeValue()
	 * @see #getEnumerationValue()
	 * @generated
	 */
	EAttribute getEnumerationValue_TypeValue();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Parameter <em>Parameter</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Parameter</em>'.
	 * @see fr.irisa.espresso.sme.Parameter
	 * @generated
	 */
	EClass getParameter();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Parameter#getInterfaceParent
	 * <em>Interface Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Interface Parent</em>'.
	 * @see fr.irisa.espresso.sme.Parameter#getInterfaceParent()
	 * @see #getParameter()
	 * @generated
	 */
	EReference getParameter_InterfaceParent();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.Parameter#getArrayDimensions
	 * <em>Array Dimensions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Array Dimensions</em>'.
	 * @see fr.irisa.espresso.sme.Parameter#getArrayDimensions()
	 * @see #getParameter()
	 * @generated
	 */
	EAttribute getParameter_ArrayDimensions();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Parameter#getType <em>Type</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.irisa.espresso.sme.Parameter#getType()
	 * @see #getParameter()
	 * @generated
	 */
	EAttribute getParameter_Type();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ParameterInstance <em>Parameter Instance</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Parameter Instance</em>'.
	 * @see fr.irisa.espresso.sme.ParameterInstance
	 * @generated
	 */
	EClass getParameterInstance();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ParameterInstance#getParameter
	 * <em>Parameter</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Parameter</em>'.
	 * @see fr.irisa.espresso.sme.ParameterInstance#getParameter()
	 * @see #getParameterInstance()
	 * @generated
	 */
	EReference getParameterInstance_Parameter();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.ParameterInstance#getInstanceParent <em>Instance Parent</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Instance Parent</em>'.
	 * @see fr.irisa.espresso.sme.ParameterInstance#getInstanceParent()
	 * @see #getParameterInstance()
	 * @generated
	 */
	EReference getParameterInstance_InstanceParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Iterator <em>Iterator</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Iterator</em>'.
	 * @see fr.irisa.espresso.sme.Iterator
	 * @generated
	 */
	EClass getIterator();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Iterator#getArrayParent
	 * <em>Array Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Array Parent</em>'.
	 * @see fr.irisa.espresso.sme.Iterator#getArrayParent()
	 * @see #getIterator()
	 * @generated
	 */
	EReference getIterator_ArrayParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Index <em>Index</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Index</em>'.
	 * @see fr.irisa.espresso.sme.Index
	 * @generated
	 */
	EClass getIndex();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Index#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.Index#getModelParent()
	 * @see #getIndex()
	 * @generated
	 */
	EReference getIndex_ModelParent();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Index#getFrom <em>From</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>From</em>'.
	 * @see fr.irisa.espresso.sme.Index#getFrom()
	 * @see #getIndex()
	 * @generated
	 */
	EAttribute getIndex_From();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Index#getTo <em>To</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>To</em>'.
	 * @see fr.irisa.espresso.sme.Index#getTo()
	 * @see #getIndex()
	 * @generated
	 */
	EAttribute getIndex_To();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Index#getStep <em>Step</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Step</em>'.
	 * @see fr.irisa.espresso.sme.Index#getStep()
	 * @see #getIndex()
	 * @generated
	 */
	EAttribute getIndex_Step();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SignalOrRef <em>Signal Or Ref</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal Or Ref</em>'.
	 * @see fr.irisa.espresso.sme.SignalOrRef
	 * @generated
	 */
	EClass getSignalOrRef();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SignalRef <em>Signal Ref</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal Ref</em>'.
	 * @see fr.irisa.espresso.sme.SignalRef
	 * @generated
	 */
	EClass getSignalRef();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.SignalRef#getSignal <em>Signal</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Signal</em>'.
	 * @see fr.irisa.espresso.sme.SignalRef#getSignal()
	 * @see #getSignalRef()
	 * @generated
	 */
	EReference getSignalRef_Signal();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.SignalRef#getSigName <em>Sig Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Sig Name</em>'.
	 * @see fr.irisa.espresso.sme.SignalRef#getSigName()
	 * @see #getSignalRef()
	 * @generated
	 */
	EAttribute getSignalRef_SigName();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.SignalRef#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.SignalRef#getModelParent()
	 * @see #getSignalRef()
	 * @generated
	 */
	EReference getSignalRef_ModelParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Signal <em>Signal</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal</em>'.
	 * @see fr.irisa.espresso.sme.Signal
	 * @generated
	 */
	EClass getSignal();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Signal#getType <em>Type</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.irisa.espresso.sme.Signal#getType()
	 * @see #getSignal()
	 * @generated
	 */
	EAttribute getSignal_Type();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.Signal#getArrayDimensions
	 * <em>Array Dimensions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Array Dimensions</em>'.
	 * @see fr.irisa.espresso.sme.Signal#getArrayDimensions()
	 * @see #getSignal()
	 * @generated
	 */
	EAttribute getSignal_ArrayDimensions();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.Signal#getInitValue
	 * <em>Init Value</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Init Value</em>'.
	 * @see fr.irisa.espresso.sme.Signal#getInitValue()
	 * @see #getSignal()
	 * @generated
	 */
	EAttribute getSignal_InitValue();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Input <em>Input</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Input</em>'.
	 * @see fr.irisa.espresso.sme.Input
	 * @generated
	 */
	EClass getInput();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Input#getInterfaceParent
	 * <em>Interface Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Interface Parent</em>'.
	 * @see fr.irisa.espresso.sme.Input#getInterfaceParent()
	 * @see #getInput()
	 * @generated
	 */
	EReference getInput_InterfaceParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.InputInstance <em>Input Instance</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Input Instance</em>'.
	 * @see fr.irisa.espresso.sme.InputInstance
	 * @generated
	 */
	EClass getInputInstance();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.InputInstance#getInput <em>Input</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Input</em>'.
	 * @see fr.irisa.espresso.sme.InputInstance#getInput()
	 * @see #getInputInstance()
	 * @generated
	 */
	EReference getInputInstance_Input();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.InputInstance#getInstanceParent <em>Instance Parent</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Instance Parent</em>'.
	 * @see fr.irisa.espresso.sme.InputInstance#getInstanceParent()
	 * @see #getInputInstance()
	 * @generated
	 */
	EReference getInputInstance_InstanceParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Output <em>Output</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Output</em>'.
	 * @see fr.irisa.espresso.sme.Output
	 * @generated
	 */
	EClass getOutput();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Output#getInterfaceParent
	 * <em>Interface Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Interface Parent</em>'.
	 * @see fr.irisa.espresso.sme.Output#getInterfaceParent()
	 * @see #getOutput()
	 * @generated
	 */
	EReference getOutput_InterfaceParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.OutputInstance <em>Output Instance</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Output Instance</em>'.
	 * @see fr.irisa.espresso.sme.OutputInstance
	 * @generated
	 */
	EClass getOutputInstance();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.OutputInstance#getOutput <em>Output</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Output</em>'.
	 * @see fr.irisa.espresso.sme.OutputInstance#getOutput()
	 * @see #getOutputInstance()
	 * @generated
	 */
	EReference getOutputInstance_Output();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.OutputInstance#getInstanceParent <em>Instance Parent</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Instance Parent</em>'.
	 * @see fr.irisa.espresso.sme.OutputInstance#getInstanceParent()
	 * @see #getOutputInstance()
	 * @generated
	 */
	EReference getOutputInstance_InstanceParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Local <em>Local</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Local</em>'.
	 * @see fr.irisa.espresso.sme.Local
	 * @generated
	 */
	EClass getLocal();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Local#getStatus <em>Status</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Status</em>'.
	 * @see fr.irisa.espresso.sme.Local#getStatus()
	 * @see #getLocal()
	 * @generated
	 */
	EAttribute getLocal_Status();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Local#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.Local#getModelParent()
	 * @see #getLocal()
	 * @generated
	 */
	EReference getLocal_ModelParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Local#getStateParent
	 * <em>State Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>State Parent</em>'.
	 * @see fr.irisa.espresso.sme.Local#getStateParent()
	 * @see #getLocal()
	 * @generated
	 */
	EReference getLocal_StateParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Local#getTypeParent
	 * <em>Type Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Type Parent</em>'.
	 * @see fr.irisa.espresso.sme.Local#getTypeParent()
	 * @see #getLocal()
	 * @generated
	 */
	EReference getLocal_TypeParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Connection <em>Connection</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Connection</em>'.
	 * @see fr.irisa.espresso.sme.Connection
	 * @generated
	 */
	EClass getConnection();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ModelConnection <em>Model Connection</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Model Connection</em>'.
	 * @see fr.irisa.espresso.sme.ModelConnection
	 * @generated
	 */
	EClass getModelConnection();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.ModelConnection#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.ModelConnection#getModelParent()
	 * @see #getModelConnection()
	 * @generated
	 */
	EReference getModelConnection_ModelParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.CaseConnection <em>Case Connection</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Case Connection</em>'.
	 * @see fr.irisa.espresso.sme.CaseConnection
	 * @generated
	 */
	EClass getCaseConnection();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.CaseConnection#getCaseKind
	 * <em>Case Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Case Kind</em>'.
	 * @see fr.irisa.espresso.sme.CaseConnection#getCaseKind()
	 * @see #getCaseConnection()
	 * @generated
	 */
	EAttribute getCaseConnection_CaseKind();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.CaseConnection#getEnumeration
	 * <em>Enumeration</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Enumeration</em>'.
	 * @see fr.irisa.espresso.sme.CaseConnection#getEnumeration()
	 * @see #getCaseConnection()
	 * @generated
	 */
	EAttribute getCaseConnection_Enumeration();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.CaseConnection#getLowerBound
	 * <em>Lower Bound</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Lower Bound</em>'.
	 * @see fr.irisa.espresso.sme.CaseConnection#getLowerBound()
	 * @see #getCaseConnection()
	 * @generated
	 */
	EAttribute getCaseConnection_LowerBound();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.CaseConnection#getUpperBound
	 * <em>Upper Bound</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Upper Bound</em>'.
	 * @see fr.irisa.espresso.sme.CaseConnection#getUpperBound()
	 * @see #getCaseConnection()
	 * @generated
	 */
	EAttribute getCaseConnection_UpperBound();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.CaseConnection#getCaseLabel
	 * <em>Case Label</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Case Label</em>'.
	 * @see fr.irisa.espresso.sme.CaseConnection#getCaseLabel()
	 * @see #getCaseConnection()
	 * @generated
	 */
	EAttribute getCaseConnection_CaseLabel();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.CaseConnection#getSrc <em>Src</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Src</em>'.
	 * @see fr.irisa.espresso.sme.CaseConnection#getSrc()
	 * @see #getCaseConnection()
	 * @generated
	 */
	EReference getCaseConnection_Src();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.CaseConnection#getDst <em>Dst</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst</em>'.
	 * @see fr.irisa.espresso.sme.CaseConnection#getDst()
	 * @see #getCaseConnection()
	 * @generated
	 */
	EReference getCaseConnection_Dst();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ClockRelation <em>Clock Relation</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Clock Relation</em>'.
	 * @see fr.irisa.espresso.sme.ClockRelation
	 * @generated
	 */
	EClass getClockRelation();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ClockRelation#getSrc <em>Src</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Src</em>'.
	 * @see fr.irisa.espresso.sme.ClockRelation#getSrc()
	 * @see #getClockRelation()
	 * @generated
	 */
	EReference getClockRelation_Src();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ClockRelation#getDst <em>Dst</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst</em>'.
	 * @see fr.irisa.espresso.sme.ClockRelation#getDst()
	 * @see #getClockRelation()
	 * @generated
	 */
	EReference getClockRelation_Dst();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ClockRelation#getSrcField
	 * <em>Src Field</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Src Field</em>'.
	 * @see fr.irisa.espresso.sme.ClockRelation#getSrcField()
	 * @see #getClockRelation()
	 * @generated
	 */
	EAttribute getClockRelation_SrcField();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ClockRelation#getDstField
	 * <em>Dst Field</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Dst Field</em>'.
	 * @see fr.irisa.espresso.sme.ClockRelation#getDstField()
	 * @see #getClockRelation()
	 * @generated
	 */
	EAttribute getClockRelation_DstField();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Condition <em>Condition</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Condition</em>'.
	 * @see fr.irisa.espresso.sme.Condition
	 * @generated
	 */
	EClass getCondition();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Condition#getConditionKind
	 * <em>Condition Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Condition Kind</em>'.
	 * @see fr.irisa.espresso.sme.Condition#getConditionKind()
	 * @see #getCondition()
	 * @generated
	 */
	EAttribute getCondition_ConditionKind();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.Condition#getSrc <em>Src</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Src</em>'.
	 * @see fr.irisa.espresso.sme.Condition#getSrc()
	 * @see #getCondition()
	 * @generated
	 */
	EReference getCondition_Src();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.Condition#getDst <em>Dst</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst</em>'.
	 * @see fr.irisa.espresso.sme.Condition#getDst()
	 * @see #getCondition()
	 * @generated
	 */
	EReference getCondition_Dst();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Condition#getSrcField <em>Src Field</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Src Field</em>'.
	 * @see fr.irisa.espresso.sme.Condition#getSrcField()
	 * @see #getCondition()
	 * @generated
	 */
	EAttribute getCondition_SrcField();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ConstantAffectation
	 * <em>Constant Affectation</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Constant Affectation</em>'.
	 * @see fr.irisa.espresso.sme.ConstantAffectation
	 * @generated
	 */
	EClass getConstantAffectation();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ConstantAffectation#getSrc <em>Src</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Src</em>'.
	 * @see fr.irisa.espresso.sme.ConstantAffectation#getSrc()
	 * @see #getConstantAffectation()
	 * @generated
	 */
	EReference getConstantAffectation_Src();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.ConstantAffectation#getDst <em>Dst</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst</em>'.
	 * @see fr.irisa.espresso.sme.ConstantAffectation#getDst()
	 * @see #getConstantAffectation()
	 * @generated
	 */
	EReference getConstantAffectation_Dst();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ConstantAffectation#getSrcField
	 * <em>Src Field</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Src Field</em>'.
	 * @see fr.irisa.espresso.sme.ConstantAffectation#getSrcField()
	 * @see #getConstantAffectation()
	 * @generated
	 */
	EAttribute getConstantAffectation_SrcField();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Dependence <em>Dependence</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Dependence</em>'.
	 * @see fr.irisa.espresso.sme.Dependence
	 * @generated
	 */
	EClass getDependence();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.Dependence#getSrc <em>Src</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Src</em>'.
	 * @see fr.irisa.espresso.sme.Dependence#getSrc()
	 * @see #getDependence()
	 * @generated
	 */
	EReference getDependence_Src();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.Dependence#getDst <em>Dst</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst</em>'.
	 * @see fr.irisa.espresso.sme.Dependence#getDst()
	 * @see #getDependence()
	 * @generated
	 */
	EReference getDependence_Dst();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Dependence#getSrcField
	 * <em>Src Field</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Src Field</em>'.
	 * @see fr.irisa.espresso.sme.Dependence#getSrcField()
	 * @see #getDependence()
	 * @generated
	 */
	EAttribute getDependence_SrcField();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Dependence#getDstField
	 * <em>Dst Field</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Dst Field</em>'.
	 * @see fr.irisa.espresso.sme.Dependence#getDstField()
	 * @see #getDependence()
	 * @generated
	 */
	EAttribute getDependence_DstField();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.DataflowConnection <em>Dataflow Connection</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Dataflow Connection</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection
	 * @generated
	 */
	EClass getDataflowConnection();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.DataflowConnection#isIsDefaultValue
	 * <em>Is Default Value</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Is Default Value</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection#isIsDefaultValue()
	 * @see #getDataflowConnection()
	 * @generated
	 */
	EAttribute getDataflowConnection_IsDefaultValue();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.DataflowConnection#getCastType
	 * <em>Cast Type</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Cast Type</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection#getCastType()
	 * @see #getDataflowConnection()
	 * @generated
	 */
	EAttribute getDataflowConnection_CastType();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.DataflowConnection#isUseSrcClock
	 * <em>Use Src Clock</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Use Src Clock</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection#isUseSrcClock()
	 * @see #getDataflowConnection()
	 * @generated
	 */
	EAttribute getDataflowConnection_UseSrcClock();
	
	/**
	 * Returns the meta object for the attribute '
	 * {@link fr.irisa.espresso.sme.DataflowConnection#isUseLastIterationValue <em>Use Last Iteration Value</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Use Last Iteration Value</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection#isUseLastIterationValue()
	 * @see #getDataflowConnection()
	 * @generated
	 */
	EAttribute getDataflowConnection_UseLastIterationValue();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.DataflowConnection#getSrc <em>Src</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Src</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection#getSrc()
	 * @see #getDataflowConnection()
	 * @generated
	 */
	EReference getDataflowConnection_Src();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.DataflowConnection#getDst <em>Dst</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection#getDst()
	 * @see #getDataflowConnection()
	 * @generated
	 */
	EReference getDataflowConnection_Dst();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.DataflowConnection#getSrcField
	 * <em>Src Field</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Src Field</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection#getSrcField()
	 * @see #getDataflowConnection()
	 * @generated
	 */
	EAttribute getDataflowConnection_SrcField();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.DataflowConnection#getDstField
	 * <em>Dst Field</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Dst Field</em>'.
	 * @see fr.irisa.espresso.sme.DataflowConnection#getDstField()
	 * @see #getDataflowConnection()
	 * @generated
	 */
	EAttribute getDataflowConnection_DstField();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.OperatorPort <em>Operator Port</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Operator Port</em>'.
	 * @see fr.irisa.espresso.sme.OperatorPort
	 * @generated
	 */
	EClass getOperatorPort();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.OperatorPort#getName <em>Name</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.irisa.espresso.sme.OperatorPort#getName()
	 * @see #getOperatorPort()
	 * @generated
	 */
	EAttribute getOperatorPort_Name();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.InputPort <em>Input Port</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Input Port</em>'.
	 * @see fr.irisa.espresso.sme.InputPort
	 * @generated
	 */
	EClass getInputPort();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.InputPort#getOperatorParent
	 * <em>Operator Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Operator Parent</em>'.
	 * @see fr.irisa.espresso.sme.InputPort#getOperatorParent()
	 * @see #getInputPort()
	 * @generated
	 */
	EReference getInputPort_OperatorParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.OutputPort <em>Output Port</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Output Port</em>'.
	 * @see fr.irisa.espresso.sme.OutputPort
	 * @generated
	 */
	EClass getOutputPort();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.OutputPort#getOperatorParent
	 * <em>Operator Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Operator Parent</em>'.
	 * @see fr.irisa.espresso.sme.OutputPort#getOperatorParent()
	 * @see #getOutputPort()
	 * @generated
	 */
	EReference getOutputPort_OperatorParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SignalOperator <em>Signal Operator</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal Operator</em>'.
	 * @see fr.irisa.espresso.sme.SignalOperator
	 * @generated
	 */
	EClass getSignalOperator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ConditionExpr <em>Condition Expr</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Condition Expr</em>'.
	 * @see fr.irisa.espresso.sme.ConditionExpr
	 * @generated
	 */
	EClass getConditionExpr();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.ConditionExpr#getSrc_Conditions
	 * <em>Src Conditions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Src Conditions</em>'.
	 * @see fr.irisa.espresso.sme.ConditionExpr#getSrc_Conditions()
	 * @see #getConditionExpr()
	 * @generated
	 */
	EReference getConditionExpr_Src_Conditions();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ConditionnedExpr <em>Conditionned Expr</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Conditionned Expr</em>'.
	 * @see fr.irisa.espresso.sme.ConditionnedExpr
	 * @generated
	 */
	EClass getConditionnedExpr();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.ConditionnedExpr#getDst_Condition
	 * <em>Dst Condition</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Dst Condition</em>'.
	 * @see fr.irisa.espresso.sme.ConditionnedExpr#getDst_Condition()
	 * @see #getConditionnedExpr()
	 * @generated
	 */
	EReference getConditionnedExpr_Dst_Condition();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ControlflowOperator
	 * <em>Controlflow Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Controlflow Operator</em>'.
	 * @see fr.irisa.espresso.sme.ControlflowOperator
	 * @generated
	 */
	EClass getControlflowOperator();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.ControlflowOperator#getModelParent <em>Model Parent</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.ControlflowOperator#getModelParent()
	 * @see #getControlflowOperator()
	 * @generated
	 */
	EReference getControlflowOperator_ModelParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.DataflowOperator <em>Dataflow Operator</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Dataflow Operator</em>'.
	 * @see fr.irisa.espresso.sme.DataflowOperator
	 * @generated
	 */
	EClass getDataflowOperator();
	
	/**
	 * Returns the meta object for the container reference '
	 * {@link fr.irisa.espresso.sme.DataflowOperator#getModelParent <em>Model Parent</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.DataflowOperator#getModelParent()
	 * @see #getDataflowOperator()
	 * @generated
	 */
	EReference getDataflowOperator_ModelParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.BooleanOperatorI <em>Boolean Operator I</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Boolean Operator I</em>'.
	 * @see fr.irisa.espresso.sme.BooleanOperatorI
	 * @generated
	 */
	EClass getBooleanOperatorI();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.NumericOperatorI <em>Numeric Operator I</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Numeric Operator I</em>'.
	 * @see fr.irisa.espresso.sme.NumericOperatorI
	 * @generated
	 */
	EClass getNumericOperatorI();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SingleInputOperator
	 * <em>Single Input Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Single Input Operator</em>'.
	 * @see fr.irisa.espresso.sme.SingleInputOperator
	 * @generated
	 */
	EClass getSingleInputOperator();
	
	/**
	 * Returns the meta object for the containment reference '{@link fr.irisa.espresso.sme.SingleInputOperator#getIn
	 * <em>In</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>In</em>'.
	 * @see fr.irisa.espresso.sme.SingleInputOperator#getIn()
	 * @see #getSingleInputOperator()
	 * @generated
	 */
	EReference getSingleInputOperator_In();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.TwoInputsOperator <em>Two Inputs Operator</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Two Inputs Operator</em>'.
	 * @see fr.irisa.espresso.sme.TwoInputsOperator
	 * @generated
	 */
	EClass getTwoInputsOperator();
	
	/**
	 * Returns the meta object for the containment reference '
	 * {@link fr.irisa.espresso.sme.TwoInputsOperator#getFirstOperand <em>First Operand</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>First Operand</em>'.
	 * @see fr.irisa.espresso.sme.TwoInputsOperator#getFirstOperand()
	 * @see #getTwoInputsOperator()
	 * @generated
	 */
	EReference getTwoInputsOperator_FirstOperand();
	
	/**
	 * Returns the meta object for the containment reference '
	 * {@link fr.irisa.espresso.sme.TwoInputsOperator#getSecondOperand <em>Second Operand</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Second Operand</em>'.
	 * @see fr.irisa.espresso.sme.TwoInputsOperator#getSecondOperand()
	 * @see #getTwoInputsOperator()
	 * @generated
	 */
	EReference getTwoInputsOperator_SecondOperand();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.MultipleInputsOperator
	 * <em>Multiple Inputs Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Multiple Inputs Operator</em>'.
	 * @see fr.irisa.espresso.sme.MultipleInputsOperator
	 * @generated
	 */
	EClass getMultipleInputsOperator();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.MultipleInputsOperator#getIns <em>Ins</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Ins</em>'.
	 * @see fr.irisa.espresso.sme.MultipleInputsOperator#getIns()
	 * @see #getMultipleInputsOperator()
	 * @generated
	 */
	EReference getMultipleInputsOperator_Ins();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.And <em>And</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for class '<em>And</em>'.
	 * @see fr.irisa.espresso.sme.And
	 * @generated
	 */
	EClass getAnd();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ArithmeticOperator <em>Arithmetic Operator</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Arithmetic Operator</em>'.
	 * @see fr.irisa.espresso.sme.ArithmeticOperator
	 * @generated
	 */
	EClass getArithmeticOperator();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ArithmeticOperator#getOperator
	 * <em>Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see fr.irisa.espresso.sme.ArithmeticOperator#getOperator()
	 * @see #getArithmeticOperator()
	 * @generated
	 */
	EAttribute getArithmeticOperator_Operator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ArrayEnumeration <em>Array Enumeration</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Array Enumeration</em>'.
	 * @see fr.irisa.espresso.sme.ArrayEnumeration
	 * @generated
	 */
	EClass getArrayEnumeration();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ArrayProduct <em>Array Product</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Array Product</em>'.
	 * @see fr.irisa.espresso.sme.ArrayProduct
	 * @generated
	 */
	EClass getArrayProduct();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ArrayRecovery <em>Array Recovery</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Array Recovery</em>'.
	 * @see fr.irisa.espresso.sme.ArrayRecovery
	 * @generated
	 */
	EClass getArrayRecovery();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ArrayRestructuration
	 * <em>Array Restructuration</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Array Restructuration</em>'.
	 * @see fr.irisa.espresso.sme.ArrayRestructuration
	 * @generated
	 */
	EClass getArrayRestructuration();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Assertion <em>Assertion</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Assertion</em>'.
	 * @see fr.irisa.espresso.sme.Assertion
	 * @generated
	 */
	EClass getAssertion();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Assertion#getExpression
	 * <em>Expression</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Expression</em>'.
	 * @see fr.irisa.espresso.sme.Assertion#getExpression()
	 * @see #getAssertion()
	 * @generated
	 */
	EAttribute getAssertion_Expression();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Assertion#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.Assertion#getModelParent()
	 * @see #getAssertion()
	 * @generated
	 */
	EReference getAssertion_ModelParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.AssertionClockConstraintOperator
	 * <em>Assertion Clock Constraint Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Assertion Clock Constraint Operator</em>'.
	 * @see fr.irisa.espresso.sme.AssertionClockConstraintOperator
	 * @generated
	 */
	EClass getAssertionClockConstraintOperator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.AssertionClockSpeedOperator
	 * <em>Assertion Clock Speed Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Assertion Clock Speed Operator</em>'.
	 * @see fr.irisa.espresso.sme.AssertionClockSpeedOperator
	 * @generated
	 */
	EClass getAssertionClockSpeedOperator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.BooleanExpression <em>Boolean Expression</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Boolean Expression</em>'.
	 * @see fr.irisa.espresso.sme.BooleanExpression
	 * @generated
	 */
	EClass getBooleanExpression();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.BooleanExpression#getExpression
	 * <em>Expression</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Expression</em>'.
	 * @see fr.irisa.espresso.sme.BooleanExpression#getExpression()
	 * @see #getBooleanExpression()
	 * @generated
	 */
	EAttribute getBooleanExpression_Expression();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.CartesianProduct <em>Cartesian Product</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Cartesian Product</em>'.
	 * @see fr.irisa.espresso.sme.CartesianProduct
	 * @generated
	 */
	EClass getCartesianProduct();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.CartesianProduct#getOuts <em>Outs</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the containment reference list '<em>Outs</em>'.
	 * @see fr.irisa.espresso.sme.CartesianProduct#getOuts()
	 * @see #getCartesianProduct()
	 * @generated
	 */
	EReference getCartesianProduct_Outs();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Cell <em>Cell</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Cell</em>'.
	 * @see fr.irisa.espresso.sme.Cell
	 * @generated
	 */
	EClass getCell();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.Cell#getInitialValue
	 * <em>Initial Value</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Initial Value</em>'.
	 * @see fr.irisa.espresso.sme.Cell#getInitialValue()
	 * @see #getCell()
	 * @generated
	 */
	EAttribute getCell_InitialValue();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ClockConstraintOperator
	 * <em>Clock Constraint Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Clock Constraint Operator</em>'.
	 * @see fr.irisa.espresso.sme.ClockConstraintOperator
	 * @generated
	 */
	EClass getClockConstraintOperator();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ClockConstraintOperator#getOperator
	 * <em>Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see fr.irisa.espresso.sme.ClockConstraintOperator#getOperator()
	 * @see #getClockConstraintOperator()
	 * @generated
	 */
	EAttribute getClockConstraintOperator_Operator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ClockRelationOperator
	 * <em>Clock Relation Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Clock Relation Operator</em>'.
	 * @see fr.irisa.espresso.sme.ClockRelationOperator
	 * @generated
	 */
	EClass getClockRelationOperator();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ClockRelationOperator#getOperator
	 * <em>Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see fr.irisa.espresso.sme.ClockRelationOperator#getOperator()
	 * @see #getClockRelationOperator()
	 * @generated
	 */
	EAttribute getClockRelationOperator_Operator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ClockSpeedOperator <em>Clock Speed Operator</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Clock Speed Operator</em>'.
	 * @see fr.irisa.espresso.sme.ClockSpeedOperator
	 * @generated
	 */
	EClass getClockSpeedOperator();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ClockSpeedOperator#getOperator
	 * <em>Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see fr.irisa.espresso.sme.ClockSpeedOperator#getOperator()
	 * @see #getClockSpeedOperator()
	 * @generated
	 */
	EAttribute getClockSpeedOperator_Operator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ComparisonOperator <em>Comparison Operator</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Comparison Operator</em>'.
	 * @see fr.irisa.espresso.sme.ComparisonOperator
	 * @generated
	 */
	EClass getComparisonOperator();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.ComparisonOperator#getOperator
	 * <em>Operator</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see fr.irisa.espresso.sme.ComparisonOperator#getOperator()
	 * @see #getComparisonOperator()
	 * @generated
	 */
	EAttribute getComparisonOperator_Operator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.ComplexOperator <em>Complex Operator</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Complex Operator</em>'.
	 * @see fr.irisa.espresso.sme.ComplexOperator
	 * @generated
	 */
	EClass getComplexOperator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Concatenation <em>Concatenation</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Concatenation</em>'.
	 * @see fr.irisa.espresso.sme.Concatenation
	 * @generated
	 */
	EClass getConcatenation();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Counter <em>Counter</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Counter</em>'.
	 * @see fr.irisa.espresso.sme.Counter
	 * @generated
	 */
	EClass getCounter();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Counter#getCounterKind
	 * <em>Counter Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Counter Kind</em>'.
	 * @see fr.irisa.espresso.sme.Counter#getCounterKind()
	 * @see #getCounter()
	 * @generated
	 */
	EAttribute getCounter_CounterKind();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Delay <em>Delay</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Delay</em>'.
	 * @see fr.irisa.espresso.sme.Delay
	 * @generated
	 */
	EClass getDelay();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Delay#getNbInstants <em>Nb Instants</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Nb Instants</em>'.
	 * @see fr.irisa.espresso.sme.Delay#getNbInstants()
	 * @see #getDelay()
	 * @generated
	 */
	EAttribute getDelay_NbInstants();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.Delay#getInitialValue
	 * <em>Initial Value</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Initial Value</em>'.
	 * @see fr.irisa.espresso.sme.Delay#getInitialValue()
	 * @see #getDelay()
	 * @generated
	 */
	EAttribute getDelay_InitialValue();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.DependenceOperator <em>Dependence Operator</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Dependence Operator</em>'.
	 * @see fr.irisa.espresso.sme.DependenceOperator
	 * @generated
	 */
	EClass getDependenceOperator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Extraction <em>Extraction</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Extraction</em>'.
	 * @see fr.irisa.espresso.sme.Extraction
	 * @generated
	 */
	EClass getExtraction();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.IfThenElse <em>If Then Else</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>If Then Else</em>'.
	 * @see fr.irisa.espresso.sme.IfThenElse
	 * @generated
	 */
	EClass getIfThenElse();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Merge <em>Merge</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Merge</em>'.
	 * @see fr.irisa.espresso.sme.Merge
	 * @generated
	 */
	EClass getMerge();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Not <em>Not</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Not</em>'.
	 * @see fr.irisa.espresso.sme.Not
	 * @generated
	 */
	EClass getNot();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.NullClock <em>Null Clock</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Null Clock</em>'.
	 * @see fr.irisa.espresso.sme.NullClock
	 * @generated
	 */
	EClass getNullClock();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.NumericExpression <em>Numeric Expression</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Numeric Expression</em>'.
	 * @see fr.irisa.espresso.sme.NumericExpression
	 * @generated
	 */
	EClass getNumericExpression();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.NumericExpression#getExpression
	 * <em>Expression</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Expression</em>'.
	 * @see fr.irisa.espresso.sme.NumericExpression#getExpression()
	 * @see #getNumericExpression()
	 * @generated
	 */
	EAttribute getNumericExpression_Expression();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Or <em>Or</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Or</em>'.
	 * @see fr.irisa.espresso.sme.Or
	 * @generated
	 */
	EClass getOr();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Pragma <em>Pragma</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Pragma</em>'.
	 * @see fr.irisa.espresso.sme.Pragma
	 * @generated
	 */
	EClass getPragma();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Pragma#getInterfaceParent
	 * <em>Interface Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Interface Parent</em>'.
	 * @see fr.irisa.espresso.sme.Pragma#getInterfaceParent()
	 * @see #getPragma()
	 * @generated
	 */
	EReference getPragma_InterfaceParent();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Pragma#getModuleParent
	 * <em>Module Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Module Parent</em>'.
	 * @see fr.irisa.espresso.sme.Pragma#getModuleParent()
	 * @see #getPragma()
	 * @generated
	 */
	EReference getPragma_ModuleParent();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Pragma#getPragma <em>Pragma</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Pragma</em>'.
	 * @see fr.irisa.espresso.sme.Pragma#getPragma()
	 * @see #getPragma()
	 * @generated
	 */
	EAttribute getPragma_Pragma();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Pragma#getExpression <em>Expression</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Expression</em>'.
	 * @see fr.irisa.espresso.sme.Pragma#getExpression()
	 * @see #getPragma()
	 * @generated
	 */
	EAttribute getPragma_Expression();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.Pragma#getTargets <em>Targets</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Targets</em>'.
	 * @see fr.irisa.espresso.sme.Pragma#getTargets()
	 * @see #getPragma()
	 * @generated
	 */
	EReference getPragma_Targets();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.RepetitionOperator <em>Repetition Operator</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Repetition Operator</em>'.
	 * @see fr.irisa.espresso.sme.RepetitionOperator
	 * @generated
	 */
	EClass getRepetitionOperator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.SequentialDefinition
	 * <em>Sequential Definition</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Sequential Definition</em>'.
	 * @see fr.irisa.espresso.sme.SequentialDefinition
	 * @generated
	 */
	EClass getSequentialDefinition();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Switch <em>Switch</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Switch</em>'.
	 * @see fr.irisa.espresso.sme.Switch
	 * @generated
	 */
	EClass getSwitch();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.Switch#getSignal <em>Signal</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Signal</em>'.
	 * @see fr.irisa.espresso.sme.Switch#getSignal()
	 * @see #getSwitch()
	 * @generated
	 */
	EReference getSwitch_Signal();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.Switch#getSrc_CaseConnections
	 * <em>Src Case Connections</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Src Case Connections</em>'.
	 * @see fr.irisa.espresso.sme.Switch#getSrc_CaseConnections()
	 * @see #getSwitch()
	 * @generated
	 */
	EReference getSwitch_Src_CaseConnections();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Switch#getSrcField <em>Src Field</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Src Field</em>'.
	 * @see fr.irisa.espresso.sme.Switch#getSrcField()
	 * @see #getSwitch()
	 * @generated
	 */
	EAttribute getSwitch_SrcField();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Transposition <em>Transposition</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Transposition</em>'.
	 * @see fr.irisa.espresso.sme.Transposition
	 * @generated
	 */
	EClass getTransposition();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.TupleOperator <em>Tuple Operator</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Tuple Operator</em>'.
	 * @see fr.irisa.espresso.sme.TupleOperator
	 * @generated
	 */
	EClass getTupleOperator();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.UnaryMinus <em>Unary Minus</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Unary Minus</em>'.
	 * @see fr.irisa.espresso.sme.UnaryMinus
	 * @generated
	 */
	EClass getUnaryMinus();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Variable <em>Variable</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Variable</em>'.
	 * @see fr.irisa.espresso.sme.Variable
	 * @generated
	 */
	EClass getVariable();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.Variable#getInitialValue
	 * <em>Initial Value</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Initial Value</em>'.
	 * @see fr.irisa.espresso.sme.Variable#getInitialValue()
	 * @see #getVariable()
	 * @generated
	 */
	EAttribute getVariable_InitialValue();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Window <em>Window</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Window</em>'.
	 * @see fr.irisa.espresso.sme.Window
	 * @generated
	 */
	EClass getWindow();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Window#getWindowSize
	 * <em>Window Size</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Window Size</em>'.
	 * @see fr.irisa.espresso.sme.Window#getWindowSize()
	 * @see #getWindow()
	 * @generated
	 */
	EAttribute getWindow_WindowSize();
	
	/**
	 * Returns the meta object for the attribute list '{@link fr.irisa.espresso.sme.Window#getInitialValue
	 * <em>Initial Value</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Initial Value</em>'.
	 * @see fr.irisa.espresso.sme.Window#getInitialValue()
	 * @see #getWindow()
	 * @generated
	 */
	EAttribute getWindow_InitialValue();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Xor <em>Xor</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Xor</em>'.
	 * @see fr.irisa.espresso.sme.Xor
	 * @generated
	 */
	EClass getXor();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.StateOrHistory <em>State Or History</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>State Or History</em>'.
	 * @see fr.irisa.espresso.sme.StateOrHistory
	 * @generated
	 */
	EClass getStateOrHistory();
	
	/**
	 * Returns the meta object for the reference list '
	 * {@link fr.irisa.espresso.sme.StateOrHistory#getDst_StrongTransitions <em>Dst Strong Transitions</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Dst Strong Transitions</em>'.
	 * @see fr.irisa.espresso.sme.StateOrHistory#getDst_StrongTransitions()
	 * @see #getStateOrHistory()
	 * @generated
	 */
	EReference getStateOrHistory_Dst_StrongTransitions();
	
	/**
	 * Returns the meta object for the reference list '
	 * {@link fr.irisa.espresso.sme.StateOrHistory#getDst_WeakTransitions <em>Dst Weak Transitions</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Dst Weak Transitions</em>'.
	 * @see fr.irisa.espresso.sme.StateOrHistory#getDst_WeakTransitions()
	 * @see #getStateOrHistory()
	 * @generated
	 */
	EReference getStateOrHistory_Dst_WeakTransitions();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.History <em>History</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>History</em>'.
	 * @see fr.irisa.espresso.sme.History
	 * @generated
	 */
	EClass getHistory();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.History#getParentState
	 * <em>Parent State</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Parent State</em>'.
	 * @see fr.irisa.espresso.sme.History#getParentState()
	 * @see #getHistory()
	 * @generated
	 */
	EReference getHistory_ParentState();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.StateBase <em>State Base</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>State Base</em>'.
	 * @see fr.irisa.espresso.sme.StateBase
	 * @generated
	 */
	EClass getStateBase();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.StateBase#getStateParent
	 * <em>State Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>State Parent</em>'.
	 * @see fr.irisa.espresso.sme.StateBase#getStateParent()
	 * @see #getStateBase()
	 * @generated
	 */
	EReference getStateBase_StateParent();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.StateBase#getSrc_WeakTransitions
	 * <em>Src Weak Transitions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Src Weak Transitions</em>'.
	 * @see fr.irisa.espresso.sme.StateBase#getSrc_WeakTransitions()
	 * @see #getStateBase()
	 * @generated
	 */
	EReference getStateBase_Src_WeakTransitions();
	
	/**
	 * Returns the meta object for the reference list '{@link fr.irisa.espresso.sme.StateBase#getSrc_StrongTransitions
	 * <em>Src Strong Transitions</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Src Strong Transitions</em>'.
	 * @see fr.irisa.espresso.sme.StateBase#getSrc_StrongTransitions()
	 * @see #getStateBase()
	 * @generated
	 */
	EReference getStateBase_Src_StrongTransitions();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.State <em>State</em>}'. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>State</em>'.
	 * @see fr.irisa.espresso.sme.State
	 * @generated
	 */
	EClass getState();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.CompoundState <em>Compound State</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Compound State</em>'.
	 * @see fr.irisa.espresso.sme.CompoundState
	 * @generated
	 */
	EClass getCompoundState();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.CompoundState#getStates
	 * <em>States</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>States</em>'.
	 * @see fr.irisa.espresso.sme.CompoundState#getStates()
	 * @see #getCompoundState()
	 * @generated
	 */
	EReference getCompoundState_States();
	
	/**
	 * Returns the meta object for the containment reference '{@link fr.irisa.espresso.sme.CompoundState#getHistory
	 * <em>History</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>History</em>'.
	 * @see fr.irisa.espresso.sme.CompoundState#getHistory()
	 * @see #getCompoundState()
	 * @generated
	 */
	EReference getCompoundState_History();
	
	/**
	 * Returns the meta object for the containment reference list '{@link fr.irisa.espresso.sme.CompoundState#getLocals
	 * <em>Locals</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Locals</em>'.
	 * @see fr.irisa.espresso.sme.CompoundState#getLocals()
	 * @see #getCompoundState()
	 * @generated
	 */
	EReference getCompoundState_Locals();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Automaton <em>Automaton</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Automaton</em>'.
	 * @see fr.irisa.espresso.sme.Automaton
	 * @generated
	 */
	EClass getAutomaton();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Automaton#getModelParent
	 * <em>Model Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Model Parent</em>'.
	 * @see fr.irisa.espresso.sme.Automaton#getModelParent()
	 * @see #getAutomaton()
	 * @generated
	 */
	EReference getAutomaton_ModelParent();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.Automaton#getInitState
	 * <em>Init State</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Init State</em>'.
	 * @see fr.irisa.espresso.sme.Automaton#getInitState()
	 * @see #getAutomaton()
	 * @generated
	 */
	EReference getAutomaton_InitState();
	
	/**
	 * Returns the meta object for the containment reference list '
	 * {@link fr.irisa.espresso.sme.Automaton#getTransitions <em>Transitions</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Transitions</em>'.
	 * @see fr.irisa.espresso.sme.Automaton#getTransitions()
	 * @see #getAutomaton()
	 * @generated
	 */
	EReference getAutomaton_Transitions();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.AndState <em>And State</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>And State</em>'.
	 * @see fr.irisa.espresso.sme.AndState
	 * @generated
	 */
	EClass getAndState();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.Transition <em>Transition</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Transition</em>'.
	 * @see fr.irisa.espresso.sme.Transition
	 * @generated
	 */
	EClass getTransition();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Transition#getGuard <em>Guard</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Guard</em>'.
	 * @see fr.irisa.espresso.sme.Transition#getGuard()
	 * @see #getTransition()
	 * @generated
	 */
	EAttribute getTransition_Guard();
	
	/**
	 * Returns the meta object for the attribute '{@link fr.irisa.espresso.sme.Transition#getPriority <em>Priority</em>}
	 * '. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Priority</em>'.
	 * @see fr.irisa.espresso.sme.Transition#getPriority()
	 * @see #getTransition()
	 * @generated
	 */
	EAttribute getTransition_Priority();
	
	/**
	 * Returns the meta object for the container reference '{@link fr.irisa.espresso.sme.Transition#getAutomatonParent
	 * <em>Automaton Parent</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Automaton Parent</em>'.
	 * @see fr.irisa.espresso.sme.Transition#getAutomatonParent()
	 * @see #getTransition()
	 * @generated
	 */
	EReference getTransition_AutomatonParent();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.WeakTransition <em>Weak Transition</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Weak Transition</em>'.
	 * @see fr.irisa.espresso.sme.WeakTransition
	 * @generated
	 */
	EClass getWeakTransition();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.WeakTransition#getSrc <em>Src</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Src</em>'.
	 * @see fr.irisa.espresso.sme.WeakTransition#getSrc()
	 * @see #getWeakTransition()
	 * @generated
	 */
	EReference getWeakTransition_Src();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.WeakTransition#getDst <em>Dst</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst</em>'.
	 * @see fr.irisa.espresso.sme.WeakTransition#getDst()
	 * @see #getWeakTransition()
	 * @generated
	 */
	EReference getWeakTransition_Dst();
	
	/**
	 * Returns the meta object for class '{@link fr.irisa.espresso.sme.StrongTransition <em>Strong Transition</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Strong Transition</em>'.
	 * @see fr.irisa.espresso.sme.StrongTransition
	 * @generated
	 */
	EClass getStrongTransition();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.StrongTransition#getSrc <em>Src</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Src</em>'.
	 * @see fr.irisa.espresso.sme.StrongTransition#getSrc()
	 * @see #getStrongTransition()
	 * @generated
	 */
	EReference getStrongTransition_Src();
	
	/**
	 * Returns the meta object for the reference '{@link fr.irisa.espresso.sme.StrongTransition#getDst <em>Dst</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Dst</em>'.
	 * @see fr.irisa.espresso.sme.StrongTransition#getDst()
	 * @see #getStrongTransition()
	 * @generated
	 */
	EReference getStrongTransition_Dst();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.SignalIntrinsicType
	 * <em>Signal Intrinsic Type</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Signal Intrinsic Type</em>'.
	 * @see fr.irisa.espresso.sme.SignalIntrinsicType
	 * @generated
	 */
	EEnum getSignalIntrinsicType();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.ModelKind <em>Model Kind</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Model Kind</em>'.
	 * @see fr.irisa.espresso.sme.ModelKind
	 * @generated
	 */
	EEnum getModelKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.ProcessAttributeKind
	 * <em>Process Attribute Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Process Attribute Kind</em>'.
	 * @see fr.irisa.espresso.sme.ProcessAttributeKind
	 * @generated
	 */
	EEnum getProcessAttributeKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.CompilationDirectiveKind
	 * <em>Compilation Directive Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Compilation Directive Kind</em>'.
	 * @see fr.irisa.espresso.sme.CompilationDirectiveKind
	 * @generated
	 */
	EEnum getCompilationDirectiveKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.SignalStateKind <em>Signal State Kind</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Signal State Kind</em>'.
	 * @see fr.irisa.espresso.sme.SignalStateKind
	 * @generated
	 */
	EEnum getSignalStateKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.CaseKind <em>Case Kind</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Case Kind</em>'.
	 * @see fr.irisa.espresso.sme.CaseKind
	 * @generated
	 */
	EEnum getCaseKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.TypeKind <em>Type Kind</em>}'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Type Kind</em>'.
	 * @see fr.irisa.espresso.sme.TypeKind
	 * @generated
	 */
	EEnum getTypeKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.ArithmeticOpKind <em>Arithmetic Op Kind</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Arithmetic Op Kind</em>'.
	 * @see fr.irisa.espresso.sme.ArithmeticOpKind
	 * @generated
	 */
	EEnum getArithmeticOpKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.ComparisonOpKind <em>Comparison Op Kind</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Comparison Op Kind</em>'.
	 * @see fr.irisa.espresso.sme.ComparisonOpKind
	 * @generated
	 */
	EEnum getComparisonOpKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.ClockConstraintOpKind
	 * <em>Clock Constraint Op Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Clock Constraint Op Kind</em>'.
	 * @see fr.irisa.espresso.sme.ClockConstraintOpKind
	 * @generated
	 */
	EEnum getClockConstraintOpKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.ClockRelationOpKind
	 * <em>Clock Relation Op Kind</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Clock Relation Op Kind</em>'.
	 * @see fr.irisa.espresso.sme.ClockRelationOpKind
	 * @generated
	 */
	EEnum getClockRelationOpKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.ClockSpeedOpKind <em>Clock Speed Op Kind</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Clock Speed Op Kind</em>'.
	 * @see fr.irisa.espresso.sme.ClockSpeedOpKind
	 * @generated
	 */
	EEnum getClockSpeedOpKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.VisibilityKind <em>Visibility Kind</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Visibility Kind</em>'.
	 * @see fr.irisa.espresso.sme.VisibilityKind
	 * @generated
	 */
	EEnum getVisibilityKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.CounterKind <em>Counter Kind</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Counter Kind</em>'.
	 * @see fr.irisa.espresso.sme.CounterKind
	 * @generated
	 */
	EEnum getCounterKind();
	
	/**
	 * Returns the meta object for enum '{@link fr.irisa.espresso.sme.StatusKind <em>Status Kind</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Status Kind</em>'.
	 * @see fr.irisa.espresso.sme.StatusKind
	 * @generated
	 */
	EEnum getStatusKind();
	
	/**
	 * Returns the meta object for data type '{@link fr.irisa.espresso.sme.polychrony.CyclicDefinitionException
	 * <em>Cyclic Definition Exception</em>}'. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for data type '<em>Cyclic Definition Exception</em>'.
	 * @see fr.irisa.espresso.sme.polychrony.CyclicDefinitionException
	 * @model instanceClass="fr.irisa.espresso.sme.polychrony.CyclicDefinitionException"
	 * @generated
	 */
	EDataType getCyclicDefinitionException();
	
	/**
	 * Returns the meta object for data type '{@link java.util.Set <em>Set</em>}'. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the meta object for data type '<em>Set</em>'.
	 * @see java.util.Set
	 * @model instanceClass="java.util.Set" typeParameters="E"
	 * @generated
	 */
	EDataType getSet();
	
	/**
	 * Returns the factory that creates the instances of the model. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SmeFactory getSmeFactory();
	
	/**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.RootModel <em>Root Model</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.RootModel
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getRootModel()
		 * @generated
		 */
		EClass		ROOT_MODEL										= eINSTANCE.getRootModel();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.SignalElement <em>Signal Element</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.SignalElement
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalElement()
		 * @generated
		 */
		EClass		SIGNAL_ELEMENT									= eINSTANCE.getSignalElement();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ConnectableElement
		 * <em>Connectable Element</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ConnectableElement
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConnectableElement()
		 * @generated
		 */
		EClass		CONNECTABLE_ELEMENT								= eINSTANCE.getConnectableElement();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.NamedElement <em>Named Element</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.NamedElement
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNamedElement()
		 * @generated
		 */
		EClass		NAMED_ELEMENT									= eINSTANCE.getNamedElement();
		
		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	NAMED_ELEMENT__NAME								= eINSTANCE.getNamedElement_Name();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.Identifier <em>Identifier</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.Identifier
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIdentifier()
		 * @generated
		 */
		EClass		IDENTIFIER										= eINSTANCE.getIdentifier();
		
		/**
		 * The meta object literal for the '<em><b>Comment</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	IDENTIFIER__COMMENT								= eINSTANCE.getIdentifier_Comment();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.SignalExpr <em>Signal Expr</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.SignalExpr
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalExpr()
		 * @generated
		 */
		EClass		SIGNAL_EXPR										= eINSTANCE.getSignalExpr();
		
		/**
		 * The meta object literal for the '<em><b>Src Dataflow Connections</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS			= eINSTANCE.getSignalExpr_Src_DataflowConnections();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ConstantExpr <em>Constant Expr</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ConstantExpr
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantExpr()
		 * @generated
		 */
		EClass		CONSTANT_EXPR									= eINSTANCE.getConstantExpr();
		
		/**
		 * The meta object literal for the '<em><b>Src Constant Affectations</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONSTANT_EXPR__SRC_CONSTANT_AFFECTATIONS		= eINSTANCE
																			.getConstantExpr_Src_ConstantAffectations();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ClockedExpr <em>Clocked Expr</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ClockedExpr
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockedExpr()
		 * @generated
		 */
		EClass		CLOCKED_EXPR									= eINSTANCE.getClockedExpr();
		
		/**
		 * The meta object literal for the '<em><b>Src Clock Relations</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CLOCKED_EXPR__SRC_CLOCK_RELATIONS				= eINSTANCE.getClockedExpr_Src_ClockRelations();
		
		/**
		 * The meta object literal for the '<em><b>Dst Clock Relations</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CLOCKED_EXPR__DST_CLOCK_RELATIONS				= eINSTANCE.getClockedExpr_Dst_ClockRelations();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.DependenceInOut <em>Dependence In Out</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.DependenceInOut
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDependenceInOut()
		 * @generated
		 */
		EClass		DEPENDENCE_IN_OUT								= eINSTANCE.getDependenceInOut();
		
		/**
		 * The meta object literal for the '<em><b>Src Dependences</b></em>' reference list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	DEPENDENCE_IN_OUT__SRC_DEPENDENCES				= eINSTANCE.getDependenceInOut_Src_Dependences();
		
		/**
		 * The meta object literal for the '<em><b>Dst Dependences</b></em>' reference list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	DEPENDENCE_IN_OUT__DST_DEPENDENCES				= eINSTANCE.getDependenceInOut_Dst_Dependences();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.SignalContainer <em>Signal Container</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.SignalContainer
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalContainer()
		 * @generated
		 */
		EClass		SIGNAL_CONTAINER								= eINSTANCE.getSignalContainer();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.InterfaceDefinition
		 * <em>Interface Definition</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.InterfaceDefinition
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getInterfaceDefinition()
		 * @generated
		 */
		EClass		INTERFACE_DEFINITION							= eINSTANCE.getInterfaceDefinition();
		
		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INTERFACE_DEFINITION__TYPE						= eINSTANCE.getInterfaceDefinition_Type();
		
		/**
		 * The meta object literal for the '<em><b>Inputs</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INTERFACE_DEFINITION__INPUTS					= eINSTANCE.getInterfaceDefinition_Inputs();
		
		/**
		 * The meta object literal for the '<em><b>Outputs</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INTERFACE_DEFINITION__OUTPUTS					= eINSTANCE.getInterfaceDefinition_Outputs();
		
		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INTERFACE_DEFINITION__PARAMETERS				= eINSTANCE.getInterfaceDefinition_Parameters();
		
		/**
		 * The meta object literal for the '<em><b>Spec</b></em>' containment reference feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INTERFACE_DEFINITION__SPEC						= eINSTANCE.getInterfaceDefinition_Spec();
		
		/**
		 * The meta object literal for the '<em><b>Pragmas</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INTERFACE_DEFINITION__PRAGMAS					= eINSTANCE.getInterfaceDefinition_Pragmas();
		
		/**
		 * The meta object literal for the '<em><b>Process Class</b></em>' attribute feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	INTERFACE_DEFINITION__PROCESS_CLASS				= eINSTANCE.getInterfaceDefinition_ProcessClass();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ModelImpl <em>Model</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ModelImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModel()
		 * @generated
		 */
		EClass		MODEL											= eINSTANCE.getModel();
		
		/**
		 * The meta object literal for the '<em><b>Assertions</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__ASSERTIONS								= eINSTANCE.getModel_Assertions();
		
		/**
		 * The meta object literal for the '<em><b>Automata</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__AUTOMATA									= eINSTANCE.getModel_Automata();
		
		/**
		 * The meta object literal for the '<em><b>Connections</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__CONNECTIONS								= eINSTANCE.getModel_Connections();
		
		/**
		 * The meta object literal for the '<em><b>Constant Ref</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__CONSTANT_REF								= eINSTANCE.getModel_ConstantRef();
		
		/**
		 * The meta object literal for the '<em><b>Constants</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__CONSTANTS								= eINSTANCE.getModel_Constants();
		
		/**
		 * The meta object literal for the '<em><b>Constraints</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__CONSTRAINTS								= eINSTANCE.getModel_Constraints();
		
		/**
		 * The meta object literal for the '<em><b>Indexes</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__INDEXES									= eINSTANCE.getModel_Indexes();
		
		/**
		 * The meta object literal for the '<em><b>Contained Instances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__CONTAINED_INSTANCES						= eINSTANCE.getModel_ContainedInstances();
		
		/**
		 * The meta object literal for the '<em><b>Literals</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__LITERALS									= eINSTANCE.getModel_Literals();
		
		/**
		 * The meta object literal for the '<em><b>Locals</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__LOCALS									= eINSTANCE.getModel_Locals();
		
		/**
		 * The meta object literal for the '<em><b>Operators</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__OPERATORS								= eINSTANCE.getModel_Operators();
		
		/**
		 * The meta object literal for the '<em><b>Signal Ref</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__SIGNAL_REF								= eINSTANCE.getModel_SignalRef();
		
		/**
		 * The meta object literal for the '<em><b>Subprocesses</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__SUBPROCESSES								= eINSTANCE.getModel_Subprocesses();
		
		/**
		 * The meta object literal for the '<em><b>Types</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__TYPES									= eINSTANCE.getModel_Types();
		
		/**
		 * The meta object literal for the '<em><b>Use Module</b></em>' containment reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__USE_MODULE								= eINSTANCE.getModel_UseModule();
		
		/**
		 * The meta object literal for the '<em><b>Model Refs</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL__MODEL_REFS								= eINSTANCE.getModel_ModelRefs();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.BasicIterateImpl <em>Basic Iterate</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.BasicIterateImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getBasicIterate()
		 * @generated
		 */
		EClass		BASIC_ITERATE									= eINSTANCE.getBasicIterate();
		
		/**
		 * The meta object literal for the '<em><b>Iteration Init</b></em>' containment reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	BASIC_ITERATE__ITERATION_INIT					= eINSTANCE.getBasicIterate_IterationInit();
		
		/**
		 * The meta object literal for the '<em><b>Iterator</b></em>' containment reference feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	BASIC_ITERATE__ITERATOR							= eINSTANCE.getBasicIterate_Iterator();
		
		/**
		 * The meta object literal for the '<em><b>Upper Bound</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	BASIC_ITERATE__UPPER_BOUND						= eINSTANCE.getBasicIterate_UpperBound();
		
		/**
		 * The meta object literal for the '<em><b>Iterator Name</b></em>' attribute feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	BASIC_ITERATE__ITERATOR_NAME					= eINSTANCE.getBasicIterate_IteratorName();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.IterateImpl <em>Iterate</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.IterateImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIterate()
		 * @generated
		 */
		EClass		ITERATE											= eINSTANCE.getIterate();
		
		/**
		 * The meta object literal for the '<em><b>Iteration Init</b></em>' containment reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ITERATE__ITERATION_INIT							= eINSTANCE.getIterate_IterationInit();
		
		/**
		 * The meta object literal for the '<em><b>Ins</b></em>' containment reference list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ITERATE__INS									= eINSTANCE.getIterate_Ins();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.IterationInitImpl <em>Iteration Init</em>}
		 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.IterationInitImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIterationInit()
		 * @generated
		 */
		EClass		ITERATION_INIT									= eINSTANCE.getIterationInit();
		
		/**
		 * The meta object literal for the '<em><b>Array Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ITERATION_INIT__ARRAY_PARENT					= eINSTANCE.getIterationInit_ArrayParent();
		
		/**
		 * The meta object literal for the '<em><b>Iterate Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ITERATION_INIT__ITERATE_PARENT					= eINSTANCE.getIterationInit_IterateParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.SpecificationsImpl
		 * <em>Specifications</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.SpecificationsImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSpecifications()
		 * @generated
		 */
		EClass		SPECIFICATIONS									= eINSTANCE.getSpecifications();
		
		/**
		 * The meta object literal for the '<em><b>Interface Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SPECIFICATIONS__INTERFACE_PARENT				= eINSTANCE.getSpecifications_InterfaceParent();
		
		/**
		 * The meta object literal for the '<em><b>Type Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SPECIFICATIONS__TYPE_PARENT						= eINSTANCE.getSpecifications_TypeParent();
		
		/**
		 * The meta object literal for the '<em><b>Model Declarations</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SPECIFICATIONS__MODEL_DECLARATIONS				= eINSTANCE.getSpecifications_ModelDeclarations();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.SubProcessImpl <em>Sub Process</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.SubProcessImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSubProcess()
		 * @generated
		 */
		EClass		SUB_PROCESS										= eINSTANCE.getSubProcess();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SUB_PROCESS__MODEL_PARENT						= eINSTANCE.getSubProcess_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>Dst Case Connection</b></em>' reference feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SUB_PROCESS__DST_CASE_CONNECTION				= eINSTANCE.getSubProcess_Dst_CaseConnection();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.TypeDeclarationImpl
		 * <em>Type Declaration</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.TypeDeclarationImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTypeDeclaration()
		 * @generated
		 */
		EClass		TYPE_DECLARATION								= eINSTANCE.getTypeDeclaration();
		
		/**
		 * The meta object literal for the '<em><b>Module Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	TYPE_DECLARATION__MODULE_PARENT					= eINSTANCE.getTypeDeclaration_ModuleParent();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	TYPE_DECLARATION__MODEL_PARENT					= eINSTANCE.getTypeDeclaration_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>Visibility</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	TYPE_DECLARATION__VISIBILITY					= eINSTANCE.getTypeDeclaration_Visibility();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ParameterType <em>Parameter Type</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ParameterType
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getParameterType()
		 * @generated
		 */
		EClass		PARAMETER_TYPE									= eINSTANCE.getParameterType();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.SignalType <em>Signal Type</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.SignalType
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalType()
		 * @generated
		 */
		EClass		SIGNAL_TYPE										= eINSTANCE.getSignalType();
		
		/**
		 * The meta object literal for the '<em><b>Array Dimensions</b></em>' attribute list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SIGNAL_TYPE__ARRAY_DIMENSIONS					= eINSTANCE.getSignalType_ArrayDimensions();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.EnumerationTypeImpl
		 * <em>Enumeration Type</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.EnumerationTypeImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getEnumerationType()
		 * @generated
		 */
		EClass		ENUMERATION_TYPE								= eINSTANCE.getEnumerationType();
		
		/**
		 * The meta object literal for the '<em><b>Enum Values</b></em>' attribute list feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	ENUMERATION_TYPE__ENUM_VALUES					= eINSTANCE.getEnumerationType_EnumValues();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ModelTypeImpl <em>Model Type</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ModelTypeImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelType()
		 * @generated
		 */
		EClass		MODEL_TYPE										= eINSTANCE.getModelType();
		
		/**
		 * The meta object literal for the '<em><b>Model Type</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_TYPE__MODEL_TYPE							= eINSTANCE.getModelType_ModelType();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.SubstitutionTypeImpl
		 * <em>Substitution Type</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.SubstitutionTypeImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSubstitutionType()
		 * @generated
		 */
		EClass		SUBSTITUTION_TYPE								= eINSTANCE.getSubstitutionType();
		
		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SUBSTITUTION_TYPE__TYPE							= eINSTANCE.getSubstitutionType_Type();
		
		/**
		 * The meta object literal for the '<em><b>Is External</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SUBSTITUTION_TYPE__IS_EXTERNAL					= eINSTANCE.getSubstitutionType_IsExternal();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.TupleTypeImpl <em>Tuple Type</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.TupleTypeImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTupleType()
		 * @generated
		 */
		EClass		TUPLE_TYPE										= eINSTANCE.getTupleType();
		
		/**
		 * The meta object literal for the '<em><b>Kind</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	TUPLE_TYPE__KIND								= eINSTANCE.getTupleType_Kind();
		
		/**
		 * The meta object literal for the '<em><b>Locals</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	TUPLE_TYPE__LOCALS								= eINSTANCE.getTupleType_Locals();
		
		/**
		 * The meta object literal for the '<em><b>Spec</b></em>' containment reference feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	TUPLE_TYPE__SPEC								= eINSTANCE.getTupleType_Spec();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ModelDeclarationImpl
		 * <em>Model Declaration</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ModelDeclarationImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelDeclaration()
		 * @generated
		 */
		EClass		MODEL_DECLARATION								= eINSTANCE.getModelDeclaration();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_DECLARATION__MODEL_PARENT					= eINSTANCE.getModelDeclaration_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>Module Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_DECLARATION__MODULE_PARENT				= eINSTANCE.getModelDeclaration_ModuleParent();
		
		/**
		 * The meta object literal for the '<em><b>Spec Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_DECLARATION__SPEC_PARENT					= eINSTANCE.getModelDeclaration_SpecParent();
		
		/**
		 * The meta object literal for the '<em><b>Model Type</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__MODEL_TYPE					= eINSTANCE.getModelDeclaration_ModelType();
		
		/**
		 * The meta object literal for the '<em><b>Visibility</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__VISIBILITY					= eINSTANCE.getModelDeclaration_Visibility();
		
		/**
		 * The meta object literal for the '<em><b>Is Main</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__IS_MAIN						= eINSTANCE.getModelDeclaration_IsMain();
		
		/**
		 * The meta object literal for the '<em><b>Is Sigali Process</b></em>' attribute feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__IS_SIGALI_PROCESS			= eINSTANCE.getModelDeclaration_IsSigaliProcess();
		
		/**
		 * The meta object literal for the '<em><b>Compilation Directive</b></em>' attribute feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__COMPILATION_DIRECTIVE		= eINSTANCE
																			.getModelDeclaration_CompilationDirective();
		
		/**
		 * The meta object literal for the '<em><b>Run On</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__RUN_ON						= eINSTANCE.getModelDeclaration_RunOn();
		
		/**
		 * The meta object literal for the '<em><b>CCODE</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__CCODE						= eINSTANCE.getModelDeclaration_C_CODE();
		
		/**
		 * The meta object literal for the '<em><b>Cpp CODE</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__CPP_CODE						= eINSTANCE.getModelDeclaration_Cpp_CODE();
		
		/**
		 * The meta object literal for the '<em><b>Java CODE</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__JAVA_CODE					= eINSTANCE.getModelDeclaration_Java_CODE();
		
		/**
		 * The meta object literal for the '<em><b>Processor type</b></em>' attribute feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_DECLARATION__PROCESSOR_TYPE				= eINSTANCE.getModelDeclaration_Processor_type();
		
		/**
		 * The meta object literal for the '<em><b>Model Declarations</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_DECLARATION__MODEL_DECLARATIONS			= eINSTANCE.getModelDeclaration_ModelDeclarations();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ModelRefImpl <em>Model Ref</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ModelRefImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelRef()
		 * @generated
		 */
		EClass		MODEL_REF										= eINSTANCE.getModelRef();
		
		/**
		 * The meta object literal for the '<em><b>Model</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_REF__MODEL								= eINSTANCE.getModelRef_Model();
		
		/**
		 * The meta object literal for the '<em><b>Model Name</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	MODEL_REF__MODEL_NAME							= eINSTANCE.getModelRef_ModelName();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_REF__MODEL_PARENT							= eINSTANCE.getModelRef_ModelParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ModelInstanceImpl <em>Model Instance</em>}
		 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ModelInstanceImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelInstance()
		 * @generated
		 */
		EClass		MODEL_INSTANCE									= eINSTANCE.getModelInstance();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_INSTANCE__MODEL_PARENT					= eINSTANCE.getModelInstance_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>Referred Interface</b></em>' reference feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_INSTANCE__REFERRED_INTERFACE				= eINSTANCE.getModelInstance_ReferredInterface();
		
		/**
		 * The meta object literal for the '<em><b>Referred Parameter</b></em>' reference feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_INSTANCE__REFERRED_PARAMETER				= eINSTANCE.getModelInstance_ReferredParameter();
		
		/**
		 * The meta object literal for the '<em><b>Inputs</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_INSTANCE__INPUTS							= eINSTANCE.getModelInstance_Inputs();
		
		/**
		 * The meta object literal for the '<em><b>Outputs</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_INSTANCE__OUTPUTS							= eINSTANCE.getModelInstance_Outputs();
		
		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_INSTANCE__PARAMETERS						= eINSTANCE.getModelInstance_Parameters();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ModuleImpl <em>Module</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ModuleImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModule()
		 * @generated
		 */
		EClass		MODULE											= eINSTANCE.getModule();
		
		/**
		 * The meta object literal for the '<em><b>Constants</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODULE__CONSTANTS								= eINSTANCE.getModule_Constants();
		
		/**
		 * The meta object literal for the '<em><b>Model Declarations</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODULE__MODEL_DECLARATIONS						= eINSTANCE.getModule_ModelDeclarations();
		
		/**
		 * The meta object literal for the '<em><b>Types</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODULE__TYPES									= eINSTANCE.getModule_Types();
		
		/**
		 * The meta object literal for the '<em><b>Use Module</b></em>' containment reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODULE__USE_MODULE								= eINSTANCE.getModule_UseModule();
		
		/**
		 * The meta object literal for the '<em><b>Pragmas</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODULE__PRAGMAS									= eINSTANCE.getModule_Pragmas();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.UseModuleImpl <em>Use Module</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.UseModuleImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getUseModule()
		 * @generated
		 */
		EClass		USE_MODULE										= eINSTANCE.getUseModule();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	USE_MODULE__MODEL_PARENT						= eINSTANCE.getUseModule_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>Module Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	USE_MODULE__MODULE_PARENT						= eINSTANCE.getUseModule_ModuleParent();
		
		/**
		 * The meta object literal for the '<em><b>Modules</b></em>' reference list feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	USE_MODULE__MODULES								= eINSTANCE.getUseModule_Modules();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.DataflowConnector <em>Dataflow Connector</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.DataflowConnector
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDataflowConnector()
		 * @generated
		 */
		EClass		DATAFLOW_CONNECTOR								= eINSTANCE.getDataflowConnector();
		
		/**
		 * The meta object literal for the '<em><b>Dst Dataflow Connections</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	DATAFLOW_CONNECTOR__DST_DATAFLOW_CONNECTIONS	= eINSTANCE
																			.getDataflowConnector_Dst_DataflowConnections();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ConstantOrRef <em>Constant Or Ref</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ConstantOrRef
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantOrRef()
		 * @generated
		 */
		EClass		CONSTANT_OR_REF									= eINSTANCE.getConstantOrRef();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ConstantRefImpl <em>Constant Ref</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ConstantRefImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantRef()
		 * @generated
		 */
		EClass		CONSTANT_REF									= eINSTANCE.getConstantRef();
		
		/**
		 * The meta object literal for the '<em><b>Constant</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONSTANT_REF__CONSTANT							= eINSTANCE.getConstantRef_Constant();
		
		/**
		 * The meta object literal for the '<em><b>Cst Name</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CONSTANT_REF__CST_NAME							= eINSTANCE.getConstantRef_CstName();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONSTANT_REF__MODEL_PARENT						= eINSTANCE.getConstantRef_ModelParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.Constant <em>Constant</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.Constant
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstant()
		 * @generated
		 */
		EClass		CONSTANT										= eINSTANCE.getConstant();
		
		/**
		 * The meta object literal for the '<em><b>Dst Constant Affectation</b></em>' reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONSTANT__DST_CONSTANT_AFFECTATION				= eINSTANCE.getConstant_Dst_ConstantAffectation();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ConstantValueImpl <em>Constant Value</em>}
		 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ConstantValueImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantValue()
		 * @generated
		 */
		EClass		CONSTANT_VALUE									= eINSTANCE.getConstantValue();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONSTANT_VALUE__MODEL_PARENT					= eINSTANCE.getConstantValue_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>Module Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONSTANT_VALUE__MODULE_PARENT					= eINSTANCE.getConstantValue_ModuleParent();
		
		/**
		 * The meta object literal for the '<em><b>Array Dimensions</b></em>' attribute list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CONSTANT_VALUE__ARRAY_DIMENSIONS				= eINSTANCE.getConstantValue_ArrayDimensions();
		
		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CONSTANT_VALUE__TYPE							= eINSTANCE.getConstantValue_Type();
		
		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute list feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CONSTANT_VALUE__VALUE							= eINSTANCE.getConstantValue_Value();
		
		/**
		 * The meta object literal for the '<em><b>Visibility</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CONSTANT_VALUE__VISIBILITY						= eINSTANCE.getConstantValue_Visibility();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.LiteralImpl <em>Literal</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.LiteralImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getLiteral()
		 * @generated
		 */
		EClass		LITERAL											= eINSTANCE.getLiteral();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	LITERAL__MODEL_PARENT							= eINSTANCE.getLiteral_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	LITERAL__VALUE									= eINSTANCE.getLiteral_Value();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.EnumerationValueImpl
		 * <em>Enumeration Value</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.EnumerationValueImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getEnumerationValue()
		 * @generated
		 */
		EClass		ENUMERATION_VALUE								= eINSTANCE.getEnumerationValue();
		
		/**
		 * The meta object literal for the '<em><b>Type Value</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	ENUMERATION_VALUE__TYPE_VALUE					= eINSTANCE.getEnumerationValue_TypeValue();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ParameterImpl <em>Parameter</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ParameterImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getParameter()
		 * @generated
		 */
		EClass		PARAMETER										= eINSTANCE.getParameter();
		
		/**
		 * The meta object literal for the '<em><b>Interface Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	PARAMETER__INTERFACE_PARENT						= eINSTANCE.getParameter_InterfaceParent();
		
		/**
		 * The meta object literal for the '<em><b>Array Dimensions</b></em>' attribute list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	PARAMETER__ARRAY_DIMENSIONS						= eINSTANCE.getParameter_ArrayDimensions();
		
		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	PARAMETER__TYPE									= eINSTANCE.getParameter_Type();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ParameterInstanceImpl
		 * <em>Parameter Instance</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ParameterInstanceImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getParameterInstance()
		 * @generated
		 */
		EClass		PARAMETER_INSTANCE								= eINSTANCE.getParameterInstance();
		
		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	PARAMETER_INSTANCE__PARAMETER					= eINSTANCE.getParameterInstance_Parameter();
		
		/**
		 * The meta object literal for the '<em><b>Instance Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	PARAMETER_INSTANCE__INSTANCE_PARENT				= eINSTANCE.getParameterInstance_InstanceParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.IteratorImpl <em>Iterator</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.IteratorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIterator()
		 * @generated
		 */
		EClass		ITERATOR										= eINSTANCE.getIterator();
		
		/**
		 * The meta object literal for the '<em><b>Array Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ITERATOR__ARRAY_PARENT							= eINSTANCE.getIterator_ArrayParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.IndexImpl <em>Index</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.IndexImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIndex()
		 * @generated
		 */
		EClass		INDEX											= eINSTANCE.getIndex();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INDEX__MODEL_PARENT								= eINSTANCE.getIndex_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>From</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	INDEX__FROM										= eINSTANCE.getIndex_From();
		
		/**
		 * The meta object literal for the '<em><b>To</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	INDEX__TO										= eINSTANCE.getIndex_To();
		
		/**
		 * The meta object literal for the '<em><b>Step</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	INDEX__STEP										= eINSTANCE.getIndex_Step();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.SignalOrRef <em>Signal Or Ref</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.SignalOrRef
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalOrRef()
		 * @generated
		 */
		EClass		SIGNAL_OR_REF									= eINSTANCE.getSignalOrRef();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.SignalRefImpl <em>Signal Ref</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.SignalRefImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalRef()
		 * @generated
		 */
		EClass		SIGNAL_REF										= eINSTANCE.getSignalRef();
		
		/**
		 * The meta object literal for the '<em><b>Signal</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SIGNAL_REF__SIGNAL								= eINSTANCE.getSignalRef_Signal();
		
		/**
		 * The meta object literal for the '<em><b>Sig Name</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SIGNAL_REF__SIG_NAME							= eINSTANCE.getSignalRef_SigName();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SIGNAL_REF__MODEL_PARENT						= eINSTANCE.getSignalRef_ModelParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.SignalImpl <em>Signal</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.SignalImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignal()
		 * @generated
		 */
		EClass		SIGNAL											= eINSTANCE.getSignal();
		
		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SIGNAL__TYPE									= eINSTANCE.getSignal_Type();
		
		/**
		 * The meta object literal for the '<em><b>Array Dimensions</b></em>' attribute list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SIGNAL__ARRAY_DIMENSIONS						= eINSTANCE.getSignal_ArrayDimensions();
		
		/**
		 * The meta object literal for the '<em><b>Init Value</b></em>' attribute list feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SIGNAL__INIT_VALUE								= eINSTANCE.getSignal_InitValue();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.InputImpl <em>Input</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.InputImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getInput()
		 * @generated
		 */
		EClass		INPUT											= eINSTANCE.getInput();
		
		/**
		 * The meta object literal for the '<em><b>Interface Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INPUT__INTERFACE_PARENT							= eINSTANCE.getInput_InterfaceParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.InputInstanceImpl <em>Input Instance</em>}
		 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.InputInstanceImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getInputInstance()
		 * @generated
		 */
		EClass		INPUT_INSTANCE									= eINSTANCE.getInputInstance();
		
		/**
		 * The meta object literal for the '<em><b>Input</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INPUT_INSTANCE__INPUT							= eINSTANCE.getInputInstance_Input();
		
		/**
		 * The meta object literal for the '<em><b>Instance Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INPUT_INSTANCE__INSTANCE_PARENT					= eINSTANCE.getInputInstance_InstanceParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.OutputImpl <em>Output</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.OutputImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOutput()
		 * @generated
		 */
		EClass		OUTPUT											= eINSTANCE.getOutput();
		
		/**
		 * The meta object literal for the '<em><b>Interface Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	OUTPUT__INTERFACE_PARENT						= eINSTANCE.getOutput_InterfaceParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.OutputInstanceImpl
		 * <em>Output Instance</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.OutputInstanceImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOutputInstance()
		 * @generated
		 */
		EClass		OUTPUT_INSTANCE									= eINSTANCE.getOutputInstance();
		
		/**
		 * The meta object literal for the '<em><b>Output</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	OUTPUT_INSTANCE__OUTPUT							= eINSTANCE.getOutputInstance_Output();
		
		/**
		 * The meta object literal for the '<em><b>Instance Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	OUTPUT_INSTANCE__INSTANCE_PARENT				= eINSTANCE.getOutputInstance_InstanceParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.LocalImpl <em>Local</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.LocalImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getLocal()
		 * @generated
		 */
		EClass		LOCAL											= eINSTANCE.getLocal();
		
		/**
		 * The meta object literal for the '<em><b>Status</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	LOCAL__STATUS									= eINSTANCE.getLocal_Status();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	LOCAL__MODEL_PARENT								= eINSTANCE.getLocal_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>State Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	LOCAL__STATE_PARENT								= eINSTANCE.getLocal_StateParent();
		
		/**
		 * The meta object literal for the '<em><b>Type Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	LOCAL__TYPE_PARENT								= eINSTANCE.getLocal_TypeParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ConnectionImpl <em>Connection</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ConnectionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConnection()
		 * @generated
		 */
		EClass		CONNECTION										= eINSTANCE.getConnection();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ModelConnectionImpl
		 * <em>Model Connection</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ModelConnectionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelConnection()
		 * @generated
		 */
		EClass		MODEL_CONNECTION								= eINSTANCE.getModelConnection();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MODEL_CONNECTION__MODEL_PARENT					= eINSTANCE.getModelConnection_ModelParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.CaseConnectionImpl
		 * <em>Case Connection</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.CaseConnectionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCaseConnection()
		 * @generated
		 */
		EClass		CASE_CONNECTION									= eINSTANCE.getCaseConnection();
		
		/**
		 * The meta object literal for the '<em><b>Case Kind</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CASE_CONNECTION__CASE_KIND						= eINSTANCE.getCaseConnection_CaseKind();
		
		/**
		 * The meta object literal for the '<em><b>Enumeration</b></em>' attribute list feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CASE_CONNECTION__ENUMERATION					= eINSTANCE.getCaseConnection_Enumeration();
		
		/**
		 * The meta object literal for the '<em><b>Lower Bound</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CASE_CONNECTION__LOWER_BOUND					= eINSTANCE.getCaseConnection_LowerBound();
		
		/**
		 * The meta object literal for the '<em><b>Upper Bound</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CASE_CONNECTION__UPPER_BOUND					= eINSTANCE.getCaseConnection_UpperBound();
		
		/**
		 * The meta object literal for the '<em><b>Case Label</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CASE_CONNECTION__CASE_LABEL						= eINSTANCE.getCaseConnection_CaseLabel();
		
		/**
		 * The meta object literal for the '<em><b>Src</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CASE_CONNECTION__SRC							= eINSTANCE.getCaseConnection_Src();
		
		/**
		 * The meta object literal for the '<em><b>Dst</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CASE_CONNECTION__DST							= eINSTANCE.getCaseConnection_Dst();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ClockRelationImpl <em>Clock Relation</em>}
		 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ClockRelationImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockRelation()
		 * @generated
		 */
		EClass		CLOCK_RELATION									= eINSTANCE.getClockRelation();
		
		/**
		 * The meta object literal for the '<em><b>Src</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CLOCK_RELATION__SRC								= eINSTANCE.getClockRelation_Src();
		
		/**
		 * The meta object literal for the '<em><b>Dst</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CLOCK_RELATION__DST								= eINSTANCE.getClockRelation_Dst();
		
		/**
		 * The meta object literal for the '<em><b>Src Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CLOCK_RELATION__SRC_FIELD						= eINSTANCE.getClockRelation_SrcField();
		
		/**
		 * The meta object literal for the '<em><b>Dst Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CLOCK_RELATION__DST_FIELD						= eINSTANCE.getClockRelation_DstField();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ConditionImpl <em>Condition</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ConditionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCondition()
		 * @generated
		 */
		EClass		CONDITION										= eINSTANCE.getCondition();
		
		/**
		 * The meta object literal for the '<em><b>Condition Kind</b></em>' attribute feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CONDITION__CONDITION_KIND						= eINSTANCE.getCondition_ConditionKind();
		
		/**
		 * The meta object literal for the '<em><b>Src</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONDITION__SRC									= eINSTANCE.getCondition_Src();
		
		/**
		 * The meta object literal for the '<em><b>Dst</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONDITION__DST									= eINSTANCE.getCondition_Dst();
		
		/**
		 * The meta object literal for the '<em><b>Src Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CONDITION__SRC_FIELD							= eINSTANCE.getCondition_SrcField();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ConstantAffectationImpl
		 * <em>Constant Affectation</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ConstantAffectationImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConstantAffectation()
		 * @generated
		 */
		EClass		CONSTANT_AFFECTATION							= eINSTANCE.getConstantAffectation();
		
		/**
		 * The meta object literal for the '<em><b>Src</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONSTANT_AFFECTATION__SRC						= eINSTANCE.getConstantAffectation_Src();
		
		/**
		 * The meta object literal for the '<em><b>Dst</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONSTANT_AFFECTATION__DST						= eINSTANCE.getConstantAffectation_Dst();
		
		/**
		 * The meta object literal for the '<em><b>Src Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CONSTANT_AFFECTATION__SRC_FIELD					= eINSTANCE.getConstantAffectation_SrcField();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.DependenceImpl <em>Dependence</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.DependenceImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDependence()
		 * @generated
		 */
		EClass		DEPENDENCE										= eINSTANCE.getDependence();
		
		/**
		 * The meta object literal for the '<em><b>Src</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	DEPENDENCE__SRC									= eINSTANCE.getDependence_Src();
		
		/**
		 * The meta object literal for the '<em><b>Dst</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	DEPENDENCE__DST									= eINSTANCE.getDependence_Dst();
		
		/**
		 * The meta object literal for the '<em><b>Src Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DEPENDENCE__SRC_FIELD							= eINSTANCE.getDependence_SrcField();
		
		/**
		 * The meta object literal for the '<em><b>Dst Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DEPENDENCE__DST_FIELD							= eINSTANCE.getDependence_DstField();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.DataflowConnectionImpl
		 * <em>Dataflow Connection</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.DataflowConnectionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDataflowConnection()
		 * @generated
		 */
		EClass		DATAFLOW_CONNECTION								= eINSTANCE.getDataflowConnection();
		
		/**
		 * The meta object literal for the '<em><b>Is Default Value</b></em>' attribute feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DATAFLOW_CONNECTION__IS_DEFAULT_VALUE			= eINSTANCE.getDataflowConnection_IsDefaultValue();
		
		/**
		 * The meta object literal for the '<em><b>Cast Type</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DATAFLOW_CONNECTION__CAST_TYPE					= eINSTANCE.getDataflowConnection_CastType();
		
		/**
		 * The meta object literal for the '<em><b>Use Src Clock</b></em>' attribute feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DATAFLOW_CONNECTION__USE_SRC_CLOCK				= eINSTANCE.getDataflowConnection_UseSrcClock();
		
		/**
		 * The meta object literal for the '<em><b>Use Last Iteration Value</b></em>' attribute feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DATAFLOW_CONNECTION__USE_LAST_ITERATION_VALUE	= eINSTANCE
																			.getDataflowConnection_UseLastIterationValue();
		
		/**
		 * The meta object literal for the '<em><b>Src</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	DATAFLOW_CONNECTION__SRC						= eINSTANCE.getDataflowConnection_Src();
		
		/**
		 * The meta object literal for the '<em><b>Dst</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	DATAFLOW_CONNECTION__DST						= eINSTANCE.getDataflowConnection_Dst();
		
		/**
		 * The meta object literal for the '<em><b>Src Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DATAFLOW_CONNECTION__SRC_FIELD					= eINSTANCE.getDataflowConnection_SrcField();
		
		/**
		 * The meta object literal for the '<em><b>Dst Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DATAFLOW_CONNECTION__DST_FIELD					= eINSTANCE.getDataflowConnection_DstField();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.OperatorPort <em>Operator Port</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.OperatorPort
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOperatorPort()
		 * @generated
		 */
		EClass		OPERATOR_PORT									= eINSTANCE.getOperatorPort();
		
		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	OPERATOR_PORT__NAME								= eINSTANCE.getOperatorPort_Name();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.InputPortImpl <em>Input Port</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.InputPortImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getInputPort()
		 * @generated
		 */
		EClass		INPUT_PORT										= eINSTANCE.getInputPort();
		
		/**
		 * The meta object literal for the '<em><b>Operator Parent</b></em>' reference feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	INPUT_PORT__OPERATOR_PARENT						= eINSTANCE.getInputPort_OperatorParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.OutputPortImpl <em>Output Port</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.OutputPortImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOutputPort()
		 * @generated
		 */
		EClass		OUTPUT_PORT										= eINSTANCE.getOutputPort();
		
		/**
		 * The meta object literal for the '<em><b>Operator Parent</b></em>' reference feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	OUTPUT_PORT__OPERATOR_PARENT					= eINSTANCE.getOutputPort_OperatorParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.SignalOperator <em>Signal Operator</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.SignalOperator
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalOperator()
		 * @generated
		 */
		EClass		SIGNAL_OPERATOR									= eINSTANCE.getSignalOperator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ConditionExpr <em>Condition Expr</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ConditionExpr
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConditionExpr()
		 * @generated
		 */
		EClass		CONDITION_EXPR									= eINSTANCE.getConditionExpr();
		
		/**
		 * The meta object literal for the '<em><b>Src Conditions</b></em>' reference list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONDITION_EXPR__SRC_CONDITIONS					= eINSTANCE.getConditionExpr_Src_Conditions();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ConditionnedExpr <em>Conditionned Expr</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ConditionnedExpr
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConditionnedExpr()
		 * @generated
		 */
		EClass		CONDITIONNED_EXPR								= eINSTANCE.getConditionnedExpr();
		
		/**
		 * The meta object literal for the '<em><b>Dst Condition</b></em>' reference list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONDITIONNED_EXPR__DST_CONDITION				= eINSTANCE.getConditionnedExpr_Dst_Condition();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ControlflowOperator
		 * <em>Controlflow Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ControlflowOperator
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getControlflowOperator()
		 * @generated
		 */
		EClass		CONTROLFLOW_OPERATOR							= eINSTANCE.getControlflowOperator();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CONTROLFLOW_OPERATOR__MODEL_PARENT				= eINSTANCE.getControlflowOperator_ModelParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.DataflowOperator <em>Dataflow Operator</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.DataflowOperator
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDataflowOperator()
		 * @generated
		 */
		EClass		DATAFLOW_OPERATOR								= eINSTANCE.getDataflowOperator();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	DATAFLOW_OPERATOR__MODEL_PARENT					= eINSTANCE.getDataflowOperator_ModelParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.BooleanOperatorI <em>Boolean Operator I</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.BooleanOperatorI
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getBooleanOperatorI()
		 * @generated
		 */
		EClass		BOOLEAN_OPERATOR_I								= eINSTANCE.getBooleanOperatorI();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.NumericOperatorI <em>Numeric Operator I</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.NumericOperatorI
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNumericOperatorI()
		 * @generated
		 */
		EClass		NUMERIC_OPERATOR_I								= eINSTANCE.getNumericOperatorI();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.SingleInputOperatorImpl
		 * <em>Single Input Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.SingleInputOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSingleInputOperator()
		 * @generated
		 */
		EClass		SINGLE_INPUT_OPERATOR							= eINSTANCE.getSingleInputOperator();
		
		/**
		 * The meta object literal for the '<em><b>In</b></em>' containment reference feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SINGLE_INPUT_OPERATOR__IN						= eINSTANCE.getSingleInputOperator_In();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.TwoInputsOperatorImpl
		 * <em>Two Inputs Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.TwoInputsOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTwoInputsOperator()
		 * @generated
		 */
		EClass		TWO_INPUTS_OPERATOR								= eINSTANCE.getTwoInputsOperator();
		
		/**
		 * The meta object literal for the '<em><b>First Operand</b></em>' containment reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	TWO_INPUTS_OPERATOR__FIRST_OPERAND				= eINSTANCE.getTwoInputsOperator_FirstOperand();
		
		/**
		 * The meta object literal for the '<em><b>Second Operand</b></em>' containment reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	TWO_INPUTS_OPERATOR__SECOND_OPERAND				= eINSTANCE.getTwoInputsOperator_SecondOperand();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.MultipleInputsOperatorImpl
		 * <em>Multiple Inputs Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.MultipleInputsOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getMultipleInputsOperator()
		 * @generated
		 */
		EClass		MULTIPLE_INPUTS_OPERATOR						= eINSTANCE.getMultipleInputsOperator();
		
		/**
		 * The meta object literal for the '<em><b>Ins</b></em>' containment reference list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	MULTIPLE_INPUTS_OPERATOR__INS					= eINSTANCE.getMultipleInputsOperator_Ins();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.AndImpl <em>And</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.AndImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAnd()
		 * @generated
		 */
		EClass		AND												= eINSTANCE.getAnd();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ArithmeticOperatorImpl
		 * <em>Arithmetic Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ArithmeticOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArithmeticOperator()
		 * @generated
		 */
		EClass		ARITHMETIC_OPERATOR								= eINSTANCE.getArithmeticOperator();
		
		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	ARITHMETIC_OPERATOR__OPERATOR					= eINSTANCE.getArithmeticOperator_Operator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ArrayEnumerationImpl
		 * <em>Array Enumeration</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ArrayEnumerationImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArrayEnumeration()
		 * @generated
		 */
		EClass		ARRAY_ENUMERATION								= eINSTANCE.getArrayEnumeration();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ArrayProductImpl <em>Array Product</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ArrayProductImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArrayProduct()
		 * @generated
		 */
		EClass		ARRAY_PRODUCT									= eINSTANCE.getArrayProduct();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ArrayRecoveryImpl <em>Array Recovery</em>}
		 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ArrayRecoveryImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArrayRecovery()
		 * @generated
		 */
		EClass		ARRAY_RECOVERY									= eINSTANCE.getArrayRecovery();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ArrayRestructurationImpl
		 * <em>Array Restructuration</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ArrayRestructurationImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArrayRestructuration()
		 * @generated
		 */
		EClass		ARRAY_RESTRUCTURATION							= eINSTANCE.getArrayRestructuration();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.AssertionImpl <em>Assertion</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.AssertionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAssertion()
		 * @generated
		 */
		EClass		ASSERTION										= eINSTANCE.getAssertion();
		
		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	ASSERTION__EXPRESSION							= eINSTANCE.getAssertion_Expression();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	ASSERTION__MODEL_PARENT							= eINSTANCE.getAssertion_ModelParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.AssertionClockConstraintOperatorImpl
		 * <em>Assertion Clock Constraint Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.AssertionClockConstraintOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAssertionClockConstraintOperator()
		 * @generated
		 */
		EClass		ASSERTION_CLOCK_CONSTRAINT_OPERATOR				= eINSTANCE.getAssertionClockConstraintOperator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.AssertionClockSpeedOperatorImpl
		 * <em>Assertion Clock Speed Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.AssertionClockSpeedOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAssertionClockSpeedOperator()
		 * @generated
		 */
		EClass		ASSERTION_CLOCK_SPEED_OPERATOR					= eINSTANCE.getAssertionClockSpeedOperator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.BooleanExpressionImpl
		 * <em>Boolean Expression</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.BooleanExpressionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getBooleanExpression()
		 * @generated
		 */
		EClass		BOOLEAN_EXPRESSION								= eINSTANCE.getBooleanExpression();
		
		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	BOOLEAN_EXPRESSION__EXPRESSION					= eINSTANCE.getBooleanExpression_Expression();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.CartesianProductImpl
		 * <em>Cartesian Product</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.CartesianProductImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCartesianProduct()
		 * @generated
		 */
		EClass		CARTESIAN_PRODUCT								= eINSTANCE.getCartesianProduct();
		
		/**
		 * The meta object literal for the '<em><b>Outs</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	CARTESIAN_PRODUCT__OUTS							= eINSTANCE.getCartesianProduct_Outs();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.CellImpl <em>Cell</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.CellImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCell()
		 * @generated
		 */
		EClass		CELL											= eINSTANCE.getCell();
		
		/**
		 * The meta object literal for the '<em><b>Initial Value</b></em>' attribute list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CELL__INITIAL_VALUE								= eINSTANCE.getCell_InitialValue();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ClockConstraintOperatorImpl
		 * <em>Clock Constraint Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ClockConstraintOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockConstraintOperator()
		 * @generated
		 */
		EClass		CLOCK_CONSTRAINT_OPERATOR						= eINSTANCE.getClockConstraintOperator();
		
		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CLOCK_CONSTRAINT_OPERATOR__OPERATOR				= eINSTANCE.getClockConstraintOperator_Operator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ClockRelationOperatorImpl
		 * <em>Clock Relation Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ClockRelationOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockRelationOperator()
		 * @generated
		 */
		EClass		CLOCK_RELATION_OPERATOR							= eINSTANCE.getClockRelationOperator();
		
		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CLOCK_RELATION_OPERATOR__OPERATOR				= eINSTANCE.getClockRelationOperator_Operator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ClockSpeedOperatorImpl
		 * <em>Clock Speed Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ClockSpeedOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockSpeedOperator()
		 * @generated
		 */
		EClass		CLOCK_SPEED_OPERATOR							= eINSTANCE.getClockSpeedOperator();
		
		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	CLOCK_SPEED_OPERATOR__OPERATOR					= eINSTANCE.getClockSpeedOperator_Operator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ComparisonOperatorImpl
		 * <em>Comparison Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ComparisonOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getComparisonOperator()
		 * @generated
		 */
		EClass		COMPARISON_OPERATOR								= eINSTANCE.getComparisonOperator();
		
		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	COMPARISON_OPERATOR__OPERATOR					= eINSTANCE.getComparisonOperator_Operator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ComplexOperatorImpl
		 * <em>Complex Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ComplexOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getComplexOperator()
		 * @generated
		 */
		EClass		COMPLEX_OPERATOR								= eINSTANCE.getComplexOperator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ConcatenationImpl <em>Concatenation</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ConcatenationImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getConcatenation()
		 * @generated
		 */
		EClass		CONCATENATION									= eINSTANCE.getConcatenation();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.CounterImpl <em>Counter</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.CounterImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCounter()
		 * @generated
		 */
		EClass		COUNTER											= eINSTANCE.getCounter();
		
		/**
		 * The meta object literal for the '<em><b>Counter Kind</b></em>' attribute feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	COUNTER__COUNTER_KIND							= eINSTANCE.getCounter_CounterKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.DelayImpl <em>Delay</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.DelayImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDelay()
		 * @generated
		 */
		EClass		DELAY											= eINSTANCE.getDelay();
		
		/**
		 * The meta object literal for the '<em><b>Nb Instants</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DELAY__NB_INSTANTS								= eINSTANCE.getDelay_NbInstants();
		
		/**
		 * The meta object literal for the '<em><b>Initial Value</b></em>' attribute list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	DELAY__INITIAL_VALUE							= eINSTANCE.getDelay_InitialValue();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.DependenceOperatorImpl
		 * <em>Dependence Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.DependenceOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getDependenceOperator()
		 * @generated
		 */
		EClass		DEPENDENCE_OPERATOR								= eINSTANCE.getDependenceOperator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.ExtractionImpl <em>Extraction</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.ExtractionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getExtraction()
		 * @generated
		 */
		EClass		EXTRACTION										= eINSTANCE.getExtraction();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.IfThenElseImpl <em>If Then Else</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.IfThenElseImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getIfThenElse()
		 * @generated
		 */
		EClass		IF_THEN_ELSE									= eINSTANCE.getIfThenElse();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.MergeImpl <em>Merge</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.MergeImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getMerge()
		 * @generated
		 */
		EClass		MERGE											= eINSTANCE.getMerge();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.NotImpl <em>Not</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.NotImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNot()
		 * @generated
		 */
		EClass		NOT												= eINSTANCE.getNot();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.NullClockImpl <em>Null Clock</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.NullClockImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNullClock()
		 * @generated
		 */
		EClass		NULL_CLOCK										= eINSTANCE.getNullClock();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.NumericExpressionImpl
		 * <em>Numeric Expression</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.NumericExpressionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getNumericExpression()
		 * @generated
		 */
		EClass		NUMERIC_EXPRESSION								= eINSTANCE.getNumericExpression();
		
		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	NUMERIC_EXPRESSION__EXPRESSION					= eINSTANCE.getNumericExpression_Expression();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.OrImpl <em>Or</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.OrImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getOr()
		 * @generated
		 */
		EClass		OR												= eINSTANCE.getOr();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.PragmaImpl <em>Pragma</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.PragmaImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getPragma()
		 * @generated
		 */
		EClass		PRAGMA											= eINSTANCE.getPragma();
		
		/**
		 * The meta object literal for the '<em><b>Interface Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	PRAGMA__INTERFACE_PARENT						= eINSTANCE.getPragma_InterfaceParent();
		
		/**
		 * The meta object literal for the '<em><b>Module Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	PRAGMA__MODULE_PARENT							= eINSTANCE.getPragma_ModuleParent();
		
		/**
		 * The meta object literal for the '<em><b>Pragma</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	PRAGMA__PRAGMA									= eINSTANCE.getPragma_Pragma();
		
		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	PRAGMA__EXPRESSION								= eINSTANCE.getPragma_Expression();
		
		/**
		 * The meta object literal for the '<em><b>Targets</b></em>' reference list feature. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	PRAGMA__TARGETS									= eINSTANCE.getPragma_Targets();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.RepetitionOperatorImpl
		 * <em>Repetition Operator</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.RepetitionOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getRepetitionOperator()
		 * @generated
		 */
		EClass		REPETITION_OPERATOR								= eINSTANCE.getRepetitionOperator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.SequentialDefinitionImpl
		 * <em>Sequential Definition</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.SequentialDefinitionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSequentialDefinition()
		 * @generated
		 */
		EClass		SEQUENTIAL_DEFINITION							= eINSTANCE.getSequentialDefinition();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.SwitchImpl <em>Switch</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.SwitchImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSwitch()
		 * @generated
		 */
		EClass		SWITCH											= eINSTANCE.getSwitch();
		
		/**
		 * The meta object literal for the '<em><b>Signal</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SWITCH__SIGNAL									= eINSTANCE.getSwitch_Signal();
		
		/**
		 * The meta object literal for the '<em><b>Src Case Connections</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	SWITCH__SRC_CASE_CONNECTIONS					= eINSTANCE.getSwitch_Src_CaseConnections();
		
		/**
		 * The meta object literal for the '<em><b>Src Field</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	SWITCH__SRC_FIELD								= eINSTANCE.getSwitch_SrcField();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.TranspositionImpl <em>Transposition</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.TranspositionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTransposition()
		 * @generated
		 */
		EClass		TRANSPOSITION									= eINSTANCE.getTransposition();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.TupleOperatorImpl <em>Tuple Operator</em>}
		 * ' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.TupleOperatorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTupleOperator()
		 * @generated
		 */
		EClass		TUPLE_OPERATOR									= eINSTANCE.getTupleOperator();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.UnaryMinusImpl <em>Unary Minus</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.UnaryMinusImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getUnaryMinus()
		 * @generated
		 */
		EClass		UNARY_MINUS										= eINSTANCE.getUnaryMinus();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.VariableImpl <em>Variable</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.VariableImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getVariable()
		 * @generated
		 */
		EClass		VARIABLE										= eINSTANCE.getVariable();
		
		/**
		 * The meta object literal for the '<em><b>Initial Value</b></em>' attribute list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	VARIABLE__INITIAL_VALUE							= eINSTANCE.getVariable_InitialValue();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.WindowImpl <em>Window</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.WindowImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getWindow()
		 * @generated
		 */
		EClass		WINDOW											= eINSTANCE.getWindow();
		
		/**
		 * The meta object literal for the '<em><b>Window Size</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	WINDOW__WINDOW_SIZE								= eINSTANCE.getWindow_WindowSize();
		
		/**
		 * The meta object literal for the '<em><b>Initial Value</b></em>' attribute list feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	WINDOW__INITIAL_VALUE							= eINSTANCE.getWindow_InitialValue();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.XorImpl <em>Xor</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.XorImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getXor()
		 * @generated
		 */
		EClass		XOR												= eINSTANCE.getXor();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.StateOrHistory <em>State Or History</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.StateOrHistory
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getStateOrHistory()
		 * @generated
		 */
		EClass		STATE_OR_HISTORY								= eINSTANCE.getStateOrHistory();
		
		/**
		 * The meta object literal for the '<em><b>Dst Strong Transitions</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	STATE_OR_HISTORY__DST_STRONG_TRANSITIONS		= eINSTANCE
																			.getStateOrHistory_Dst_StrongTransitions();
		
		/**
		 * The meta object literal for the '<em><b>Dst Weak Transitions</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	STATE_OR_HISTORY__DST_WEAK_TRANSITIONS			= eINSTANCE.getStateOrHistory_Dst_WeakTransitions();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.HistoryImpl <em>History</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.HistoryImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getHistory()
		 * @generated
		 */
		EClass		HISTORY											= eINSTANCE.getHistory();
		
		/**
		 * The meta object literal for the '<em><b>Parent State</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	HISTORY__PARENT_STATE							= eINSTANCE.getHistory_ParentState();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.StateBase <em>State Base</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.StateBase
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getStateBase()
		 * @generated
		 */
		EClass		STATE_BASE										= eINSTANCE.getStateBase();
		
		/**
		 * The meta object literal for the '<em><b>State Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	STATE_BASE__STATE_PARENT						= eINSTANCE.getStateBase_StateParent();
		
		/**
		 * The meta object literal for the '<em><b>Src Weak Transitions</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	STATE_BASE__SRC_WEAK_TRANSITIONS				= eINSTANCE.getStateBase_Src_WeakTransitions();
		
		/**
		 * The meta object literal for the '<em><b>Src Strong Transitions</b></em>' reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	STATE_BASE__SRC_STRONG_TRANSITIONS				= eINSTANCE.getStateBase_Src_StrongTransitions();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.StateImpl <em>State</em>}' class. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.StateImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getState()
		 * @generated
		 */
		EClass		STATE											= eINSTANCE.getState();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.CompoundState <em>Compound State</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.CompoundState
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCompoundState()
		 * @generated
		 */
		EClass		COMPOUND_STATE									= eINSTANCE.getCompoundState();
		
		/**
		 * The meta object literal for the '<em><b>States</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	COMPOUND_STATE__STATES							= eINSTANCE.getCompoundState_States();
		
		/**
		 * The meta object literal for the '<em><b>History</b></em>' containment reference feature. <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	COMPOUND_STATE__HISTORY							= eINSTANCE.getCompoundState_History();
		
		/**
		 * The meta object literal for the '<em><b>Locals</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	COMPOUND_STATE__LOCALS							= eINSTANCE.getCompoundState_Locals();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.AutomatonImpl <em>Automaton</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.AutomatonImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAutomaton()
		 * @generated
		 */
		EClass		AUTOMATON										= eINSTANCE.getAutomaton();
		
		/**
		 * The meta object literal for the '<em><b>Model Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	AUTOMATON__MODEL_PARENT							= eINSTANCE.getAutomaton_ModelParent();
		
		/**
		 * The meta object literal for the '<em><b>Init State</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	AUTOMATON__INIT_STATE							= eINSTANCE.getAutomaton_InitState();
		
		/**
		 * The meta object literal for the '<em><b>Transitions</b></em>' containment reference list feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	AUTOMATON__TRANSITIONS							= eINSTANCE.getAutomaton_Transitions();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.AndStateImpl <em>And State</em>}' class.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.AndStateImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getAndState()
		 * @generated
		 */
		EClass		AND_STATE										= eINSTANCE.getAndState();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.TransitionImpl <em>Transition</em>}'
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.TransitionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTransition()
		 * @generated
		 */
		EClass		TRANSITION										= eINSTANCE.getTransition();
		
		/**
		 * The meta object literal for the '<em><b>Guard</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	TRANSITION__GUARD								= eINSTANCE.getTransition_Guard();
		
		/**
		 * The meta object literal for the '<em><b>Priority</b></em>' attribute feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute	TRANSITION__PRIORITY							= eINSTANCE.getTransition_Priority();
		
		/**
		 * The meta object literal for the '<em><b>Automaton Parent</b></em>' container reference feature. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	TRANSITION__AUTOMATON_PARENT					= eINSTANCE.getTransition_AutomatonParent();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.WeakTransitionImpl
		 * <em>Weak Transition</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.WeakTransitionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getWeakTransition()
		 * @generated
		 */
		EClass		WEAK_TRANSITION									= eINSTANCE.getWeakTransition();
		
		/**
		 * The meta object literal for the '<em><b>Src</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	WEAK_TRANSITION__SRC							= eINSTANCE.getWeakTransition_Src();
		
		/**
		 * The meta object literal for the '<em><b>Dst</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	WEAK_TRANSITION__DST							= eINSTANCE.getWeakTransition_Dst();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.impl.StrongTransitionImpl
		 * <em>Strong Transition</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.impl.StrongTransitionImpl
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getStrongTransition()
		 * @generated
		 */
		EClass		STRONG_TRANSITION								= eINSTANCE.getStrongTransition();
		
		/**
		 * The meta object literal for the '<em><b>Src</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	STRONG_TRANSITION__SRC							= eINSTANCE.getStrongTransition_Src();
		
		/**
		 * The meta object literal for the '<em><b>Dst</b></em>' reference feature. <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * 
		 * @generated
		 */
		EReference	STRONG_TRANSITION__DST							= eINSTANCE.getStrongTransition_Dst();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.SignalIntrinsicType
		 * <em>Signal Intrinsic Type</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.SignalIntrinsicType
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalIntrinsicType()
		 * @generated
		 */
		EEnum		SIGNAL_INTRINSIC_TYPE							= eINSTANCE.getSignalIntrinsicType();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ModelKind <em>Model Kind</em>}' enum. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ModelKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getModelKind()
		 * @generated
		 */
		EEnum		MODEL_KIND										= eINSTANCE.getModelKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ProcessAttributeKind
		 * <em>Process Attribute Kind</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ProcessAttributeKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getProcessAttributeKind()
		 * @generated
		 */
		EEnum		PROCESS_ATTRIBUTE_KIND							= eINSTANCE.getProcessAttributeKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.CompilationDirectiveKind
		 * <em>Compilation Directive Kind</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.CompilationDirectiveKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCompilationDirectiveKind()
		 * @generated
		 */
		EEnum		COMPILATION_DIRECTIVE_KIND						= eINSTANCE.getCompilationDirectiveKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.SignalStateKind <em>Signal State Kind</em>}'
		 * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.SignalStateKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSignalStateKind()
		 * @generated
		 */
		EEnum		SIGNAL_STATE_KIND								= eINSTANCE.getSignalStateKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.CaseKind <em>Case Kind</em>}' enum. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.CaseKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCaseKind()
		 * @generated
		 */
		EEnum		CASE_KIND										= eINSTANCE.getCaseKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.TypeKind <em>Type Kind</em>}' enum. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.TypeKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getTypeKind()
		 * @generated
		 */
		EEnum		TYPE_KIND										= eINSTANCE.getTypeKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ArithmeticOpKind <em>Arithmetic Op Kind</em>}'
		 * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ArithmeticOpKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getArithmeticOpKind()
		 * @generated
		 */
		EEnum		ARITHMETIC_OP_KIND								= eINSTANCE.getArithmeticOpKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ComparisonOpKind <em>Comparison Op Kind</em>}'
		 * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ComparisonOpKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getComparisonOpKind()
		 * @generated
		 */
		EEnum		COMPARISON_OP_KIND								= eINSTANCE.getComparisonOpKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ClockConstraintOpKind
		 * <em>Clock Constraint Op Kind</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ClockConstraintOpKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockConstraintOpKind()
		 * @generated
		 */
		EEnum		CLOCK_CONSTRAINT_OP_KIND						= eINSTANCE.getClockConstraintOpKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ClockRelationOpKind
		 * <em>Clock Relation Op Kind</em>}' enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ClockRelationOpKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockRelationOpKind()
		 * @generated
		 */
		EEnum		CLOCK_RELATION_OP_KIND							= eINSTANCE.getClockRelationOpKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.ClockSpeedOpKind <em>Clock Speed Op Kind</em>}'
		 * enum. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.ClockSpeedOpKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getClockSpeedOpKind()
		 * @generated
		 */
		EEnum		CLOCK_SPEED_OP_KIND								= eINSTANCE.getClockSpeedOpKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.VisibilityKind <em>Visibility Kind</em>}' enum.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.VisibilityKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getVisibilityKind()
		 * @generated
		 */
		EEnum		VISIBILITY_KIND									= eINSTANCE.getVisibilityKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.CounterKind <em>Counter Kind</em>}' enum. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.CounterKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCounterKind()
		 * @generated
		 */
		EEnum		COUNTER_KIND									= eINSTANCE.getCounterKind();
		
		/**
		 * The meta object literal for the '{@link fr.irisa.espresso.sme.StatusKind <em>Status Kind</em>}' enum. <!--
		 * begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.StatusKind
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getStatusKind()
		 * @generated
		 */
		EEnum		STATUS_KIND										= eINSTANCE.getStatusKind();
		
		/**
		 * The meta object literal for the '<em>Cyclic Definition Exception</em>' data type. <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see fr.irisa.espresso.sme.polychrony.CyclicDefinitionException
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getCyclicDefinitionException()
		 * @generated
		 */
		EDataType	CYCLIC_DEFINITION_EXCEPTION						= eINSTANCE.getCyclicDefinitionException();
		
		/**
		 * The meta object literal for the '<em>Set</em>' data type. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @see java.util.Set
		 * @see fr.irisa.espresso.sme.impl.SmePackageImpl#getSet()
		 * @generated
		 */
		EDataType	SET												= eINSTANCE.getSet();
		
	}
	
} // SmePackage
