/*
 * Authors: Loïc Besnard, Christian Brunette, Jean-Pierre Talpin. Copyright (C) by INRIA-CNRS - developed by Espresso
 * project - EPL License - 2010.
 * 
 * Contact: polychronycontact@listes.irisa.fr
 * 
 * This file is part of Polychrony SME Platform (website: http://www.irisa.fr/espresso/polychrony).
 * 
 * Polychrony SME Platform is free software; you can redistribute it and/or modify it under the terms of the EPL as
 * published by the Eclipse Foundation.
 * 
 * Polychrony SME Platform are distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License - v 1.0
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License - v 1.0 along with Polychrony SME Platform; see the
 * file COPYING. If not, consult the url http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse
 * Foundation, Inc. 102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
 */

package fr.irisa.espresso.sme.impl;

import java.util.Set;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import fr.irisa.espresso.sme.*;
import fr.irisa.espresso.sme.polychrony.CyclicDefinitionException;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package</b>. <!-- end-user-doc -->
 * 
 * @generated
 */
public class SmePackageImpl extends EPackageImpl implements SmePackage {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		rootModelEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		signalElementEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		connectableElementEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		namedElementEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		identifierEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		signalExprEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		constantExprEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		clockedExprEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		dependenceInOutEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		signalContainerEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		interfaceDefinitionEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		modelEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		basicIterateEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		iterateEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		iterationInitEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		specificationsEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		subProcessEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		typeDeclarationEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		parameterTypeEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		signalTypeEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		enumerationTypeEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		modelTypeEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		substitutionTypeEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		tupleTypeEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		modelDeclarationEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		modelRefEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		modelInstanceEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		moduleEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		useModuleEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		dataflowConnectorEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		constantOrRefEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		constantRefEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		constantEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		constantValueEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		literalEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		enumerationValueEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		parameterEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		parameterInstanceEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		iteratorEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		indexEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		signalOrRefEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		signalRefEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		signalEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		inputEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		inputInstanceEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		outputEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		outputInstanceEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		localEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		connectionEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		modelConnectionEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		caseConnectionEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		clockRelationEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		conditionEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		constantAffectationEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		dependenceEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		dataflowConnectionEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		operatorPortEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		inputPortEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		outputPortEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		signalOperatorEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		conditionExprEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		conditionnedExprEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		controlflowOperatorEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		dataflowOperatorEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		booleanOperatorIEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		numericOperatorIEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		singleInputOperatorEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		twoInputsOperatorEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		multipleInputsOperatorEClass			= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		andEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		arithmeticOperatorEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		arrayEnumerationEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		arrayProductEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		arrayRecoveryEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		arrayRestructurationEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		assertionEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		assertionClockConstraintOperatorEClass	= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		assertionClockSpeedOperatorEClass		= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		booleanExpressionEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		cartesianProductEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		cellEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		clockConstraintOperatorEClass			= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		clockRelationOperatorEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		clockSpeedOperatorEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		comparisonOperatorEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		complexOperatorEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		concatenationEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		counterEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		delayEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		dependenceOperatorEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		extractionEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		ifThenElseEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		mergeEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		notEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		nullClockEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		numericExpressionEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		orEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		pragmaEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		repetitionOperatorEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		sequentialDefinitionEClass				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		switchEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		transpositionEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		tupleOperatorEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		unaryMinusEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		variableEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		windowEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		xorEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		stateOrHistoryEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		historyEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		stateBaseEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		stateEClass								= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		compoundStateEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		automatonEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		andStateEClass							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		transitionEClass						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		weakTransitionEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass		strongTransitionEClass					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		signalIntrinsicTypeEEnum				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		modelKindEEnum							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		processAttributeKindEEnum				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		compilationDirectiveKindEEnum			= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		signalStateKindEEnum					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		caseKindEEnum							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		typeKindEEnum							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		arithmeticOpKindEEnum					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		comparisonOpKindEEnum					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		clockConstraintOpKindEEnum				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		clockRelationOpKindEEnum				= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		clockSpeedOpKindEEnum					= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		visibilityKindEEnum						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		counterKindEEnum						= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EEnum		statusKindEEnum							= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EDataType	cyclicDefinitionExceptionEDataType		= null;
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EDataType	setEDataType							= null;
	
	/**
	 * Creates an instance of the model <b>Package</b>, registered with {@link org.eclipse.emf.ecore.EPackage.Registry
	 * EPackage.Registry} by the package package URI value.
	 * <p>
	 * Note: the correct way to create the package is via the static factory method {@link #init init()}, which also
	 * performs initialization of the package, or returns the registered package, if one already exists. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see fr.irisa.espresso.sme.SmePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private SmePackageImpl() {
		super(eNS_URI, SmeFactory.eINSTANCE);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private static boolean	isInited	= false;
	
	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * Simple dependencies are satisfied by calling this method on all dependent packages before doing anything else.
	 * This method drives initialization for interdependent packages directly, in parallel with this package, itself.
	 * <p>
	 * Of this package and its interdependencies, all packages which have not yet been registered by their URI values
	 * are first created and registered. The packages are then initialized in two steps: meta-model objects for all of
	 * the packages are created before any are initialized, since one package's meta-model objects may refer to those of
	 * another.
	 * <p>
	 * Invocation of this method will not affect any packages that have already been initialized. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static SmePackage init() {
		if (isInited)
			return (SmePackage) EPackage.Registry.INSTANCE.getEPackage(SmePackage.eNS_URI);
		
		// Obtain or create and register package
		SmePackageImpl theSmePackage = (SmePackageImpl) (EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof SmePackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(eNS_URI)
				: new SmePackageImpl());
		
		isInited = true;
		
		// Create package meta-data objects
		theSmePackage.createPackageContents();
		
		// Initialize created meta-data
		theSmePackage.initializePackageContents();
		
		// Mark meta-data to indicate it can't be changed
		theSmePackage.freeze();
		
		return theSmePackage;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getRootModel() {
		return rootModelEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSignalElement() {
		return signalElementEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConnectableElement() {
		return connectableElementEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getNamedElement() {
		return namedElementEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getNamedElement_Name() {
		return (EAttribute) namedElementEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getIdentifier() {
		return identifierEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getIdentifier_Comment() {
		return (EAttribute) identifierEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSignalExpr() {
		return signalExprEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSignalExpr_Src_DataflowConnections() {
		return (EReference) signalExprEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConstantExpr() {
		return constantExprEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConstantExpr_Src_ConstantAffectations() {
		return (EReference) constantExprEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getClockedExpr() {
		return clockedExprEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getClockedExpr_Src_ClockRelations() {
		return (EReference) clockedExprEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getClockedExpr_Dst_ClockRelations() {
		return (EReference) clockedExprEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getDependenceInOut() {
		return dependenceInOutEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getDependenceInOut_Src_Dependences() {
		return (EReference) dependenceInOutEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getDependenceInOut_Dst_Dependences() {
		return (EReference) dependenceInOutEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSignalContainer() {
		return signalContainerEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getInterfaceDefinition() {
		return interfaceDefinitionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInterfaceDefinition_Type() {
		return (EReference) interfaceDefinitionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInterfaceDefinition_Inputs() {
		return (EReference) interfaceDefinitionEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInterfaceDefinition_Outputs() {
		return (EReference) interfaceDefinitionEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInterfaceDefinition_Parameters() {
		return (EReference) interfaceDefinitionEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInterfaceDefinition_Spec() {
		return (EReference) interfaceDefinitionEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInterfaceDefinition_Pragmas() {
		return (EReference) interfaceDefinitionEClass.getEStructuralFeatures().get(5);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getInterfaceDefinition_ProcessClass() {
		return (EAttribute) interfaceDefinitionEClass.getEStructuralFeatures().get(6);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getModel() {
		return modelEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Assertions() {
		return (EReference) modelEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Automata() {
		return (EReference) modelEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Connections() {
		return (EReference) modelEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_ConstantRef() {
		return (EReference) modelEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Constants() {
		return (EReference) modelEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Constraints() {
		return (EReference) modelEClass.getEStructuralFeatures().get(5);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Indexes() {
		return (EReference) modelEClass.getEStructuralFeatures().get(6);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_ContainedInstances() {
		return (EReference) modelEClass.getEStructuralFeatures().get(7);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Literals() {
		return (EReference) modelEClass.getEStructuralFeatures().get(8);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Locals() {
		return (EReference) modelEClass.getEStructuralFeatures().get(9);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Operators() {
		return (EReference) modelEClass.getEStructuralFeatures().get(10);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_SignalRef() {
		return (EReference) modelEClass.getEStructuralFeatures().get(11);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Subprocesses() {
		return (EReference) modelEClass.getEStructuralFeatures().get(12);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_Types() {
		return (EReference) modelEClass.getEStructuralFeatures().get(13);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_UseModule() {
		return (EReference) modelEClass.getEStructuralFeatures().get(14);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModel_ModelRefs() {
		return (EReference) modelEClass.getEStructuralFeatures().get(15);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getBasicIterate() {
		return basicIterateEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getBasicIterate_IterationInit() {
		return (EReference) basicIterateEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getBasicIterate_Iterator() {
		return (EReference) basicIterateEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getBasicIterate_UpperBound() {
		return (EAttribute) basicIterateEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getBasicIterate_IteratorName() {
		return (EAttribute) basicIterateEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getIterate() {
		return iterateEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getIterate_IterationInit() {
		return (EReference) iterateEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getIterate_Ins() {
		return (EReference) iterateEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getIterationInit() {
		return iterationInitEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getIterationInit_ArrayParent() {
		return (EReference) iterationInitEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getIterationInit_IterateParent() {
		return (EReference) iterationInitEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSpecifications() {
		return specificationsEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSpecifications_InterfaceParent() {
		return (EReference) specificationsEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSpecifications_TypeParent() {
		return (EReference) specificationsEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSpecifications_ModelDeclarations() {
		return (EReference) specificationsEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSubProcess() {
		return subProcessEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSubProcess_ModelParent() {
		return (EReference) subProcessEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSubProcess_Dst_CaseConnection() {
		return (EReference) subProcessEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getTypeDeclaration() {
		return typeDeclarationEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getTypeDeclaration_ModuleParent() {
		return (EReference) typeDeclarationEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getTypeDeclaration_ModelParent() {
		return (EReference) typeDeclarationEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getTypeDeclaration_Visibility() {
		return (EAttribute) typeDeclarationEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getParameterType() {
		return parameterTypeEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSignalType() {
		return signalTypeEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSignalType_ArrayDimensions() {
		return (EAttribute) signalTypeEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getEnumerationType() {
		return enumerationTypeEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getEnumerationType_EnumValues() {
		return (EAttribute) enumerationTypeEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getModelType() {
		return modelTypeEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelType_ModelType() {
		return (EAttribute) modelTypeEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSubstitutionType() {
		return substitutionTypeEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSubstitutionType_Type() {
		return (EAttribute) substitutionTypeEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSubstitutionType_IsExternal() {
		return (EAttribute) substitutionTypeEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getTupleType() {
		return tupleTypeEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getTupleType_Kind() {
		return (EAttribute) tupleTypeEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getTupleType_Locals() {
		return (EReference) tupleTypeEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getTupleType_Spec() {
		return (EReference) tupleTypeEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getModelDeclaration() {
		return modelDeclarationEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelDeclaration_ModelParent() {
		return (EReference) modelDeclarationEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelDeclaration_ModuleParent() {
		return (EReference) modelDeclarationEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelDeclaration_SpecParent() {
		return (EReference) modelDeclarationEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_ModelType() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_Visibility() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_IsMain() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(5);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_IsSigaliProcess() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(6);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_CompilationDirective() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(7);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_RunOn() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(8);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_C_CODE() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(9);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_Cpp_CODE() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(10);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_Java_CODE() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(11);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelDeclaration_Processor_type() {
		return (EAttribute) modelDeclarationEClass.getEStructuralFeatures().get(12);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelDeclaration_ModelDeclarations() {
		return (EReference) modelDeclarationEClass.getEStructuralFeatures().get(13);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getModelRef() {
		return modelRefEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelRef_Model() {
		return (EReference) modelRefEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getModelRef_ModelName() {
		return (EAttribute) modelRefEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelRef_ModelParent() {
		return (EReference) modelRefEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getModelInstance() {
		return modelInstanceEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelInstance_ModelParent() {
		return (EReference) modelInstanceEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelInstance_ReferredInterface() {
		return (EReference) modelInstanceEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelInstance_ReferredParameter() {
		return (EReference) modelInstanceEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelInstance_Inputs() {
		return (EReference) modelInstanceEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelInstance_Outputs() {
		return (EReference) modelInstanceEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelInstance_Parameters() {
		return (EReference) modelInstanceEClass.getEStructuralFeatures().get(5);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getModule() {
		return moduleEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModule_Constants() {
		return (EReference) moduleEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModule_ModelDeclarations() {
		return (EReference) moduleEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModule_Types() {
		return (EReference) moduleEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModule_UseModule() {
		return (EReference) moduleEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModule_Pragmas() {
		return (EReference) moduleEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getUseModule() {
		return useModuleEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getUseModule_ModelParent() {
		return (EReference) useModuleEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getUseModule_ModuleParent() {
		return (EReference) useModuleEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getUseModule_Modules() {
		return (EReference) useModuleEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getDataflowConnector() {
		return dataflowConnectorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getDataflowConnector_Dst_DataflowConnections() {
		return (EReference) dataflowConnectorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConstantOrRef() {
		return constantOrRefEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConstantRef() {
		return constantRefEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConstantRef_Constant() {
		return (EReference) constantRefEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getConstantRef_CstName() {
		return (EAttribute) constantRefEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConstantRef_ModelParent() {
		return (EReference) constantRefEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConstant() {
		return constantEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConstant_Dst_ConstantAffectation() {
		return (EReference) constantEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConstantValue() {
		return constantValueEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConstantValue_ModelParent() {
		return (EReference) constantValueEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConstantValue_ModuleParent() {
		return (EReference) constantValueEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getConstantValue_ArrayDimensions() {
		return (EAttribute) constantValueEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getConstantValue_Type() {
		return (EAttribute) constantValueEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getConstantValue_Value() {
		return (EAttribute) constantValueEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getConstantValue_Visibility() {
		return (EAttribute) constantValueEClass.getEStructuralFeatures().get(5);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getLiteral() {
		return literalEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getLiteral_ModelParent() {
		return (EReference) literalEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getLiteral_Value() {
		return (EAttribute) literalEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getEnumerationValue() {
		return enumerationValueEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getEnumerationValue_TypeValue() {
		return (EAttribute) enumerationValueEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getParameter() {
		return parameterEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getParameter_InterfaceParent() {
		return (EReference) parameterEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getParameter_ArrayDimensions() {
		return (EAttribute) parameterEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getParameter_Type() {
		return (EAttribute) parameterEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getParameterInstance() {
		return parameterInstanceEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getParameterInstance_Parameter() {
		return (EReference) parameterInstanceEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getParameterInstance_InstanceParent() {
		return (EReference) parameterInstanceEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getIterator() {
		return iteratorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getIterator_ArrayParent() {
		return (EReference) iteratorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getIndex() {
		return indexEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getIndex_ModelParent() {
		return (EReference) indexEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getIndex_From() {
		return (EAttribute) indexEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getIndex_To() {
		return (EAttribute) indexEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getIndex_Step() {
		return (EAttribute) indexEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSignalOrRef() {
		return signalOrRefEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSignalRef() {
		return signalRefEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSignalRef_Signal() {
		return (EReference) signalRefEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSignalRef_SigName() {
		return (EAttribute) signalRefEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSignalRef_ModelParent() {
		return (EReference) signalRefEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSignal() {
		return signalEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSignal_Type() {
		return (EAttribute) signalEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSignal_ArrayDimensions() {
		return (EAttribute) signalEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSignal_InitValue() {
		return (EAttribute) signalEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getInput() {
		return inputEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInput_InterfaceParent() {
		return (EReference) inputEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getInputInstance() {
		return inputInstanceEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInputInstance_Input() {
		return (EReference) inputInstanceEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInputInstance_InstanceParent() {
		return (EReference) inputInstanceEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getOutput() {
		return outputEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getOutput_InterfaceParent() {
		return (EReference) outputEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getOutputInstance() {
		return outputInstanceEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getOutputInstance_Output() {
		return (EReference) outputInstanceEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getOutputInstance_InstanceParent() {
		return (EReference) outputInstanceEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getLocal() {
		return localEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getLocal_Status() {
		return (EAttribute) localEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getLocal_ModelParent() {
		return (EReference) localEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getLocal_StateParent() {
		return (EReference) localEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getLocal_TypeParent() {
		return (EReference) localEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConnection() {
		return connectionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getModelConnection() {
		return modelConnectionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getModelConnection_ModelParent() {
		return (EReference) modelConnectionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getCaseConnection() {
		return caseConnectionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCaseConnection_CaseKind() {
		return (EAttribute) caseConnectionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCaseConnection_Enumeration() {
		return (EAttribute) caseConnectionEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCaseConnection_LowerBound() {
		return (EAttribute) caseConnectionEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCaseConnection_UpperBound() {
		return (EAttribute) caseConnectionEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCaseConnection_CaseLabel() {
		return (EAttribute) caseConnectionEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getCaseConnection_Src() {
		return (EReference) caseConnectionEClass.getEStructuralFeatures().get(5);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getCaseConnection_Dst() {
		return (EReference) caseConnectionEClass.getEStructuralFeatures().get(6);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getClockRelation() {
		return clockRelationEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getClockRelation_Src() {
		return (EReference) clockRelationEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getClockRelation_Dst() {
		return (EReference) clockRelationEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getClockRelation_SrcField() {
		return (EAttribute) clockRelationEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getClockRelation_DstField() {
		return (EAttribute) clockRelationEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getCondition() {
		return conditionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCondition_ConditionKind() {
		return (EAttribute) conditionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getCondition_Src() {
		return (EReference) conditionEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getCondition_Dst() {
		return (EReference) conditionEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCondition_SrcField() {
		return (EAttribute) conditionEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConstantAffectation() {
		return constantAffectationEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConstantAffectation_Src() {
		return (EReference) constantAffectationEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConstantAffectation_Dst() {
		return (EReference) constantAffectationEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getConstantAffectation_SrcField() {
		return (EAttribute) constantAffectationEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getDependence() {
		return dependenceEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getDependence_Src() {
		return (EReference) dependenceEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getDependence_Dst() {
		return (EReference) dependenceEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDependence_SrcField() {
		return (EAttribute) dependenceEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDependence_DstField() {
		return (EAttribute) dependenceEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getDataflowConnection() {
		return dataflowConnectionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDataflowConnection_IsDefaultValue() {
		return (EAttribute) dataflowConnectionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDataflowConnection_CastType() {
		return (EAttribute) dataflowConnectionEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDataflowConnection_UseSrcClock() {
		return (EAttribute) dataflowConnectionEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDataflowConnection_UseLastIterationValue() {
		return (EAttribute) dataflowConnectionEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getDataflowConnection_Src() {
		return (EReference) dataflowConnectionEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getDataflowConnection_Dst() {
		return (EReference) dataflowConnectionEClass.getEStructuralFeatures().get(5);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDataflowConnection_SrcField() {
		return (EAttribute) dataflowConnectionEClass.getEStructuralFeatures().get(6);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDataflowConnection_DstField() {
		return (EAttribute) dataflowConnectionEClass.getEStructuralFeatures().get(7);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getOperatorPort() {
		return operatorPortEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getOperatorPort_Name() {
		return (EAttribute) operatorPortEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getInputPort() {
		return inputPortEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getInputPort_OperatorParent() {
		return (EReference) inputPortEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getOutputPort() {
		return outputPortEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getOutputPort_OperatorParent() {
		return (EReference) outputPortEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSignalOperator() {
		return signalOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConditionExpr() {
		return conditionExprEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConditionExpr_Src_Conditions() {
		return (EReference) conditionExprEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConditionnedExpr() {
		return conditionnedExprEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getConditionnedExpr_Dst_Condition() {
		return (EReference) conditionnedExprEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getControlflowOperator() {
		return controlflowOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getControlflowOperator_ModelParent() {
		return (EReference) controlflowOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getDataflowOperator() {
		return dataflowOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getDataflowOperator_ModelParent() {
		return (EReference) dataflowOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getBooleanOperatorI() {
		return booleanOperatorIEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getNumericOperatorI() {
		return numericOperatorIEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSingleInputOperator() {
		return singleInputOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSingleInputOperator_In() {
		return (EReference) singleInputOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getTwoInputsOperator() {
		return twoInputsOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getTwoInputsOperator_FirstOperand() {
		return (EReference) twoInputsOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getTwoInputsOperator_SecondOperand() {
		return (EReference) twoInputsOperatorEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getMultipleInputsOperator() {
		return multipleInputsOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getMultipleInputsOperator_Ins() {
		return (EReference) multipleInputsOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getAnd() {
		return andEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getArithmeticOperator() {
		return arithmeticOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getArithmeticOperator_Operator() {
		return (EAttribute) arithmeticOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getArrayEnumeration() {
		return arrayEnumerationEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getArrayProduct() {
		return arrayProductEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getArrayRecovery() {
		return arrayRecoveryEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getArrayRestructuration() {
		return arrayRestructurationEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getAssertion() {
		return assertionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getAssertion_Expression() {
		return (EAttribute) assertionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getAssertion_ModelParent() {
		return (EReference) assertionEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getAssertionClockConstraintOperator() {
		return assertionClockConstraintOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getAssertionClockSpeedOperator() {
		return assertionClockSpeedOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getBooleanExpression() {
		return booleanExpressionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getBooleanExpression_Expression() {
		return (EAttribute) booleanExpressionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getCartesianProduct() {
		return cartesianProductEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getCartesianProduct_Outs() {
		return (EReference) cartesianProductEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getCell() {
		return cellEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCell_InitialValue() {
		return (EAttribute) cellEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getClockConstraintOperator() {
		return clockConstraintOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getClockConstraintOperator_Operator() {
		return (EAttribute) clockConstraintOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getClockRelationOperator() {
		return clockRelationOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getClockRelationOperator_Operator() {
		return (EAttribute) clockRelationOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getClockSpeedOperator() {
		return clockSpeedOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getClockSpeedOperator_Operator() {
		return (EAttribute) clockSpeedOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getComparisonOperator() {
		return comparisonOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getComparisonOperator_Operator() {
		return (EAttribute) comparisonOperatorEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getComplexOperator() {
		return complexOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getConcatenation() {
		return concatenationEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getCounter() {
		return counterEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getCounter_CounterKind() {
		return (EAttribute) counterEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getDelay() {
		return delayEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDelay_NbInstants() {
		return (EAttribute) delayEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getDelay_InitialValue() {
		return (EAttribute) delayEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getDependenceOperator() {
		return dependenceOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getExtraction() {
		return extractionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getIfThenElse() {
		return ifThenElseEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getMerge() {
		return mergeEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getNot() {
		return notEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getNullClock() {
		return nullClockEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getNumericExpression() {
		return numericExpressionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getNumericExpression_Expression() {
		return (EAttribute) numericExpressionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getOr() {
		return orEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getPragma() {
		return pragmaEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getPragma_InterfaceParent() {
		return (EReference) pragmaEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getPragma_ModuleParent() {
		return (EReference) pragmaEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getPragma_Pragma() {
		return (EAttribute) pragmaEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getPragma_Expression() {
		return (EAttribute) pragmaEClass.getEStructuralFeatures().get(3);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getPragma_Targets() {
		return (EReference) pragmaEClass.getEStructuralFeatures().get(4);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getRepetitionOperator() {
		return repetitionOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSequentialDefinition() {
		return sequentialDefinitionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSwitch() {
		return switchEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSwitch_Signal() {
		return (EReference) switchEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSwitch_Src_CaseConnections() {
		return (EReference) switchEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSwitch_SrcField() {
		return (EAttribute) switchEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getTransposition() {
		return transpositionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getTupleOperator() {
		return tupleOperatorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getUnaryMinus() {
		return unaryMinusEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getVariable() {
		return variableEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getVariable_InitialValue() {
		return (EAttribute) variableEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getWindow() {
		return windowEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getWindow_WindowSize() {
		return (EAttribute) windowEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getWindow_InitialValue() {
		return (EAttribute) windowEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getXor() {
		return xorEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getStateOrHistory() {
		return stateOrHistoryEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getStateOrHistory_Dst_StrongTransitions() {
		return (EReference) stateOrHistoryEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getStateOrHistory_Dst_WeakTransitions() {
		return (EReference) stateOrHistoryEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getHistory() {
		return historyEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getHistory_ParentState() {
		return (EReference) historyEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getStateBase() {
		return stateBaseEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getStateBase_StateParent() {
		return (EReference) stateBaseEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getStateBase_Src_WeakTransitions() {
		return (EReference) stateBaseEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getStateBase_Src_StrongTransitions() {
		return (EReference) stateBaseEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getState() {
		return stateEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getCompoundState() {
		return compoundStateEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getCompoundState_States() {
		return (EReference) compoundStateEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getCompoundState_History() {
		return (EReference) compoundStateEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getCompoundState_Locals() {
		return (EReference) compoundStateEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getAutomaton() {
		return automatonEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getAutomaton_ModelParent() {
		return (EReference) automatonEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getAutomaton_InitState() {
		return (EReference) automatonEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getAutomaton_Transitions() {
		return (EReference) automatonEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getAndState() {
		return andStateEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getTransition() {
		return transitionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getTransition_Guard() {
		return (EAttribute) transitionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getTransition_Priority() {
		return (EAttribute) transitionEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getTransition_AutomatonParent() {
		return (EReference) transitionEClass.getEStructuralFeatures().get(2);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getWeakTransition() {
		return weakTransitionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getWeakTransition_Src() {
		return (EReference) weakTransitionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getWeakTransition_Dst() {
		return (EReference) weakTransitionEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getStrongTransition() {
		return strongTransitionEClass;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getStrongTransition_Src() {
		return (EReference) strongTransitionEClass.getEStructuralFeatures().get(0);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getStrongTransition_Dst() {
		return (EReference) strongTransitionEClass.getEStructuralFeatures().get(1);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getSignalIntrinsicType() {
		return signalIntrinsicTypeEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getModelKind() {
		return modelKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getProcessAttributeKind() {
		return processAttributeKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getCompilationDirectiveKind() {
		return compilationDirectiveKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getSignalStateKind() {
		return signalStateKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getCaseKind() {
		return caseKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getTypeKind() {
		return typeKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getArithmeticOpKind() {
		return arithmeticOpKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getComparisonOpKind() {
		return comparisonOpKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getClockConstraintOpKind() {
		return clockConstraintOpKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getClockRelationOpKind() {
		return clockRelationOpKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getClockSpeedOpKind() {
		return clockSpeedOpKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getVisibilityKind() {
		return visibilityKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getCounterKind() {
		return counterKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EEnum getStatusKind() {
		return statusKindEEnum;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EDataType getCyclicDefinitionException() {
		return cyclicDefinitionExceptionEDataType;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EDataType getSet() {
		return setEDataType;
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SmeFactory getSmeFactory() {
		return (SmeFactory) getEFactoryInstance();
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private boolean	isCreated	= false;
	
	/**
	 * Creates the meta-model objects for the package. This method is guarded to have no affect on any invocation but
	 * its first. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated)
			return;
		isCreated = true;
		
		// Create classes and their features
		signalElementEClass = createEClass(SIGNAL_ELEMENT);
		
		rootModelEClass = createEClass(ROOT_MODEL);
		
		connectableElementEClass = createEClass(CONNECTABLE_ELEMENT);
		
		namedElementEClass = createEClass(NAMED_ELEMENT);
		createEAttribute(namedElementEClass, NAMED_ELEMENT__NAME);
		
		identifierEClass = createEClass(IDENTIFIER);
		createEAttribute(identifierEClass, IDENTIFIER__COMMENT);
		
		signalExprEClass = createEClass(SIGNAL_EXPR);
		createEReference(signalExprEClass, SIGNAL_EXPR__SRC_DATAFLOW_CONNECTIONS);
		
		constantExprEClass = createEClass(CONSTANT_EXPR);
		createEReference(constantExprEClass, CONSTANT_EXPR__SRC_CONSTANT_AFFECTATIONS);
		
		clockedExprEClass = createEClass(CLOCKED_EXPR);
		createEReference(clockedExprEClass, CLOCKED_EXPR__SRC_CLOCK_RELATIONS);
		createEReference(clockedExprEClass, CLOCKED_EXPR__DST_CLOCK_RELATIONS);
		
		dependenceInOutEClass = createEClass(DEPENDENCE_IN_OUT);
		createEReference(dependenceInOutEClass, DEPENDENCE_IN_OUT__SRC_DEPENDENCES);
		createEReference(dependenceInOutEClass, DEPENDENCE_IN_OUT__DST_DEPENDENCES);
		
		signalContainerEClass = createEClass(SIGNAL_CONTAINER);
		
		interfaceDefinitionEClass = createEClass(INTERFACE_DEFINITION);
		createEReference(interfaceDefinitionEClass, INTERFACE_DEFINITION__TYPE);
		createEReference(interfaceDefinitionEClass, INTERFACE_DEFINITION__INPUTS);
		createEReference(interfaceDefinitionEClass, INTERFACE_DEFINITION__OUTPUTS);
		createEReference(interfaceDefinitionEClass, INTERFACE_DEFINITION__PARAMETERS);
		createEReference(interfaceDefinitionEClass, INTERFACE_DEFINITION__SPEC);
		createEReference(interfaceDefinitionEClass, INTERFACE_DEFINITION__PRAGMAS);
		createEAttribute(interfaceDefinitionEClass, INTERFACE_DEFINITION__PROCESS_CLASS);
		
		modelEClass = createEClass(MODEL);
		createEReference(modelEClass, MODEL__ASSERTIONS);
		createEReference(modelEClass, MODEL__AUTOMATA);
		createEReference(modelEClass, MODEL__CONNECTIONS);
		createEReference(modelEClass, MODEL__CONSTANT_REF);
		createEReference(modelEClass, MODEL__CONSTANTS);
		createEReference(modelEClass, MODEL__CONSTRAINTS);
		createEReference(modelEClass, MODEL__INDEXES);
		createEReference(modelEClass, MODEL__CONTAINED_INSTANCES);
		createEReference(modelEClass, MODEL__LITERALS);
		createEReference(modelEClass, MODEL__LOCALS);
		createEReference(modelEClass, MODEL__OPERATORS);
		createEReference(modelEClass, MODEL__SIGNAL_REF);
		createEReference(modelEClass, MODEL__SUBPROCESSES);
		createEReference(modelEClass, MODEL__TYPES);
		createEReference(modelEClass, MODEL__USE_MODULE);
		createEReference(modelEClass, MODEL__MODEL_REFS);
		
		basicIterateEClass = createEClass(BASIC_ITERATE);
		createEReference(basicIterateEClass, BASIC_ITERATE__ITERATION_INIT);
		createEReference(basicIterateEClass, BASIC_ITERATE__ITERATOR);
		createEAttribute(basicIterateEClass, BASIC_ITERATE__UPPER_BOUND);
		createEAttribute(basicIterateEClass, BASIC_ITERATE__ITERATOR_NAME);
		
		iterateEClass = createEClass(ITERATE);
		createEReference(iterateEClass, ITERATE__ITERATION_INIT);
		createEReference(iterateEClass, ITERATE__INS);
		
		iterationInitEClass = createEClass(ITERATION_INIT);
		createEReference(iterationInitEClass, ITERATION_INIT__ARRAY_PARENT);
		createEReference(iterationInitEClass, ITERATION_INIT__ITERATE_PARENT);
		
		specificationsEClass = createEClass(SPECIFICATIONS);
		createEReference(specificationsEClass, SPECIFICATIONS__INTERFACE_PARENT);
		createEReference(specificationsEClass, SPECIFICATIONS__TYPE_PARENT);
		createEReference(specificationsEClass, SPECIFICATIONS__MODEL_DECLARATIONS);
		
		subProcessEClass = createEClass(SUB_PROCESS);
		createEReference(subProcessEClass, SUB_PROCESS__MODEL_PARENT);
		createEReference(subProcessEClass, SUB_PROCESS__DST_CASE_CONNECTION);
		
		typeDeclarationEClass = createEClass(TYPE_DECLARATION);
		createEReference(typeDeclarationEClass, TYPE_DECLARATION__MODULE_PARENT);
		createEReference(typeDeclarationEClass, TYPE_DECLARATION__MODEL_PARENT);
		createEAttribute(typeDeclarationEClass, TYPE_DECLARATION__VISIBILITY);
		
		parameterTypeEClass = createEClass(PARAMETER_TYPE);
		
		signalTypeEClass = createEClass(SIGNAL_TYPE);
		createEAttribute(signalTypeEClass, SIGNAL_TYPE__ARRAY_DIMENSIONS);
		
		enumerationTypeEClass = createEClass(ENUMERATION_TYPE);
		createEAttribute(enumerationTypeEClass, ENUMERATION_TYPE__ENUM_VALUES);
		
		modelTypeEClass = createEClass(MODEL_TYPE);
		createEAttribute(modelTypeEClass, MODEL_TYPE__MODEL_TYPE);
		
		substitutionTypeEClass = createEClass(SUBSTITUTION_TYPE);
		createEAttribute(substitutionTypeEClass, SUBSTITUTION_TYPE__TYPE);
		createEAttribute(substitutionTypeEClass, SUBSTITUTION_TYPE__IS_EXTERNAL);
		
		tupleTypeEClass = createEClass(TUPLE_TYPE);
		createEAttribute(tupleTypeEClass, TUPLE_TYPE__KIND);
		createEReference(tupleTypeEClass, TUPLE_TYPE__LOCALS);
		createEReference(tupleTypeEClass, TUPLE_TYPE__SPEC);
		
		modelDeclarationEClass = createEClass(MODEL_DECLARATION);
		createEReference(modelDeclarationEClass, MODEL_DECLARATION__MODEL_PARENT);
		createEReference(modelDeclarationEClass, MODEL_DECLARATION__MODULE_PARENT);
		createEReference(modelDeclarationEClass, MODEL_DECLARATION__SPEC_PARENT);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__MODEL_TYPE);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__VISIBILITY);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__IS_MAIN);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__IS_SIGALI_PROCESS);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__COMPILATION_DIRECTIVE);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__RUN_ON);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__CCODE);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__CPP_CODE);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__JAVA_CODE);
		createEAttribute(modelDeclarationEClass, MODEL_DECLARATION__PROCESSOR_TYPE);
		createEReference(modelDeclarationEClass, MODEL_DECLARATION__MODEL_DECLARATIONS);
		
		modelRefEClass = createEClass(MODEL_REF);
		createEReference(modelRefEClass, MODEL_REF__MODEL);
		createEAttribute(modelRefEClass, MODEL_REF__MODEL_NAME);
		createEReference(modelRefEClass, MODEL_REF__MODEL_PARENT);
		
		modelInstanceEClass = createEClass(MODEL_INSTANCE);
		createEReference(modelInstanceEClass, MODEL_INSTANCE__MODEL_PARENT);
		createEReference(modelInstanceEClass, MODEL_INSTANCE__REFERRED_INTERFACE);
		createEReference(modelInstanceEClass, MODEL_INSTANCE__REFERRED_PARAMETER);
		createEReference(modelInstanceEClass, MODEL_INSTANCE__INPUTS);
		createEReference(modelInstanceEClass, MODEL_INSTANCE__OUTPUTS);
		createEReference(modelInstanceEClass, MODEL_INSTANCE__PARAMETERS);
		
		moduleEClass = createEClass(MODULE);
		createEReference(moduleEClass, MODULE__CONSTANTS);
		createEReference(moduleEClass, MODULE__MODEL_DECLARATIONS);
		createEReference(moduleEClass, MODULE__TYPES);
		createEReference(moduleEClass, MODULE__USE_MODULE);
		createEReference(moduleEClass, MODULE__PRAGMAS);
		
		useModuleEClass = createEClass(USE_MODULE);
		createEReference(useModuleEClass, USE_MODULE__MODEL_PARENT);
		createEReference(useModuleEClass, USE_MODULE__MODULE_PARENT);
		createEReference(useModuleEClass, USE_MODULE__MODULES);
		
		dataflowConnectorEClass = createEClass(DATAFLOW_CONNECTOR);
		createEReference(dataflowConnectorEClass, DATAFLOW_CONNECTOR__DST_DATAFLOW_CONNECTIONS);
		
		constantOrRefEClass = createEClass(CONSTANT_OR_REF);
		
		constantRefEClass = createEClass(CONSTANT_REF);
		createEReference(constantRefEClass, CONSTANT_REF__CONSTANT);
		createEAttribute(constantRefEClass, CONSTANT_REF__CST_NAME);
		createEReference(constantRefEClass, CONSTANT_REF__MODEL_PARENT);
		
		constantEClass = createEClass(CONSTANT);
		createEReference(constantEClass, CONSTANT__DST_CONSTANT_AFFECTATION);
		
		constantValueEClass = createEClass(CONSTANT_VALUE);
		createEReference(constantValueEClass, CONSTANT_VALUE__MODEL_PARENT);
		createEReference(constantValueEClass, CONSTANT_VALUE__MODULE_PARENT);
		createEAttribute(constantValueEClass, CONSTANT_VALUE__ARRAY_DIMENSIONS);
		createEAttribute(constantValueEClass, CONSTANT_VALUE__TYPE);
		createEAttribute(constantValueEClass, CONSTANT_VALUE__VALUE);
		createEAttribute(constantValueEClass, CONSTANT_VALUE__VISIBILITY);
		
		literalEClass = createEClass(LITERAL);
		createEReference(literalEClass, LITERAL__MODEL_PARENT);
		createEAttribute(literalEClass, LITERAL__VALUE);
		
		enumerationValueEClass = createEClass(ENUMERATION_VALUE);
		createEAttribute(enumerationValueEClass, ENUMERATION_VALUE__TYPE_VALUE);
		
		parameterEClass = createEClass(PARAMETER);
		createEReference(parameterEClass, PARAMETER__INTERFACE_PARENT);
		createEAttribute(parameterEClass, PARAMETER__ARRAY_DIMENSIONS);
		createEAttribute(parameterEClass, PARAMETER__TYPE);
		
		parameterInstanceEClass = createEClass(PARAMETER_INSTANCE);
		createEReference(parameterInstanceEClass, PARAMETER_INSTANCE__PARAMETER);
		createEReference(parameterInstanceEClass, PARAMETER_INSTANCE__INSTANCE_PARENT);
		
		iteratorEClass = createEClass(ITERATOR);
		createEReference(iteratorEClass, ITERATOR__ARRAY_PARENT);
		
		indexEClass = createEClass(INDEX);
		createEReference(indexEClass, INDEX__MODEL_PARENT);
		createEAttribute(indexEClass, INDEX__FROM);
		createEAttribute(indexEClass, INDEX__TO);
		createEAttribute(indexEClass, INDEX__STEP);
		
		signalOrRefEClass = createEClass(SIGNAL_OR_REF);
		
		signalRefEClass = createEClass(SIGNAL_REF);
		createEReference(signalRefEClass, SIGNAL_REF__SIGNAL);
		createEAttribute(signalRefEClass, SIGNAL_REF__SIG_NAME);
		createEReference(signalRefEClass, SIGNAL_REF__MODEL_PARENT);
		
		signalEClass = createEClass(SIGNAL);
		createEAttribute(signalEClass, SIGNAL__TYPE);
		createEAttribute(signalEClass, SIGNAL__ARRAY_DIMENSIONS);
		createEAttribute(signalEClass, SIGNAL__INIT_VALUE);
		
		inputEClass = createEClass(INPUT);
		createEReference(inputEClass, INPUT__INTERFACE_PARENT);
		
		inputInstanceEClass = createEClass(INPUT_INSTANCE);
		createEReference(inputInstanceEClass, INPUT_INSTANCE__INPUT);
		createEReference(inputInstanceEClass, INPUT_INSTANCE__INSTANCE_PARENT);
		
		outputEClass = createEClass(OUTPUT);
		createEReference(outputEClass, OUTPUT__INTERFACE_PARENT);
		
		outputInstanceEClass = createEClass(OUTPUT_INSTANCE);
		createEReference(outputInstanceEClass, OUTPUT_INSTANCE__OUTPUT);
		createEReference(outputInstanceEClass, OUTPUT_INSTANCE__INSTANCE_PARENT);
		
		localEClass = createEClass(LOCAL);
		createEAttribute(localEClass, LOCAL__STATUS);
		createEReference(localEClass, LOCAL__MODEL_PARENT);
		createEReference(localEClass, LOCAL__STATE_PARENT);
		createEReference(localEClass, LOCAL__TYPE_PARENT);
		
		connectionEClass = createEClass(CONNECTION);
		
		modelConnectionEClass = createEClass(MODEL_CONNECTION);
		createEReference(modelConnectionEClass, MODEL_CONNECTION__MODEL_PARENT);
		
		caseConnectionEClass = createEClass(CASE_CONNECTION);
		createEAttribute(caseConnectionEClass, CASE_CONNECTION__CASE_KIND);
		createEAttribute(caseConnectionEClass, CASE_CONNECTION__ENUMERATION);
		createEAttribute(caseConnectionEClass, CASE_CONNECTION__LOWER_BOUND);
		createEAttribute(caseConnectionEClass, CASE_CONNECTION__UPPER_BOUND);
		createEAttribute(caseConnectionEClass, CASE_CONNECTION__CASE_LABEL);
		createEReference(caseConnectionEClass, CASE_CONNECTION__SRC);
		createEReference(caseConnectionEClass, CASE_CONNECTION__DST);
		
		clockRelationEClass = createEClass(CLOCK_RELATION);
		createEReference(clockRelationEClass, CLOCK_RELATION__SRC);
		createEReference(clockRelationEClass, CLOCK_RELATION__DST);
		createEAttribute(clockRelationEClass, CLOCK_RELATION__SRC_FIELD);
		createEAttribute(clockRelationEClass, CLOCK_RELATION__DST_FIELD);
		
		conditionEClass = createEClass(CONDITION);
		createEAttribute(conditionEClass, CONDITION__CONDITION_KIND);
		createEReference(conditionEClass, CONDITION__SRC);
		createEReference(conditionEClass, CONDITION__DST);
		createEAttribute(conditionEClass, CONDITION__SRC_FIELD);
		
		constantAffectationEClass = createEClass(CONSTANT_AFFECTATION);
		createEReference(constantAffectationEClass, CONSTANT_AFFECTATION__SRC);
		createEReference(constantAffectationEClass, CONSTANT_AFFECTATION__DST);
		createEAttribute(constantAffectationEClass, CONSTANT_AFFECTATION__SRC_FIELD);
		
		dataflowConnectionEClass = createEClass(DATAFLOW_CONNECTION);
		createEAttribute(dataflowConnectionEClass, DATAFLOW_CONNECTION__IS_DEFAULT_VALUE);
		createEAttribute(dataflowConnectionEClass, DATAFLOW_CONNECTION__CAST_TYPE);
		createEAttribute(dataflowConnectionEClass, DATAFLOW_CONNECTION__USE_SRC_CLOCK);
		createEAttribute(dataflowConnectionEClass, DATAFLOW_CONNECTION__USE_LAST_ITERATION_VALUE);
		createEReference(dataflowConnectionEClass, DATAFLOW_CONNECTION__SRC);
		createEReference(dataflowConnectionEClass, DATAFLOW_CONNECTION__DST);
		createEAttribute(dataflowConnectionEClass, DATAFLOW_CONNECTION__SRC_FIELD);
		createEAttribute(dataflowConnectionEClass, DATAFLOW_CONNECTION__DST_FIELD);
		
		dependenceEClass = createEClass(DEPENDENCE);
		createEReference(dependenceEClass, DEPENDENCE__SRC);
		createEReference(dependenceEClass, DEPENDENCE__DST);
		createEAttribute(dependenceEClass, DEPENDENCE__SRC_FIELD);
		createEAttribute(dependenceEClass, DEPENDENCE__DST_FIELD);
		
		operatorPortEClass = createEClass(OPERATOR_PORT);
		createEAttribute(operatorPortEClass, OPERATOR_PORT__NAME);
		
		inputPortEClass = createEClass(INPUT_PORT);
		createEReference(inputPortEClass, INPUT_PORT__OPERATOR_PARENT);
		
		outputPortEClass = createEClass(OUTPUT_PORT);
		createEReference(outputPortEClass, OUTPUT_PORT__OPERATOR_PARENT);
		
		signalOperatorEClass = createEClass(SIGNAL_OPERATOR);
		
		conditionExprEClass = createEClass(CONDITION_EXPR);
		createEReference(conditionExprEClass, CONDITION_EXPR__SRC_CONDITIONS);
		
		conditionnedExprEClass = createEClass(CONDITIONNED_EXPR);
		createEReference(conditionnedExprEClass, CONDITIONNED_EXPR__DST_CONDITION);
		
		controlflowOperatorEClass = createEClass(CONTROLFLOW_OPERATOR);
		createEReference(controlflowOperatorEClass, CONTROLFLOW_OPERATOR__MODEL_PARENT);
		
		dataflowOperatorEClass = createEClass(DATAFLOW_OPERATOR);
		createEReference(dataflowOperatorEClass, DATAFLOW_OPERATOR__MODEL_PARENT);
		
		booleanOperatorIEClass = createEClass(BOOLEAN_OPERATOR_I);
		
		numericOperatorIEClass = createEClass(NUMERIC_OPERATOR_I);
		
		singleInputOperatorEClass = createEClass(SINGLE_INPUT_OPERATOR);
		createEReference(singleInputOperatorEClass, SINGLE_INPUT_OPERATOR__IN);
		
		twoInputsOperatorEClass = createEClass(TWO_INPUTS_OPERATOR);
		createEReference(twoInputsOperatorEClass, TWO_INPUTS_OPERATOR__FIRST_OPERAND);
		createEReference(twoInputsOperatorEClass, TWO_INPUTS_OPERATOR__SECOND_OPERAND);
		
		multipleInputsOperatorEClass = createEClass(MULTIPLE_INPUTS_OPERATOR);
		createEReference(multipleInputsOperatorEClass, MULTIPLE_INPUTS_OPERATOR__INS);
		
		andEClass = createEClass(AND);
		
		arithmeticOperatorEClass = createEClass(ARITHMETIC_OPERATOR);
		createEAttribute(arithmeticOperatorEClass, ARITHMETIC_OPERATOR__OPERATOR);
		
		arrayEnumerationEClass = createEClass(ARRAY_ENUMERATION);
		
		arrayProductEClass = createEClass(ARRAY_PRODUCT);
		
		arrayRecoveryEClass = createEClass(ARRAY_RECOVERY);
		
		arrayRestructurationEClass = createEClass(ARRAY_RESTRUCTURATION);
		
		assertionEClass = createEClass(ASSERTION);
		createEAttribute(assertionEClass, ASSERTION__EXPRESSION);
		createEReference(assertionEClass, ASSERTION__MODEL_PARENT);
		
		assertionClockConstraintOperatorEClass = createEClass(ASSERTION_CLOCK_CONSTRAINT_OPERATOR);
		
		assertionClockSpeedOperatorEClass = createEClass(ASSERTION_CLOCK_SPEED_OPERATOR);
		
		booleanExpressionEClass = createEClass(BOOLEAN_EXPRESSION);
		createEAttribute(booleanExpressionEClass, BOOLEAN_EXPRESSION__EXPRESSION);
		
		cartesianProductEClass = createEClass(CARTESIAN_PRODUCT);
		createEReference(cartesianProductEClass, CARTESIAN_PRODUCT__OUTS);
		
		cellEClass = createEClass(CELL);
		createEAttribute(cellEClass, CELL__INITIAL_VALUE);
		
		clockConstraintOperatorEClass = createEClass(CLOCK_CONSTRAINT_OPERATOR);
		createEAttribute(clockConstraintOperatorEClass, CLOCK_CONSTRAINT_OPERATOR__OPERATOR);
		
		clockRelationOperatorEClass = createEClass(CLOCK_RELATION_OPERATOR);
		createEAttribute(clockRelationOperatorEClass, CLOCK_RELATION_OPERATOR__OPERATOR);
		
		clockSpeedOperatorEClass = createEClass(CLOCK_SPEED_OPERATOR);
		createEAttribute(clockSpeedOperatorEClass, CLOCK_SPEED_OPERATOR__OPERATOR);
		
		comparisonOperatorEClass = createEClass(COMPARISON_OPERATOR);
		createEAttribute(comparisonOperatorEClass, COMPARISON_OPERATOR__OPERATOR);
		
		complexOperatorEClass = createEClass(COMPLEX_OPERATOR);
		
		concatenationEClass = createEClass(CONCATENATION);
		
		counterEClass = createEClass(COUNTER);
		createEAttribute(counterEClass, COUNTER__COUNTER_KIND);
		
		delayEClass = createEClass(DELAY);
		createEAttribute(delayEClass, DELAY__NB_INSTANTS);
		createEAttribute(delayEClass, DELAY__INITIAL_VALUE);
		
		dependenceOperatorEClass = createEClass(DEPENDENCE_OPERATOR);
		
		extractionEClass = createEClass(EXTRACTION);
		
		ifThenElseEClass = createEClass(IF_THEN_ELSE);
		
		mergeEClass = createEClass(MERGE);
		
		notEClass = createEClass(NOT);
		
		nullClockEClass = createEClass(NULL_CLOCK);
		
		numericExpressionEClass = createEClass(NUMERIC_EXPRESSION);
		createEAttribute(numericExpressionEClass, NUMERIC_EXPRESSION__EXPRESSION);
		
		orEClass = createEClass(OR);
		
		pragmaEClass = createEClass(PRAGMA);
		createEReference(pragmaEClass, PRAGMA__INTERFACE_PARENT);
		createEReference(pragmaEClass, PRAGMA__MODULE_PARENT);
		createEAttribute(pragmaEClass, PRAGMA__PRAGMA);
		createEAttribute(pragmaEClass, PRAGMA__EXPRESSION);
		createEReference(pragmaEClass, PRAGMA__TARGETS);
		
		repetitionOperatorEClass = createEClass(REPETITION_OPERATOR);
		
		sequentialDefinitionEClass = createEClass(SEQUENTIAL_DEFINITION);
		
		switchEClass = createEClass(SWITCH);
		createEReference(switchEClass, SWITCH__SIGNAL);
		createEReference(switchEClass, SWITCH__SRC_CASE_CONNECTIONS);
		createEAttribute(switchEClass, SWITCH__SRC_FIELD);
		
		transpositionEClass = createEClass(TRANSPOSITION);
		
		tupleOperatorEClass = createEClass(TUPLE_OPERATOR);
		
		unaryMinusEClass = createEClass(UNARY_MINUS);
		
		variableEClass = createEClass(VARIABLE);
		createEAttribute(variableEClass, VARIABLE__INITIAL_VALUE);
		
		windowEClass = createEClass(WINDOW);
		createEAttribute(windowEClass, WINDOW__WINDOW_SIZE);
		createEAttribute(windowEClass, WINDOW__INITIAL_VALUE);
		
		xorEClass = createEClass(XOR);
		
		stateOrHistoryEClass = createEClass(STATE_OR_HISTORY);
		createEReference(stateOrHistoryEClass, STATE_OR_HISTORY__DST_STRONG_TRANSITIONS);
		createEReference(stateOrHistoryEClass, STATE_OR_HISTORY__DST_WEAK_TRANSITIONS);
		
		historyEClass = createEClass(HISTORY);
		createEReference(historyEClass, HISTORY__PARENT_STATE);
		
		stateBaseEClass = createEClass(STATE_BASE);
		createEReference(stateBaseEClass, STATE_BASE__STATE_PARENT);
		createEReference(stateBaseEClass, STATE_BASE__SRC_WEAK_TRANSITIONS);
		createEReference(stateBaseEClass, STATE_BASE__SRC_STRONG_TRANSITIONS);
		
		stateEClass = createEClass(STATE);
		
		compoundStateEClass = createEClass(COMPOUND_STATE);
		createEReference(compoundStateEClass, COMPOUND_STATE__STATES);
		createEReference(compoundStateEClass, COMPOUND_STATE__HISTORY);
		createEReference(compoundStateEClass, COMPOUND_STATE__LOCALS);
		
		automatonEClass = createEClass(AUTOMATON);
		createEReference(automatonEClass, AUTOMATON__MODEL_PARENT);
		createEReference(automatonEClass, AUTOMATON__INIT_STATE);
		createEReference(automatonEClass, AUTOMATON__TRANSITIONS);
		
		andStateEClass = createEClass(AND_STATE);
		
		transitionEClass = createEClass(TRANSITION);
		createEAttribute(transitionEClass, TRANSITION__GUARD);
		createEAttribute(transitionEClass, TRANSITION__PRIORITY);
		createEReference(transitionEClass, TRANSITION__AUTOMATON_PARENT);
		
		weakTransitionEClass = createEClass(WEAK_TRANSITION);
		createEReference(weakTransitionEClass, WEAK_TRANSITION__SRC);
		createEReference(weakTransitionEClass, WEAK_TRANSITION__DST);
		
		strongTransitionEClass = createEClass(STRONG_TRANSITION);
		createEReference(strongTransitionEClass, STRONG_TRANSITION__SRC);
		createEReference(strongTransitionEClass, STRONG_TRANSITION__DST);
		
		// Create enums
		signalIntrinsicTypeEEnum = createEEnum(SIGNAL_INTRINSIC_TYPE);
		modelKindEEnum = createEEnum(MODEL_KIND);
		processAttributeKindEEnum = createEEnum(PROCESS_ATTRIBUTE_KIND);
		compilationDirectiveKindEEnum = createEEnum(COMPILATION_DIRECTIVE_KIND);
		signalStateKindEEnum = createEEnum(SIGNAL_STATE_KIND);
		caseKindEEnum = createEEnum(CASE_KIND);
		typeKindEEnum = createEEnum(TYPE_KIND);
		arithmeticOpKindEEnum = createEEnum(ARITHMETIC_OP_KIND);
		comparisonOpKindEEnum = createEEnum(COMPARISON_OP_KIND);
		clockConstraintOpKindEEnum = createEEnum(CLOCK_CONSTRAINT_OP_KIND);
		clockRelationOpKindEEnum = createEEnum(CLOCK_RELATION_OP_KIND);
		clockSpeedOpKindEEnum = createEEnum(CLOCK_SPEED_OP_KIND);
		visibilityKindEEnum = createEEnum(VISIBILITY_KIND);
		counterKindEEnum = createEEnum(COUNTER_KIND);
		statusKindEEnum = createEEnum(STATUS_KIND);
		
		// Create data types
		cyclicDefinitionExceptionEDataType = createEDataType(CYCLIC_DEFINITION_EXCEPTION);
		setEDataType = createEDataType(SET);
	}
	
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private boolean	isInitialized	= false;
	
	/**
	 * Complete the initialization of the package and its meta-model. This method is guarded to have no affect on any
	 * invocation but its first. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized)
			return;
		isInitialized = true;
		
		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);
		
		// Create type parameters
		addETypeParameter(setEDataType, "E");
		
		// Set bounds for type parameters
		
		// Add supertypes to classes
		rootModelEClass.getESuperTypes().add(this.getSignalElement());
		connectableElementEClass.getESuperTypes().add(this.getSignalElement());
		namedElementEClass.getESuperTypes().add(this.getSignalElement());
		identifierEClass.getESuperTypes().add(this.getNamedElement());
		identifierEClass.getESuperTypes().add(this.getConnectableElement());
		signalExprEClass.getESuperTypes().add(this.getConnectableElement());
		constantExprEClass.getESuperTypes().add(this.getConnectableElement());
		clockedExprEClass.getESuperTypes().add(this.getConnectableElement());
		dependenceInOutEClass.getESuperTypes().add(this.getConnectableElement());
		signalContainerEClass.getESuperTypes().add(this.getSignalElement());
		interfaceDefinitionEClass.getESuperTypes().add(this.getSignalContainer());
		modelEClass.getESuperTypes().add(this.getSignalContainer());
		basicIterateEClass.getESuperTypes().add(this.getSubProcess());
		iterateEClass.getESuperTypes().add(this.getSubProcess());
		iterateEClass.getESuperTypes().add(this.getSignalOperator());
		iterationInitEClass.getESuperTypes().add(this.getModel());
		specificationsEClass.getESuperTypes().add(this.getModel());
		subProcessEClass.getESuperTypes().add(this.getModel());
		subProcessEClass.getESuperTypes().add(this.getClockedExpr());
		subProcessEClass.getESuperTypes().add(this.getIdentifier());
		subProcessEClass.getESuperTypes().add(this.getDependenceInOut());
		typeDeclarationEClass.getESuperTypes().add(this.getIdentifier());
		signalTypeEClass.getESuperTypes().add(this.getParameterType());
		signalTypeEClass.getESuperTypes().add(this.getConstantExpr());
		enumerationTypeEClass.getESuperTypes().add(this.getTypeDeclaration());
		enumerationTypeEClass.getESuperTypes().add(this.getSignalType());
		modelTypeEClass.getESuperTypes().add(this.getInterfaceDefinition());
		modelTypeEClass.getESuperTypes().add(this.getTypeDeclaration());
		modelTypeEClass.getESuperTypes().add(this.getParameterType());
		substitutionTypeEClass.getESuperTypes().add(this.getTypeDeclaration());
		substitutionTypeEClass.getESuperTypes().add(this.getSignalType());
		tupleTypeEClass.getESuperTypes().add(this.getTypeDeclaration());
		tupleTypeEClass.getESuperTypes().add(this.getSignalContainer());
		tupleTypeEClass.getESuperTypes().add(this.getSignalType());
		modelDeclarationEClass.getESuperTypes().add(this.getModel());
		modelDeclarationEClass.getESuperTypes().add(this.getInterfaceDefinition());
		modelDeclarationEClass.getESuperTypes().add(this.getIdentifier());
		modelDeclarationEClass.getESuperTypes().add(this.getConstantExpr());
		modelDeclarationEClass.getESuperTypes().add(this.getRootModel());
		modelRefEClass.getESuperTypes().add(this.getConstantExpr());
		modelRefEClass.getESuperTypes().add(this.getSignalElement());
		modelInstanceEClass.getESuperTypes().add(this.getClockedExpr());
		modelInstanceEClass.getESuperTypes().add(this.getIdentifier());
		modelInstanceEClass.getESuperTypes().add(this.getDependenceInOut());
		modelInstanceEClass.getESuperTypes().add(this.getSignalContainer());
		moduleEClass.getESuperTypes().add(this.getIdentifier());
		moduleEClass.getESuperTypes().add(this.getRootModel());
		moduleEClass.getESuperTypes().add(this.getSignalContainer());
		useModuleEClass.getESuperTypes().add(this.getSignalElement());
		dataflowConnectorEClass.getESuperTypes().add(this.getConnectableElement());
		constantOrRefEClass.getESuperTypes().add(this.getSignalExpr());
		constantOrRefEClass.getESuperTypes().add(this.getConstantExpr());
		constantRefEClass.getESuperTypes().add(this.getConstantOrRef());
		constantRefEClass.getESuperTypes().add(this.getSignalElement());
		constantRefEClass.getESuperTypes().add(this.getConditionExpr());
		constantEClass.getESuperTypes().add(this.getConstantOrRef());
		constantEClass.getESuperTypes().add(this.getIdentifier());
		constantValueEClass.getESuperTypes().add(this.getConstant());
		constantValueEClass.getESuperTypes().add(this.getConditionExpr());
		literalEClass.getESuperTypes().add(this.getSignalExpr());
		literalEClass.getESuperTypes().add(this.getConstantExpr());
		literalEClass.getESuperTypes().add(this.getConditionExpr());
		enumerationValueEClass.getESuperTypes().add(this.getLiteral());
		parameterEClass.getESuperTypes().add(this.getConstant());
		parameterEClass.getESuperTypes().add(this.getConditionExpr());
		parameterInstanceEClass.getESuperTypes().add(this.getConstant());
		parameterInstanceEClass.getESuperTypes().add(this.getConditionExpr());
		iteratorEClass.getESuperTypes().add(this.getConstant());
		indexEClass.getESuperTypes().add(this.getConstant());
		signalOrRefEClass.getESuperTypes().add(this.getSignalExpr());
		signalOrRefEClass.getESuperTypes().add(this.getClockedExpr());
		signalOrRefEClass.getESuperTypes().add(this.getDependenceInOut());
		signalOrRefEClass.getESuperTypes().add(this.getDataflowConnector());
		signalOrRefEClass.getESuperTypes().add(this.getConditionExpr());
		signalRefEClass.getESuperTypes().add(this.getSignalOrRef());
		signalRefEClass.getESuperTypes().add(this.getSignalElement());
		signalEClass.getESuperTypes().add(this.getSignalOrRef());
		signalEClass.getESuperTypes().add(this.getIdentifier());
		inputEClass.getESuperTypes().add(this.getSignal());
		inputInstanceEClass.getESuperTypes().add(this.getSignalOrRef());
		inputInstanceEClass.getESuperTypes().add(this.getIdentifier());
		outputEClass.getESuperTypes().add(this.getSignal());
		outputInstanceEClass.getESuperTypes().add(this.getSignalOrRef());
		outputInstanceEClass.getESuperTypes().add(this.getConstantExpr());
		outputInstanceEClass.getESuperTypes().add(this.getIdentifier());
		localEClass.getESuperTypes().add(this.getSignal());
		connectionEClass.getESuperTypes().add(this.getNamedElement());
		modelConnectionEClass.getESuperTypes().add(this.getConnection());
		caseConnectionEClass.getESuperTypes().add(this.getModelConnection());
		clockRelationEClass.getESuperTypes().add(this.getModelConnection());
		conditionEClass.getESuperTypes().add(this.getModelConnection());
		constantAffectationEClass.getESuperTypes().add(this.getModelConnection());
		dataflowConnectionEClass.getESuperTypes().add(this.getModelConnection());
		dependenceEClass.getESuperTypes().add(this.getModelConnection());
		operatorPortEClass.getESuperTypes().add(this.getConnectableElement());
		operatorPortEClass.getESuperTypes().add(this.getSignalElement());
		inputPortEClass.getESuperTypes().add(this.getClockedExpr());
		inputPortEClass.getESuperTypes().add(this.getOperatorPort());
		inputPortEClass.getESuperTypes().add(this.getDataflowConnector());
		outputPortEClass.getESuperTypes().add(this.getIdentifier());
		outputPortEClass.getESuperTypes().add(this.getSignalExpr());
		outputPortEClass.getESuperTypes().add(this.getConstantExpr());
		signalOperatorEClass.getESuperTypes().add(this.getSignalContainer());
		conditionExprEClass.getESuperTypes().add(this.getConnectableElement());
		conditionnedExprEClass.getESuperTypes().add(this.getConnectableElement());
		booleanOperatorIEClass.getESuperTypes().add(this.getSignalExpr());
		booleanOperatorIEClass.getESuperTypes().add(this.getConstantExpr());
		booleanOperatorIEClass.getESuperTypes().add(this.getDataflowOperator());
		booleanOperatorIEClass.getESuperTypes().add(this.getConditionExpr());
		numericOperatorIEClass.getESuperTypes().add(this.getSignalExpr());
		numericOperatorIEClass.getESuperTypes().add(this.getConstantExpr());
		numericOperatorIEClass.getESuperTypes().add(this.getDataflowOperator());
		singleInputOperatorEClass.getESuperTypes().add(this.getSignalOperator());
		singleInputOperatorEClass.getESuperTypes().add(this.getNamedElement());
		twoInputsOperatorEClass.getESuperTypes().add(this.getSignalOperator());
		twoInputsOperatorEClass.getESuperTypes().add(this.getNamedElement());
		multipleInputsOperatorEClass.getESuperTypes().add(this.getSignalOperator());
		multipleInputsOperatorEClass.getESuperTypes().add(this.getNamedElement());
		andEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		andEClass.getESuperTypes().add(this.getBooleanOperatorI());
		arithmeticOperatorEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		arithmeticOperatorEClass.getESuperTypes().add(this.getNumericOperatorI());
		arrayEnumerationEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		arrayEnumerationEClass.getESuperTypes().add(this.getSignalExpr());
		arrayEnumerationEClass.getESuperTypes().add(this.getConstantExpr());
		arrayEnumerationEClass.getESuperTypes().add(this.getDataflowOperator());
		arrayProductEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		arrayProductEClass.getESuperTypes().add(this.getNumericOperatorI());
		arrayRecoveryEClass.getESuperTypes().add(this.getTwoInputsOperator());
		arrayRecoveryEClass.getESuperTypes().add(this.getSignalExpr());
		arrayRecoveryEClass.getESuperTypes().add(this.getConstantExpr());
		arrayRecoveryEClass.getESuperTypes().add(this.getConditionExpr());
		arrayRecoveryEClass.getESuperTypes().add(this.getDataflowOperator());
		arrayRestructurationEClass.getESuperTypes().add(this.getTwoInputsOperator());
		arrayRestructurationEClass.getESuperTypes().add(this.getSignalExpr());
		arrayRestructurationEClass.getESuperTypes().add(this.getConstantExpr());
		arrayRestructurationEClass.getESuperTypes().add(this.getDataflowOperator());
		assertionEClass.getESuperTypes().add(this.getNamedElement());
		assertionEClass.getESuperTypes().add(this.getConditionnedExpr());
		assertionClockConstraintOperatorEClass.getESuperTypes().add(this.getClockConstraintOperator());
		assertionClockSpeedOperatorEClass.getESuperTypes().add(this.getClockSpeedOperator());
		booleanExpressionEClass.getESuperTypes().add(this.getNamedElement());
		booleanExpressionEClass.getESuperTypes().add(this.getBooleanOperatorI());
		cartesianProductEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		cartesianProductEClass.getESuperTypes().add(this.getDataflowOperator());
		cellEClass.getESuperTypes().add(this.getSingleInputOperator());
		cellEClass.getESuperTypes().add(this.getConditionnedExpr());
		cellEClass.getESuperTypes().add(this.getSignalExpr());
		cellEClass.getESuperTypes().add(this.getConditionExpr());
		cellEClass.getESuperTypes().add(this.getDataflowOperator());
		clockConstraintOperatorEClass.getESuperTypes().add(this.getClockedExpr());
		clockConstraintOperatorEClass.getESuperTypes().add(this.getNamedElement());
		clockConstraintOperatorEClass.getESuperTypes().add(this.getControlflowOperator());
		clockRelationOperatorEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		clockRelationOperatorEClass.getESuperTypes().add(this.getClockedExpr());
		clockRelationOperatorEClass.getESuperTypes().add(this.getControlflowOperator());
		clockSpeedOperatorEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		clockSpeedOperatorEClass.getESuperTypes().add(this.getControlflowOperator());
		comparisonOperatorEClass.getESuperTypes().add(this.getTwoInputsOperator());
		comparisonOperatorEClass.getESuperTypes().add(this.getBooleanOperatorI());
		complexOperatorEClass.getESuperTypes().add(this.getTwoInputsOperator());
		complexOperatorEClass.getESuperTypes().add(this.getNumericOperatorI());
		concatenationEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		concatenationEClass.getESuperTypes().add(this.getSignalExpr());
		concatenationEClass.getESuperTypes().add(this.getConstantExpr());
		concatenationEClass.getESuperTypes().add(this.getDataflowOperator());
		counterEClass.getESuperTypes().add(this.getTwoInputsOperator());
		counterEClass.getESuperTypes().add(this.getSignalExpr());
		counterEClass.getESuperTypes().add(this.getDataflowOperator());
		delayEClass.getESuperTypes().add(this.getSingleInputOperator());
		delayEClass.getESuperTypes().add(this.getSignalExpr());
		delayEClass.getESuperTypes().add(this.getConditionExpr());
		delayEClass.getESuperTypes().add(this.getDataflowOperator());
		dependenceOperatorEClass.getESuperTypes().add(this.getDependenceInOut());
		dependenceOperatorEClass.getESuperTypes().add(this.getConditionnedExpr());
		dependenceOperatorEClass.getESuperTypes().add(this.getNamedElement());
		dependenceOperatorEClass.getESuperTypes().add(this.getControlflowOperator());
		extractionEClass.getESuperTypes().add(this.getSingleInputOperator());
		extractionEClass.getESuperTypes().add(this.getConditionnedExpr());
		extractionEClass.getESuperTypes().add(this.getSignalExpr());
		extractionEClass.getESuperTypes().add(this.getConstantExpr());
		extractionEClass.getESuperTypes().add(this.getConditionExpr());
		extractionEClass.getESuperTypes().add(this.getDataflowOperator());
		ifThenElseEClass.getESuperTypes().add(this.getTwoInputsOperator());
		ifThenElseEClass.getESuperTypes().add(this.getConditionnedExpr());
		ifThenElseEClass.getESuperTypes().add(this.getSignalExpr());
		ifThenElseEClass.getESuperTypes().add(this.getConstantExpr());
		ifThenElseEClass.getESuperTypes().add(this.getConditionExpr());
		ifThenElseEClass.getESuperTypes().add(this.getDataflowOperator());
		mergeEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		mergeEClass.getESuperTypes().add(this.getSignalExpr());
		mergeEClass.getESuperTypes().add(this.getConstantExpr());
		mergeEClass.getESuperTypes().add(this.getConditionExpr());
		mergeEClass.getESuperTypes().add(this.getDataflowOperator());
		notEClass.getESuperTypes().add(this.getSingleInputOperator());
		notEClass.getESuperTypes().add(this.getBooleanOperatorI());
		nullClockEClass.getESuperTypes().add(this.getClockedExpr());
		nullClockEClass.getESuperTypes().add(this.getControlflowOperator());
		nullClockEClass.getESuperTypes().add(this.getSignalElement());
		numericExpressionEClass.getESuperTypes().add(this.getNamedElement());
		numericExpressionEClass.getESuperTypes().add(this.getNumericOperatorI());
		orEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		orEClass.getESuperTypes().add(this.getBooleanOperatorI());
		pragmaEClass.getESuperTypes().add(this.getSignalElement());
		repetitionOperatorEClass.getESuperTypes().add(this.getTwoInputsOperator());
		repetitionOperatorEClass.getESuperTypes().add(this.getSignalExpr());
		repetitionOperatorEClass.getESuperTypes().add(this.getConstantExpr());
		repetitionOperatorEClass.getESuperTypes().add(this.getDataflowOperator());
		sequentialDefinitionEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		sequentialDefinitionEClass.getESuperTypes().add(this.getSignalExpr());
		sequentialDefinitionEClass.getESuperTypes().add(this.getConstantExpr());
		sequentialDefinitionEClass.getESuperTypes().add(this.getDataflowOperator());
		switchEClass.getESuperTypes().add(this.getNamedElement());
		switchEClass.getESuperTypes().add(this.getDataflowOperator());
		switchEClass.getESuperTypes().add(this.getConnectableElement());
		transpositionEClass.getESuperTypes().add(this.getSingleInputOperator());
		transpositionEClass.getESuperTypes().add(this.getSignalExpr());
		transpositionEClass.getESuperTypes().add(this.getConstantExpr());
		transpositionEClass.getESuperTypes().add(this.getDataflowOperator());
		tupleOperatorEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		tupleOperatorEClass.getESuperTypes().add(this.getSignalExpr());
		tupleOperatorEClass.getESuperTypes().add(this.getConstantExpr());
		tupleOperatorEClass.getESuperTypes().add(this.getDataflowOperator());
		unaryMinusEClass.getESuperTypes().add(this.getSingleInputOperator());
		unaryMinusEClass.getESuperTypes().add(this.getNumericOperatorI());
		variableEClass.getESuperTypes().add(this.getSingleInputOperator());
		variableEClass.getESuperTypes().add(this.getSignalExpr());
		variableEClass.getESuperTypes().add(this.getDataflowOperator());
		windowEClass.getESuperTypes().add(this.getSingleInputOperator());
		windowEClass.getESuperTypes().add(this.getSignalExpr());
		windowEClass.getESuperTypes().add(this.getDataflowOperator());
		xorEClass.getESuperTypes().add(this.getMultipleInputsOperator());
		xorEClass.getESuperTypes().add(this.getBooleanOperatorI());
		stateOrHistoryEClass.getESuperTypes().add(this.getConnectableElement());
		historyEClass.getESuperTypes().add(this.getStateOrHistory());
		historyEClass.getESuperTypes().add(this.getOperatorPort());
		stateBaseEClass.getESuperTypes().add(this.getStateOrHistory());
		stateBaseEClass.getESuperTypes().add(this.getIdentifier());
		stateEClass.getESuperTypes().add(this.getModel());
		stateEClass.getESuperTypes().add(this.getStateBase());
		compoundStateEClass.getESuperTypes().add(this.getStateBase());
		compoundStateEClass.getESuperTypes().add(this.getSignalContainer());
		automatonEClass.getESuperTypes().add(this.getCompoundState());
		automatonEClass.getESuperTypes().add(this.getClockedExpr());
		automatonEClass.getESuperTypes().add(this.getDependenceInOut());
		andStateEClass.getESuperTypes().add(this.getCompoundState());
		transitionEClass.getESuperTypes().add(this.getConnection());
		weakTransitionEClass.getESuperTypes().add(this.getTransition());
		strongTransitionEClass.getESuperTypes().add(this.getTransition());
		
		// Initialize classes and features; add operations and parameters
		initEClass(signalElementEClass, SignalElement.class, "SignalElement", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		addEOperation(signalElementEClass, this.getSignalContainer(), "getParent", 1, 1, IS_UNIQUE, !IS_ORDERED);
		
		EOperation op = addEOperation(signalElementEClass, ecorePackage.getEInt(), "getAST", 1, 1, IS_UNIQUE,
			IS_ORDERED);
		EGenericType g1 = createEGenericType(this.getSet());
		EGenericType g2 = createEGenericType(this.getSignalElement());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "path", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getCyclicDefinitionException());
		
		op = addEOperation(signalElementEClass, ecorePackage.getEInt(), "getDeclarationAST", 1, 1, IS_UNIQUE,
			IS_ORDERED);
		addEParameter(op, ecorePackage.getEInt(), "declTree", 1, 1, IS_UNIQUE, IS_ORDERED);
		
		op = addEOperation(signalElementEClass, ecorePackage.getEInt(), "buildEquationsAST", 1, 1, IS_UNIQUE,
			IS_ORDERED);
		addEParameter(op, ecorePackage.getEInt(), "bodyTree", 1, 1, IS_UNIQUE, IS_ORDERED);
		
		initEClass(rootModelEClass, RootModel.class, "RootModel", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(connectableElementEClass, ConnectableElement.class, "ConnectableElement", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(namedElementEClass, NamedElement.class, "NamedElement", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNamedElement_Name(), ecorePackage.getEString(), "name", null, 1, 1, NamedElement.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(identifierEClass, Identifier.class, "Identifier", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIdentifier_Comment(), ecorePackage.getEString(), "comment", null, 0, 1, Identifier.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		op = addEOperation(identifierEClass, ecorePackage.getEString(), "toString", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEBoolean(), "asCode", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEBoolean(), "withComments", 1, 1, IS_UNIQUE, IS_ORDERED);
		
		initEClass(signalExprEClass, SignalExpr.class, "SignalExpr", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSignalExpr_Src_DataflowConnections(), this.getDataflowConnection(), this
				.getDataflowConnection_Src(), "src_DataflowConnections", null, 0, -1, SignalExpr.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		
		initEClass(constantExprEClass, ConstantExpr.class, "ConstantExpr", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getConstantExpr_Src_ConstantAffectations(), this.getConstantAffectation(), this
				.getConstantAffectation_Src(), "src_ConstantAffectations", null, 0, -1, ConstantExpr.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(clockedExprEClass, ClockedExpr.class, "ClockedExpr", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getClockedExpr_Src_ClockRelations(), this.getClockRelation(), this.getClockRelation_Src(),
			"src_ClockRelations", null, 0, -1, ClockedExpr.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getClockedExpr_Dst_ClockRelations(), this.getClockRelation(), this.getClockRelation_Dst(),
			"dst_ClockRelations", null, 0, -1, ClockedExpr.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(dependenceInOutEClass, DependenceInOut.class, "DependenceInOut", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDependenceInOut_Src_Dependences(), this.getDependence(), this.getDependence_Src(),
			"src_Dependences", null, 0, -1, DependenceInOut.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDependenceInOut_Dst_Dependences(), this.getDependence(), this.getDependence_Dst(),
			"dst_Dependences", null, 0, -1, DependenceInOut.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(signalContainerEClass, SignalContainer.class, "SignalContainer", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		addEOperation(signalContainerEClass, this.getConstantOrRef(), "getVisibleConstants", 0, -1, IS_UNIQUE,
			IS_ORDERED);
		
		addEOperation(signalContainerEClass, this.getSignalOrRef(), "getVisibleSignals", 0, -1, IS_UNIQUE, IS_ORDERED);
		
		addEOperation(signalContainerEClass, this.getIdentifier(), "getVisibleTypes", 0, -1, IS_UNIQUE, IS_ORDERED);
		
		addEOperation(signalContainerEClass, ecorePackage.getEString(), "getName", 1, 1, IS_UNIQUE, IS_ORDERED);
		
		addEOperation(signalContainerEClass, this.getInterfaceDefinition(), "getVisibleModelProcesses", 0, -1,
			IS_UNIQUE, IS_ORDERED);
		
		initEClass(interfaceDefinitionEClass, InterfaceDefinition.class, "InterfaceDefinition", IS_ABSTRACT,
			IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInterfaceDefinition_Type(), this.getModelType(), null, "type", null, 0, 1,
			InterfaceDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getInterfaceDefinition_Inputs(), this.getInput(), this.getInput_InterfaceParent(), "inputs",
			null, 0, -1, InterfaceDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getInterfaceDefinition_Outputs(), this.getOutput(), this.getOutput_InterfaceParent(), "outputs",
			null, 0, -1, InterfaceDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getInterfaceDefinition_Parameters(), this.getParameter(), this.getParameter_InterfaceParent(),
			"parameters", null, 0, -1, InterfaceDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getInterfaceDefinition_Spec(), this.getSpecifications(), this
				.getSpecifications_InterfaceParent(), "spec", null, 1, 1, InterfaceDefinition.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			!IS_ORDERED);
		initEReference(getInterfaceDefinition_Pragmas(), this.getPragma(), this.getPragma_InterfaceParent(), "pragmas",
			null, 0, -1, InterfaceDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getInterfaceDefinition_ProcessClass(), this.getProcessAttributeKind(), "processClass", "unsafe",
			0, 1, InterfaceDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
			IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		op = addEOperation(interfaceDefinitionEClass, ecorePackage.getEString(), "toString", 1, 1, IS_UNIQUE,
			IS_ORDERED);
		addEParameter(op, ecorePackage.getEBoolean(), "asCode", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEBoolean(), "withComments", 1, 1, IS_UNIQUE, IS_ORDERED);
		
		initEClass(modelEClass, Model.class, "Model", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModel_Assertions(), this.getAssertion(), this.getAssertion_ModelParent(), "assertions", null,
			0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Automata(), this.getAutomaton(), this.getAutomaton_ModelParent(), "automata", null, 0,
			-1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Connections(), this.getModelConnection(), this.getModelConnection_ModelParent(),
			"connections", null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_ConstantRef(), this.getConstantRef(), this.getConstantRef_ModelParent(), "constantRef",
			null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Constants(), this.getConstantValue(), this.getConstantValue_ModelParent(), "constants",
			null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Constraints(), this.getControlflowOperator(),
			this.getControlflowOperator_ModelParent(), "constraints", null, 0, -1, Model.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		initEReference(getModel_Indexes(), this.getIndex(), this.getIndex_ModelParent(), "indexes", null, 0, -1,
			Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
			IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_ContainedInstances(), this.getModelInstance(), this.getModelInstance_ModelParent(),
			"containedInstances", null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Literals(), this.getLiteral(), this.getLiteral_ModelParent(), "literals", null, 0, -1,
			Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
			IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Locals(), this.getLocal(), this.getLocal_ModelParent(), "locals", null, 0, -1,
			Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
			IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Operators(), this.getDataflowOperator(), this.getDataflowOperator_ModelParent(),
			"operators", null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_SignalRef(), this.getSignalRef(), this.getSignalRef_ModelParent(), "signalRef", null,
			0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Subprocesses(), this.getSubProcess(), this.getSubProcess_ModelParent(), "subprocesses",
			null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Types(), this.getTypeDeclaration(), this.getTypeDeclaration_ModelParent(), "types",
			null, 0, -1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_UseModule(), this.getUseModule(), this.getUseModule_ModelParent(), "useModule", null,
			0, 1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_ModelRefs(), this.getModelRef(), this.getModelRef_ModelParent(), "modelRefs", null, 0,
			-1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(basicIterateEClass, BasicIterate.class, "BasicIterate", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBasicIterate_IterationInit(), this.getIterationInit(), this.getIterationInit_ArrayParent(),
			"iterationInit", null, 1, 1, BasicIterate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBasicIterate_Iterator(), this.getIterator(), this.getIterator_ArrayParent(), "iterator",
			null, 1, 1, BasicIterate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getBasicIterate_UpperBound(), ecorePackage.getEString(), "upperBound", null, 1, 1,
			BasicIterate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getBasicIterate_IteratorName(), ecorePackage.getEString(), "iteratorName", "", 1, 1,
			BasicIterate.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			IS_DERIVED, IS_ORDERED);
		
		initEClass(iterateEClass, Iterate.class, "Iterate", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIterate_IterationInit(), this.getIterationInit(), this.getIterationInit_IterateParent(),
			"iterationInit", null, 1, 1, Iterate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIterate_Ins(), this.getInputPort(), null, "ins", null, 1, -1, Iterate.class, !IS_TRANSIENT,
			!IS_VOLATILE, !IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		
		initEClass(iterationInitEClass, IterationInit.class, "IterationInit", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIterationInit_ArrayParent(), this.getBasicIterate(), this.getBasicIterate_IterationInit(),
			"arrayParent", null, 0, 1, IterationInit.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIterationInit_IterateParent(), this.getIterate(), this.getIterate_IterationInit(),
			"iterateParent", null, 0, 1, IterationInit.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(specificationsEClass, Specifications.class, "Specifications", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSpecifications_InterfaceParent(), this.getInterfaceDefinition(), this
				.getInterfaceDefinition_Spec(), "interfaceParent", null, 0, 1, Specifications.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		initEReference(getSpecifications_TypeParent(), this.getTupleType(), this.getTupleType_Spec(), "typeParent",
			null, 0, 1, Specifications.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSpecifications_ModelDeclarations(), this.getModelDeclaration(), this
				.getModelDeclaration_SpecParent(), "modelDeclarations", null, 0, -1, Specifications.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(subProcessEClass, SubProcess.class, "SubProcess", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSubProcess_ModelParent(), this.getModel(), this.getModel_Subprocesses(), "modelParent", null,
			1, 1, SubProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSubProcess_Dst_CaseConnection(), this.getCaseConnection(), this.getCaseConnection_Dst(),
			"dst_CaseConnection", null, 0, 1, SubProcess.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(typeDeclarationEClass, TypeDeclaration.class, "TypeDeclaration", IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTypeDeclaration_ModuleParent(), this.getModule(), this.getModule_Types(), "moduleParent",
			null, 0, 1, TypeDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTypeDeclaration_ModelParent(), this.getModel(), this.getModel_Types(), "modelParent", null,
			0, 1, TypeDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTypeDeclaration_Visibility(), this.getVisibilityKind(), "visibility", null, 1, 1,
			TypeDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(parameterTypeEClass, ParameterType.class, "ParameterType", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(signalTypeEClass, SignalType.class, "SignalType", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSignalType_ArrayDimensions(), ecorePackage.getEString(), "arrayDimensions", null, 0, -1,
			SignalType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(enumerationTypeEClass, EnumerationType.class, "EnumerationType", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEnumerationType_EnumValues(), ecorePackage.getEString(), "enumValues", null, 1, -1,
			EnumerationType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(modelTypeEClass, ModelType.class, "ModelType", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getModelType_ModelType(), this.getModelKind(), "modelType", "process", 0, 1, ModelType.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(substitutionTypeEClass, SubstitutionType.class, "SubstitutionType", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSubstitutionType_Type(), ecorePackage.getEString(), "type", null, 0, 1,
			SubstitutionType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getSubstitutionType_IsExternal(), ecorePackage.getEBoolean(), "isExternal", "false", 0, 1,
			SubstitutionType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(tupleTypeEClass, TupleType.class, "TupleType", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTupleType_Kind(), this.getTypeKind(), "kind", "struct", 0, 1, TupleType.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getTupleType_Locals(), this.getLocal(), this.getLocal_TypeParent(), "locals", null, 1, -1,
			TupleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTupleType_Spec(), this.getSpecifications(), this.getSpecifications_TypeParent(), "spec",
			null, 0, 1, TupleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(modelDeclarationEClass, ModelDeclaration.class, "ModelDeclaration", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelDeclaration_ModelParent(), this.getModelDeclaration(), this
				.getModelDeclaration_ModelDeclarations(), "modelParent", null, 0, 1, ModelDeclaration.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEReference(getModelDeclaration_ModuleParent(), this.getModule(), this.getModule_ModelDeclarations(),
			"moduleParent", null, 0, 1, ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelDeclaration_SpecParent(), this.getSpecifications(), this
				.getSpecifications_ModelDeclarations(), "specParent", null, 0, 1, ModelDeclaration.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelDeclaration_ModelType(), this.getModelKind(), "modelType", "process", 0, 1,
			ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelDeclaration_Visibility(), this.getVisibilityKind(), "visibility", null, 0, 1,
			ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelDeclaration_IsMain(), ecorePackage.getEBoolean(), "isMain", "false", 0, 1,
			ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getModelDeclaration_IsSigaliProcess(), ecorePackage.getEBoolean(), "isSigaliProcess", "false",
			0, 1, ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
			!IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getModelDeclaration_CompilationDirective(), this.getCompilationDirectiveKind(),
			"compilationDirective", "NONE", 0, 1, ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getModelDeclaration_RunOn(), ecorePackage.getEInt(), "runOn", "-1", 0, 1,
			ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getModelDeclaration_C_CODE(), ecorePackage.getEString(), "c_CODE", null, 0, 1,
			ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getModelDeclaration_Cpp_CODE(), ecorePackage.getEString(), "cpp_CODE", null, 0, 1,
			ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getModelDeclaration_Java_CODE(), ecorePackage.getEString(), "java_CODE", null, 0, 1,
			ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getModelDeclaration_Processor_type(), ecorePackage.getEString(), "processor_type", null, 0, 1,
			ModelDeclaration.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEReference(getModelDeclaration_ModelDeclarations(), this.getModelDeclaration(), this
				.getModelDeclaration_ModelParent(), "modelDeclarations", null, 0, -1, ModelDeclaration.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(modelRefEClass, ModelRef.class, "ModelRef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelRef_Model(), this.getModelDeclaration(), null, "model", null, 1, 1, ModelRef.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelRef_ModelName(), ecorePackage.getEString(), "modelName", null, 1, 1, ModelRef.class,
			IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
		initEReference(getModelRef_ModelParent(), this.getModel(), this.getModel_ModelRefs(), "modelParent", null, 1,
			1, ModelRef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(modelInstanceEClass, ModelInstance.class, "ModelInstance", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelInstance_ModelParent(), this.getModel(), this.getModel_ContainedInstances(),
			"modelParent", null, 1, 1, ModelInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelInstance_ReferredInterface(), this.getInterfaceDefinition(), null, "referredInterface",
			null, 1, 1, ModelInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelInstance_ReferredParameter(), this.getParameter(), null, "referredParameter", null, 0,
			1, ModelInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelInstance_Inputs(), this.getInputInstance(), this.getInputInstance_InstanceParent(),
			"inputs", null, 0, -1, ModelInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelInstance_Outputs(), this.getOutputInstance(), this.getOutputInstance_InstanceParent(),
			"outputs", null, 0, -1, ModelInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelInstance_Parameters(), this.getParameterInstance(), this
				.getParameterInstance_InstanceParent(), "parameters", null, 0, -1, ModelInstance.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		
		initEClass(moduleEClass, Module.class, "Module", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModule_Constants(), this.getConstantValue(), this.getConstantValue_ModuleParent(),
			"constants", null, 0, -1, Module.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModule_ModelDeclarations(), this.getModelDeclaration(), this
				.getModelDeclaration_ModuleParent(), "modelDeclarations", null, 0, -1, Module.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		initEReference(getModule_Types(), this.getTypeDeclaration(), this.getTypeDeclaration_ModuleParent(), "types",
			null, 0, -1, Module.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModule_UseModule(), this.getUseModule(), this.getUseModule_ModuleParent(), "useModule", null,
			0, 1, Module.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModule_Pragmas(), this.getPragma(), this.getPragma_ModuleParent(), "pragmas", null, 0, -1,
			Module.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		addEOperation(moduleEClass, this.getConstantValue(), "getExportedConstants", 0, -1, IS_UNIQUE, IS_ORDERED);
		
		addEOperation(moduleEClass, this.getModelDeclaration(), "getExportedModels", 0, -1, IS_UNIQUE, IS_ORDERED);
		
		addEOperation(moduleEClass, this.getTypeDeclaration(), "getExportedTypes", 0, -1, IS_UNIQUE, IS_ORDERED);
		
		initEClass(useModuleEClass, UseModule.class, "UseModule", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getUseModule_ModelParent(), this.getModel(), this.getModel_UseModule(), "modelParent", null, 0,
			1, UseModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUseModule_ModuleParent(), this.getModule(), this.getModule_UseModule(), "moduleParent", null,
			0, 1, UseModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUseModule_Modules(), this.getModule(), null, "modules", null, 1, -1, UseModule.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(dataflowConnectorEClass, DataflowConnector.class, "DataflowConnector", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDataflowConnector_Dst_DataflowConnections(), this.getDataflowConnection(), this
				.getDataflowConnection_Dst(), "dst_DataflowConnections", null, 0, -1, DataflowConnector.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(constantOrRefEClass, ConstantOrRef.class, "ConstantOrRef", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(constantRefEClass, ConstantRef.class, "ConstantRef", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getConstantRef_Constant(), this.getConstant(), null, "constant", null, 1, 1, ConstantRef.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getConstantRef_CstName(), ecorePackage.getEString(), "cstName", null, 1, 1, ConstantRef.class,
			IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
		initEReference(getConstantRef_ModelParent(), this.getModel(), this.getModel_ConstantRef(), "modelParent", null,
			1, 1, ConstantRef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(constantEClass, Constant.class, "Constant", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getConstant_Dst_ConstantAffectation(), this.getConstantAffectation(), this
				.getConstantAffectation_Dst(), "dst_ConstantAffectation", null, 0, 1, Constant.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		
		initEClass(constantValueEClass, ConstantValue.class, "ConstantValue", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getConstantValue_ModelParent(), this.getModel(), this.getModel_Constants(), "modelParent", null,
			0, 1, ConstantValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getConstantValue_ModuleParent(), this.getModule(), this.getModule_Constants(), "moduleParent",
			null, 0, 1, ConstantValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConstantValue_ArrayDimensions(), ecorePackage.getEString(), "arrayDimensions", null, 0, -1,
			ConstantValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getConstantValue_Type(), ecorePackage.getEString(), "type", null, 0, 1, ConstantValue.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConstantValue_Value(), ecorePackage.getEString(), "value", null, 0, -1, ConstantValue.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConstantValue_Visibility(), this.getVisibilityKind(), "visibility", null, 1, 1,
			ConstantValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(literalEClass, Literal.class, "Literal", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLiteral_ModelParent(), this.getModel(), this.getModel_Literals(), "modelParent", null, 1, 1,
			Literal.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLiteral_Value(), ecorePackage.getEString(), "value", null, 1, 1, Literal.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(enumerationValueEClass, EnumerationValue.class, "EnumerationValue", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEnumerationValue_TypeValue(), ecorePackage.getEString(), "typeValue", null, 0, 1,
			EnumerationValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(parameterEClass, Parameter.class, "Parameter", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getParameter_InterfaceParent(), this.getInterfaceDefinition(), this
				.getInterfaceDefinition_Parameters(), "interfaceParent", null, 1, 1, Parameter.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		initEAttribute(getParameter_ArrayDimensions(), ecorePackage.getEString(), "arrayDimensions", null, 0, -1,
			Parameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getParameter_Type(), ecorePackage.getEString(), "type", null, 0, 1, Parameter.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(parameterInstanceEClass, ParameterInstance.class, "ParameterInstance", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getParameterInstance_Parameter(), this.getParameter(), null, "parameter", null, 1, 1,
			ParameterInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getParameterInstance_InstanceParent(), this.getModelInstance(), this
				.getModelInstance_Parameters(), "instanceParent", null, 1, 1, ParameterInstance.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		
		initEClass(iteratorEClass, Iterator.class, "Iterator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIterator_ArrayParent(), this.getBasicIterate(), this.getBasicIterate_Iterator(),
			"arrayParent", null, 1, 1, Iterator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(indexEClass, Index.class, "Index", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getIndex_ModelParent(), this.getModel(), this.getModel_Indexes(), "modelParent", null, 1, 1,
			Index.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getIndex_From(), ecorePackage.getEString(), "from", null, 1, 1, Index.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getIndex_To(), ecorePackage.getEString(), "to", null, 1, 1, Index.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getIndex_Step(), ecorePackage.getEString(), "step", "1", 0, 1, Index.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(signalOrRefEClass, SignalOrRef.class, "SignalOrRef", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		addEOperation(signalOrRefEClass, ecorePackage.getEBoolean(), "isPartiallyDefined", 1, 1, IS_UNIQUE, IS_ORDERED);
		
		initEClass(signalRefEClass, SignalRef.class, "SignalRef", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSignalRef_Signal(), this.getSignal(), null, "signal", null, 1, 1, SignalRef.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getSignalRef_SigName(), ecorePackage.getEString(), "sigName", null, 1, 1, SignalRef.class,
			IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
		initEReference(getSignalRef_ModelParent(), this.getModel(), this.getModel_SignalRef(), "modelParent", null, 1,
			1, SignalRef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(signalEClass, Signal.class, "Signal", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSignal_Type(), ecorePackage.getEString(), "type", null, 0, 1, Signal.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSignal_ArrayDimensions(), ecorePackage.getEString(), "arrayDimensions", null, 0, -1,
			Signal.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		initEAttribute(getSignal_InitValue(), ecorePackage.getEString(), "initValue", null, 0, -1, Signal.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(inputEClass, Input.class, "Input", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInput_InterfaceParent(), this.getInterfaceDefinition(), this.getInterfaceDefinition_Inputs(),
			"interfaceParent", null, 1, 1, Input.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(inputInstanceEClass, InputInstance.class, "InputInstance", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInputInstance_Input(), this.getInput(), null, "input", null, 1, 1, InputInstance.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEReference(getInputInstance_InstanceParent(), this.getModelInstance(), this.getModelInstance_Inputs(),
			"instanceParent", null, 1, 1, InputInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(outputEClass, Output.class, "Output", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getOutput_InterfaceParent(), this.getInterfaceDefinition(), this
				.getInterfaceDefinition_Outputs(), "interfaceParent", null, 1, 1, Output.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		
		initEClass(outputInstanceEClass, OutputInstance.class, "OutputInstance", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getOutputInstance_Output(), this.getOutput(), null, "output", null, 1, 1, OutputInstance.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEReference(getOutputInstance_InstanceParent(), this.getModelInstance(), this.getModelInstance_Outputs(),
			"instanceParent", null, 1, 1, OutputInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(localEClass, Local.class, "Local", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLocal_Status(), this.getStatusKind(), "status", null, 1, 1, Local.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLocal_ModelParent(), this.getModel(), this.getModel_Locals(), "modelParent", null, 0, 1,
			Local.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLocal_StateParent(), this.getCompoundState(), this.getCompoundState_Locals(), "stateParent",
			null, 0, 1, Local.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLocal_TypeParent(), this.getTupleType(), this.getTupleType_Locals(), "typeParent", null, 0,
			1, Local.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(connectionEClass, Connection.class, "Connection", IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		addEOperation(connectionEClass, this.getConnectableElement(), "getSource", 1, 1, !IS_UNIQUE, !IS_ORDERED);
		
		addEOperation(connectionEClass, this.getConnectableElement(), "getDestination", 1, 1, !IS_UNIQUE, !IS_ORDERED);
		
		initEClass(modelConnectionEClass, ModelConnection.class, "ModelConnection", IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelConnection_ModelParent(), this.getModel(), this.getModel_Connections(), "modelParent",
			null, 1, 1, ModelConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(caseConnectionEClass, CaseConnection.class, "CaseConnection", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCaseConnection_CaseKind(), this.getCaseKind(), "caseKind", null, 1, 1, CaseConnection.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getCaseConnection_Enumeration(), ecorePackage.getEString(), "enumeration", null, 0, -1,
			CaseConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getCaseConnection_LowerBound(), ecorePackage.getEString(), "lowerBound", "", 0, 1,
			CaseConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getCaseConnection_UpperBound(), ecorePackage.getEString(), "upperBound", "", 0, 1,
			CaseConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getCaseConnection_CaseLabel(), ecorePackage.getEString(), "caseLabel", null, 1, 1,
			CaseConnection.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			IS_DERIVED, IS_ORDERED);
		initEReference(getCaseConnection_Src(), this.getSwitch(), this.getSwitch_Src_CaseConnections(), "src", null, 1,
			1, CaseConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getCaseConnection_Dst(), this.getSubProcess(), this.getSubProcess_Dst_CaseConnection(), "dst",
			null, 1, 1, CaseConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(clockRelationEClass, ClockRelation.class, "ClockRelation", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getClockRelation_Src(), this.getClockedExpr(), this.getClockedExpr_Src_ClockRelations(), "src",
			null, 1, 1, ClockRelation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getClockRelation_Dst(), this.getClockedExpr(), this.getClockedExpr_Dst_ClockRelations(), "dst",
			null, 1, 1, ClockRelation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getClockRelation_SrcField(), ecorePackage.getEString(), "srcField", "", 0, 1,
			ClockRelation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getClockRelation_DstField(), ecorePackage.getEString(), "dstField", "", 0, 1,
			ClockRelation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		
		initEClass(conditionEClass, Condition.class, "Condition", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCondition_ConditionKind(), this.getSignalStateKind(), "conditionKind", null, 1, 1,
			Condition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEReference(getCondition_Src(), this.getConditionExpr(), this.getConditionExpr_Src_Conditions(), "src",
			null, 1, 1, Condition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCondition_Dst(), this.getConditionnedExpr(), this.getConditionnedExpr_Dst_Condition(), "dst",
			null, 1, 1, Condition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCondition_SrcField(), ecorePackage.getEString(), "srcField", "", 0, 1, Condition.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(constantAffectationEClass, ConstantAffectation.class, "ConstantAffectation", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getConstantAffectation_Src(), this.getConstantExpr(), this
				.getConstantExpr_Src_ConstantAffectations(), "src", null, 1, 1, ConstantAffectation.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEReference(getConstantAffectation_Dst(), this.getConstant(), this.getConstant_Dst_ConstantAffectation(),
			"dst", null, 1, 1, ConstantAffectation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConstantAffectation_SrcField(), ecorePackage.getEString(), "srcField", "", 0, 1,
			ConstantAffectation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		
		initEClass(dataflowConnectionEClass, DataflowConnection.class, "DataflowConnection", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDataflowConnection_IsDefaultValue(), ecorePackage.getEBoolean(), "isDefaultValue", "false",
			0, 1, DataflowConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
			!IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getDataflowConnection_CastType(), this.getSignalIntrinsicType(), "castType", "", 1, 1,
			DataflowConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getDataflowConnection_UseSrcClock(), ecorePackage.getEBoolean(), "useSrcClock", null, 1, 1,
			DataflowConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getDataflowConnection_UseLastIterationValue(), ecorePackage.getEBoolean(),
			"useLastIterationValue", null, 1, 1, DataflowConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getDataflowConnection_Src(), this.getSignalExpr(), this.getSignalExpr_Src_DataflowConnections(),
			"src", null, 1, 1, DataflowConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDataflowConnection_Dst(), this.getDataflowConnector(), this
				.getDataflowConnector_Dst_DataflowConnections(), "dst", null, 1, 1, DataflowConnection.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataflowConnection_SrcField(), ecorePackage.getEString(), "srcField", "", 0, 1,
			DataflowConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		initEAttribute(getDataflowConnection_DstField(), ecorePackage.getEString(), "dstField", "", 0, 1,
			DataflowConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, !IS_ORDERED);
		
		initEClass(dependenceEClass, Dependence.class, "Dependence", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDependence_Src(), this.getDependenceInOut(), this.getDependenceInOut_Src_Dependences(),
			"src", null, 1, 1, Dependence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDependence_Dst(), this.getDependenceInOut(), this.getDependenceInOut_Dst_Dependences(),
			"dst", null, 1, 1, Dependence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDependence_SrcField(), ecorePackage.getEString(), "srcField", "", 0, 1, Dependence.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getDependence_DstField(), ecorePackage.getEString(), "dstField", "", 0, 1, Dependence.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		addEOperation(dependenceEClass, ecorePackage.getEInt(), "getDstAST", 1, 1, IS_UNIQUE, IS_ORDERED);
		
		initEClass(operatorPortEClass, OperatorPort.class, "OperatorPort", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getOperatorPort_Name(), ecorePackage.getEString(), "name", "", 1, 1, OperatorPort.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
		
		initEClass(inputPortEClass, InputPort.class, "InputPort", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInputPort_OperatorParent(), this.getSignalOperator(), null, "operatorParent", null, 1, 1,
			InputPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(outputPortEClass, OutputPort.class, "OutputPort", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getOutputPort_OperatorParent(), this.getSignalOperator(), null, "operatorParent", null, 1, 1,
			OutputPort.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(signalOperatorEClass, SignalOperator.class, "SignalOperator", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		addEOperation(signalOperatorEClass, this.getInputPort(), "getInputPorts", 1, -1, IS_UNIQUE, IS_ORDERED);
		
		addEOperation(signalOperatorEClass, this.getOutputPort(), "getOutputPorts", 1, -1, IS_UNIQUE, IS_ORDERED);
		
		op = addEOperation(signalOperatorEClass, ecorePackage.getEString(), "getPortName", 1, 1, !IS_UNIQUE,
			!IS_ORDERED);
		addEParameter(op, this.getOperatorPort(), "port", 1, 1, !IS_UNIQUE, !IS_ORDERED);
		
		initEClass(conditionExprEClass, ConditionExpr.class, "ConditionExpr", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getConditionExpr_Src_Conditions(), this.getCondition(), this.getCondition_Src(),
			"src_Conditions", null, 0, -1, ConditionExpr.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(conditionnedExprEClass, ConditionnedExpr.class, "ConditionnedExpr", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getConditionnedExpr_Dst_Condition(), this.getCondition(), this.getCondition_Dst(),
			"dst_Condition", null, 0, -1, ConditionnedExpr.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(controlflowOperatorEClass, ControlflowOperator.class, "ControlflowOperator", IS_ABSTRACT,
			IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getControlflowOperator_ModelParent(), this.getModel(), this.getModel_Constraints(),
			"modelParent", null, 1, 1, ControlflowOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(dataflowOperatorEClass, DataflowOperator.class, "DataflowOperator", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDataflowOperator_ModelParent(), this.getModel(), this.getModel_Operators(), "modelParent",
			null, 1, 1, DataflowOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(booleanOperatorIEClass, BooleanOperatorI.class, "BooleanOperatorI", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(numericOperatorIEClass, NumericOperatorI.class, "NumericOperatorI", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(singleInputOperatorEClass, SingleInputOperator.class, "SingleInputOperator", IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSingleInputOperator_In(), this.getInputPort(), null, "in", null, 1, 1,
			SingleInputOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(twoInputsOperatorEClass, TwoInputsOperator.class, "TwoInputsOperator", IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTwoInputsOperator_FirstOperand(), this.getInputPort(), null, "firstOperand", null, 1, 1,
			TwoInputsOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTwoInputsOperator_SecondOperand(), this.getInputPort(), null, "secondOperand", null, 1, 1,
			TwoInputsOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(multipleInputsOperatorEClass, MultipleInputsOperator.class, "MultipleInputsOperator", IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMultipleInputsOperator_Ins(), this.getInputPort(), null, "ins", null, 1, -1,
			MultipleInputsOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(andEClass, And.class, "And", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(arithmeticOperatorEClass, ArithmeticOperator.class, "ArithmeticOperator", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getArithmeticOperator_Operator(), this.getArithmeticOpKind(), "operator", null, 1, 1,
			ArithmeticOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(arrayEnumerationEClass, ArrayEnumeration.class, "ArrayEnumeration", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(arrayProductEClass, ArrayProduct.class, "ArrayProduct", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(arrayRecoveryEClass, ArrayRecovery.class, "ArrayRecovery", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(arrayRestructurationEClass, ArrayRestructuration.class, "ArrayRestructuration", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(assertionEClass, Assertion.class, "Assertion", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAssertion_Expression(), ecorePackage.getEString(), "expression", null, 0, 1, Assertion.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getAssertion_ModelParent(), this.getModel(), this.getModel_Assertions(), "modelParent", null, 1,
			1, Assertion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(assertionClockConstraintOperatorEClass, AssertionClockConstraintOperator.class,
			"AssertionClockConstraintOperator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(assertionClockSpeedOperatorEClass, AssertionClockSpeedOperator.class, "AssertionClockSpeedOperator",
			!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(booleanExpressionEClass, BooleanExpression.class, "BooleanExpression", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBooleanExpression_Expression(), ecorePackage.getEString(), "expression", null, 1, 1,
			BooleanExpression.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(cartesianProductEClass, CartesianProduct.class, "CartesianProduct", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCartesianProduct_Outs(), this.getOutputPort(), null, "outs", null, 1, -1,
			CartesianProduct.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(cellEClass, Cell.class, "Cell", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCell_InitialValue(), ecorePackage.getEString(), "initialValue", null, 0, -1, Cell.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(clockConstraintOperatorEClass, ClockConstraintOperator.class, "ClockConstraintOperator",
			!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getClockConstraintOperator_Operator(), this.getClockConstraintOpKind(), "operator", null, 1, 1,
			ClockConstraintOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
			IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(clockRelationOperatorEClass, ClockRelationOperator.class, "ClockRelationOperator", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getClockRelationOperator_Operator(), this.getClockRelationOpKind(), "operator", null, 1, 1,
			ClockRelationOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(clockSpeedOperatorEClass, ClockSpeedOperator.class, "ClockSpeedOperator", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getClockSpeedOperator_Operator(), this.getClockSpeedOpKind(), "operator", null, 1, 1,
			ClockSpeedOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(comparisonOperatorEClass, ComparisonOperator.class, "ComparisonOperator", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getComparisonOperator_Operator(), this.getComparisonOpKind(), "operator", null, 1, 1,
			ComparisonOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(complexOperatorEClass, ComplexOperator.class, "ComplexOperator", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(concatenationEClass, Concatenation.class, "Concatenation", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(counterEClass, Counter.class, "Counter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCounter_CounterKind(), this.getCounterKind(), "counterKind", null, 1, 1, Counter.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(delayEClass, Delay.class, "Delay", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDelay_NbInstants(), ecorePackage.getEString(), "nbInstants", "1", 0, 1, Delay.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDelay_InitialValue(), ecorePackage.getEString(), "initialValue", null, 0, -1, Delay.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(dependenceOperatorEClass, DependenceOperator.class, "DependenceOperator", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(extractionEClass, Extraction.class, "Extraction", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(ifThenElseEClass, IfThenElse.class, "IfThenElse", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(mergeEClass, Merge.class, "Merge", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(notEClass, Not.class, "Not", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(nullClockEClass, NullClock.class, "NullClock", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(numericExpressionEClass, NumericExpression.class, "NumericExpression", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNumericExpression_Expression(), ecorePackage.getEString(), "expression", null, 1, 1,
			NumericExpression.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(orEClass, Or.class, "Or", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(pragmaEClass, Pragma.class, "Pragma", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPragma_InterfaceParent(), this.getInterfaceDefinition(), this
				.getInterfaceDefinition_Pragmas(), "interfaceParent", null, 0, 1, Pragma.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		initEReference(getPragma_ModuleParent(), this.getModule(), this.getModule_Pragmas(), "moduleParent", null, 0,
			1, Pragma.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPragma_Pragma(), ecorePackage.getEString(), "pragma", null, 1, 1, Pragma.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPragma_Expression(), ecorePackage.getEString(), "expression", null, 0, 1, Pragma.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPragma_Targets(), this.getIdentifier(), null, "targets", null, 0, -1, Pragma.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(repetitionOperatorEClass, RepetitionOperator.class, "RepetitionOperator", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(sequentialDefinitionEClass, SequentialDefinition.class, "SequentialDefinition", !IS_ABSTRACT,
			!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(switchEClass, Switch.class, "Switch", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSwitch_Signal(), this.getSignal(), null, "signal", null, 1, 1, Switch.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED,
			!IS_ORDERED);
		initEReference(getSwitch_Src_CaseConnections(), this.getCaseConnection(), this.getCaseConnection_Src(),
			"src_CaseConnections", null, 1, -1, Switch.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSwitch_SrcField(), ecorePackage.getEString(), "srcField", "", 0, 1, Switch.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(transpositionEClass, Transposition.class, "Transposition", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(tupleOperatorEClass, TupleOperator.class, "TupleOperator", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(unaryMinusEClass, UnaryMinus.class, "UnaryMinus", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(variableEClass, Variable.class, "Variable", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getVariable_InitialValue(), ecorePackage.getEString(), "initialValue", null, 0, -1,
			Variable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		
		initEClass(windowEClass, Window.class, "Window", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getWindow_WindowSize(), ecorePackage.getEString(), "windowSize", "1", 0, 1, Window.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getWindow_InitialValue(), ecorePackage.getEString(), "initialValue", null, 0, -1, Window.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(xorEClass, Xor.class, "Xor", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(stateOrHistoryEClass, StateOrHistory.class, "StateOrHistory", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getStateOrHistory_Dst_StrongTransitions(), this.getStrongTransition(), this
				.getStrongTransition_Dst(), "dst_StrongTransitions", null, 0, -1, StateOrHistory.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		initEReference(getStateOrHistory_Dst_WeakTransitions(), this.getWeakTransition(), this.getWeakTransition_Dst(),
			"dst_WeakTransitions", null, 0, -1, StateOrHistory.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(historyEClass, History.class, "History", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getHistory_ParentState(), this.getCompoundState(), this.getCompoundState_History(),
			"parentState", null, 1, 1, History.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		
		initEClass(stateBaseEClass, StateBase.class, "StateBase", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getStateBase_StateParent(), this.getCompoundState(), this.getCompoundState_States(),
			"stateParent", null, 0, 1, StateBase.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getStateBase_Src_WeakTransitions(), this.getWeakTransition(), this.getWeakTransition_Src(),
			"src_WeakTransitions", null, 0, -1, StateBase.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
			!IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getStateBase_Src_StrongTransitions(), this.getStrongTransition(),
			this.getStrongTransition_Src(), "src_StrongTransitions", null, 0, -1, StateBase.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		
		initEClass(stateEClass, State.class, "State", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(compoundStateEClass, CompoundState.class, "CompoundState", IS_ABSTRACT, IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCompoundState_States(), this.getStateBase(), this.getStateBase_StateParent(), "states", null,
			1, -1, CompoundState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCompoundState_History(), this.getHistory(), this.getHistory_ParentState(), "history", null,
			0, 1, CompoundState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getCompoundState_Locals(), this.getLocal(), this.getLocal_StateParent(), "locals", null, 0, -1,
			CompoundState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		addEOperation(compoundStateEClass, ecorePackage.getEString(), "getPrefix", 1, 1, IS_UNIQUE, IS_ORDERED);
		
		initEClass(automatonEClass, Automaton.class, "Automaton", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAutomaton_ModelParent(), this.getModel(), this.getModel_Automata(), "modelParent", null, 0,
			1, Automaton.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
			!IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAutomaton_InitState(), this.getStateBase(), null, "initState", null, 1, 1, Automaton.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
			!IS_DERIVED, IS_ORDERED);
		initEReference(getAutomaton_Transitions(), this.getTransition(), this.getTransition_AutomatonParent(),
			"transitions", null, 0, -1, Automaton.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		addEOperation(automatonEClass, ecorePackage.getEInt(), "getCurrentStateNameAST", 0, 1, IS_UNIQUE, IS_ORDERED);
		
		initEClass(andStateEClass, AndState.class, "AndState", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		
		initEClass(transitionEClass, Transition.class, "Transition", IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTransition_Guard(), ecorePackage.getEString(), "guard", null, 0, 1, Transition.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTransition_Priority(), ecorePackage.getEInt(), "priority", null, 1, 1, Transition.class,
			!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTransition_AutomatonParent(), this.getAutomaton(), this.getAutomaton_Transitions(),
			"automatonParent", null, 1, 1, Transition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(weakTransitionEClass, WeakTransition.class, "WeakTransition", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getWeakTransition_Src(), this.getStateBase(), this.getStateBase_Src_WeakTransitions(), "src",
			null, 1, 1, WeakTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getWeakTransition_Dst(), this.getStateOrHistory(), this.getStateOrHistory_Dst_WeakTransitions(),
			"dst", null, 1, 1, WeakTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		
		initEClass(strongTransitionEClass, StrongTransition.class, "StrongTransition", !IS_ABSTRACT, !IS_INTERFACE,
			IS_GENERATED_INSTANCE_CLASS);
		initEReference(getStrongTransition_Src(), this.getStateBase(), this.getStateBase_Src_StrongTransitions(),
			"src", null, 1, 1, StrongTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
			IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getStrongTransition_Dst(), this.getStateOrHistory(), this
				.getStateOrHistory_Dst_StrongTransitions(), "dst", null, 1, 1, StrongTransition.class, !IS_TRANSIENT,
			!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
			IS_ORDERED);
		
		// Initialize enums and add enum literals
		initEEnum(signalIntrinsicTypeEEnum, SignalIntrinsicType.class, "SignalIntrinsicType");
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.UNDEFINED_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.BOOLEAN_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.CHAR_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.COMPLEX_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.DCOMPLEX_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.DREAL_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.EVENT_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.INTEGER_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.LONG_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.REAL_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.SHORT_LITERAL);
		addEEnumLiteral(signalIntrinsicTypeEEnum, SignalIntrinsicType.STRING_LITERAL);
		
		initEEnum(modelKindEEnum, ModelKind.class, "ModelKind");
		addEEnumLiteral(modelKindEEnum, ModelKind.ACTION_LITERAL);
		addEEnumLiteral(modelKindEEnum, ModelKind.FUNCTION_LITERAL);
		addEEnumLiteral(modelKindEEnum, ModelKind.NODE_LITERAL);
		addEEnumLiteral(modelKindEEnum, ModelKind.PROCESS_LITERAL);
		
		initEEnum(processAttributeKindEEnum, ProcessAttributeKind.class, "ProcessAttributeKind");
		addEEnumLiteral(processAttributeKindEEnum, ProcessAttributeKind.SAFE_LITERAL);
		addEEnumLiteral(processAttributeKindEEnum, ProcessAttributeKind.DETERMINISTIC_LITERAL);
		addEEnumLiteral(processAttributeKindEEnum, ProcessAttributeKind.UNSAFE_LITERAL);
		
		initEEnum(compilationDirectiveKindEEnum, CompilationDirectiveKind.class, "CompilationDirectiveKind");
		addEEnumLiteral(compilationDirectiveKindEEnum, CompilationDirectiveKind.NONE_LITERAL);
		addEEnumLiteral(compilationDirectiveKindEEnum, CompilationDirectiveKind.UNEXPANDED_LITERAL);
		addEEnumLiteral(compilationDirectiveKindEEnum, CompilationDirectiveKind.SEPARATE_LITERAL);
		addEEnumLiteral(compilationDirectiveKindEEnum, CompilationDirectiveKind.BLACK_BOX_LITERAL);
		addEEnumLiteral(compilationDirectiveKindEEnum, CompilationDirectiveKind.GREY_BOX_LITERAL);
		addEEnumLiteral(compilationDirectiveKindEEnum, CompilationDirectiveKind.DELAY_CLUSTER_LITERAL);
		
		initEEnum(signalStateKindEEnum, SignalStateKind.class, "SignalStateKind");
		addEEnumLiteral(signalStateKindEEnum, SignalStateKind.PRESENT_LITERAL);
		addEEnumLiteral(signalStateKindEEnum, SignalStateKind.TRUE_LITERAL);
		addEEnumLiteral(signalStateKindEEnum, SignalStateKind.FALSE_LITERAL);
		
		initEEnum(caseKindEEnum, CaseKind.class, "CaseKind");
		addEEnumLiteral(caseKindEEnum, CaseKind.ELSE_CASE_LITERAL);
		addEEnumLiteral(caseKindEEnum, CaseKind.ENUMERATION_LITERAL);
		addEEnumLiteral(caseKindEEnum, CaseKind.CLOSED_INTERVAL_LITERAL);
		addEEnumLiteral(caseKindEEnum, CaseKind.RIGHT_HALF_OPENED_INTERVAL_LITERAL);
		addEEnumLiteral(caseKindEEnum, CaseKind.LEFT_HALF_OPENED_INTERVAL_LITERAL);
		addEEnumLiteral(caseKindEEnum, CaseKind.OPENED_INTERVAL_LITERAL);
		
		initEEnum(typeKindEEnum, TypeKind.class, "TypeKind");
		addEEnumLiteral(typeKindEEnum, TypeKind.BUNDLE_LITERAL);
		addEEnumLiteral(typeKindEEnum, TypeKind.STRUCT_LITERAL);
		
		initEEnum(arithmeticOpKindEEnum, ArithmeticOpKind.class, "ArithmeticOpKind");
		addEEnumLiteral(arithmeticOpKindEEnum, ArithmeticOpKind.ADDITION_LITERAL);
		addEEnumLiteral(arithmeticOpKindEEnum, ArithmeticOpKind.SUBSTRACTION_LITERAL);
		addEEnumLiteral(arithmeticOpKindEEnum, ArithmeticOpKind.MULTIPLICATION_LITERAL);
		addEEnumLiteral(arithmeticOpKindEEnum, ArithmeticOpKind.DIVISION_LITERAL);
		addEEnumLiteral(arithmeticOpKindEEnum, ArithmeticOpKind.MODULO_LITERAL);
		addEEnumLiteral(arithmeticOpKindEEnum, ArithmeticOpKind.POWER_LITERAL);
		
		initEEnum(comparisonOpKindEEnum, ComparisonOpKind.class, "ComparisonOpKind");
		addEEnumLiteral(comparisonOpKindEEnum, ComparisonOpKind.EQUAL_LITERAL);
		addEEnumLiteral(comparisonOpKindEEnum, ComparisonOpKind.NOT_EQUAL_LITERAL);
		addEEnumLiteral(comparisonOpKindEEnum, ComparisonOpKind.GREATER_LITERAL);
		addEEnumLiteral(comparisonOpKindEEnum, ComparisonOpKind.GREATER_OR_EQUAL_LITERAL);
		addEEnumLiteral(comparisonOpKindEEnum, ComparisonOpKind.SMALLER_LITERAL);
		addEEnumLiteral(comparisonOpKindEEnum, ComparisonOpKind.SMALLER_OR_EQUAL_LITERAL);
		addEEnumLiteral(comparisonOpKindEEnum, ComparisonOpKind.EQUAL_ANY_LITERAL);
		addEEnumLiteral(comparisonOpKindEEnum, ComparisonOpKind.SMALLER_OR_EQUAL_ANY_LITERAL);
		
		initEEnum(clockConstraintOpKindEEnum, ClockConstraintOpKind.class, "ClockConstraintOpKind");
		addEEnumLiteral(clockConstraintOpKindEEnum, ClockConstraintOpKind.SYNCHRONIZED_LITERAL);
		addEEnumLiteral(clockConstraintOpKindEEnum, ClockConstraintOpKind.EXCLUDED_LITERAL);
		addEEnumLiteral(clockConstraintOpKindEEnum, ClockConstraintOpKind.IDENTITY_LITERAL);
		
		initEEnum(clockRelationOpKindEEnum, ClockRelationOpKind.class, "ClockRelationOpKind");
		addEEnumLiteral(clockRelationOpKindEEnum, ClockRelationOpKind.UNION_LITERAL);
		addEEnumLiteral(clockRelationOpKindEEnum, ClockRelationOpKind.INTERSECTION_LITERAL);
		addEEnumLiteral(clockRelationOpKindEEnum, ClockRelationOpKind.COMPLEMENTARY_LITERAL);
		
		initEEnum(clockSpeedOpKindEEnum, ClockSpeedOpKind.class, "ClockSpeedOpKind");
		addEEnumLiteral(clockSpeedOpKindEEnum, ClockSpeedOpKind.SLOWER_LITERAL);
		addEEnumLiteral(clockSpeedOpKindEEnum, ClockSpeedOpKind.FASTER_LITERAL);
		
		initEEnum(visibilityKindEEnum, VisibilityKind.class, "VisibilityKind");
		addEEnumLiteral(visibilityKindEEnum, VisibilityKind.PUBLIC_LITERAL);
		addEEnumLiteral(visibilityKindEEnum, VisibilityKind.PRIVATE_LITERAL);
		
		initEEnum(counterKindEEnum, CounterKind.class, "CounterKind");
		addEEnumLiteral(counterKindEEnum, CounterKind.AFTER);
		addEEnumLiteral(counterKindEEnum, CounterKind.FROM);
		addEEnumLiteral(counterKindEEnum, CounterKind.COUNT);
		
		initEEnum(statusKindEEnum, StatusKind.class, "StatusKind");
		addEEnumLiteral(statusKindEEnum, StatusKind.NORMAL);
		addEEnumLiteral(statusKindEEnum, StatusKind.SHARED);
		addEEnumLiteral(statusKindEEnum, StatusKind.STATEVAR);
		
		// Initialize data types
		initEDataType(cyclicDefinitionExceptionEDataType, CyclicDefinitionException.class, "CyclicDefinitionException",
			IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(setEDataType, Set.class, "Set", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		
		// Create resource
		createResource(eNS_URI);
		
		// Create annotations
		// http://www.topcased.org/uuid
		createUuidAnnotations();
	}
	
	/**
	 * Initializes the annotations for <b>http://www.topcased.org/uuid</b>. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	protected void createUuidAnnotations() {
		String source = "http://www.topcased.org/uuid";
		addAnnotation(this, source, new String[] { "uuid", "_1_AnwO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum, source, new String[] { "uuid", "_1_Anwe5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_1_JxsO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(2), source, new String[] { "uuid",
				"_1_csoO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(3), source, new String[] { "uuid",
				"_1_wOoO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(4), source, new String[] { "uuid",
				"_2ADJkO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(5), source, new String[] { "uuid",
				"_2AWEgO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(6), source, new String[] { "uuid",
				"_2Ao_cO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(7), source, new String[] { "uuid",
				"_2AywcO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(8), source, new String[] { "uuid",
				"_2BFrYO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(9), source, new String[] { "uuid",
				"_2BZNYO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(10), source, new String[] { "uuid",
				"_2BsIUO5WEduz9o2pAin6-g" });
		addAnnotation(signalIntrinsicTypeEEnum.getELiterals().get(11), source, new String[] { "uuid",
				"_2B1SQO5WEduz9o2pAin6-g" });
		addAnnotation(modelKindEEnum, source, new String[] { "uuid", "_2B1SQe5WEduz9o2pAin6-g" });
		addAnnotation(modelKindEEnum.getELiterals().get(0), source, new String[] { "uuid", "_2B_DQO5WEduz9o2pAin6-g" });
		addAnnotation(modelKindEEnum.getELiterals().get(1), source, new String[] { "uuid", "_2CI0QO5WEduz9o2pAin6-g" });
		addAnnotation(modelKindEEnum.getELiterals().get(2), source, new String[] { "uuid", "_2CbvMO5WEduz9o2pAin6-g" });
		addAnnotation(modelKindEEnum.getELiterals().get(3), source, new String[] { "uuid", "_2CuqIO5WEduz9o2pAin6-g" });
		addAnnotation(processAttributeKindEEnum, source, new String[] { "uuid", "_2D688O5WEduz9o2pAin6-g" });
		addAnnotation(processAttributeKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2EN34O5WEduz9o2pAin6-g" });
		addAnnotation(processAttributeKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2EN34e5WEduz9o2pAin6-g" });
		addAnnotation(processAttributeKindEEnum.getELiterals().get(2), source, new String[] { "uuid",
				"_2EN34u5WEduz9o2pAin6-g" });
		addAnnotation(compilationDirectiveKindEEnum, source, new String[] { "uuid", "_2EXo4O5WEduz9o2pAin6-g" });
		addAnnotation(compilationDirectiveKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2IPcQO5WEduz9o2pAin6-g" });
		addAnnotation(compilationDirectiveKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2IPcQe5WEduz9o2pAin6-g" });
		addAnnotation(compilationDirectiveKindEEnum.getELiterals().get(2), source, new String[] { "uuid",
				"_2IZNQO5WEduz9o2pAin6-g" });
		addAnnotation(compilationDirectiveKindEEnum.getELiterals().get(3), source, new String[] { "uuid",
				"_2IZNQe5WEduz9o2pAin6-g" });
		addAnnotation(compilationDirectiveKindEEnum.getELiterals().get(4), source, new String[] { "uuid",
				"_2IZNQu5WEduz9o2pAin6-g" });
		addAnnotation(compilationDirectiveKindEEnum.getELiterals().get(5), source, new String[] { "uuid",
				"_2Ii-QO5WEduz9o2pAin6-g" });
		addAnnotation(signalStateKindEEnum, source, new String[] { "uuid", "_2Ii-Qe5WEduz9o2pAin6-g" });
		addAnnotation(signalStateKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2IsIMO5WEduz9o2pAin6-g" });
		addAnnotation(signalStateKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2IsIMe5WEduz9o2pAin6-g" });
		addAnnotation(signalStateKindEEnum.getELiterals().get(2), source, new String[] { "uuid",
				"_2I15MO5WEduz9o2pAin6-g" });
		addAnnotation(caseKindEEnum, source, new String[] { "uuid", "_2I15Me5WEduz9o2pAin6-g" });
		addAnnotation(caseKindEEnum.getELiterals().get(0), source, new String[] { "uuid", "_2I_DIO5WEduz9o2pAin6-g" });
		addAnnotation(caseKindEEnum.getELiterals().get(1), source, new String[] { "uuid", "_2I_DIe5WEduz9o2pAin6-g" });
		addAnnotation(caseKindEEnum.getELiterals().get(2), source, new String[] { "uuid", "_2I_DIu5WEduz9o2pAin6-g" });
		addAnnotation(caseKindEEnum.getELiterals().get(3), source, new String[] { "uuid", "_2JI0IO5WEduz9o2pAin6-g" });
		addAnnotation(caseKindEEnum.getELiterals().get(4), source, new String[] { "uuid", "_2JI0Ie5WEduz9o2pAin6-g" });
		addAnnotation(caseKindEEnum.getELiterals().get(5), source, new String[] { "uuid", "_2JSlIO5WEduz9o2pAin6-g" });
		addAnnotation(typeKindEEnum, source, new String[] { "uuid", "_2JSlIe5WEduz9o2pAin6-g" });
		addAnnotation(typeKindEEnum.getELiterals().get(0), source, new String[] { "uuid", "_2JSlIu5WEduz9o2pAin6-g" });
		addAnnotation(typeKindEEnum.getELiterals().get(1), source, new String[] { "uuid", "_2JbvEO5WEduz9o2pAin6-g" });
		addAnnotation(arithmeticOpKindEEnum, source, new String[] { "uuid", "_2JbvEe5WEduz9o2pAin6-g" });
		addAnnotation(arithmeticOpKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2JlgEO5WEduz9o2pAin6-g" });
		addAnnotation(arithmeticOpKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2JlgEe5WEduz9o2pAin6-g" });
		addAnnotation(arithmeticOpKindEEnum.getELiterals().get(2), source, new String[] { "uuid",
				"_2JlgEu5WEduz9o2pAin6-g" });
		addAnnotation(arithmeticOpKindEEnum.getELiterals().get(3), source, new String[] { "uuid",
				"_2JlgE-5WEduz9o2pAin6-g" });
		addAnnotation(arithmeticOpKindEEnum.getELiterals().get(4), source, new String[] { "uuid",
				"_2JvREO5WEduz9o2pAin6-g" });
		addAnnotation(arithmeticOpKindEEnum.getELiterals().get(5), source, new String[] { "uuid",
				"_2JvREe5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum, source, new String[] { "uuid", "_2JvREu5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2J4bAO5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2J4bAe5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum.getELiterals().get(2), source, new String[] { "uuid",
				"_2J4bAu5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum.getELiterals().get(3), source, new String[] { "uuid",
				"_2KCMAO5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum.getELiterals().get(4), source, new String[] { "uuid",
				"_2KCMAe5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum.getELiterals().get(5), source, new String[] { "uuid",
				"_2KLV8O5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum.getELiterals().get(6), source, new String[] { "uuid",
				"_2KLV8e5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOpKindEEnum.getELiterals().get(7), source, new String[] { "uuid",
				"_2KLV8u5WEduz9o2pAin6-g" });
		addAnnotation(clockConstraintOpKindEEnum, source, new String[] { "uuid", "_2KVG8O5WEduz9o2pAin6-g" });
		addAnnotation(clockConstraintOpKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2KVG8e5WEduz9o2pAin6-g" });
		addAnnotation(clockConstraintOpKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2KVG8u5WEduz9o2pAin6-g" });
		addAnnotation(clockConstraintOpKindEEnum.getELiterals().get(2), source, new String[] { "uuid",
				"_2KVG8-5WEduz9o2pAin6-g" });
		addAnnotation(clockRelationOpKindEEnum, source, new String[] { "uuid", "_2Ke38O5WEduz9o2pAin6-g" });
		addAnnotation(clockRelationOpKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2KoB4O5WEduz9o2pAin6-g" });
		addAnnotation(clockRelationOpKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2KoB4e5WEduz9o2pAin6-g" });
		addAnnotation(clockRelationOpKindEEnum.getELiterals().get(2), source, new String[] { "uuid",
				"_2KoB4u5WEduz9o2pAin6-g" });
		addAnnotation(clockSpeedOpKindEEnum, source, new String[] { "uuid", "_2KoB4-5WEduz9o2pAin6-g" });
		addAnnotation(clockSpeedOpKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2Kxy4O5WEduz9o2pAin6-g" });
		addAnnotation(clockSpeedOpKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2Kxy4e5WEduz9o2pAin6-g" });
		addAnnotation(visibilityKindEEnum, source, new String[] { "uuid", "_2K7j4O5WEduz9o2pAin6-g" });
		addAnnotation(visibilityKindEEnum.getELiterals().get(0), source, new String[] { "uuid",
				"_2K7j4e5WEduz9o2pAin6-g" });
		addAnnotation(visibilityKindEEnum.getELiterals().get(1), source, new String[] { "uuid",
				"_2LEt0O5WEduz9o2pAin6-g" });
		addAnnotation(counterKindEEnum, source, new String[] { "uuid", "_2LEt0e5WEduz9o2pAin6-g" });
		addAnnotation(counterKindEEnum.getELiterals().get(0), source,
			new String[] { "uuid", "_2LEt0u5WEduz9o2pAin6-g" });
		addAnnotation(counterKindEEnum.getELiterals().get(1), source,
			new String[] { "uuid", "_2LEt0-5WEduz9o2pAin6-g" });
		addAnnotation(counterKindEEnum.getELiterals().get(2), source,
			new String[] { "uuid", "_2LOe0O5WEduz9o2pAin6-g" });
		addAnnotation(signalElementEClass, source, new String[] { "uuid", "_2LOe0u5WEduz9o2pAin6-g" });
		addAnnotation(signalElementEClass.getEOperations().get(0), source, new String[] { "uuid",
				"_2LOe0-5WEduz9o2pAin6-g" });
		addAnnotation(rootModelEClass, source, new String[] { "uuid", "_2LOe0e5WEduz9o2pAin6-g" });
		addAnnotation(connectableElementEClass, source, new String[] { "uuid", "_2LOe1O5WEduz9o2pAin6-g" });
		addAnnotation(namedElementEClass, source, new String[] { "uuid", "_2LOe1e5WEduz9o2pAin6-g" });
		addAnnotation(getNamedElement_Name(), source, new String[] { "uuid", "_2LOe1u5WEduz9o2pAin6-g" });
		addAnnotation(identifierEClass, source, new String[] { "uuid", "_2LOe1-5WEduz9o2pAin6-g" });
		addAnnotation(getIdentifier_Comment(), source, new String[] { "uuid", "_2LOe2O5WEduz9o2pAin6-g" });
		addAnnotation(signalExprEClass, source, new String[] { "uuid", "_2LOe2e5WEduz9o2pAin6-g" });
		addAnnotation(getSignalExpr_Src_DataflowConnections(), source,
			new String[] { "uuid", "_2LOe2u5WEduz9o2pAin6-g" });
		addAnnotation(constantExprEClass, source, new String[] { "uuid", "_2LOe2-5WEduz9o2pAin6-g" });
		addAnnotation(getConstantExpr_Src_ConstantAffectations(), source, new String[] { "uuid",
				"_2LOe3O5WEduz9o2pAin6-g" });
		addAnnotation(clockedExprEClass, source, new String[] { "uuid", "_2LOe3e5WEduz9o2pAin6-g" });
		addAnnotation(getClockedExpr_Src_ClockRelations(), source, new String[] { "uuid", "_2LOe3u5WEduz9o2pAin6-g" });
		addAnnotation(getClockedExpr_Dst_ClockRelations(), source, new String[] { "uuid", "_2LOe3-5WEduz9o2pAin6-g" });
		addAnnotation(dependenceInOutEClass, source, new String[] { "uuid", "_2LOe4O5WEduz9o2pAin6-g" });
		addAnnotation(getDependenceInOut_Src_Dependences(), source, new String[] { "uuid", "_2LOe4e5WEduz9o2pAin6-g" });
		addAnnotation(getDependenceInOut_Dst_Dependences(), source, new String[] { "uuid", "_2LOe4u5WEduz9o2pAin6-g" });
		addAnnotation(signalContainerEClass, source, new String[] { "uuid", "_2LOe4-5WEduz9o2pAin6-g" });
		addAnnotation(signalContainerEClass.getEOperations().get(0), source, new String[] { "uuid",
				"_2LOe5O5WEduz9o2pAin6-g" });
		addAnnotation(signalContainerEClass.getEOperations().get(1), source, new String[] { "uuid",
				"_2LOe5e5WEduz9o2pAin6-g" });
		addAnnotation(signalContainerEClass.getEOperations().get(2), source, new String[] { "uuid",
				"_2LOe5u5WEduz9o2pAin6-g" });
		addAnnotation(signalContainerEClass.getEOperations().get(3), source, new String[] { "uuid",
				"_2LOe5-5WEduz9o2pAin6-g" });
		addAnnotation(signalContainerEClass.getEOperations().get(4), source, new String[] { "uuid",
				"_2LOe6O5WEduz9o2pAin6-g" });
		addAnnotation(interfaceDefinitionEClass, source, new String[] { "uuid", "_2LOe6e5WEduz9o2pAin6-g" });
		addAnnotation(getInterfaceDefinition_Type(), source, new String[] { "uuid", "_2LOe6u5WEduz9o2pAin6-g" });
		addAnnotation(getInterfaceDefinition_Inputs(), source, new String[] { "uuid", "_2LOe6-5WEduz9o2pAin6-g" });
		addAnnotation(getInterfaceDefinition_Outputs(), source, new String[] { "uuid", "_2LOe7O5WEduz9o2pAin6-g" });
		addAnnotation(getInterfaceDefinition_Parameters(), source, new String[] { "uuid", "_2LOe7e5WEduz9o2pAin6-g" });
		addAnnotation(getInterfaceDefinition_Spec(), source, new String[] { "uuid", "_2LOe7u5WEduz9o2pAin6-g" });
		addAnnotation(getInterfaceDefinition_Pragmas(), source, new String[] { "uuid", "_2LOe7-5WEduz9o2pAin6-g" });
		addAnnotation(getInterfaceDefinition_ProcessClass(), source, new String[] { "uuid", "_2LOe8O5WEduz9o2pAin6-g" });
		addAnnotation(modelEClass, source, new String[] { "uuid", "_2LOe8e5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Assertions(), source, new String[] { "uuid", "_2LOe8u5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Automata(), source, new String[] { "uuid", "_2LOe8-5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Connections(), source, new String[] { "uuid", "_2LOe9O5WEduz9o2pAin6-g" });
		addAnnotation(getModel_ConstantRef(), source, new String[] { "uuid", "_2LOe9e5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Constants(), source, new String[] { "uuid", "_2LOe9u5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Constraints(), source, new String[] { "uuid", "_2LOe9-5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Indexes(), source, new String[] { "uuid", "_2LOe-O5WEduz9o2pAin6-g" });
		addAnnotation(getModel_ContainedInstances(), source, new String[] { "uuid", "_2LOe-e5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Locals(), source, new String[] { "uuid", "_2LOe-u5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Operators(), source, new String[] { "uuid", "_2LOe--5WEduz9o2pAin6-g" });
		addAnnotation(getModel_SignalRef(), source, new String[] { "uuid", "_2LOe_O5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Subprocesses(), source, new String[] { "uuid", "_2LOe_e5WEduz9o2pAin6-g" });
		addAnnotation(getModel_Types(), source, new String[] { "uuid", "_2LOe_u5WEduz9o2pAin6-g" });
		addAnnotation(getModel_UseModule(), source, new String[] { "uuid", "_2LOe_-5WEduz9o2pAin6-g" });
		addAnnotation(getModel_ModelRefs(), source, new String[] { "uuid", "_X5lIABW_EdyjKrSFpqO4YA" });
		addAnnotation(iterateEClass, source, new String[] { "uuid", "_2LOfAO5WEduz9o2pAin6-g" });
		addAnnotation(getIterate_IterationInit(), source, new String[] { "uuid", "_2LOfAu5WEduz9o2pAin6-g" });
		addAnnotation(getIterate_Ins(), source, new String[] { "uuid", "_2LOfA-5WEduz9o2pAin6-g" });
		addAnnotation(iterationInitEClass, source, new String[] { "uuid", "_2LOfBO5WEduz9o2pAin6-g" });
		addAnnotation(getIterationInit_IterateParent(), source, new String[] { "uuid", "_2LOfBe5WEduz9o2pAin6-g" });
		addAnnotation(specificationsEClass, source, new String[] { "uuid", "_2LOfBu5WEduz9o2pAin6-g" });
		addAnnotation(getSpecifications_InterfaceParent(), source, new String[] { "uuid", "_2LOfB-5WEduz9o2pAin6-g" });
		addAnnotation(getSpecifications_TypeParent(), source, new String[] { "uuid", "_2LOfCO5WEduz9o2pAin6-g" });
		addAnnotation(getSpecifications_ModelDeclarations(), source, new String[] { "uuid", "_2LOfCe5WEduz9o2pAin6-g" });
		addAnnotation(subProcessEClass, source, new String[] { "uuid", "_2LOfCu5WEduz9o2pAin6-g" });
		addAnnotation(getSubProcess_ModelParent(), source, new String[] { "uuid", "_2LOfC-5WEduz9o2pAin6-g" });
		addAnnotation(getSubProcess_Dst_CaseConnection(), source, new String[] { "uuid", "_2LOfDO5WEduz9o2pAin6-g" });
		addAnnotation(typeDeclarationEClass, source, new String[] { "uuid", "_2LOfDe5WEduz9o2pAin6-g" });
		addAnnotation(getTypeDeclaration_ModuleParent(), source, new String[] { "uuid", "_2LOfDu5WEduz9o2pAin6-g" });
		addAnnotation(getTypeDeclaration_ModelParent(), source, new String[] { "uuid", "_2LOfD-5WEduz9o2pAin6-g" });
		addAnnotation(getTypeDeclaration_Visibility(), source, new String[] { "uuid", "_2LOfEO5WEduz9o2pAin6-g" });
		addAnnotation(parameterTypeEClass, source, new String[] { "uuid", "_2LOfEe5WEduz9o2pAin6-g" });
		addAnnotation(signalTypeEClass, source, new String[] { "uuid", "_2LOfEu5WEduz9o2pAin6-g" });
		addAnnotation(getSignalType_ArrayDimensions(), source, new String[] { "uuid", "_2LOfFe5WEduz9o2pAin6-g" });
		addAnnotation(enumerationTypeEClass, source, new String[] { "uuid", "_2LOfE-5WEduz9o2pAin6-g" });
		addAnnotation(getEnumerationType_EnumValues(), source, new String[] { "uuid", "_2LOfFO5WEduz9o2pAin6-g" });
		addAnnotation(modelTypeEClass, source, new String[] { "uuid", "_2LOfFu5WEduz9o2pAin6-g" });
		addAnnotation(getModelType_ModelType(), source, new String[] { "uuid", "_2LOfF-5WEduz9o2pAin6-g" });
		addAnnotation(substitutionTypeEClass, source, new String[] { "uuid", "_2LOfGO5WEduz9o2pAin6-g" });
		addAnnotation(getSubstitutionType_Type(), source, new String[] { "uuid", "_2LOfGe5WEduz9o2pAin6-g" });
		addAnnotation(getSubstitutionType_IsExternal(), source, new String[] { "uuid", "_2LOfGu5WEduz9o2pAin6-g" });
		addAnnotation(tupleTypeEClass, source, new String[] { "uuid", "_2LOfHO5WEduz9o2pAin6-g" });
		addAnnotation(getTupleType_Kind(), source, new String[] { "uuid", "_2LOfHe5WEduz9o2pAin6-g" });
		addAnnotation(getTupleType_Locals(), source, new String[] { "uuid", "_2LOfH-5WEduz9o2pAin6-g" });
		addAnnotation(getTupleType_Spec(), source, new String[] { "uuid", "_2LOfIO5WEduz9o2pAin6-g" });
		addAnnotation(modelDeclarationEClass, source, new String[] { "uuid", "_2LOfIe5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_ModelParent(), source, new String[] { "uuid", "_2LOfIu5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_ModuleParent(), source, new String[] { "uuid", "_2LOfI-5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_SpecParent(), source, new String[] { "uuid", "_2LOfJO5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_ModelType(), source, new String[] { "uuid", "_2LOfJe5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_Visibility(), source, new String[] { "uuid", "_2LOfJu5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_IsMain(), source, new String[] { "uuid", "_2LOfJ-5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_IsSigaliProcess(), source, new String[] { "uuid", "_2LOfKO5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_CompilationDirective(), source, new String[] { "uuid",
				"_2LOfKe5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_RunOn(), source, new String[] { "uuid", "_2LOfKu5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_C_CODE(), source, new String[] { "uuid", "_2LOfK-5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_Cpp_CODE(), source, new String[] { "uuid", "_2LOfLO5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_Java_CODE(), source, new String[] { "uuid", "_2LOfLe5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_Processor_type(), source, new String[] { "uuid", "_2LOfLu5WEduz9o2pAin6-g" });
		addAnnotation(getModelDeclaration_ModelDeclarations(), source,
			new String[] { "uuid", "_2LOfL-5WEduz9o2pAin6-g" });
		addAnnotation(modelRefEClass, source, new String[] { "uuid", "_X5lIMRW_EdyjKrSFpqO4YA" });
		addAnnotation(getModelRef_Model(), source, new String[] { "uuid", "_X5lIMhW_EdyjKrSFpqO4YA" });
		addAnnotation(getModelRef_ModelName(), source, new String[] { "uuid", "_X5lIMxW_EdyjKrSFpqO4YA" });
		addAnnotation(getModelRef_ModelParent(), source, new String[] { "uuid", "_X5lINBW_EdyjKrSFpqO4YA" });
		addAnnotation(modelInstanceEClass, source, new String[] { "uuid", "_2LOfMO5WEduz9o2pAin6-g" });
		addAnnotation(getModelInstance_ModelParent(), source, new String[] { "uuid", "_2LOfMe5WEduz9o2pAin6-g" });
		addAnnotation(getModelInstance_ReferredInterface(), source, new String[] { "uuid", "_2LOfMu5WEduz9o2pAin6-g" });
		addAnnotation(getModelInstance_ReferredParameter(), source, new String[] { "uuid", "_2LOfM-5WEduz9o2pAin6-g" });
		addAnnotation(getModelInstance_Inputs(), source, new String[] { "uuid", "_2LOfNO5WEduz9o2pAin6-g" });
		addAnnotation(getModelInstance_Outputs(), source, new String[] { "uuid", "_2LOfNe5WEduz9o2pAin6-g" });
		addAnnotation(getModelInstance_Parameters(), source, new String[] { "uuid", "_2LOfNu5WEduz9o2pAin6-g" });
		addAnnotation(moduleEClass, source, new String[] { "uuid", "_2LOfN-5WEduz9o2pAin6-g" });
		addAnnotation(moduleEClass.getEOperations().get(0), source, new String[] { "uuid", "_2LOfOO5WEduz9o2pAin6-g" });
		addAnnotation(moduleEClass.getEOperations().get(1), source, new String[] { "uuid", "_2LOfOe5WEduz9o2pAin6-g" });
		addAnnotation(moduleEClass.getEOperations().get(2), source, new String[] { "uuid", "_2LOfOu5WEduz9o2pAin6-g" });
		addAnnotation(getModule_Constants(), source, new String[] { "uuid", "_2LOfO-5WEduz9o2pAin6-g" });
		addAnnotation(getModule_ModelDeclarations(), source, new String[] { "uuid", "_2LOfPO5WEduz9o2pAin6-g" });
		addAnnotation(getModule_Types(), source, new String[] { "uuid", "_2LOfPe5WEduz9o2pAin6-g" });
		addAnnotation(getModule_UseModule(), source, new String[] { "uuid", "_2LOfPu5WEduz9o2pAin6-g" });
		addAnnotation(getModule_Pragmas(), source, new String[] { "uuid", "_2LOfP-5WEduz9o2pAin6-g" });
		addAnnotation(useModuleEClass, source, new String[] { "uuid", "_2LOfQO5WEduz9o2pAin6-g" });
		addAnnotation(getUseModule_ModelParent(), source, new String[] { "uuid", "_2LOfQe5WEduz9o2pAin6-g" });
		addAnnotation(getUseModule_ModuleParent(), source, new String[] { "uuid", "_2LOfQu5WEduz9o2pAin6-g" });
		addAnnotation(getUseModule_Modules(), source, new String[] { "uuid", "_2LOfQ-5WEduz9o2pAin6-g" });
		addAnnotation(dataflowConnectorEClass, source, new String[] { "uuid", "_2LOfRO5WEduz9o2pAin6-g" });
		addAnnotation(getDataflowConnector_Dst_DataflowConnections(), source, new String[] { "uuid",
				"_2LOfRe5WEduz9o2pAin6-g" });
		addAnnotation(constantOrRefEClass, source, new String[] { "uuid", "_2LOfRu5WEduz9o2pAin6-g" });
		addAnnotation(constantRefEClass, source, new String[] { "uuid", "_2LOfR-5WEduz9o2pAin6-g" });
		addAnnotation(getConstantRef_Constant(), source, new String[] { "uuid", "_2LOfSO5WEduz9o2pAin6-g" });
		addAnnotation(getConstantRef_CstName(), source, new String[] { "uuid", "_2LOfSe5WEduz9o2pAin6-g" });
		addAnnotation(getConstantRef_ModelParent(), source, new String[] { "uuid", "_2LOfSu5WEduz9o2pAin6-g" });
		addAnnotation(constantEClass, source, new String[] { "uuid", "_2LOfS-5WEduz9o2pAin6-g" });
		addAnnotation(getConstant_Dst_ConstantAffectation(), source, new String[] { "uuid", "_2LOfTO5WEduz9o2pAin6-g" });
		addAnnotation(constantValueEClass, source, new String[] { "uuid", "_2LOfTu5WEduz9o2pAin6-g" });
		addAnnotation(getConstantValue_ModelParent(), source, new String[] { "uuid", "_2LOfT-5WEduz9o2pAin6-g" });
		addAnnotation(getConstantValue_ModuleParent(), source, new String[] { "uuid", "_2LOfUO5WEduz9o2pAin6-g" });
		addAnnotation(getConstantValue_ArrayDimensions(), source, new String[] { "uuid", "_2LOfUe5WEduz9o2pAin6-g" });
		addAnnotation(getConstantValue_Type(), source, new String[] { "uuid", "_2LOfUu5WEduz9o2pAin6-g" });
		addAnnotation(getConstantValue_Value(), source, new String[] { "uuid", "_2LOfU-5WEduz9o2pAin6-g" });
		addAnnotation(getConstantValue_Visibility(), source, new String[] { "uuid", "_2LOfVO5WEduz9o2pAin6-g" });
		addAnnotation(parameterEClass, source, new String[] { "uuid", "_2LOfVe5WEduz9o2pAin6-g" });
		addAnnotation(getParameter_InterfaceParent(), source, new String[] { "uuid", "_2LOfVu5WEduz9o2pAin6-g" });
		addAnnotation(getParameter_ArrayDimensions(), source, new String[] { "uuid", "_2LOfV-5WEduz9o2pAin6-g" });
		addAnnotation(getParameter_Type(), source, new String[] { "uuid", "_2LOfWO5WEduz9o2pAin6-g" });
		addAnnotation(parameterInstanceEClass, source, new String[] { "uuid", "_2LOfWe5WEduz9o2pAin6-g" });
		addAnnotation(getParameterInstance_Parameter(), source, new String[] { "uuid", "_2LOfWu5WEduz9o2pAin6-g" });
		addAnnotation(getParameterInstance_InstanceParent(), source, new String[] { "uuid", "_2LOfW-5WEduz9o2pAin6-g" });
		addAnnotation(indexEClass, source, new String[] { "uuid", "_2LOfXO5WEduz9o2pAin6-g" });
		addAnnotation(getIndex_ModelParent(), source, new String[] { "uuid", "_2LOfXe5WEduz9o2pAin6-g" });
		addAnnotation(getIndex_From(), source, new String[] { "uuid", "_2LOfXu5WEduz9o2pAin6-g" });
		addAnnotation(getIndex_To(), source, new String[] { "uuid", "_2LOfX-5WEduz9o2pAin6-g" });
		addAnnotation(getIndex_Step(), source, new String[] { "uuid", "_2LOfYO5WEduz9o2pAin6-g" });
		addAnnotation(signalOrRefEClass, source, new String[] { "uuid", "_2LOfYe5WEduz9o2pAin6-g" });
		addAnnotation(signalRefEClass, source, new String[] { "uuid", "_2LOfY-5WEduz9o2pAin6-g" });
		addAnnotation(getSignalRef_Signal(), source, new String[] { "uuid", "_2LOfZO5WEduz9o2pAin6-g" });
		addAnnotation(getSignalRef_SigName(), source, new String[] { "uuid", "_2LOfZe5WEduz9o2pAin6-g" });
		addAnnotation(getSignalRef_ModelParent(), source, new String[] { "uuid", "_2LOfZu5WEduz9o2pAin6-g" });
		addAnnotation(signalEClass, source, new String[] { "uuid", "_2LOfZ-5WEduz9o2pAin6-g" });
		addAnnotation(getSignal_Type(), source, new String[] { "uuid", "_2LOfaO5WEduz9o2pAin6-g" });
		addAnnotation(getSignal_ArrayDimensions(), source, new String[] { "uuid", "_2LOfae5WEduz9o2pAin6-g" });
		addAnnotation(getSignal_InitValue(), source, new String[] { "uuid", "_2LOfau5WEduz9o2pAin6-g" });
		addAnnotation(inputEClass, source, new String[] { "uuid", "_2LOfbO5WEduz9o2pAin6-g" });
		addAnnotation(getInput_InterfaceParent(), source, new String[] { "uuid", "_2LOfbe5WEduz9o2pAin6-g" });
		addAnnotation(inputInstanceEClass, source, new String[] { "uuid", "_2LOfbu5WEduz9o2pAin6-g" });
		addAnnotation(getInputInstance_Input(), source, new String[] { "uuid", "_2LOfb-5WEduz9o2pAin6-g" });
		addAnnotation(getInputInstance_InstanceParent(), source, new String[] { "uuid", "_2LOfcO5WEduz9o2pAin6-g" });
		addAnnotation(outputEClass, source, new String[] { "uuid", "_2LOfce5WEduz9o2pAin6-g" });
		addAnnotation(getOutput_InterfaceParent(), source, new String[] { "uuid", "_2LOfcu5WEduz9o2pAin6-g" });
		addAnnotation(outputInstanceEClass, source, new String[] { "uuid", "_2LOfc-5WEduz9o2pAin6-g" });
		addAnnotation(getOutputInstance_Output(), source, new String[] { "uuid", "_2LOfdO5WEduz9o2pAin6-g" });
		addAnnotation(getOutputInstance_InstanceParent(), source, new String[] { "uuid", "_2LOfde5WEduz9o2pAin6-g" });
		addAnnotation(localEClass, source, new String[] { "uuid", "_2LOfdu5WEduz9o2pAin6-g" });
		addAnnotation(getLocal_ModelParent(), source, new String[] { "uuid", "_2LOfeO5WEduz9o2pAin6-g" });
		addAnnotation(getLocal_StateParent(), source, new String[] { "uuid", "_2LOfee5WEduz9o2pAin6-g" });
		addAnnotation(getLocal_TypeParent(), source, new String[] { "uuid", "_2LOfeu5WEduz9o2pAin6-g" });
		addAnnotation(connectionEClass, source, new String[] { "uuid", "_2LOfe-5WEduz9o2pAin6-g" });
		addAnnotation(connectionEClass.getEOperations().get(0), source, new String[] { "uuid",
				"_2LOffO5WEduz9o2pAin6-g" });
		addAnnotation(connectionEClass.getEOperations().get(1), source, new String[] { "uuid",
				"_2LOffe5WEduz9o2pAin6-g" });
		addAnnotation(modelConnectionEClass, source, new String[] { "uuid", "_2LOffu5WEduz9o2pAin6-g" });
		addAnnotation(getModelConnection_ModelParent(), source, new String[] { "uuid", "_2LOff-5WEduz9o2pAin6-g" });
		addAnnotation(caseConnectionEClass, source, new String[] { "uuid", "_2LOfgO5WEduz9o2pAin6-g" });
		addAnnotation(getCaseConnection_CaseKind(), source, new String[] { "uuid", "_2LOfge5WEduz9o2pAin6-g" });
		addAnnotation(getCaseConnection_Enumeration(), source, new String[] { "uuid", "_2LOfgu5WEduz9o2pAin6-g" });
		addAnnotation(getCaseConnection_LowerBound(), source, new String[] { "uuid", "_2LOfg-5WEduz9o2pAin6-g" });
		addAnnotation(getCaseConnection_UpperBound(), source, new String[] { "uuid", "_2LOfhO5WEduz9o2pAin6-g" });
		addAnnotation(getCaseConnection_CaseLabel(), source, new String[] { "uuid", "_2LOfhe5WEduz9o2pAin6-g" });
		addAnnotation(getCaseConnection_Src(), source, new String[] { "uuid", "_2LOfhu5WEduz9o2pAin6-g" });
		addAnnotation(getCaseConnection_Dst(), source, new String[] { "uuid", "_2LOfh-5WEduz9o2pAin6-g" });
		addAnnotation(clockRelationEClass, source, new String[] { "uuid", "_2LOfjO5WEduz9o2pAin6-g" });
		addAnnotation(getClockRelation_Src(), source, new String[] { "uuid", "_2LOfje5WEduz9o2pAin6-g" });
		addAnnotation(getClockRelation_Dst(), source, new String[] { "uuid", "_2LOfju5WEduz9o2pAin6-g" });
		addAnnotation(conditionEClass, source, new String[] { "uuid", "_2LOfj-5WEduz9o2pAin6-g" });
		addAnnotation(getCondition_ConditionKind(), source, new String[] { "uuid", "_2LOfkO5WEduz9o2pAin6-g" });
		addAnnotation(getCondition_Dst(), source, new String[] { "uuid", "_2LOfk-5WEduz9o2pAin6-g" });
		addAnnotation(constantAffectationEClass, source, new String[] { "uuid", "_2LOflO5WEduz9o2pAin6-g" });
		addAnnotation(getConstantAffectation_Src(), source, new String[] { "uuid", "_2LOfle5WEduz9o2pAin6-g" });
		addAnnotation(getConstantAffectation_Dst(), source, new String[] { "uuid", "_2LOflu5WEduz9o2pAin6-g" });
		addAnnotation(dataflowConnectionEClass, source, new String[] { "uuid", "_2LOfmu5WEduz9o2pAin6-g" });
		addAnnotation(getDataflowConnection_IsDefaultValue(), source,
			new String[] { "uuid", "_2LOfnO5WEduz9o2pAin6-g" });
		addAnnotation(getDataflowConnection_CastType(), source, new String[] { "uuid", "_2LOfne5WEduz9o2pAin6-g" });
		addAnnotation(getDataflowConnection_UseSrcClock(), source, new String[] { "uuid", "_2LOfnu5WEduz9o2pAin6-g" });
		addAnnotation(getDataflowConnection_UseLastIterationValue(), source, new String[] { "uuid",
				"_2LOfn-5WEduz9o2pAin6-g" });
		addAnnotation(getDataflowConnection_Src(), source, new String[] { "uuid", "_2LOfoO5WEduz9o2pAin6-g" });
		addAnnotation(getDataflowConnection_Dst(), source, new String[] { "uuid", "_2LOfoe5WEduz9o2pAin6-g" });
		addAnnotation(dependenceEClass, source, new String[] { "uuid", "_2LOfl-5WEduz9o2pAin6-g" });
		addAnnotation(getDependence_Src(), source, new String[] { "uuid", "_2LOfmO5WEduz9o2pAin6-g" });
		addAnnotation(getDependence_Dst(), source, new String[] { "uuid", "_2LOfme5WEduz9o2pAin6-g" });
		addAnnotation(operatorPortEClass, source, new String[] { "uuid", "_2LOfou5WEduz9o2pAin6-g" });
		addAnnotation(getOperatorPort_Name(), source, new String[] { "uuid", "_2LOfo-5WEduz9o2pAin6-g" });
		addAnnotation(inputPortEClass, source, new String[] { "uuid", "_2LOfpO5WEduz9o2pAin6-g" });
		addAnnotation(getInputPort_OperatorParent(), source, new String[] { "uuid", "_2LOfpe5WEduz9o2pAin6-g" });
		addAnnotation(outputPortEClass, source, new String[] { "uuid", "_2LOfpu5WEduz9o2pAin6-g" });
		addAnnotation(getOutputPort_OperatorParent(), source, new String[] { "uuid", "_2LOfp-5WEduz9o2pAin6-g" });
		addAnnotation(signalOperatorEClass, source, new String[] { "uuid", "_2LOfqO5WEduz9o2pAin6-g" });
		addAnnotation(signalOperatorEClass.getEOperations().get(0), source, new String[] { "uuid",
				"_2LOfqe5WEduz9o2pAin6-g" });
		addAnnotation(signalOperatorEClass.getEOperations().get(1), source, new String[] { "uuid",
				"_2LOfqu5WEduz9o2pAin6-g" });
		addAnnotation(signalOperatorEClass.getEOperations().get(2), source, new String[] { "uuid",
				"_2LOfq-5WEduz9o2pAin6-g" });
		addAnnotation(getConditionExpr_Src_Conditions(), source, new String[] { "uuid", "_2LOfYu5WEduz9o2pAin6-g" });
		addAnnotation(conditionnedExprEClass, source, new String[] { "uuid", "_2LOfru5WEduz9o2pAin6-g" });
		addAnnotation(getConditionnedExpr_Dst_Condition(), source, new String[] { "uuid", "_2LOfr-5WEduz9o2pAin6-g" });
		addAnnotation(controlflowOperatorEClass, source, new String[] { "uuid", "_2LOfsO5WEduz9o2pAin6-g" });
		addAnnotation(getControlflowOperator_ModelParent(), source, new String[] { "uuid", "_2LOfse5WEduz9o2pAin6-g" });
		addAnnotation(dataflowOperatorEClass, source, new String[] { "uuid", "_2LOfsu5WEduz9o2pAin6-g" });
		addAnnotation(getDataflowOperator_ModelParent(), source, new String[] { "uuid", "_2LOfs-5WEduz9o2pAin6-g" });
		addAnnotation(booleanOperatorIEClass, source, new String[] { "uuid", "_2LOftO5WEduz9o2pAin6-g" });
		addAnnotation(numericOperatorIEClass, source, new String[] { "uuid", "_2LOftu5WEduz9o2pAin6-g" });
		addAnnotation(singleInputOperatorEClass, source, new String[] { "uuid", "_2LOft-5WEduz9o2pAin6-g" });
		addAnnotation(getSingleInputOperator_In(), source, new String[] { "uuid", "_2LOfuO5WEduz9o2pAin6-g" });
		addAnnotation(twoInputsOperatorEClass, source, new String[] { "uuid", "_2LOfue5WEduz9o2pAin6-g" });
		addAnnotation(getTwoInputsOperator_FirstOperand(), source, new String[] { "uuid", "_2LOfuu5WEduz9o2pAin6-g" });
		addAnnotation(getTwoInputsOperator_SecondOperand(), source, new String[] { "uuid", "_2LOfu-5WEduz9o2pAin6-g" });
		addAnnotation(multipleInputsOperatorEClass, source, new String[] { "uuid", "_2LOfvO5WEduz9o2pAin6-g" });
		addAnnotation(getMultipleInputsOperator_Ins(), source, new String[] { "uuid", "_2LOfve5WEduz9o2pAin6-g" });
		addAnnotation(andEClass, source, new String[] { "uuid", "_2LOfvu5WEduz9o2pAin6-g" });
		addAnnotation(arithmeticOperatorEClass, source, new String[] { "uuid", "_2LOfv-5WEduz9o2pAin6-g" });
		addAnnotation(getArithmeticOperator_Operator(), source, new String[] { "uuid", "_2LOfwO5WEduz9o2pAin6-g" });
		addAnnotation(arrayEnumerationEClass, source, new String[] { "uuid", "_2LOfwe5WEduz9o2pAin6-g" });
		addAnnotation(arrayProductEClass, source, new String[] { "uuid", "_2LOfwu5WEduz9o2pAin6-g" });
		addAnnotation(arrayRestructurationEClass, source, new String[] { "uuid", "_2LOfw-5WEduz9o2pAin6-g" });
		addAnnotation(assertionEClass, source, new String[] { "uuid", "_2LOfxO5WEduz9o2pAin6-g" });
		addAnnotation(getAssertion_Expression(), source, new String[] { "uuid", "_2LOfxe5WEduz9o2pAin6-g" });
		addAnnotation(getAssertion_ModelParent(), source, new String[] { "uuid", "_2LOfxu5WEduz9o2pAin6-g" });
		addAnnotation(booleanExpressionEClass, source, new String[] { "uuid", "_2LOfx-5WEduz9o2pAin6-g" });
		addAnnotation(getBooleanExpression_Expression(), source, new String[] { "uuid", "_2LOfyO5WEduz9o2pAin6-g" });
		addAnnotation(cartesianProductEClass, source, new String[] { "uuid", "_2LOfye5WEduz9o2pAin6-g" });
		addAnnotation(getCartesianProduct_Outs(), source, new String[] { "uuid", "_2LOfyu5WEduz9o2pAin6-g" });
		addAnnotation(cellEClass, source, new String[] { "uuid", "_2LOfy-5WEduz9o2pAin6-g" });
		addAnnotation(getCell_InitialValue(), source, new String[] { "uuid", "_2LOfzO5WEduz9o2pAin6-g" });
		addAnnotation(clockConstraintOperatorEClass, source, new String[] { "uuid", "_2LOfze5WEduz9o2pAin6-g" });
		addAnnotation(getClockConstraintOperator_Operator(), source, new String[] { "uuid", "_2LOfzu5WEduz9o2pAin6-g" });
		addAnnotation(clockRelationOperatorEClass, source, new String[] { "uuid", "_2LOfz-5WEduz9o2pAin6-g" });
		addAnnotation(getClockRelationOperator_Operator(), source, new String[] { "uuid", "_2LOf0O5WEduz9o2pAin6-g" });
		addAnnotation(clockSpeedOperatorEClass, source, new String[] { "uuid", "_2LOf0e5WEduz9o2pAin6-g" });
		addAnnotation(getClockSpeedOperator_Operator(), source, new String[] { "uuid", "_2LOf0u5WEduz9o2pAin6-g" });
		addAnnotation(comparisonOperatorEClass, source, new String[] { "uuid", "_2LOf0-5WEduz9o2pAin6-g" });
		addAnnotation(getComparisonOperator_Operator(), source, new String[] { "uuid", "_2LOf1O5WEduz9o2pAin6-g" });
		addAnnotation(complexOperatorEClass, source, new String[] { "uuid", "_2LOf1e5WEduz9o2pAin6-g" });
		addAnnotation(concatenationEClass, source, new String[] { "uuid", "_2LOf1u5WEduz9o2pAin6-g" });
		addAnnotation(counterEClass, source, new String[] { "uuid", "_2LOf1-5WEduz9o2pAin6-g" });
		addAnnotation(getCounter_CounterKind(), source, new String[] { "uuid", "_2LOf2O5WEduz9o2pAin6-g" });
		addAnnotation(delayEClass, source, new String[] { "uuid", "_2LOf2e5WEduz9o2pAin6-g" });
		addAnnotation(getDelay_NbInstants(), source, new String[] { "uuid", "_2LOf2u5WEduz9o2pAin6-g" });
		addAnnotation(getDelay_InitialValue(), source, new String[] { "uuid", "_2LOf2-5WEduz9o2pAin6-g" });
		addAnnotation(dependenceOperatorEClass, source, new String[] { "uuid", "_2LOf3O5WEduz9o2pAin6-g" });
		addAnnotation(extractionEClass, source, new String[] { "uuid", "_2LOf3e5WEduz9o2pAin6-g" });
		addAnnotation(ifThenElseEClass, source, new String[] { "uuid", "_2LOf3u5WEduz9o2pAin6-g" });
		addAnnotation(mergeEClass, source, new String[] { "uuid", "_2LOf3-5WEduz9o2pAin6-g" });
		addAnnotation(notEClass, source, new String[] { "uuid", "_2LOf4O5WEduz9o2pAin6-g" });
		addAnnotation(nullClockEClass, source, new String[] { "uuid", "_2LOf4e5WEduz9o2pAin6-g" });
		addAnnotation(numericExpressionEClass, source, new String[] { "uuid", "_2LOf4u5WEduz9o2pAin6-g" });
		addAnnotation(getNumericExpression_Expression(), source, new String[] { "uuid", "_2LOf4-5WEduz9o2pAin6-g" });
		addAnnotation(orEClass, source, new String[] { "uuid", "_2LOf5O5WEduz9o2pAin6-g" });
		addAnnotation(pragmaEClass, source, new String[] { "uuid", "_2LOf5e5WEduz9o2pAin6-g" });
		addAnnotation(getPragma_InterfaceParent(), source, new String[] { "uuid", "_2LOf5u5WEduz9o2pAin6-g" });
		addAnnotation(getPragma_ModuleParent(), source, new String[] { "uuid", "_2LOf5-5WEduz9o2pAin6-g" });
		addAnnotation(getPragma_Pragma(), source, new String[] { "uuid", "_2LOf6O5WEduz9o2pAin6-g" });
		addAnnotation(getPragma_Expression(), source, new String[] { "uuid", "_2LOf6e5WEduz9o2pAin6-g" });
		addAnnotation(getPragma_Targets(), source, new String[] { "uuid", "_2LOf6u5WEduz9o2pAin6-g" });
		addAnnotation(repetitionOperatorEClass, source, new String[] { "uuid", "_2LOf6-5WEduz9o2pAin6-g" });
		addAnnotation(sequentialDefinitionEClass, source, new String[] { "uuid", "_2LOf7e5WEduz9o2pAin6-g" });
		addAnnotation(switchEClass, source, new String[] { "uuid", "_2LOf7u5WEduz9o2pAin6-g" });
		addAnnotation(getSwitch_Signal(), source, new String[] { "uuid", "_2LOf7-5WEduz9o2pAin6-g" });
		addAnnotation(getSwitch_Src_CaseConnections(), source, new String[] { "uuid", "_2LOf8O5WEduz9o2pAin6-g" });
		addAnnotation(transpositionEClass, source, new String[] { "uuid", "_2LOf8e5WEduz9o2pAin6-g" });
		addAnnotation(tupleOperatorEClass, source, new String[] { "uuid", "_2LOf8u5WEduz9o2pAin6-g" });
		addAnnotation(unaryMinusEClass, source, new String[] { "uuid", "_2LOf8-5WEduz9o2pAin6-g" });
		addAnnotation(variableEClass, source, new String[] { "uuid", "_2LOf9O5WEduz9o2pAin6-g" });
		addAnnotation(getVariable_InitialValue(), source, new String[] { "uuid", "_2LOf9e5WEduz9o2pAin6-g" });
		addAnnotation(windowEClass, source, new String[] { "uuid", "_2LOf9u5WEduz9o2pAin6-g" });
		addAnnotation(getWindow_WindowSize(), source, new String[] { "uuid", "_2LOf9-5WEduz9o2pAin6-g" });
		addAnnotation(getWindow_InitialValue(), source, new String[] { "uuid", "_2LOf-O5WEduz9o2pAin6-g" });
		addAnnotation(xorEClass, source, new String[] { "uuid", "_2LOf-e5WEduz9o2pAin6-g" });
		addAnnotation(stateOrHistoryEClass, source, new String[] { "uuid", "_2LOf-u5WEduz9o2pAin6-g" });
		addAnnotation(getStateOrHistory_Dst_StrongTransitions(), source, new String[] { "uuid",
				"_2LOf--5WEduz9o2pAin6-g" });
		addAnnotation(getStateOrHistory_Dst_WeakTransitions(), source,
			new String[] { "uuid", "_2LOf_O5WEduz9o2pAin6-g" });
		addAnnotation(historyEClass, source, new String[] { "uuid", "_2LOf_e5WEduz9o2pAin6-g" });
		addAnnotation(getHistory_ParentState(), source, new String[] { "uuid", "_2LOf_u5WEduz9o2pAin6-g" });
		addAnnotation(stateBaseEClass, source, new String[] { "uuid", "_2LOf_-5WEduz9o2pAin6-g" });
		addAnnotation(getStateBase_StateParent(), source, new String[] { "uuid", "_2LOgAO5WEduz9o2pAin6-g" });
		addAnnotation(getStateBase_Src_WeakTransitions(), source, new String[] { "uuid", "_2LOgAe5WEduz9o2pAin6-g" });
		addAnnotation(getStateBase_Src_StrongTransitions(), source, new String[] { "uuid", "_2LOgAu5WEduz9o2pAin6-g" });
		addAnnotation(stateEClass, source, new String[] { "uuid", "_2LOgA-5WEduz9o2pAin6-g" });
		addAnnotation(compoundStateEClass, source, new String[] { "uuid", "_2LOgBO5WEduz9o2pAin6-g" });
		addAnnotation(getCompoundState_States(), source, new String[] { "uuid", "_2LOgBe5WEduz9o2pAin6-g" });
		addAnnotation(getCompoundState_History(), source, new String[] { "uuid", "_2LOgBu5WEduz9o2pAin6-g" });
		addAnnotation(getCompoundState_Locals(), source, new String[] { "uuid", "_2LOgB-5WEduz9o2pAin6-g" });
		addAnnotation(automatonEClass, source, new String[] { "uuid", "_2LOgCO5WEduz9o2pAin6-g" });
		addAnnotation(getAutomaton_ModelParent(), source, new String[] { "uuid", "_2LOgCe5WEduz9o2pAin6-g" });
		addAnnotation(getAutomaton_InitState(), source, new String[] { "uuid", "_2LOgCu5WEduz9o2pAin6-g" });
		addAnnotation(getAutomaton_Transitions(), source, new String[] { "uuid", "_2LOgC-5WEduz9o2pAin6-g" });
		addAnnotation(andStateEClass, source, new String[] { "uuid", "_2LOgDu5WEduz9o2pAin6-g" });
		addAnnotation(transitionEClass, source, new String[] { "uuid", "_2LOgD-5WEduz9o2pAin6-g" });
		addAnnotation(getTransition_Guard(), source, new String[] { "uuid", "_2LOgEO5WEduz9o2pAin6-g" });
		addAnnotation(getTransition_Priority(), source, new String[] { "uuid", "_2LOgEe5WEduz9o2pAin6-g" });
		addAnnotation(getTransition_AutomatonParent(), source, new String[] { "uuid", "_3h6dhBXJEdyEE5SD-YnmUA" });
		addAnnotation(weakTransitionEClass, source, new String[] { "uuid", "_2LOgEu5WEduz9o2pAin6-g" });
		addAnnotation(getWeakTransition_Src(), source, new String[] { "uuid", "_2LOgFO5WEduz9o2pAin6-g" });
		addAnnotation(getWeakTransition_Dst(), source, new String[] { "uuid", "_2LOgFe5WEduz9o2pAin6-g" });
		addAnnotation(strongTransitionEClass, source, new String[] { "uuid", "_2LOgFu5WEduz9o2pAin6-g" });
		addAnnotation(getStrongTransition_Src(), source, new String[] { "uuid", "_2LOgGO5WEduz9o2pAin6-g" });
		addAnnotation(getStrongTransition_Dst(), source, new String[] { "uuid", "_2LOgGe5WEduz9o2pAin6-g" });
	}
	
} // SmePackageImpl
